(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source | 
  Boogie/Spec# benchmarks.
  This benchmark was translated by Michal Moskal.
|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun InRange (Int Int) Bool)
(declare-fun int_18446744073709551615 () Int)
(declare-fun Smt.false () Int)
(declare-fun ThenCheck_correct () Int)
(declare-fun then_correct () Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun then_2_join_correct () Int)
(declare-fun CONCVARSYM (Int) Int)
(declare-fun divides (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun ThenCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun subtypes (Int Int) Bool)
(declare-fun store1 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun StartCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun join_2_GeneratedUnifiedExit_correct () Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun int_2147483647 () Int)
(declare-fun x_0 () Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun ReallyLastGeneratedExit_correct () Int)
(declare-fun x_1 () Int)
(declare-fun x_2 () Int)
(declare-fun x_3 () Int)
(declare-fun int_m9223372036854775808 () Int)
(declare-fun Smt.true () Int)
(declare-fun int_4294967295 () Int)
(declare-fun start_correct () Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun StartCheck_correct () Int)
(declare-fun boolNot (Int) Int)
(declare-fun GeneratedUnifiedExit_correct () Int)
(declare-fun ElseCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun intLess (Int Int) Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun f_ (Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun is (Int Int) Int)
(declare-fun join_correct () Int)
(declare-fun int_m2147483648 () Int)
(declare-fun ElseCheck_correct () Int)
(declare-fun else_correct () Int)
(declare-fun modulo (Int Int) Int)
(declare-fun else_2_join_correct () Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun int_9223372036854775807 () Int)
(assert true)
(assert true)
(assert (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v)))
(assert (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v)))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolIff ?x ?y) Smt.true) (= (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolImplies ?x ?y) Smt.true) (=> (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolAnd ?x ?y) Smt.true) (and (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolOr ?x ?y) Smt.true) (or (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int)) (! (= (= (boolNot ?x) Smt.true) (not (= ?x Smt.true))) :pattern ((boolNot ?x)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (anyEqual ?x ?y) Smt.true) (= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (! (= (= (anyNeq ?x ?y) Smt.true) (not (= ?x ?y))) :pattern ((anyNeq ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (intLess ?x ?y) Smt.true) (< ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtMost ?x ?y) Smt.true) (<= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtLeast ?x ?y) Smt.true) (>= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intGreater ?x ?y) Smt.true) (> ?x ?y))))
(assert (distinct Smt.false Smt.true))
(assert (forall ((?t Int)) (! (subtypes ?t ?t) :pattern ((subtypes ?t ?t)) )))
(assert (forall ((?t Int) (?u Int) (?v Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?v)) (subtypes ?t ?v)) :pattern ((subtypes ?t ?u) (subtypes ?u ?v)) )))
(assert (forall ((?t Int) (?u Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?t)) (= ?t ?u)) :pattern ((subtypes ?t ?u) (subtypes ?u ?t)) )))
(assert (let ((?v_0 (= 3 3))) (let ((?v_14 (=> ?v_0 true)) (?v_15 (= start_correct Smt.true)) (?v_9 (f_ 3))) (let ((?v_1 (f_ ?v_9))) (let ((?v_4 (= x_1 ?v_1)) (?v_3 (= x_1 3)) (?v_2 (and (= 3 x_1) (= 3 ?v_1)))) (let ((?v_5 (=> ?v_2 true)) (?v_16 (= else_correct Smt.true)) (?v_17 (= ElseCheck_correct Smt.true)) (?v_18 (= ElseCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_6 (=> true true)) (?v_19 (= GeneratedUnifiedExit_correct Smt.true)) (?v_20 (= ReallyLastGeneratedExit_correct Smt.true)) (?v_21 (= else_2_join_correct Smt.true)) (?v_7 (f_ x_2))) (let ((?v_8 (= x_2 ?v_7)) (?v_10 (= 3 ?v_9)) (?v_22 (= join_correct Smt.true)) (?v_23 (= join_2_GeneratedUnifiedExit_correct Smt.true)) (?v_13 (= x_0 ?v_9)) (?v_12 (= x_0 3))) (let ((?v_11 (and (= 3 x_0) ?v_10)) (?v_24 (= then_correct Smt.true)) (?v_25 (= then_2_join_correct Smt.true)) (?v_26 (= ThenCheck_correct Smt.true)) (?v_27 (= ThenCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_28 (= StartCheck_correct Smt.true)) (?v_29 (= StartCheck_2_GeneratedUnifiedExit_correct Smt.true))) (not (=> (and (=> (=> true (=> true ?v_14)) ?v_15) (=> (=> true (=> ?v_0 (=> ?v_4 (=> ?v_3 ?v_5)))) ?v_16) (=> (=> true (=> ?v_2 (and ?v_3 ?v_4 (=> (and ?v_3 ?v_4) ?v_5)))) ?v_17) (=> (=> true (=> (= x_3 x_1) true)) ?v_18) (=> ?v_6 ?v_19) (=> ?v_6 ?v_20) (=> (=> true (=> (= x_2 x_1) true)) ?v_21) (=> (=> true (=> (and (= x_2 (f_ ?v_7)) (= x_2 3)) (and ?v_8 (=> ?v_8 (=> (and (= 3 x_2) ?v_10) true))))) ?v_22) (=> (=> true (=> (= x_3 x_2) true)) ?v_23) (=> (=> true (=> ?v_0 (=> ?v_13 (=> ?v_12 (=> ?v_11 true))))) ?v_24) (=> (=> true (=> (= x_2 x_0) true)) ?v_25) (=> (=> true (=> ?v_11 (and ?v_12 ?v_13 (=> (and ?v_12 ?v_13) (=> (and (= x_0 (f_ x_0)) ?v_12) true))))) ?v_26) (=> (=> true (=> (= x_3 x_0) true)) ?v_27) (=> (=> true (=> ?v_0 (and ?v_0 (=> ?v_0 ?v_14)))) ?v_28) (=> (=> true (=> (= x_3 3) true)) ?v_29)) (and ?v_15 ?v_16 ?v_17 ?v_18 ?v_19 ?v_20 ?v_21 ?v_22 ?v_23 ?v_24 ?v_25 ?v_26 ?v_27 ?v_28 ?v_29)))))))))))
(check-sat)
(exit)
