(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sls/sls_insertion_sort.spl:57:4-20:Possible heap access through null or dangling reference
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldInt Loc) Int)
(declare-fun read$1 (FldLoc Loc) Loc)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetLoc)
(declare-fun setenum$0 (Loc) SetLoc)
(declare-fun union$0 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun in$0 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_20$0 () Bool)
(declare-fun Axiom_21$0 () Bool)
(declare-fun Axiom_22$0 () Bool)
(declare-fun Axiom_23$0 () Bool)
(declare-fun Axiom_24$0 () Bool)
(declare-fun Axiom_25$0 () Bool)
(declare-fun Axiom_26$0 () Bool)
(declare-fun Axiom_27$0 () Bool)
(declare-fun Axiom_28$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_3$0 () SetLoc)
(declare-fun FP_4$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_2$0 () SetLoc)
(declare-fun curr_2$0 () Loc)
(declare-fun curr_4$0 () Loc)
(declare-fun curr_5$0 () Loc)
(declare-fun curr_init$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lseg_domain$0 (FldLoc Loc Loc) SetLoc)
(declare-fun lseg_struct$0 (SetLoc FldLoc Loc Loc) Bool)
(declare-fun lslseg_domain$0 (FldInt FldLoc Loc Loc Int) SetLoc)
(declare-fun lslseg_struct$0 (SetLoc FldInt FldLoc Loc Loc Int) Bool)
(declare-fun lst_2$0 () Loc)
(declare-fun lst_init$0 () Loc)
(declare-fun min_2$0 () Loc)
(declare-fun min_4$0 () Loc)
(declare-fun min_5$0 () Loc)
(declare-fun min_init$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prv_4$0 () Loc)
(declare-fun prv_5$0 () Loc)
(declare-fun prv_init$0 () Loc)
(declare-fun sk_?X_60$0 () SetLoc)
(declare-fun sk_?X_61$0 () SetLoc)
(declare-fun sk_?X_62$0 () SetLoc)
(declare-fun sk_?X_63$0 () SetLoc)
(declare-fun sk_?X_64$0 () SetLoc)
(declare-fun sk_?X_65$0 () SetLoc)
(declare-fun sk_?X_66$0 () SetLoc)
(declare-fun sk_?X_67$0 () SetLoc)
(declare-fun sk_?X_68$0 () SetLoc)
(declare-fun sk_?X_69$0 () SetLoc)
(declare-fun sk_?X_70$0 () SetLoc)
(declare-fun sk_?X_71$0 () SetLoc)
(declare-fun sk_?X_72$0 () SetLoc)
(declare-fun sk_?X_73$0 () SetLoc)
(declare-fun sk_?X_74$0 () SetLoc)
(declare-fun sk_?X_75$0 () SetLoc)
(declare-fun sk_?X_76$0 () SetLoc)
(declare-fun sk_?X_77$0 () SetLoc)
(declare-fun sk_?X_78$0 () SetLoc)
(declare-fun sk_?X_79$0 () SetLoc)
(declare-fun sk_?X_80$0 () SetLoc)
(declare-fun sk_?X_81$0 () SetLoc)
(declare-fun sk_?X_82$0 () SetLoc)
(declare-fun sk_?X_83$0 () SetLoc)
(declare-fun sk_?X_84$0 () SetLoc)
(declare-fun sk_?X_85$0 () SetLoc)
(declare-fun sk_?X_86$0 () SetLoc)
(declare-fun sk_?X_87$0 () SetLoc)
(declare-fun sk_?X_88$0 () SetLoc)
(declare-fun sk_?X_89$0 () SetLoc)
(declare-fun sk_?X_90$0 () SetLoc)
(declare-fun sk_?X_91$0 () SetLoc)
(declare-fun sk_?X_92$0 () SetLoc)
(declare-fun srt_4$0 () Loc)
(declare-fun srt_5$0 () Loc)
(declare-fun srt_init$0 () Loc)
(declare-fun tmp_2$0 () Int)
(declare-fun tmp_init$0 () Int)
(declare-fun ulseg_domain$0 (FldInt FldLoc Loc Loc Int) SetLoc)
(declare-fun ulseg_struct$0 (SetLoc FldInt FldLoc Loc Loc Int) Bool)

(assert (forall ((?y Loc))
        (or (not (Btwn$0 next$0 prv_init$0 ?y ?y)) (= prv_init$0 ?y)
            (Btwn$0 next$0 prv_init$0 (read$1 next$0 prv_init$0) ?y))))

(assert (forall ((?y Loc))
        (or (not (Btwn$0 next$0 srt_5$0 ?y ?y)) (= srt_5$0 ?y)
            (Btwn$0 next$0 srt_5$0 (read$1 next$0 srt_5$0) ?y))))

(assert (forall ((?y Loc))
        (or (not (Btwn$0 next$0 curr_5$0 ?y ?y)) (= curr_5$0 ?y)
            (Btwn$0 next$0 curr_5$0 (read$1 next$0 curr_5$0) ?y))))

(assert (forall ((?y Loc))
        (or (not (= (read$1 next$0 prv_init$0) prv_init$0))
            (not (Btwn$0 next$0 prv_init$0 ?y ?y)) (= prv_init$0 ?y))))

(assert (forall ((?y Loc))
        (or (not (= (read$1 next$0 srt_5$0) srt_5$0))
            (not (Btwn$0 next$0 srt_5$0 ?y ?y)) (= srt_5$0 ?y))))

(assert (forall ((?y Loc))
        (or (not (= (read$1 next$0 curr_5$0) curr_5$0))
            (not (Btwn$0 next$0 curr_5$0 ?y ?y)) (= curr_5$0 ?y))))

(assert (Btwn$0 next$0 prv_init$0 (read$1 next$0 prv_init$0)
  (read$1 next$0 prv_init$0)))

(assert (Btwn$0 next$0 srt_5$0 (read$1 next$0 srt_5$0) (read$1 next$0 srt_5$0)))

(assert (Btwn$0 next$0 curr_5$0 (read$1 next$0 curr_5$0) (read$1 next$0 curr_5$0)))

(assert (or (in$0 (ep$0 next$0 FP_3$0 curr_4$0) FP_3$0)
    (= curr_4$0 (ep$0 next$0 FP_3$0 curr_4$0))))

(assert (or (in$0 (ep$0 next$0 FP_3$0 curr_5$0) FP_3$0)
    (= curr_5$0 (ep$0 next$0 FP_3$0 curr_5$0))))

(assert (or (in$0 (ep$0 next$0 FP_3$0 lst_2$0) FP_3$0)
    (= lst_2$0 (ep$0 next$0 FP_3$0 lst_2$0))))

(assert (or (in$0 (ep$0 next$0 FP_3$0 srt_5$0) FP_3$0)
    (= srt_5$0 (ep$0 next$0 FP_3$0 srt_5$0))))

(assert (or (in$0 (ep$0 next$0 FP_3$0 min_5$0) FP_3$0)
    (= min_5$0 (ep$0 next$0 FP_3$0 min_5$0))))

(assert (forall ((l1 Loc))
        (or (not Axiom_27$0)
            (or (<= (read$0 data$0 min_5$0) (read$0 data$0 l1))
                (not (in$0 l1 sk_?X_64$0))))))

(assert (forall ((l1 Loc))
        (or (not Axiom_25$0)
            (or (<= (read$0 data$0 min_5$0) (read$0 data$0 l1))
                (not (in$0 l1 sk_?X_67$0))))))

(assert (forall ((l1 Loc))
        (or (not Axiom_23$0)
            (or (<= (read$0 data$0 l1) (read$0 data$0 prv_init$0))
                (not (in$0 l1 sk_?X_89$0))))))

(assert (forall ((l1 Loc) (l2 Loc))
        (or (not Axiom_22$0)
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 prv_init$0))
                (not (in$0 l1 sk_?X_89$0)) (not (in$0 l2 sk_?X_89$0))))))

(assert (forall ((l1 Loc))
        (or (not Axiom_20$0)
            (or (<= (read$0 data$0 prv_4$0) (read$0 data$0 l1))
                (not (in$0 l1 sk_?X_81$0))))))

(assert (forall ((?y Loc))
        (or (Btwn$0 next$0 curr_4$0 (ep$0 next$0 FP_3$0 curr_4$0) ?y)
            (not (Btwn$0 next$0 curr_4$0 ?y ?y)) (not (in$0 ?y FP_3$0)))))

(assert (forall ((?y Loc))
        (or (Btwn$0 next$0 curr_5$0 (ep$0 next$0 FP_3$0 curr_5$0) ?y)
            (not (Btwn$0 next$0 curr_5$0 ?y ?y)) (not (in$0 ?y FP_3$0)))))

(assert (forall ((?y Loc))
        (or (Btwn$0 next$0 lst_2$0 (ep$0 next$0 FP_3$0 lst_2$0) ?y)
            (not (Btwn$0 next$0 lst_2$0 ?y ?y)) (not (in$0 ?y FP_3$0)))))

(assert (forall ((?y Loc))
        (or (Btwn$0 next$0 srt_5$0 (ep$0 next$0 FP_3$0 srt_5$0) ?y)
            (not (Btwn$0 next$0 srt_5$0 ?y ?y)) (not (in$0 ?y FP_3$0)))))

(assert (forall ((?y Loc))
        (or (Btwn$0 next$0 min_5$0 (ep$0 next$0 FP_3$0 min_5$0) ?y)
            (not (Btwn$0 next$0 min_5$0 ?y ?y)) (not (in$0 ?y FP_3$0)))))

(assert (Btwn$0 next$0 curr_4$0 (ep$0 next$0 FP_3$0 curr_4$0)
  (ep$0 next$0 FP_3$0 curr_4$0)))

(assert (Btwn$0 next$0 curr_5$0 (ep$0 next$0 FP_3$0 curr_5$0)
  (ep$0 next$0 FP_3$0 curr_5$0)))

(assert (Btwn$0 next$0 lst_2$0 (ep$0 next$0 FP_3$0 lst_2$0)
  (ep$0 next$0 FP_3$0 lst_2$0)))

(assert (Btwn$0 next$0 srt_5$0 (ep$0 next$0 FP_3$0 srt_5$0)
  (ep$0 next$0 FP_3$0 srt_5$0)))

(assert (Btwn$0 next$0 min_5$0 (ep$0 next$0 FP_3$0 min_5$0)
  (ep$0 next$0 FP_3$0 min_5$0)))

(assert (forall ((l1 Loc))
        (or (not Axiom_28$0)
            (or (<= (read$0 data$0 prv_init$0) (read$0 data$0 l1))
                (not (in$0 l1 sk_?X_85$0))))))

(assert (forall ((l1 Loc))
        (or (not Axiom_26$0)
            (or (<= (read$0 data$0 min_4$0) (read$0 data$0 l1))
                (not (in$0 l1 sk_?X_79$0))))))

(assert (forall ((l1 Loc))
        (or (not Axiom_24$0)
            (or (<= (read$0 data$0 min_4$0) (read$0 data$0 l1))
                (not (in$0 l1 sk_?X_76$0))))))

(assert (forall ((l1 Loc))
        (or (not Axiom_21$0)
            (or (<= (read$0 data$0 prv_5$0) (read$0 data$0 l1))
                (not (in$0 l1 sk_?X_62$0))))))

(assert (forall ((x Loc))
        (or
            (and
                 (in$0 x
                   (union$0 (intersection$0 Alloc$0 FP_3$0)
                     (setminus$0 Alloc$0 Alloc$0)))
                 (or (in$0 x (intersection$0 Alloc$0 FP_3$0))
                     (in$0 x (setminus$0 Alloc$0 Alloc$0))))
            (and (not (in$0 x (intersection$0 Alloc$0 FP_3$0)))
                 (not (in$0 x (setminus$0 Alloc$0 Alloc$0)))
                 (not
                      (in$0 x
                        (union$0 (intersection$0 Alloc$0 FP_3$0)
                          (setminus$0 Alloc$0 Alloc$0))))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 FP_Caller$0 Alloc$0))
                 (or (in$0 x FP_Caller$0) (in$0 x Alloc$0)))
            (and (not (in$0 x FP_Caller$0)) (not (in$0 x Alloc$0))
                 (not (in$0 x (union$0 FP_Caller$0 Alloc$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 FP_4$0 Alloc$0))
                 (or (in$0 x FP_4$0) (in$0 x Alloc$0)))
            (and (not (in$0 x FP_4$0)) (not (in$0 x Alloc$0))
                 (not (in$0 x (union$0 FP_4$0 Alloc$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 FP_3$0 FP$0))
                 (or (in$0 x FP_3$0) (in$0 x FP$0)))
            (and (not (in$0 x FP_3$0)) (not (in$0 x FP$0))
                 (not (in$0 x (union$0 FP_3$0 FP$0)))))))

(assert (forall ((x Loc))
        (or
            (and
                 (in$0 x
                   (union$0 (setminus$0 FP$0 FP_3$0)
                     (union$0 (intersection$0 Alloc$0 FP_3$0)
                       (setminus$0 Alloc$0 Alloc$0))))
                 (or (in$0 x (setminus$0 FP$0 FP_3$0))
                     (in$0 x
                       (union$0 (intersection$0 Alloc$0 FP_3$0)
                         (setminus$0 Alloc$0 Alloc$0)))))
            (and (not (in$0 x (setminus$0 FP$0 FP_3$0)))
                 (not
                      (in$0 x
                        (union$0 (intersection$0 Alloc$0 FP_3$0)
                          (setminus$0 Alloc$0 Alloc$0))))
                 (not
                      (in$0 x
                        (union$0 (setminus$0 FP$0 FP_3$0)
                          (union$0 (intersection$0 Alloc$0 FP_3$0)
                            (setminus$0 Alloc$0 Alloc$0)))))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 FP$0 FP_Caller$0))
                 (or (in$0 x FP$0) (in$0 x FP_Caller$0)))
            (and (not (in$0 x FP$0)) (not (in$0 x FP_Caller$0))
                 (not (in$0 x (union$0 FP$0 FP_Caller$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_62$0 sk_?X_64$0))
                 (or (in$0 x sk_?X_62$0) (in$0 x sk_?X_64$0)))
            (and (not (in$0 x sk_?X_62$0)) (not (in$0 x sk_?X_64$0))
                 (not (in$0 x (union$0 sk_?X_62$0 sk_?X_64$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_61$0 sk_?X_64$0))
                 (or (in$0 x sk_?X_61$0) (in$0 x sk_?X_64$0)))
            (and (not (in$0 x sk_?X_61$0)) (not (in$0 x sk_?X_64$0))
                 (not (in$0 x (union$0 sk_?X_61$0 sk_?X_64$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_65$0 sk_?X_67$0))
                 (or (in$0 x sk_?X_65$0) (in$0 x sk_?X_67$0)))
            (and (not (in$0 x sk_?X_65$0)) (not (in$0 x sk_?X_67$0))
                 (not (in$0 x (union$0 sk_?X_65$0 sk_?X_67$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_66$0 sk_?X_67$0))
                 (or (in$0 x sk_?X_66$0) (in$0 x sk_?X_67$0)))
            (and (not (in$0 x sk_?X_66$0)) (not (in$0 x sk_?X_67$0))
                 (not (in$0 x (union$0 sk_?X_66$0 sk_?X_67$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_78$0 sk_?X_76$0))
                 (or (in$0 x sk_?X_78$0) (in$0 x sk_?X_76$0)))
            (and (not (in$0 x sk_?X_78$0)) (not (in$0 x sk_?X_76$0))
                 (not (in$0 x (union$0 sk_?X_78$0 sk_?X_76$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_77$0 sk_?X_76$0))
                 (or (in$0 x sk_?X_77$0) (in$0 x sk_?X_76$0)))
            (and (not (in$0 x sk_?X_77$0)) (not (in$0 x sk_?X_76$0))
                 (not (in$0 x (union$0 sk_?X_77$0 sk_?X_76$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_82$0 sk_?X_79$0))
                 (or (in$0 x sk_?X_82$0) (in$0 x sk_?X_79$0)))
            (and (not (in$0 x sk_?X_82$0)) (not (in$0 x sk_?X_79$0))
                 (not (in$0 x (union$0 sk_?X_82$0 sk_?X_79$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_81$0 sk_?X_79$0))
                 (or (in$0 x sk_?X_81$0) (in$0 x sk_?X_79$0)))
            (and (not (in$0 x sk_?X_81$0)) (not (in$0 x sk_?X_79$0))
                 (not (in$0 x (union$0 sk_?X_81$0 sk_?X_79$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_86$0 sk_?X_85$0))
                 (or (in$0 x sk_?X_86$0) (in$0 x sk_?X_85$0)))
            (and (not (in$0 x sk_?X_86$0)) (not (in$0 x sk_?X_85$0))
                 (not (in$0 x (union$0 sk_?X_86$0 sk_?X_85$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_89$0 sk_?X_88$0))
                 (or (in$0 x sk_?X_89$0) (in$0 x sk_?X_88$0)))
            (and (not (in$0 x sk_?X_89$0)) (not (in$0 x sk_?X_88$0))
                 (not (in$0 x (union$0 sk_?X_89$0 sk_?X_88$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_92$0 sk_?X_91$0))
                 (or (in$0 x sk_?X_92$0) (in$0 x sk_?X_91$0)))
            (and (not (in$0 x sk_?X_92$0)) (not (in$0 x sk_?X_91$0))
                 (not (in$0 x (union$0 sk_?X_92$0 sk_?X_91$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x Alloc$0) (in$0 x FP_3$0)
                 (in$0 x (intersection$0 Alloc$0 FP_3$0)))
            (and (or (not (in$0 x Alloc$0)) (not (in$0 x FP_3$0)))
                 (not (in$0 x (intersection$0 Alloc$0 FP_3$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_61$0) (in$0 x sk_?X_64$0)
                 (in$0 x (intersection$0 sk_?X_61$0 sk_?X_64$0)))
            (and (or (not (in$0 x sk_?X_61$0)) (not (in$0 x sk_?X_64$0)))
                 (not (in$0 x (intersection$0 sk_?X_61$0 sk_?X_64$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_62$0) (in$0 x sk_?X_64$0)
                 (in$0 x (intersection$0 sk_?X_62$0 sk_?X_64$0)))
            (and (or (not (in$0 x sk_?X_62$0)) (not (in$0 x sk_?X_64$0)))
                 (not (in$0 x (intersection$0 sk_?X_62$0 sk_?X_64$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_65$0) (in$0 x sk_?X_67$0)
                 (in$0 x (intersection$0 sk_?X_65$0 sk_?X_67$0)))
            (and (or (not (in$0 x sk_?X_65$0)) (not (in$0 x sk_?X_67$0)))
                 (not (in$0 x (intersection$0 sk_?X_65$0 sk_?X_67$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_66$0) (in$0 x sk_?X_67$0)
                 (in$0 x (intersection$0 sk_?X_66$0 sk_?X_67$0)))
            (and (or (not (in$0 x sk_?X_66$0)) (not (in$0 x sk_?X_67$0)))
                 (not (in$0 x (intersection$0 sk_?X_66$0 sk_?X_67$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_77$0) (in$0 x sk_?X_76$0)
                 (in$0 x (intersection$0 sk_?X_77$0 sk_?X_76$0)))
            (and (or (not (in$0 x sk_?X_77$0)) (not (in$0 x sk_?X_76$0)))
                 (not (in$0 x (intersection$0 sk_?X_77$0 sk_?X_76$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_78$0) (in$0 x sk_?X_76$0)
                 (in$0 x (intersection$0 sk_?X_78$0 sk_?X_76$0)))
            (and (or (not (in$0 x sk_?X_78$0)) (not (in$0 x sk_?X_76$0)))
                 (not (in$0 x (intersection$0 sk_?X_78$0 sk_?X_76$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_81$0) (in$0 x sk_?X_79$0)
                 (in$0 x (intersection$0 sk_?X_81$0 sk_?X_79$0)))
            (and (or (not (in$0 x sk_?X_81$0)) (not (in$0 x sk_?X_79$0)))
                 (not (in$0 x (intersection$0 sk_?X_81$0 sk_?X_79$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_82$0) (in$0 x sk_?X_79$0)
                 (in$0 x (intersection$0 sk_?X_82$0 sk_?X_79$0)))
            (and (or (not (in$0 x sk_?X_82$0)) (not (in$0 x sk_?X_79$0)))
                 (not (in$0 x (intersection$0 sk_?X_82$0 sk_?X_79$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_86$0) (in$0 x sk_?X_85$0)
                 (in$0 x (intersection$0 sk_?X_86$0 sk_?X_85$0)))
            (and (or (not (in$0 x sk_?X_86$0)) (not (in$0 x sk_?X_85$0)))
                 (not (in$0 x (intersection$0 sk_?X_86$0 sk_?X_85$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_89$0) (in$0 x sk_?X_88$0)
                 (in$0 x (intersection$0 sk_?X_89$0 sk_?X_88$0)))
            (and (or (not (in$0 x sk_?X_89$0)) (not (in$0 x sk_?X_88$0)))
                 (not (in$0 x (intersection$0 sk_?X_89$0 sk_?X_88$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_92$0) (in$0 x sk_?X_91$0)
                 (in$0 x (intersection$0 sk_?X_92$0 sk_?X_91$0)))
            (and (or (not (in$0 x sk_?X_92$0)) (not (in$0 x sk_?X_91$0)))
                 (not (in$0 x (intersection$0 sk_?X_92$0 sk_?X_91$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x Alloc$0) (in$0 x (setminus$0 Alloc$0 Alloc$0))
                 (not (in$0 x Alloc$0)))
            (and (or (in$0 x Alloc$0) (not (in$0 x Alloc$0)))
                 (not (in$0 x (setminus$0 Alloc$0 Alloc$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x FP$0) (in$0 x (setminus$0 FP$0 FP_3$0))
                 (not (in$0 x FP_3$0)))
            (and (or (in$0 x FP_3$0) (not (in$0 x FP$0)))
                 (not (in$0 x (setminus$0 FP$0 FP_3$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x FP_Caller$0) (in$0 x (setminus$0 FP_Caller$0 FP$0))
                 (not (in$0 x FP$0)))
            (and (or (in$0 x FP$0) (not (in$0 x FP_Caller$0)))
                 (not (in$0 x (setminus$0 FP_Caller$0 FP$0)))))))

(assert (forall ((y Loc) (x Loc))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (= (read$1 next$0 null$0) null$0))

(assert (forall ((x Loc)) (not (in$0 x emptyset$0))))

(assert (or (Btwn$0 next$0 curr_5$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_60$0 next$0 curr_5$0 null$0))))

(assert (or (and (Btwn$0 next$0 curr_4$0 null$0 null$0) Axiom_20$0)
    (not
         (ulseg_struct$0 sk_?X_81$0 data$0 next$0 curr_4$0 null$0
           (read$0 data$0 prv_4$0)))))

(assert (or
    (and (Btwn$0 next$0 lst_init$0 prv_init$0 prv_init$0) Axiom_23$0
         Axiom_22$0)
    (not
         (lslseg_struct$0 sk_?X_89$0 data$0 next$0 lst_init$0 prv_init$0
           (read$0 data$0 prv_init$0)))))

(assert (or (and (Btwn$0 next$0 min_5$0 curr_5$0 curr_5$0) Axiom_25$0)
    (not
         (ulseg_struct$0 sk_?X_67$0 data$0 next$0 min_5$0 curr_5$0
           (read$0 data$0 min_5$0)))))

(assert (or (and (Btwn$0 next$0 srt_5$0 min_5$0 min_5$0) Axiom_27$0)
    (not
         (ulseg_struct$0 sk_?X_64$0 data$0 next$0 srt_5$0 min_5$0
           (read$0 data$0 min_5$0)))))

(assert (= FP_4$0
  (union$0 (setminus$0 FP$0 FP_3$0)
    (union$0 (intersection$0 Alloc$0 FP_3$0) (setminus$0 Alloc$0 Alloc$0)))))

(assert (= curr_2$0 curr_init$0))

(assert (= curr_5$0 null$0))

(assert (= min_2$0 min_init$0))

(assert (= prv_4$0 prv_init$0))

(assert (= srt_4$0 srt_init$0))

(assert (= tmp_2$0 tmp_init$0))

(assert (Frame$1 FP_3$0 Alloc$0 next$0 next$0))

(assert (= Alloc$0 (union$0 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_61$0 sk_?X_60$0))

(assert (= sk_?X_63$0 sk_?X_62$0))

(assert (= sk_?X_65$0 (union$0 sk_?X_63$0 sk_?X_64$0)))

(assert (= sk_?X_67$0
  (ulseg_domain$0 data$0 next$0 min_5$0 curr_5$0 (read$0 data$0 min_5$0))))

(assert (= sk_?X_69$0 (union$0 sk_?X_66$0 sk_?X_67$0)))

(assert (= sk_?X_71$0 sk_?X_69$0))

(assert (= sk_?X_72$0 sk_?X_74$0))

(assert (= sk_?X_74$0 (union$0 sk_?X_77$0 sk_?X_76$0)))

(assert (= sk_?X_76$0
  (ulseg_domain$0 data$0 next$0 min_4$0 curr_4$0 (read$0 data$0 min_4$0))))

(assert (= sk_?X_78$0 (union$0 sk_?X_80$0 sk_?X_79$0)))

(assert (= sk_?X_80$0 sk_?X_81$0))

(assert (= sk_?X_82$0 sk_?X_83$0))

(assert (= FP$0 (union$0 FP_3$0 FP$0)))

(assert (= sk_?X_84$0 (union$0 sk_?X_86$0 sk_?X_85$0)))

(assert (= sk_?X_86$0 (union$0 sk_?X_89$0 sk_?X_87$0)))

(assert (= sk_?X_88$0 (setenum$0 prv_init$0)))

(assert (= sk_?X_90$0 (union$0 sk_?X_92$0 sk_?X_91$0)))

(assert (= sk_?X_92$0 emptyset$0))

(assert (or
    (and (= (read$1 next$0 prv_init$0) srt_init$0) (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_86$0 sk_?X_85$0))
         (= emptyset$0 (intersection$0 sk_?X_89$0 sk_?X_87$0))
         (= sk_?X_84$0 FP$0)
         (lslseg_struct$0 sk_?X_89$0 data$0 next$0 lst_init$0 prv_init$0
           (read$0 data$0 prv_init$0))
         (ulseg_struct$0 sk_?X_85$0 data$0 next$0 srt_init$0 null$0
           (read$0 data$0 prv_init$0)))
    (and (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_92$0 sk_?X_91$0))
         (= prv_init$0 null$0) (= sk_?X_90$0 FP$0) (= srt_init$0 lst_init$0)
         (lseg_struct$0 sk_?X_91$0 next$0 lst_init$0 null$0))))

(assert (not (in$0 null$0 Alloc$0)))

(assert (not (in$0 min_5$0 FP_4$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_4$0 l1 null$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 curr_4$0 null$0
                     (read$0 data$0 prv_4$0)))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_4$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 curr_4$0 null$0
                          (read$0 data$0 prv_4$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_5$0 l1 null$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 curr_5$0 null$0
                     (read$0 data$0 prv_5$0)))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_5$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 curr_5$0 null$0
                          (read$0 data$0 prv_5$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 prv_init$0)
                 (in$0 l1
                   (lslseg_domain$0 data$0 next$0 lst_init$0 prv_init$0
                     (read$0 data$0 prv_init$0)))
                 (not (= l1 prv_init$0)))
            (and
                 (or (= l1 prv_init$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 prv_init$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data$0 next$0 lst_init$0 prv_init$0
                          (read$0 data$0 prv_init$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 min_5$0 l1 curr_5$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 min_5$0 curr_5$0
                     (read$0 data$0 min_5$0)))
                 (not (= l1 curr_5$0)))
            (and
                 (or (= l1 curr_5$0)
                     (not (Btwn$0 next$0 min_5$0 l1 curr_5$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 min_5$0 curr_5$0
                          (read$0 data$0 min_5$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 srt_5$0 l1 min_5$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 srt_5$0 min_5$0
                     (read$0 data$0 min_5$0)))
                 (not (= l1 min_5$0)))
            (and (or (= l1 min_5$0) (not (Btwn$0 next$0 srt_5$0 l1 min_5$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 srt_5$0 min_5$0
                          (read$0 data$0 min_5$0))))))))

(assert (or (Btwn$0 next$0 curr_4$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_83$0 next$0 curr_4$0 null$0))))

(assert (or (Btwn$0 next$0 lst_init$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_91$0 next$0 lst_init$0 null$0))))

(assert (or (and (Btwn$0 next$0 curr_5$0 null$0 null$0) Axiom_21$0)
    (not
         (ulseg_struct$0 sk_?X_62$0 data$0 next$0 curr_5$0 null$0
           (read$0 data$0 prv_5$0)))))

(assert (or (and (Btwn$0 next$0 min_4$0 curr_4$0 curr_4$0) Axiom_24$0)
    (not
         (ulseg_struct$0 sk_?X_76$0 data$0 next$0 min_4$0 curr_4$0
           (read$0 data$0 min_4$0)))))

(assert (or (and (Btwn$0 next$0 srt_4$0 min_4$0 min_4$0) Axiom_26$0)
    (not
         (ulseg_struct$0 sk_?X_79$0 data$0 next$0 srt_4$0 min_4$0
           (read$0 data$0 min_4$0)))))

(assert (or (and (Btwn$0 next$0 srt_init$0 null$0 null$0) Axiom_28$0)
    (not
         (ulseg_struct$0 sk_?X_85$0 data$0 next$0 srt_init$0 null$0
           (read$0 data$0 prv_init$0)))))

(assert (= FP_Caller_2$0 (setminus$0 FP_Caller$0 FP$0)))

(assert (= curr_4$0 (read$1 next$0 srt_4$0)))

(assert (= lst_2$0 lst_init$0))

(assert (= min_4$0 srt_4$0))

(assert (= prv_5$0 prv_4$0))

(assert (= srt_5$0 srt_4$0))

(assert (Frame$0 FP_3$0 Alloc$0 data$0 data$0))

(assert (= Alloc$0 (union$0 FP_4$0 Alloc$0)))

(assert (= sk_?X_60$0 (lseg_domain$0 next$0 curr_5$0 null$0)))

(assert (= sk_?X_62$0
  (ulseg_domain$0 data$0 next$0 curr_5$0 null$0 (read$0 data$0 prv_5$0))))

(assert (= sk_?X_64$0
  (ulseg_domain$0 data$0 next$0 srt_5$0 min_5$0 (read$0 data$0 min_5$0))))

(assert (= sk_?X_66$0 (union$0 sk_?X_61$0 sk_?X_64$0)))

(assert (= sk_?X_68$0 (union$0 sk_?X_65$0 sk_?X_67$0)))

(assert (= sk_?X_70$0 sk_?X_68$0))

(assert (or
    (and (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_61$0 sk_?X_64$0))
         (= emptyset$0 (intersection$0 sk_?X_66$0 sk_?X_67$0))
         (= prv_5$0 null$0)
         (= sk_?X_71$0
           (union$0 (intersection$0 Alloc$0 FP_3$0)
             (setminus$0 Alloc$0 Alloc$0)))
         (lseg_struct$0 sk_?X_60$0 next$0 curr_5$0 null$0)
         (ulseg_struct$0 sk_?X_64$0 data$0 next$0 srt_5$0 min_5$0
           (read$0 data$0 min_5$0))
         (ulseg_struct$0 sk_?X_67$0 data$0 next$0 min_5$0 curr_5$0
           (read$0 data$0 min_5$0))
         (not (= min_5$0 null$0)))
    (and (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_63$0 sk_?X_64$0))
         (= emptyset$0 (intersection$0 sk_?X_65$0 sk_?X_67$0))
         (= sk_?X_70$0
           (union$0 (intersection$0 Alloc$0 FP_3$0)
             (setminus$0 Alloc$0 Alloc$0)))
         (<= (read$0 data$0 prv_5$0) (read$0 data$0 min_5$0))
         (ulseg_struct$0 sk_?X_62$0 data$0 next$0 curr_5$0 null$0
           (read$0 data$0 prv_5$0))
         (ulseg_struct$0 sk_?X_64$0 data$0 next$0 srt_5$0 min_5$0
           (read$0 data$0 min_5$0))
         (ulseg_struct$0 sk_?X_67$0 data$0 next$0 min_5$0 curr_5$0
           (read$0 data$0 min_5$0))
         (not (= min_5$0 null$0)))))

(assert (= sk_?X_73$0 sk_?X_75$0))

(assert (= sk_?X_75$0 (union$0 sk_?X_78$0 sk_?X_76$0)))

(assert (= sk_?X_77$0 (union$0 sk_?X_82$0 sk_?X_79$0)))

(assert (= sk_?X_79$0
  (ulseg_domain$0 data$0 next$0 srt_4$0 min_4$0 (read$0 data$0 min_4$0))))

(assert (= sk_?X_81$0
  (ulseg_domain$0 data$0 next$0 curr_4$0 null$0 (read$0 data$0 prv_4$0))))

(assert (= sk_?X_83$0 (lseg_domain$0 next$0 curr_4$0 null$0)))

(assert (or
    (and (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_77$0 sk_?X_76$0))
         (= emptyset$0 (intersection$0 sk_?X_82$0 sk_?X_79$0))
         (= prv_4$0 null$0) (= sk_?X_72$0 FP_3$0)
         (lseg_struct$0 sk_?X_83$0 next$0 curr_4$0 null$0)
         (ulseg_struct$0 sk_?X_76$0 data$0 next$0 min_4$0 curr_4$0
           (read$0 data$0 min_4$0))
         (ulseg_struct$0 sk_?X_79$0 data$0 next$0 srt_4$0 min_4$0
           (read$0 data$0 min_4$0))
         (not (= min_4$0 null$0)))
    (and (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_78$0 sk_?X_76$0))
         (= emptyset$0 (intersection$0 sk_?X_80$0 sk_?X_79$0))
         (= sk_?X_73$0 FP_3$0)
         (<= (read$0 data$0 prv_4$0) (read$0 data$0 min_4$0))
         (ulseg_struct$0 sk_?X_76$0 data$0 next$0 min_4$0 curr_4$0
           (read$0 data$0 min_4$0))
         (ulseg_struct$0 sk_?X_79$0 data$0 next$0 srt_4$0 min_4$0
           (read$0 data$0 min_4$0))
         (ulseg_struct$0 sk_?X_81$0 data$0 next$0 curr_4$0 null$0
           (read$0 data$0 prv_4$0))
         (not (= min_4$0 null$0)))))

(assert (= sk_?X_85$0
  (ulseg_domain$0 data$0 next$0 srt_init$0 null$0 (read$0 data$0 prv_init$0))))

(assert (= sk_?X_87$0 sk_?X_88$0))

(assert (= sk_?X_89$0
  (lslseg_domain$0 data$0 next$0 lst_init$0 prv_init$0
    (read$0 data$0 prv_init$0))))

(assert (= sk_?X_91$0 (lseg_domain$0 next$0 lst_init$0 null$0)))

(assert (= FP_Caller$0 (union$0 FP$0 FP_Caller$0)))

(assert (not (= srt_4$0 null$0)))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_4$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next$0 curr_4$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_4$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next$0 curr_4$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_5$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next$0 curr_5$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_5$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next$0 curr_5$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next$0 lst_init$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next$0 lst_init$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 min_4$0 l1 curr_4$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 min_4$0 curr_4$0
                     (read$0 data$0 min_4$0)))
                 (not (= l1 curr_4$0)))
            (and
                 (or (= l1 curr_4$0)
                     (not (Btwn$0 next$0 min_4$0 l1 curr_4$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 min_4$0 curr_4$0
                          (read$0 data$0 min_4$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 srt_4$0 l1 min_4$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 srt_4$0 min_4$0
                     (read$0 data$0 min_4$0)))
                 (not (= l1 min_4$0)))
            (and (or (= l1 min_4$0) (not (Btwn$0 next$0 srt_4$0 l1 min_4$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 srt_4$0 min_4$0
                          (read$0 data$0 min_4$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 srt_init$0 l1 null$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 srt_init$0 null$0
                     (read$0 data$0 prv_init$0)))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 srt_init$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 srt_init$0 null$0
                          (read$0 data$0 prv_init$0))))))))

(assert (forall ((?x Loc)) (Btwn$0 next$0 ?x ?x ?x)))

(assert (forall ((?x Loc) (?y Loc)) (or (not (Btwn$0 next$0 ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 next$0 ?x ?y ?y)) (not (Btwn$0 next$0 ?x ?z ?z))
            (Btwn$0 next$0 ?x ?y ?z) (Btwn$0 next$0 ?x ?z ?y))))

(assert (forall ((?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 next$0 ?x ?y ?z))
            (and (Btwn$0 next$0 ?x ?y ?y) (Btwn$0 next$0 ?y ?z ?z)))))

(assert (forall ((?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 next$0 ?x ?y ?y)) (not (Btwn$0 next$0 ?y ?z ?z))
            (Btwn$0 next$0 ?x ?z ?z))))

(assert (forall ((?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 next$0 ?x ?y ?z)) (not (Btwn$0 next$0 ?y ?u ?z))
            (and (Btwn$0 next$0 ?x ?y ?u) (Btwn$0 next$0 ?x ?u ?z)))))

(assert (forall ((?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 next$0 ?x ?y ?z)) (not (Btwn$0 next$0 ?x ?u ?y))
            (and (Btwn$0 next$0 ?x ?u ?z) (Btwn$0 next$0 ?u ?y ?z)))))

(check-sat)
(exit)
