(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/insert.spl:46:3-4:An invariant might not be maintained by a loop in procedure insert
  tests/spl/sl_sorted_set/insert.spl:36:14:Related location: This is the loop invariant that might not be maintained
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_42$0 () Bool)
(declare-fun Axiom_43$0 () Bool)
(declare-fun Axiom_44$0 () Bool)
(declare-fun Axiom_45$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_2$0 () SetLoc)
(declare-fun c1_4$0 () SetInt)
(declare-fun c1_5$0 () SetInt)
(declare-fun c1_init$0 () SetInt)
(declare-fun c2_4$0 () SetInt)
(declare-fun c2_5$0 () SetInt)
(declare-fun c2_init$0 () SetInt)
(declare-fun content_2$0 () SetInt)
(declare-fun content_init$0 () SetInt)
(declare-fun curr_4$0 () Loc)
(declare-fun curr_5$0 () Loc)
(declare-fun curr_init$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst_2$0 () Loc)
(declare-fun lst_init$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev_4$0 () Loc)
(declare-fun prev_5$0 () Loc)
(declare-fun prev_init$0 () Loc)
(declare-fun sk_?X_156$0 () SetLoc)
(declare-fun sk_?X_157$0 () SetLoc)
(declare-fun sk_?X_158$0 () SetLoc)
(declare-fun sk_?X_159$0 () SetLoc)
(declare-fun sk_?X_160$0 () SetLoc)
(declare-fun sk_?X_161$0 () SetLoc)
(declare-fun sk_?X_162$0 () SetLoc)
(declare-fun sk_?X_163$0 () SetLoc)
(declare-fun sk_?X_164$0 () SetLoc)
(declare-fun sk_?X_165$0 () SetLoc)
(declare-fun sk_?X_166$0 () SetLoc)
(declare-fun sk_?X_167$0 () SetLoc)
(declare-fun sk_?X_168$0 () SetLoc)
(declare-fun sk_?X_169$0 () SetLoc)
(declare-fun sk_?X_170$0 () SetLoc)
(declare-fun sk_?X_171$0 () SetLoc)
(declare-fun sk_?e_5$0 () Int)
(declare-fun sk_?e_6$0 () Int)
(declare-fun sk_FP_2$0 () SetLoc)
(declare-fun sk_FP_3$0 () SetLoc)
(declare-fun sk_l1_5$0 () Loc)
(declare-fun sk_l1_6$0 () Loc)
(declare-fun sk_l2_5$0 () Loc)
(declare-fun sk_l2_6$0 () Loc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_1737$0 () Int)
(declare-fun t_1738$0 () Int)
(declare-fun t_1739$0 () Int)
(declare-fun t_1740$0 () Int)
(declare-fun t_1741$0 () Int)
(declare-fun t_1742$0 () Int)
(declare-fun t_1743$0 () Int)
(declare-fun t_1744$0 () Int)
(declare-fun t_1745$0 () Int)
(declare-fun t_1746$0 () Int)
(declare-fun t_1747$0 () Int)
(declare-fun t_1748$0 () Int)
(declare-fun t_1749$0 () Int)
(declare-fun t_1750$0 () Int)
(declare-fun t_1751$0 () Int)
(declare-fun t_1752$0 () Int)
(declare-fun t_1753$0 () Int)
(declare-fun t_1754$0 () Int)
(declare-fun t_1755$0 () Int)
(declare-fun t_1756$0 () Int)
(declare-fun t_1757$0 () Int)
(declare-fun t_1758$0 () Int)
(declare-fun t_1759$0 () Int)
(declare-fun t_1760$0 () Int)
(declare-fun t_1761$0 () Int)
(declare-fun t_1762$0 () Int)
(declare-fun t_1763$0 () Int)
(declare-fun t_1764$0 () Int)
(declare-fun t_1765$0 () Int)
(declare-fun t_1766$0 () Int)
(declare-fun t_1767$0 () Int)
(declare-fun t_1768$0 () Int)
(declare-fun t_1769$0 () Int)
(declare-fun t_1770$0 () Int)
(declare-fun t_1771$0 () Int)
(declare-fun t_1772$0 () Int)
(declare-fun t_1773$0 () Int)
(declare-fun t_1774$0 () Int)
(declare-fun t_1775$0 () Int)
(declare-fun t_1776$0 () Int)
(declare-fun t_1777$0 () Int)
(declare-fun t_1778$0 () Int)
(declare-fun t_1779$0 () Int)
(declare-fun t_1780$0 () Int)
(declare-fun t_1781$0 () Int)
(declare-fun t_1782$0 () Int)
(declare-fun t_1783$0 () Int)
(declare-fun t_1784$0 () Int)
(declare-fun t_1785$0 () Int)
(declare-fun t_1786$0 () Int)
(declare-fun t_1787$0 () Int)
(declare-fun t_1788$0 () Int)
(declare-fun t_1789$0 () Loc)
(declare-fun t_1790$0 () Loc)
(declare-fun t_1791$0 () Loc)
(declare-fun t_1792$0 () Loc)
(declare-fun t_1793$0 () Loc)
(declare-fun t_1794$0 () Loc)
(declare-fun t_1795$0 () Loc)
(declare-fun t_1796$0 () Loc)
(declare-fun t_1797$0 () Loc)
(declare-fun t_1798$0 () Loc)
(declare-fun t_1799$0 () Loc)
(declare-fun t_1800$0 () Loc)
(declare-fun t_1801$0 () Loc)
(declare-fun t_1802$0 () Loc)
(declare-fun t_1803$0 () Loc)
(declare-fun t_1804$0 () Loc)
(declare-fun t_1805$0 () Loc)
(declare-fun t_1806$0 () Loc)
(declare-fun t_1807$0 () Loc)
(declare-fun t_1808$0 () Loc)
(declare-fun t_1809$0 () Loc)
(declare-fun t_1810$0 () Loc)
(declare-fun t_1811$0 () Loc)
(declare-fun t_1812$0 () Loc)
(declare-fun t_1813$0 () Loc)
(declare-fun t_1814$0 () Loc)
(declare-fun t_1815$0 () Loc)
(declare-fun t_1816$0 () Loc)
(declare-fun t_1817$0 () Loc)
(declare-fun t_1818$0 () Loc)
(declare-fun t_1819$0 () Loc)
(declare-fun t_1820$0 () Loc)
(declare-fun t_1821$0 () Loc)
(declare-fun t_1822$0 () Loc)
(declare-fun t_1823$0 () Loc)
(declare-fun t_1824$0 () Loc)
(declare-fun t_1825$0 () Loc)
(declare-fun t_1826$0 () Loc)
(declare-fun t_1827$0 () Loc)
(declare-fun t_1828$0 () Loc)
(declare-fun t_1829$0 () Loc)
(declare-fun t_1830$0 () Loc)
(declare-fun t_1831$0 () Loc)
(declare-fun t_1832$0 () Loc)
(declare-fun t_1833$0 () Loc)
(declare-fun t_1834$0 () Loc)
(declare-fun t_1835$0 () Loc)
(declare-fun t_1836$0 () Loc)
(declare-fun t_1837$0 () Loc)
(declare-fun t_1838$0 () Loc)
(declare-fun t_1839$0 () Loc)
(declare-fun t_1840$0 () Loc)
(declare-fun val_2$0 () Int)
(declare-fun val_init$0 () Int)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1840$0))

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1839$0))

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1838$0))

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1837$0))

(assert (=
  (witness$0 data$0 val_2$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1836$0))

(assert (= (witness$0 data$0 val_2$0 (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1835$0))

(assert (=
  (witness$0 data$0 val_2$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1834$0))

(assert (= (witness$0 data$0 val_2$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1833$0))

(assert (=
  (witness$0 data$0 sk_?e_6$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1832$0))

(assert (=
  (witness$0 data$0 sk_?e_6$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1831$0))

(assert (=
  (witness$0 data$0 sk_?e_6$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1830$0))

(assert (=
  (witness$0 data$0 sk_?e_6$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1829$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1828$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1827$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1826$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1825$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1824$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1823$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1822$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1821$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1820$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1819$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1818$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1817$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1816$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1815$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1814$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1813$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1812$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1811$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1810$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1809$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1808$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1807$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1806$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1805$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1804$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1803$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1802$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1801$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1800$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1799$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1798$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1797$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1796$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1795$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1794$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1793$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1792$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_1791$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1790$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_1789$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1788$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1787$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1786$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1785$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1784$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1783$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1782$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1781$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_6$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1780$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_6$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1779$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_6$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1778$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_6$0
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1777$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1776$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1775$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1774$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1773$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1772$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1771$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1770$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1769$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1768$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1767$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1766$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1765$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1764$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1763$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1762$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1761$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1760$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1759$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1758$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1757$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1756$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1755$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1754$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1753$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1752$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1751$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1750$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1749$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1748$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1747$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1746$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1745$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1744$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1743$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1742$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1741$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_1740$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_1739$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_1738$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_1737$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (not Axiom_42$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_169$0)) (not (in$1 l2 sk_?X_169$0))))))

(assert (or (and (Btwn$0 next$0 curr_init$0 null$0 null$0) Axiom_43$0)
    (not
         (sorted_set_struct$0 sk_?X_161$0 data$0 next$0 curr_init$0 null$0
           c1_init$0))))

(assert (or (not Axiom_44$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_5$0))
                (not (in$1 l1 sk_?X_171$0)) (not (in$1 l2 sk_?X_171$0))))))

(assert (or (and (Btwn$0 next$0 lst_init$0 curr_init$0 curr_init$0) Axiom_45$0)
    (not
         (sorted_set_struct$0 sk_?X_163$0 data$0 next$0 lst_init$0
           curr_init$0 c2_init$0))))

(assert (= c1_4$0 c1_init$0))

(assert (= c2_4$0 c2_init$0))

(assert (= content_2$0 content_init$0))

(assert (= curr_5$0 (read$0 next$0 curr_4$0)))

(assert (= prev_4$0 prev_init$0))

(assert (= val_2$0 val_init$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_157$0 sk_?X_159$0))

(assert (= sk_?X_159$0 (union$1 sk_?X_162$0 sk_?X_160$0)))

(assert (= sk_?X_161$0 (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0)))

(assert (= sk_?X_163$0 (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0)))

(assert (or
    (and (= (read$0 next$0 prev_init$0) curr_init$0)
         (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_162$0 sk_?X_160$0))
         (= c1_init$0 (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
         (= c2_init$0 (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
         (= content_init$0 (union$0 c1_init$0 c2_init$0))
         (= sk_?X_157$0 FP$0) (> val_init$0 (read$1 data$0 prev_init$0))
         (Btwn$0 next$0 lst_init$0 prev_init$0 curr_init$0)
         (sorted_set_struct$0 sk_?X_161$0 data$0 next$0 curr_init$0 null$0
           c1_init$0)
         (sorted_set_struct$0 sk_?X_163$0 data$0 next$0 lst_init$0
           curr_init$0 c2_init$0)
         (or (= curr_init$0 null$0) (= prev_init$0 null$0)
             (< (read$1 data$0 prev_init$0) (read$1 data$0 curr_init$0)))
         (not (= prev_init$0 curr_init$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_init$0 (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
         (= c2_init$0 emptyset$0)
         (= content_init$0 (union$0 c1_init$0 c2_init$0))
         (= curr_init$0 lst_init$0) (= prev_init$0 null$0)
         (= sk_?X_156$0 FP$0)
         (sorted_set_struct$0 sk_?X_161$0 data$0 next$0 curr_init$0 null$0
           c1_init$0)
         (or (= curr_init$0 null$0) (= prev_init$0 null$0)
             (< (read$1 data$0 prev_init$0) (read$1 data$0 curr_init$0))))))

(assert (= sk_?X_165$0 sk_?X_167$0))

(assert (= sk_?X_167$0 (union$1 sk_?X_170$0 sk_?X_168$0)))

(assert (= sk_?X_169$0 (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0)))

(assert (= sk_?X_171$0 (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0)))

(assert (= sk_FP_3$0 sk_?X_164$0))

(assert (or (in$0 sk_?e_6$0 c2_5$0)
    (and (in$0 sk_?e_6$0 (union$0 c1_5$0 c2_5$0))
         (not (in$0 sk_?e_6$0 content_2$0)))
    (and (in$0 sk_?e_6$0 c1_5$0)
         (not
              (in$0 sk_?e_6$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))
    (and (in$0 sk_?e_6$0 content_2$0)
         (not (in$0 sk_?e_6$0 (union$0 c1_5$0 c2_5$0))))
    (and (in$0 sk_?e_6$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
         (not (in$0 sk_?e_6$0 c1_5$0)))
    (and (in$1 sk_l2_6$0 sk_FP_3$0) (not (in$1 sk_l2_6$0 FP$0)))
    (and (not (= curr_5$0 null$0)) (not (= prev_5$0 null$0))
         (not (< (read$1 data$0 prev_5$0) (read$1 data$0 curr_5$0))))
    (not (= curr_5$0 lst_2$0)) (not (= prev_5$0 null$0))
    (not (Btwn$0 next$0 curr_5$0 null$0 null$0))
    (and (Btwn$0 next$0 sk_l1_6$0 sk_l2_6$0 null$0)
         (in$1 sk_l1_6$0 sk_?X_169$0) (in$1 sk_l2_6$0 sk_?X_169$0)
         (not (= sk_l1_6$0 sk_l2_6$0))
         (not (< (read$1 data$0 sk_l1_6$0) (read$1 data$0 sk_l2_6$0))))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_init$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 curr_init$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_init$0
                          null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 curr_init$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))
                 (not (= l1 curr_init$0)))
            (and
                 (or (= l1 curr_init$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 curr_init$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_init$0
                          curr_init$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
              (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (and (Btwn$0 next$0 curr_5$0 null$0 null$0) Axiom_42$0)
    (not
         (sorted_set_struct$0 sk_?X_169$0 data$0 next$0 curr_5$0 null$0
           c1_5$0))))

(assert (or (not Axiom_43$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_161$0)) (not (in$1 l2 sk_?X_161$0))))))

(assert (or (and (Btwn$0 next$0 lst_2$0 curr_5$0 curr_5$0) Axiom_44$0)
    (not
         (sorted_set_struct$0 sk_?X_171$0 data$0 next$0 lst_2$0 curr_5$0
           c2_5$0))))

(assert (or (not Axiom_45$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_init$0))
                (not (in$1 l1 sk_?X_163$0)) (not (in$1 l2 sk_?X_163$0))))))

(assert (= FP_Caller_2$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c1_5$0 (setminus$0 c1_4$0 (setenum$0 (read$1 data$0 curr_4$0)))))

(assert (= c2_5$0 (union$0 c2_4$0 (setenum$0 (read$1 data$0 curr_4$0)))))

(assert (= curr_4$0 curr_init$0))

(assert (= lst_2$0 lst_init$0))

(assert (= prev_5$0 curr_4$0))

(assert (< (read$1 data$0 curr_4$0) val_2$0))

(assert (= sk_?X_156$0 sk_?X_158$0))

(assert (= sk_?X_158$0 sk_?X_160$0))

(assert (= sk_?X_160$0 sk_?X_161$0))

(assert (= sk_?X_162$0 sk_?X_163$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (= sk_?X_164$0 sk_?X_166$0))

(assert (= sk_?X_166$0 sk_?X_168$0))

(assert (= sk_?X_168$0 sk_?X_169$0))

(assert (= sk_?X_170$0 sk_?X_171$0))

(assert (= sk_FP_2$0 sk_?X_165$0))

(assert (or (= prev_5$0 curr_5$0)
    (in$1 sk_l1_5$0 (intersection$1 sk_?X_170$0 sk_?X_168$0))
    (and (in$0 sk_?e_5$0 (union$0 c1_5$0 c2_5$0))
         (not (in$0 sk_?e_5$0 content_2$0)))
    (and (in$0 sk_?e_5$0 c1_5$0)
         (not
              (in$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))
    (and (in$0 sk_?e_5$0 c2_5$0)
         (not
              (in$0 sk_?e_5$0
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))
    (and (in$0 sk_?e_5$0 content_2$0)
         (not (in$0 sk_?e_5$0 (union$0 c1_5$0 c2_5$0))))
    (and (in$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
         (not (in$0 sk_?e_5$0 c1_5$0)))
    (and (in$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
         (not (in$0 sk_?e_5$0 c2_5$0)))
    (and (in$1 sk_l1_5$0 sk_FP_2$0) (not (in$1 sk_l1_5$0 FP$0)))
    (and (not (= curr_5$0 null$0)) (not (= prev_5$0 null$0))
         (not (< (read$1 data$0 prev_5$0) (read$1 data$0 curr_5$0))))
    (not (= (read$0 next$0 prev_5$0) curr_5$0))
    (not (> val_2$0 (read$1 data$0 prev_5$0)))
    (not (Btwn$0 next$0 curr_5$0 null$0 null$0))
    (not (Btwn$0 next$0 lst_2$0 curr_5$0 curr_5$0))
    (not (Btwn$0 next$0 lst_2$0 prev_5$0 curr_5$0))
    (and (Btwn$0 next$0 sk_l1_5$0 sk_l2_5$0 null$0)
         (in$1 sk_l1_5$0 sk_?X_169$0) (in$1 sk_l2_5$0 sk_?X_169$0)
         (not (= sk_l1_5$0 sk_l2_5$0))
         (not (< (read$1 data$0 sk_l1_5$0) (read$1 data$0 sk_l2_5$0))))
    (and (Btwn$0 next$0 sk_l1_5$0 sk_l2_5$0 curr_5$0)
         (in$1 sk_l1_5$0 sk_?X_171$0) (in$1 sk_l2_5$0 sk_?X_171$0)
         (not (= sk_l1_5$0 sk_l2_5$0))
         (not (< (read$1 data$0 sk_l1_5$0) (read$1 data$0 sk_l2_5$0))))))

(assert (not (= curr_4$0 null$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_5$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_5$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_2$0 l1 curr_5$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))
                 (not (= l1 curr_5$0)))
            (and
                 (or (= l1 curr_5$0)
                     (not (Btwn$0 next$0 lst_2$0 l1 curr_5$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
              (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
