(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/union.spl:44:8-30:A postcondition of procedure union might not hold at this return point
  tests/spl/sl_sorted_set/union.spl:28:10-53:Related location: This is the postcondition that might not hold
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Alloc_1$0 () SetLoc)
(declare-fun Alloc_2$0 () SetLoc)
(declare-fun Axiom_60$0 () Bool)
(declare-fun Axiom_61$0 () Bool)
(declare-fun Axiom_62$0 () Bool)
(declare-fun Axiom_63$0 () Bool)
(declare-fun Axiom_64$0 () Bool)
(declare-fun Axiom_65$0 () Bool)
(declare-fun Axiom_66$0 () Bool)
(declare-fun Axiom_67$0 () Bool)
(declare-fun Axiom_68$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_1$0 () SetLoc)
(declare-fun FP_2$0 () SetLoc)
(declare-fun FP_3$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun FP_Caller_final_1$0 () SetLoc)
(declare-fun content1$0 () SetInt)
(declare-fun content1_1$0 () SetInt)
(declare-fun content2$0 () SetInt)
(declare-fun content2_1$0 () SetInt)
(declare-fun data$0 () FldInt)
(declare-fun lst1$0 () Loc)
(declare-fun lst2$0 () Loc)
(declare-fun n_2$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun next_1$0 () FldLoc)
(declare-fun res_1$0 () Loc)
(declare-fun res_2$0 () Loc)
(declare-fun sk_?X_68$0 () SetLoc)
(declare-fun sk_?X_69$0 () SetLoc)
(declare-fun sk_?X_70$0 () SetLoc)
(declare-fun sk_?X_71$0 () SetLoc)
(declare-fun sk_?X_72$0 () SetLoc)
(declare-fun sk_?X_73$0 () SetLoc)
(declare-fun sk_?X_74$0 () SetLoc)
(declare-fun sk_?X_75$0 () SetLoc)
(declare-fun sk_?e_4$0 () Int)
(declare-fun sk_l1_7$0 () Loc)
(declare-fun sk_l2_7$0 () Loc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_370$0 () Int)
(declare-fun t_371$0 () Int)
(declare-fun t_372$0 () Int)
(declare-fun t_373$0 () Int)
(declare-fun t_374$0 () Int)
(declare-fun t_375$0 () Int)
(declare-fun t_376$0 () Int)
(declare-fun t_377$0 () Int)
(declare-fun t_378$0 () Int)
(declare-fun t_379$0 () Int)
(declare-fun t_380$0 () Int)
(declare-fun t_381$0 () Int)
(declare-fun t_382$0 () Int)
(declare-fun t_383$0 () Int)
(declare-fun t_384$0 () Int)
(declare-fun t_385$0 () Int)
(declare-fun t_386$0 () Int)
(declare-fun t_387$0 () Int)
(declare-fun t_388$0 () Int)
(declare-fun t_389$0 () Int)
(declare-fun t_390$0 () Int)
(declare-fun t_391$0 () Int)
(declare-fun t_392$0 () Int)
(declare-fun t_393$0 () Int)
(declare-fun t_394$0 () Int)
(declare-fun t_395$0 () Loc)
(declare-fun t_396$0 () Loc)
(declare-fun t_397$0 () Loc)
(declare-fun t_398$0 () Loc)
(declare-fun t_399$0 () Loc)
(declare-fun t_400$0 () Loc)
(declare-fun t_401$0 () Loc)
(declare-fun t_402$0 () Loc)
(declare-fun t_403$0 () Loc)
(declare-fun t_404$0 () Loc)
(declare-fun t_405$0 () Loc)
(declare-fun t_406$0 () Loc)
(declare-fun t_407$0 () Loc)
(declare-fun t_408$0 () Loc)
(declare-fun t_409$0 () Loc)
(declare-fun t_410$0 () Loc)
(declare-fun t_411$0 () Loc)
(declare-fun t_412$0 () Loc)
(declare-fun t_413$0 () Loc)
(declare-fun t_414$0 () Loc)
(declare-fun t_415$0 () Loc)
(declare-fun t_416$0 () Loc)
(declare-fun t_417$0 () Loc)
(declare-fun t_418$0 () Loc)
(declare-fun t_419$0 () Loc)
(declare-fun t_420$0 () Loc)
(declare-fun t_421$0 () Loc)
(declare-fun t_422$0 () Loc)
(declare-fun t_423$0 () Loc)
(declare-fun t_424$0 () Loc)
(declare-fun t_425$0 () Loc)
(declare-fun t_426$0 () Loc)
(declare-fun t_427$0 () Loc)
(declare-fun t_428$0 () Loc)
(declare-fun t_429$0 () Loc)
(declare-fun t_430$0 () Loc)
(declare-fun t_431$0 () Loc)
(declare-fun t_432$0 () Loc)
(declare-fun t_433$0 () Loc)
(declare-fun t_434$0 () Loc)
(declare-fun t_435$0 () Loc)
(declare-fun t_436$0 () Loc)
(declare-fun t_437$0 () Loc)
(declare-fun t_438$0 () Loc)
(declare-fun t_439$0 () Loc)
(declare-fun t_440$0 () Loc)
(declare-fun t_441$0 () Loc)
(declare-fun t_442$0 () Loc)
(declare-fun t_443$0 () Loc)
(declare-fun t_444$0 () Loc)
(declare-fun t_445$0 () Loc)
(declare-fun t_446$0 () Loc)
(declare-fun t_447$0 () Loc)
(declare-fun t_448$0 () Loc)
(declare-fun t_449$0 () Loc)
(declare-fun t_450$0 () Loc)
(declare-fun t_451$0 () Loc)
(declare-fun t_452$0 () Loc)
(declare-fun t_453$0 () Loc)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
  t_453$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
  t_452$0))

(assert (= (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
  t_451$0))

(assert (= (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_450$0))

(assert (= (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_449$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
  t_448$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
  t_447$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
  t_446$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_445$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_444$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
  t_443$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
  t_442$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
  t_441$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_440$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_439$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst2$0)
    (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
  t_438$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst2$0)
    (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
  t_437$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst2$0)
    (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
  t_436$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst2$0)
    (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_435$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst2$0)
    (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_434$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst1$0)
    (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
  t_433$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst1$0)
    (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
  t_432$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst1$0)
    (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
  t_431$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst1$0)
    (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_430$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst1$0)
    (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_429$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_428$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_427$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_426$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_425$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_424$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_423$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_422$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_421$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_420$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_419$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_418$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_417$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_416$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_415$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_414$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_413$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_412$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_411$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_410$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_409$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_408$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_407$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_406$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_405$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_404$0))

(assert (= (ep$0 next$0 FP_2$0 sk_l2_7$0) t_403$0))

(assert (= (ep$0 next$0 FP_2$0 sk_l1_7$0) t_402$0))

(assert (= (ep$0 next$0 FP_2$0 res_2$0) t_401$0))

(assert (= (ep$0 next$0 FP_2$0 res_1$0) t_400$0))

(assert (= (ep$0 next$0 FP_2$0 n_2$0) t_399$0))

(assert (= (ep$0 next$0 FP_2$0 lst2$0) t_398$0))

(assert (= (ep$0 next$0 FP_2$0 lst1$0) t_397$0))

(assert (= (ep$0 next$0 FP_2$0 null$0) t_396$0))

(assert (= (read$0 next_1$0 lst1$0) t_395$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_394$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_393$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_392$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_391$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_390$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_389$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_388$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_387$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_386$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_385$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_384$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_383$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_382$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_381$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_380$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_379$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_378$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_377$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_376$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_375$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_374$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_373$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_372$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_371$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_370$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (not Axiom_60$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_74$0))
                (not (in$1 l2 sk_?X_74$0))))))

(assert (or (and (Btwn$0 next$0 lst2$0 null$0 null$0) Axiom_61$0)
    (not
         (sorted_set_struct$0 sk_?X_70$0 data$0 next$0 lst2$0 null$0
           content2_1$0))))

(assert (or (not Axiom_62$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_73$0))
                (not (in$1 l2 sk_?X_73$0))))))

(assert (or (and (Btwn$0 next$0 n_2$0 null$0 null$0) Axiom_63$0)
    (not
         (sorted_set_struct$0 sk_?X_71$0 data$0 next$0 n_2$0 null$0
           content1_1$0))))

(assert (or (not Axiom_64$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next_1$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_68$0)) (not (in$1 l2 sk_?X_68$0))))))

(assert (or (and (Btwn$0 next_1$0 res_2$0 null$0 null$0) Axiom_65$0)
    (not
         (sorted_set_struct$0 sk_?X_75$0 data$0 next_1$0 res_2$0 null$0
           (union$0 content1$0 content2$0)))))

(assert (= FP_1$0 (setminus$1 FP$0 (setenum$1 lst1$0))))

(assert (= FP_Caller_1$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= n_2$0 (read$0 next$0 lst1$0)))

(assert (Frame$1 FP_2$0 Alloc_1$0 data$0 data$0))

(assert (= Alloc_2$0 (union$1 FP_3$0 Alloc_2$0)))

(assert (= emptyset$1 (intersection$1 sk_?X_71$0 sk_?X_70$0)))

(assert (= content2_1$0 (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))

(assert (= sk_?X_69$0 FP_2$0))

(assert (= sk_?X_71$0 (sorted_set_domain$0 data$0 next$0 n_2$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_70$0 data$0 next$0 lst2$0 null$0 content2_1$0))

(assert (= emptyset$1 (intersection$1 sk_?X_74$0 sk_?X_73$0)))

(assert (= content2$0 (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))

(assert (= sk_?X_72$0 FP$0))

(assert (= sk_?X_74$0 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_73$0 data$0 next$0 lst2$0 null$0 content2$0))

(assert (= (union$0 content1_1$0 content2_1$0)
  (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))

(assert (= sk_?X_68$0 (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0)))

(assert (= sk_?X_75$0
  (union$1 (intersection$1 Alloc_2$0 FP$0) (setminus$1 Alloc_2$0 Alloc$0))))

(assert (not (= lst1$0 null$0)))

(assert (not (< (read$1 data$0 lst1$0) (read$1 data$0 lst2$0))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 n_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst1$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst1$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst1$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 n_2$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 n_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 n_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 n_2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_1$0 res_2$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next_1$0 res_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
              (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (or (and Axiom_68$0 Axiom_67$0 Axiom_66$0)
    (not (Frame$0 FP_2$0 Alloc_1$0 next$0 next_1$0))))

(assert (or (and (Btwn$0 next$0 lst1$0 null$0 null$0) Axiom_60$0)
    (not
         (sorted_set_struct$0 sk_?X_74$0 data$0 next$0 lst1$0 null$0
           content1$0))))

(assert (or (not Axiom_61$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_70$0))
                (not (in$1 l2 sk_?X_70$0))))))

(assert (or (and (Btwn$0 next$0 lst2$0 null$0 null$0) Axiom_62$0)
    (not
         (sorted_set_struct$0 sk_?X_73$0 data$0 next$0 lst2$0 null$0
           content2$0))))

(assert (or (not Axiom_63$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_71$0))
                (not (in$1 l2 sk_?X_71$0))))))

(assert (or (and (Btwn$0 next_1$0 res_1$0 null$0 null$0) Axiom_64$0)
    (not
         (sorted_set_struct$0 sk_?X_68$0 data$0 next_1$0 res_1$0 null$0
           (union$0 content1_1$0 content2_1$0)))))

(assert (or (not Axiom_65$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next_1$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_75$0)) (not (in$1 l2 sk_?X_75$0))))))

(assert (= Alloc_1$0 (setminus$1 Alloc$0 (setenum$1 lst1$0))))

(assert (= FP_3$0
  (union$1 (setminus$1 FP_1$0 FP_2$0)
    (union$1 (intersection$1 Alloc_2$0 FP_2$0)
      (setminus$1 Alloc_2$0 Alloc_1$0)))))

(assert (= FP_Caller_final_1$0 (union$1 FP_Caller_1$0 FP_3$0)))

(assert (= res_2$0 res_1$0))

(assert (Frame$0 FP_2$0 Alloc_1$0 next$0 next_1$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= content1_1$0 (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))

(assert (= sk_?X_69$0 (union$1 sk_?X_71$0 sk_?X_70$0)))

(assert (= sk_?X_70$0 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0)))

(assert (= FP_1$0 (union$1 FP_2$0 FP_1$0)))

(assert (sorted_set_struct$0 sk_?X_71$0 data$0 next$0 n_2$0 null$0 content1_1$0))

(assert (= content1$0 (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))

(assert (= sk_?X_72$0 (union$1 sk_?X_74$0 sk_?X_73$0)))

(assert (= sk_?X_73$0 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0)))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (sorted_set_struct$0 sk_?X_74$0 data$0 next$0 lst1$0 null$0 content1$0))

(assert (= sk_?X_68$0
  (union$1 (intersection$1 Alloc_2$0 FP_2$0)
    (setminus$1 Alloc_2$0 Alloc_1$0))))

(assert (sorted_set_struct$0 sk_?X_68$0 data$0 next_1$0 res_1$0 null$0
  (union$0 content1_1$0 content2_1$0)))

(assert (or
    (and (in$0 sk_?e_4$0 (union$0 content1$0 content2$0))
         (not
              (in$0 sk_?e_4$0
                (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))))
    (and (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
         (not (in$0 sk_?e_4$0 (union$0 content1$0 content2$0))))
    (and (in$1 sk_l2_7$0 sk_?X_75$0)
         (not
              (in$1 sk_l2_7$0
                (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0))))
    (and
         (in$1 sk_l2_7$0
           (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0))
         (not (in$1 sk_l2_7$0 sk_?X_75$0)))
    (not (Btwn$0 next_1$0 res_2$0 null$0 null$0))
    (and (Btwn$0 next_1$0 sk_l1_7$0 sk_l2_7$0 null$0)
         (in$1 sk_l1_7$0 sk_?X_75$0) (in$1 sk_l2_7$0 sk_?X_75$0)
         (not (= sk_l1_7$0 sk_l2_7$0))
         (not (< (read$1 data$0 sk_l1_7$0) (read$1 data$0 sk_l2_7$0))))))

(assert (not (= lst2$0 null$0)))

(assert (not (> (read$1 data$0 lst1$0) (read$1 data$0 lst2$0))))

(assert (not (in$1 null$0 Alloc_2$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 n_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst2$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_1$0 res_1$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next_1$0 res_1$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst1$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 n_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 n_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 n_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 n_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
              (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (not Axiom_66$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (in$1 ?x FP_2$0)
                (and (Btwn$0 next$0 ?x ?z ?y) (Btwn$0 next_1$0 ?x ?z ?y))
                (and (not (Btwn$0 next$0 ?x ?z ?y))
                     (not (Btwn$0 next_1$0 ?x ?z ?y)))
                (not (= ?x (ep$0 next$0 FP_2$0 ?x)))))))

(assert (or (not Axiom_67$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (and (Btwn$0 next$0 ?x ?z ?y) (Btwn$0 next_1$0 ?x ?z ?y))
                (and (not (Btwn$0 next$0 ?x ?z ?y))
                     (not (Btwn$0 next_1$0 ?x ?z ?y)))
                (not
                     (or (Btwn$0 next$0 ?x ?y (ep$0 next$0 FP_2$0 ?x))
                         (and (Btwn$0 next$0 ?x ?y ?y)
                              (not
                                   (Btwn$0 next$0 ?x (ep$0 next$0 FP_2$0 ?x)
                                     (ep$0 next$0 FP_2$0 ?x))))))))))

(assert (or (not Axiom_68$0)
    (forall ((?x Loc))
            (or (= (read$0 next$0 ?x) (read$0 next_1$0 ?x))
                (not (in$1 ?x (setminus$1 Alloc_1$0 FP_2$0)))))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
