(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 (S5 S6) Int)
(declare-fun f6 () S5)
(declare-fun f7 (S7 S2) S6)
(declare-fun f8 () S7)
(declare-fun f9 () S6)
(declare-fun f10 (S4 S8) S4)
(declare-fun f11 () S3)
(declare-fun f12 () S8)
(declare-fun f13 (S4 S8 S8) S4)
(declare-fun f14 () S8)
(declare-fun f15 (S4 S8) S4)
(declare-fun f16 () S8)
(declare-fun f17 (S3 S9) S1)
(declare-fun f18 () S9)
(declare-fun f19 (S10 S4) S1)
(declare-fun f20 (S8 S8) S10)
(declare-fun f21 (S3) S4)
(declare-fun f22 (S11 Int) S6)
(declare-fun f23 () S11)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f3 f11 ?v0))) (= (f3 f4 ?v0) (ite (< (f5 f6 ?v_0) (f5 f6 f9)) (f10 ?v_1 f12) (ite (= ?v_0 f9) (f13 ?v_1 f14 f12) (f15 ?v_1 f12)))))))
(assert (not (= f14 f16)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8) (?v4 S3) (?v5 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v3)) (=> (not (= ?v0 ?v3)) (=> (not (= ?v1 ?v2)) (=> (= (f17 ?v4 f18) f1) (=> (= (f17 ?v5 f18) f1) (=> (forall ((?v6 S2)) (= (= (f19 (f20 ?v0 ?v1) (f3 ?v4 ?v6)) f1) (= (f19 (f20 ?v2 ?v3) (f3 ?v5 ?v6)) f1))) (= (= (f19 (f20 ?v0 ?v1) (f21 ?v4)) f1) (= (f19 (f20 ?v2 ?v3) (f21 ?v5)) f1)))))))))))
(assert (let ((?v_0 (f20 f14 f16))) (not (=> (forall ((?v0 S2)) (let ((?v_1 (f3 f11 ?v0)) (?v_2 (f7 f8 ?v0))) (= (= (f19 ?v_0 ?v_1) f1) (= (f19 ?v_0 (ite (< (f5 f6 ?v_2) (f5 f6 f9)) (f10 ?v_1 f12) (ite (= ?v_2 f9) (f13 ?v_1 f14 f12) (f15 ?v_1 f12)))) f1)))) (=> (forall ((?v0 S3)) (=> (= (f17 ?v0 f18) f1) (forall ((?v1 S3)) (=> (= (f17 ?v1 f18) f1) (forall ((?v2 S8) (?v3 S8)) (let ((?v_3 (f20 ?v2 ?v3))) (=> (forall ((?v4 S2)) (= (= (f19 ?v_3 (f3 ?v0 ?v4)) f1) (= (f19 ?v_3 (f3 ?v1 ?v4)) f1))) (= (= (f19 ?v_3 (f21 ?v0)) f1) (= (f19 ?v_3 (f21 ?v1)) f1))))))))) (=> (= (f17 f11 f18) f1) (=> (= (f17 f4 f18) f1) (= (= (f19 ?v_0 (f21 f11)) f1) (= (f19 ?v_0 (f21 f4)) f1)))))))))
(assert (forall ((?v0 S6)) (= (f22 f23 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f22 f23 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f22 f23 ?v0)) 0))))
(check-sat)
(exit)
