(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-sort S25 0)
(declare-sort S26 0)
(declare-sort S27 0)
(declare-sort S28 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 () S3)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S2) Int)
(declare-fun f8 () S5)
(declare-fun f9 () S3)
(declare-fun f10 () S3)
(declare-fun f11 (S7 Int) S1)
(declare-fun f12 (S8 S6) S7)
(declare-fun f13 () S8)
(declare-fun f14 (S6 S2) S1)
(declare-fun f15 (S9 S7) S7)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S6) S6)
(declare-fun f18 () S10)
(declare-fun f19 (S11 S6) S1)
(declare-fun f20 (S12 S2) S11)
(declare-fun f21 () S12)
(declare-fun f22 () S9)
(declare-fun f23 (S13 S7) S1)
(declare-fun f24 (S14 Int) S13)
(declare-fun f25 () S14)
(declare-fun f26 (S15 S7) S6)
(declare-fun f27 () S15)
(declare-fun f28 (S16 S2) S3)
(declare-fun f29 () S16)
(declare-fun f30 (S17 Int) Int)
(declare-fun f31 (S18 Int) S17)
(declare-fun f32 () S18)
(declare-fun f33 () S16)
(declare-fun f34 (S19 S6) S10)
(declare-fun f35 () S19)
(declare-fun f36 (S20 S7) S9)
(declare-fun f37 () S20)
(declare-fun f38 () S19)
(declare-fun f39 () S20)
(declare-fun f40 () S3)
(declare-fun f41 (S21 S2) S6)
(declare-fun f42 (S22 S2) S21)
(declare-fun f43 () S22)
(declare-fun f44 () S2)
(declare-fun f45 () S19)
(declare-fun f46 (S23 S3) S10)
(declare-fun f47 () S23)
(declare-fun f48 () S20)
(declare-fun f49 (S24 S4) S15)
(declare-fun f50 () S24)
(declare-fun f51 (S25 S5) S8)
(declare-fun f52 () S25)
(declare-fun f53 (S26 S1) S1)
(declare-fun f54 (S27 S1) S26)
(declare-fun f55 () S27)
(declare-fun f56 () S10)
(declare-fun f57 () S9)
(declare-fun f58 () S13)
(declare-fun f59 (S28 S6) S21)
(declare-fun f60 () S28)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 f6 (+ (* 2 (f7 f8 ?v0)) 1)))))
(assert (forall ((?v0 S2)) (= (f3 f9 ?v0) (f5 f6 (* 2 (f7 f8 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 f10 ?v0) (f5 f6 (+ (f7 f8 ?v0) 1)))))
(assert (forall ((?v0 S6) (?v1 Int)) (= (= (f11 (f12 f13 ?v0) ?v1) f1) (and (<= 0 ?v1) (= (f14 ?v0 (f5 f6 ?v1)) f1)))))
(assert (forall ((?v0 S7) (?v1 Int)) (= (= (f11 (f15 f16 ?v0) ?v1) f1) (and (<= 0 ?v1) (= (f11 ?v0 ?v1) f1)))))
(assert (forall ((?v0 S6) (?v1 S2)) (= (= (f14 (f17 f18 ?v0) ?v1) f1) (= (f19 (f20 f21 ?v1) ?v0) f1))))
(assert (forall ((?v0 S7) (?v1 Int)) (= (= (f11 (f15 f22 ?v0) ?v1) f1) (= (f23 (f24 f25 ?v1) ?v0) f1))))
(assert (forall ((?v0 S7) (?v1 S2)) (= (= (f14 (f26 f27 ?v0) ?v1) f1) (= (f11 ?v0 (f7 f8 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f28 f29 ?v0) ?v1) (f5 f6 (f30 (f31 f32 (f7 f8 ?v0)) (f7 f8 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f28 f33 ?v0) ?v1) (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f20 f21 ?v2))) (= (= (f14 (f17 (f34 f35 ?v0) ?v1) ?v2) f1) (or (= (f19 ?v_0 ?v0) f1) (= (f19 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (= (= (f11 (f15 (f36 f37 ?v0) ?v1) ?v2) f1) (or (= (f23 ?v_0 ?v0) f1) (= (f23 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (= (= (f14 (f17 (f34 f38 ?v0) ?v1) ?v2) f1) (or (= (f14 ?v0 ?v2) f1) (= (f14 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (= (= (f11 (f15 (f36 f39 ?v0) ?v1) ?v2) f1) (or (= (f11 ?v0 ?v2) f1) (= (f11 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2)) (= (f3 f40 ?v0) ?v0)))
(assert (let ((?v_0 (f42 f43 (f5 f6 0)))) (let ((?v_1 (f41 ?v_0 f44))) (not (= (f41 ?v_0 (f5 f6 (* 2 (f7 f8 f44)))) (f17 (f34 f45 (f17 (f46 f47 f9) ?v_1)) (f17 (f46 f47 f4) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (f17 (f46 f47 (f28 f33 ?v0)) (f41 (f42 f43 ?v1) ?v2)) (f41 (f42 f43 (f5 f6 (+ (f7 f8 ?v1) ?v_0))) (f5 f6 (+ (f7 f8 ?v2) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f19 ?v_0 (f17 (f34 f45 ?v1) ?v2)) f1) (=> (=> (= (f19 ?v_0 ?v1) f1) false) (=> (=> (= (f19 ?v_0 ?v2) f1) false) false))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f24 f25 ?v0))) (=> (= (f23 ?v_0 (f15 (f36 f48 ?v1) ?v2)) f1) (=> (=> (= (f23 ?v_0 ?v1) f1) false) (=> (=> (= (f23 ?v_0 ?v2) f1) false) false))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (=> (= (f14 (f17 (f34 f45 ?v0) ?v1) ?v2) f1) (=> (=> (= (f14 ?v0 ?v2) f1) false) (=> (=> (= (f14 ?v1 ?v2) f1) false) false)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (=> (= (f11 (f15 (f36 f48 ?v0) ?v1) ?v2) f1) (=> (=> (= (f11 ?v0 ?v2) f1) false) (=> (=> (= (f11 ?v1 ?v2) f1) false) false)))))
(assert (forall ((?v0 S6) (?v1 S2) (?v2 S6)) (=> (=> (not (= (f14 ?v0 ?v1) f1)) (= (f14 ?v2 ?v1) f1)) (= (f14 (f17 (f34 f45 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 S7) (?v1 Int) (?v2 S7)) (=> (=> (not (= (f11 ?v0 ?v1) f1)) (= (f11 ?v2 ?v1) f1)) (= (f11 (f15 (f36 f48 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (=> (=> (not (= (f19 ?v_0 ?v1) f1)) (= (f19 ?v_0 ?v2) f1)) (= (f19 ?v_0 (f17 (f34 f45 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f24 f25 ?v0))) (=> (=> (not (= (f23 ?v_0 ?v1) f1)) (= (f23 ?v_0 ?v2) f1)) (= (f23 ?v_0 (f15 (f36 f48 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2) (?v3 S6)) (=> (= ?v0 (f3 ?v1 ?v2)) (=> (= (f19 (f20 f21 ?v2) ?v3) f1) (= (f19 (f20 f21 ?v0) (f17 (f46 f47 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 Int) (?v3 S7)) (=> (= ?v0 (f5 ?v1 ?v2)) (=> (= (f23 (f24 f25 ?v2) ?v3) f1) (= (f19 (f20 f21 ?v0) (f26 (f49 f50 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S2) (?v3 S6)) (=> (= ?v0 (f7 ?v1 ?v2)) (=> (= (f19 (f20 f21 ?v2) ?v3) f1) (= (f23 (f24 f25 ?v0) (f12 (f51 f52 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f17 (f46 f47 f10) (f41 (f42 f43 ?v0) ?v1)) (f41 (f42 f43 (f5 f6 (+ (f7 f8 ?v0) 1))) (f5 f6 (+ (f7 f8 ?v1) 1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f42 f43 ?v0))) (let ((?v_2 (f5 f6 (+ ?v_0 (f7 f8 ?v2))))) (=> (<= (f7 f8 ?v0) ?v_0) (= (f41 ?v_1 ?v_2) (f17 (f34 f45 (f41 ?v_1 ?v1)) (f41 (f42 f43 ?v1) ?v_2))))))))
(assert (forall ((?v0 S3) (?v1 S6) (?v2 S6)) (let ((?v_0 (f46 f47 ?v0))) (= (f17 ?v_0 (f17 (f34 f45 ?v1) ?v2)) (f17 (f34 f45 (f17 ?v_0 ?v1)) (f17 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S7) (?v2 S7)) (let ((?v_0 (f49 f50 ?v0))) (= (f26 ?v_0 (f15 (f36 f48 ?v1) ?v2)) (f17 (f34 f45 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S6) (?v2 S6)) (let ((?v_0 (f51 f52 ?v0))) (= (f12 ?v_0 (f17 (f34 f45 ?v1) ?v2)) (f15 (f36 f48 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (= (= (f14 (f17 (f34 f45 ?v0) ?v1) ?v2) f1) (= (f53 (f54 f55 (f14 ?v0 ?v2)) (f14 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (= (= (f11 (f15 (f36 f48 ?v0) ?v1) ?v2) f1) (= (f53 (f54 f55 (f11 ?v0 ?v2)) (f11 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (= (= (f14 (f17 (f34 f45 ?v0) ?v1) ?v2) f1) (= (f53 (f54 f55 (f14 ?v0 ?v2)) (f14 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (= (= (f11 (f15 (f36 f48 ?v0) ?v1) ?v2) f1) (= (f53 (f54 f55 (f11 ?v0 ?v2)) (f11 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f17 f56 (f17 (f34 f38 ?v0) ?v1)) (f17 (f34 f45 (f17 f56 ?v0)) (f17 f56 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 f57 (f15 (f36 f39 ?v0) ?v1)) (f15 (f36 f48 (f15 f57 ?v0)) (f15 f57 ?v1)))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f54 f55 ?v0))) (= (= (f53 (f54 f55 (f53 ?v_0 ?v1)) ?v2) f1) (= (f53 ?v_0 (f53 (f54 f55 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 f45 ?v0))) (= (f17 (f34 f45 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f34 f45 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f36 f48 ?v0))) (= (f15 (f36 f48 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f36 f48 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f54 f55 ?v0))) (= (= (f53 (f54 f55 (f53 ?v_0 ?v1)) ?v2) f1) (= (f53 ?v_0 (f53 (f54 f55 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 f45 ?v0))) (= (f17 (f34 f45 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f34 f45 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f36 f48 ?v0))) (= (f15 (f36 f48 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f36 f48 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f54 f55 ?v0))) (= (= (f53 (f54 f55 (f53 ?v_0 ?v1)) ?v2) f1) (= (f53 ?v_0 (f53 (f54 f55 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 f45 ?v0))) (= (f17 (f34 f45 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f34 f45 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f36 f48 ?v0))) (= (f15 (f36 f48 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f36 f48 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f54 f55 ?v0)) (?v_0 (f54 f55 ?v1))) (= (= (f53 ?v_1 (f53 ?v_0 ?v2)) f1) (= (f53 ?v_0 (f53 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f34 f45 ?v0)) (?v_0 (f34 f45 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f36 f48 ?v0)) (?v_0 (f36 f48 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f54 f55 ?v0)) (?v_0 (f54 f55 ?v1))) (= (= (f53 ?v_1 (f53 ?v_0 ?v2)) f1) (= (f53 ?v_0 (f53 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f34 f45 ?v0)) (?v_0 (f34 f45 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f36 f48 ?v0)) (?v_0 (f36 f48 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f54 f55 ?v0)) (?v_0 (f54 f55 ?v1))) (= (= (f53 ?v_1 (f53 ?v_0 ?v2)) f1) (= (f53 ?v_0 (f53 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f34 f45 ?v0)) (?v_0 (f34 f45 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f36 f48 ?v0)) (?v_0 (f36 f48 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f54 f55 ?v0))) (let ((?v_1 (f53 ?v_0 ?v1))) (= (= (f53 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f34 f45 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f36 f48 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f54 f55 ?v0))) (let ((?v_1 (f53 ?v_0 ?v1))) (= (= (f53 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f34 f45 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f36 f48 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f54 f55 ?v0))) (let ((?v_1 (f53 ?v_0 ?v1))) (= (= (f53 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f34 f45 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f36 f48 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f53 (f54 f55 ?v0) ?v1) f1) (= (f53 (f54 f55 ?v1) ?v0) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f17 (f34 f45 ?v0) ?v1) (f17 (f34 f45 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f36 f48 ?v0) ?v1) (f15 (f36 f48 ?v1) ?v0))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f53 (f54 f55 ?v0) ?v1) f1) (= (f53 (f54 f55 ?v1) ?v0) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f17 (f34 f45 ?v0) ?v1) (f17 (f34 f45 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f36 f48 ?v0) ?v1) (f15 (f36 f48 ?v1) ?v0))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f53 (f54 f55 ?v0) ?v1) f1) (= (f53 (f54 f55 ?v1) ?v0) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f17 (f34 f45 ?v0) ?v1) (f17 (f34 f45 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f36 f48 ?v0) ?v1) (f15 (f36 f48 ?v1) ?v0))))
(assert (forall ((?v0 S1)) (= (= (f53 (f54 f55 ?v0) ?v0) f1) (= ?v0 f1))))
(assert (forall ((?v0 S6)) (= (f17 (f34 f45 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f15 (f36 f48 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S1)) (= (= (f53 (f54 f55 ?v0) ?v0) f1) (= ?v0 f1))))
(assert (forall ((?v0 S6)) (= (f17 (f34 f45 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f15 (f36 f48 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2) (?v3 S3)) (=> (= (f19 (f20 f21 ?v0) ?v1) f1) (=> (= ?v2 (f3 ?v3 ?v0)) (= (f19 (f20 f21 ?v2) (f17 (f46 f47 ?v3) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S2) (?v3 S4)) (=> (= (f23 (f24 f25 ?v0) ?v1) f1) (=> (= ?v2 (f5 ?v3 ?v0)) (= (f19 (f20 f21 ?v2) (f26 (f49 f50 ?v3) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 Int) (?v3 S5)) (=> (= (f19 (f20 f21 ?v0) ?v1) f1) (=> (= ?v2 (f7 ?v3 ?v0)) (= (f23 (f24 f25 ?v2) (f12 (f51 f52 ?v3) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S3)) (=> (= (f19 (f20 f21 ?v0) ?v1) f1) (= (f19 (f20 f21 (f3 ?v2 ?v0)) (f17 (f46 f47 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S4)) (=> (= (f23 (f24 f25 ?v0) ?v1) f1) (= (f19 (f20 f21 (f5 ?v2 ?v0)) (f26 (f49 f50 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S5)) (=> (= (f19 (f20 f21 ?v0) ?v1) f1) (= (f23 (f24 f25 (f7 ?v2 ?v0)) (f12 (f51 f52 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S6)) (= (= (f19 (f20 f21 ?v0) (f17 (f46 f47 ?v1) ?v2)) f1) (exists ((?v3 S2)) (and (= (f19 (f20 f21 ?v3) ?v2) f1) (= ?v0 (f3 ?v1 ?v3)))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S7)) (= (= (f19 (f20 f21 ?v0) (f26 (f49 f50 ?v1) ?v2)) f1) (exists ((?v3 Int)) (and (= (f23 (f24 f25 ?v3) ?v2) f1) (= ?v0 (f5 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S6)) (= (= (f23 (f24 f25 ?v0) (f12 (f51 f52 ?v1) ?v2)) f1) (exists ((?v3 S2)) (and (= (f19 (f20 f21 ?v3) ?v2) f1) (= ?v0 (f7 ?v1 ?v3)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f19 ?v_0 ?v1) f1) (= (f19 ?v_0 (f17 (f34 f45 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f24 f25 ?v0))) (=> (= (f23 ?v_0 ?v1) f1) (= (f23 ?v_0 (f15 (f36 f48 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f19 ?v_0 ?v1) f1) (= (f19 ?v_0 (f17 (f34 f45 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f24 f25 ?v0))) (=> (= (f23 ?v_0 ?v1) f1) (= (f23 ?v_0 (f15 (f36 f48 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S2) (?v2 S6)) (=> (= (f14 ?v0 ?v1) f1) (= (f14 (f17 (f34 f45 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 S7) (?v1 Int) (?v2 S7)) (=> (= (f11 ?v0 ?v1) f1) (= (f11 (f15 (f36 f48 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 S6) (?v1 S2) (?v2 S6)) (=> (= (f14 ?v0 ?v1) f1) (= (f14 (f17 (f34 f45 ?v0) ?v2) ?v1) f1))))
(assert (forall ((?v0 S7) (?v1 Int) (?v2 S7)) (=> (= (f11 ?v0 ?v1) f1) (= (f11 (f15 (f36 f48 ?v0) ?v2) ?v1) f1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (forall ((?v3 S2)) (=> (= (f19 (f20 f21 ?v3) (f17 (f34 f45 ?v0) ?v1)) f1) (= (f14 ?v2 ?v3) f1))) (and (forall ((?v3 S2)) (=> (= (f19 (f20 f21 ?v3) ?v0) f1) (= (f14 ?v2 ?v3) f1))) (forall ((?v3 S2)) (=> (= (f19 (f20 f21 ?v3) ?v1) f1) (= (f14 ?v2 ?v3) f1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (forall ((?v3 Int)) (=> (= (f23 (f24 f25 ?v3) (f15 (f36 f48 ?v0) ?v1)) f1) (= (f11 ?v2 ?v3) f1))) (and (forall ((?v3 Int)) (=> (= (f23 (f24 f25 ?v3) ?v0) f1) (= (f11 ?v2 ?v3) f1))) (forall ((?v3 Int)) (=> (= (f23 (f24 f25 ?v3) ?v1) f1) (= (f11 ?v2 ?v3) f1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (exists ((?v3 S2)) (and (= (f19 (f20 f21 ?v3) (f17 (f34 f45 ?v0) ?v1)) f1) (= (f14 ?v2 ?v3) f1))) (or (exists ((?v3 S2)) (and (= (f19 (f20 f21 ?v3) ?v0) f1) (= (f14 ?v2 ?v3) f1))) (exists ((?v3 S2)) (and (= (f19 (f20 f21 ?v3) ?v1) f1) (= (f14 ?v2 ?v3) f1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (exists ((?v3 Int)) (and (= (f23 (f24 f25 ?v3) (f15 (f36 f48 ?v0) ?v1)) f1) (= (f11 ?v2 ?v3) f1))) (or (exists ((?v3 Int)) (and (= (f23 (f24 f25 ?v3) ?v0) f1) (= (f11 ?v2 ?v3) f1))) (exists ((?v3 Int)) (and (= (f23 (f24 f25 ?v3) ?v1) f1) (= (f11 ?v2 ?v3) f1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 f45 ?v0))) (= (f17 (f34 f45 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f34 f45 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f36 f48 ?v0))) (= (f15 (f36 f48 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f36 f48 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (= (f19 ?v_0 (f17 (f34 f45 ?v1) ?v2)) f1) (or (= (f19 ?v_0 ?v1) f1) (= (f19 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f24 f25 ?v0))) (= (= (f23 ?v_0 (f15 (f36 f48 ?v1) ?v2)) f1) (or (= (f23 ?v_0 ?v1) f1) (= (f23 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f34 f45 ?v0)) (?v_0 (f34 f45 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f36 f48 ?v0)) (?v_0 (f36 f48 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f34 f45 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f36 f48 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f17 (f34 f45 ?v0) ?v1) (f17 (f34 f45 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f36 f48 ?v0) ?v1) (f15 (f36 f48 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f17 (f34 f45 ?v0) ?v1) (f17 f56 (f17 (f34 f35 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f36 f48 ?v0) ?v1) (f15 f57 (f15 (f36 f37 ?v0) ?v1)))))
(assert (forall ((?v0 S6)) (= (f17 (f34 f45 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f15 (f36 f48 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f17 (f46 f47 f40) ?v0) ?v0)))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (= (= (f14 (f17 (f34 f45 (f17 f18 ?v0)) (f17 f18 ?v1)) ?v2) f1) (= (f19 (f20 f21 ?v2) (f17 (f34 f45 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (= (= (f11 (f15 (f36 f48 (f15 f22 ?v0)) (f15 f22 ?v1)) ?v2) f1) (= (f23 (f24 f25 ?v2) (f15 (f36 f48 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S6)) (=> (= (f19 (f20 f21 ?v0) (f17 (f46 f47 ?v1) ?v2)) f1) (=> (forall ((?v3 S2)) (=> (= ?v0 (f3 ?v1 ?v3)) (=> (= (f19 (f20 f21 ?v3) ?v2) f1) false))) false))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S7)) (=> (= (f19 (f20 f21 ?v0) (f26 (f49 f50 ?v1) ?v2)) f1) (=> (forall ((?v3 Int)) (=> (= ?v0 (f5 ?v1 ?v3)) (=> (= (f23 (f24 f25 ?v3) ?v2) f1) false))) false))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S6)) (=> (= (f23 (f24 f25 ?v0) (f12 (f51 f52 ?v1) ?v2)) f1) (=> (forall ((?v3 S2)) (=> (= ?v0 (f7 ?v1 ?v3)) (=> (= (f19 (f20 f21 ?v3) ?v2) f1) false))) false))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S3) (?v3 S3)) (=> (= ?v0 ?v1) (=> (forall ((?v4 S2)) (=> (= (f19 (f20 f21 ?v4) ?v1) f1) (= (f3 ?v2 ?v4) (f3 ?v3 ?v4)))) (= (f17 (f46 f47 ?v2) ?v0) (f17 (f46 f47 ?v3) ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S4) (?v3 S4)) (=> (= ?v0 ?v1) (=> (forall ((?v4 Int)) (=> (= (f23 (f24 f25 ?v4) ?v1) f1) (= (f5 ?v2 ?v4) (f5 ?v3 ?v4)))) (= (f26 (f49 f50 ?v2) ?v0) (f26 (f49 f50 ?v3) ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5) (?v3 S5)) (=> (= ?v0 ?v1) (=> (forall ((?v4 S2)) (=> (= (f19 (f20 f21 ?v4) ?v1) f1) (= (f7 ?v2 ?v4) (f7 ?v3 ?v4)))) (= (f12 (f51 f52 ?v2) ?v0) (f12 (f51 f52 ?v3) ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f51 f52 f8))) (= (f17 (f34 f45 ?v0) ?v1) (f26 (f49 f50 f6) (f15 (f36 f48 (f12 ?v_0 ?v0)) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (forall ((?v2 S2)) (=> (< (f7 f8 ?v2) (f7 f8 ?v0)) (= (f14 ?v1 ?v2) f1))) (forall ((?v2 S2)) (=> (= (f19 (f20 f21 ?v2) (f41 (f42 f43 (f5 f6 0)) ?v0)) f1) (= (f14 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (exists ((?v2 S2)) (and (< (f7 f8 ?v2) (f7 f8 ?v0)) (= (f14 ?v1 ?v2) f1))) (exists ((?v2 S2)) (and (= (f19 (f20 f21 ?v2) (f41 (f42 f43 (f5 f6 0)) ?v0)) f1) (= (f14 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f7 f8 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f30 (f31 f32 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f30 (f31 f32 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f30 (f31 f32 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f5 f6 (f30 (f31 f32 (f7 f8 ?v0)) (f7 f8 ?v1)))) (or (= ?v1 (f5 f6 1)) (= ?v0 (f5 f6 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_3 (f7 f8 ?v3)) (?v_1 (f7 f8 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f30 (f31 f32 ?v_0) ?v_1) (f30 (f31 f32 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_3 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v2))) (let ((?v_2 (f31 f32 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f30 ?v_2 ?v_1) (f30 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S6)) (= (f17 f56 ?v0) (f26 (f49 f50 f6) (f15 f57 (f12 f13 ?v0))))))
(assert (forall ((?v0 S7)) (= (f15 f57 (f15 f16 ?v0)) (f12 (f51 f52 f8) (f17 f56 (f26 f27 ?v0))))))
(assert (forall ((?v0 S6)) (= (f26 (f49 f50 f6) (f12 (f51 f52 f8) ?v0)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S6)) (= (= (f19 (f20 f21 ?v0) ?v1) f1) (= (f23 (f24 f25 (f7 f8 ?v0)) (f12 (f51 f52 f8) ?v1)) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f51 f52 f8))) (= (= ?v0 ?v1) (= (f12 ?v_0 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f30 (f31 f32 (f7 f8 ?v0)) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f5 f6 (f30 (f31 f32 (f7 f8 (f5 f6 ?v0))) (f7 f8 (f5 f6 ?v1)))) (f5 f6 (f30 (f31 f32 ?v0) ?v1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (<= ?v_0 (f30 (f31 f32 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f31 f32 ?v_0))) (<= ?v_0 (f30 ?v_1 (f30 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f5 f6 (* 0 (f7 f8 ?v0))) (f5 f6 0))))
(assert (forall ((?v0 S2)) (= (f5 f6 (* 1 (f7 f8 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1))) (= (< 0 (f30 (f31 f32 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 1))) (= (= ?v_0 (f5 f6 (f30 (f31 f32 (f7 f8 ?v0)) (f7 f8 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f5 f6 (* (f7 f8 ?v0) 0)) (f5 f6 0))))
(assert (forall ((?v0 S2)) (= (f5 f6 (* (f7 f8 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S6)) (= (= (f19 (f20 f21 ?v0) ?v1) f1) (= (f14 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (= (f23 (f24 f25 ?v0) ?v1) f1) (= (f11 ?v1 ?v0) f1))))
(assert (forall ((?v0 S6)) (= (f17 f56 ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f15 f57 ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f5 f6 (f30 (f31 f32 ?v_1) ?v_0)) (f5 f6 (f30 (f31 f32 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f31 f32 ?v_0)) (?v_2 (f7 f8 ?v1))) (= (f5 f6 (f30 ?v_1 (+ ?v_2 1))) (f5 f6 (+ ?v_0 (f30 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 (f7 f8 ?v0))) (?v_1 (f7 f8 ?v1)) (?v_2 (f7 f8 ?v2))) (= (f5 f6 (f30 ?v_0 (+ ?v_1 ?v_2))) (f5 f6 (+ (f30 ?v_0 ?v_1) (f30 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 (f7 f8 ?v0))) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (f5 f6 (f30 ?v_0 (f7 f8 (f5 f6 (- ?v_1 ?v_2))))) (f5 f6 (- (f30 ?v_0 ?v_1) (f30 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (= (<= ?v_0 (f30 (f31 f32 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f5 f6 (f30 (f31 f32 (+ ?v_1 1)) ?v_0)) (f5 f6 (+ ?v_0 (f30 (f31 f32 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 1))) (= (= (f5 f6 (f30 (f31 f32 (f7 f8 ?v0)) (f7 f8 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 0))) (= (= (f5 f6 (f30 (f31 f32 (f7 f8 ?v0)) (f7 f8 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 (f7 f8 ?v0))) (?v_1 (f7 f8 ?v1)) (?v_2 (f7 f8 ?v2))) (= (f5 f6 (f30 (f31 f32 (f30 ?v_0 ?v_1)) ?v_2)) (f5 f6 (f30 ?v_0 (f30 (f31 f32 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v2))) (= (f5 f6 (f30 (f31 f32 (+ ?v_0 ?v_2)) ?v_1)) (f5 f6 (+ (f30 (f31 f32 ?v_0) ?v_1) (f30 (f31 f32 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v2))) (= (f5 f6 (f30 (f31 f32 (f7 f8 (f5 f6 (- ?v_0 ?v_2)))) ?v_1)) (f5 f6 (- (f30 (f31 f32 ?v_0) ?v_1) (f30 (f31 f32 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 (+ 0 1)))) (= (= (f5 f6 (f30 (f31 f32 (f7 f8 ?v0)) (f7 f8 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f7 f8 ?v0))) (let ((?v_0 (f31 f32 ?v_1)) (?v_3 (f7 f8 ?v2)) (?v_2 (f7 f8 ?v1))) (= (< (f30 ?v_0 ?v_2) (f30 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v2)) (?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (< (f30 (f31 f32 ?v_1) ?v_0) (f30 (f31 f32 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f7 f8 ?v0))) (let ((?v_0 (f31 f32 ?v_1)) (?v_3 (f7 f8 ?v2)) (?v_2 (f7 f8 ?v1))) (= (<= (f30 ?v_0 ?v_2) (f30 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v2)) (?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (<= (f30 (f31 f32 ?v_1) ?v_0) (f30 (f31 f32 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 (f7 f8 ?v0)))) (= (= (f5 f6 (f30 ?v_0 (f7 f8 ?v1))) (f5 f6 (f30 ?v_0 (f7 f8 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f5 f6 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v1))) (= (= (f5 f6 (f30 (f31 f32 (f7 f8 ?v0)) ?v_0)) (f5 f6 (f30 (f31 f32 (f7 f8 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f5 f6 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 (+ (f7 f8 ?v0) 1)))) (= (= (f5 f6 (f30 ?v_0 (f7 f8 ?v1))) (f5 f6 (f30 ?v_0 (f7 f8 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 (+ (f7 f8 ?v0) 1))) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (< (f30 ?v_0 ?v_1) (f30 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 (+ (f7 f8 ?v0) 1))) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (<= (f30 ?v_0 ?v_1) (f30 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f30 (f31 f32 ?v_0) ?v_2) (f30 (f31 f32 ?v_1) ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f31 f32 (f7 f8 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f30 ?v_1 ?v_0) (f30 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f30 (f31 f32 ?v_0) ?v_1) (f30 (f31 f32 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f49 f50 f6))) (=> (= (f23 f58 ?v0) f1) (=> (= (f23 f58 ?v1) f1) (= (f15 (f36 f48 ?v0) ?v1) (f12 (f51 f52 f8) (f17 (f34 f45 (f26 ?v_0 ?v0)) (f26 ?v_0 ?v1)))))))))
(assert (forall ((?v0 S6) (?v1 S2) (?v2 S2)) (= (= (f14 (f41 (f59 f60 ?v0) ?v1) ?v2) f1) (forall ((?v3 S2)) (=> (= (f19 (f20 f21 ?v3) (f41 (f42 f43 ?v1) ?v2)) f1) (= (f14 ?v0 ?v3) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f30 (f31 f32 ?v0) ?v1))) (= (f5 f6 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f5 f6 (f30 (f31 f32 (f7 f8 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)))) (f7 f8 (f5 f6 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f30 (f31 f32 (f7 f8 ?v0)) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f30 (f31 f32 (f7 f8 ?v0)) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f30 (f31 f32 ?v0) ?v1)) (f5 f6 (f30 (f31 f32 (f7 f8 (f5 f6 ?v0))) (f7 f8 (f5 f6 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f5 f6 (f30 (f31 f32 ?v0) ?v1)) (f5 f6 (f30 (f31 f32 (f7 f8 (f5 f6 (- ?v0)))) (f7 f8 (f5 f6 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f30 (f31 f32 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f30 (f31 f32 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f7 f8 ?v2))) (let ((?v_1 (f31 f32 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f30 ?v_1 ?v0) (f30 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 f32 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f30 ?v_0 ?v0) (f30 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f30 (f31 f32 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f30 (f31 f32 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 S7) (?v1 Int)) (=> (= (f23 f58 ?v0) f1) (=> (= (f23 (f24 f25 ?v1) ?v0) f1) (<= 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f30 (f31 f32 (- ?v0 ?v1)) ?v2) (- (f30 (f31 f32 ?v0) ?v2) (f30 (f31 f32 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f30 (f31 f32 (+ ?v0 ?v1)) ?v2) (+ (f30 (f31 f32 ?v0) ?v2) (f30 (f31 f32 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 (f31 f32 (f30 ?v_0 ?v1)) ?v2) (f30 ?v_0 (f30 (f31 f32 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 (f31 f32 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 (f31 f32 (- ?v0)) ?v1) (- (f30 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (- ?v1 ?v2)) (- (f30 ?v_0 ?v1) (f30 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (+ ?v1 ?v2)) (+ (f30 ?v_0 ?v1) (f30 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 (f31 f32 ?v0) ?v1) (f30 (f31 f32 ?v1) ?v0))))
(assert (forall ((?v0 S2)) (= (f5 f6 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
