(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S6) S5)
(declare-fun f7 (S7 S5) S4)
(declare-fun f8 (S8 S4) S7)
(declare-fun f9 () S8)
(declare-fun f10 (S9 S5) S5)
(declare-fun f11 (S10 S5) S9)
(declare-fun f12 () S10)
(declare-fun f13 () S8)
(declare-fun f14 () S10)
(declare-fun f15 (S11 S4) S4)
(declare-fun f16 (S12 S5) S11)
(declare-fun f17 () S12)
(declare-fun f18 () S10)
(declare-fun f19 () S7)
(declare-fun f20 () S4)
(declare-fun f21 () S6)
(declare-fun f22 () S6)
(declare-fun f23 () S5)
(declare-fun f24 (S13 S6) Int)
(declare-fun f25 () S13)
(declare-fun f26 (S14 S6) S6)
(declare-fun f27 (S15 S6) S14)
(declare-fun f28 () S15)
(declare-fun f29 () S6)
(declare-fun f30 (S16 Int) S13)
(declare-fun f31 () S16)
(declare-fun f32 (S17 Int) S6)
(declare-fun f33 () S17)
(declare-fun f34 () S2)
(declare-fun f35 () S3)
(declare-fun f36 () S3)
(declare-fun f37 () S3)
(declare-fun f38 (S18 S19) S5)
(declare-fun f39 (S20 S4) S18)
(declare-fun f40 () S20)
(declare-fun f41 (S21 S6) S19)
(declare-fun f42 (S6) S21)
(declare-fun f43 () S5)
(declare-fun f44 () S15)
(declare-fun f45 () S6)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S5) (?v2 S6)) (= (f6 (f7 (f8 f9 ?v0) ?v1) ?v2) (f10 (f11 f12 (f6 ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S5) (?v2 S6)) (= (f6 (f7 (f8 f13 ?v0) ?v1) ?v2) (f10 (f11 f14 (f6 ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S4) (?v2 S6)) (= (f6 (f15 (f16 f17 ?v0) ?v1) ?v2) (f10 (f11 f14 ?v0) (f6 ?v1 ?v2)))))
(assert (let ((?v_1 (f7 f19 (f6 f20 f21)))) (let ((?v_0 (f6 ?v_1 f22))) (let ((?v_2 (f10 (f11 f18 ?v_0) f23))) (not (= (f10 (f11 f12 (f10 (f11 f18 (f6 (f7 f19 ?v_0) f21)) f23)) ?v_2) (f10 (f11 f12 (f10 (f11 f18 (f6 (f7 f19 (f6 ?v_1 f21)) f22)) f23)) ?v_2)))))))
(assert (< 0 (f24 f25 f22)))
(assert (< (f24 f25 f22) (f24 f25 f21)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f19 (f6 f20 ?v0)) ?v0) f23)))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f11 f12 f23))) (= (f10 ?v_0 (f6 (f7 f19 ?v0) ?v1)) (f6 (f7 f19 (f10 ?v_0 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S6)) (= (f6 (f7 f19 (f10 (f11 f12 ?v0) ?v1)) ?v2) (f10 (f11 f12 (f6 (f7 f19 ?v0) ?v2)) (f6 (f7 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f10 (f11 f12 (f10 (f11 f18 ?v0) ?v1)) ?v2) (f10 (f11 f18 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f10 (f11 f12 (f10 (f11 f18 ?v0) ?v1)) ?v2) (f10 (f11 f18 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) f23) ?v0)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f28 f29) ?v0) f29)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f19 f23) ?v0) f23)))
(assert (forall ((?v0 S6)) (= (f24 (f30 f31 1) ?v0) 1)))
(assert (= (f26 (f27 f28 f29) (f32 f33 2)) f29))
(assert (= (f6 (f7 f19 f23) (f32 f33 2)) f23))
(assert (= (f24 (f30 f31 1) (f32 f33 2)) 1))
(assert (forall ((?v0 S6)) (= (f26 (f27 f28 ?v0) (f32 f33 0)) f29)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f19 ?v0) (f32 f33 0)) f23)))
(assert (forall ((?v0 Int)) (= (f24 (f30 f31 ?v0) (f32 f33 0)) 1)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f28 ?v0) (f32 f33 0)) f29)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f19 ?v0) (f32 f33 0)) f23)))
(assert (forall ((?v0 Int)) (= (f24 (f30 f31 ?v0) (f32 f33 0)) 1)))
(assert (forall ((?v0 Int) (?v1 S6)) (= (f3 f34 (f24 (f30 f31 ?v0) ?v1)) (f24 (f30 f31 (f3 f34 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f24 (f30 f31 ?v0) (f32 f33 2)))) (= (f3 f34 ?v_0) ?v_0))))
(assert (= (f3 f34 1) 1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f32 f33 2))) (= (f24 (f30 f31 (f3 f34 ?v0)) ?v_0) (f24 (f30 f31 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f24 (f30 f31 ?v0) (f32 f33 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f19 ?v0) (f32 f33 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f28 ?v0) (f32 f33 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f24 (f30 f31 ?v0) (f32 f33 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f19 ?v0) (f32 f33 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f28 ?v0) (f32 f33 1)) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f10 (f11 f18 ?v0) ?v1) (f10 (f11 f18 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f35 ?v0) ?v1) ?v2) (f3 (f4 f35 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f36 ?v0) ?v1) ?v2) (f3 (f4 f36 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f34 (- ?v0 ?v1)) (f3 f34 (- ?v1 ?v0)))))
(assert (forall ((?v0 S6)) (= (= f29 ?v0) (= ?v0 f29))))
(assert (forall ((?v0 S5)) (= (= f23 ?v0) (= ?v0 f23))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f4 f37 ?v_0))) (=> (< 0 ?v_0) (= (f6 (f7 f19 (f6 f20 (f32 f33 (f3 ?v_1 (f24 f25 ?v1))))) (f32 f33 (f3 ?v_1 (f24 f25 ?v2)))) (f6 (f7 f19 (f6 f20 ?v1)) ?v2)))))))
(assert (let ((?v_1 (f6 (f7 f19 (f6 f20 f21)) f22))) (let ((?v_0 (f7 f19 ?v_1))) (= (f38 (f39 f40 ?v_0) (f41 (f42 (f32 f33 0)) f21)) (f10 (f11 f12 (f10 (f11 f18 (f6 ?v_0 f21)) f23)) (f10 (f11 f18 ?v_1) f23))))))
(assert (forall ((?v0 S5) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v2)) (?v_1 (f24 f25 ?v1)) (?v_2 (f7 f19 ?v0))) (=> (not (= ?v0 f43)) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f32 f33 (- ?v_0 ?v_1))) (f10 (f11 f12 (f6 ?v_2 ?v2)) (f6 ?v_2 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f34 (f3 (f4 f37 ?v0) ?v1)) (f3 (f4 f37 (f3 f34 ?v0)) (f3 f34 ?v1)))))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 f45) ?v0) f45)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 f43) ?v0) f43)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 f45) ?v0) f45)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 f43) ?v0) f43)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 f43) ?v0) f43)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 f43) ?v0) f43)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 ?v0) f45) f45)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 ?v0) f43) f43)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 ?v0) f45) f45)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 ?v0) f43) f43)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 ?v0) f43) f43)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 ?v0) f43) f43)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f10 (f11 f14 ?v0) ?v1) (f10 (f11 f14 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f26 (f27 f44 ?v0) ?v1) (f26 (f27 f44 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f37 ?v0) ?v1) (f3 (f4 f37 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 ?v1) (ite (= ?v1 (f32 f33 0)) (f32 f33 1) (f32 f33 (f3 (f4 f37 (f24 f25 ?v0)) (f24 f25 (f26 ?v_0 (f32 f33 (- (f24 f25 ?v1) 1)))))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f32 f33 0)) (?v_2 (f24 f25 ?v0)) (?v_1 (f24 f25 ?v1))) (= (f32 f33 (f3 (f4 f37 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f32 f33 (+ ?v_1 (f3 (f4 f37 (f24 f25 (f32 f33 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f32 f33 (* ?v_0 2)) (f32 f33 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f11 f14 ?v0)) (?v_0 (f11 f14 ?v1))) (= (f10 ?v_1 (f10 ?v_0 ?v2)) (f10 ?v_0 (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f27 f44 ?v0)) (?v_0 (f27 f44 ?v1))) (= (f26 ?v_1 (f26 ?v_0 ?v2)) (f26 ?v_0 (f26 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f4 f37 ?v0)) (?v_0 (f4 f37 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S4) (?v2 S19)) (= (f10 (f11 f14 ?v0) (f38 (f39 f40 ?v1) ?v2)) (f38 (f39 f40 (f15 (f16 f17 ?v0) ?v1)) ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v0))) (= (f10 ?v_0 (f10 (f11 f14 ?v1) ?v2)) (f10 (f11 f14 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 ?v_0 (f26 (f27 f44 ?v1) ?v2)) (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f37 ?v0))) (= (f3 ?v_0 (f3 (f4 f37 ?v1) ?v2)) (f3 (f4 f37 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f34 ?v0))) (= (f3 (f4 f37 ?v_0) ?v_0) (f3 (f4 f37 ?v0) ?v0)))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f32 f33 (* 2 ?v_0)) (f32 f33 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f37 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f10 (f11 f14 ?v0) ?v1) f43) (or (= ?v0 f43) (= ?v1 f43)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v0))) (= (f10 (f11 f14 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f14 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f44 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f37 ?v0))) (= (f3 (f4 f37 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f37 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S19) (?v2 S5)) (= (f10 (f11 f14 (f38 (f39 f40 ?v0) ?v1)) ?v2) (f38 (f39 f40 (f7 (f8 f13 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S19) (?v2 S5)) (= (f10 (f11 f12 (f38 (f39 f40 ?v0) ?v1)) ?v2) (f38 (f39 f40 (f7 (f8 f9 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v0))) (= (f10 (f11 f14 (f10 ?v_0 ?v1)) ?v2) (f10 (f11 f14 (f10 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f44 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f37 ?v0))) (= (f3 (f4 f37 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f37 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f11 f14 ?v0)) (?v_1 (f10 (f11 f14 ?v2) ?v3))) (= (f10 (f11 f14 (f10 ?v_0 ?v1)) ?v_1) (f10 ?v_0 (f10 (f11 f14 ?v1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f27 f44 ?v0)) (?v_1 (f26 (f27 f44 ?v2) ?v3))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v_1) (f26 ?v_0 (f26 (f27 f44 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f37 ?v0)) (?v_1 (f3 (f4 f37 ?v2) ?v3))) (= (f3 (f4 f37 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f37 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f11 f14 (f10 (f11 f14 ?v0) ?v1))) (?v_0 (f11 f14 ?v2))) (= (f10 ?v_1 (f10 ?v_0 ?v3)) (f10 ?v_0 (f10 ?v_1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f27 f44 (f26 (f27 f44 ?v0) ?v1))) (?v_0 (f27 f44 ?v2))) (= (f26 ?v_1 (f26 ?v_0 ?v3)) (f26 ?v_0 (f26 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f4 f37 (f3 (f4 f37 ?v0) ?v1))) (?v_0 (f4 f37 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f11 f14 ?v0))) (= (f10 (f11 f14 (f10 ?v_0 ?v1)) (f10 (f11 f14 ?v2) ?v3)) (f10 (f11 f14 (f10 ?v_0 ?v2)) (f10 (f11 f14 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) (f26 (f27 f44 ?v2) ?v3)) (f26 (f27 f44 (f26 ?v_0 ?v2)) (f26 (f27 f44 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f37 ?v0))) (= (f3 (f4 f37 (f3 ?v_0 ?v1)) (f3 (f4 f37 ?v2) ?v3)) (f3 (f4 f37 (f3 ?v_0 ?v2)) (f3 (f4 f37 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f45)) (=> (not (= ?v1 f45)) (not (= (f26 (f27 f44 ?v0) ?v1) f45))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f3 (f4 f37 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f43)) (=> (not (= ?v1 f43)) (not (= (f10 (f11 f14 ?v0) ?v1) f43))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f26 (f27 f44 ?v0) ?v1) f45) (or (= ?v0 f45) (= ?v1 f45)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f37 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f10 (f11 f14 ?v0) ?v1) f43) (or (= ?v0 f43) (= ?v1 f43)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v0))) (= (f10 (f11 f14 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f14 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f44 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f37 ?v0))) (= (f3 (f4 f37 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f37 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (= (= (f3 f34 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S6)) (= (= f45 ?v0) (= ?v0 f45))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= f43 ?v0) (= ?v0 f43))))
(assert (= (f3 f34 0) 0))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f30 f31 ?v0))) (let ((?v_1 (f24 ?v_0 ?v1))) (= (f24 ?v_0 (f32 f33 (* 2 (f24 f25 ?v1)))) (f3 (f4 f37 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f7 f19 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f32 f33 (* 2 (f24 f25 ?v1)))) (f10 (f11 f14 ?v_1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f26 ?v_0 ?v1))) (= (f26 ?v_0 (f32 f33 (* 2 (f24 f25 ?v1)))) (f26 (f27 f44 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f30 f31 ?v0))) (let ((?v_1 (f24 ?v_0 ?v1))) (= (f24 ?v_0 (f32 f33 (+ (* 2 (f24 f25 ?v1)) 1))) (f3 (f4 f37 ?v0) (f3 (f4 f37 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f7 f19 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f32 f33 (+ (* 2 (f24 f25 ?v1)) 1))) (f10 (f11 f14 ?v0) (f10 (f11 f14 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f26 ?v_0 ?v1))) (= (f26 ?v_0 (f32 f33 (+ (* 2 (f24 f25 ?v1)) 1))) (f26 (f27 f44 ?v0) (f26 (f27 f44 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f24 ?v_0 (f32 f33 (+ (* 2 (f24 f25 ?v1)) 1))) (f3 (f4 f37 ?v0) (f24 (f30 f31 (f24 ?v_0 ?v1)) (f32 f33 2)))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 ?v_0 (f32 f33 (+ (* 2 (f24 f25 ?v1)) 1))) (f10 (f11 f14 ?v0) (f6 (f7 f19 (f6 ?v_0 ?v1)) (f32 f33 2)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f32 f33 (+ (* 2 (f24 f25 ?v1)) 1))) (f26 (f27 f44 ?v0) (f26 (f27 f28 (f26 ?v_0 ?v1)) (f32 f33 2)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f43)) (=> (= (f10 (f11 f14 ?v1) ?v0) ?v2) (= ?v1 (f10 (f11 f12 ?v2) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f43)) (=> (= ?v1 (f10 (f11 f14 ?v2) ?v0)) (= (f10 (f11 f12 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (not (= ?v0 f43)) (=> (not (= ?v1 f43)) (= (= (f10 (f11 f12 ?v2) ?v0) (f10 (f11 f12 ?v3) ?v1)) (= (f10 (f11 f14 ?v2) ?v1) (f10 (f11 f14 ?v3) ?v0)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v0))) (=> (not (= ?v0 f43)) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) (f10 (f11 f12 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f43)) (= (f10 (f11 f12 (f10 (f11 f14 ?v1) ?v0)) (f10 (f11 f14 ?v2) ?v0)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f43)) (= (= (f10 (f11 f12 ?v1) ?v0) ?v2) (= ?v1 (f10 (f11 f14 ?v2) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f43)) (= (= ?v1 (f10 (f11 f12 ?v2) ?v0)) (= (f10 (f11 f14 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f10 (f11 f12 ?v0) ?v1) ?v2) (ite (not (= ?v1 f43)) (= ?v0 (f10 (f11 f14 ?v2) ?v1)) (= ?v2 f43)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= ?v0 (f10 (f11 f12 ?v1) ?v2)) (ite (not (= ?v2 f43)) (= (f10 (f11 f14 ?v0) ?v2) ?v1) (= ?v0 f43)))))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 f29) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 f23) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 f29) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 f23) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 ?v0) f29) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 ?v0) f23) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 ?v0) f29) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 ?v0) f23) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f18 ?v0) f43) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f18 ?v0) ?v0) f43)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (= (f10 (f11 f18 ?v0) ?v1) f43))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f10 (f11 f18 ?v0) ?v1) f43) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f43)) (= (f10 (f11 f18 ?v1) (f10 (f11 f12 ?v2) ?v0)) (f10 (f11 f12 (f10 (f11 f18 (f10 (f11 f14 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f43)) (= (f10 (f11 f18 (f10 (f11 f12 ?v1) ?v0)) ?v2) (f10 (f11 f12 (f10 (f11 f18 ?v1) (f10 (f11 f14 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (not (= ?v0 f43)) (=> (not (= ?v1 f43)) (= (f10 (f11 f18 (f10 (f11 f12 ?v2) ?v0)) (f10 (f11 f12 ?v3) ?v1)) (f10 (f11 f12 (f10 (f11 f18 (f10 (f11 f14 ?v2) ?v1)) (f10 (f11 f14 ?v3) ?v0))) (f10 (f11 f14 ?v0) ?v1)))))))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 f29) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 f23) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 ?v0) f29) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 ?v0) f23) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v0))) (= (f10 ?v_0 (f10 (f11 f18 ?v1) ?v2)) (f10 (f11 f18 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v0))) (= (f10 ?v_0 (f10 (f11 f18 ?v1) ?v2)) (f10 (f11 f18 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f10 (f11 f14 (f10 (f11 f18 ?v0) ?v1)) ?v2) (f10 (f11 f18 (f10 (f11 f14 ?v0) ?v2)) (f10 (f11 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f10 (f11 f14 (f10 (f11 f18 ?v0) ?v1)) ?v2) (f10 (f11 f18 (f10 (f11 f14 ?v0) ?v2)) (f10 (f11 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f37 ?v0) ?v0) (f24 (f30 f31 ?v0) (f32 f33 2)))))
(assert (forall ((?v0 S5)) (= (f10 (f11 f14 ?v0) ?v0) (f6 (f7 f19 ?v0) (f32 f33 2)))))
(assert (forall ((?v0 S6)) (= (f26 (f27 f44 ?v0) ?v0) (f26 (f27 f28 ?v0) (f32 f33 2)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f24 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1))) (f3 (f4 f37 ?v0) (f24 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1))) (f10 (f11 f14 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1))) (f26 (f27 f44 ?v0) (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f24 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1))) (f3 (f4 f37 ?v0) (f24 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1))) (f10 (f11 f14 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1))) (f26 (f27 f44 ?v0) (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f24 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1))) (f3 (f4 f37 (f24 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1))) (f10 (f11 f14 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1))) (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f24 (f30 f31 ?v0) (f32 f33 2)) (f3 (f4 f37 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f19 ?v0) (f32 f33 2)) (f10 (f11 f14 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (= (f26 (f27 f28 ?v0) (f32 f33 2)) (f26 (f27 f44 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f24 (f30 f31 ?v0) (f32 f33 3)) (f3 (f4 f37 (f3 (f4 f37 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f19 ?v0) (f32 f33 3)) (f10 (f11 f14 (f10 (f11 f14 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S6)) (= (f26 (f27 f28 ?v0) (f32 f33 3)) (f26 (f27 f44 (f26 (f27 f44 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f3 (f4 f37 ?v0) (f24 ?v_0 ?v1)) (f24 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f10 (f11 f14 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f44 ?v0) (f26 ?v_0 ?v1)) (f26 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f24 ?v_0 (f32 f33 (+ (f24 f25 ?v1) (f24 f25 ?v2)))) (f3 (f4 f37 (f24 ?v_0 ?v1)) (f24 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S6) (?v2 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 ?v_0 (f32 f33 (+ (f24 f25 ?v1) (f24 f25 ?v2)))) (f10 (f11 f14 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f32 f33 (+ (f24 f25 ?v1) (f24 f25 ?v2)))) (f26 (f27 f44 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f3 (f4 f37 (f24 ?v_0 ?v1)) ?v0) (f24 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f10 (f11 f14 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v0) (f26 ?v_0 (f32 f33 (+ (f24 f25 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 (f30 f31 ?v0) ?v1))) (= (f3 (f4 f37 ?v_0) ?v0) (f3 (f4 f37 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f6 (f7 f19 ?v0) ?v1))) (= (f10 (f11 f14 ?v_0) ?v0) (f10 (f11 f14 ?v0) ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f26 (f27 f28 ?v0) ?v1))) (= (f26 (f27 f44 ?v_0) ?v0) (f26 (f27 f44 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f24 (f30 f31 (f3 (f4 f37 ?v0) ?v1)) ?v2) (f3 (f4 f37 (f24 (f30 f31 ?v0) ?v2)) (f24 (f30 f31 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S6)) (= (f6 (f7 f19 (f10 (f11 f14 ?v0) ?v1)) ?v2) (f10 (f11 f14 (f6 (f7 f19 ?v0) ?v2)) (f6 (f7 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f26 (f27 f28 (f26 (f27 f44 ?v0) ?v1)) ?v2) (f26 (f27 f44 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f24 (f30 f31 (f3 (f4 f37 ?v0) ?v1)) ?v2) (f3 (f4 f37 (f24 (f30 f31 ?v0) ?v2)) (f24 (f30 f31 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S6)) (= (f6 (f7 f19 (f10 (f11 f14 ?v0) ?v1)) ?v2) (f10 (f11 f14 (f6 (f7 f19 ?v0) ?v2)) (f6 (f7 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f26 (f27 f28 (f26 (f27 f44 ?v0) ?v1)) ?v2) (f26 (f27 f44 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f3 (f4 f37 (f24 ?v_0 ?v1)) (f24 ?v_0 ?v2)) (f24 ?v_0 (f32 f33 (+ (f24 f25 ?v1) (f24 f25 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S6) (?v2 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f10 (f11 f14 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f32 f33 (+ (f24 f25 ?v1) (f24 f25 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2)) (f26 ?v_0 (f32 f33 (+ (f24 f25 ?v1) (f24 f25 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v0))) (= (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2)) (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f10 (f11 f14 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 ?v2) ?v3)) (f10 (f11 f12 (f10 (f11 f14 ?v0) ?v2)) (f10 (f11 f14 ?v1) ?v3)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f24 ?v_0 (f32 f33 (f3 (f4 f37 (f24 f25 ?v1)) (f24 f25 ?v2)))) (f24 (f30 f31 (f24 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S6) (?v2 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 ?v_0 (f32 f33 (f3 (f4 f37 (f24 f25 ?v1)) (f24 f25 ?v2)))) (f6 (f7 f19 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f32 f33 (f3 (f4 f37 (f24 f25 ?v1)) (f24 f25 ?v2)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f24 ?v_0 (f32 f33 (* 2 (f24 f25 ?v1)))) (f24 (f30 f31 (f24 ?v_0 ?v1)) (f32 f33 2))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 ?v_0 (f32 f33 (* 2 (f24 f25 ?v1)))) (f6 (f7 f19 (f6 ?v_0 ?v1)) (f32 f33 2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f32 f33 (* 2 (f24 f25 ?v1)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) (f32 f33 2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f30 f31 ?v0))) (= (f24 (f30 f31 (f24 ?v_0 ?v1)) ?v2) (f24 ?v_0 (f32 f33 (f3 (f4 f37 (f24 f25 ?v1)) (f24 f25 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S6) (?v2 S6)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 (f7 f19 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f32 f33 (f3 (f4 f37 (f24 f25 ?v1)) (f24 f25 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f32 f33 (f3 (f4 f37 (f24 f25 ?v1)) (f24 f25 ?v2))))))))
(assert (not (= f29 f45)))
(assert (not (= f23 f43)))
(assert (not (= 1 0)))
(assert (not (= f45 f29)))
(assert (not (= f43 f23)))
(assert (not (= 0 1)))
(assert (forall ((?v0 S6)) (= (f26 (f27 f28 f45) (f32 f33 (+ (f24 f25 ?v0) 1))) f45)))
(assert (forall ((?v0 S6)) (= (f24 (f30 f31 0) (f32 f33 (+ (f24 f25 ?v0) 1))) 0)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f19 f43) (f32 f33 (+ (f24 f25 ?v0) 1))) f43)))
(assert (= (f26 (f27 f28 f45) (f32 f33 2)) f45))
(assert (= (f24 (f30 f31 0) (f32 f33 2)) 0))
(assert (= (f6 (f7 f19 f43) (f32 f33 2)) f43))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f26 (f27 f28 ?v0) ?v1) f45) (and (= ?v0 f45) (not (= ?v1 (f32 f33 0)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (= (f24 (f30 f31 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f32 f33 0)))))))
(assert (forall ((?v0 S5) (?v1 S6)) (= (= (f6 (f7 f19 ?v0) ?v1) f43) (and (= ?v0 f43) (not (= ?v1 (f32 f33 0)))))))
(assert (forall ((?v0 Int)) (= (= (f24 (f30 f31 ?v0) (f32 f33 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f19 ?v0) (f32 f33 2)) f43) (= ?v0 f43))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (not (= ?v0 0)) (not (= (f24 (f30 f31 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S6)) (=> (not (= ?v0 f43)) (not (= (f6 (f7 f19 ?v0) ?v1) f43)))))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 f43) ?v0) f43)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 f43) ?v0) f43)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) f43) f43)))
(assert (forall ((?v0 S6)) (not (= (f6 f20 ?v0) f43))))
(assert (forall ((?v0 S6)) (= (f26 (f27 f28 f45) ?v0) (ite (= ?v0 (f32 f33 0)) f29 f45))))
(assert (forall ((?v0 S6)) (= (f6 (f7 f19 f43) ?v0) (ite (= ?v0 (f32 f33 0)) f23 f43))))
(assert (forall ((?v0 S6)) (= (f24 (f30 f31 0) ?v0) (ite (= ?v0 (f32 f33 0)) 1 0))))
(assert (forall ((?v0 S6)) (= (f32 f33 (f24 f25 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f24 f25 (f32 f33 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f24 f25 (f32 f33 ?v0)) 0))))
(check-sat)
(exit)
