(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S2) S2)
(declare-fun f5 () S5)
(declare-fun f6 (S6 Int) S3)
(declare-fun f7 () S6)
(declare-fun f8 (S7 S3) Int)
(declare-fun f9 () S7)
(declare-fun f10 (S8 S7) S7)
(declare-fun f11 () S8)
(declare-fun f12 () S8)
(declare-fun f13 (S9 Int) Int)
(declare-fun f14 () S9)
(declare-fun f15 (S10 S4) S2)
(declare-fun f16 (S11 S2) S10)
(declare-fun f17 () S11)
(declare-fun f18 (S12 S4) S4)
(declare-fun f19 (S13 S4) S12)
(declare-fun f20 () S13)
(declare-fun f21 (S14 S3) S2)
(declare-fun f22 (S15 S2) S14)
(declare-fun f23 () S15)
(declare-fun f24 (S16 S3) S7)
(declare-fun f25 (S17 S7) S16)
(declare-fun f26 () S17)
(declare-fun f27 (S18 S19) S4)
(declare-fun f28 (S20 S2) S18)
(declare-fun f29 () S20)
(declare-fun f30 () S10)
(declare-fun f31 () S4)
(declare-fun f32 () S2)
(declare-fun f33 () S3)
(declare-fun f34 () S3)
(declare-fun f35 (S21 S3) S19)
(declare-fun f36 (S3) S21)
(declare-fun f37 () S4)
(declare-fun f38 (S22 S19) Int)
(declare-fun f39 (S23 S7) S22)
(declare-fun f40 () S23)
(declare-fun f41 (S24 Int) S7)
(declare-fun f42 () S24)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f3 (f4 f5 ?v0) ?v1) (f3 ?v0 (f6 f7 (+ (f8 f9 ?v1) 1))))))
(assert (forall ((?v0 S7) (?v1 S3)) (= (f8 (f10 f11 ?v0) ?v1) (f8 ?v0 (f6 f7 (+ (f8 f9 ?v1) 1))))))
(assert (forall ((?v0 S7) (?v1 S3)) (= (f8 (f10 f12 ?v0) ?v1) (f13 f14 (f8 ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S3)) (= (f3 (f15 (f16 f17 ?v0) ?v1) ?v2) (f18 (f19 f20 (f3 ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (= (f3 (f21 (f22 f23 ?v0) ?v1) ?v2) (f3 ?v0 (f6 f7 (+ (f8 f9 ?v2) (f8 f9 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S3)) (= (f8 (f24 (f25 f26 ?v0) ?v1) ?v2) (f8 ?v0 (f6 f7 (+ (f8 f9 ?v2) (f8 f9 ?v1)))))))
(assert (not (= (f27 (f28 f29 (f15 f30 (f3 (f15 f30 (f18 (f19 f20 f31) (f3 f32 f33))) f34))) (f35 (f36 (f6 f7 0)) f33)) f37)))
(assert (< 0 (f8 f9 f34)))
(assert (< (f8 f9 f34) (f8 f9 f33)))
(assert (forall ((?v0 S3)) (not (= (f3 f32 ?v0) f37))))
(assert (forall ((?v0 S3)) (= (f3 (f15 f30 (f3 f32 ?v0)) ?v0) f31)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f8 f9 ?v1)) (= (f27 (f28 f29 (f15 f30 (f3 (f15 f30 (f3 f32 ?v1)) ?v0))) (f35 (f36 (f6 f7 0)) ?v1)) f37))))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_1 (f6 f7 0)) (?v_0 (f39 f40 ?v0))) (=> (= (f8 ?v0 ?v_1) 0) (= (f38 ?v_0 (f35 (f36 (f6 f7 (+ 0 1))) ?v1)) (f38 ?v_0 (f35 (f36 ?v_1) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_1 (f6 f7 0)) (?v_0 (f28 f29 ?v0))) (=> (= (f3 ?v0 ?v_1) f37) (= (f27 ?v_0 (f35 (f36 (f6 f7 (+ 0 1))) ?v1)) (f27 ?v_0 (f35 (f36 ?v_1) ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f19 f20 f31))) (= (f18 ?v_0 (f3 (f15 f30 ?v0) ?v1)) (f3 (f15 f30 (f18 ?v_0 ?v0)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S3)) (=> (not (= ?v0 f37)) (= (f3 (f15 f30 (f18 (f19 f20 ?v1) ?v0)) ?v2) (f18 (f19 f20 (f3 (f15 f30 ?v1) ?v2)) (f3 (f15 f30 ?v0) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1)) (?v_2 (f15 f30 ?v0))) (=> (not (= ?v0 f37)) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1))) (f18 (f19 f20 (f3 ?v_2 ?v2)) (f3 ?v_2 ?v1))))))))
(assert (forall ((?v0 S4)) (= (f18 (f19 f20 ?v0) ?v0) (ite (= ?v0 f37) f37 f31))))
(assert (forall ((?v0 S4)) (=> (not (= ?v0 f37)) (= (f18 (f19 f20 ?v0) ?v0) f31))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f37)) (= (= (f18 (f19 f20 ?v1) ?v0) f31) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3)) (= (f3 (f15 f30 f37) ?v0) (ite (= ?v0 (f6 f7 0)) f31 f37))))
(assert (forall ((?v0 S3)) (= (f8 (f41 f42 0) ?v0) (ite (= ?v0 (f6 f7 0)) 1 0))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S3)) (= (f38 (f39 f40 ?v0) (f35 (f36 (f6 f7 (+ (f8 f9 ?v1) 1))) (f6 f7 (+ (f8 f9 ?v2) 1)))) (f38 (f39 f40 (f10 f11 ?v0)) (f35 (f36 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (= (f27 (f28 f29 ?v0) (f35 (f36 (f6 f7 (+ (f8 f9 ?v1) 1))) (f6 f7 (+ (f8 f9 ?v2) 1)))) (f27 (f28 f29 (f4 f5 ?v0)) (f35 (f36 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f8 f9 ?v2))) (= (f38 (f39 f40 ?v0) (f35 (f36 (f6 f7 (+ (f8 f9 ?v1) ?v_0))) (f6 f7 (+ (f8 f9 ?v3) ?v_0)))) (f38 (f39 f40 (f24 (f25 f26 ?v0) ?v2)) (f35 (f36 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f8 f9 ?v2))) (= (f27 (f28 f29 ?v0) (f35 (f36 (f6 f7 (+ (f8 f9 ?v1) ?v_0))) (f6 f7 (+ (f8 f9 ?v3) ?v_0)))) (f27 (f28 f29 (f21 (f22 f23 ?v0) ?v2)) (f35 (f36 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S19) (?v2 S4)) (= (f18 (f19 f20 (f27 (f28 f29 ?v0) ?v1)) ?v2) (f27 (f28 f29 (f15 (f16 f17 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S19) (?v2 S4)) (= (f18 (f19 f20 (f27 (f28 f29 ?v0) ?v1)) ?v2) (f27 (f28 f29 (f15 (f16 f17 ?v0) ?v2)) ?v1))))
(assert (= (f13 f14 1) 1))
(assert (forall ((?v0 Int)) (= (f8 (f41 f42 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f15 f30 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f13 f14 (f8 (f41 f42 ?v0) ?v1)) (f8 (f41 f42 (f13 f14 ?v0)) ?v1))))
(assert (forall ((?v0 S7) (?v1 S19)) (let ((?v_0 (f38 (f39 f40 (f10 f12 ?v0)) ?v1))) (= (f13 f14 ?v_0) ?v_0))))
(assert (not (= f37 f31)))
(assert (not (= 0 1)))
(assert (not (= f31 f37)))
(assert (not (= 1 0)))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (not (= ?v0 0)) (not (= (f8 (f41 f42 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (not (= ?v0 f37)) (not (= (f3 (f15 f30 ?v0) ?v1) f37)))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f8 (f41 f42 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (= (= (f3 (f15 f30 ?v0) ?v1) f37) (and (= ?v0 f37) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S3)) (= (f8 (f41 f42 0) (f6 f7 (+ (f8 f9 ?v0) 1))) 0)))
(assert (forall ((?v0 S3)) (= (f3 (f15 f30 f37) (f6 f7 (+ (f8 f9 ?v0) 1))) f37)))
(assert (forall ((?v0 S4)) (= (f18 (f19 f20 ?v0) f37) f37)))
(assert (forall ((?v0 S4)) (= (f18 (f19 f20 f37) ?v0) f37)))
(assert (forall ((?v0 S4)) (= (f18 (f19 f20 f37) ?v0) f37)))
(assert (forall ((?v0 S4)) (= (f3 (f15 f30 ?v0) (f6 f7 0)) f31)))
(assert (forall ((?v0 Int)) (= (f8 (f41 f42 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S3)) (= (f3 (f15 f30 f31) ?v0) f31)))
(assert (forall ((?v0 S3)) (= (f8 (f41 f42 1) ?v0) 1)))
(assert (forall ((?v0 S3)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
