(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 Int) S2)
(declare-fun f4 () S3)
(declare-fun f5 (S4 Int) Int)
(declare-fun f6 (S5 Int) S4)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 (S7 S2) S7)
(declare-fun f11 (S2) S7)
(declare-fun f12 () S2)
(declare-fun f13 () S2)
(declare-fun f14 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 (f8 f9 ?v0))) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f3 f4 (f5 ?v_0 (+ ?v_1 ?v_2))) (f3 f4 (+ (f5 ?v_0 ?v_1) (f5 ?v_0 ?v_2)))))))
(assert (let ((?v_0 (f11 (f3 f4 (* 2 (f8 f9 f12))))) (?v_1 (f6 f7 (f8 f9 f13))) (?v_2 (f8 f9 f14))) (not (= (f10 ?v_0 (f3 f4 (f5 ?v_1 (* 2 ?v_2)))) (f10 ?v_0 (f3 f4 (* 2 (f5 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2)) (= (f3 f4 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f3 f4 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f3 f4 ?v0)) 0))))
(check-sat)
(exit)
