(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 () S3)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 () S3)
(declare-fun f11 (S7 S3) S3)
(declare-fun f12 (S8 S2) S7)
(declare-fun f13 () S8)
(declare-fun f14 () S2)
(declare-fun f15 () S2)
(declare-fun f16 (S9 S4) S4)
(declare-fun f17 (S10 S4) S9)
(declare-fun f18 () S10)
(declare-fun f19 () S10)
(declare-fun f20 (S11 S4) S3)
(declare-fun f21 () S11)
(declare-fun f22 () S3)
(declare-fun f23 (S12 Int) Int)
(declare-fun f24 (S13 Int) S12)
(declare-fun f25 () S13)
(declare-fun f26 (S14 S2) S2)
(declare-fun f27 (S15 S2) S14)
(declare-fun f28 () S15)
(declare-fun f29 () S15)
(declare-fun f30 (S16 Int) S6)
(declare-fun f31 () S16)
(declare-fun f32 () S12)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f3 f5 (f6 f7 (+ (* 2 (f8 f9 ?v0)) 1))))))
(assert (forall ((?v0 S2)) (= (f3 f10 ?v0) (f3 f5 (f6 f7 (* 2 (f8 f9 ?v0)))))))
(assert (let ((?v_0 (f6 f7 (* 2 (f8 f9 f14)))) (?v_1 (f12 f13 f14))) (not (= (f3 (f11 (f12 f13 ?v_0) f5) f15) (f16 (f17 f18 (f3 (f11 ?v_1 f10) f15)) (f16 (f17 f19 (f3 (f20 f21 (f3 f22 ?v_0)) f15)) (f3 (f11 ?v_1 f4) f15)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f24 f25 (f8 f9 ?v1))) (?v_1 (f8 f9 ?v2))) (= (f3 (f20 f21 (f3 f22 (f6 f7 (* 2 (f8 f9 ?v0))))) (f6 f7 (f23 ?v_0 (* 2 ?v_1)))) (f3 (f20 f21 (f3 f22 ?v0)) (f6 f7 (f23 ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (let ((?v_1 (f24 f25 ?v_0))) (=> (< 0 ?v_0) (= (f3 (f20 f21 (f3 f22 (f6 f7 (f23 ?v_1 (f8 f9 ?v1))))) (f6 f7 (f23 ?v_1 (f8 f9 ?v2)))) (f3 (f20 f21 (f3 f22 ?v1)) ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f26 (f27 f29 ?v0) (f26 (f27 f28 (f26 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f16 (f17 f19 ?v0) (f3 (f20 f21 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f30 f31 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f23 (f24 f25 ?v0) (f8 (f30 f31 (f8 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f26 ?v_0 ?v1))) (= (f26 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f26 (f27 f29 ?v0) (f26 (f27 f29 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f16 (f17 f19 ?v0) (f16 (f17 f19 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f30 f31 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f23 (f24 f25 ?v0) (f23 (f24 f25 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f26 ?v_0 ?v1))) (= (f26 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f26 (f27 f29 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f16 (f17 f19 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f30 f31 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f23 (f24 f25 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f6 f7 (f23 (f24 f25 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f6 f7 (f23 (f24 f25 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f3 (f20 f21 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f30 f31 ?v0))) (= (f8 ?v_0 (f6 f7 (f23 (f24 f25 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f8 (f30 f31 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f3 (f20 f21 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f30 f31 ?v0))) (= (f8 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f8 (f30 f31 (f8 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f6 f7 (f23 (f24 f25 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 (f20 f21 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f23 (f24 f25 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f30 f31 ?v0))) (= (f8 (f30 f31 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f6 f7 (f23 (f24 f25 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S2)) (= (f26 (f27 f29 ?v0) ?v0) (f26 (f27 f28 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S4)) (= (f16 (f17 f19 ?v0) ?v0) (f3 (f20 f21 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) ?v0) (f8 (f30 f31 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f26 (f27 f29 ?v0) (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f16 (f17 f19 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f30 f31 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f23 (f24 f25 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f26 (f27 f29 ?v0) (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f16 (f17 f19 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f30 f31 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f23 (f24 f25 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f16 (f17 f19 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f30 f31 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f23 (f24 f25 (f8 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2)) (= (f26 (f27 f28 ?v0) (f6 f7 2)) (f26 (f27 f29 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f3 (f20 f21 ?v0) (f6 f7 2)) (f16 (f17 f19 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f8 (f30 f31 ?v0) (f6 f7 2)) (f23 (f24 f25 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f26 (f27 f28 ?v0) (f6 f7 3)) (f26 (f27 f29 (f26 (f27 f29 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S4)) (= (f3 (f20 f21 ?v0) (f6 f7 3)) (f16 (f17 f19 (f16 (f17 f19 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f8 (f30 f31 ?v0) (f6 f7 3)) (f23 (f24 f25 (f23 (f24 f25 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f23 (f24 f25 (f8 f9 ?v0)) (f8 f9 (f26 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f17 f19 ?v0))) (= (f16 (f17 f19 (f16 ?v_0 ?v1)) (f16 (f17 f19 ?v2) ?v3)) (f16 (f17 f19 (f16 ?v_0 ?v2)) (f16 (f17 f19 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 (f24 f25 (f23 ?v_0 ?v1)) (f23 (f24 f25 ?v2) ?v3)) (f23 (f24 f25 (f23 ?v_0 ?v2)) (f23 (f24 f25 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) (f26 (f27 f29 ?v2) ?v3)) (f26 (f27 f29 (f26 ?v_0 ?v2)) (f26 (f27 f29 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f17 f19 (f16 (f17 f19 ?v0) ?v1))) (?v_0 (f17 f19 ?v2))) (= (f16 ?v_1 (f16 ?v_0 ?v3)) (f16 ?v_0 (f16 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f24 f25 (f23 (f24 f25 ?v0) ?v1))) (?v_0 (f24 f25 ?v2))) (= (f23 ?v_1 (f23 ?v_0 ?v3)) (f23 ?v_0 (f23 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f27 f29 (f26 (f27 f29 ?v0) ?v1))) (?v_0 (f27 f29 ?v2))) (= (f26 ?v_1 (f26 ?v_0 ?v3)) (f26 ?v_0 (f26 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f17 f19 ?v0)) (?v_1 (f16 (f17 f19 ?v2) ?v3))) (= (f16 (f17 f19 (f16 ?v_0 ?v1)) ?v_1) (f16 ?v_0 (f16 (f17 f19 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f24 f25 ?v0)) (?v_1 (f23 (f24 f25 ?v2) ?v3))) (= (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v_1) (f23 ?v_0 (f23 (f24 f25 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f27 f29 ?v0)) (?v_1 (f26 (f27 f29 ?v2) ?v3))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v_1) (f26 ?v_0 (f26 (f27 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f19 ?v0))) (= (f16 (f17 f19 (f16 ?v_0 ?v1)) ?v2) (f16 (f17 f19 (f16 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2) (f23 (f24 f25 (f23 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f29 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f19 ?v0))) (= (f16 (f17 f19 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f17 f19 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2) (f23 ?v_0 (f23 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f19 ?v0))) (= (f16 ?v_0 (f16 (f17 f19 ?v1) ?v2)) (f16 (f17 f19 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f23 (f24 f25 ?v1) ?v2)) (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 ?v_0 (f26 (f27 f29 ?v1) ?v2)) (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f17 f19 ?v0)) (?v_0 (f17 f19 ?v1))) (= (f16 ?v_1 (f16 ?v_0 ?v2)) (f16 ?v_0 (f16 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f24 f25 ?v0)) (?v_0 (f24 f25 ?v1))) (= (f23 ?v_1 (f23 ?v_0 ?v2)) (f23 ?v_0 (f23 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f27 f29 ?v0)) (?v_0 (f27 f29 ?v1))) (= (f26 ?v_1 (f26 ?v_0 ?v2)) (f26 ?v_0 (f26 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 (f17 f19 ?v0) ?v1) (f16 (f17 f19 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f23 (f24 f25 ?v0) ?v1) (f23 (f24 f25 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f26 (f27 f29 ?v0) ?v1) (f26 (f27 f29 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) (f16 (f17 f18 ?v2) ?v3)) (f16 (f17 f18 (f16 ?v_0 ?v2)) (f16 (f17 f18 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 (f17 f18 (f16 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f17 f18 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f16 (f17 f18 ?v1) ?v2)) (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f17 f18 ?v0)) (?v_0 (f17 f18 ?v1))) (= (f16 ?v_1 (f16 ?v_0 ?v2)) (f16 ?v_0 (f16 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 (f17 f18 ?v0) ?v1) (f16 (f17 f18 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f30 f31 (f23 f32 ?v0)) ?v_0) (f8 (f30 f31 ?v0) ?v_0)))))
(assert (forall ((?v0 S2)) (= (f26 (f27 f28 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f20 f21 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 (f30 f31 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f26 (f27 f28 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f20 f21 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 (f30 f31 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
