(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 () S3)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S2) Int)
(declare-fun f8 () S5)
(declare-fun f9 () S3)
(declare-fun f10 () S3)
(declare-fun f11 (S6 S2) S3)
(declare-fun f12 () S6)
(declare-fun f13 (S7 S2) S1)
(declare-fun f14 (S8 S7) S7)
(declare-fun f15 (S9 S7) S8)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S2) S7)
(declare-fun f18 (S11 S2) S10)
(declare-fun f19 () S11)
(declare-fun f20 () S2)
(declare-fun f21 () S9)
(declare-fun f22 (S12 S3) S8)
(declare-fun f23 () S12)
(declare-fun f24 (S13 S7) S1)
(declare-fun f25 (S14 S2) S13)
(declare-fun f26 () S14)
(declare-fun f27 (S15 S1) S1)
(declare-fun f28 (S16 S1) S15)
(declare-fun f29 () S16)
(declare-fun f30 () S8)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 f6 (+ (* 2 (f7 f8 ?v0)) 1)))))
(assert (forall ((?v0 S2)) (= (f3 f9 ?v0) (f5 f6 (* 2 (f7 f8 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 f10 ?v0) (f5 f6 (+ (f7 f8 ?v0) 1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f11 f12 ?v0) ?v1) (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S2)) (= (= (f13 (f14 (f15 f16 ?v0) ?v1) ?v2) f1) (or (= (f13 ?v0 ?v2) f1) (= (f13 ?v1 ?v2) f1)))))
(assert (let ((?v_0 (f18 f19 (f5 f6 0)))) (let ((?v_1 (f17 ?v_0 f20))) (not (= (f17 ?v_0 (f5 f6 (* 2 (f7 f8 f20)))) (f14 (f15 f21 (f14 (f22 f23 f9) ?v_1)) (f14 (f22 f23 f4) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (f14 (f22 f23 (f11 f12 ?v0)) (f17 (f18 f19 ?v1) ?v2)) (f17 (f18 f19 (f5 f6 (+ (f7 f8 ?v1) ?v_0))) (f5 f6 (+ (f7 f8 ?v2) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S7) (?v2 S7)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f24 ?v_0 (f14 (f15 f21 ?v1) ?v2)) f1) (=> (=> (= (f24 ?v_0 ?v1) f1) false) (=> (=> (= (f24 ?v_0 ?v2) f1) false) false))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S2)) (=> (= (f13 (f14 (f15 f21 ?v0) ?v1) ?v2) f1) (=> (=> (= (f13 ?v0 ?v2) f1) false) (=> (=> (= (f13 ?v1 ?v2) f1) false) false)))))
(assert (forall ((?v0 S7) (?v1 S2) (?v2 S7)) (=> (=> (not (= (f13 ?v0 ?v1) f1)) (= (f13 ?v2 ?v1) f1)) (= (f13 (f14 (f15 f21 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S7) (?v2 S7)) (let ((?v_0 (f25 f26 ?v0))) (=> (=> (not (= (f24 ?v_0 ?v1) f1)) (= (f24 ?v_0 ?v2) f1)) (= (f24 ?v_0 (f14 (f15 f21 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2) (?v3 S7)) (=> (= ?v0 (f3 ?v1 ?v2)) (=> (= (f24 (f25 f26 ?v2) ?v3) f1) (= (f24 (f25 f26 ?v0) (f14 (f22 f23 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f14 (f22 f23 f10) (f17 (f18 f19 ?v0) ?v1)) (f17 (f18 f19 (f5 f6 (+ (f7 f8 ?v0) 1))) (f5 f6 (+ (f7 f8 ?v1) 1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f18 f19 ?v0))) (let ((?v_2 (f5 f6 (+ ?v_0 (f7 f8 ?v2))))) (=> (<= (f7 f8 ?v0) ?v_0) (= (f17 ?v_1 ?v_2) (f14 (f15 f21 (f17 ?v_1 ?v1)) (f17 (f18 f19 ?v1) ?v_2))))))))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S7)) (let ((?v_0 (f22 f23 ?v0))) (= (f14 ?v_0 (f14 (f15 f21 ?v1) ?v2)) (f14 (f15 f21 (f14 ?v_0 ?v1)) (f14 ?v_0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S2)) (= (= (f13 (f14 (f15 f21 ?v0) ?v1) ?v2) f1) (= (f27 (f28 f29 (f13 ?v0 ?v2)) (f13 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S2)) (= (= (f13 (f14 (f15 f21 ?v0) ?v1) ?v2) f1) (= (f27 (f28 f29 (f13 ?v0 ?v2)) (f13 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f14 f30 (f14 (f15 f16 ?v0) ?v1)) (f14 (f15 f21 (f14 f30 ?v0)) (f14 f30 ?v1)))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f28 f29 ?v0))) (= (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2) f1) (= (f27 ?v_0 (f27 (f28 f29 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f15 f21 ?v0))) (= (f14 (f15 f21 (f14 ?v_0 ?v1)) ?v2) (f14 ?v_0 (f14 (f15 f21 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f28 f29 ?v0))) (= (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2) f1) (= (f27 ?v_0 (f27 (f28 f29 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f15 f21 ?v0))) (= (f14 (f15 f21 (f14 ?v_0 ?v1)) ?v2) (f14 ?v_0 (f14 (f15 f21 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f28 f29 ?v0))) (= (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2) f1) (= (f27 ?v_0 (f27 (f28 f29 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f15 f21 ?v0))) (= (f14 (f15 f21 (f14 ?v_0 ?v1)) ?v2) (f14 ?v_0 (f14 (f15 f21 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f28 f29 ?v0)) (?v_0 (f28 f29 ?v1))) (= (= (f27 ?v_1 (f27 ?v_0 ?v2)) f1) (= (f27 ?v_0 (f27 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f15 f21 ?v0)) (?v_0 (f15 f21 ?v1))) (= (f14 ?v_1 (f14 ?v_0 ?v2)) (f14 ?v_0 (f14 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f28 f29 ?v0)) (?v_0 (f28 f29 ?v1))) (= (= (f27 ?v_1 (f27 ?v_0 ?v2)) f1) (= (f27 ?v_0 (f27 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f15 f21 ?v0)) (?v_0 (f15 f21 ?v1))) (= (f14 ?v_1 (f14 ?v_0 ?v2)) (f14 ?v_0 (f14 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f28 f29 ?v0)) (?v_0 (f28 f29 ?v1))) (= (= (f27 ?v_1 (f27 ?v_0 ?v2)) f1) (= (f27 ?v_0 (f27 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f15 f21 ?v0)) (?v_0 (f15 f21 ?v1))) (= (f14 ?v_1 (f14 ?v_0 ?v2)) (f14 ?v_0 (f14 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f28 f29 ?v0))) (let ((?v_1 (f27 ?v_0 ?v1))) (= (= (f27 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f15 f21 ?v0))) (let ((?v_1 (f14 ?v_0 ?v1))) (= (f14 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f28 f29 ?v0))) (let ((?v_1 (f27 ?v_0 ?v1))) (= (= (f27 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f15 f21 ?v0))) (let ((?v_1 (f14 ?v_0 ?v1))) (= (f14 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f28 f29 ?v0))) (let ((?v_1 (f27 ?v_0 ?v1))) (= (= (f27 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f15 f21 ?v0))) (let ((?v_1 (f14 ?v_0 ?v1))) (= (f14 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f27 (f28 f29 ?v0) ?v1) f1) (= (f27 (f28 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f14 (f15 f21 ?v0) ?v1) (f14 (f15 f21 ?v1) ?v0))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f27 (f28 f29 ?v0) ?v1) f1) (= (f27 (f28 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f14 (f15 f21 ?v0) ?v1) (f14 (f15 f21 ?v1) ?v0))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f27 (f28 f29 ?v0) ?v1) f1) (= (f27 (f28 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f14 (f15 f21 ?v0) ?v1) (f14 (f15 f21 ?v1) ?v0))))
(assert (forall ((?v0 S1)) (= (= (f27 (f28 f29 ?v0) ?v0) f1) (= ?v0 f1))))
(assert (forall ((?v0 S7)) (= (f14 (f15 f21 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 f6 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
