(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 (S4 S5) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) S3)
(declare-fun f9 () S6)
(declare-fun f10 () S3)
(declare-fun f11 () S5)
(declare-fun f12 (S7 S5) S5)
(declare-fun f13 (S7) S7)
(declare-fun f14 (S5 S7) S7)
(declare-fun f15 () S5)
(declare-fun f16 () S7)
(assert (not (= f1 f2)))
(assert (<= 2 (f3 f4 (f5 f6 f7))))
(assert (let ((?v_1 (f5 f6 f7)) (?v_0 (f3 f4 f10))) (let ((?v_4 (+ ?v_0 1)) (?v_3 (f5 f6 (f12 (f13 (f14 f15 f16)) f15))) (?v_2 (f5 f6 f15))) (not (=> (not (= ?v_1 (f8 f9 ?v_4))) (=> (= (f8 f9 (+ (+ (f3 f4 (f5 f6 f11)) ?v_0) 1)) ?v_3) (=> (= ?v_2 ?v_1) (=> (= ?v_2 ?v_3) (< ?v_4 (f3 f4 ?v_1))))))))))
(assert (forall ((?v0 S3)) (= (f8 f9 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f8 f9 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f8 f9 ?v0)) 0))))
(check-sat)
(exit)
