(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S5)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 () S6)
(declare-fun f10 () S5)
(declare-fun f11 () S6)
(declare-fun f12 (S7 S8) S5)
(declare-fun f13 (S9 S5) S7)
(declare-fun f14 () S9)
(declare-fun f15 () S5)
(declare-fun f16 () S8)
(declare-fun f17 () S5)
(declare-fun f18 () S5)
(declare-fun f19 (S10 Int) S8)
(declare-fun f20 () S10)
(declare-fun f21 (S11 S8) Int)
(declare-fun f22 (S12 Int) S11)
(declare-fun f23 () S12)
(declare-fun f24 () S3)
(declare-fun f25 (S13 S8) S8)
(declare-fun f26 (S14 S8) S13)
(declare-fun f27 () S14)
(declare-fun f28 () S8)
(declare-fun f29 () S14)
(declare-fun f30 () S11)
(declare-fun f31 () S8)
(declare-fun f32 () S14)
(declare-fun f33 () S2)
(declare-fun f34 (S15 S14) S14)
(declare-fun f35 (S16 S8) S15)
(declare-fun f36 () S16)
(declare-fun f37 (S17 S6) S9)
(declare-fun f38 (S18 S5) S17)
(declare-fun f39 () S18)
(declare-fun f40 (S19 S3) S12)
(declare-fun f41 (S20 Int) S19)
(declare-fun f42 () S20)
(declare-fun f43 () S3)
(declare-fun f44 () S3)
(declare-fun f45 () S4)
(declare-fun f46 (S8 S8) S1)
(declare-fun f47 (S8 S8) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 (f6 (f7 f9 f10) (f6 (f7 f11 (f12 (f13 f14 f15) f16)) f17))) f10) (f6 (f7 f8 f18) f10))))
(assert (= (f6 (f7 f9 f10) (f6 (f7 f11 (f12 (f13 f14 f15) f16)) f17)) f18))
(assert (not (= f16 (f19 f20 0))))
(assert (not (= f17 f18)))
(assert (not (= f15 f18)))
(assert (= (f6 (f7 f9 f10) (f6 (f7 f11 (f12 (f13 f14 f15) f16)) f17)) f18))
(assert (=> (forall ((?v0 S5)) (=> (= (f6 (f7 f9 f10) (f6 (f7 f11 (f12 (f13 f14 ?v0) f16)) f17)) f18) false)) false))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f19 f20 (+ (+ 0 1) 1)))) (= (f6 (f7 f8 (f12 (f13 f14 ?v0) ?v_0)) (f12 (f13 f14 ?v1) ?v_0)) (f6 (f7 f11 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f9 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 (+ (+ 0 1) 1)))) (= (- (f21 (f22 f23 ?v0) ?v_0) (f21 (f22 f23 ?v1) ?v_0)) (f3 (f4 f24 (- ?v0 ?v1)) (+ ?v0 ?v1))))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 (f6 (f7 f11 ?v0) ?v0)) f10) (f6 (f7 f11 (f6 (f7 f9 ?v0) f10)) (f6 (f7 f8 ?v0) f10)))))
(assert (forall ((?v0 Int)) (= (- (f3 (f4 f24 ?v0) ?v0) 1) (f3 (f4 f24 (+ ?v0 1)) (- ?v0 1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) f28 (f25 (f26 f29 ?v0) (f25 ?v_0 (f19 f20 (- (f21 f30 ?v1) 1)))))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) f10 (f6 (f7 f11 ?v0) (f12 ?v_0 (f19 f20 (- (f21 f30 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) 1 (f3 (f4 f24 ?v0) (f21 ?v_0 (f19 f20 (- (f21 f30 ?v1) 1)))))))))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 f31) ?v0) (ite (= ?v0 (f19 f20 0)) f28 f31))))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f18) ?v0) (ite (= ?v0 (f19 f20 0)) f10 f18))))
(assert (forall ((?v0 S8)) (= (f21 (f22 f23 0) ?v0) (ite (= ?v0 (f19 f20 0)) 1 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (= (+ (f21 (f22 f23 ?v0) ?v_0) (f21 (f22 f23 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 (f7 f11 ?v2) ?v3)) (f6 (f7 f9 (f6 ?v_0 (f6 (f7 f8 ?v1) ?v3))) (f6 (f7 f11 (f6 (f7 f8 ?v0) ?v2)) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f24 ?v0))) (= (- (f3 ?v_0 ?v1) (f3 (f4 f24 ?v2) ?v3)) (+ (f3 ?v_0 (- ?v1 ?v3)) (f3 (f4 f24 (- ?v0 ?v2)) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f7 f11 ?v2)) (?v_0 (f7 f11 (f6 (f7 f8 ?v0) ?v2))) (?v_2 (f6 (f7 f8 ?v1) ?v3))) (= (f6 (f7 f8 (f6 (f7 f11 ?v0) ?v1)) (f6 ?v_1 ?v3)) (f6 (f7 f9 (f6 (f7 f9 (f6 ?v_0 ?v_2)) (f6 ?v_0 ?v3))) (f6 ?v_1 ?v_2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (= (= (f6 (f7 f9 (f6 (f7 f11 ?v0) ?v1)) ?v2) (f6 (f7 f9 (f6 (f7 f11 ?v3) ?v1)) ?v4)) (= ?v2 (f6 (f7 f9 (f6 (f7 f11 (f6 (f7 f8 ?v3) ?v0)) ?v1)) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (f3 (f4 f24 ?v0) ?v1) ?v2) (+ (f3 (f4 f24 ?v3) ?v1) ?v4)) (= ?v2 (+ (f3 (f4 f24 (- ?v3 ?v0)) ?v1) ?v4)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (= (= (f6 (f7 f9 (f6 (f7 f11 ?v0) ?v1)) ?v2) (f6 (f7 f9 (f6 (f7 f11 ?v3) ?v1)) ?v4)) (= (f6 (f7 f9 (f6 (f7 f11 (f6 (f7 f8 ?v0) ?v3)) ?v1)) ?v2) ?v4))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (f3 (f4 f24 ?v0) ?v1) ?v2) (+ (f3 (f4 f24 ?v3) ?v1) ?v4)) (= (+ (f3 (f4 f24 (- ?v0 ?v3)) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S8)) (= (f25 (f26 f32 ?v0) ?v0) (f25 (f26 f29 (f25 (f26 f32 f28) f28)) ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f9 ?v0) ?v0) (f6 (f7 f11 (f6 (f7 f9 f10) f10)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (f3 (f4 f24 (+ 1 1)) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f25 (f26 f32 ?v0) (f25 (f26 f29 ?v1) ?v0)) (f25 (f26 f29 (f25 (f26 f32 ?v1) f28)) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f9 ?v0) (f6 (f7 f11 ?v1) ?v0)) (f6 (f7 f11 (f6 (f7 f9 ?v1) f10)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (f3 (f4 f24 ?v1) ?v0)) (f3 (f4 f24 (+ ?v1 1)) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f25 (f26 f32 (f25 (f26 f29 ?v0) ?v1)) ?v1) (f25 (f26 f29 (f25 (f26 f32 ?v0) f28)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f9 (f6 (f7 f11 ?v0) ?v1)) ?v1) (f6 (f7 f11 (f6 (f7 f9 ?v0) f10)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f3 (f4 f24 ?v0) ?v1) ?v1) (f3 (f4 f24 (+ ?v0 1)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f19 f20 (f3 (f4 f24 (f21 f30 ?v1)) (f21 f30 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f19 f20 (f3 (f4 f24 (f21 f30 ?v1)) (f21 f30 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f19 f20 (f3 (f4 f24 (f21 f30 ?v1)) (f21 f30 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f19 f20 (* 2 (f21 f30 ?v1)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) (f19 f20 2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f19 f20 (* 2 (f21 f30 ?v1)))) (f25 (f26 f27 (f25 ?v_0 ?v1)) (f19 f20 2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f19 f20 (* 2 (f21 f30 ?v1)))) (f21 (f22 f23 (f21 ?v_0 ?v1)) (f19 f20 2))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f19 f20 (f3 (f4 f24 (f21 f30 ?v1)) (f21 f30 ?v2)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f19 f20 (f3 (f4 f24 (f21 f30 ?v1)) (f21 f30 ?v2)))) (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f19 f20 (f3 (f4 f24 (f21 f30 ?v1)) (f21 f30 ?v2)))) (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f26 f29 ?v0))) (= (f25 (f26 f29 (f25 ?v_0 ?v1)) (f25 (f26 f29 ?v2) ?v3)) (f25 (f26 f29 (f25 ?v_0 ?v2)) (f25 (f26 f29 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 (f7 f11 (f6 ?v_0 ?v1)) (f6 (f7 f11 ?v2) ?v3)) (f6 (f7 f11 (f6 ?v_0 ?v2)) (f6 (f7 f11 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f24 ?v0))) (= (f3 (f4 f24 (f3 ?v_0 ?v1)) (f3 (f4 f24 ?v2) ?v3)) (f3 (f4 f24 (f3 ?v_0 ?v2)) (f3 (f4 f24 ?v1) ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_1 (f26 f29 (f25 (f26 f29 ?v0) ?v1))) (?v_0 (f26 f29 ?v2))) (= (f25 ?v_1 (f25 ?v_0 ?v3)) (f25 ?v_0 (f25 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f7 f11 (f6 (f7 f11 ?v0) ?v1))) (?v_0 (f7 f11 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f4 f24 (f3 (f4 f24 ?v0) ?v1))) (?v_0 (f4 f24 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f26 f29 ?v0)) (?v_1 (f25 (f26 f29 ?v2) ?v3))) (= (f25 (f26 f29 (f25 ?v_0 ?v1)) ?v_1) (f25 ?v_0 (f25 (f26 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f11 ?v0)) (?v_1 (f6 (f7 f11 ?v2) ?v3))) (= (f6 (f7 f11 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f11 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f24 ?v0)) (?v_1 (f3 (f4 f24 ?v2) ?v3))) (= (f3 (f4 f24 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f29 ?v0))) (= (f25 (f26 f29 (f25 ?v_0 ?v1)) ?v2) (f25 (f26 f29 (f25 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 (f7 f11 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f11 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (= (f3 (f4 f24 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f24 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f29 ?v0))) (= (f25 (f26 f29 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 (f7 f11 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f11 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (= (f3 (f4 f24 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f24 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f33 ?v0))) (= (f3 (f4 f24 ?v_0) ?v_0) (f3 (f4 f24 ?v0) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f29 ?v0))) (= (f25 ?v_0 (f25 (f26 f29 ?v1) ?v2)) (f25 (f26 f29 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 ?v_0 (f6 (f7 f11 ?v1) ?v2)) (f6 (f7 f11 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (= (f3 ?v_0 (f3 (f4 f24 ?v1) ?v2)) (f3 (f4 f24 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f26 f29 ?v0)) (?v_0 (f26 f29 ?v1))) (= (f25 ?v_1 (f25 ?v_0 ?v2)) (f25 ?v_0 (f25 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f7 f11 ?v0)) (?v_0 (f7 f11 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f4 f24 ?v0)) (?v_0 (f4 f24 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f25 (f26 f29 ?v0) ?v1) (f25 (f26 f29 ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f11 ?v0) ?v1) (f6 (f7 f11 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f24 ?v0) ?v1) (f3 (f4 f24 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f33 (f3 (f4 f24 ?v0) ?v1)) (f3 (f4 f24 (f3 f33 ?v0)) (f3 f33 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f9 ?v0))) (= (f6 (f7 f9 (f6 ?v_0 ?v1)) (f6 (f7 f9 ?v2) ?v3)) (f6 (f7 f9 (f6 ?v_0 ?v2)) (f6 (f7 f9 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f9 ?v0))) (= (f6 (f7 f9 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f9 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f9 ?v0))) (= (f6 (f7 f9 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f9 ?v0))) (= (f6 ?v_0 (f6 (f7 f9 ?v1) ?v2)) (f6 (f7 f9 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f7 f9 ?v0)) (?v_0 (f7 f9 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f9 ?v0) ?v1) (f6 (f7 f9 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (= (f3 f33 1) 1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 2))) (= (f21 (f22 f23 (f3 f33 ?v0)) ?v_0) (f21 (f22 f23 ?v0) ?v_0)))))
(assert (forall ((?v0 S5)) (= (f12 (f13 f14 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f21 (f22 f23 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f12 (f13 f14 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f21 (f22 f23 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 (f22 f23 ?v0) (f19 f20 2)))) (= (f3 f33 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f3 f33 (f21 (f22 f23 ?v0) ?v1)) (f21 (f22 f23 (f3 f33 ?v0)) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f25 (f26 f29 ?v0) ?v1) f31) (or (= ?v0 f31) (= ?v1 f31)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f18) (or (= ?v0 f18) (= ?v1 f18)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f24 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f31)) (=> (not (= ?v1 f31)) (not (= (f25 (f26 f29 ?v0) ?v1) f31))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f18)) (=> (not (= ?v1 f18)) (not (= (f6 (f7 f11 ?v0) ?v1) f18))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f3 (f4 f24 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f11 ?v0) ?v1) f18) (or (= ?v0 f18) (= ?v1 f18)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f24 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 ?v0) f18) f18)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 ?v0) f18) f18)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 ?v0) f31) f31)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 ?v0) f18) f18)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 ?v0) f31) f31)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 ?v0) f18) f18)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 f18) ?v0) f18)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 f31) ?v0) f31)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 f18) ?v0) f18)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 f31) ?v0) f31)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 f18) ?v0) f18)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= ?v0 (f25 (f26 f32 ?v0) ?v1)) (= ?v1 f31))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 (f6 (f7 f9 ?v0) ?v1)) (= ?v1 f18))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S8)) (= (f25 (f26 f32 ?v0) f31) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f9 ?v0) f18) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f32 f31) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f9 f18) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (not (= f31 f28)))
(assert (not (= f18 f10)))
(assert (not (= 0 1)))
(assert (not (= f28 f31)))
(assert (not (= f10 f18)))
(assert (not (= 1 0)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f26 f29 ?v0)) (?v_1 (f26 f29 ?v2))) (= (= (f25 (f26 f32 (f25 ?v_0 ?v1)) (f25 ?v_1 ?v3)) (f25 (f26 f32 (f25 ?v_0 ?v3)) (f25 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f11 ?v0)) (?v_1 (f7 f11 ?v2))) (= (= (f6 (f7 f9 (f6 ?v_0 ?v1)) (f6 ?v_1 ?v3)) (f6 (f7 f9 (f6 ?v_0 ?v3)) (f6 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f24 ?v0)) (?v_1 (f4 f24 ?v2))) (= (= (+ (f3 ?v_0 ?v1) (f3 ?v_1 ?v3)) (+ (f3 ?v_0 ?v3) (f3 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (f25 (f26 f32 (f25 (f26 f29 ?v0) ?v1)) (f25 (f26 f32 (f25 (f26 f29 ?v2) ?v1)) ?v3)) (f25 (f26 f32 (f25 (f26 f29 (f25 (f26 f32 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f6 (f7 f9 (f6 (f7 f11 ?v0) ?v1)) (f6 (f7 f9 (f6 (f7 f11 ?v2) ?v1)) ?v3)) (f6 (f7 f9 (f6 (f7 f11 (f6 (f7 f9 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (f3 (f4 f24 ?v0) ?v1) (+ (f3 (f4 f24 ?v2) ?v1) ?v3)) (+ (f3 (f4 f24 (+ ?v0 ?v2)) ?v1) ?v3))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f25 (f26 f32 (f25 (f26 f29 ?v0) ?v1)) (f25 (f26 f29 ?v2) ?v1)) (f25 (f26 f29 (f25 (f26 f32 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f9 (f6 (f7 f11 ?v0) ?v1)) (f6 (f7 f11 ?v2) ?v1)) (f6 (f7 f11 (f6 (f7 f9 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f24 ?v0) ?v1) (f3 (f4 f24 ?v2) ?v1)) (f3 (f4 f24 (+ ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f11 (f6 (f7 f9 ?v0) ?v1)) ?v2) (f6 (f7 f9 (f6 (f7 f11 ?v0) ?v2)) (f6 (f7 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f11 (f6 (f7 f9 ?v0) ?v1)) ?v2) (f6 (f7 f9 (f6 (f7 f11 ?v0) ?v2)) (f6 (f7 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f25 (f26 f29 (f25 (f26 f32 ?v0) ?v1)) ?v2) (f25 (f26 f32 (f25 (f26 f29 ?v0) ?v2)) (f25 (f26 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f11 (f6 (f7 f9 ?v0) ?v1)) ?v2) (f6 (f7 f9 (f6 (f7 f11 ?v0) ?v2)) (f6 (f7 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f24 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f24 ?v0) ?v2) (f3 (f4 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f25 (f26 f29 (f25 (f26 f32 ?v0) ?v1)) ?v2) (f25 (f26 f32 (f25 (f26 f29 ?v0) ?v2)) (f25 (f26 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f11 (f6 (f7 f9 ?v0) ?v1)) ?v2) (f6 (f7 f9 (f6 (f7 f11 ?v0) ?v2)) (f6 (f7 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f24 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f24 ?v0) ?v2) (f3 (f4 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f26 f29 ?v0)) (?v_1 (f26 f29 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f25 (f26 f32 (f25 ?v_0 ?v2)) (f25 ?v_1 ?v3)) (f25 (f26 f32 (f25 ?v_0 ?v3)) (f25 ?v_1 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f11 ?v0)) (?v_1 (f7 f11 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f6 (f7 f9 (f6 ?v_0 ?v2)) (f6 ?v_1 ?v3)) (f6 (f7 f9 (f6 ?v_0 ?v3)) (f6 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f24 ?v0)) (?v_1 (f4 f24 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (f3 ?v_0 ?v2) (f3 ?v_1 ?v3)) (+ (f3 ?v_0 ?v3) (f3 ?v_1 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 ?v_0 (f6 (f7 f9 ?v1) ?v2)) (f6 (f7 f9 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f29 ?v0))) (= (f25 ?v_0 (f25 (f26 f32 ?v1) ?v2)) (f25 (f26 f32 (f25 ?v_0 ?v1)) (f25 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 ?v_0 (f6 (f7 f9 ?v1) ?v2)) (f6 (f7 f9 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 ?v_0 (f6 (f7 f9 ?v1) ?v2)) (f6 (f7 f9 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 ?v0) f28) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 ?v0) f10) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 f28) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 f10) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f11 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f11 ?v0) ?v2)) (f6 (f7 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f11 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f11 ?v0) ?v2)) (f6 (f7 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (not (= ?v0 f18)) (not (= (f12 (f13 f14 ?v0) ?v1) f18)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f21 (f22 f23 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S5)) (= (= (f12 (f13 f14 ?v0) (f19 f20 2)) f18) (= ?v0 f18))))
(assert (forall ((?v0 Int)) (= (= (f21 (f22 f23 ?v0) (f19 f20 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f25 (f26 f27 ?v0) ?v1) f31) (and (= ?v0 f31) (not (= ?v1 (f19 f20 0)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (= (f12 (f13 f14 ?v0) ?v1) f18) (and (= ?v0 f18) (not (= ?v1 (f19 f20 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f21 (f22 f23 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f19 f20 0)))))))
(assert (= (f25 (f26 f27 f31) (f19 f20 2)) f31))
(assert (= (f12 (f13 f14 f18) (f19 f20 2)) f18))
(assert (= (f21 (f22 f23 0) (f19 f20 2)) 0))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 f31) (f19 f20 (+ (f21 f30 ?v0) 1))) f31)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f18) (f19 f20 (+ (f21 f30 ?v0) 1))) f18)))
(assert (forall ((?v0 S8)) (= (f21 (f22 f23 0) (f19 f20 (+ (f21 f30 ?v0) 1))) 0)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S5)) (let ((?v_0 (f21 f30 ?v1)) (?v_1 (f21 f30 ?v0)) (?v_2 (f13 f14 ?v2))) (=> (<= ?v_1 ?v_0) (= (f12 ?v_2 (f19 f20 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f11 (f12 ?v_2 (f19 f20 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f30 ?v1)) (?v_1 (f21 f30 ?v0)) (?v_2 (f26 f27 ?v2))) (=> (<= ?v_1 ?v_0) (= (f25 ?v_2 (f19 f20 (- (+ ?v_0 1) ?v_1))) (f25 (f26 f29 (f25 ?v_2 (f19 f20 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f30 ?v1)) (?v_1 (f21 f30 ?v0)) (?v_2 (f22 f23 ?v2))) (=> (<= ?v_1 ?v_0) (= (f21 ?v_2 (f19 f20 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f24 (f21 ?v_2 (f19 f20 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S5)) (let ((?v_0 (f21 f30 ?v0)) (?v_1 (f13 f14 ?v1))) (=> (< 0 ?v_0) (= (f6 (f7 f11 (f12 ?v_1 (f19 f20 (- ?v_0 1)))) ?v1) (f12 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f30 ?v0)) (?v_1 (f26 f27 ?v1))) (=> (< 0 ?v_0) (= (f25 (f26 f29 (f25 ?v_1 (f19 f20 (- ?v_0 1)))) ?v1) (f25 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f21 f30 ?v0)) (?v_1 (f22 f23 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f24 (f21 ?v_1 (f19 f20 (- ?v_0 1)))) ?v1) (f21 ?v_1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 (f7 f11 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2)) (f12 ?v_0 (f19 f20 (+ (f21 f30 ?v1) (f21 f30 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f29 (f25 ?v_0 ?v1)) (f25 ?v_0 ?v2)) (f25 ?v_0 (f19 f20 (+ (f21 f30 ?v1) (f21 f30 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 (f4 f24 (f21 ?v_0 ?v1)) (f21 ?v_0 ?v2)) (f21 ?v_0 (f19 f20 (+ (f21 f30 ?v1) (f21 f30 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f12 (f13 f14 (f6 (f7 f11 ?v0) ?v1)) ?v2) (f6 (f7 f11 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f25 (f26 f27 (f25 (f26 f29 ?v0) ?v1)) ?v2) (f25 (f26 f29 (f25 (f26 f27 ?v0) ?v2)) (f25 (f26 f27 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f21 (f22 f23 (f3 (f4 f24 ?v0) ?v1)) ?v2) (f3 (f4 f24 (f21 (f22 f23 ?v0) ?v2)) (f21 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f12 (f13 f14 (f6 (f7 f11 ?v0) ?v1)) ?v2) (f6 (f7 f11 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f25 (f26 f27 (f25 (f26 f29 ?v0) ?v1)) ?v2) (f25 (f26 f29 (f25 (f26 f27 ?v0) ?v2)) (f25 (f26 f27 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f21 (f22 f23 (f3 (f4 f24 ?v0) ?v1)) ?v2) (f3 (f4 f24 (f21 (f22 f23 ?v0) ?v2)) (f21 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (= (f6 (f7 f11 ?v_0) ?v0) (f6 (f7 f11 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f25 (f26 f27 ?v0) ?v1))) (= (f25 (f26 f29 ?v_0) ?v0) (f25 (f26 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 (f22 f23 ?v0) ?v1))) (= (f3 (f4 f24 ?v_0) ?v0) (f3 (f4 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 (f7 f11 (f12 ?v_0 ?v1)) ?v0) (f12 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f29 (f25 ?v_0 ?v1)) ?v0) (f25 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 (f4 f24 (f21 ?v_0 ?v1)) ?v0) (f21 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f19 f20 (* 2 (f21 f30 ?v1)))) (f6 (f7 f11 ?v_1) ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (let ((?v_1 (f25 ?v_0 ?v1))) (= (f25 ?v_0 (f19 f20 (* 2 (f21 f30 ?v1)))) (f25 (f26 f29 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f21 ?v_0 ?v1))) (= (f21 ?v_0 (f19 f20 (* 2 (f21 f30 ?v1)))) (f3 (f4 f24 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f19 f20 (+ (f21 f30 ?v1) (f21 f30 ?v2)))) (f6 (f7 f11 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f19 f20 (+ (f21 f30 ?v1) (f21 f30 ?v2)))) (f25 (f26 f29 (f25 ?v_0 ?v1)) (f25 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f19 f20 (+ (f21 f30 ?v1) (f21 f30 ?v2)))) (f3 (f4 f24 (f21 ?v_0 ?v1)) (f21 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 (f7 f11 ?v0) (f12 ?v_0 ?v1)) (f12 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f29 ?v0) (f25 ?v_0 ?v1)) (f25 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 (f4 f24 ?v0) (f21 ?v_0 ?v1)) (f21 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f19 f20 (+ (* 2 (f21 f30 ?v1)) 1))) (f6 (f7 f11 ?v0) (f6 (f7 f11 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (let ((?v_1 (f25 ?v_0 ?v1))) (= (f25 ?v_0 (f19 f20 (+ (* 2 (f21 f30 ?v1)) 1))) (f25 (f26 f29 ?v0) (f25 (f26 f29 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f21 ?v_0 ?v1))) (= (f21 ?v_0 (f19 f20 (+ (* 2 (f21 f30 ?v1)) 1))) (f3 (f4 f24 ?v0) (f3 (f4 f24 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f19 f20 (+ (* 2 (f21 f30 ?v1)) 1))) (f6 (f7 f11 ?v0) (f12 (f13 f14 (f12 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f19 f20 (+ (* 2 (f21 f30 ?v1)) 1))) (f25 (f26 f29 ?v0) (f25 (f26 f27 (f25 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f19 f20 (+ (* 2 (f21 f30 ?v1)) 1))) (f3 (f4 f24 ?v0) (f21 (f22 f23 (f21 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 S5)) (= (f12 (f13 f14 ?v0) (f19 f20 3)) (f6 (f7 f11 (f6 (f7 f11 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 ?v0) (f19 f20 3)) (f25 (f26 f29 (f25 (f26 f29 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f21 (f22 f23 ?v0) (f19 f20 3)) (f3 (f4 f24 (f3 (f4 f24 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S5)) (= (f12 (f13 f14 ?v0) (f19 f20 2)) (f6 (f7 f11 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 ?v0) (f19 f20 2)) (f25 (f26 f29 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f21 (f22 f23 ?v0) (f19 f20 2)) (f3 (f4 f24 ?v0) ?v0))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1))) (f6 (f7 f11 (f12 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1))) (f25 (f26 f29 (f25 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1))) (f3 (f4 f24 (f21 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1))) (f6 (f7 f11 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1))) (f25 (f26 f29 ?v0) (f25 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1))) (f3 (f4 f24 ?v0) (f21 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1))) (f6 (f7 f11 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1))) (f25 (f26 f29 ?v0) (f25 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f19 f20 (+ (f21 f30 ?v1) 1))) (f3 (f4 f24 ?v0) (f21 ?v_0 ?v1))))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 ?v0) ?v0) (f12 (f13 f14 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 ?v0) ?v0) (f25 (f26 f27 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f24 ?v0) ?v0) (f21 (f22 f23 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 ?v0) (f19 f20 0)) f28)))
(assert (forall ((?v0 S5)) (= (f12 (f13 f14 ?v0) (f19 f20 0)) f10)))
(assert (forall ((?v0 Int)) (= (f21 (f22 f23 ?v0) (f19 f20 0)) 1)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 ?v0) (f19 f20 0)) f28)))
(assert (forall ((?v0 S5)) (= (f12 (f13 f14 ?v0) (f19 f20 0)) f10)))
(assert (forall ((?v0 Int)) (= (f21 (f22 f23 ?v0) (f19 f20 0)) 1)))
(assert (= (f25 (f26 f27 f28) (f19 f20 2)) f28))
(assert (= (f12 (f13 f14 f10) (f19 f20 2)) f10))
(assert (= (f21 (f22 f23 1) (f19 f20 2)) 1))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 f28) ?v0) f28)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f10) ?v0) f10)))
(assert (forall ((?v0 S8)) (= (f21 (f22 f23 1) ?v0) 1)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8) (?v4 S8)) (let ((?v_0 (f26 f29 ?v0))) (=> (not (= ?v0 f31)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f25 (f26 f32 ?v1) (f25 ?v_0 ?v3)) (f25 (f26 f32 ?v2) (f25 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (let ((?v_0 (f7 f11 ?v0))) (=> (not (= ?v0 f18)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f6 (f7 f9 ?v1) (f6 ?v_0 ?v3)) (f6 (f7 f9 ?v2) (f6 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f4 f24 ?v0))) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (f3 ?v_0 ?v3)) (+ ?v2 (f3 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (f3 (f4 f24 ?v0) ?v0) (f3 (f4 f24 ?v1) ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (= f27 (f34 (f35 f36 f28) f29)))
(assert (= f14 (f37 (f38 f39 f10) f11)))
(assert (= f23 (f40 (f41 f42 1) f24)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f6 (f7 f8 (f6 (f7 f9 ?v0) ?v1)) (f6 (f7 f9 ?v2) ?v3)) (f6 (f7 f9 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (- ?v0 ?v2) (- ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f6 (f7 f9 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f9 (f6 (f7 f8 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 ?v0) f28) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 ?v0) f10) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 ?v0) f28) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 ?v0) f10) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 f28) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 f10) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f29 f28) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f11 f10) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f18) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (= (f6 (f7 f8 ?v0) ?v1) f18))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) (f19 f20 1) (f19 f20 (f3 (f4 f24 (f21 f30 ?v0)) (f21 f30 (f25 ?v_0 (f19 f20 (- (f21 f30 ?v1) 1)))))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f19 f20 0)) (?v_2 (f21 f30 ?v0)) (?v_1 (f21 f30 ?v1))) (= (f19 f20 (f3 (f4 f24 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f19 f20 (+ ?v_1 (f3 (f4 f24 (f21 f30 (f19 f20 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f21 f30 ?v0))) (= (f19 f20 (* ?v_0 2)) (f19 f20 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f21 f30 ?v0))) (= (f19 f20 (* 2 ?v_0)) (f19 f20 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S8)) (let ((?v_0 (f22 (f40 (f41 f42 ?v0) ?v1) ?v2))) (= (f21 ?v_0 (f19 f20 (+ (f21 f30 ?v3) 1))) (f3 (f4 ?v1 ?v2) (f21 ?v_0 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S6) (?v2 S5) (?v3 S8)) (let ((?v_0 (f13 (f37 (f38 f39 ?v0) ?v1) ?v2))) (= (f12 ?v_0 (f19 f20 (+ (f21 f30 ?v3) 1))) (f6 (f7 ?v1 ?v2) (f12 ?v_0 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S14) (?v2 S8) (?v3 S8)) (let ((?v_0 (f26 (f34 (f35 f36 ?v0) ?v1) ?v2))) (= (f25 ?v_0 (f19 f20 (+ (f21 f30 ?v3) 1))) (f25 (f26 ?v1 ?v2) (f25 ?v_0 ?v3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (= (f21 (f22 (f40 (f41 f42 ?v0) ?v1) ?v2) (f19 f20 0)) ?v0)))
(assert (forall ((?v0 S5) (?v1 S6) (?v2 S5)) (= (f12 (f13 (f37 (f38 f39 ?v0) ?v1) ?v2) (f19 f20 0)) ?v0)))
(assert (forall ((?v0 S8) (?v1 S14) (?v2 S8)) (= (f25 (f26 (f34 (f35 f36 ?v0) ?v1) ?v2) (f19 f20 0)) ?v0)))
(assert (= (f3 f33 0) 0))
(assert (forall ((?v0 S8)) (= (= f31 ?v0) (= ?v0 f31))))
(assert (forall ((?v0 S5)) (= (= f18 ?v0) (= ?v0 f18))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f3 f33 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f29 ?v0))) (= (f25 (f26 f29 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (f6 (f7 f11 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f11 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (= (f3 (f4 f24 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f24 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f3 f33 ?v0) (f3 f33 ?v1)))) (= (f3 f33 ?v_0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f9 ?v0))) (= (f6 (f7 f9 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f43 ?v0) ?v1) ?v2) (f3 (f4 f43 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f44 ?v0) ?v1) ?v2) (f3 (f4 f44 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f9 ?v0))) (= (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f9 ?v0) ?v1) (f6 (f7 f9 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f9 ?v0))) (=> (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f9 ?v0))) (=> (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f9 ?v0) ?v1) (f6 (f7 f9 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S8)) (= (= f28 ?v0) (= ?v0 f28))))
(assert (forall ((?v0 S5)) (= (= f10 ?v0) (= ?v0 f10))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f33 (- ?v0 ?v1)) (f3 f33 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f43 ?v0) ?v1) ?v2) (f3 (f4 f43 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f44 ?v0) ?v1) ?v2) (f3 (f4 f44 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S8)) (= (f25 (f26 f32 f31) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f9 f18) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f32 f31) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f9 f18) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S8)) (= (f25 (f26 f32 ?v0) f31) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f9 ?v0) f18) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f32 ?v0) f31) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f9 ?v0) f18) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f18) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f18)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (f12 (f13 f14 (f6 f45 ?v0)) (f19 f20 2)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (<= (+ (f3 (f4 f24 ?v3) ?v0) (f3 (f4 f24 ?v4) ?v2)) ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f25 (f26 f27 ?v0) ?v1))) (=> (= (f46 f31 ?v0) f1) (=> (= (f46 ?v0 f28) f1) (= (f46 (f25 (f26 f29 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 (f22 f23 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f3 (f4 f24 ?v0) ?v_0) ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f46 ?v0 ?v1) f1) (=> (= (f47 ?v2 ?v3) f1) (= (f46 (f25 (f26 f32 ?v0) ?v2) (f25 (f26 f32 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f47 ?v0 ?v1) f1) (=> (= (f46 ?v2 ?v3) f1) (= (f46 (f25 (f26 f32 ?v0) ?v2) (f25 (f26 f32 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f3 f33 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 f33 ?v0))))
(assert (forall ((?v0 Int)) (not (< (f3 f33 ?v0) 0))))
(assert (forall ((?v0 Int)) (= (< 0 (f3 f33 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 f33 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (<= 0 (f3 f33 ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f3 f33 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f33 ?v0) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (= (f46 (f25 (f26 f32 ?v0) ?v1) (f25 (f26 f32 ?v2) ?v1)) f1) (= (f46 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f32 ?v0))) (= (= (f46 (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) f1) (= (f46 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f46 ?v0 ?v1) f1) (= (f46 (f25 (f26 f32 ?v0) ?v2) (f25 (f26 f32 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f32 ?v2))) (=> (= (f46 ?v0 ?v1) f1) (= (f46 (f25 ?v_0 ?v0) (f25 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f46 ?v0 ?v1) f1) (=> (= (f46 ?v2 ?v3) f1) (= (f46 (f25 (f26 f32 ?v0) ?v2) (f25 (f26 f32 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f46 (f25 (f26 f32 ?v0) ?v1) (f25 (f26 f32 ?v2) ?v1)) f1) (= (f46 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f32 ?v0))) (=> (= (f46 (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) f1) (= (f46 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f33 (+ ?v0 ?v1)) (+ (f3 f33 ?v0) (f3 f33 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (= (f47 (f25 (f26 f32 ?v0) ?v1) (f25 (f26 f32 ?v2) ?v1)) f1) (= (f47 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f32 ?v0))) (= (= (f47 (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) f1) (= (f47 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f33 (- (f3 f33 ?v0) (f3 f33 ?v1))) (f3 f33 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f33 ?v0) (f3 f33 ?v1)) (f3 f33 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f33 ?v0) (f3 f33 ?v1)) (f3 f33 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (<= ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (<= ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (=> (< 0 ?v0) (= (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (<= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (=> (< ?v0 0) (= (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (<= ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (f3 (f4 f24 ?v0) ?v2) (f3 (f4 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (f3 (f4 f24 ?v0) ?v2) (f3 (f4 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (f3 (f4 f24 ?v0) ?v2) (f3 (f4 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (f3 (f4 f24 ?v0) ?v2) (f3 (f4 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f3 (f4 f24 ?v0) ?v1) (f3 (f4 f24 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f3 (f4 f24 ?v0) ?v1) (f3 (f4 f24 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (=> (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (=> (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f3 (f4 f24 ?v0) ?v1) (f3 (f4 f24 ?v2) ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (=> (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f21 f30 ?v2)) (< (f21 (f22 f23 ?v0) ?v2) (f21 (f22 f23 ?v1) ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f46 ?v0 ?v1) f1) (=> (= (f47 f31 ?v0) f1) (=> (< 0 (f21 f30 ?v2)) (= (f46 (f25 (f26 f27 ?v0) ?v2) (f25 (f26 f27 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (< (f21 (f22 f23 ?v0) ?v1) (f21 (f22 f23 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f46 (f25 (f26 f27 ?v0) ?v1) (f25 (f26 f27 ?v2) ?v1)) f1) (=> (= (f47 f31 ?v2) f1) (= (f46 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (=> (< (f21 (f22 f23 ?v0) ?v_0) (f21 (f22 f23 ?v1) ?v_0)) (=> (<= 0 ?v1) (< ?v0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f19 f20 2))) (=> (= (f46 (f25 (f26 f27 ?v0) ?v_0) (f25 (f26 f27 ?v1) ?v_0)) f1) (=> (= (f47 f31 ?v1) f1) (= (f46 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (=> (< 1 ?v0) (= (<= (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (<= (f21 f30 ?v1) (f21 f30 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (=> (= (f46 f28 ?v0) f1) (= (= (f47 (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) f1) (<= (f21 f30 ?v1) (f21 f30 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (=> (< 1 ?v0) (=> (<= (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (<= (f21 f30 ?v1) (f21 f30 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (=> (= (f46 f28 ?v0) f1) (=> (= (f47 (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) f1) (<= (f21 f30 ?v1) (f21 f30 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f3 f33 ?v0)) (?v_1 (f3 f33 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f3 (f4 f24 ?v_0) ?v_1) (f3 (f4 f24 ?v1) ?v3)))))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f21 f30 ?v0)) (<= ?v_0 (f21 f30 (f25 (f26 f27 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (=> (< 0 (f21 f30 ?v0)) (=> (< (f21 f30 (f25 ?v_0 ?v1)) (f21 f30 (f25 ?v_0 ?v2))) (< (f21 f30 ?v1) (f21 f30 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (= (f19 f20 (f21 (f22 f23 ?v0) ?v1)) (f25 (f26 f27 (f19 f20 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f19 f20 (+ 0 1)))) (= (= (f25 (f26 f27 ?v0) ?v1) ?v_0) (or (= ?v1 (f19 f20 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f21 (f22 f23 (f21 f30 ?v0)) ?v1) (f21 f30 (f25 (f26 f27 ?v0) ?v1)))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f19 f20 (+ 0 1)))) (= (f25 (f26 f27 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (< 0 (f21 f30 (f25 (f26 f27 ?v0) ?v1))) (or (< 0 (f21 f30 ?v0)) (= ?v1 (f19 f20 0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f21 f30 (f25 (f26 f27 ?v0) ?v1)) (f21 (f22 f23 (f21 f30 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (< (+ (f3 (f4 f24 ?v3) ?v0) (f3 (f4 f24 ?v4) ?v2)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v2))) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f3 (f4 f24 ?v1) ?v2) (f3 (f4 f24 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 (f4 f24 ?v0) ?v2) (f3 (f4 f24 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (f3 (f4 f24 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f3 (f4 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (=> (< ?v0 0) (= (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (< ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f3 (f4 f24 ?v0) ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f3 (f4 f24 ?v0) ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f3 (f4 f24 ?v1) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f3 (f4 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (f3 (f4 f24 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (=> (< 0 ?v0) (= (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v0))) (= (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f3 (f4 f24 ?v0) ?v1) (f3 (f4 f24 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 Int)) (not (< (f3 (f4 f24 ?v0) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (< 0 (+ ?v0 ?v0)) (< 0 ?v0))))
(assert (< 0 1))
(assert (not (< 1 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (< (- ?v0 ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f3 (f4 f24 ?v0) ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f3 f33 (f3 (f4 f24 ?v0) ?v1)) (f3 (f4 f24 (f3 f33 ?v0)) (f3 f33 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f3 (f4 f24 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f3 (f4 f24 ?v0) ?v2) (f3 (f4 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f3 (f4 f24 ?v0) ?v2) (f3 (f4 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f3 (f4 f24 ?v1) ?v2) (f3 (f4 f24 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f24 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f3 (f4 f24 ?v0) ?v2) (f3 (f4 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S8)) (= (f19 f20 (f21 f30 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f21 f30 (f19 f20 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f21 f30 (f19 f20 ?v0)) 0))))
(check-sat)
(exit)
