(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S2)
(declare-fun f8 (S5 S6) S2)
(declare-fun f9 (S7 S2) S5)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S9) S2)
(declare-fun f12 () S8)
(declare-fun f13 () S9)
(declare-fun f14 (S10 Int) S6)
(declare-fun f15 () S10)
(declare-fun f16 (S11 S6) Int)
(declare-fun f17 () S11)
(declare-fun f18 () S6)
(declare-fun f19 () S2)
(declare-fun f20 () S2)
(declare-fun f21 () S2)
(declare-fun f22 () S3)
(declare-fun f23 (S2 S2) S1)
(declare-fun f24 (S12 S9) S9)
(declare-fun f25 (S13 S9) S12)
(declare-fun f26 () S13)
(declare-fun f27 () S3)
(declare-fun f28 (S14 Int) Int)
(declare-fun f29 (S15 Int) S14)
(declare-fun f30 () S15)
(declare-fun f31 (S16 Int) S11)
(declare-fun f32 () S16)
(declare-fun f33 (S6 S6) S1)
(declare-fun f34 () S6)
(declare-fun f35 (S17 S6) S6)
(declare-fun f36 (S18 S6) S17)
(declare-fun f37 () S18)
(declare-fun f38 () S18)
(declare-fun f39 () S3)
(declare-fun f40 (S19 S6) S9)
(declare-fun f41 (S20 S9) S19)
(declare-fun f42 () S20)
(declare-fun f43 () S9)
(declare-fun f44 () S9)
(declare-fun f45 (S6 S6) S1)
(declare-fun f46 () S6)
(declare-fun f47 () S14)
(declare-fun f48 () S12)
(declare-fun f49 () S9)
(declare-fun f50 () S13)
(declare-fun f51 () S4)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 f7) (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19)) f20) f1)))
(assert (= (f3 f21 f7) f1))
(assert (= (f3 f7 f20) f1))
(assert (= (f3 f7 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1))
(assert (= (f3 f21 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1))
(assert (not (= f18 (f14 f15 0))))
(assert (= (f3 f21 f7) f1))
(assert (= (f3 f7 f20) f1))
(assert (= (f3 f21 f19) f1))
(assert (= (f3 f7 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1))
(assert (= (f3 f21 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (and (= (f3 ?v1 f20) f1) (= (f3 ?v1 ?v0) f1)))))))
(assert (=> (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v0 f20) f1) (=> (= (f3 ?v0 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1) false)))) false))
(assert (let ((?v_0 (f11 f12 f13))) (= (f23 (f4 (f5 f6 f7) ?v_0) (f4 (f5 f6 f20) ?v_0)) f1)))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S9) (?v3 S2)) (=> (= (f3 (f11 f12 ?v0) ?v1) f1) (=> (= (f3 (f11 f12 ?v2) ?v3) f1) (= (f3 (f11 f12 (f24 (f25 f26 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f4 f27 ?v0) ?v1) f1) (=> (= (f3 (f4 f27 ?v2) ?v3) f1) (= (f3 (f4 f27 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f20 ?v0) f1) (= (f3 f20 (f4 (f5 f6 ?v0) (f8 (f9 f10 ?v0) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 1 ?v0) (< 1 (f28 (f29 f30 ?v0) (f16 (f31 f32 ?v0) ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f33 f34 ?v0) f1) (= (f33 f34 (f35 (f36 f37 ?v0) (f35 (f36 f38 ?v0) ?v1))) f1))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (f3 f20 ?v0) f1) (= (f3 ?v_0 (f4 (f5 f6 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f16 (f31 f32 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (f28 (f29 f30 ?v0) ?v_0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f35 (f36 f38 ?v0) ?v1))) (=> (= (f33 f34 ?v0) f1) (= (f33 ?v_0 (f35 (f36 f37 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f4 f39 ?v0) f20) f1) (= (f3 (f8 (f9 f10 ?v0) (f14 f15 2)) f20) f1))))
(assert (forall ((?v0 S9) (?v1 S6)) (= (f11 f12 (f40 (f41 f42 ?v0) ?v1)) (f8 (f9 f10 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f4 f27 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f27 ?v0)) ?v1))))
(assert (= (f11 f12 f43) f20))
(assert (= (f4 f27 f20) f20))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f11 f12 (f24 (f25 f26 ?v0) ?v1)) (f4 (f5 f6 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f27 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f27 ?v0)) (f4 f27 ?v1)))))
(assert (forall ((?v0 S9) (?v1 S6)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) f43 (f24 (f25 f26 ?v0) (f40 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) f20 (f4 (f5 f6 ?v0) (f8 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f16 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) 1 (f28 (f29 f30 ?v0) (f16 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) f34 (f35 (f36 f37 ?v0) (f35 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f20 ?v0) f1) (= (f3 f20 (f8 (f9 f10 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1)))) f1))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 1 ?v0) (< 1 (f16 (f31 f32 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f33 f34 ?v0) f1) (= (f33 f34 (f35 (f36 f38 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1)))) f1))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (= (= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (=> (< 1 ?v0) (= (= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v0))) (=> (= (f33 f34 ?v0) f1) (= (= (f35 ?v_0 ?v1) (f35 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S9)) (= (= (f23 (f11 f12 ?v0) f21) f1) (= ?v0 f44))))
(assert (forall ((?v0 S2)) (= (= (f23 (f4 f27 ?v0) f21) f1) (= ?v0 f21))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f16 (f31 f32 ?v0) ?v_0) (f16 (f31 f32 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f8 (f9 f10 ?v0) ?v_0) (f8 (f9 f10 ?v2) ?v_0)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 f21 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f35 (f36 f38 ?v0) ?v_0) (f35 (f36 f38 ?v2) ?v_0)) (=> (= (f45 f46 ?v0) f1) (=> (= (f45 f46 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (<= (f16 (f31 f32 ?v0) ?v_0) (f16 (f31 f32 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f23 (f8 (f9 f10 ?v0) ?v_0) (f8 (f9 f10 ?v2) ?v_0)) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f45 (f35 (f36 f38 ?v0) ?v_0) (f35 (f36 f38 ?v2) ?v_0)) f1) (=> (= (f45 f46 ?v2) f1) (= (f45 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (=> (= (f16 (f31 f32 ?v0) ?v1) (f16 (f31 f32 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f16 f17 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (=> (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 f21 ?v2) f1) (=> (< 0 (f16 f17 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f35 (f36 f38 ?v0) ?v1) (f35 (f36 f38 ?v2) ?v1)) (=> (= (f45 f46 ?v0) f1) (=> (= (f45 f46 ?v2) f1) (=> (< 0 (f16 f17 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f16 (f31 f32 ?v0) ?v2) (f16 (f31 f32 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 f21 ?v0) f1) (= (f23 (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f45 ?v0 ?v1) f1) (=> (= (f45 f46 ?v0) f1) (= (f45 (f35 (f36 f38 ?v0) ?v2) (f35 (f36 f38 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (<= 0 ?v0) (<= 0 (f16 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f23 f21 ?v0) f1) (= (f23 f21 (f8 (f9 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f45 f46 ?v0) f1) (= (f45 f46 (f35 (f36 f38 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f23 f21 (f8 (f9 f10 (f4 f39 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S6)) (<= 0 (f16 (f31 f32 (f28 f47 ?v0)) ?v1))))
(assert (forall ((?v0 S9)) (= (f23 f21 (f11 f12 ?v0)) f1)))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 ?v_0 (f14 f15 (f28 (f29 f30 (f16 f17 ?v1)) (f16 f17 ?v2)))) (f35 (f36 f38 (f35 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S6) (?v2 S6)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f14 f15 (f28 (f29 f30 (f16 f17 ?v1)) (f16 f17 ?v2)))) (f40 (f41 f42 (f40 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f14 f15 (f28 (f29 f30 (f16 f17 ?v1)) (f16 f17 ?v2)))) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f44)) (= (f11 f12 (f24 f48 ?v0)) (f4 f22 (f11 f12 ?v0))))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 f27 (f4 f22 ?v0)) (f4 f22 (f4 f27 ?v0))))))
(assert (forall ((?v0 S9)) (= (f11 f12 (f24 f48 ?v0)) (f4 f22 (f11 f12 ?v0)))))
(assert (forall ((?v0 S2)) (= (f4 f27 (f4 f22 ?v0)) (f4 f22 (f4 f27 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S6)) (=> (not (= ?v0 f44)) (= (f24 f48 (f40 (f41 f42 ?v0) ?v1)) (f40 (f41 f42 (f24 f48 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (not (= ?v0 f21)) (= (f4 f22 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f22 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (=> (< (f16 (f31 f32 ?v0) ?v1) (f16 (f31 f32 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (=> (= (f3 (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1)) f1) (=> (= (f23 f21 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f33 (f35 (f36 f38 ?v0) ?v1) (f35 (f36 f38 ?v2) ?v1)) f1) (=> (= (f45 f46 ?v2) f1) (= (f33 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f16 f17 ?v2)) (< (f16 (f31 f32 ?v0) ?v2) (f16 (f31 f32 ?v1) ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f23 f21 ?v0) f1) (=> (< 0 (f16 f17 ?v2)) (= (f3 (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f33 ?v0 ?v1) f1) (=> (= (f45 f46 ?v0) f1) (=> (< 0 (f16 f17 ?v2)) (= (f33 (f35 (f36 f38 ?v0) ?v2) (f35 (f36 f38 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f23 f21 ?v2) f1) (=> (= (f23 ?v2 f20) f1) (= (f23 (f8 ?v_0 ?v1) (f8 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f31 f32 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v0))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f45 f46 ?v2) f1) (=> (= (f45 ?v2 f34) f1) (= (f45 (f35 ?v_0 ?v1) (f35 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S9)) (= (= (f11 f12 ?v0) f21) (= ?v0 f44))))
(assert (forall ((?v0 S2)) (= (= (f4 f27 ?v0) f21) (= ?v0 f21))))
(assert (= (f11 f12 f44) f21))
(assert (= (f4 f27 f21) f21))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f23 f20 ?v2) f1) (= (f23 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f31 f32 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (<= 1 ?v2) (<= (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f45 f34 ?v2) f1) (= (f45 (f35 ?v_0 ?v0) (f35 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f23 f20 ?v0) f1) (= (f23 f20 (f8 (f9 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (<= 1 ?v0) (<= 1 (f16 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f45 f34 ?v0) f1) (= (f45 f34 (f35 (f36 f38 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S9) (?v1 S6)) (= (f24 f48 (f40 (f41 f42 ?v0) ?v1)) (f40 (f41 f42 (f24 f48 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f4 f22 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f22 ?v0)) ?v1))))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 ?v0) f44) f44)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f21) f21)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 ?v0) f44) f44)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f21) f21)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 f44) ?v0) f44)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f21) ?v0) f21)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 f44) ?v0) f44)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f21) ?v0) f21)))
(assert (forall ((?v0 S9) (?v1 S6)) (=> (not (= ?v0 f44)) (not (= (f40 (f41 f42 ?v0) ?v1) f44)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (not (= ?v0 0)) (not (= (f16 (f31 f32 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (not (= ?v0 f21)) (not (= (f8 (f9 f10 ?v0) ?v1) f21)))))
(assert (forall ((?v0 S9) (?v1 S6)) (= (= (f40 (f41 f42 ?v0) ?v1) f44) (and (= ?v0 f44) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (= (f16 (f31 f32 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (= (f8 (f9 f10 ?v0) ?v1) f21) (and (= ?v0 f21) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f35 (f36 f38 ?v0) ?v1) f46) (and (= ?v0 f46) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S6)) (= (f40 (f41 f42 f44) (f14 f15 (+ (f16 f17 ?v0) 1))) f44)))
(assert (forall ((?v0 S6)) (= (f16 (f31 f32 0) (f14 f15 (+ (f16 f17 ?v0) 1))) 0)))
(assert (forall ((?v0 S6)) (= (f8 (f9 f10 f21) (f14 f15 (+ (f16 f17 ?v0) 1))) f21)))
(assert (forall ((?v0 S6)) (= (f35 (f36 f38 f46) (f14 f15 (+ (f16 f17 ?v0) 1))) f46)))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (=> (= (f23 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (=> (< 1 ?v0) (=> (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v0))) (=> (= (f33 f34 ?v0) f1) (=> (= (f45 (f35 ?v_0 ?v1) (f35 ?v_0 ?v2)) f1) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (= (= (f23 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (=> (< 1 ?v0) (= (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v0))) (=> (= (f33 f34 ?v0) f1) (= (= (f45 (f35 ?v_0 ?v1) (f35 ?v_0 ?v2)) f1) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v0) ?v1)) (f4 (f5 f6 (f11 f12 ?v0)) (f11 f12 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f27 ?v0)) (f4 f27 ?v1))) f1)))
(assert (forall ((?v0 S9) (?v1 S6)) (= (f23 (f11 f12 (f40 (f41 f42 ?v0) ?v1)) (f8 (f9 f10 (f11 f12 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f23 (f4 f27 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f27 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 f21 ?v1) f1) (=> (= (f3 (f4 (f5 f6 ?v1) ?v2) (f4 (f5 f6 ?v0) ?v3)) f1) (= (f3 (f4 (f5 f6 (f4 f22 ?v0)) ?v2) (f4 (f5 f6 (f4 f22 ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 f21 ?v1) f1) (=> (= (f3 (f4 (f5 f6 ?v1) ?v2) (f4 (f5 f6 ?v0) ?v3)) f1) (= (f3 (f4 (f5 f6 ?v2) (f4 f22 ?v0)) (f4 (f5 f6 ?v3) (f4 f22 ?v1))) f1))))))
(assert (forall ((?v0 S9)) (= (= (f3 f21 (f11 f12 ?v0)) f1) (not (= ?v0 f44)))))
(assert (forall ((?v0 S2)) (= (= (f3 f21 (f4 f27 ?v0)) f1) (not (= ?v0 f21)))))
(assert (forall ((?v0 S6)) (= (f35 (f36 f38 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f4 f39 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f39 ?v0)) ?v1))))
(assert (forall ((?v0 S9)) (let ((?v_0 (f11 f12 ?v0))) (= (f4 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 0 ?v0) (< 0 (f16 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f21 ?v0) f1) (= (f3 f21 (f8 (f9 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f33 f46 ?v0) f1) (= (f33 f46 (f35 (f36 f38 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S6)) (= (f40 (f41 f42 f44) ?v0) (ite (= ?v0 (f14 f15 0)) f43 f44))))
(assert (forall ((?v0 S6)) (= (f8 (f9 f10 f21) ?v0) (ite (= ?v0 (f14 f15 0)) f20 f21))))
(assert (forall ((?v0 S6)) (= (f16 (f31 f32 0) ?v0) (ite (= ?v0 (f14 f15 0)) 1 0))))
(assert (forall ((?v0 S6)) (= (f35 (f36 f38 f46) ?v0) (ite (= ?v0 (f14 f15 0)) f34 f46))))
(assert (forall ((?v0 S9)) (not (= (f3 (f11 f12 ?v0) f21) f1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f3 f21 ?v2) f1) (=> (= (f3 ?v2 f20) f1) (= (f3 (f8 ?v_0 ?v1) (f8 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f31 f32 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f16 ?v_0 ?v1) (f16 ?v_0 ?v0))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f33 f46 ?v2) f1) (=> (= (f33 ?v2 f34) f1) (= (f33 (f35 ?v_0 ?v1) (f35 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v0 f20) f1) (= (f3 (f8 (f9 f10 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) f20) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f16 (f31 f32 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) 1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f33 f46 ?v0) f1) (=> (= (f33 ?v0 f34) f1) (= (f33 (f35 (f36 f38 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) f34) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0)) (?v_2 (f36 f38 ?v2))) (=> (<= ?v_1 ?v_0) (= (f35 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f35 (f36 f37 (f35 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S9)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0)) (?v_2 (f41 f42 ?v2))) (=> (<= ?v_1 ?v_0) (= (f40 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f24 (f25 f26 (f40 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0)) (?v_2 (f9 f10 ?v2))) (=> (<= ?v_1 ?v_0) (= (f8 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f4 (f5 f6 (f8 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0)) (?v_2 (f31 f32 ?v2))) (=> (<= ?v_1 ?v_0) (= (f16 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f28 (f29 f30 (f16 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f35 (f36 f38 (f35 (f36 f37 ?v0) ?v1)) ?v2) (f35 (f36 f37 (f35 (f36 f38 ?v0) ?v2)) (f35 (f36 f38 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S6)) (= (f40 (f41 f42 (f24 (f25 f26 ?v0) ?v1)) ?v2) (f24 (f25 f26 (f40 (f41 f42 ?v0) ?v2)) (f40 (f41 f42 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (= (f8 (f9 f10 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f8 (f9 f10 ?v0) ?v2)) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f16 (f31 f32 (f28 (f29 f30 ?v0) ?v1)) ?v2) (f28 (f29 f30 (f16 (f31 f32 ?v0) ?v2)) (f16 (f31 f32 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f35 (f36 f38 ?v0) ?v1))) (= (f35 (f36 f37 ?v_0) ?v0) (f35 (f36 f37 ?v0) ?v_0)))))
(assert (forall ((?v0 S9) (?v1 S6)) (let ((?v_0 (f40 (f41 f42 ?v0) ?v1))) (= (f24 (f25 f26 ?v_0) ?v0) (f24 (f25 f26 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f4 (f5 f6 ?v_0) ?v0) (f4 (f5 f6 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f16 (f31 f32 ?v0) ?v1))) (= (f28 (f29 f30 ?v_0) ?v0) (f28 (f29 f30 ?v0) ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 ?v_0 (f14 f15 (+ (f16 f17 ?v1) (f16 f17 ?v2)))) (f35 (f36 f37 (f35 ?v_0 ?v1)) (f35 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S6) (?v2 S6)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f14 f15 (+ (f16 f17 ?v1) (f16 f17 ?v2)))) (f24 (f25 f26 (f40 ?v_0 ?v1)) (f40 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f14 f15 (+ (f16 f17 ?v1) (f16 f17 ?v2)))) (f4 (f5 f6 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f16 ?v_0 (f14 f15 (+ (f16 f17 ?v1) (f16 f17 ?v2)))) (f28 (f29 f30 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f35 (f36 f37 (f35 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S9) (?v1 S6)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f24 (f25 f26 (f40 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f4 (f5 f6 (f8 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f16 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f28 (f29 f30 (f16 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f35 (f36 f37 ?v0) (f35 ?v_0 ?v1))))))
(assert (forall ((?v0 S9) (?v1 S6)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f24 (f25 f26 ?v0) (f40 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f4 (f5 f6 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f16 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f28 (f29 f30 ?v0) (f16 ?v_0 ?v1))))))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 ?v0) (f14 f15 0)) f43)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) (f14 f15 0)) f20)))
(assert (forall ((?v0 Int)) (= (f16 (f31 f32 ?v0) (f14 f15 0)) 1)))
(assert (forall ((?v0 S6)) (= (f35 (f36 f38 ?v0) (f14 f15 0)) f34)))
(assert (forall ((?v0 S6)) (= (f40 (f41 f42 f43) ?v0) f43)))
(assert (forall ((?v0 S6)) (= (f8 (f9 f10 f20) ?v0) f20)))
(assert (forall ((?v0 S6)) (= (f16 (f31 f32 1) ?v0) 1)))
(assert (forall ((?v0 S6)) (= (f35 (f36 f38 f34) ?v0) f34)))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v0 f20) f1) (= (f3 (f4 (f5 f6 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f16 (f31 f32 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f28 (f29 f30 ?v0) ?v_0) ?v_0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f35 (f36 f38 ?v0) ?v1))) (=> (= (f33 f46 ?v0) f1) (=> (= (f33 ?v0 f34) f1) (= (f33 (f35 (f36 f37 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f3 f20 ?v2) f1) (= (f3 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f31 f32 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (< 1 ?v2) (< (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f33 f34 ?v2) f1) (= (f33 (f35 ?v_0 ?v0) (f35 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (=> (= (f3 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (=> (< 1 ?v0) (=> (< (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v0))) (=> (= (f33 f34 ?v0) f1) (=> (= (f33 (f35 ?v_0 ?v1) (f35 ?v_0 ?v2)) f1) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f20 ?v0) f1) (=> (< 0 (f16 f17 ?v1)) (= (f3 f20 (f8 (f9 f10 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 1 ?v0) (=> (< 0 (f16 f17 ?v1)) (< 1 (f16 (f31 f32 ?v0) ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f33 f34 ?v0) f1) (=> (< 0 (f16 f17 ?v1)) (= (f33 f34 (f35 (f36 f38 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (= (= (f3 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (=> (< 1 ?v0) (= (< (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f36 f38 ?v0))) (=> (= (f33 f34 ?v0) f1) (= (= (f33 (f35 ?v_0 ?v1) (f35 ?v_0 ?v2)) f1) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (forall ((?v2 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v2) ?v0)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (forall ((?v2 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v2) ?v0)) (f4 (f5 f6 (f4 f27 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (forall ((?v2 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v0) ?v2)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (forall ((?v2 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 (f4 f27 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S2)) (and (= (f3 f21 ?v0) f1) (forall ((?v1 S9) (?v2 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f11 f12 ?v1)) (f11 f12 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S2)) (and (= (f3 f21 ?v0) f1) (forall ((?v1 S2) (?v2 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f4 f27 ?v1)) (f4 f27 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S9)) (=> (= (f23 ?v0 (f11 f12 ?v1)) f1) (=> (= (f3 f21 ?v0) f1) (= (f23 (f11 f12 (f24 f48 ?v1)) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 (f4 f27 ?v1)) f1) (=> (= (f3 f21 ?v0) f1) (= (f23 (f4 f27 (f4 f22 ?v1)) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (and (= (f23 f21 ?v1) f1) (forall ((?v2 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v2) ?v0)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (and (= (f23 f21 ?v1) f1) (forall ((?v2 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v2) ?v0)) (f4 (f5 f6 (f4 f27 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (and (= (f23 f21 ?v1) f1) (forall ((?v2 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v0) ?v2)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (and (= (f23 f21 ?v1) f1) (forall ((?v2 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 (f4 f27 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S2)) (and (= (f23 f21 ?v0) f1) (forall ((?v1 S9) (?v2 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f11 f12 ?v1)) (f11 f12 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S2)) (and (= (f23 f21 ?v0) f1) (forall ((?v1 S2) (?v2 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f4 f27 ?v1)) (f4 f27 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S9) (?v2 S9)) (=> (= (f23 ?v0 f21) f1) (=> (= (f23 (f11 f12 ?v1) (f4 (f5 f6 ?v0) (f11 f12 ?v2))) f1) (= ?v1 f44)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 f21) f1) (=> (= (f23 (f4 f27 ?v1) (f4 (f5 f6 ?v0) (f4 f27 ?v2))) f1) (= ?v1 f21)))))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f23 ?v0 f20) f1) (= (f23 f20 (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f22 ?v0) f20) f1) (or (= (f23 ?v0 f21) f1) (= (f3 f20 ?v0) f1)))))
(assert (not (= f49 f44)))
(assert (not (= f13 f44)))
(assert (forall ((?v0 S2)) (= (f4 f39 (f4 f22 ?v0)) (f4 f22 (f4 f39 ?v0)))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 f39 (f4 f22 ?v0)) (f4 f22 (f4 f39 ?v0))))))
(assert (= (f24 f48 f44) f44))
(assert (= (f4 f22 f21) f21))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f24 f48 (f24 (f25 f26 ?v0) ?v1)) (f24 (f25 f26 (f24 f48 ?v0)) (f24 f48 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f22 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f22 ?v0)) (f4 f22 ?v1)))))
(assert (forall ((?v0 S9)) (= (= (f24 f48 ?v0) f43) (= ?v0 f43))))
(assert (forall ((?v0 S2)) (= (= (f4 f22 ?v0) f20) (= ?v0 f20))))
(assert (forall ((?v0 S2)) (= (= (f23 (f4 f22 ?v0) f21) f1) (= (f23 ?v0 f21) f1))))
(assert (forall ((?v0 S2)) (= (= (f23 f21 (f4 f22 ?v0)) f1) (= (f23 f21 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (= (f3 f21 (f4 f22 ?v0)) f1) (= (f3 f21 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f22 ?v0) f21) f1) (= (f3 ?v0 f21) f1))))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (= (f3 f21 (f4 f22 ?v0)) f1))))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 (f4 f22 ?v0)) f1) (=> (not (= ?v0 f21)) (= (f3 f21 ?v0) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0 f21) f1) (= (f3 (f4 f22 ?v0) f21) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 f21 ?v0) f1) (= (f3 (f4 f22 ?v1) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 f21) f1) (= (f3 (f4 f22 ?v1) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f4 f22 ?v0) f21) f1) (=> (not (= ?v0 f21)) (= (f3 ?v0 f21) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (=> (= (f3 f21 ?v0) f1) (= (f3 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (=> (= (f3 ?v1 f21) f1) (= (f3 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 f21) f1) (=> (= (f23 (f4 f39 ?v1) (f4 (f5 f6 ?v0) (f4 f39 ?v2))) f1) (= ?v1 f21)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (=> (= (f3 ?v1 f21) f1) (= (f23 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (=> (= (f3 f21 ?v0) f1) (= (f23 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f3 ?v1 f21) f1) (= (f23 (f4 f22 ?v1) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f3 f21 ?v0) f1) (= (f23 (f4 f22 ?v1) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2)) (= (= (f23 (f4 f22 ?v0) f20) f1) (or (= (f23 ?v0 f21) f1) (= (f23 f20 ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f20 (f4 f22 ?v0)) f1) (and (= (f3 f21 ?v0) f1) (= (f3 ?v0 f20) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v0 f20) f1) (= (f3 f20 (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f44)) (= (f24 (f25 f26 (f24 f48 ?v0)) ?v0) f43))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 (f5 f6 (f4 f22 ?v0)) ?v0) f20))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (= (= (f3 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (and (=> (= (f3 f21 ?v_0) f1) (= (f3 ?v1 ?v0) f1)) (=> (= (f23 ?v_0 f21) f1) (= (f3 ?v0 ?v1) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (= (= (f23 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (and (=> (= (f3 f21 ?v_0) f1) (= (f23 ?v1 ?v0) f1)) (=> (= (f23 ?v_0 f21) f1) (= (f23 ?v0 ?v1) f1)))))))
(assert (forall ((?v0 S2)) (= (= (f23 f20 (f4 f22 ?v0)) f1) (and (= (f3 f21 ?v0) f1) (= (f23 ?v0 f20) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (forall ((?v2 S2)) (=> (= (f3 f21 ?v2) f1) (=> (= (f3 ?v2 f20) f1) (= (f23 (f4 (f5 f6 ?v2) ?v0) ?v1) f1)))) (= (f23 ?v0 ?v1) f1))))
(assert (exists ((?v0 S2)) (forall ((?v1 S9) (?v2 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f11 f12 ?v1)) (f11 f12 ?v2))) ?v0)) f1))))
(assert (exists ((?v0 S2)) (forall ((?v1 S2) (?v2 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f4 f27 ?v1)) (f4 f27 ?v2))) ?v0)) f1))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (forall ((?v2 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v0) ?v2)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 (f4 f27 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (forall ((?v2 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v2) ?v0)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v2) ?v0)) (f4 (f5 f6 (f4 f27 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 (f5 f6 (f4 f22 ?v0)) ?v0) f20))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f21 ?v0) f1) (= (= (f23 (f4 (f5 f6 ?v1) ?v0) (f4 (f5 f6 ?v2) ?v0)) f1) (= (f23 ?v1 ?v2) f1)))))
(assert (= (f24 (f25 f50 f43) (f24 (f25 f26 (f40 (f41 f42 f13) f18)) f49)) f44))
(assert (forall ((?v0 S2)) (= (f23 ?v0 ?v0) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f23 ?v0 ?v1) f1) (= (f23 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v2) f1) (= (f23 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f36 f38 ?v1))) (=> (< 0 ?v_0) (= (f35 (f36 f37 (f35 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f35 ?v_1 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S9)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f41 f42 ?v1))) (=> (< 0 ?v_0) (= (f24 (f25 f26 (f40 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f40 ?v_1 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S2)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f9 f10 ?v1))) (=> (< 0 ?v_0) (= (f4 (f5 f6 (f8 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f8 ?v_1 ?v0))))))
(assert (forall ((?v0 S6) (?v1 Int)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f31 f32 ?v1))) (=> (< 0 ?v_0) (= (f28 (f29 f30 (f16 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f16 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f23 ?v0 ?v1) f1) (or (= (f3 ?v0 ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 ?v0 ?v1) f1) (and (= (f23 ?v0 ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (not (= ?v0 f21)) (= (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (= (= (f4 (f5 f6 ?v1) ?v0) (f4 (f5 f6 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (not (= f21 f20)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f20) ?v0) ?v0)))
(assert (= (f4 f22 f21) f21))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 f21 ?v1) f1) (= (f3 f21 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f21 ?v0) f1) (= (= (f3 (f4 (f5 f6 ?v1) ?v0) (f4 (f5 f6 ?v2) ?v0)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 ?v0 f20) f1) (= (f23 (f8 (f9 f10 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (<= 0 ?v0) (=> (<= ?v0 1) (<= (f16 (f31 f32 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f45 f46 ?v0) f1) (=> (= (f45 ?v0 f34) f1) (= (f45 (f35 (f36 f38 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f3 f21 ?v0) f1) (= (= (f23 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1) (= (f23 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< ?v0 0) (< (f16 (f31 f32 ?v0) (f14 f15 (+ (* 2 (f16 f17 ?v1)) 1))) 0))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 ?v0 f21) f1) (= (f3 (f8 (f9 f10 ?v0) (f14 f15 (+ (* 2 (f16 f17 ?v1)) 1))) f21) f1))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f44)) (= (f24 (f25 f26 (f24 f48 ?v0)) ?v0) f43))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 (f5 f6 (f4 f22 ?v0)) ?v0) f20))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f44)) (= (f24 (f25 f26 ?v0) (f24 f48 ?v0)) f43))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 (f5 f6 ?v0) (f4 f22 ?v0)) f20))))
(assert (forall ((?v0 Int) (?v1 S6)) (<= 0 (f16 (f31 f32 ?v0) (f14 f15 (* 2 (f16 f17 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f23 f21 (f8 (f9 f10 ?v0) (f14 f15 (* 2 (f16 f17 ?v1))))) f1)))
(assert (=> (forall ((?v0 S9)) (=> (= (f24 (f25 f50 f43) (f24 (f25 f26 (f40 (f41 f42 ?v0) f18)) f49)) f44) false)) false))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f51 ?v0) ?v1)) ?v2) (f4 (f5 f51 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f24 (f25 f26 (f24 (f25 f50 ?v0) ?v1)) ?v2) (f24 (f25 f50 (f24 (f25 f26 ?v0) ?v2)) (f24 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f51 ?v0) ?v1)) ?v2) (f4 (f5 f51 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f24 (f25 f26 (f24 (f25 f50 ?v0) ?v1)) ?v2) (f24 (f25 f50 (f24 (f25 f26 ?v0) ?v2)) (f24 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f51 ?v1) ?v2)) (f4 (f5 f51 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f24 (f25 f50 ?v1) ?v2)) (f24 (f25 f50 (f24 ?v_0 ?v1)) (f24 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f51 ?v1) ?v2)) (f4 (f5 f51 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f24 (f25 f50 ?v1) ?v2)) (f24 (f25 f50 (f24 ?v_0 ?v1)) (f24 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v1 (f4 (f5 f51 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f51 (f4 (f5 f6 ?v0) ?v0)) (f4 (f5 f6 ?v1) ?v1)) f21) (and (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (f28 (f29 f30 ?v0) ?v0) (f28 (f29 f30 ?v1) ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2)) (= (f3 ?v0 (f4 (f5 f51 ?v0) f20)) f1)))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 f15 2))) (= (= (f4 (f5 f51 (f8 (f9 f10 ?v0) ?v_0)) (f8 (f9 f10 ?v1) ?v_0)) f21) (and (= ?v0 f21) (= ?v1 f21))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (= (+ (f16 (f31 f32 ?v0) ?v_0) (f16 (f31 f32 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f4 f27 ?v0) ?v1) f1) (=> (= (f3 (f4 f27 ?v2) ?v3) f1) (= (f3 (f4 f27 (f4 (f5 f51 ?v0) ?v2)) (f4 (f5 f51 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S9) (?v3 S2)) (=> (= (f3 (f11 f12 ?v0) ?v1) f1) (=> (= (f3 (f11 f12 ?v2) ?v3) f1) (= (f3 (f11 f12 (f24 (f25 f50 ?v0) ?v2)) (f4 (f5 f51 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f23 (f4 f27 (f4 (f5 f51 ?v0) ?v1)) (f4 (f5 f51 (f4 f27 ?v0)) (f4 f27 ?v1))) f1)))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f23 (f11 f12 (f24 (f25 f50 ?v0) ?v1)) (f4 (f5 f51 (f11 f12 ?v0)) (f11 f12 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f4 (f5 f51 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f51 (f4 (f5 f6 ?v2) ?v1)) ?v3)) (f4 (f5 f51 (f4 (f5 f6 (f4 (f5 f51 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (= (f24 (f25 f50 (f24 (f25 f26 ?v0) ?v1)) (f24 (f25 f50 (f24 (f25 f26 ?v2) ?v1)) ?v3)) (f24 (f25 f50 (f24 (f25 f26 (f24 (f25 f50 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (f28 (f29 f30 ?v0) ?v1) (+ (f28 (f29 f30 ?v2) ?v1) ?v3)) (+ (f28 (f29 f30 (+ ?v0 ?v2)) ?v1) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f51 ?v0) ?v1)) ?v2) (f4 (f5 f51 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f24 (f25 f26 (f24 (f25 f50 ?v0) ?v1)) ?v2) (f24 (f25 f50 (f24 (f25 f26 ?v0) ?v2)) (f24 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f28 (f29 f30 (+ ?v0 ?v1)) ?v2) (+ (f28 (f29 f30 ?v0) ?v2) (f28 (f29 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f23 (f4 (f5 f51 (f4 (f5 f6 ?v0) ?v0)) (f4 (f5 f6 ?v1) ?v1)) f21) f1) (and (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (+ (f28 (f29 f30 ?v0) ?v0) (f28 (f29 f30 ?v1) ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f23 f21 (f4 (f5 f51 (f4 (f5 f6 ?v0) ?v0)) (f4 (f5 f6 ?v1) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= 0 (+ (f28 (f29 f30 ?v0) ?v0) (f28 (f29 f30 ?v1) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= (f3 (f4 (f5 f51 (f4 (f5 f6 ?v0) ?v0)) (f4 (f5 f6 ?v1) ?v1)) f21) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (not (< (+ (f28 (f29 f30 ?v0) ?v0) (f28 (f29 f30 ?v1) ?v1)) 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f21 (f4 (f5 f51 (f4 (f5 f6 ?v0) ?v0)) (f4 (f5 f6 ?v1) ?v1))) f1) (or (not (= ?v0 f21)) (not (= ?v1 f21))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< 0 (+ (f28 (f29 f30 ?v0) ?v0) (f28 (f29 f30 ?v1) ?v1))) (or (not (= ?v0 0)) (not (= ?v1 0))))))
(assert (= (f3 f21 (f4 (f5 f51 f20) f20)) f1))
(assert (< 0 (+ 1 1)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 f15 2))) (= (= (f23 (f4 (f5 f51 (f8 (f9 f10 ?v0) ?v_0)) (f8 (f9 f10 ?v1) ?v_0)) f21) f1) (and (= ?v0 f21) (= ?v1 f21))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (<= (+ (f16 (f31 f32 ?v0) ?v_0) (f16 (f31 f32 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 f15 2))) (= (f23 f21 (f4 (f5 f51 (f8 (f9 f10 ?v0) ?v_0)) (f8 (f9 f10 ?v1) ?v_0))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (<= 0 (+ (f16 (f31 f32 ?v0) ?v_0) (f16 (f31 f32 ?v1) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 f15 2))) (not (= (f3 (f4 (f5 f51 (f8 (f9 f10 ?v0) ?v_0)) (f8 (f9 f10 ?v1) ?v_0)) f21) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (not (< (+ (f16 (f31 f32 ?v0) ?v_0) (f16 (f31 f32 ?v1) ?v_0)) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 f15 2))) (= (= (f3 f21 (f4 (f5 f51 (f8 (f9 f10 ?v0) ?v_0)) (f8 (f9 f10 ?v1) ?v_0))) f1) (or (not (= ?v0 f21)) (not (= ?v1 f21)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (< 0 (+ (f16 (f31 f32 ?v0) ?v_0) (f16 (f31 f32 ?v1) ?v_0))) (or (not (= ?v0 0)) (not (= ?v1 0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f22 ?v0)) (?v_1 (f4 f22 ?v1))) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (= (f4 (f5 f51 ?v_0) ?v_1) (f4 (f5 f6 (f4 (f5 f6 ?v_0) (f4 (f5 f51 ?v0) ?v1))) ?v_1)))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f24 f48 ?v0)) (?v_1 (f24 f48 ?v1))) (=> (not (= ?v0 f44)) (=> (not (= ?v1 f44)) (= (f24 (f25 f50 ?v_0) ?v_1) (f24 (f25 f26 (f24 (f25 f26 ?v_0) (f24 (f25 f50 ?v0) ?v1))) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v2 ?v1) f1) (=> (= (f23 f21 ?v3) f1) (=> (= (f23 f21 ?v4) f1) (=> (= (f4 (f5 f51 ?v3) ?v4) f20) (= (f23 (f4 (f5 f51 (f4 (f5 f6 ?v3) ?v0)) (f4 (f5 f6 ?v4) ?v2)) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (<= (+ (f28 (f29 f30 ?v3) ?v0) (f28 (f29 f30 ?v4) ?v2)) ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f22 ?v0)) (?v_1 (f4 f22 ?v1))) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (= (f4 (f5 f51 ?v_0) ?v_1) (f4 (f5 f6 (f4 (f5 f6 (f4 (f5 f51 ?v0) ?v1)) ?v_0)) ?v_1)))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f24 f48 ?v0)) (?v_1 (f24 f48 ?v1))) (=> (not (= ?v0 f44)) (=> (not (= ?v1 f44)) (= (f24 (f25 f50 ?v_0) ?v_1) (f24 (f25 f26 (f24 (f25 f26 (f24 (f25 f50 ?v0) ?v1)) ?v_0)) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 ?v0 ?v1) f1) false) (=> (=> (= (f3 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f39 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f39 ?v0)) (f4 f39 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f28 f47 (f28 (f29 f30 ?v0) ?v1)) (f28 (f29 f30 (f28 f47 ?v0)) (f28 f47 ?v1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f39 ?v0))) (= (f4 (f5 f6 ?v_0) ?v_0) (f4 (f5 f6 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f28 f47 ?v0))) (= (f28 (f29 f30 ?v_0) ?v_0) (f28 (f29 f30 ?v0) ?v0)))))
(assert (= (f4 f39 f20) f20))
(assert (= (f28 f47 1) 1))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 (f9 f10 ?v0) (f14 f15 2)))) (= (f4 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f14 f15 2))) (= (f8 (f9 f10 (f4 f39 ?v0)) ?v_0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 ?v1) f1) (=> (= (f23 f21 ?v3) f1) (=> (= (f23 f21 ?v4) f1) (=> (= (f4 (f5 f51 ?v3) ?v4) f20) (= (f3 (f4 (f5 f51 (f4 (f5 f6 ?v3) ?v0)) (f4 (f5 f6 ?v4) ?v2)) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (< (+ (f28 (f29 f30 ?v3) ?v0) (f28 (f29 f30 ?v4) ?v2)) ?v1))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) (f14 f15 1) (f14 f15 (f28 (f29 f30 (f16 f17 ?v0)) (f16 f17 (f35 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f14 f15 0)) (?v_2 (f16 f17 ?v0)) (?v_1 (f16 f17 ?v1))) (= (f14 f15 (f28 (f29 f30 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f14 f15 (+ ?v_1 (f28 (f29 f30 (f16 f17 (f14 f15 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f16 f17 ?v0))) (= (f14 f15 (* ?v_0 2)) (f14 f15 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f16 f17 ?v0))) (= (f14 f15 (* 2 ?v_0)) (f14 f15 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 f22 ?v0) (f4 f22 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 f22 ?v0) (f4 f22 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2)) (= (f4 f22 (f4 f22 ?v0)) ?v0)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 f44) ?v0) f44)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f21) ?v0) f21)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 ?v0) f44) f44)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f21) f21)))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f24 (f25 f26 ?v0) ?v1) f44) (or (= ?v0 f44) (= ?v1 f44)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 (f29 f30 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f6 ?v0) ?v1) f21) (or (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (not (= ?v0 f44)) (=> (not (= ?v1 f44)) (not (= (f24 (f25 f26 ?v0) ?v1) f44))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f28 (f29 f30 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (not (= (f4 (f5 f6 ?v0) ?v1) f21))))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f24 (f25 f26 ?v0) ?v1) f44) (or (= ?v0 f44) (= ?v1 f44)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 (f29 f30 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f21) (or (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f39 ?v0)) (?v_1 (f4 f39 ?v2))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_1 ?v3) f1) (= (f3 (f4 (f5 f6 ?v_0) ?v_1) (f4 (f5 f6 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f28 f47 ?v0)) (?v_1 (f28 f47 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f28 (f29 f30 ?v_0) ?v_1) (f28 (f29 f30 ?v1) ?v3)))))))
(assert (not (= f43 f44)))
(assert (not (= f20 f21)))
(assert (not (= 1 0)))
(assert (not (= f44 f43)))
(assert (not (= f21 f20)))
(assert (not (= 0 1)))
(assert (= (f40 (f41 f42 f44) (f14 f15 2)) f44))
(assert (= (f16 (f31 f32 0) (f14 f15 2)) 0))
(assert (= (f8 (f9 f10 f21) (f14 f15 2)) f21))
(assert (= (f35 (f36 f38 f46) (f14 f15 2)) f46))
(assert (forall ((?v0 S9)) (= (= (f40 (f41 f42 ?v0) (f14 f15 2)) f44) (= ?v0 f44))))
(assert (forall ((?v0 Int)) (= (= (f16 (f31 f32 ?v0) (f14 f15 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f8 (f9 f10 ?v0) (f14 f15 2)) f21) (= ?v0 f21))))
(assert (forall ((?v0 S6)) (= (f35 (f36 f38 ?v0) (f14 f15 2)) (f35 (f36 f37 ?v0) ?v0))))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 ?v0) (f14 f15 2)) (f24 (f25 f26 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) (f14 f15 2)) (f4 (f5 f6 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f16 (f31 f32 ?v0) (f14 f15 2)) (f28 (f29 f30 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (= (f35 (f36 f38 ?v0) (f14 f15 3)) (f35 (f36 f37 (f35 (f36 f37 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 ?v0) (f14 f15 3)) (f24 (f25 f26 (f24 (f25 f26 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) (f14 f15 3)) (f4 (f5 f6 (f4 (f5 f6 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f16 (f31 f32 ?v0) (f14 f15 3)) (f28 (f29 f30 (f28 (f29 f30 ?v0) ?v0)) ?v0))))
(assert (= (f40 (f41 f42 f43) (f14 f15 2)) f43))
(assert (= (f8 (f9 f10 f20) (f14 f15 2)) f20))
(assert (= (f16 (f31 f32 1) (f14 f15 2)) 1))
(assert (= (f35 (f36 f38 f34) (f14 f15 2)) f34))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f24 f48 ?v0) (f24 f48 ?v1)) (=> (not (= ?v0 f44)) (=> (not (= ?v1 f44)) (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 f22 ?v0) (f4 f22 ?v1)) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (= ?v0 ?v1))))))
(assert (forall ((?v0 S9)) (=> (= (f24 f48 ?v0) f44) (= ?v0 f44))))
(assert (forall ((?v0 S2)) (=> (= (f4 f22 ?v0) f21) (= ?v0 f21))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f44)) (= (f24 f48 (f24 f48 ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 f22 (f4 f22 ?v0)) ?v0))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f44)) (not (= (f24 f48 ?v0) f44)))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (not (= (f4 f22 ?v0) f21)))))
(assert (forall ((?v0 S9)) (= (= (f24 f48 ?v0) f44) (= ?v0 f44))))
(assert (forall ((?v0 S2)) (= (= (f4 f22 ?v0) f21) (= ?v0 f21))))
(assert (= (f24 f48 f44) f44))
(assert (= (f4 f22 f21) f21))
(assert (= (f24 f48 f43) f43))
(assert (= (f4 f22 f20) f20))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 ?v_0 (f14 f15 (* 2 (f16 f17 ?v1)))) (f35 (f36 f38 (f35 ?v_0 ?v1)) (f14 f15 2))))))
(assert (forall ((?v0 S9) (?v1 S6)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f14 f15 (* 2 (f16 f17 ?v1)))) (f40 (f41 f42 (f40 ?v_0 ?v1)) (f14 f15 2))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f14 f15 (* 2 (f16 f17 ?v1)))) (f8 (f9 f10 (f8 ?v_0 ?v1)) (f14 f15 2))))))
(assert (forall ((?v0 Int)) (<= 0 (f28 (f29 f30 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f23 f21 (f4 (f5 f6 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (f28 (f29 f30 ?v0) ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f23 f21 (f4 (f5 f6 ?v0) ?v1)) f1) (or (and (= (f23 f21 ?v0) f1) (= (f23 f21 ?v1) f1)) (and (= (f23 ?v0 f21) f1) (= (f23 ?v1 f21) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f28 (f29 f30 ?v0) ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f23 (f4 (f5 f6 ?v0) ?v1) f21) f1) (or (and (= (f23 f21 ?v0) f1) (= (f23 ?v1 f21) f1)) (and (= (f23 ?v0 f21) f1) (= (f23 f21 ?v1) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 f21 ?v0) f1) (= (f4 (f5 f6 (f4 f39 ?v1)) ?v0) (f4 f39 (f4 (f5 f6 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f28 (f29 f30 (f28 f47 ?v1)) ?v0) (f28 f47 (f28 (f29 f30 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f28 (f29 f30 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 f21 ?v1) f1) (= (f23 f21 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f28 (f29 f30 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 ?v1 f21) f1) (= (f23 (f4 (f5 f6 ?v0) ?v1) f21) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f28 (f29 f30 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 ?v1 f21) f1) (= (f23 (f4 (f5 f6 ?v1) ?v0) f21) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f28 (f29 f30 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 f21) f1) (=> (= (f23 f21 ?v1) f1) (= (f23 (f4 (f5 f6 ?v0) ?v1) f21) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f28 (f29 f30 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 f21) f1) (=> (= (f23 ?v1 f21) f1) (= (f23 f21 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f28 (f29 f30 ?v0) ?v2) (f28 (f29 f30 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f30 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f28 ?v_0 ?v0) (f28 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v2))) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f30 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f28 ?v_0 ?v0) (f28 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v2))) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f28 (f29 f30 ?v1) ?v2) (f28 (f29 f30 ?v0) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v2 f21) f1) (= (f23 (f4 (f5 f6 ?v1) ?v2) (f4 (f5 f6 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f30 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f28 ?v_0 ?v1) (f28 ?v_0 ?v0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v2))) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v2 f21) f1) (= (f23 (f4 ?v_0 ?v1) (f4 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f28 (f29 f30 ?v0) ?v2) (f28 (f29 f30 ?v1) ?v3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v2 ?v3) f1) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f28 (f29 f30 ?v0) ?v2) (f28 (f29 f30 ?v1) ?v3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v2 ?v3) f1) (=> (= (f23 f21 ?v1) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f28 (f29 f30 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (or (and (= (f23 f21 ?v0) f1) (= (f23 f21 ?v1) f1)) (and (= (f23 ?v0 f21) f1) (= (f23 ?v1 f21) f1))) (= (f23 f21 (f4 (f5 f6 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (or (= (f23 f21 ?v0) f1) (= (f23 ?v0 f21) f1)) (or (= (f23 f21 ?v1) f1) (= (f23 ?v1 f21) f1))) (= (f4 f39 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f39 ?v0)) (f4 f39 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f28 f47 (f28 (f29 f30 ?v0) ?v1)) (f28 (f29 f30 (f28 f47 ?v0)) (f28 f47 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f28 (f29 f30 ?v0) ?v1) 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (or (and (= (f23 f21 ?v0) f1) (= (f23 ?v1 f21) f1)) (and (= (f23 ?v0 f21) f1) (= (f23 f21 ?v1) f1))) (= (f23 (f4 (f5 f6 ?v0) ?v1) f21) f1))))
(assert (forall ((?v0 Int)) (not (< (f28 (f29 f30 ?v0) ?v0) 0))))
(assert (forall ((?v0 S2)) (not (= (f3 (f4 (f5 f6 ?v0) ?v0) f21) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f28 (f29 f30 ?v0) ?v1) (f28 (f29 f30 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v1)) f1) (or (and (= (f3 f21 ?v1) f1) (= (f3 ?v0 ?v2) f1)) (and (= (f3 ?v1 f21) f1) (= (f3 ?v2 ?v0) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (= (f3 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1) (or (and (= (f3 f21 ?v0) f1) (= (f3 ?v1 ?v2) f1)) (and (= (f3 ?v0 f21) f1) (= (f3 ?v2 ?v1) f1)))))))
(assert (forall ((?v0 S6)) (= (f14 f15 (f16 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f17 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
