(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S4) Int)
(declare-fun f4 () S3)
(declare-fun f5 (S5 S6) S4)
(declare-fun f6 (S7 S2) S5)
(declare-fun f7 () S7)
(declare-fun f8 () S6)
(declare-fun f9 () S4)
(declare-fun f10 () S6)
(declare-fun f11 () S5)
(declare-fun f12 (S8 S6) S6)
(declare-fun f13 (S9 S6) S8)
(declare-fun f14 () S9)
(declare-fun f15 (S10 Int) S4)
(declare-fun f16 () S10)
(declare-fun f17 (S11 S4) S6)
(declare-fun f18 (S12 S6) S11)
(declare-fun f19 () S12)
(declare-fun f20 (S13 S2) S8)
(declare-fun f21 () S13)
(declare-fun f22 () S2)
(declare-fun f23 () S6)
(declare-fun f24 (S14 S2) S2)
(declare-fun f25 () S14)
(declare-fun f26 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (<= (f3 f4 (f5 (f6 f7 ?v0) f8)) (f3 f4 f9))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f10)) (=> (not (= ?v1 f10)) (= (f5 f11 (f12 (f13 f14 ?v0) ?v1)) (f15 f16 (+ (f3 f4 (f5 f11 ?v0)) (f3 f4 (f5 f11 ?v1)))))))))
(assert (= (f5 f11 f10) (f15 f16 0)))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f5 f11 (f17 (f18 f19 (f12 (f20 f21 ?v0) (f12 (f20 f21 f22) f10))) ?v1)) ?v1)))
(assert (let ((?v_1 (f15 f16 0)) (?v_2 (f5 f11 f23)) (?v_0 (f5 (f6 f7 f26) f8))) (not (=> (not (= ?v_2 ?v_1)) (=> (not (= f23 f10)) (=> (= (f5 f11 f8) f9) (=> (= f8 (f12 (f13 f14 (f17 (f18 f19 (f12 (f20 f21 (f24 f25 f26)) (f12 (f20 f21 f22) f10))) ?v_0)) f23)) (=> (not (= ?v_0 ?v_1)) (< (f3 f4 ?v_2) (f3 f4 f9))))))))))
(assert (forall ((?v0 S4)) (= (f15 f16 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
