(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S2)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S6) S2)
(declare-fun f8 (S7 S2) S5)
(declare-fun f9 () S7)
(declare-fun f10 (S8 S9) S3)
(declare-fun f11 () S8)
(declare-fun f12 (S9) S9)
(declare-fun f13 () S9)
(declare-fun f14 () S9)
(declare-fun f15 () S2)
(declare-fun f16 (S10 Int) S6)
(declare-fun f17 () S10)
(declare-fun f18 (S11 S6) Int)
(declare-fun f19 () S11)
(declare-fun f20 (S12 S2) S6)
(declare-fun f21 (S13 S9) S12)
(declare-fun f22 () S13)
(declare-fun f23 () S2)
(declare-fun f24 () S2)
(assert (not (= f1 f2)))
(assert (not (= f3 (f4 (f5 f6 (f7 (f8 f9 (f4 (f10 f11 (f12 f13)) (f4 (f10 f11 f14) f15))) (f16 f17 (+ (f18 f19 (f20 (f21 f22 f13) f3)) 1)))) f23))))
(assert (= f3 (f4 (f5 f6 (f7 (f8 f9 (f4 (f10 f11 (f12 f13)) (f4 (f10 f11 f14) f15))) (f20 (f21 f22 f13) f3))) f24)))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f16 f17 (+ (f18 f19 ?v1) 1))) (f4 (f5 f6 (f7 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 S6)) (= (f16 f17 (f18 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f18 f19 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f18 f19 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
