(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-sort S25 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 () S5)
(declare-fun f6 (S6 S7) S4)
(declare-fun f7 () S6)
(declare-fun f8 () S7)
(declare-fun f9 () S3)
(declare-fun f10 (S8 S3) S7)
(declare-fun f11 (S9 S7) S8)
(declare-fun f12 () S9)
(declare-fun f13 (S10 S7) S7)
(declare-fun f14 () S10)
(declare-fun f15 (S11 S4) S4)
(declare-fun f16 () S11)
(declare-fun f17 (S12 Int) S3)
(declare-fun f18 () S12)
(declare-fun f19 () S10)
(declare-fun f20 (S13 Int) Int)
(declare-fun f21 () S13)
(declare-fun f22 (S14 S3) Int)
(declare-fun f23 (S15 Int) S14)
(declare-fun f24 () S15)
(declare-fun f25 (S16 S3) S3)
(declare-fun f26 (S17 S3) S16)
(declare-fun f27 () S17)
(declare-fun f28 () S10)
(declare-fun f29 (S18 S4) S7)
(declare-fun f30 () S18)
(declare-fun f31 () S11)
(declare-fun f32 (S4 S19) S1)
(declare-fun f33 () S19)
(declare-fun f34 (Int S20) S1)
(declare-fun f35 () S20)
(declare-fun f36 (S7 S21) S1)
(declare-fun f37 () S21)
(declare-fun f38 () S19)
(declare-fun f39 () S21)
(declare-fun f40 (S19 S4) S1)
(declare-fun f41 (S7 S7) S1)
(declare-fun f42 (S11) S1)
(declare-fun f43 (S22 S4) S11)
(declare-fun f44 () S22)
(declare-fun f45 (S23 Int) S16)
(declare-fun f46 () S23)
(declare-fun f47 () S14)
(declare-fun f48 () S7)
(declare-fun f49 () S4)
(declare-fun f50 () S7)
(declare-fun f51 () S4)
(declare-fun f52 (S24 Int) S13)
(declare-fun f53 () S24)
(declare-fun f54 (S25 S7) S10)
(declare-fun f55 () S25)
(declare-fun f56 (S3 S3) S1)
(declare-fun f57 () S3)
(declare-fun f58 () S3)
(declare-fun f59 () S17)
(declare-fun f60 () S11)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f6 f7 f8)) f9) (f6 f7 (f10 (f11 f12 f8) f9)))))
(assert (forall ((?v0 S7) (?v1 S3)) (= (f6 f7 (f10 (f11 f12 ?v0) ?v1)) (f3 (f4 f5 (f6 f7 ?v0)) ?v1))))
(assert (forall ((?v0 S7) (?v1 S3)) (= (f13 f14 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 (f13 f14 ?v0)) ?v1))))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 (f15 f16 ?v0)) (f17 f18 2)) ?v0)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f6 f7 ?v0) (f6 f7 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S3)) (= (f13 f19 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 (f13 f19 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f20 f21 (f22 (f23 f24 ?v0) ?v1)) (f22 (f23 f24 (f20 f21 ?v0)) ?v1))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f10 (f11 f12 ?v0) (f17 f18 2)))) (= (f13 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f22 (f23 f24 ?v0) (f17 f18 2)))) (= (f20 f21 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f10 (f11 f12 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f10 (f11 f12 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S7)) (let ((?v_0 (f17 f18 2))) (= (f10 (f11 f12 (f13 f19 ?v0)) ?v_0) (f10 (f11 f12 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 2))) (= (f22 (f23 f24 (f20 f21 ?v0)) ?v_0) (f22 (f23 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 S7) (?v1 S3)) (= (f13 f28 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 (f13 f28 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S3)) (= (f29 f30 (f3 (f4 f5 ?v0) ?v1)) (f10 (f11 f12 (f29 f30 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S3)) (= (f15 f31 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f15 f31 ?v0)) ?v1))))
(assert (forall ((?v0 S7)) (= (f32 (f6 f7 ?v0) f33) f1)))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (= (f34 ?v0 f35) f1) (= (f34 (f22 (f23 f24 ?v0) ?v1) f35) f1))))
(assert (forall ((?v0 S7) (?v1 S3)) (=> (= (f36 ?v0 f37) f1) (= (f36 (f10 (f11 f12 ?v0) ?v1) f37) f1))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (= (f32 ?v0 f38) f1) (= (f32 (f3 (f4 f5 ?v0) ?v1) f38) f1))))
(assert (forall ((?v0 S4)) (= (f15 f31 (f15 f31 ?v0)) ?v0)))
(assert (forall ((?v0 S7)) (let ((?v_0 (f13 f28 ?v0))) (= (f13 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f29 f30 ?v0))) (= (f13 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (= (f29 f30 (f15 f31 ?v0)) (f29 f30 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f15 f31 ?v0) (f15 f31 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S7)) (= (f29 f30 (f6 f7 ?v0)) (f13 f19 ?v0))))
(assert (forall ((?v0 S7)) (= (f13 f28 (f13 f14 ?v0)) (f13 f19 ?v0))))
(assert (forall ((?v0 S7) (?v1 S3)) (=> (= (f36 ?v0 f39) f1) (= (f36 (f10 (f11 f12 ?v0) ?v1) f39) f1))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (= (f32 ?v0 f33) f1) (= (f32 (f3 (f4 f5 ?v0) ?v1) f33) f1))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f6 f7 ?v0))) (= (f15 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (=> (= (f32 ?v0 f33) f1) (=> (forall ((?v1 S7)) (=> (= ?v0 (f6 f7 ?v1)) false)) false))))
(assert (forall ((?v0 S4) (?v1 S19)) (=> (= (f32 ?v0 f33) f1) (=> (forall ((?v2 S7)) (= (f40 ?v1 (f6 f7 ?v2)) f1)) (= (f40 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S7) (?v1 S3)) (= (f41 (f13 f28 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 (f13 f28 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 S4) (?v1 S3)) (= (f41 (f29 f30 (f3 (f4 f5 ?v0) ?v1)) (f10 (f11 f12 (f29 f30 ?v0)) ?v1)) f1)))
(assert (= (f42 f31) f1))
(assert (forall ((?v0 S4)) (= (f29 f30 (f15 (f43 f44 ?v0) (f15 f31 ?v0))) (f10 (f11 f12 (f29 f30 ?v0)) (f17 f18 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f25 (f45 f46 ?v0) ?v1) (f17 f18 (+ (f22 f47 (f17 f18 ?v0)) (f22 f47 ?v1))))))
(assert (= (f36 f48 f37) f1))
(assert (= (f32 f49 f38) f1))
(assert (= (f34 0 f35) f1))
(assert (= (f36 f48 f39) f1))
(assert (= (f32 f49 f33) f1))
(assert (= (f36 f50 f37) f1))
(assert (= (f32 f51 f38) f1))
(assert (= (f34 1 f35) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f34 ?v0 f35) f1) (=> (= (f34 ?v1 f35) f1) (= (f34 (f20 (f52 f53 ?v0) ?v1) f35) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f36 ?v0 f37) f1) (=> (= (f36 ?v1 f37) f1) (= (f36 (f13 (f54 f55 ?v0) ?v1) f37) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f32 ?v0 f38) f1) (=> (= (f32 ?v1 f38) f1) (= (f32 (f15 (f43 f44 ?v0) ?v1) f38) f1)))))
(assert (= (f36 f50 f39) f1))
(assert (= (f32 f51 f33) f1))
(assert (forall ((?v0 S7) (?v1 S3)) (= (f41 f48 (f10 (f11 f12 ?v0) (f17 f18 (* 2 (f22 f47 ?v1))))) f1)))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f22 (f23 f24 ?v0) (f17 f18 (* 2 (f22 f47 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f41 (f13 f28 (f13 (f54 f55 ?v0) ?v1)) (f13 (f54 f55 (f13 f28 ?v0)) (f13 f28 ?v1))) f1)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f41 (f29 f30 (f15 (f43 f44 ?v0) ?v1)) (f13 (f54 f55 (f29 f30 ?v0)) (f29 f30 ?v1))) f1)))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 f48) ?v0) f48)))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 f49) ?v0) f49)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 f48) ?v0) f48)))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 f49) ?v0) f49)))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 f48) ?v0) f48)))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 f49) ?v0) f49)))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 f50) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 f51) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 ?v0) f48) f48)))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 ?v0) f49) f49)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 ?v0) f48) f48)))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 ?v0) f49) f49)))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 ?v0) f48) f48)))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 ?v0) f49) f49)))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 ?v0) f50) ?v0)))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 ?v0) f51) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 (f52 f53 ?v0) ?v1) (f20 (f52 f53 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f13 (f54 f55 ?v0) ?v1) (f13 (f54 f55 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f15 (f43 f44 ?v0) ?v1) (f15 (f43 f44 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f52 f53 ?v0)) (?v_0 (f52 f53 ?v1))) (= (f20 ?v_1 (f20 ?v_0 ?v2)) (f20 ?v_0 (f20 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f54 f55 ?v0)) (?v_0 (f54 f55 ?v1))) (= (f13 ?v_1 (f13 ?v_0 ?v2)) (f13 ?v_0 (f13 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f43 f44 ?v0)) (?v_0 (f43 f44 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f52 f53 ?v0))) (= (f20 ?v_0 (f20 (f52 f53 ?v1) ?v2)) (f20 (f52 f53 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f54 f55 ?v0))) (= (f13 ?v_0 (f13 (f54 f55 ?v1) ?v2)) (f13 (f54 f55 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f43 f44 ?v0))) (= (f15 ?v_0 (f15 (f43 f44 ?v1) ?v2)) (f15 (f43 f44 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7)) (= (= (f41 (f13 f28 ?v0) f48) f1) (= ?v0 f48))))
(assert (forall ((?v0 S4)) (= (= (f41 (f29 f30 ?v0) f48) f1) (= ?v0 f49))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f52 f53 ?v0))) (= (f20 (f52 f53 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f52 f53 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f54 f55 ?v0))) (= (f13 (f54 f55 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f13 (f54 f55 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f43 f44 ?v0))) (= (f15 (f43 f44 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f43 f44 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f52 f53 ?v0))) (= (f20 (f52 f53 (f20 ?v_0 ?v1)) ?v2) (f20 (f52 f53 (f20 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f54 f55 ?v0))) (= (f13 (f54 f55 (f13 ?v_0 ?v1)) ?v2) (f13 (f54 f55 (f13 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f43 f44 ?v0))) (= (f15 (f43 f44 (f15 ?v_0 ?v1)) ?v2) (f15 (f43 f44 (f15 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f52 f53 ?v0)) (?v_1 (f20 (f52 f53 ?v2) ?v3))) (= (f20 (f52 f53 (f20 ?v_0 ?v1)) ?v_1) (f20 ?v_0 (f20 (f52 f53 ?v1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f54 f55 ?v0)) (?v_1 (f13 (f54 f55 ?v2) ?v3))) (= (f13 (f54 f55 (f13 ?v_0 ?v1)) ?v_1) (f13 ?v_0 (f13 (f54 f55 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f43 f44 ?v0)) (?v_1 (f15 (f43 f44 ?v2) ?v3))) (= (f15 (f43 f44 (f15 ?v_0 ?v1)) ?v_1) (f15 ?v_0 (f15 (f43 f44 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f52 f53 (f20 (f52 f53 ?v0) ?v1))) (?v_0 (f52 f53 ?v2))) (= (f20 ?v_1 (f20 ?v_0 ?v3)) (f20 ?v_0 (f20 ?v_1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_1 (f54 f55 (f13 (f54 f55 ?v0) ?v1))) (?v_0 (f54 f55 ?v2))) (= (f13 ?v_1 (f13 ?v_0 ?v3)) (f13 ?v_0 (f13 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f43 f44 (f15 (f43 f44 ?v0) ?v1))) (?v_0 (f43 f44 ?v2))) (= (f15 ?v_1 (f15 ?v_0 ?v3)) (f15 ?v_0 (f15 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f52 f53 ?v0))) (= (f20 (f52 f53 (f20 ?v_0 ?v1)) (f20 (f52 f53 ?v2) ?v3)) (f20 (f52 f53 (f20 ?v_0 ?v2)) (f20 (f52 f53 ?v1) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f54 f55 ?v0))) (= (f13 (f54 f55 (f13 ?v_0 ?v1)) (f13 (f54 f55 ?v2) ?v3)) (f13 (f54 f55 (f13 ?v_0 ?v2)) (f13 (f54 f55 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f43 f44 ?v0))) (= (f15 (f43 f44 (f15 ?v_0 ?v1)) (f15 (f43 f44 ?v2) ?v3)) (f15 (f43 f44 (f15 ?v_0 ?v2)) (f15 (f43 f44 ?v1) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S3)) (=> (= (f41 f48 (f10 (f11 f12 ?v0) (f17 f18 (+ (* 2 (f22 f47 ?v1)) 1)))) f1) (= (f41 f48 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 (f22 (f23 f24 ?v0) (f17 f18 (+ (* 2 (f22 f47 ?v1)) 1)))) (<= 0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S7)) (let ((?v_0 (f11 f12 ?v2))) (=> (<= (f22 f47 ?v0) (f22 f47 ?v1)) (=> (= (f41 f48 ?v2) f1) (=> (= (f41 ?v2 f50) f1) (= (f41 (f10 ?v_0 ?v1) (f10 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f23 f24 ?v2))) (=> (<= (f22 f47 ?v0) (f22 f47 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f22 ?v_0 ?v1) (f22 ?v_0 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f27 ?v2))) (=> (<= (f22 f47 ?v0) (f22 f47 ?v1)) (=> (= (f56 f57 ?v2) f1) (=> (= (f56 ?v2 f58) f1) (= (f56 (f25 ?v_0 ?v1) (f25 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f17 f18 (* 2 (f22 f47 ?v1)))) (f20 (f52 f53 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (let ((?v_1 (f25 ?v_0 ?v1))) (= (f25 ?v_0 (f17 f18 (* 2 (f22 f47 ?v1)))) (f25 (f26 f59 ?v_1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 (f17 f18 (* 2 (f22 f47 ?v1)))) (f13 (f54 f55 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f17 f18 (* 2 (f22 f47 ?v1)))) (f15 (f43 f44 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f17 f18 (+ (* 2 (f22 f47 ?v1)) 1))) (f20 (f52 f53 ?v0) (f20 (f52 f53 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (let ((?v_1 (f25 ?v_0 ?v1))) (= (f25 ?v_0 (f17 f18 (+ (* 2 (f22 f47 ?v1)) 1))) (f25 (f26 f59 ?v0) (f25 (f26 f59 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 (f17 f18 (+ (* 2 (f22 f47 ?v1)) 1))) (f13 (f54 f55 ?v0) (f13 (f54 f55 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f17 f18 (+ (* 2 (f22 f47 ?v1)) 1))) (f15 (f43 f44 ?v0) (f15 (f43 f44 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f17 f18 (+ (* 2 (f22 f47 ?v1)) 1))) (f20 (f52 f53 ?v0) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f17 f18 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f17 f18 (+ (* 2 (f22 f47 ?v1)) 1))) (f25 (f26 f59 ?v0) (f25 (f26 f27 (f25 ?v_0 ?v1)) (f17 f18 2)))))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f17 f18 (+ (* 2 (f22 f47 ?v1)) 1))) (f13 (f54 f55 ?v0) (f10 (f11 f12 (f10 ?v_0 ?v1)) (f17 f18 2)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (* 2 (f22 f47 ?v1)) 1))) (f15 (f43 f44 ?v0) (f3 (f4 f5 (f3 ?v_0 ?v1)) (f17 f18 2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S7)) (let ((?v_0 (f11 f12 ?v2))) (=> (<= (f22 f47 ?v0) (f22 f47 ?v1)) (=> (= (f41 f50 ?v2) f1) (= (f41 (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f23 f24 ?v2))) (=> (<= (f22 f47 ?v0) (f22 f47 ?v1)) (=> (<= 1 ?v2) (<= (f22 ?v_0 ?v0) (f22 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f27 ?v2))) (=> (<= (f22 f47 ?v0) (f22 f47 ?v1)) (=> (= (f56 f58 ?v2) f1) (= (f56 (f25 ?v_0 ?v0) (f25 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S7) (?v1 S3)) (=> (= (f41 f50 ?v0) f1) (= (f41 f50 (f10 (f11 f12 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 1 ?v0) (<= 1 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f56 f58 ?v0) f1) (= (f56 f58 (f25 (f26 f27 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f17 f18 2))) (=> (= (f10 (f11 f12 ?v0) ?v_0) (f10 (f11 f12 ?v1) ?v_0)) (=> (= (f41 f48 ?v0) f1) (=> (= (f41 f48 ?v1) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (=> (= (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 2))) (=> (= (f25 (f26 f27 ?v0) ?v_0) (f25 (f26 f27 ?v1) ?v_0)) (=> (= (f56 f57 ?v0) f1) (=> (= (f56 f57 ?v1) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f17 f18 2))) (=> (= (f41 (f10 (f11 f12 ?v0) ?v_0) (f10 (f11 f12 ?v1) ?v_0)) f1) (=> (= (f41 f48 ?v1) f1) (= (f41 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (=> (<= (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 2))) (=> (= (f56 (f25 (f26 f27 ?v0) ?v_0) (f25 (f26 f27 ?v1) ?v_0)) f1) (=> (= (f56 f57 ?v1) f1) (= (f56 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S7)) (let ((?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))) (=> (= (f10 (f11 f12 ?v0) ?v_0) (f10 (f11 f12 ?v2) ?v_0)) (=> (= (f41 f48 ?v0) f1) (=> (= (f41 f48 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (let ((?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))) (=> (= (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))) (=> (= (f25 (f26 f27 ?v0) ?v_0) (f25 (f26 f27 ?v2) ?v_0)) (=> (= (f56 f57 ?v0) f1) (=> (= (f56 f57 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S7)) (let ((?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))) (=> (= (f41 (f10 (f11 f12 ?v0) ?v_0) (f10 (f11 f12 ?v2) ?v_0)) f1) (=> (= (f41 f48 ?v2) f1) (= (f41 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (let ((?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))) (=> (<= (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))) (=> (= (f56 (f25 (f26 f27 ?v0) ?v_0) (f25 (f26 f27 ?v2) ?v_0)) f1) (=> (= (f56 f57 ?v2) f1) (= (f56 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S7)) (=> (= (f10 (f11 f12 ?v0) ?v1) (f10 (f11 f12 ?v2) ?v1)) (=> (= (f41 f48 ?v0) f1) (=> (= (f41 f48 ?v2) f1) (=> (< 0 (f22 f47 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f22 (f23 f24 ?v0) ?v1) (f22 (f23 f24 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f22 f47 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f25 (f26 f27 ?v0) ?v1) (f25 (f26 f27 ?v2) ?v1)) (=> (= (f56 f57 ?v0) f1) (=> (= (f56 f57 ?v2) f1) (=> (< 0 (f22 f47 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S3)) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 f48 ?v0) f1) (= (f41 (f10 (f11 f12 ?v0) ?v2) (f10 (f11 f12 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f22 (f23 f24 ?v0) ?v2) (f22 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f56 ?v0 ?v1) f1) (=> (= (f56 f57 ?v0) f1) (= (f56 (f25 (f26 f27 ?v0) ?v2) (f25 (f26 f27 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S7) (?v1 S3)) (=> (= (f41 f48 ?v0) f1) (= (f41 f48 (f10 (f11 f12 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f56 f57 ?v0) f1) (= (f56 f57 (f25 (f26 f27 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S7) (?v1 S3)) (= (f41 f48 (f10 (f11 f12 (f13 f19 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f22 (f23 f24 (f20 f21 ?v0)) ?v1))))
(assert (forall ((?v0 S7)) (= (f41 f48 (f10 (f11 f12 ?v0) (f17 f18 2))) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f22 (f23 f24 ?v0) (f17 f18 2)))))
(assert (forall ((?v0 S3)) (= (f10 (f11 f12 f48) ?v0) (ite (= ?v0 (f17 f18 0)) f50 f48))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f49) ?v0) (ite (= ?v0 (f17 f18 0)) f51 f49))))
(assert (forall ((?v0 S3)) (= (f22 (f23 f24 0) ?v0) (ite (= ?v0 (f17 f18 0)) 1 0))))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 f57) ?v0) (ite (= ?v0 (f17 f18 0)) f58 f57))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f13 f28 (f13 (f54 f55 ?v0) ?v1)) (f13 (f54 f55 (f13 f28 ?v0)) (f13 f28 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f29 f30 (f15 (f43 f44 ?v0) ?v1)) (f13 (f54 f55 (f29 f30 ?v0)) (f29 f30 ?v1)))))
(assert (= (f13 f28 f50) f50))
(assert (= (f29 f30 f51) f50))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f6 f7 (f13 (f54 f55 ?v0) ?v1)) (f15 (f43 f44 (f6 f7 ?v0)) (f6 f7 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f13 f14 (f13 (f54 f55 ?v0) ?v1)) (f13 (f54 f55 (f13 f14 ?v0)) (f13 f14 ?v1)))))
(assert (forall ((?v0 S7)) (= (f41 f48 (f13 f28 ?v0)) f1)))
(assert (forall ((?v0 S4)) (= (f41 f48 (f29 f30 ?v0)) f1)))
(assert (= (f6 f7 f50) f51))
(assert (= (f13 f14 f50) f50))
(assert (forall ((?v0 S7)) (= (= (f13 f28 ?v0) f48) (= ?v0 f48))))
(assert (forall ((?v0 S4)) (= (= (f29 f30 ?v0) f48) (= ?v0 f49))))
(assert (= (f13 f28 f48) f48))
(assert (= (f29 f30 f49) f48))
(assert (forall ((?v0 S7)) (= (= (f6 f7 ?v0) f49) (= ?v0 f48))))
(assert (forall ((?v0 S7)) (= (= (f13 f14 ?v0) f48) (= ?v0 f48))))
(assert (= (f6 f7 f48) f49))
(assert (= (f13 f14 f48) f48))
(assert (= (f6 f7 f48) f49))
(assert (= (f13 f14 f48) f48))
(assert (forall ((?v0 Int)) (= (f20 (f52 f53 ?v0) ?v0) (f22 (f23 f24 ?v0) (f17 f18 2)))))
(assert (forall ((?v0 S3)) (= (f25 (f26 f59 ?v0) ?v0) (f25 (f26 f27 ?v0) (f17 f18 2)))))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 ?v0) ?v0) (f10 (f11 f12 ?v0) (f17 f18 2)))))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 ?v0) ?v0) (f3 (f4 f5 ?v0) (f17 f18 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f20 (f52 f53 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f25 (f26 f59 ?v0) (f25 ?v_0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f13 (f54 f55 ?v0) (f10 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f15 (f43 f44 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f20 (f52 f53 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f25 (f26 f59 ?v0) (f25 ?v_0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f13 (f54 f55 ?v0) (f10 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f15 (f43 f44 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f20 (f52 f53 (f22 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f25 (f26 f59 (f25 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f13 (f54 f55 (f10 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1))) (f15 (f43 f44 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f17 f18 2)) (f20 (f52 f53 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 ?v0) (f17 f18 2)) (f25 (f26 f59 ?v0) ?v0))))
(assert (forall ((?v0 S7)) (= (f10 (f11 f12 ?v0) (f17 f18 2)) (f13 (f54 f55 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f17 f18 2)) (f15 (f43 f44 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f17 f18 3)) (f20 (f52 f53 (f20 (f52 f53 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 ?v0) (f17 f18 3)) (f25 (f26 f59 (f25 (f26 f59 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S7)) (= (f10 (f11 f12 ?v0) (f17 f18 3)) (f13 (f54 f55 (f13 (f54 f55 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f17 f18 3)) (f15 (f43 f44 (f15 (f43 f44 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f20 (f52 f53 ?v0) (f22 ?v_0 ?v1)) (f22 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f59 ?v0) (f25 ?v_0 ?v1)) (f25 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f13 (f54 f55 ?v0) (f10 ?v_0 ?v1)) (f10 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f15 (f43 f44 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f17 f18 (+ (f22 f47 ?v1) (f22 f47 ?v2)))) (f20 (f52 f53 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f17 f18 (+ (f22 f47 ?v1) (f22 f47 ?v2)))) (f25 (f26 f59 (f25 ?v_0 ?v1)) (f25 ?v_0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f17 f18 (+ (f22 f47 ?v1) (f22 f47 ?v2)))) (f13 (f54 f55 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (f22 f47 ?v1) (f22 f47 ?v2)))) (f15 (f43 f44 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f20 (f52 f53 (f22 ?v_0 ?v1)) ?v0) (f22 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f59 (f25 ?v_0 ?v1)) ?v0) (f25 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f13 (f54 f55 (f10 ?v_0 ?v1)) ?v0) (f10 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f15 (f43 f44 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f17 f18 (+ (f22 f47 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f22 (f23 f24 ?v0) ?v1))) (= (f20 (f52 f53 ?v_0) ?v0) (f20 (f52 f53 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f25 (f26 f27 ?v0) ?v1))) (= (f25 (f26 f59 ?v_0) ?v0) (f25 (f26 f59 ?v0) ?v_0)))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f10 (f11 f12 ?v0) ?v1))) (= (f13 (f54 f55 ?v_0) ?v0) (f13 (f54 f55 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f15 (f43 f44 ?v_0) ?v0) (f15 (f43 f44 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f22 (f23 f24 (f20 (f52 f53 ?v0) ?v1)) ?v2) (f20 (f52 f53 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f25 (f26 f27 (f25 (f26 f59 ?v0) ?v1)) ?v2) (f25 (f26 f59 (f25 (f26 f27 ?v0) ?v2)) (f25 (f26 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S3)) (= (f10 (f11 f12 (f13 (f54 f55 ?v0) ?v1)) ?v2) (f13 (f54 f55 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S3)) (= (f3 (f4 f5 (f15 (f43 f44 ?v0) ?v1)) ?v2) (f15 (f43 f44 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f22 (f23 f24 (f20 (f52 f53 ?v0) ?v1)) ?v2) (f20 (f52 f53 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f25 (f26 f27 (f25 (f26 f59 ?v0) ?v1)) ?v2) (f25 (f26 f59 (f25 (f26 f27 ?v0) ?v2)) (f25 (f26 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S3)) (= (f10 (f11 f12 (f13 (f54 f55 ?v0) ?v1)) ?v2) (f13 (f54 f55 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S3)) (= (f3 (f4 f5 (f15 (f43 f44 ?v0) ?v1)) ?v2) (f15 (f43 f44 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f20 (f52 f53 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2)) (f22 ?v_0 (f17 f18 (+ (f22 f47 ?v1) (f22 f47 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f59 (f25 ?v_0 ?v1)) (f25 ?v_0 ?v2)) (f25 ?v_0 (f17 f18 (+ (f22 f47 ?v1) (f22 f47 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f13 (f54 f55 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) (f10 ?v_0 (f17 f18 (+ (f22 f47 ?v1) (f22 f47 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f15 (f43 f44 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f17 f18 (+ (f22 f47 ?v1) (f22 f47 ?v2))))))))
(assert (forall ((?v0 S3)) (= (f10 (f11 f12 f50) ?v0) f50)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f51) ?v0) f51)))
(assert (forall ((?v0 S3)) (= (f22 (f23 f24 1) ?v0) 1)))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 f58) ?v0) f58)))
(assert (= (f10 (f11 f12 f50) (f17 f18 2)) f50))
(assert (= (f3 (f4 f5 f51) (f17 f18 2)) f51))
(assert (= (f22 (f23 f24 1) (f17 f18 2)) 1))
(assert (= (f25 (f26 f27 f58) (f17 f18 2)) f58))
(assert (forall ((?v0 S7)) (= (f10 (f11 f12 ?v0) (f17 f18 0)) f50)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f17 f18 0)) f51)))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f17 f18 0)) 1)))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 ?v0) (f17 f18 0)) f58)))
(assert (forall ((?v0 S7)) (= (f10 (f11 f12 ?v0) (f17 f18 0)) f50)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f17 f18 0)) f51)))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f17 f18 0)) 1)))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 ?v0) (f17 f18 0)) f58)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f17 f18 (f20 (f52 f53 (f22 f47 ?v1)) (f22 f47 ?v2)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f17 f18 (f20 (f52 f53 (f22 f47 ?v1)) (f22 f47 ?v2)))) (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f17 f18 (f20 (f52 f53 (f22 f47 ?v1)) (f22 f47 ?v2)))) (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f17 f18 (f20 (f52 f53 (f22 f47 ?v1)) (f22 f47 ?v2)))) (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f17 f18 (* 2 (f22 f47 ?v1)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f17 f18 2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f17 f18 (* 2 (f22 f47 ?v1)))) (f25 (f26 f27 (f25 ?v_0 ?v1)) (f17 f18 2))))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f17 f18 (* 2 (f22 f47 ?v1)))) (f10 (f11 f12 (f10 ?v_0 ?v1)) (f17 f18 2))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f17 f18 (* 2 (f22 f47 ?v1)))) (f3 (f4 f5 (f3 ?v_0 ?v1)) (f17 f18 2))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f17 f18 (f20 (f52 f53 (f22 f47 ?v1)) (f22 f47 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f17 f18 (f20 (f52 f53 (f22 f47 ?v1)) (f22 f47 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f17 f18 (f20 (f52 f53 (f22 f47 ?v1)) (f22 f47 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f17 f18 (f20 (f52 f53 (f22 f47 ?v1)) (f22 f47 ?v2))))))))
(assert (forall ((?v0 S3)) (= (f10 (f11 f12 f48) (f17 f18 (+ (f22 f47 ?v0) 1))) f48)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f49) (f17 f18 (+ (f22 f47 ?v0) 1))) f49)))
(assert (forall ((?v0 S3)) (= (f22 (f23 f24 0) (f17 f18 (+ (f22 f47 ?v0) 1))) 0)))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 f57) (f17 f18 (+ (f22 f47 ?v0) 1))) f57)))
(assert (= (f10 (f11 f12 f48) (f17 f18 2)) f48))
(assert (= (f3 (f4 f5 f49) (f17 f18 2)) f49))
(assert (= (f22 (f23 f24 0) (f17 f18 2)) 0))
(assert (= (f25 (f26 f27 f57) (f17 f18 2)) f57))
(assert (forall ((?v0 S7) (?v1 S3)) (= (= (f10 (f11 f12 ?v0) ?v1) f48) (and (= ?v0 f48) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f49) (and (= ?v0 f49) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f22 (f23 f24 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f25 (f26 f27 ?v0) ?v1) f57) (and (= ?v0 f57) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S7)) (= (= (f10 (f11 f12 ?v0) (f17 f18 2)) f48) (= ?v0 f48))))
(assert (forall ((?v0 S4)) (= (= (f3 (f4 f5 ?v0) (f17 f18 2)) f49) (= ?v0 f49))))
(assert (forall ((?v0 Int)) (= (= (f22 (f23 f24 ?v0) (f17 f18 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S7) (?v1 S3)) (=> (not (= ?v0 f48)) (not (= (f10 (f11 f12 ?v0) ?v1) f48)))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (not (= ?v0 f49)) (not (= (f3 (f4 f5 ?v0) ?v1) f49)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (not (= ?v0 0)) (not (= (f22 (f23 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f15 f31 (f15 (f43 f44 ?v0) ?v1)) (f15 (f43 f44 (f15 f31 ?v0)) (f15 f31 ?v1)))))
(assert (= (f15 f31 f51) f51))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f36 ?v0 f39) f1) (=> (= (f36 ?v1 f39) f1) (= (f36 (f13 (f54 f55 ?v0) ?v1) f39) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f32 ?v0 f33) f1) (=> (= (f32 ?v1 f33) f1) (= (f32 (f15 (f43 f44 ?v0) ?v1) f33) f1)))))
(assert (forall ((?v0 S4)) (= (= (f15 f31 ?v0) f49) (= ?v0 f49))))
(assert (= (f15 f31 f49) f49))
(assert (forall ((?v0 S7) (?v1 S3)) (=> (= (f41 f48 ?v0) f1) (=> (= (f41 ?v0 f50) f1) (= (f41 (f10 (f11 f12 ?v0) (f17 f18 (+ (f22 f47 ?v1) 1))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (=> (<= ?v0 1) (<= (f22 (f23 f24 ?v0) (f17 f18 (+ (f22 f47 ?v1) 1))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f56 f57 ?v0) f1) (=> (= (f56 ?v0 f58) f1) (= (f56 (f25 (f26 f27 ?v0) (f17 f18 (+ (f22 f47 ?v1) 1))) ?v0) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f41 f48 ?v0) f1) (=> (= (f41 f48 ?v1) f1) (=> (= (f41 ?v1 f50) f1) (= (f41 (f13 (f54 f55 ?v1) ?v0) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f20 (f52 f53 ?v1) ?v0) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f41 f48 ?v0) f1) (=> (= (f41 f48 ?v1) f1) (=> (= (f41 ?v1 f50) f1) (= (f41 (f13 (f54 f55 ?v0) ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f20 (f52 f53 ?v0) ?v1) ?v0))))))
(assert (exists ((?v0 S7)) (and (= (f41 f48 ?v0) f1) (forall ((?v1 S4)) (= (f41 (f29 f30 (f15 f31 ?v1)) (f13 (f54 f55 (f29 f30 ?v1)) ?v0)) f1)))))
(assert (exists ((?v0 S7)) (forall ((?v1 S4)) (= (f41 (f29 f30 (f15 f31 ?v1)) (f13 (f54 f55 (f29 f30 ?v1)) ?v0)) f1))))
(assert (exists ((?v0 S7)) (and (= (f41 f48 ?v0) f1) (forall ((?v1 S7)) (= (f41 (f29 f30 (f6 f7 ?v1)) (f13 (f54 f55 (f13 f28 ?v1)) ?v0)) f1)))))
(assert (exists ((?v0 S7)) (and (= (f41 f48 ?v0) f1) (forall ((?v1 S7)) (= (f41 (f13 f28 (f13 f14 ?v1)) (f13 (f54 f55 (f13 f28 ?v1)) ?v0)) f1)))))
(assert (exists ((?v0 S7)) (forall ((?v1 S7)) (= (f41 (f29 f30 (f6 f7 ?v1)) (f13 (f54 f55 (f13 f28 ?v1)) ?v0)) f1))))
(assert (exists ((?v0 S7)) (forall ((?v1 S7)) (= (f41 (f13 f28 (f13 f14 ?v1)) (f13 (f54 f55 (f13 f28 ?v1)) ?v0)) f1))))
(assert (exists ((?v0 S7)) (forall ((?v1 S7) (?v2 S7)) (= (f41 (f13 f28 (f13 (f54 f55 ?v1) ?v2)) (f13 (f54 f55 (f13 (f54 f55 (f13 f28 ?v1)) (f13 f28 ?v2))) ?v0)) f1))))
(assert (exists ((?v0 S7)) (forall ((?v1 S4) (?v2 S4)) (= (f41 (f29 f30 (f15 (f43 f44 ?v1) ?v2)) (f13 (f54 f55 (f13 (f54 f55 (f29 f30 ?v1)) (f29 f30 ?v2))) ?v0)) f1))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (= (f41 (f13 f28 (f13 (f54 f55 ?v0) ?v2)) (f13 (f54 f55 (f13 f28 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S4)) (exists ((?v1 S7)) (forall ((?v2 S4)) (= (f41 (f29 f30 (f15 (f43 f44 ?v0) ?v2)) (f13 (f54 f55 (f29 f30 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S7)) (= (f13 f28 ?v0) (f13 f19 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 (f52 f53 ?v0) ?v1))) (= (f17 f18 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f17 f18 (f20 (f52 f53 (f22 f47 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)))) (f22 f47 (f17 f18 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 (f52 f53 (f22 f47 ?v0)) (f22 f47 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) (f17 f18 1) (f17 f18 (f20 (f52 f53 (f22 f47 ?v0)) (f22 f47 (f25 ?v_0 (f17 f18 (- (f22 f47 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 0)) (?v_2 (f22 f47 ?v0)) (?v_1 (f22 f47 ?v1))) (= (f17 f18 (f20 (f52 f53 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f17 f18 (+ ?v_1 (f20 (f52 f53 (f22 f47 (f17 f18 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f22 f47 ?v0))) (= (f17 f18 (* ?v_0 2)) (f17 f18 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 (f52 f53 (f22 f47 ?v0)) (f22 f47 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f22 f47 ?v0))) (= (f17 f18 (* 2 ?v_0)) (f17 f18 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f17 f18 (f20 (f52 f53 (f22 f47 ?v1)) (f22 f47 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f20 (f52 f53 ?v0) ?v1)) (f17 f18 (f20 (f52 f53 (f22 f47 (f17 f18 ?v0))) (f22 f47 (f17 f18 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f17 f18 (f20 (f52 f53 ?v0) ?v1)) (f17 f18 (f20 (f52 f53 (f22 f47 (f17 f18 (- ?v0)))) (f22 f47 (f17 f18 (- ?v1)))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f54 f55 ?v0))) (=> (not (= ?v0 f48)) (= (= (f13 ?v_0 ?v1) (f13 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f48)) (= (= (f13 (f54 f55 ?v1) ?v0) (f13 (f54 f55 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f54 f55 ?v0))) (= (f13 (f54 f55 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f13 (f54 f55 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f13 (f54 f55 ?v0) ?v1) (f13 (f54 f55 ?v1) ?v0))))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 f50) ?v0) ?v0)))
(assert (not (= f48 f50)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f13 f19 (f13 (f54 f55 ?v0) ?v1)) (f13 (f54 f55 (f13 f19 ?v0)) (f13 f19 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 f21 (f20 (f52 f53 ?v0) ?v1)) (f20 (f52 f53 (f20 f21 ?v0)) (f20 f21 ?v1)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f13 f19 ?v0))) (= (f13 (f54 f55 ?v_0) ?v_0) (f13 (f54 f55 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (f20 (f52 f53 ?v_0) ?v_0) (f20 (f52 f53 ?v0) ?v0)))))
(assert (= (f13 f19 f50) f50))
(assert (= (f20 f21 1) 1))
(assert (forall ((?v0 S7)) (= (f41 ?v0 ?v0) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f41 ?v0 ?v1) f1) (= (f41 ?v1 ?v0) f1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 ?v1 ?v2) f1) (= (f41 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 f48) ?v0) f48)))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 f49) ?v0) f49)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S7)) (= (f13 (f54 f55 ?v0) f48) f48)))
(assert (forall ((?v0 S4)) (= (f15 (f43 f44 ?v0) f49) f49)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f13 (f54 f55 ?v0) ?v1) f48) (or (= ?v0 f48) (= ?v1 f48)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f15 (f43 f44 ?v0) ?v1) f49) (or (= ?v0 f49) (= ?v1 f49)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 (f52 f53 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 f48)) (=> (not (= ?v1 f48)) (not (= (f13 (f54 f55 ?v0) ?v1) f48))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f49)) (=> (not (= ?v1 f49)) (not (= (f15 (f43 f44 ?v0) ?v1) f49))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f20 (f52 f53 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f13 (f54 f55 ?v0) ?v1) f48) (or (= ?v0 f48) (= ?v1 f48)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f15 (f43 f44 ?v0) ?v1) f49) (or (= ?v0 f49) (= ?v1 f49)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 (f52 f53 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (not (= f50 f48)))
(assert (not (= f51 f49)))
(assert (not (= 1 0)))
(assert (not (= f48 f50)))
(assert (not (= f49 f51)))
(assert (not (= 0 1)))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f22 f47 ?v0)) (?v_1 (f23 f24 ?v1))) (=> (< 0 ?v_0) (= (f20 (f52 f53 (f22 ?v_1 (f17 f18 (- ?v_0 1)))) ?v1) (f22 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f47 ?v0)) (?v_1 (f26 f27 ?v1))) (=> (< 0 ?v_0) (= (f25 (f26 f59 (f25 ?v_1 (f17 f18 (- ?v_0 1)))) ?v1) (f25 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S7)) (let ((?v_0 (f22 f47 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (f13 (f54 f55 (f10 ?v_1 (f17 f18 (- ?v_0 1)))) ?v1) (f10 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S4)) (let ((?v_0 (f22 f47 ?v0)) (?v_1 (f4 f5 ?v1))) (=> (< 0 ?v_0) (= (f15 (f43 f44 (f3 ?v_1 (f17 f18 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S7)) (= (f41 f48 (f13 (f54 f55 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f20 (f52 f53 ?v0) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f41 f48 (f13 (f54 f55 ?v0) ?v1)) f1) (or (and (= (f41 f48 ?v0) f1) (= (f41 f48 ?v1) f1)) (and (= (f41 ?v0 f48) f1) (= (f41 ?v1 f48) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (f20 (f52 f53 ?v0) ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f41 (f13 (f54 f55 ?v0) ?v1) f48) f1) (or (and (= (f41 f48 ?v0) f1) (= (f41 ?v1 f48) f1)) (and (= (f41 ?v0 f48) f1) (= (f41 f48 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f20 (f52 f53 ?v0) ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f41 f48 ?v0) f1) (= (f13 (f54 f55 (f13 f19 ?v1)) ?v0) (f13 f19 (f13 (f54 f55 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f20 (f52 f53 (f20 f21 ?v1)) ?v0) (f20 f21 (f20 (f52 f53 ?v1) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f41 f48 ?v0) f1) (=> (= (f41 f48 ?v1) f1) (= (f41 f48 (f13 (f54 f55 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f20 (f52 f53 ?v0) ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f41 f48 ?v0) f1) (=> (= (f41 ?v1 f48) f1) (= (f41 (f13 (f54 f55 ?v0) ?v1) f48) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f20 (f52 f53 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f41 f48 ?v0) f1) (=> (= (f41 ?v1 f48) f1) (= (f41 (f13 (f54 f55 ?v1) ?v0) f48) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f20 (f52 f53 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f41 ?v0 f48) f1) (=> (= (f41 f48 ?v1) f1) (= (f41 (f13 (f54 f55 ?v0) ?v1) f48) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f20 (f52 f53 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f41 ?v0 f48) f1) (=> (= (f41 ?v1 f48) f1) (= (f41 f48 (f13 (f54 f55 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f20 (f52 f53 ?v0) ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 f48 ?v2) f1) (= (f41 (f13 (f54 f55 ?v0) ?v2) (f13 (f54 f55 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f20 (f52 f53 ?v0) ?v2) (f20 (f52 f53 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f54 f55 ?v2))) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 f48 ?v2) f1) (= (f41 (f13 ?v_0 ?v0) (f13 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f52 f53 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f20 ?v_0 ?v0) (f20 ?v_0 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f54 f55 ?v2))) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 f48 ?v2) f1) (= (f41 (f13 ?v_0 ?v0) (f13 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f52 f53 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f20 ?v_0 ?v0) (f20 ?v_0 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 ?v2 f48) f1) (= (f41 (f13 (f54 f55 ?v1) ?v2) (f13 (f54 f55 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f20 (f52 f53 ?v1) ?v2) (f20 (f52 f53 ?v0) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f54 f55 ?v2))) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 ?v2 f48) f1) (= (f41 (f13 ?v_0 ?v1) (f13 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f52 f53 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f20 ?v_0 ?v1) (f20 ?v_0 ?v0)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 ?v2 ?v3) f1) (=> (= (f41 f48 ?v0) f1) (=> (= (f41 f48 ?v2) f1) (= (f41 (f13 (f54 f55 ?v0) ?v2) (f13 (f54 f55 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f20 (f52 f53 ?v0) ?v2) (f20 (f52 f53 ?v1) ?v3))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 ?v2 ?v3) f1) (=> (= (f41 f48 ?v1) f1) (=> (= (f41 f48 ?v2) f1) (= (f41 (f13 (f54 f55 ?v0) ?v2) (f13 (f54 f55 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f20 (f52 f53 ?v0) ?v2) (f20 (f52 f53 ?v1) ?v3))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (or (and (= (f41 f48 ?v0) f1) (= (f41 f48 ?v1) f1)) (and (= (f41 ?v0 f48) f1) (= (f41 ?v1 f48) f1))) (= (f41 f48 (f13 (f54 f55 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f20 (f52 f53 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (and (or (= (f41 f48 ?v0) f1) (= (f41 ?v0 f48) f1)) (or (= (f41 f48 ?v1) f1) (= (f41 ?v1 f48) f1))) (= (f13 f19 (f13 (f54 f55 ?v0) ?v1)) (f13 (f54 f55 (f13 f19 ?v0)) (f13 f19 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f20 f21 (f20 (f52 f53 ?v0) ?v1)) (f20 (f52 f53 (f20 f21 ?v0)) (f20 f21 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (or (and (= (f41 f48 ?v0) f1) (= (f41 ?v1 f48) f1)) (and (= (f41 ?v0 f48) f1) (= (f41 f48 ?v1) f1))) (= (f41 (f13 (f54 f55 ?v0) ?v1) f48) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f20 (f52 f53 ?v0) ?v1) 0))))
(assert (not (= (f41 f50 f48) f1)))
(assert (not (<= 1 0)))
(assert (= (f41 f48 f50) f1))
(assert (<= 0 1))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (and (= (f41 f48 ?v1) f1) (forall ((?v2 S7)) (= (f41 (f13 f28 (f13 (f54 f55 ?v2) ?v0)) (f13 (f54 f55 (f13 f28 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S4)) (exists ((?v1 S7)) (and (= (f41 f48 ?v1) f1) (forall ((?v2 S4)) (= (f41 (f29 f30 (f15 (f43 f44 ?v2) ?v0)) (f13 (f54 f55 (f29 f30 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (and (= (f41 f48 ?v1) f1) (forall ((?v2 S7)) (= (f41 (f13 f28 (f13 (f54 f55 ?v0) ?v2)) (f13 (f54 f55 (f13 f28 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S4)) (exists ((?v1 S7)) (and (= (f41 f48 ?v1) f1) (forall ((?v2 S4)) (= (f41 (f29 f30 (f15 (f43 f44 ?v0) ?v2)) (f13 (f54 f55 (f29 f30 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S7)) (and (= (f41 f48 ?v0) f1) (forall ((?v1 S7) (?v2 S7)) (= (f41 (f13 f28 (f13 (f54 f55 ?v1) ?v2)) (f13 (f54 f55 (f13 (f54 f55 (f13 f28 ?v1)) (f13 f28 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S7)) (and (= (f41 f48 ?v0) f1) (forall ((?v1 S4) (?v2 S4)) (= (f41 (f29 f30 (f15 (f43 f44 ?v1) ?v2)) (f13 (f54 f55 (f13 (f54 f55 (f29 f30 ?v1)) (f29 f30 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f41 ?v0 f48) f1) (=> (= (f41 (f13 f28 ?v1) (f13 (f54 f55 ?v0) (f13 f28 ?v2))) f1) (= ?v1 f48)))))
(assert (forall ((?v0 S7) (?v1 S4) (?v2 S4)) (=> (= (f41 ?v0 f48) f1) (=> (= (f41 (f29 f30 ?v1) (f13 (f54 f55 ?v0) (f29 f30 ?v2))) f1) (= ?v1 f49)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 (f52 f53 ?v0) ?v1) (f20 (f52 f53 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f17 f18 (+ (f22 f47 ?v1) (f22 f47 ?v2)))) (f20 (f52 f53 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f52 f53 ?v0))) (= (f20 ?v_0 (+ ?v1 ?v2)) (+ (f20 ?v_0 ?v1) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f52 f53 ?v0))) (= (f20 ?v_0 (- ?v1 ?v2)) (- (f20 ?v_0 ?v1) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 (f52 f53 (- ?v0)) ?v1) (- (f20 (f52 f53 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 (f52 f53 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f52 f53 ?v0))) (= (f20 (f52 f53 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f52 f53 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f20 (f52 f53 (+ ?v0 ?v1)) ?v2) (+ (f20 (f52 f53 ?v0) ?v2) (f20 (f52 f53 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f20 (f52 f53 (- ?v0 ?v1)) ?v2) (- (f20 (f52 f53 ?v0) ?v2) (f20 (f52 f53 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f20 (f52 f53 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f52 f53 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f20 ?v_0 ?v0) (f20 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f22 f47 ?v2))) (let ((?v_1 (f52 f53 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f20 ?v_1 ?v0) (f20 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 (f52 f53 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 (f52 f53 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f22 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f22 f47 (f25 (f26 f27 ?v0) ?v1)) (f22 (f23 f24 (f22 f47 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f22 f47 (f25 (f26 f27 ?v0) ?v1))) (or (< 0 (f22 f47 ?v0)) (= ?v1 (f17 f18 0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f22 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f17 f18 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f17 f18 (+ 0 1)))) (= (f25 (f26 f27 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f22 (f23 f24 (f22 f47 ?v0)) ?v1) (f22 f47 (f25 (f26 f27 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 (+ 0 1)))) (= (= (f25 (f26 f27 ?v0) ?v1) ?v_0) (or (= ?v1 (f17 f18 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f17 f18 (f22 (f23 f24 ?v0) ?v1)) (f25 (f26 f27 (f17 f18 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f27 ?v0))) (=> (< 0 (f22 f47 ?v0)) (=> (< (f22 f47 (f25 ?v_0 ?v1)) (f22 f47 (f25 ?v_0 ?v2))) (< (f22 f47 ?v1) (f22 f47 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f22 f47 ?v0)) (<= ?v_0 (f22 f47 (f25 (f26 f27 ?v0) ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f41 ?v0 f48) f1) (=> (= (f41 (f13 f19 ?v1) (f13 (f54 f55 ?v0) (f13 f19 ?v2))) f1) (= ?v1 f48)))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (= (f41 (f13 f28 (f13 (f54 f55 ?v2) ?v0)) (f13 (f54 f55 (f13 f28 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S4)) (exists ((?v1 S7)) (forall ((?v2 S4)) (= (f41 (f29 f30 (f15 (f43 f44 ?v2) ?v0)) (f13 (f54 f55 (f29 f30 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S7) (?v1 S3)) (=> (= (f41 (f10 (f11 f12 ?v0) (f17 f18 (* 2 (f22 f47 ?v1)))) f48) f1) (= ?v0 f48))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= (f22 (f23 f24 ?v0) (f17 f18 (* 2 (f22 f47 ?v1)))) 0) (= ?v0 0))))
(assert (forall ((?v0 S7) (?v1 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) f50 (f13 (f54 f55 ?v0) (f10 ?v_0 (f17 f18 (- (f22 f47 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) f51 (f15 (f43 f44 ?v0) (f3 ?v_0 (f17 f18 (- (f22 f47 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) 1 (f20 (f52 f53 ?v0) (f22 ?v_0 (f17 f18 (- (f22 f47 ?v1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) f58 (f25 (f26 f59 ?v0) (f25 ?v_0 (f17 f18 (- (f22 f47 ?v1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f22 f47 (f25 (f26 f27 ?v0) ?v1))) (or (= ?v1 (f17 f18 0)) (< 0 (f22 f47 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f22 f47 ?v1)) (?v_1 (f22 f47 ?v0)) (?v_2 (f23 f24 ?v2))) (=> (<= ?v_1 ?v_0) (= (f22 ?v_2 (f17 f18 (- (+ ?v_0 1) ?v_1))) (f20 (f52 f53 (f22 ?v_2 (f17 f18 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f47 ?v1)) (?v_1 (f22 f47 ?v0)) (?v_2 (f26 f27 ?v2))) (=> (<= ?v_1 ?v_0) (= (f25 ?v_2 (f17 f18 (- (+ ?v_0 1) ?v_1))) (f25 (f26 f59 (f25 ?v_2 (f17 f18 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S7)) (let ((?v_0 (f22 f47 ?v1)) (?v_1 (f22 f47 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_1 ?v_0) (= (f10 ?v_2 (f17 f18 (- (+ ?v_0 1) ?v_1))) (f13 (f54 f55 (f10 ?v_2 (f17 f18 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S4)) (let ((?v_0 (f22 f47 ?v1)) (?v_1 (f22 f47 ?v0)) (?v_2 (f4 f5 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f17 f18 (- (+ ?v_0 1) ?v_1))) (f15 (f43 f44 (f3 ?v_2 (f17 f18 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S7)) (= (f41 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f25 (f26 f27 (f17 f18 ?v0)) ?v1) (f17 f18 (f22 (f23 f24 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (=> (= (f41 ?v0 ?v1) f1) false) (=> (=> (= (f41 ?v1 ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f20 (f52 f53 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 (f52 f53 (f22 f47 ?v0)) (f22 f47 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f17 f18 (f20 (f52 f53 (f22 f47 (f17 f18 ?v0))) (f22 f47 (f17 f18 ?v1)))) (f17 f18 (f20 (f52 f53 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f22 (f23 f24 (f22 f47 ?v0)) ?v1) (f22 f47 (f25 (f26 f27 ?v0) ?v1)))))
(assert (= (f15 f60 f49) f51))
(assert (forall ((?v0 S4)) (exists ((?v1 S4) (?v2 S7)) (= ?v0 (f15 (f43 f44 (f6 f7 ?v2)) (f15 f60 ?v1))))))
(assert (forall ((?v0 S3)) (= (f17 f18 (f22 f47 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f22 f47 (f17 f18 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f22 f47 (f17 f18 ?v0)) 0))))
(check-sat)
(exit)
