(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4) S1)
(declare-fun f7 (S6 S6) S1)
(declare-fun f8 () S6)
(declare-fun f9 (S8 S7) Int)
(declare-fun f10 () S8)
(declare-fun f11 (S9 S5) S6)
(declare-fun f12 () S9)
(declare-fun f13 (S10 S5) S5)
(declare-fun f14 (S11 S5) S10)
(declare-fun f15 () S11)
(declare-fun f16 (S12 S7) S5)
(declare-fun f17 () S12)
(declare-fun f18 (S4 S7) S7)
(declare-fun f19 (S13 S4) S4)
(declare-fun f20 (S14 S4) S13)
(declare-fun f21 () S14)
(declare-fun f22 () S4)
(declare-fun f23 () S4)
(declare-fun f24 (S15 S6) S5)
(declare-fun f25 (S16 S6) S15)
(declare-fun f26 () S16)
(declare-fun f27 () S6)
(declare-fun f28 () S6)
(declare-fun f29 () S5)
(declare-fun f30 (S17 S6) S6)
(declare-fun f31 () S17)
(declare-fun f32 (S18 S6) S17)
(declare-fun f33 () S18)
(declare-fun f34 (S6 S6) S1)
(declare-fun f35 () S6)
(declare-fun f36 (S19 Int) S7)
(declare-fun f37 () S19)
(declare-fun f38 () S2)
(declare-fun f39 () S17)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (exists ((?v0 S4) (?v1 S5)) (and (= (f6 ?v0) f1) (forall ((?v2 S6)) (=> (= (f7 f8 ?v2) f1) (exists ((?v3 S7)) (forall ((?v4 S7)) (=> (<= (f9 f10 ?v3) (f9 f10 ?v4)) (= (f7 (f11 f12 (f13 (f14 f15 (f16 f17 (f18 ?v0 ?v4))) ?v1)) ?v2) f1))))))))))
(assert (= (f6 (f19 (f20 f21 f22) f23)) f1))
(assert (forall ((?v0 S6)) (=> (= (f7 f8 ?v0) f1) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (<= (f9 f10 ?v1) (f9 f10 ?v2)) (= (f7 (f11 f12 (f13 (f14 f15 (f16 f17 (f18 (f19 (f20 f21 f22) f23) ?v2))) (f24 (f25 f26 f27) f28))) ?v0) f1)))))))
(assert (= (f6 f23) f1))
(assert (= (f6 (f19 (f20 f21 f22) f23)) f1))
(assert (= (f6 f22) f1))
(assert (forall ((?v0 S6)) (=> (= (f7 f8 ?v0) f1) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (<= (f9 f10 ?v1) (f9 f10 ?v2)) (= (f7 (f11 f12 (f13 (f14 f15 (f16 f17 (f18 (f19 (f20 f21 f22) f23) ?v2))) (f24 (f25 f26 f27) f28))) ?v0) f1)))))))
(assert (forall ((?v0 S5)) (= (= (f7 f8 (f11 f12 ?v0)) f1) (not (= ?v0 f29)))))
(assert (forall ((?v0 S6)) (= (= (f7 f8 (f30 f31 ?v0)) f1) (not (= ?v0 f8)))))
(assert (forall ((?v0 S6)) (not (= (f7 (f30 f31 ?v0) f8) f1))))
(assert (forall ((?v0 S5)) (not (= (f7 (f11 f12 ?v0) f8) f1))))
(assert (= (f11 f12 f29) f8))
(assert (= (f30 f31 f8) f8))
(assert (forall ((?v0 S5)) (= (= (f11 f12 ?v0) f8) (= ?v0 f29))))
(assert (forall ((?v0 S6)) (= (= (f30 f31 ?v0) f8) (= ?v0 f8))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f7 ?v0 ?v1) f1) (= (f7 (f30 (f32 f33 ?v0) ?v1) f8) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (< (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S7)) (= (f34 (f11 f12 (f16 f17 ?v0)) f35) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f11 f12 (f13 (f14 f15 ?v0) ?v1)) (f11 f12 (f13 (f14 f15 ?v1) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f30 f31 (f30 (f32 f33 ?v0) ?v1)) (f30 f31 (f30 (f32 f33 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f30 (f32 f33 ?v0) ?v1) (f30 (f32 f33 ?v2) ?v3)) (= (= (f7 ?v0 ?v1) f1) (= (f7 ?v2 ?v3) f1)))))
(assert (forall ((?v0 S5)) (= (f13 (f14 f15 ?v0) f29) ?v0)))
(assert (forall ((?v0 S6)) (= (f30 (f32 f33 ?v0) f8) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f13 (f14 f15 ?v0) ?v0) f29)))
(assert (forall ((?v0 S6)) (= (f30 (f32 f33 ?v0) ?v0) f8)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (= (f13 (f14 f15 ?v0) ?v1) f29))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= ?v0 ?v1) (= (f30 (f32 f33 ?v0) ?v1) f8))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f13 (f14 f15 ?v0) ?v1) f29) (= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f30 (f32 f33 ?v0) ?v1) f8) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (= (f34 f8 f35) f1))
(assert (= (f34 (f11 f12 (f16 f17 (f36 f37 0))) f35) f1))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 f38 ?v0))))
(assert (forall ((?v0 S6)) (= (f34 ?v0 (f30 f39 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f3 f38 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f34 (f30 f39 ?v0) ?v1) f1) (= (f34 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f38 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (=> (= (f34 f8 ?v0) f1) (= (f30 f39 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f3 f38 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S6)) (= (= (f34 (f30 f39 ?v0) f8) f1) (= ?v0 f8))))
(assert (forall ((?v0 Int)) (<= 0 (f3 f38 ?v0))))
(assert (forall ((?v0 S6)) (= (f34 f8 (f30 f39 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f30 (f32 f33 ?v0) ?v1) (f30 (f32 f33 ?v2) ?v3)) (= (= (f34 ?v0 ?v1) f1) (= (f34 ?v2 ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f38 ?v0) (f3 f38 ?v1)) (f3 f38 (- ?v1 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f34 (f30 (f32 f33 (f30 f39 ?v0)) (f30 f39 ?v1)) (f30 f39 (f30 (f32 f33 ?v1) ?v0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f38 ?v0) (f3 f38 ?v1)) (f3 f38 (- ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f34 (f30 (f32 f33 (f30 f39 ?v0)) (f30 f39 ?v1)) (f30 f39 (f30 (f32 f33 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f38 (- (f3 f38 ?v0) (f3 f38 ?v1))) (f3 f38 (- ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f34 (f30 f39 (f30 (f32 f33 (f30 f39 ?v0)) (f30 f39 ?v1))) (f30 f39 (f30 (f32 f33 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f34 ?v0 ?v1) f1) (= (f34 (f30 (f32 f33 ?v0) ?v1) f8) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (<= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f34 (f30 (f32 f33 (f11 f12 ?v0)) (f11 f12 ?v1)) (f11 f12 (f13 (f14 f15 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f34 (f30 (f32 f33 (f30 f31 ?v0)) (f30 f31 ?v1)) (f30 f31 (f30 (f32 f33 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f34 (f30 f39 (f30 (f32 f33 (f11 f12 ?v0)) (f11 f12 ?v1))) (f11 f12 (f13 (f14 f15 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f34 (f30 f39 (f30 (f32 f33 (f30 f31 ?v0)) (f30 f31 ?v1))) (f30 f31 (f30 (f32 f33 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S6)) (= (f34 f8 (f30 f31 ?v0)) f1)))
(assert (forall ((?v0 S5)) (= (f34 f8 (f11 f12 ?v0)) f1)))
(assert (forall ((?v0 S5)) (= (= (f34 (f11 f12 ?v0) f8) f1) (= ?v0 f29))))
(assert (forall ((?v0 S6)) (= (= (f34 (f30 f31 ?v0) f8) f1) (= ?v0 f8))))
(assert (forall ((?v0 S7)) (= (f36 f37 (f9 f10 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f10 (f36 f37 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f9 f10 (f36 f37 ?v0)) 0))))
(check-sat)
(exit)
