(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S3) S1)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 () S3)
(declare-fun f7 (S3 S3) S1)
(declare-fun f8 (S5 S2) S2)
(declare-fun f9 (S6 S7) S5)
(declare-fun f10 () S6)
(declare-fun f11 () S7)
(declare-fun f12 (S8 S3) S3)
(declare-fun f13 (S9 S3) S8)
(declare-fun f14 () S9)
(declare-fun f15 () S8)
(declare-fun f16 () S3)
(declare-fun f17 () S9)
(declare-fun f18 () S3)
(declare-fun f19 (S10 S11) S3)
(declare-fun f20 () S10)
(declare-fun f21 (S12 Int) S11)
(declare-fun f22 () S12)
(declare-fun f23 (S13 S11) Int)
(declare-fun f24 () S13)
(declare-fun f25 () S11)
(declare-fun f26 () S3)
(declare-fun f27 () S2)
(declare-fun f28 (S14 S2) S5)
(declare-fun f29 () S14)
(declare-fun f30 () S8)
(declare-fun f31 () S8)
(declare-fun f32 () S14)
(declare-fun f33 () S5)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 S2)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f7 (f4 f5 (f8 (f9 f10 f11) ?v0)) (f12 (f13 f14 (f12 f15 f16)) (f12 (f13 f17 f18) (f19 f20 (f21 f22 (+ (f23 f24 f25) 1)))))) f1)))))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S3)) (and (exists ((?v2 S2)) (and (= (f3 (f4 f5 ?v2) f6) f1) (= (f4 f5 (f8 (f9 f10 f11) ?v2)) (f12 f15 ?v1)))) (= (f7 ?v0 ?v1) f1))) (= (f7 ?v0 f16) f1))))
(assert (= (f3 f26 f6) f1))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f4 f5 (f8 (f9 f10 f11) ?v0)) (f12 f15 ?v1)) (=> (not (= (f7 ?v1 f18) f1)) false)))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 (f12 f15 f16) (f4 f5 (f8 (f9 f10 f11) ?v0))) f1))))
(assert (exists ((?v0 S3)) (forall ((?v1 S3)) (=> (exists ((?v2 S2)) (and (= (f3 (f4 f5 ?v2) f6) f1) (= (f4 f5 (f8 (f9 f10 f11) ?v2)) (f12 f15 ?v1)))) (= (f7 ?v1 ?v0) f1)))))
(assert (exists ((?v0 S3) (?v1 S2)) (and (= (f3 (f4 f5 ?v1) f6) f1) (= (f4 f5 (f8 (f9 f10 f11) ?v1)) (f12 f15 ?v0)))))
(assert (exists ((?v0 S3)) (forall ((?v1 S3)) (= (exists ((?v2 S3)) (and (exists ((?v3 S2)) (and (= (f3 (f4 f5 ?v3) f6) f1) (= (f4 f5 (f8 (f9 f10 f11) ?v3)) (f12 f15 ?v2)))) (= (f7 ?v1 ?v2) f1))) (= (f7 ?v1 ?v0) f1)))))
(assert (=> (forall ((?v0 S3)) (=> (forall ((?v1 S3)) (= (exists ((?v2 S3)) (and (exists ((?v3 S2)) (and (= (f3 (f4 f5 ?v3) f6) f1) (= (f4 f5 (f8 (f9 f10 f11) ?v3)) (f12 f15 ?v2)))) (= (f7 ?v1 ?v2) f1))) (= (f7 ?v1 ?v0) f1))) false)) false))
(assert (let ((?v_0 (f4 f5 (f8 (f9 f10 f11) f27)))) (and (= (f3 (f4 f5 f27) f6) f1) (= ?v_0 (f12 f15 (f12 f15 ?v_0))))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (<= (f23 f24 ?v0) (f23 f24 ?v1)) (= (f7 (f19 f20 ?v0) (f12 (f13 f14 (f19 f20 ?v1)) f18)) f1))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (< (f23 f24 ?v0) (f23 f24 ?v1)) (= (f3 (f12 (f13 f14 (f19 f20 ?v0)) f18) (f19 f20 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2) (?v3 S3)) (=> (= (f7 (f4 f5 ?v0) ?v1) f1) (=> (= (f7 (f4 f5 ?v2) ?v3) f1) (= (f7 (f4 f5 (f8 (f28 f29 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f7 (f12 f30 ?v0) ?v1) f1) (=> (= (f7 (f12 f30 ?v2) ?v3) f1) (= (f7 (f12 f30 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 (f8 (f28 f29 ?v0) ?v1)) (f12 (f13 f14 (f4 f5 ?v0)) (f4 f5 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f12 f30 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f14 (f12 f30 ?v0)) (f12 f30 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f7 ?v0 ?v1) f1) (= (f7 ?v0 (f12 (f13 f17 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f14 f18) f18))) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f7 ?v0 ?v1) f1) (= (f7 (f12 (f13 f17 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f14 f18) f18)) ?v1) f1))))
(assert (=> (not (= (f3 f26 f6) f1)) (exists ((?v0 S2)) (forall ((?v1 S2)) (let ((?v_0 (f9 f10 f11))) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 (f8 ?v_0 ?v0)) (f4 f5 (f8 ?v_0 ?v1))) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f12 f15 ?v_0) ?v_0) f1))))
(assert (forall ((?v0 S11)) (= (f19 f20 (f21 f22 (+ (f23 f24 ?v0) 1))) (f12 (f13 f14 (f19 f20 ?v0)) f18))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f12 f15 ?v2)) (?v_2 (f12 f15 ?v3))) (= (f3 (f12 f31 (f12 (f13 f14 (f12 ?v_0 ?v1)) (f12 (f13 f14 ?v_1) ?v_2))) (f12 (f13 f14 (f12 f31 (f12 ?v_0 ?v_1))) (f12 f31 (f12 (f13 f14 ?v1) ?v_2)))) f1))))
(assert (forall ((?v0 S11)) (= (f3 f26 (f19 f20 ?v0)) f1)))
(assert (= (f12 f30 f26) f26))
(assert (= (f4 f5 f27) f26))
(assert (forall ((?v0 S3)) (= (= (f12 f30 ?v0) f26) (= ?v0 f26))))
(assert (forall ((?v0 S2)) (= (= (f4 f5 ?v0) f26) (= ?v0 f27))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f26)) (= (f12 f31 (f12 (f13 f17 ?v1) ?v0)) (f12 (f13 f17 (f12 f31 ?v1)) (f12 f31 ?v0))))))
(assert (forall ((?v0 S3)) (= (f12 (f13 f17 f26) ?v0) f26)))
(assert (forall ((?v0 S2)) (= (f8 (f28 f32 f27) ?v0) f27)))
(assert (not (= f26 f18)))
(assert (forall ((?v0 S11)) (= (= (f19 f20 ?v0) f26) (= ?v0 (f21 f22 0)))))
(assert (= (f19 f20 (f21 f22 0)) f26))
(assert (forall ((?v0 S3)) (= (= (f3 (f12 f30 ?v0) f26) f1) (= ?v0 f26))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f5 ?v0) f26) f1) (= ?v0 f27))))
(assert (forall ((?v0 S3)) (= (= (f7 f26 (f12 f30 ?v0)) f1) (not (= ?v0 f26)))))
(assert (forall ((?v0 S2)) (= (= (f7 f26 (f4 f5 ?v0)) f1) (not (= ?v0 f27)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 f26) f1) (= (f3 (f12 (f13 f17 ?v1) ?v2) (f12 (f13 f17 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 f26 ?v2) f1) (= (f3 (f12 (f13 f17 ?v0) ?v2) (f12 (f13 f17 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f12 (f13 f17 ?v0) ?v1) f26) f1) (or (and (= (f3 f26 ?v0) f1) (= (f3 ?v1 f26) f1)) (and (= (f3 ?v0 f26) f1) (= (f3 f26 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 f26 (f12 (f13 f17 ?v0) ?v1)) f1) (or (and (= (f3 f26 ?v0) f1) (= (f3 f26 ?v1) f1)) (and (= (f3 ?v0 f26) f1) (= (f3 ?v1 f26) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f8 (f28 f29 ?v0) ?v1) f27) (= ?v1 (f8 f33 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f12 (f13 f14 ?v0) ?v1) f26) (= ?v1 (f12 f15 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ ?v0 ?v1) 0) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f7 ?v0 ?v1) f1) (=> (= (f7 ?v2 f26) f1) (= (f7 (f12 (f13 f17 ?v1) ?v2) (f12 (f13 f17 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f7 ?v0 ?v1) f1) (=> (= (f7 f26 ?v2) f1) (= (f7 (f12 (f13 f17 ?v0) ?v2) (f12 (f13 f17 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f7 ?v0 f26) f1) (=> (= (f7 ?v1 f26) f1) (= (f7 f26 (f12 (f13 f17 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f7 ?v0 f26) f1) (=> (= (f7 f26 ?v1) f1) (= (f7 (f12 (f13 f17 ?v0) ?v1) f26) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f7 f26 ?v0) f1) (=> (= (f7 ?v1 f26) f1) (= (f7 (f12 (f13 f17 ?v0) ?v1) f26) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f7 f26 ?v0) f1) (=> (= (f7 f26 ?v1) f1) (= (f7 f26 (f12 (f13 f17 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f7 f26 ?v0) f1) (= (f12 (f13 f17 (f12 f31 ?v1)) ?v0) (f12 f31 (f12 (f13 f17 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f7 (f12 (f13 f17 ?v0) ?v1) (f12 (f13 f17 ?v2) ?v1)) f1) (and (=> (= (f7 f26 ?v1) f1) (= (f7 ?v0 ?v2) f1)) (and (=> (= (f7 ?v1 f26) f1) (= (f7 ?v2 ?v0) f1)) (not (= ?v1 f26)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f7 (f12 (f13 f17 ?v0) ?v1) f26) f1) (or (and (= (f7 f26 ?v0) f1) (= (f7 ?v1 f26) f1)) (and (= (f7 ?v0 f26) f1) (= (f7 f26 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f7 f26 (f12 (f13 f17 ?v0) ?v1)) f1) (or (and (= (f7 f26 ?v0) f1) (= (f7 f26 ?v1) f1)) (and (= (f7 ?v0 f26) f1) (= (f7 ?v1 f26) f1))))))
(assert (forall ((?v0 S3)) (= (f3 f26 (f12 f30 ?v0)) f1)))
(assert (forall ((?v0 S2)) (= (f3 f26 (f4 f5 ?v0)) f1)))
(assert (forall ((?v0 S3)) (not (= (f7 (f12 f30 ?v0) f26) f1))))
(assert (forall ((?v0 S2)) (not (= (f7 (f4 f5 ?v0) f26) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 f26 (f12 (f13 f17 ?v0) ?v1)) f1) (and (or (= (f3 ?v0 f26) f1) (= (f3 f26 ?v1) f1)) (or (= (f3 f26 ?v0) f1) (= (f3 ?v1 f26) f1))))))
(assert (forall ((?v0 S11)) (= (= (f3 (f19 f20 ?v0) f26) f1) (= ?v0 (f21 f22 0)))))
(assert (forall ((?v0 S11)) (= (= (f7 f26 (f19 f20 ?v0)) f1) (< 0 (f23 f24 ?v0)))))
(assert (forall ((?v0 S11)) (= (f7 f26 (f19 f20 (f21 f22 (+ (f23 f24 ?v0) 1)))) f1)))
(assert (forall ((?v0 S11)) (not (= (f7 (f19 f20 ?v0) f26) f1))))
(assert (forall ((?v0 S3)) (= (f12 f31 ?v0) (ite (= (f7 ?v0 f26) f1) (f12 f15 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f12 f31 ?v0) (ite (= (f7 ?v0 f26) f1) (f12 f15 ?v0) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f12 (f13 f14 ?v0) (f12 f15 ?v1)) f26) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f12 (f13 f14 ?v0) ?v1) f26) (= ?v1 (f12 f15 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 ?v0 f26) f1) (=> (= (f7 ?v1 f26) f1) (= (f3 f26 (f12 (f13 f17 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 ?v0 f26) f1) (=> (= (f7 f26 ?v1) f1) (= (f3 (f12 (f13 f17 ?v0) ?v1) f26) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 f26 ?v0) f1) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f7 f26 ?v2) f1) (=> (= (f3 ?v2 ?v3) f1) (= (f3 (f12 (f13 f17 ?v0) ?v3) (f12 (f13 f17 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 f26 ?v0) f1) (=> (= (f7 ?v0 ?v1) f1) (=> (= (f7 f26 ?v2) f1) (=> (= (f3 ?v2 ?v3) f1) (= (f7 (f12 (f13 f17 ?v0) ?v3) (f12 (f13 f17 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S11)) (= (f21 f22 (f23 f24 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f23 f24 (f21 f22 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f23 f24 (f21 f22 ?v0)) 0))))
(check-sat)
(exit)
