(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3) S2)
(declare-fun f5 (S4 Int) S3)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S3) Int)
(declare-fun f8 () S5)
(declare-fun f9 () S3)
(declare-fun f10 () S3)
(declare-fun f11 (S6 S3) S3)
(declare-fun f12 () S6)
(declare-fun f13 () S2)
(declare-fun f14 (S7 S2) S3)
(declare-fun f15 () S7)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ (f7 f8 f9) (f7 f8 f10)))) (not (= (f3 (f4 (f5 f6 (+ ?v_0 1))) (f4 (f5 f6 (+ (f7 f8 (f11 f12 (f5 f6 ?v_0))) 1)))) f1))))
(assert (let ((?v_0 (+ (f7 f8 f9) (f7 f8 f10)))) (<= ?v_0 (f7 f8 (f11 f12 (f5 f6 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 ?v0) (f4 ?v1)) f1) (<= (f7 f8 ?v0) (f7 f8 ?v1)))))
(assert (forall ((?v0 S3)) (= (f3 f13 (f4 ?v0)) f1)))
(assert (= (f4 (f5 f6 0)) f13))
(assert (= (f14 f15 f13) (f5 f6 0)))
(assert (forall ((?v0 S3)) (= (f5 f6 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
