(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S4 S3) S2)
(declare-fun f4 (S5 S2) S4)
(declare-fun f5 () S5)
(declare-fun f6 () S2)
(declare-fun f7 (S6 S2) S7)
(declare-fun f8 () S6)
(declare-fun f9 (S8 S2) S2)
(declare-fun f10 (S9 S3) S8)
(declare-fun f11 () S9)
(declare-fun f12 (S10 Int) S7)
(declare-fun f13 () S10)
(declare-fun f14 (S11 S7) Int)
(declare-fun f15 () S11)
(declare-fun f16 () S9)
(declare-fun f17 () S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f6) (= ?v0 f6))))
(assert (forall ((?v0 S3) (?v1 S2)) (= (f7 f8 (f9 (f10 f11 ?v0) ?v1)) (ite (= ?v1 f6) (f12 f13 0) (f12 f13 (+ (f14 f15 (f7 f8 ?v1)) 1))))))
(assert (forall ((?v0 S3) (?v1 S2)) (<= (f14 f15 (f7 f8 (f9 (f10 f16 ?v0) ?v1))) (f14 f15 (f7 f8 ?v1)))))
(assert (not (forall ((?v0 S3) (?v1 S2)) (let ((?v_0 (f3 (f4 f5 ?v1) f17))) (=> (= (f7 f8 ?v_0) (f7 f8 ?v1)) (=> (not (= ?v1 f6)) (< (f14 f15 (f7 f8 (f9 (f10 f16 f17) ?v_0))) (f14 f15 (f7 f8 (f9 (f10 f11 ?v0) ?v_0))))))))))
(assert (forall ((?v0 S7)) (= (f12 f13 (f14 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f15 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f14 f15 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
