(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S4 S3) S1)
(declare-fun f4 (S2) S4)
(declare-fun f5 (S5 S6) S4)
(declare-fun f6 (S7 S3) S5)
(declare-fun f7 (S8) S7)
(declare-fun f8 (S9 S10) S8)
(declare-fun f9 () S9)
(declare-fun f10 () S10)
(declare-fun f11 (S11 Int) S6)
(declare-fun f12 () S11)
(declare-fun f13 (S2) S4)
(declare-fun f14 (S12 S6) Int)
(declare-fun f15 () S12)
(declare-fun f16 (S13 S14) S8)
(declare-fun f17 () S13)
(declare-fun f18 (S10) S14)
(declare-fun f19 () S8)
(declare-fun f20 (S15 S8) S6)
(declare-fun f21 () S15)
(declare-fun f22 () S15)
(declare-fun f23 (S16 S3) S4)
(declare-fun f24 (S8) S16)
(declare-fun f25 (S17 S8) S8)
(declare-fun f26 (S18 S8) S17)
(declare-fun f27 () S18)
(declare-fun f28 (S8) S1)
(declare-fun f29 (S19 S4) S18)
(declare-fun f30 () S19)
(assert (not (= f1 f2)))
(assert (not (forall ((?v0 S2) (?v1 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (forall ((?v2 S3)) (=> (= (f3 (f5 (f6 (f7 (f8 f9 f10)) ?v1) (f11 f12 0)) ?v2) f1) (= (f3 (f13 ?v0) ?v2) f1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f8 f9 ?v0) (f8 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S8) (?v1 S3) (?v2 S6) (?v3 S3)) (let ((?v_0 (f6 (f7 ?v0) ?v1))) (=> (= (f3 (f5 ?v_0 ?v2) ?v3) f1) (= (f3 (f5 ?v_0 (f11 f12 (+ (f14 f15 ?v2) 1))) ?v3) f1)))))
(assert (forall ((?v0 S8) (?v1 S3) (?v2 S6) (?v3 S3) (?v4 S6)) (let ((?v_0 (f6 (f7 ?v0) ?v1))) (=> (= (f3 (f5 ?v_0 ?v2) ?v3) f1) (=> (<= (f14 f15 ?v2) (f14 f15 ?v4)) (= (f3 (f5 ?v_0 ?v4) ?v3) f1))))))
(assert (forall ((?v0 S8) (?v1 S3) (?v2 S6) (?v3 S3) (?v4 S8) (?v5 S3) (?v6 S6) (?v7 S3)) (=> (= (f3 (f5 (f6 (f7 ?v0) ?v1) ?v2) ?v3) f1) (=> (= (f3 (f5 (f6 (f7 ?v4) ?v5) ?v6) ?v7) f1) (exists ((?v8 S6)) (and (= (f3 (f5 (f6 (f7 ?v0) ?v1) ?v8) ?v3) f1) (= (f3 (f5 (f6 (f7 ?v4) ?v5) ?v8) ?v7) f1)))))))
(assert (forall ((?v0 S10) (?v1 S3) (?v2 S6) (?v3 S3)) (=> (= (f3 (f5 (f6 (f7 (f16 f17 (f18 ?v0))) ?v1) ?v2) ?v3) f1) (= (f3 (f5 (f6 (f7 (f8 f9 ?v0)) ?v1) (f11 f12 (+ (f14 f15 ?v2) 1))) ?v3) f1))))
(assert (forall ((?v0 S10) (?v1 S3) (?v2 S6) (?v3 S3)) (=> (= (f3 (f5 (f6 (f7 (f8 f9 ?v0)) ?v1) ?v2) ?v3) f1) (=> (forall ((?v4 S6)) (=> (= ?v2 (f11 f12 (+ (f14 f15 ?v4) 1))) (=> (= (f3 (f5 (f6 (f7 (f16 f17 (f18 ?v0))) ?v1) ?v4) ?v3) f1) false))) false))))
(assert (forall ((?v0 S3) (?v1 S6)) (= (f3 (f5 (f6 (f7 f19) ?v0) ?v1) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S6) (?v2 S3)) (=> (= (f3 (f5 (f6 (f7 f19) ?v0) ?v1) ?v2) f1) (=> (=> (= ?v2 ?v0) false) false))))
(assert (forall ((?v0 S10)) (= (f20 f21 (f8 f9 ?v0)) (f11 f12 0))))
(assert (forall ((?v0 S10)) (= (f20 f22 (f8 f9 ?v0)) (f11 f12 0))))
(assert (= (f20 f21 f19) (f11 f12 0)))
(assert (= (f20 f22 f19) (f11 f12 0)))
(assert (forall ((?v0 S10)) (not (= (f8 f9 ?v0) f19))))
(assert (forall ((?v0 S10)) (not (= f19 (f8 f9 ?v0)))))
(assert (forall ((?v0 S10) (?v1 S3) (?v2 S3)) (=> (= (f3 (f23 (f24 (f8 f9 ?v0)) ?v1) ?v2) f1) (=> (=> (= (f3 (f23 (f24 (f16 f17 (f18 ?v0))) ?v1) ?v2) f1) false) false))))
(assert (forall ((?v0 S10) (?v1 S3) (?v2 S3)) (=> (= (f3 (f23 (f24 (f16 f17 (f18 ?v0))) ?v1) ?v2) f1) (= (f3 (f23 (f24 (f8 f9 ?v0)) ?v1) ?v2) f1))))
(assert (forall ((?v0 S8) (?v1 S3) (?v2 S6) (?v3 S3) (?v4 S8) (?v5 S3)) (=> (= (f3 (f5 (f6 (f7 ?v0) ?v1) ?v2) ?v3) f1) (=> (= (f3 (f5 (f6 (f7 ?v4) ?v3) ?v2) ?v5) f1) (= (f3 (f5 (f6 (f7 (f25 (f26 f27 ?v0) ?v4)) ?v1) ?v2) ?v5) f1)))))
(assert (=> (= (f28 f19) f1) (=> false false)))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8) (?v3 S3) (?v4 S6) (?v5 S3)) (let ((?v_0 (= (f3 ?v0 ?v3) f1))) (=> (= (f3 (f5 (f6 (f7 (f25 (f26 (f29 f30 ?v0) ?v1) ?v2)) ?v3) ?v4) ?v5) f1) (=> (=> ?v_0 (=> (= (f3 (f5 (f6 (f7 ?v1) ?v3) ?v4) ?v5) f1) false)) (=> (=> (not ?v_0) (=> (= (f3 (f5 (f6 (f7 ?v2) ?v3) ?v4) ?v5) f1) false)) false))))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S8) (?v3 S6) (?v4 S3) (?v5 S8)) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 (f5 (f6 (f7 ?v2) ?v1) ?v3) ?v4) f1) (= (f3 (f5 (f6 (f7 (f25 (f26 (f29 f30 ?v0) ?v5) ?v2)) ?v1) ?v3) ?v4) f1)))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S8) (?v3 S6) (?v4 S3) (?v5 S8)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 (f5 (f6 (f7 ?v2) ?v1) ?v3) ?v4) f1) (= (f3 (f5 (f6 (f7 (f25 (f26 (f29 f30 ?v0) ?v2) ?v5)) ?v1) ?v3) ?v4) f1)))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S8) (?v3 S3) (?v4 S8)) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 (f23 (f24 ?v2) ?v1) ?v3) f1) (= (f3 (f23 (f24 (f25 (f26 (f29 f30 ?v0) ?v4) ?v2)) ?v1) ?v3) f1)))))
(assert (forall ((?v0 S6)) (= (f11 f12 (f14 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f15 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f14 f15 (f11 f12 ?v0)) 0))))
(check-sat)
(exit)
