(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2 S3) S1)
(declare-fun f6 () S3)
(declare-fun f7 (S4) S3)
(declare-fun f8 (S5 S3) S3)
(declare-fun f9 (S2) S5)
(declare-fun f10 () S2)
(declare-fun f11 () S3)
(declare-fun f12 (S3 S3) S1)
(declare-fun f13 () S3)
(declare-fun f14 (S6 Int) S4)
(declare-fun f15 () S6)
(declare-fun f16 (S7 S4) Int)
(declare-fun f17 () S7)
(declare-fun f18 () S1)
(declare-fun f19 (S3 S3) S1)
(declare-fun f20 (S3) S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) false)))
(assert (not (forall ((?v0 S4)) (=> (forall ((?v1 S2)) (=> (= (f5 ?v1 f6) f1) (= (f3 (f7 ?v0) ?v1) f1))) (forall ((?v1 S2)) (=> (= (f5 ?v1 (f8 (f9 f10) f11)) f1) (= (f3 (f7 ?v0) ?v1) f1)))))))
(assert (= (f12 f6 (f8 (f9 f10) f13)) f1))
(assert (forall ((?v0 S4)) (=> (forall ((?v1 S2)) (=> (= (f5 ?v1 f6) f1) (= (f3 (f7 ?v0) ?v1) f1))) (forall ((?v1 S2)) (=> (= (f5 ?v1 (f8 (f9 f10) f13)) f1) (= (f3 (f7 ?v0) ?v1) f1))))))
(assert (= (f12 f6 f11) f1))
(assert (forall ((?v0 S4)) (=> (forall ((?v1 S2)) (=> (= (f5 ?v1 f6) f1) (= (f3 (f7 ?v0) ?v1) f1))) (forall ((?v1 S2)) (=> (= (f5 ?v1 f11) f1) (= (f3 (f7 ?v0) ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (f12 ?v0 f13) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f12 ?v0 ?v1) f1) (=> (= (f12 ?v2 ?v0) f1) (= (f12 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S4)) (=> (forall ((?v2 S2)) (=> (= (f5 ?v2 ?v0) f1) (= (f3 (f7 (f14 f15 (+ (f16 f17 ?v1) 1))) ?v2) f1))) (forall ((?v2 S2)) (=> (= (f5 ?v2 ?v0) f1) (= (f3 (f7 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_0 (f9 ?v1))) (=> (= (f12 ?v0 (f8 ?v_0 f13)) f1) (=> (= (f12 ?v0 ?v2) f1) (= (f12 ?v0 (f8 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_0 (f9 ?v1))) (=> (= (f12 ?v0 (f8 ?v_0 ?v2)) f1) (and (= (f12 ?v0 (f8 ?v_0 f13)) f1) (= (f12 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (=> (= (f3 (f7 (f14 f15 (+ (f16 f17 ?v0) 1))) ?v1) f1) (= (f3 (f7 ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (=> (= (f5 ?v0 (f8 (f9 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f5 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (=> (not (= (f5 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f5 ?v0 (f8 (f9 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2)) (=> (= (f5 ?v0 f13) f1) false)))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= f13 (f8 (f9 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= (f8 (f9 ?v0) ?v1) f13))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f5 ?v0 (f8 (f9 ?v1) f13)) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f8 (f9 ?v0) (f8 (f9 ?v1) f13)) (f8 (f9 ?v2) (f8 (f9 ?v3) f13))) (or (and (= ?v0 ?v2) (= ?v1 ?v3)) (and (= ?v0 ?v3) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f5 ?v0 (f8 (f9 ?v1) f13)) f1) (=> (=> (= ?v0 ?v1) false) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f8 (f9 ?v0) f13) (f8 (f9 ?v1) f13)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2)) (= (= (f3 f13 ?v0) f1) (= f18 f1))))
(assert (forall ((?v0 S2)) (= (= (f3 f13 ?v0) f1) (= f18 f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f19 ?v0 ?v1) f1) (forall ((?v2 S4)) (=> (forall ((?v3 S2)) (=> (= (f5 ?v3 ?v0) f1) (= (f3 (f7 ?v2) ?v3) f1))) (forall ((?v3 S2)) (=> (= (f5 ?v3 ?v1) f1) (= (f3 (f7 ?v2) ?v3) f1))))))))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= ?v0 f13) (not (= (f5 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S3)) (= (= (f20 ?v0) f13) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2)) (= (= (f5 ?v0 f13) f1) false)))
(assert (forall ((?v0 S3)) (= (= f13 (f20 ?v0)) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (=> (= (f5 ?v1 f13) f1) (= (f3 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (and (= (f5 ?v1 f13) f1) (= (f3 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (= (f5 ?v1 ?v0) f1)) (not (= ?v0 f13)))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (not (= (f5 ?v1 ?v0) f1))) (= ?v0 f13))))
(assert (= f13 (f20 f4)))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f5 ?v0 ?v1) f1) (= (f8 (f9 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (= (f5 ?v0 ?v1) f1) (= (f5 ?v0 (f8 (f9 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f9 ?v0))) (=> (not (= (f5 ?v0 ?v1) f1)) (=> (not (= (f5 ?v0 ?v2) f1)) (= (= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f8 (f9 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (= (= (f5 ?v0 (f8 (f9 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f5 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S4)) (= (f14 f15 (f16 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f17 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
