(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S6 S5) S3)
(declare-fun f7 () S5)
(declare-fun f8 (S7 S8) S6)
(declare-fun f9 () S7)
(declare-fun f10 () S8)
(declare-fun f11 () S5)
(declare-fun f12 (S11 S10) S1)
(declare-fun f13 (S5 S9) S11)
(declare-fun f14 (S6 S10 S2 S10) S1)
(declare-fun f15 (S12 S6) S2)
(declare-fun f16 () S12)
(declare-fun f17 () S6)
(declare-fun f18 (S13 S2) Int)
(declare-fun f19 () S13)
(declare-fun f20 (S14 S15) S6)
(declare-fun f21 () S14)
(declare-fun f22 (S8) S15)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 0) (f6 f7 (f8 f9 f10) f11)) f1)))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S6) (?v3 S5)) (= (= (f3 ?v0 (f6 ?v1 ?v2 ?v3)) f1) (forall ((?v4 S9) (?v5 S10)) (=> (= (f12 (f13 ?v1 ?v4) ?v5) f1) (forall ((?v6 S10)) (=> (= (f14 ?v2 ?v5 ?v0 ?v6) f1) (= (f12 (f13 ?v3 ?v4) ?v6) f1))))))))
(assert (= (f15 f16 f17) (f4 f5 0)))
(assert (forall ((?v0 S8) (?v1 S10) (?v2 S2) (?v3 S10)) (=> (= (f14 (f8 f9 ?v0) ?v1 ?v2 ?v3) f1) (=> (forall ((?v4 S2)) (=> (= ?v2 (f4 f5 (+ (f18 f19 ?v4) 1))) (=> (= (f14 (f20 f21 (f22 ?v0)) ?v1 ?v4 ?v3) f1) false))) false))))
(assert (forall ((?v0 S2)) (= (f4 f5 (f18 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f18 f19 (f4 f5 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f18 f19 (f4 f5 ?v0)) 0))))
(check-sat)
(exit)
