(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 Int) S3)
(declare-fun f5 (S5 Int) S4)
(declare-fun f6 () S5)
(declare-fun f7 () S4)
(declare-fun f8 () Int)
(declare-fun f9 (S6 Int) Int)
(declare-fun f10 (S7 Int) S6)
(declare-fun f11 () S7)
(declare-fun f12 (S8 S2) Int)
(declare-fun f13 () S8)
(declare-fun f14 (S9 S10) S2)
(declare-fun f15 (S11 S12) S9)
(declare-fun f16 () S11)
(declare-fun f17 () S12)
(declare-fun f18 () S10)
(declare-fun f19 () S12)
(declare-fun f20 (S13 S10) S10)
(declare-fun f21 (S4 S5 S5) S13)
(declare-fun f22 (S14 S10) S10)
(declare-fun f23 (S15 Int) S14)
(declare-fun f24 () S15)
(declare-fun f25 (S16 S13) S1)
(declare-fun f26 (S17 S2) S16)
(declare-fun f27 (S18 Int) S17)
(declare-fun f28 (S19 Int) S18)
(declare-fun f29 () S19)
(declare-fun f30 () Int)
(declare-fun f31 () Int)
(declare-fun f32 (S20 S2) S2)
(declare-fun f33 (S21 Int) S20)
(declare-fun f34 () S21)
(declare-fun f35 () Int)
(declare-fun f36 () S2)
(declare-fun f37 (S10) S13)
(declare-fun f38 () S16)
(declare-fun f39 () S2)
(declare-fun f40 (S12 S16) Int)
(declare-fun f41 (S10) S22)
(declare-fun f42 (S16 S10) S10)
(declare-fun f43 () S19)
(declare-fun f44 () S2)
(declare-fun f45 () S22)
(declare-fun f46 (Int S23) S1)
(declare-fun f47 (S2) S23)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (= (f3 (f4 (f5 f6 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f3 (f4 f7 ?v0) ?v1) f1) false)))
(assert (not false))
(assert (<= 0 f8))
(assert (let ((?v_0 (f12 f13 (f14 (f15 f16 f17) f18)))) (< f8 (f9 (f10 f11 ?v_0) (f12 f13 (f14 (f15 f16 f19) (f20 (f21 f7 f6 f6) (f22 (f23 f24 ?v_0) f18))))))))
(assert (= (f25 (f26 (f27 (f28 f29 f30) f31) (f32 (f33 f34 f35) f36)) (f37 f18)) f1))
(assert (= f38 (f26 (f27 (f28 f29 f30) f31) (f32 (f33 f34 f35) f36))))
(assert (= f39 (f32 (f33 f34 f35) f36)))
(assert (forall ((?v0 S16)) (=> (= (f25 ?v0 (f37 f18)) f1) (and (not (= (f40 f17 ?v0) 0)) (not (= (f40 f19 ?v0) 0))))))
(assert (let ((?v_0 (f12 f13 (f14 (f15 f16 f17) f18)))) (= (f41 (f42 (f26 (f27 (f28 f43 ?v_0) 0) (f32 (f33 f34 1) f44)) (f22 (f23 f24 ?v_0) f18))) f45)))
(assert (not (= f35 0)))
(assert (forall ((?v0 Int)) (=> (= (f46 ?v0 (f47 (f14 (f15 f16 f17) f18))) f1) (not (= ?v0 0)))))
(assert (= (f46 f35 (f47 (f14 (f15 f16 f17) f18))) f1))
(assert (let ((?v_0 (f12 f13 (f14 (f15 f16 f17) f18)))) (and (<= ?v_0 0) (< f35 ?v_0))))
(assert (forall ((?v0 S2)) (=> (forall ((?v1 Int)) (=> (= (f46 ?v1 (f47 ?v0)) f1) (not (= ?v1 0)))) (< 0 (f12 f13 ?v0)))))
(check-sat)
(exit)
