(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2) Int)
(declare-fun f6 () S3)
(declare-fun f7 (S2) Int)
(declare-fun f8 (S6 S5) S4)
(declare-fun f9 (S7 S4) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S3 S4) S1)
(declare-fun f12 (S8 S9) S6)
(declare-fun f13 (S10 S6) S8)
(declare-fun f14 () S10)
(declare-fun f15 () S6)
(declare-fun f16 () S9)
(declare-fun f17 () S5)
(declare-fun f18 (S2 S3) S1)
(declare-fun f19 (S5) S3)
(declare-fun f20 (S9 S5) S5)
(declare-fun f21 (S4) S1)
(declare-fun f22 (S11 S4) S4)
(declare-fun f23 (S12 S4) S11)
(declare-fun f24 () S12)
(declare-fun f25 () S12)
(declare-fun f26 () S11)
(declare-fun f27 () S4)
(declare-fun f28 () S4)
(declare-fun f29 () S12)
(declare-fun f30 () S12)
(declare-fun f31 (S13 S2) S2)
(declare-fun f32 () S13)
(declare-fun f33 (S14 S2) S4)
(declare-fun f34 () S14)
(declare-fun f35 () S11)
(declare-fun f36 (S15 S13) S11)
(declare-fun f37 () S15)
(declare-fun f38 () S11)
(declare-fun f39 () S11)
(declare-fun f40 (S16 S6) S11)
(declare-fun f41 (S17 S13) S16)
(declare-fun f42 (S18 S3) S17)
(declare-fun f43 (S19 S14) S18)
(declare-fun f44 () S19)
(declare-fun f45 () S14)
(declare-fun f46 (S4) S3)
(declare-fun f47 (S20 S6) S6)
(declare-fun f48 (S21 S13) S20)
(declare-fun f49 (S22 S3) S21)
(declare-fun f50 () S22)
(declare-fun f51 (S23 S14) S11)
(declare-fun f52 () S23)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (not (= (f5 ?v0) 0)))))
(assert (forall ((?v0 S2)) (= (= (f3 f6 ?v0) f1) (not (= (f7 ?v0) 0)))))
(assert (forall ((?v0 S4) (?v1 S5)) (= (f8 (f9 f10 ?v0) ?v1) ?v0)))
(assert (not (= (f11 f6 (f8 (f12 (f13 f14 f15) f16) f17)) f1)))
(assert (forall ((?v0 S2)) (=> (= (f18 ?v0 (f19 f17)) f1) (and (not (= (f5 ?v0) 0)) (not (= (f7 ?v0) 0))))))
(assert (forall ((?v0 S5) (?v1 S2)) (=> (forall ((?v2 S2)) (=> (= (f18 ?v2 (f19 ?v0)) f1) (not (= (f7 ?v2) 0)))) (=> (forall ((?v2 S2)) (=> (= (f18 ?v2 (f19 ?v0)) f1) (not (= (f5 ?v2) 0)))) (=> (= (f18 ?v1 (f19 (f20 f16 ?v0))) f1) (not (= (f7 ?v1) 0)))))))
(assert (forall ((?v0 S5)) (= (f21 (f8 (f12 (f13 f14 f15) f16) ?v0)) f1)))
(assert (forall ((?v0 S4) (?v1 S9) (?v2 S5)) (= (f8 (f12 (f13 f14 (f9 f10 ?v0)) ?v1) ?v2) ?v0)))
(assert (forall ((?v0 S6) (?v1 S9) (?v2 S5)) (= (f8 (f12 (f13 f14 ?v0) ?v1) ?v2) (f8 ?v0 (f20 ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S9) (?v2 S5)) (= (f8 (f12 (f13 f14 ?v0) ?v1) ?v2) (f8 ?v0 (f20 ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S9) (?v2 S6) (?v3 S5)) (=> (= (f12 (f13 f14 ?v0) ?v1) ?v2) (= (f8 ?v0 (f20 ?v1 ?v3)) (f8 ?v2 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f11 f6 ?v0) f1) (=> (= (f11 f6 ?v1) f1) (= (f11 f6 (f22 (f23 f24 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f11 f6 ?v0) f1) (=> (= (f11 f6 ?v1) f1) (= (f11 f6 (f22 (f23 f25 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f21 ?v0) f1) (=> (= (f21 ?v1) f1) (= (f21 (f22 (f23 f24 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f21 ?v0) f1) (=> (= (f21 ?v1) f1) (= (f21 (f22 (f23 f25 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4)) (= (= (f11 f6 (f22 f26 ?v0)) f1) (= (f11 f6 ?v0) f1))))
(assert (= (f11 f6 f27) f1))
(assert (= (f11 f6 f28) f1))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f11 f6 (f22 (f23 f29 ?v0) ?v1)) f1) (and (= (f11 f6 ?v0) f1) (= (f11 f6 ?v1) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f11 f6 (f22 (f23 f30 ?v0) ?v1)) f1) (and (= (f11 f6 ?v0) f1) (= (f11 f6 ?v1) f1)))))
(assert (forall ((?v0 S2)) (=> (not (not (= (f5 ?v0) 0))) (=> (not (= (f7 ?v0) 0)) (not (= (f7 (f31 f32 ?v0)) 0))))))
(assert (forall ((?v0 S2)) (= (= (f11 f6 (f33 f34 ?v0)) f1) (not (= (f7 ?v0) 0)))))
(assert (forall ((?v0 S4)) (= (= (f11 f6 (f22 f35 ?v0)) f1) (= (f11 f6 ?v0) f1))))
(assert (forall ((?v0 S13) (?v1 S4)) (=> (forall ((?v2 S2)) (= (not (= (f7 (f31 ?v0 ?v2)) 0)) (not (= (f7 ?v2) 0)))) (= (= (f11 f6 (f22 (f36 f37 ?v0) ?v1)) f1) (= (f11 f6 ?v1) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f22 (f23 f24 ?v0) ?v1) (ite (= ?v0 f27) ?v1 (ite (= ?v1 f27) ?v0 (ite (or (= ?v0 f28) (= ?v1 f28)) f28 (f22 (f23 f30 ?v0) ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f22 (f23 f25 ?v0) ?v1) (ite (= ?v0 f28) ?v1 (ite (= ?v1 f28) ?v0 (ite (or (= ?v0 f27) (= ?v1 f27)) f27 (f22 (f23 f29 ?v0) ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (= (f22 (f23 f29 ?v0) ?v1) (f22 (f23 f29 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (= (f22 (f23 f30 ?v0) ?v1) (f22 (f23 f30 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f33 f34 ?v0) (f33 f34 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f22 f35 ?v0) (f22 f35 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f22 f26 ?v0) (f22 f26 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S13) (?v1 S4) (?v2 S4)) (let ((?v_0 (f36 f37 ?v0))) (= (f22 ?v_0 (f22 (f23 f29 ?v1) ?v2)) (f22 (f23 f29 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 S13) (?v1 S4) (?v2 S4)) (let ((?v_0 (f36 f37 ?v0))) (= (f22 ?v_0 (f22 (f23 f30 ?v1) ?v2)) (f22 (f23 f30 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 S13) (?v1 S4)) (let ((?v_0 (f36 f37 ?v0))) (= (f22 ?v_0 (f22 f35 ?v1)) (f22 f35 (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 S13) (?v1 S4)) (let ((?v_0 (f36 f37 ?v0))) (= (f22 ?v_0 (f22 f26 ?v1)) (f22 f26 (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 S13) (?v1 S2)) (= (f22 (f36 f37 ?v0) (f33 f34 ?v1)) (f33 f34 (f31 ?v0 ?v1)))))
(assert (forall ((?v0 S13)) (= (f22 (f36 f37 ?v0) f27) f27)))
(assert (forall ((?v0 S13)) (= (f22 (f36 f37 ?v0) f28) f28)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (not (= (f22 (f23 f29 ?v0) ?v1) (f22 (f23 f30 ?v2) ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (not (= (f22 (f23 f30 ?v0) ?v1) (f22 (f23 f29 ?v2) ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (not (= (f22 (f23 f29 ?v0) ?v1) (f33 f34 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f22 (f23 f29 ?v0) ?v1) (f22 f35 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f22 (f23 f29 ?v0) ?v1) (f22 f26 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (not (= (f22 (f23 f30 ?v0) ?v1) (f33 f34 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f22 (f23 f30 ?v0) ?v1) (f22 f35 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f22 (f23 f30 ?v0) ?v1) (f22 f26 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f22 (f23 f29 ?v0) ?v1) f27))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f22 (f23 f29 ?v0) ?v1) f28))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f22 (f23 f30 ?v0) ?v1) f27))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f22 (f23 f30 ?v0) ?v1) f28))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S4)) (not (= (f33 f34 ?v0) (f22 (f23 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S4)) (not (= (f33 f34 ?v0) (f22 (f23 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f22 f35 ?v0) (f22 (f23 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f22 f35 ?v0) (f22 (f23 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f22 f26 ?v0) (f22 (f23 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f22 f26 ?v0) (f22 (f23 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S4)) (not (= (f33 f34 ?v0) (f22 f35 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S4)) (not (= (f33 f34 ?v0) (f22 f26 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S2)) (not (= (f22 f35 ?v0) (f33 f34 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f22 f35 ?v0) (f22 f26 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S2)) (not (= (f22 f26 ?v0) (f33 f34 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f22 f26 ?v0) (f22 f35 ?v1)))))
(assert (forall ((?v0 S2)) (not (= (f33 f34 ?v0) f27))))
(assert (forall ((?v0 S2)) (not (= (f33 f34 ?v0) f28))))
(assert (forall ((?v0 S4)) (not (= (f22 f35 ?v0) f27))))
(assert (forall ((?v0 S4)) (not (= (f22 f35 ?v0) f28))))
(assert (forall ((?v0 S4)) (not (= (f22 f26 ?v0) f27))))
(assert (forall ((?v0 S4)) (not (= (f22 f26 ?v0) f28))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= f27 (f22 (f23 f29 ?v0) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= f27 (f22 (f23 f30 ?v0) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= f28 (f22 (f23 f29 ?v0) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= f28 (f22 (f23 f30 ?v0) ?v1)))))
(assert (forall ((?v0 S2)) (not (= f27 (f33 f34 ?v0)))))
(assert (forall ((?v0 S4)) (not (= f27 (f22 f35 ?v0)))))
(assert (forall ((?v0 S4)) (not (= f27 (f22 f26 ?v0)))))
(assert (forall ((?v0 S2)) (not (= f28 (f33 f34 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (= (f18 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S4)) (not (= f28 (f22 f35 ?v0)))))
(assert (forall ((?v0 S4)) (not (= f28 (f22 f26 ?v0)))))
(assert (not (= f27 f28)))
(assert (not (= f28 f27)))
(assert (forall ((?v0 S4)) (= (= (f21 (f22 f35 ?v0)) f1) (= (f21 ?v0) f1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f21 (f22 (f23 f30 ?v0) ?v1)) f1) (and (= (f21 ?v0) f1) (= (f21 ?v1) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f21 (f22 (f23 f29 ?v0) ?v1)) f1) (and (= (f21 ?v0) f1) (= (f21 ?v1) f1)))))
(assert (= (= (f21 f27) f1) true))
(assert (= (= (f21 f28) f1) true))
(assert (forall ((?v0 S2)) (= (= (f21 (f33 f34 ?v0)) f1) true)))
(assert (forall ((?v0 S4)) (= (= (f21 (f22 f26 ?v0)) f1) false)))
(assert (forall ((?v0 S13) (?v1 S4)) (= (= (f21 (f22 (f36 f37 ?v0) ?v1)) f1) (= (f21 ?v1) f1))))
(assert (forall ((?v0 S4)) (= (f22 f38 ?v0) (ite (= ?v0 f28) f27 (ite (= ?v0 f27) f28 (f22 f35 ?v0))))))
(assert (forall ((?v0 S4)) (=> (=> (= ?v0 f28) false) (=> (=> (= ?v0 f27) false) (=> (forall ((?v1 S2)) (=> (= ?v0 (f33 f34 ?v1)) false)) (=> (forall ((?v1 S4) (?v2 S4)) (=> (= ?v0 (f22 (f23 f29 ?v1) ?v2)) false)) (=> (forall ((?v1 S4) (?v2 S4)) (=> (= ?v0 (f22 (f23 f30 ?v1) ?v2)) false)) (=> (forall ((?v1 S4)) (=> (= ?v0 (f22 f35 ?v1)) false)) (=> (forall ((?v1 S4)) (=> (= ?v0 (f22 f26 ?v1)) false)) false)))))))))
(assert (= f39 (f40 (f41 (f42 (f43 f44 f45) f4) f32) (f12 (f13 f14 f15) f16))))
(assert (forall ((?v0 S4)) (= (= (f21 (f22 f38 ?v0)) f1) (= (f21 ?v0) f1))))
(assert (forall ((?v0 S6) (?v1 S4) (?v2 S4)) (let ((?v_0 (f40 (f41 (f42 (f43 f44 f45) f4) f32) ?v0))) (= (f22 ?v_0 (f22 (f23 f30 ?v1) ?v2)) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S4) (?v2 S4)) (let ((?v_0 (f40 (f41 (f42 (f43 f44 f45) f4) f32) ?v0))) (= (f22 ?v_0 (f22 (f23 f29 ?v1) ?v2)) (f22 (f23 f25 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S2)) (=> (forall ((?v3 S5)) (=> (forall ((?v4 S2)) (=> (= (f18 ?v4 (f19 ?v3)) f1) (and (not (= (f5 ?v4) 0)) (not (= (f7 ?v4) 0))))) (= (f11 f6 (f8 ?v0 ?v3)) f1))) (=> (forall ((?v3 S2)) (=> (= (f18 ?v3 (f19 ?v1)) f1) (not (= (f7 ?v3) 0)))) (=> (= (f18 ?v2 (f46 (f8 (f47 (f48 (f49 f50 f4) f32) ?v0) ?v1))) f1) (not (= (f7 ?v2) 0)))))))
(assert (forall ((?v0 S2)) (=> (not (= (f7 ?v0) 0)) (forall ((?v1 S2)) (=> (= (f18 ?v1 (f46 (f33 f45 ?v0))) f1) (not (= (f7 ?v1) 0)))))))
(assert (forall ((?v0 S6) (?v1 S4)) (let ((?v_0 (f40 (f41 (f42 (f43 f44 f45) f4) f32) ?v0))) (= (f22 ?v_0 (f22 f35 ?v1)) (f22 f38 (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 S4)) (= (f46 (f22 f35 ?v0)) (f46 ?v0))))
(assert (forall ((?v0 S4)) (= (f46 (f22 f26 ?v0)) (f46 ?v0))))
(assert (forall ((?v0 S6) (?v1 S2)) (let ((?v_0 (f33 f34 ?v1))) (= (f22 (f40 (f41 (f42 (f43 f44 f45) f4) f32) ?v0) ?v_0) ?v_0))))
(assert (forall ((?v0 S6)) (= (f22 (f40 (f41 (f42 (f43 f44 f45) f4) f32) ?v0) f27) f27)))
(assert (forall ((?v0 S6)) (= (f22 (f40 (f41 (f42 (f43 f44 f45) f4) f32) ?v0) f28) f28)))
(assert (forall ((?v0 S2)) (=> (not (= (f7 ?v0) 0)) (= (f11 f6 (f33 f45 ?v0)) f1))))
(assert (forall ((?v0 S6) (?v1 S4)) (=> (forall ((?v2 S5)) (=> (forall ((?v3 S2)) (=> (= (f18 ?v3 (f19 ?v2)) f1) (not (= (f5 ?v3) 0)))) (= (f21 (f8 ?v0 ?v2)) f1))) (= (f21 (f22 (f40 (f41 (f42 (f43 f44 f45) f4) f32) ?v0) ?v1)) f1))))
(assert (forall ((?v0 S6) (?v1 S4)) (=> (forall ((?v2 S5)) (=> (forall ((?v3 S2)) (=> (= (f18 ?v3 (f19 ?v2)) f1) (not (= (f5 ?v3) 0)))) (= (f21 (f8 ?v0 ?v2)) f1))) (=> (forall ((?v2 S5)) (=> (forall ((?v3 S2)) (=> (= (f18 ?v3 (f19 ?v2)) f1) (and (not (= (f5 ?v3) 0)) (not (= (f7 ?v3) 0))))) (= (f11 f6 (f8 ?v0 ?v2)) f1))) (=> (= (f11 f6 ?v1) f1) (= (f11 f6 (f22 (f40 (f41 (f42 (f43 f44 f45) f4) f32) ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S4)) (=> (= (f21 ?v0) f1) (=> (= (f11 f6 ?v0) f1) (forall ((?v1 S2)) (=> (= (f18 ?v1 (f46 (f22 (f51 f52 f45) ?v0))) f1) (not (= (f7 ?v1) 0))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f51 f52 f45))) (= (f22 ?v_0 (f22 f35 (f22 (f23 f29 ?v0) ?v1))) (f22 (f23 f30 (f22 ?v_0 (f22 f35 ?v0))) (f22 ?v_0 (f22 f35 ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f51 f52 f45))) (= (f22 ?v_0 (f22 f35 (f22 (f23 f30 ?v0) ?v1))) (f22 (f23 f29 (f22 ?v_0 (f22 f35 ?v0))) (f22 ?v_0 (f22 f35 ?v1)))))))
(assert (forall ((?v0 S4)) (= (= (f21 (f22 (f51 f52 f45) ?v0)) f1) (= (f21 ?v0) f1))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f51 f52 f45))) (= (f22 ?v_0 (f22 f35 (f22 f35 ?v0))) (f22 ?v_0 ?v0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f33 f34 ?v0))) (= (f22 (f51 f52 f45) ?v_0) ?v_0))))
(check-sat)
(exit)
