(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-sort S25 0)
(declare-sort S26 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) S2)
(declare-fun f7 (S6 S2) S5)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S2) S2)
(declare-fun f10 (S8 S4) S7)
(declare-fun f11 () S8)
(declare-fun f12 (S9 S10) S1)
(declare-fun f13 (S11 S9) S9)
(declare-fun f14 (S9) S11)
(declare-fun f15 (S12 S13) S1)
(declare-fun f16 (S14 S12) S12)
(declare-fun f17 (S12) S14)
(declare-fun f18 (S15 S3) S3)
(declare-fun f19 (S3) S15)
(declare-fun f20 (S16 S17) S2)
(declare-fun f21 (S18 S2) S16)
(declare-fun f22 (S19 S20) S18)
(declare-fun f23 () S19)
(declare-fun f24 () S20)
(declare-fun f25 () S5)
(declare-fun f26 () S4)
(declare-fun f27 () S17)
(declare-fun f28 () S4)
(declare-fun f29 (S3 S17) S1)
(declare-fun f30 (S21 S4) Int)
(declare-fun f31 () S21)
(declare-fun f32 (S22 Int) S4)
(declare-fun f33 () S22)
(declare-fun f34 (S20 S2) S7)
(declare-fun f35 (S12 S23) S1)
(declare-fun f36 (S9) S12)
(declare-fun f37 () S7)
(declare-fun f38 () S17)
(declare-fun f39 (S24 S17) S17)
(declare-fun f40 (S25 S7) S24)
(declare-fun f41 () S25)
(declare-fun f42 (S26 S2) S4)
(declare-fun f43 () S26)
(declare-fun f44 () S13)
(declare-fun f45 () S23)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (and (= (f3 f5 ?v0) f1) (forall ((?v1 S4)) (= (f3 f5 (f6 (f7 f8 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (= (f9 (f10 f11 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S10)) (= (= (f12 (f13 (f14 ?v0) ?v1) ?v2) f1) (and (= (f12 ?v0 ?v2) f1) (= (f12 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S13)) (= (= (f15 (f16 (f17 ?v0) ?v1) ?v2) f1) (and (= (f15 ?v0 ?v2) f1) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f18 (f19 ?v0) ?v1) ?v2) f1) (and (= (f3 ?v0 ?v2) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (not (= (f3 f5 (f6 (f7 f8 (f20 (f21 (f22 f23 f24) (f6 f25 f26)) f27)) f28)) f1)))
(assert (= (f29 f4 f27) f1))
(assert (forall ((?v0 S17) (?v1 S4)) (=> (= (f29 f5 ?v0) f1) (= (f3 f5 (f20 (f21 (f22 f23 f24) (f6 f25 ?v1)) ?v0)) f1))))
(assert (forall ((?v0 S4) (?v1 S17) (?v2 S4) (?v3 S17)) (let ((?v_0 (f22 f23 f24))) (= (= (f20 (f21 ?v_0 (f6 f25 ?v0)) ?v1) (f20 (f21 ?v_0 (f6 f25 ?v2)) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f6 f25 ?v0)) (?v_1 (f30 f31 ?v0))) (= (f6 (f7 f8 ?v_0) ?v1) (ite (< ?v_1 (f30 f31 ?v1)) ?v_0 (f6 f25 (f32 f33 (+ ?v_1 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f6 (f7 f8 (f9 (f34 f24 ?v0) ?v1)) ?v2) (f9 (f34 f24 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (not (= (f6 f25 ?v0) (f9 (f34 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (not (= (f9 (f34 f24 ?v0) ?v1) (f6 f25 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S17) (?v2 S2)) (let ((?v_0 (f22 f23 f24))) (= (= (f20 (f21 ?v_0 ?v0) ?v1) (f20 (f21 ?v_0 ?v2) ?v1)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S23)) (= (= (f35 (f16 (f17 ?v0) ?v1) ?v2) f1) (and (= (f35 ?v0 ?v2) f1) (= (f35 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S13)) (= (= (f15 (f36 (f13 (f14 ?v0) ?v1)) ?v2) f1) (and (= (f15 (f36 ?v0) ?v2) f1) (= (f15 (f36 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S17)) (= (= (f29 (f18 (f19 ?v0) ?v1) ?v2) f1) (and (= (f29 ?v0 ?v2) f1) (= (f29 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (+ (f30 f31 ?v1) 1)) (?v_1 (f7 f8 ?v2))) (=> (< (f30 f31 ?v0) ?v_0) (= (f6 (f7 f8 (f6 ?v_1 ?v0)) (f32 f33 ?v_0)) (f6 (f7 f8 (f6 ?v_1 ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 f25 ?v0) (f6 f25 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f9 (f34 f24 ?v0) ?v1) (f9 (f34 f24 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S20) (?v1 S2) (?v2 S17) (?v3 S2)) (let ((?v_0 (f22 f23 ?v0))) (=> (forall ((?v4 S2) (?v5 S2) (?v6 S2)) (let ((?v_1 (f34 ?v0 ?v6))) (= (f9 (f34 ?v0 (f9 ?v_1 ?v4)) ?v5) (f9 (f34 ?v0 (f9 ?v_1 ?v5)) ?v4)))) (= (f9 (f34 ?v0 (f20 (f21 ?v_0 ?v1) ?v2)) ?v3) (f20 (f21 ?v_0 (f9 (f34 ?v0 ?v1) ?v3)) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S17) (?v2 S2) (?v3 S17)) (let ((?v_0 (f22 f23 f24))) (not (= (f20 (f21 ?v_0 (f6 f25 ?v0)) ?v1) (f20 (f21 ?v_0 (f9 f37 ?v2)) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4) (?v3 S17)) (not (= (f9 (f34 f24 (f9 f37 ?v0)) ?v1) (f20 (f21 (f22 f23 f24) (f6 f25 ?v2)) ?v3)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S17)) (let ((?v_0 (f6 f25 ?v0))) (= (= ?v_0 (f20 (f21 (f22 f23 f24) ?v1) ?v2)) (and (= ?v_0 ?v1) (= ?v2 f38))))))
(assert (forall ((?v0 S2) (?v1 S17) (?v2 S4)) (let ((?v_0 (f22 f23 f24))) (= (f6 (f7 f8 (f20 (f21 ?v_0 ?v0) ?v1)) ?v2) (f20 (f21 ?v_0 (f6 (f7 f8 ?v0) ?v2)) (f39 (f40 f41 (f10 f11 ?v2)) ?v1))))))
(assert (forall ((?v0 S4)) (= (f42 f43 (f6 f25 ?v0)) (f32 f33 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f42 f43 (f9 (f34 f24 ?v0) ?v1)) (f32 f33 (+ (+ (f30 f31 (f42 f43 ?v0)) (f30 f31 (f42 f43 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S9)) (= (f15 (f36 ?v0) f44) f1)))
(assert (forall ((?v0 S12)) (= (f35 ?v0 f45) f1)))
(assert (forall ((?v0 S3)) (= (f29 ?v0 f38) f1)))
(assert (forall ((?v0 S2)) (=> (= (f3 f5 ?v0) f1) (= (f3 f5 (f9 f37 ?v0)) f1))))
(assert (forall ((?v0 S2)) (= (f42 f43 (f9 f37 ?v0)) (f32 f33 (+ (f30 f31 (f42 f43 ?v0)) (+ 0 1))))))
(assert (forall ((?v0 S7) (?v1 S17)) (= (= f38 (f39 (f40 f41 ?v0) ?v1)) (= ?v1 f38))))
(assert (forall ((?v0 S7)) (= (f39 (f40 f41 ?v0) f38) f38)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f9 f37 ?v0) (f9 f37 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S17)) (= (= (f39 (f40 f41 ?v0) ?v1) f38) (= ?v1 f38))))
(assert (forall ((?v0 S4)) (= (f32 f33 (f30 f31 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f30 f31 (f32 f33 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f30 f31 (f32 f33 ?v0)) 0))))
(check-sat)
(exit)
