(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S4 S3) S3)
(declare-fun f6 (S5 S3) S4)
(declare-fun f7 () S5)
(declare-fun f8 () S3)
(declare-fun f9 (S6 S7) S3)
(declare-fun f10 () S6)
(declare-fun f11 () S7)
(declare-fun f12 (S8 S3) S6)
(declare-fun f13 (S9 S3) S8)
(declare-fun f14 () S9)
(declare-fun f15 () S8)
(declare-fun f16 (S2 S10) S1)
(declare-fun f17 (S11 S10) S3)
(declare-fun f18 (S12 S3) S11)
(declare-fun f19 (S13 S5) S12)
(declare-fun f20 () S13)
(declare-fun f21 (S14 S3) S7)
(declare-fun f22 () S14)
(declare-fun f23 (S15 Int) S7)
(declare-fun f24 () S15)
(declare-fun f25 (S16 S7) Int)
(declare-fun f26 () S16)
(declare-fun f27 () S4)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 (f6 f7 f8) (f9 f10 f11))) f1)))
(assert (= (f3 f4 f8) f1))
(assert (forall ((?v0 S7)) (= (f3 f4 (f9 f10 ?v0)) f1)))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S3)) (not (= (f9 f10 ?v0) (f5 (f6 f7 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S7)) (not (= (f5 (f6 f7 ?v0) ?v1) (f9 f10 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 f10 ?v0) (f9 f10 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S7)) (=> (= (f3 f4 ?v0) f1) (= (f3 f4 (f9 (f12 (f13 f14 ?v0) (f9 f10 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S7)) (=> (= (f3 f4 ?v0) f1) (= (f3 f4 (f9 (f12 f15 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S10) (?v1 S7)) (=> (= (f16 f4 ?v0) f1) (= (f3 f4 (f17 (f18 (f19 f20 f7) (f9 f10 ?v1)) ?v0)) f1))))
(assert (forall ((?v0 S7) (?v1 S10) (?v2 S7) (?v3 S10)) (let ((?v_0 (f19 f20 f7))) (= (= (f17 (f18 ?v_0 (f9 f10 ?v0)) ?v1) (f17 (f18 ?v_0 (f9 f10 ?v2)) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S7)) (= (f21 f22 (f9 f10 ?v0)) (f23 f24 0))))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S3)) (= (f9 (f12 (f13 f14 (f9 (f12 f15 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S3)) (let ((?v_0 (+ (f25 f26 ?v1) 1)) (?v_1 (f12 f15 ?v2))) (=> (< (f25 f26 ?v0) ?v_0) (= (f9 (f12 f15 (f9 ?v_1 ?v0)) (f23 f24 ?v_0)) (f9 (f12 f15 (f9 ?v_1 ?v1)) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S3) (?v3 S3)) (let ((?v_0 (+ (f25 f26 ?v1) 1))) (=> (< (f25 f26 ?v0) ?v_0) (= (f9 (f12 f15 (f9 (f12 (f13 f14 ?v2) ?v3) ?v1)) ?v0) (f9 (f12 (f13 f14 (f9 (f12 f15 ?v2) ?v0)) (f9 (f12 f15 ?v3) ?v0)) (f23 f24 ?v_0)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S3) (?v3 S3)) (let ((?v_0 (+ (f25 f26 ?v1) 1))) (=> (< (f25 f26 ?v0) ?v_0) (= (f9 (f12 f15 (f9 (f12 (f13 f14 ?v2) ?v3) ?v0)) ?v1) (f9 (f12 (f13 f14 (f9 (f12 f15 ?v2) (f23 f24 ?v_0))) (f9 (f12 f15 ?v3) ?v1)) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S3) (?v3 S3) (?v4 S3)) (let ((?v_0 (+ (f25 f26 ?v1) 1)) (?v_1 (f13 f14 ?v2))) (=> (< (f25 f26 ?v0) ?v_0) (= (f9 (f12 (f13 f14 (f9 (f12 ?v_1 (f9 (f12 f15 ?v3) ?v0)) (f23 f24 ?v_0))) (f9 (f12 (f13 f14 ?v4) ?v3) ?v1)) ?v0) (f9 (f12 (f13 f14 (f9 (f12 ?v_1 ?v4) ?v0)) ?v3) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S10) (?v2 S3)) (let ((?v_0 (f19 f20 f7))) (= (= (f17 (f18 ?v_0 ?v0) ?v1) (f17 (f18 ?v_0 ?v2) ?v1)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S7)) (= (f9 (f12 (f13 f14 (f5 (f6 f7 ?v0) ?v1)) ?v2) ?v3) (f5 (f6 f7 (f9 (f12 (f13 f14 ?v0) ?v2) ?v3)) (f9 (f12 (f13 f14 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S3)) (let ((?v_0 (f25 f26 ?v1))) (=> (< (f25 f26 ?v0) ?v_0) (= (f9 (f12 (f13 f14 (f9 f10 ?v1)) ?v2) ?v0) (f9 f10 (f23 f24 (- ?v_0 1))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S3)) (let ((?v_0 (f9 f10 ?v0))) (=> (< (f25 f26 ?v0) (f25 f26 ?v1)) (= (f9 (f12 (f13 f14 ?v_0) ?v2) ?v1) ?v_0)))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S7)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f25 f26 ?v0))) (= (f9 (f12 (f13 f14 ?v_1) ?v1) ?v2) (ite (< (f25 f26 ?v2) ?v_0) (f9 f10 (f23 f24 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S3)) (= (f9 (f12 (f13 f14 (f9 f10 ?v0)) ?v1) ?v0) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S7)) (= (f9 (f12 f15 (f5 (f6 f7 ?v0) ?v1)) ?v2) (f5 (f6 f7 (f9 (f12 f15 ?v0) ?v2)) (f9 (f12 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f25 f26 ?v0))) (= (f9 (f12 f15 ?v_0) ?v1) (ite (< ?v_1 (f25 f26 ?v1)) ?v_0 (f9 f10 (f23 f24 (+ ?v_1 1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f21 f22 (f5 (f6 f7 ?v0) ?v1)) (f23 f24 (+ (+ (f25 f26 (f21 f22 ?v0)) (f25 f26 (f21 f22 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S10)) (let ((?v_0 (f19 f20 f7))) (=> (= (f3 f4 (f17 (f18 ?v_0 (f9 (f12 (f13 f14 ?v0) ?v1) (f23 f24 0))) ?v2)) f1) (=> (= (f3 f4 ?v1) f1) (= (f3 f4 (f17 (f18 ?v_0 (f5 (f6 f7 (f5 f27 ?v0)) ?v1)) ?v2)) f1))))))
(assert (forall ((?v0 S3)) (= (= (f3 f4 ?v0) f1) (or (exists ((?v1 S10) (?v2 S7)) (and (= ?v0 (f17 (f18 (f19 f20 f7) (f9 f10 ?v2)) ?v1)) (= (f16 f4 ?v1) f1))) (or (exists ((?v1 S3)) (and (= ?v0 (f5 f27 ?v1)) (= (f3 f4 ?v1) f1))) (exists ((?v1 S3) (?v2 S3) (?v3 S10)) (let ((?v_0 (f19 f20 f7))) (and (= ?v0 (f17 (f18 ?v_0 (f5 (f6 f7 (f5 f27 ?v1)) ?v2)) ?v3)) (and (= (f3 f4 (f17 (f18 ?v_0 (f9 (f12 (f13 f14 ?v1) ?v2) (f23 f24 0))) ?v3)) f1) (= (f3 f4 ?v2) f1))))))))))
(assert (forall ((?v0 S7) (?v1 S10) (?v2 S3) (?v3 S10)) (let ((?v_0 (f19 f20 f7))) (not (= (f17 (f18 ?v_0 (f9 f10 ?v0)) ?v1) (f17 (f18 ?v_0 (f5 f27 ?v2)) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S7) (?v3 S10)) (not (= (f5 (f6 f7 (f5 f27 ?v0)) ?v1) (f17 (f18 (f19 f20 f7) (f9 f10 ?v2)) ?v3)))))
(assert (forall ((?v0 S7)) (= (f23 f24 (f25 f26 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f25 f26 (f23 f24 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f25 f26 (f23 f24 ?v0)) 0))))
(check-sat)
(exit)
