(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 () S3)
(declare-fun f5 (S4 S5) S2)
(declare-fun f6 (S6 S2) S4)
(declare-fun f7 (S7 S2) S6)
(declare-fun f8 () S7)
(declare-fun f9 () S2)
(declare-fun f10 () S5)
(declare-fun f11 (S8 S5) S3)
(declare-fun f12 (S9 S2) S8)
(declare-fun f13 () S9)
(declare-fun f14 (S10 S2) S1)
(declare-fun f15 () S10)
(declare-fun f16 (S11 S12) S2)
(declare-fun f17 (S13 S2) S11)
(declare-fun f18 (S14 S15) S13)
(declare-fun f19 () S14)
(declare-fun f20 () S15)
(declare-fun f21 () S4)
(declare-fun f22 () S5)
(declare-fun f23 () S12)
(declare-fun f24 (S10 S12) S1)
(declare-fun f25 (S16 S12) S12)
(declare-fun f26 (S17 S3) S16)
(declare-fun f27 () S17)
(declare-fun f28 () S2)
(declare-fun f29 () S2)
(declare-fun f30 (S15 S2) S3)
(declare-fun f31 (S18 S5) Int)
(declare-fun f32 () S18)
(declare-fun f33 (S19 Int) S5)
(declare-fun f34 () S19)
(declare-fun f35 () S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 (f6 (f7 f8 ?v0) f9) f10))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S2)) (= (f3 (f11 (f12 f13 ?v0) ?v1) ?v2) (f5 (f6 (f7 f8 ?v2) ?v0) ?v1))))
(assert (not (= (f14 f15 (f5 (f6 (f7 f8 (f16 (f17 (f18 f19 f20) (f5 f21 f22)) f23)) f9) f10)) f1)))
(assert (not (= f22 f10)))
(assert (= (f24 f15 (f25 (f26 f27 f4) f23)) f1))
(assert (= (f14 f15 f28) f1))
(assert (= (f14 f15 f29) f1))
(assert (not (= f22 f10)))
(assert (= (f14 f15 f9) f1))
(assert (forall ((?v0 S5)) (= (f14 f15 (f5 f21 ?v0)) f1)))
(assert (forall ((?v0 S2) (?v1 S5)) (=> (= (f14 f15 ?v0) f1) (= (f14 f15 (f3 (f30 f20 ?v0) (f5 f21 ?v1))) f1))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (=> (= (f14 f15 ?v0) f1) (= (f14 f15 (f5 (f6 (f7 f8 ?v0) (f5 f21 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S12) (?v1 S5)) (=> (= (f24 f15 ?v0) f1) (= (f14 f15 (f16 (f17 (f18 f19 f20) (f5 f21 ?v1)) ?v0)) f1))))
(assert (forall ((?v0 S5) (?v1 S12) (?v2 S5) (?v3 S12)) (let ((?v_0 (f18 f19 f20))) (= (= (f16 (f17 ?v_0 (f5 f21 ?v0)) ?v1) (f16 (f17 ?v_0 (f5 f21 ?v2)) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (= (f24 f15 (f25 (f26 f27 f4) f23)) f1))
(assert (forall ((?v0 S5) (?v1 S2)) (= (f5 (f6 (f7 f8 (f5 f21 ?v0)) ?v1) ?v0) ?v1)))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S5)) (let ((?v_1 (f5 f21 ?v0)) (?v_0 (f31 f32 ?v0))) (= (f5 (f6 (f7 f8 ?v_1) ?v1) ?v2) (ite (< (f31 f32 ?v2) ?v_0) (f5 f21 (f33 f34 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2)) (let ((?v_0 (f5 f21 ?v0))) (=> (< (f31 f32 ?v0) (f31 f32 ?v1)) (= (f5 (f6 (f7 f8 ?v_0) ?v2) ?v1) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2)) (let ((?v_0 (f31 f32 ?v1))) (=> (< (f31 f32 ?v0) ?v_0) (= (f5 (f6 (f7 f8 (f5 f21 ?v1)) ?v2) ?v0) (f5 f21 (f33 f34 (- ?v_0 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S5)) (= (f5 (f6 (f7 f8 (f3 (f30 f20 ?v0) ?v1)) ?v2) ?v3) (f3 (f30 f20 (f5 (f6 (f7 f8 ?v0) ?v2) ?v3)) (f5 (f6 (f7 f8 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S2)) (not (= (f5 f21 ?v0) (f3 (f30 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5)) (not (= (f3 (f30 f20 ?v0) ?v1) (f5 f21 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S12) (?v2 S2)) (let ((?v_0 (f18 f19 f20))) (= (= (f16 (f17 ?v_0 ?v0) ?v1) (f16 (f17 ?v_0 ?v2) ?v1)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S12)) (let ((?v_0 (f18 f19 f20))) (=> (= (f14 f15 (f16 (f17 ?v_0 (f5 (f6 (f7 f8 ?v0) ?v1) (f33 f34 0))) ?v2)) f1) (=> (= (f14 f15 ?v1) f1) (= (f14 f15 (f16 (f17 ?v_0 (f3 (f30 f20 (f3 f35 ?v0)) ?v1)) ?v2)) f1))))))
(assert (forall ((?v0 S2)) (=> (= (f14 f15 ?v0) f1) (= (f14 f15 (f3 f35 ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f35 ?v0) (f3 f35 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f3 (f30 f20 ?v0) ?v1) (f3 f35 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f3 f35 ?v0) (f3 (f30 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S2)) (not (= (f5 f21 ?v0) (f3 f35 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S5)) (not (= (f3 f35 ?v0) (f5 f21 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S12) (?v2 S2) (?v3 S5)) (let ((?v_0 (f18 f19 f20))) (= (f5 (f6 (f7 f8 (f16 (f17 ?v_0 ?v0) ?v1)) ?v2) ?v3) (f16 (f17 ?v_0 (f5 (f6 (f7 f8 ?v0) ?v2) ?v3)) (f25 (f26 f27 (f11 (f12 f13 ?v2) ?v3)) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S12) (?v2 S2) (?v3 S12)) (let ((?v_0 (f18 f19 f20))) (= (= (f16 (f17 ?v_0 (f3 f35 ?v0)) ?v1) (f16 (f17 ?v_0 (f3 f35 ?v2)) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S12) (?v2 S2) (?v3 S12)) (let ((?v_0 (f18 f19 f20))) (not (= (f16 (f17 ?v_0 (f5 f21 ?v0)) ?v1) (f16 (f17 ?v_0 (f3 f35 ?v2)) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5) (?v3 S12)) (not (= (f3 (f30 f20 (f3 f35 ?v0)) ?v1) (f16 (f17 (f18 f19 f20) (f5 f21 ?v2)) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f3 (f30 f20 ?v0) ?v1) (f3 (f30 f20 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f5 f21 ?v0) (f5 f21 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2)) (= (= (f14 f15 ?v0) f1) (or (exists ((?v1 S12) (?v2 S5)) (and (= ?v0 (f16 (f17 (f18 f19 f20) (f5 f21 ?v2)) ?v1)) (= (f24 f15 ?v1) f1))) (or (exists ((?v1 S2)) (and (= ?v0 (f3 f35 ?v1)) (= (f14 f15 ?v1) f1))) (exists ((?v1 S2) (?v2 S2) (?v3 S12)) (let ((?v_0 (f18 f19 f20))) (and (= ?v0 (f16 (f17 ?v_0 (f3 (f30 f20 (f3 f35 ?v1)) ?v2)) ?v3)) (and (= (f14 f15 (f16 (f17 ?v_0 (f5 (f6 (f7 f8 ?v1) ?v2) (f33 f34 0))) ?v3)) f1) (= (f14 f15 ?v2) f1))))))))))
(assert (forall ((?v0 S5)) (= (f33 f34 (f31 f32 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f31 f32 (f33 f34 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f31 f32 (f33 f34 ?v0)) 0))))
(check-sat)
(exit)
