(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S9 Int) S1)
(declare-fun f14 () S9)
(declare-fun f15 () S7)
(declare-fun f16 () Int)
(declare-fun f17 (Int) S1)
(declare-fun f18 () S5)
(declare-fun f19 () S7)
(declare-fun f20 (Int S9) S1)
(declare-fun f21 (S10 Int) S9)
(declare-fun f22 (Int) S10)
(declare-fun f23 (Int) S9)
(declare-fun f24 (S9) S1)
(declare-fun f25 (S2) S1)
(declare-fun f26 (Int) S10)
(declare-fun f27 () S7)
(declare-fun f28 (S11 S9) S2)
(declare-fun f29 () S11)
(declare-fun f30 (Int) S9)
(declare-fun f31 (Int) S9)
(declare-fun f32 (Int) S9)
(declare-fun f33 (S12 S9) S10)
(declare-fun f34 () S9)
(declare-fun f35 () S9)
(declare-fun f36 () S6)
(declare-fun f37 (S13 Int) S8)
(declare-fun f38 () S13)
(declare-fun f39 (S14 Int) S10)
(declare-fun f40 (Int) S14)
(declare-fun f41 (S9) S9)
(declare-fun f42 (S15 S2) S1)
(declare-fun f43 (S2) S15)
(declare-fun f44 () S4)
(declare-fun f45 () S4)
(declare-fun f46 () S4)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (forall ((?v0 Int)) (= (= (f13 f14 ?v0) f1) false)))
(assert (not (= (f8 (f9 f15 (- 1)) (+ (* 4 f16) 1)) 1)))
(assert (= (f17 (+ (* 4 f16) 1)) f1))
(assert (= (f17 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f17 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int)) (=> (= (f17 ?v0) f1) (= (f6 f18 ?v0) (f6 f7 (- ?v0 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f8 (f9 f19 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f8 (f9 f19 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f8 (f9 f19 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f8 (f9 f19 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f8 (f9 f19 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f8 (f9 f19 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f19 ?v0))) (=> (= (f17 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f8 ?v_0 (f8 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f20 ?v2 (f21 (f22 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f20 ?v2 (f21 (f22 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f20 ?v0 (f21 (f22 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (not (= (f20 ?v1 (f21 (f22 (- ?v0 1)) ?v2)) f1)) (=> (= (f20 ?v1 (f21 (f22 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f8 (f9 f19 ?v2) ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f20 ?v1 (f21 (f22 (- ?v0 1)) ?v2)) f1) (= (f20 ?v1 (f21 (f22 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 (f22 ?v1) ?v0))) (=> (= (f17 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f20 ?v2 ?v_0) f1) (= (f20 (f8 (f9 f19 ?v0) ?v2) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f21 (f22 ?v1) ?v0))) (=> (= (f17 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f20 (f8 (f9 f19 ?v0) ?v2) ?v_1) f1) (= (f20 ?v2 ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f17 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f20 ?v2 (f21 (f22 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f17 ?v0) f1) (= (f23 ?v_0) (f21 (f22 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f24 (f21 (f22 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S2)) (=> (= (f25 ?v0) f1) (= (f17 (f11 f12 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f13 (f21 (f26 (f8 (f9 f27 ?v1) (f8 (f9 f19 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int)) (= (f6 f18 ?v0) (f28 f29 (f30 ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f17 ?v1) f1) (= (f13 (f31 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f15 ?v0) ?v1) (ite (= (f13 (f21 (f26 ?v0) 0) ?v1) f1) 0 (ite (= (f13 (f32 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 S12) (?v1 Int) (?v2 Int)) (=> (forall ((?v3 Int) (?v4 Int)) (= (f13 (f21 (f33 ?v0 f34) ?v3) ?v4) f1)) (=> (forall ((?v3 Int) (?v4 Int)) (let ((?v_0 (- ?v3 1))) (=> (< 1 ?v3) (=> (= (f13 (f21 (f33 ?v0 (f21 (f22 ?v_0) ?v4)) ?v_0) ?v4) f1) (= (f13 (f21 (f33 ?v0 (f21 (f22 ?v3) ?v4)) ?v3) ?v4) f1))))) (= (f13 (f21 (f33 ?v0 (f21 (f22 ?v1) ?v2)) ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f17 ?v0) f1) (= (= (f20 ?v0 f35) f1) (< 2 ?v0)))))
(assert (forall ((?v0 Int)) (=> (= (f17 ?v0) f1) (= (f13 (f21 (f26 (f8 f36 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (= (f13 (f21 (f26 (f8 (f9 f15 ?v1) ?v0)) (f11 (f37 f38 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 (f37 f38 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f11 (f37 f38 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f37 f38 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 3))) (let ((?v_0 (f11 (f37 f38 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f37 f38 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f37 f38 ?v0))) (= (f8 (f9 f27 ?v0) (f11 ?v_0 (f6 f7 2))) (f11 ?v_0 (f6 f7 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 3))) (= (f11 (f37 f38 (- ?v0)) ?v_0) (- (f11 (f37 f38 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f37 f38 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f37 f38 ?v0) ?v_0) (f8 (f9 f27 (* 2 ?v0)) ?v1)) (f11 (f37 f38 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f37 f38 (- ?v0 ?v1)) ?v_0) (+ (- (f11 (f37 f38 ?v0) ?v_0) (f8 (f9 f27 (* 2 ?v0)) ?v1)) (f11 (f37 f38 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_1 (f37 f38 ?v0)) (?v_3 (f37 f38 ?v1))) (= (f11 (f37 f38 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f11 ?v_1 ?v_0) (f8 (f9 f27 (* 3 (f11 ?v_1 ?v_2))) ?v1)) (f8 (f9 f27 (* 3 ?v0)) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_3 (f37 f38 ?v1)) (?v_1 (f37 f38 ?v0))) (= (f11 (f37 f38 (- ?v0 ?v1)) ?v_0) (- (+ (- (f11 ?v_1 ?v_0) (f8 (f9 f27 (* 3 (f11 ?v_1 ?v_2))) ?v1)) (f8 (f9 f27 (* 3 ?v0)) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f9 f27 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f11 (f37 f38 ?v0) ?v_0) (f11 (f37 f38 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2)) (?v_1 (f37 f38 ?v0))) (= (f11 (f37 f38 (f11 ?v_1 ?v_0)) ?v_0) (f11 ?v_1 (f6 f7 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (f11 (f37 f38 ?v0) ?v_0) (f11 (f37 f38 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f13 (f21 (f26 (f8 (f9 f27 ?v0) ?v_0)) 1) ?v1) f1) (= (f13 (f21 (f26 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (not (= (f13 (f31 ?v0) ?v1) f1)) (= (f13 (f21 (f26 (f11 (f37 f38 ?v1) (f6 f7 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f31 (f11 (f37 f38 ?v0) ?v2)))) (=> (= (f17 ?v0) f1) (=> (not (= (f13 (f31 ?v0) ?v1) f1)) (=> (= (f13 ?v_0 (f8 (f9 f27 ?v1) ?v3)) f1) (= (f13 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f31 (f11 (f37 f38 ?v0) ?v2)))) (=> (= (f17 ?v0) f1) (=> (not (= (f13 (f31 ?v0) ?v1) f1)) (=> (= (f13 ?v_0 (f8 (f9 f27 ?v3) ?v1)) f1) (= (f13 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 S2) (?v1 Int)) (=> (< 0 (f11 f12 ?v0)) (= (= (f20 (f11 (f37 f38 ?v1) ?v0) f35) f1) (= (f20 ?v1 f35) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f8 (f9 f27 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f20 ?v0 f35) f1) (=> (<= 0 ?v0) (= (f11 (f37 f38 (- ?v1)) ?v_0) (- (f11 (f37 f38 ?v1) ?v_0))))))))
(assert (forall ((?v0 Int)) (=> (= (f11 (f37 f38 ?v0) (f6 f7 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 (f8 (f9 f27 ?v0) ?v1) f35) f1) (= (f20 ?v0 f35) f1))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f37 f38 (- 1)))) (let ((?v_1 (f11 ?v_0 ?v1)) (?v_2 (f11 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f13 (f21 (f26 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (=> (= (f20 ?v0 f35) f1) (< 0 (f8 (f9 f10 (- ?v0 1)) 2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (= (f13 (f21 (f26 ?v1) 0) ?v0) f1) (= (f13 (f21 (f26 0) (f11 (f37 f38 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f13 (f21 (f26 ?v1) 0) ?v0) f1)) (=> (= (f13 (f32 ?v0) ?v1) f1) (= (f13 (f21 (f26 (f11 (f37 f38 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f13 (f21 (f26 ?v1) 0) ?v0) f1)) (=> (not (= (f13 (f32 ?v0) ?v1) f1)) (= (f13 (f21 (f26 (f11 (f37 f38 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f13 (f21 (f26 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 (+ (* 2 ?v1) 1)) (= (f20 ?v0 f35) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0 f35) f1) (=> (= (f20 ?v1 f35) f1) (= (f20 (f8 (f9 f27 ?v0) ?v1) f35) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f20 ?v0 f35) f1) (=> (<= 0 ?v0) (= (f11 (f37 f38 (- 1)) (f6 f7 ?v0)) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f37 f38 ?v1)) (?v_1 (f6 f7 ?v0))) (=> (< 0 ?v0) (= (f11 ?v_0 ?v_1) (f8 (f9 f27 ?v1) (f11 ?v_0 (f6 f7 (- (f11 f12 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f13 (f21 (f26 ?v0) 0) ?v1) f1)) (=> (= (f13 (f21 (f26 (f11 (f37 f38 ?v2) (f6 f7 2))) ?v0) ?v1) f1) (not (= (f13 (f31 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f17 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f13 (f21 (f26 ?v1) 0) ?v0) f1)) (=> (not (= (f13 (f32 ?v0) ?v1) f1)) (= (f13 (f21 (f26 (f8 f36 ?v_0)) (f11 (f37 f38 ?v1) (f6 f7 (f8 (f9 f10 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 S9)) (let ((?v_0 (f11 (f37 f38 (- 1)) (f28 f29 ?v0)))) (=> (= (f24 ?v0) f1) (= (f8 (f9 f27 ?v_0) ?v_0) 1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 (f37 f38 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f32 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f13 (f21 (f26 (f11 (f37 f38 ?v2) (f6 f7 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f31 ?v0))) (=> (= (f17 ?v0) f1) (=> (= (f13 ?v_0 (f11 (f37 f38 ?v1) ?v2)) f1) (= (f13 ?v_0 ?v1) f1))))))
(assert (= (f24 f34) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f13 (f21 (f26 ?v1) 0) ?v0) f1)) (=> (not (= (f13 (f32 ?v0) ?v1) f1)) (=> (not (= (f13 (f21 (f26 ?v2) 0) ?v0) f1)) (= (f28 f29 (f21 (f39 (f40 ?v1) ?v0) ?v2)) (f6 f7 2)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f31 ?v0))) (=> (= (f17 ?v0) f1) (=> (= (f13 ?v_0 (f11 (f37 f38 ?v1) ?v2)) f1) (=> (< 0 (f11 f12 ?v2)) (= (f13 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 ?v1))) (=> (<= 0 ?v0) (=> (= (f17 ?v1) f1) (=> (= (f13 ?v_0 (f8 (f9 f27 ?v0) ?v2)) f1) (or (= (f13 ?v_0 ?v0) f1) (= (f13 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 ?v0))) (=> (= (f17 ?v0) f1) (=> (= (f13 ?v_0 (f8 (f9 f27 ?v1) ?v2)) f1) (or (= (f13 ?v_0 ?v1) f1) (= (f13 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f26 ?v1))) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (= (f13 (f21 (f26 (f8 (f9 f27 ?v1) ?v1)) 1) ?v0) f1) (or (= (f13 (f21 ?v_0 1) ?v0) f1) (= (f13 (f21 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (= (f13 (f21 (f26 (f8 (f9 f27 ?v1) ?v2)) 0) ?v0) f1) (or (= (f13 (f21 (f26 ?v1) 0) ?v0) f1) (= (f13 (f21 (f26 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f13 (f21 (f26 ?v1) 0) ?v0) f1)) (not (= (f13 (f21 (f26 ?v2) 0) ?v0) f1))) (not (= (f13 (f21 (f26 (f8 (f9 f27 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f13 (f21 (f26 (f8 (f9 f27 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f20 ?v0 ?v1) f1) (= (f13 ?v1 ?v0) f1))))
(assert (forall ((?v0 S9)) (= (f41 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f9 f27 ?v1))) (= (+ (f8 (f9 f27 (- ?v0 (f8 ?v_0 ?v2))) ?v3) (f8 (f9 f27 (- ?v4 (f8 ?v_0 ?v5))) ?v6)) (- (+ (f8 (f9 f27 ?v0) ?v3) (f8 (f9 f27 ?v4) ?v6)) (f8 ?v_0 (+ (f8 (f9 f27 ?v2) ?v3) (f8 (f9 f27 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f21 (f26 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (= (f13 (f21 (f26 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 (f26 ?v0) ?v1))) (= (= (f13 ?v_0 (- ?v2)) f1) (= (f13 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (f13 (f21 (f26 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f21 (f26 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f21 (f26 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f13 (f21 (f26 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f13 (f21 (f26 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f13 (f21 (f26 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f13 (f21 (f26 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f13 (f21 (f26 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f26 ?v1))) (=> (< 2 ?v0) (=> (= (f13 (f21 ?v_0 (- 1)) ?v0) f1) (not (= (f13 (f21 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (= (f13 (f21 (f26 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f26 ?v0))) (=> (= (f13 (f21 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f13 (f21 (f26 ?v3) ?v4) ?v2) f1) (= (f13 (f21 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f26 ?v0))) (=> (= (f13 (f21 ?v_0 ?v1) ?v2) f1) (=> (= (f13 (f21 (f26 ?v1) ?v3) ?v2) f1) (= (f13 (f21 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (=> (= (f13 (f21 (f26 ?v3) ?v4) ?v2) f1) (= (f13 (f21 (f26 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (=> (= (f13 (f21 (f26 ?v3) ?v4) ?v2) f1) (= (f13 (f21 (f26 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 (f31 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (= (f28 f29 f34) (f6 f7 0)))
(assert (forall ((?v0 S9)) (=> (not (= (f24 ?v0) f1)) (= (f28 f29 ?v0) (f6 f7 0)))))
(assert (forall ((?v0 S9)) (=> (< 0 (f11 f12 (f28 f29 ?v0))) (= (f24 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f8 (f9 f27 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f13 (f21 (f26 (f8 (f9 f27 ?v0) ?v1)) (f8 (f9 f27 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f26 ?v3))) (=> (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (= (= (f13 (f21 ?v_0 (f8 (f9 f27 ?v0) ?v4)) ?v2) f1) (= (f13 (f21 ?v_0 (f8 (f9 f27 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f26 ?v3)) (?v_1 (f9 f27 ?v4))) (=> (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (= (= (f13 (f21 ?v_0 (f8 ?v_1 ?v0)) ?v2) f1) (= (f13 (f21 ?v_0 (f8 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (= (f13 (f21 (f26 (f8 (f9 f27 ?v0) ?v3)) (f8 (f9 f27 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f27 ?v3))) (=> (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (= (f13 (f21 (f26 (f8 ?v_0 ?v0)) (f8 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (=> (= (f13 (f21 (f26 ?v3) ?v4) ?v2) f1) (= (f13 (f21 (f26 (f8 (f9 f27 ?v0) ?v3)) (f8 (f9 f27 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (f8 (f9 f27 ?v0) (f8 (f9 f10 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (f8 (f9 f27 ?v2) ?v0)) (< (f8 (f9 f10 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (f8 (f9 f27 ?v2) ?v0) ?v0)) (<= (f8 (f9 f10 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f21 (f26 ?v0) 0) ?v1) f1) (= (f13 (f31 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f21 (f26 ?v0) 0) ?v1) f1) (= (f13 (f31 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (= (f13 (f31 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f13 (f21 (f26 ?v0) ?v1) ?v2) f1) (= (f13 (f21 (f26 (f11 (f37 f38 ?v0) ?v3)) (f11 (f37 f38 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 ?v1))) (=> (< 0 (f11 f12 ?v0)) (=> (= (f13 ?v_0 ?v2) f1) (= (f13 ?v_0 (f11 (f37 f38 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int)) (= (= (f17 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f13 (f31 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 S9)) (= (< 0 (f11 f12 (f28 f29 ?v0))) (and (not (= ?v0 f34)) (= (f24 ?v0) f1)))))
(assert (forall ((?v0 S9)) (= (= (f28 f29 ?v0) (f6 f7 0)) (or (= ?v0 f34) (not (= (f24 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (not (= (f13 (f21 (f26 ?v1) 0) ?v0) f1)) (=> (not (= (f13 (f21 (f26 ?v2) 0) ?v0) f1)) (not (= (f13 (f21 (f26 (f8 (f9 f27 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 (f31 ?v0) ?v1) f1) (= (f8 (f9 f27 ?v0) (f8 (f9 f10 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f13 (f31 ?v0) ?v1) f1) (= (f11 (f37 f38 (f8 (f9 f10 ?v1) ?v0)) ?v2) (f8 (f9 f10 (f11 (f37 f38 ?v1) ?v2)) (f11 (f37 f38 ?v0) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f42 (f43 ?v0) ?v1) f1) (= (f3 (f4 f44 (f3 (f4 f45 ?v1) ?v0)) ?v2) (f3 (f4 f45 (f3 (f4 f44 ?v1) ?v2)) (f3 (f4 f44 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 (f31 ?v0) ?v1) f1) (= (f8 (f9 f27 ?v0) (f8 (f9 f10 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f42 (f43 ?v0) ?v1) f1) (= (f3 (f4 f46 ?v0) (f3 (f4 f45 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f27 ?v2))) (=> (= (f13 (f31 ?v0) ?v1) f1) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v0)) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f46 ?v2))) (=> (= (f42 (f43 ?v0) ?v1) f1) (= (f3 ?v_0 (f3 (f4 f45 ?v1) ?v0)) (f3 (f4 f45 (f3 ?v_0 ?v1)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 (f31 ?v0) ?v1) f1) (= (f8 (f9 f27 (f8 (f9 f10 ?v1) ?v0)) ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f42 (f43 ?v0) ?v1) f1) (= (f3 (f4 f46 (f3 (f4 f45 ?v1) ?v0)) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 (f31 ?v0) ?v1) f1) (= (f8 (f9 f27 (f8 (f9 f10 ?v1) ?v0)) ?v2) (f8 (f9 f10 (f8 (f9 f27 ?v1) ?v2)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f42 (f43 ?v0) ?v1) f1) (= (f3 (f4 f46 (f3 (f4 f45 ?v1) ?v0)) ?v2) (f3 (f4 f45 (f3 (f4 f46 ?v1) ?v2)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1)))) (f6 f7 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 ?v0))) (=> (= (f25 ?v0) f1) (=> (= (f42 ?v_0 (f3 (f4 f44 ?v1) ?v2)) f1) (= (f42 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f43 (f3 (f4 f44 ?v0) ?v2)))) (=> (= (f25 ?v0) f1) (=> (not (= (f42 (f43 ?v0) ?v1) f1)) (=> (= (f42 ?v_0 (f6 f7 (f8 (f9 f27 (f11 f12 ?v3)) (f11 f12 ?v1)))) f1) (= (f42 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 (f9 f10 (- ?v0 1)) 2))) (= (f6 f7 (* 2 (f11 f12 (f6 f7 ?v_0)))) (f6 f7 (* 2 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f13 (f21 (f26 (f11 ?v_0 ?v1)) 1) ?v2) f1) (= (f13 (f21 (f26 (f11 ?v_0 (f6 f7 (f8 (f9 f27 (f11 f12 ?v1)) (f11 f12 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f8 (f9 f27 ?v3) ?v4) ?v5))) (=> (= (+ (f8 (f9 f27 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f27 ?v0))) (=> (<= (+ (f8 ?v_0 ?v1) ?v2) (+ (f8 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f8 (f9 f27 ?v3) ?v4) ?v5))) (=> (= (+ (f8 (f9 f27 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f27 ?v0))) (=> (<= (+ (f8 ?v_0 ?v1) ?v2) (+ (f8 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f8 (f9 f27 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f8 (f9 f27 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f8 (f9 f27 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f8 (f9 f27 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f8 (f9 f10 ?v1) ?v2) (f8 (f9 f10 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f8 (f9 f10 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f8 (f9 f10 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f8 (f9 f10 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f8 (f9 f10 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f8 (f9 f10 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f8 ?v_0 ?v2) (f8 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f8 (f9 f10 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f8 (f9 f10 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f8 (f9 f10 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f8 (f9 f10 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f8 (f9 f10 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f8 (f9 f10 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f8 (f9 f10 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f8 (f9 f10 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f8 (f9 f10 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) (- ?v1)) (f8 (f9 f10 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) (- ?v1)) (f8 (f9 f10 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 0) ?v0) 0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 ?v0))) (=> (= (f13 ?v_0 ?v1) f1) (=> (= (f13 ?v_0 ?v2) f1) (= (= (f13 (f31 (f8 (f9 f10 ?v1) ?v0)) (f8 (f9 f10 ?v2) ?v0)) f1) (= (f13 (f31 ?v1) ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 ?v0))) (=> (= (f42 ?v_0 ?v1) f1) (=> (= (f42 ?v_0 ?v2) f1) (= (= (f42 (f43 (f3 (f4 f45 ?v1) ?v0)) (f3 (f4 f45 ?v2) ?v0)) f1) (= (f42 (f43 ?v1) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (f8 (f9 f27 ?v1) ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f8 (f9 f10 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v1))) (=> (< 0 ?v0) (= (f8 ?v_0 (f8 (f9 f27 ?v2) ?v0)) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 S9) (?v1 Int) (?v2 Int)) (= (= (f13 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f13 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (f8 (f9 f27 ?v2) ?v3) ?v4)))) (= (f13 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (f8 (f9 f27 ?v2) ?v3) ?v4)))) (= (f13 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v1) ?v0))) (=> (= (f13 (f31 ?v0) ?v1) f1) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)) (ite (< ?v0 0) (- ?v0) ?v0)))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f37 f38 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f8 (f9 f10 (f11 ?v_0 ?v0)) ?v1) (f11 ?v_0 (f6 f7 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f13 (f31 ?v0) ?v1) f1) (=> (= (f13 (f31 ?v2) ?v3) f1) (= (f8 (f9 f27 (f8 (f9 f10 ?v1) ?v0)) (f8 (f9 f10 ?v3) ?v2)) (f8 (f9 f10 (f8 (f9 f27 ?v1) ?v3)) (f8 (f9 f27 ?v0) ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f42 (f43 ?v0) ?v1) f1) (=> (= (f42 (f43 ?v2) ?v3) f1) (= (f3 (f4 f46 (f3 (f4 f45 ?v1) ?v0)) (f3 (f4 f45 ?v3) ?v2)) (f3 (f4 f45 (f3 (f4 f46 ?v1) ?v3)) (f3 (f4 f46 ?v0) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (= (f20 ?v0 f35) f1) (exists ((?v2 Int)) (let ((?v_1 (f8 (f9 f27 ?v2) ?v0))) (let ((?v_0 (- ?v1 ?v_1))) (< (ite (< ?v_0 0) (* (- 2) ?v_0) (- (* 2 ?v1) (* 2 ?v_1))) ?v0))))))))
(assert (forall ((?v0 Int)) (= (f24 (f23 ?v0)) f1)))
(assert (forall ((?v0 Int)) (= (f8 f36 ?v0) (ite (<= ?v0 0) 1 (f8 (f9 f27 ?v0) (f8 f36 (- ?v0 1)))))))
(assert (forall ((?v0 Int)) (=> (= (f20 ?v0 f34) f1) false)))
(assert (forall ((?v0 S15) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f42 ?v0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) f1) (or (and (= ?v2 ?v_0) (= (f42 ?v0 ?v_0) f1)) (exists ((?v3 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_2 (f9 f27 (f11 f12 ?v2))) (?v_3 (f11 f12 ?v3))) (and (and (<= (f8 ?v_2 ?v_3) ?v_1) (< ?v_1 (f8 ?v_2 (+ ?v_3 1)))) (= (f42 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 S15) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 0))) (let ((?v_1 (= ?v2 ?v_0))) (= (= (f42 ?v0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) f1) (and (=> ?v_1 (= (f42 ?v0 ?v_0) f1)) (=> (not ?v_1) (forall ((?v3 S2) (?v4 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v4))) (=> (< ?v_3 ?v_2) (=> (= ?v1 (f6 f7 (+ (f8 (f9 f27 ?v_2) (f11 f12 ?v3)) ?v_3))) (= (f42 ?v0 ?v3) f1))))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= (f8 (f9 f10 ?v_0) (f11 f12 ?v1)) ?v_0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (+ 0 1))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (+ (+ (+ ?v_1 1) 1) 1))) (f6 f7 (f8 ?v_0 (+ 3 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (f8 (f9 f27 ?v_1) ?v_2))) (f6 f7 (f8 (f9 f10 (f8 ?v_0 ?v_1)) ?v_2))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (f8 (f9 f10 (+ (+ ?v_0 1) 1)) 2)) (f6 f7 (+ (f8 (f9 f10 ?v_0) 2) 1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ (+ (+ ?v_0 1) 1) 1)) ?v_1)) (f6 f7 (f8 (f9 f10 (+ 3 ?v_0)) ?v_1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_0)) 2)) ?v0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 1 ?v_0) (< 0 (f8 (f9 f10 ?v_0) 2))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (< 0 (f8 (f9 f10 (+ ?v_0 1)) 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (ite (< ?v_1 ?v_0) (f6 f7 0) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (f6 f7 (f8 (f9 f10 (f8 (f9 f27 (f11 f12 ?v1)) ?v_0)) ?v_0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (f6 f7 (f8 (f9 f10 (f8 (f9 f27 ?v_0) (f11 f12 ?v1))) ?v_0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (let ((?v_2 (f9 f27 ?v_0)) (?v_3 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (and (<= (f8 ?v_2 ?v_3) ?v_1) (< ?v_1 (f8 ?v_2 (+ ?v_3 1)))) (= ?v1 (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (=> (not (< ?v_1 ?v_0)) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (=> (< 1 ?v_1) (=> (< 0 ?v_0) (< (f8 (f9 f10 ?v_0) ?v_1) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (=> (<= ?v_0 ?v_1) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f9 f10 (f11 f12 ?v2)))) (=> (< 0 ?v_0) (=> (<= ?v_0 ?v_1) (<= (f8 ?v_2 ?v_1) (f8 ?v_2 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0))) (=> (< ?v_0 ?v_1) (= (f6 f7 (f8 (f9 f10 ?v_0) ?v_1)) (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f8 (f9 f10 ?v_0) ?v_2) (f8 (f9 f10 ?v_1) ?v_2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 (f6 f7 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f6 f7 (f8 (f9 f27 ?v_0) ?v_0)) (f6 f7 (+ (f8 (f9 f27 (f11 f12 (f6 f7 (- ?v0 1)))) (f11 f12 (f6 f7 (- ?v0 3)))) 1)))))))
(assert (= f34 (f41 f14)))
(assert (forall ((?v0 S9)) (= (forall ((?v1 Int)) (not (= (f20 ?v1 ?v0) f1))) (= ?v0 f34))))
(assert (forall ((?v0 S9)) (= (exists ((?v1 Int)) (= (f20 ?v1 ?v0) f1)) (not (= ?v0 f34)))))
(assert (forall ((?v0 S9)) (= (exists ((?v1 Int)) (and (= (f20 ?v1 f34) f1) (= (f13 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S9)) (= (forall ((?v1 Int)) (=> (= (f20 ?v1 f34) f1) (= (f13 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S9)) (= (= f34 (f41 ?v0)) (forall ((?v1 Int)) (not (= (f13 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int)) (= (= (f20 ?v0 f34) f1) false)))
(assert (forall ((?v0 S9)) (= (= (f41 ?v0) f34) (forall ((?v1 Int)) (not (= (f13 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S9) (?v1 Int)) (=> (= ?v0 f34) (not (= (f20 ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f20 ?v0 (f23 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f20 ?v1 (f23 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0 (f23 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0 (f23 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f43 ?v0))) (=> (= (f25 ?v0) f1) (=> (= (f42 ?v_0 (f3 (f4 f44 ?v1) (f6 f7 2))) f1) (= (f42 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f43 ?v0))) (=> (= (f25 ?v0) f1) (=> (= (f42 ?v_0 (f3 (f4 f44 ?v1) (f6 f7 (+ (+ 0 1) 1)))) f1) (= (f42 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f3 (f4 f44 ?v1) ?v2))) (=> (= (f25 ?v0) f1) (=> (= (f42 (f43 ?v0) ?v_0) f1) (= (f42 (f43 (f3 (f4 f44 ?v0) ?v2)) ?v_0) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 ?v0))) (=> (= (f42 ?v_0 ?v1) f1) (=> (= (f42 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) f1) (= (f42 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f42 (f43 ?v0) ?v1) f1) (or (= ?v1 (f6 f7 0)) (<= (f11 f12 ?v0) (f11 f12 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (and (= (f42 (f43 ?v0) ?v1) f1) (= (f42 (f43 ?v1) ?v0) f1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f27 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))) (= (<= (f11 f12 (f3 (f4 f44 ?v0) ?v_0)) (f11 f12 (f3 (f4 f44 ?v2) ?v_0))) (<= (f11 f12 ?v0) (f11 f12 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))) (= (< (f11 f12 (f3 (f4 f44 ?v0) ?v_0)) (f11 f12 (f3 (f4 f44 ?v2) ?v_0))) (< (f11 f12 ?v0) (f11 f12 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))) (= (= (f3 (f4 f44 ?v0) ?v_0) (f3 (f4 f44 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f3 (f4 f44 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f3 (f4 f44 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2)) (=> (= (f25 ?v0) f1) (<= 2 (f11 f12 ?v0)))))
(assert (= (f25 (f6 f7 2)) f1))
(assert (not (= (f25 (f6 f7 (+ 0 1))) f1)))
(assert (not (= (f25 (f6 f7 0)) f1)))
(assert (not (= (f25 (f6 f7 1)) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v3))) (=> (= ?v0 (f6 f7 (+ (f8 (f9 f27 (f11 f12 ?v1)) ?v_1) ?v_0))) (=> (< 0 ?v_0) (=> (< ?v_0 ?v_1) (not (= (f42 (f43 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f27 (f11 f12 ?v2)))) (=> (= (f42 (f43 ?v0) ?v1) f1) (= (f42 (f43 (f6 f7 (f8 ?v_0 (f11 f12 ?v0)))) (f6 f7 (f8 ?v_0 (f11 f12 ?v1)))) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (=> (= (f42 (f43 ?v0) ?v1) f1) (= (f42 (f43 (f6 f7 (f8 (f9 f27 (f11 f12 ?v0)) ?v_0))) (f6 f7 (f8 (f9 f27 (f11 f12 ?v1)) ?v_0))) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f42 (f43 ?v0) ?v1) f1) (or (= ?v1 (f6 f7 0)) (or (= ?v1 ?v0) (<= (* 2 (f11 f12 ?v0)) (f11 f12 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f42 (f43 (f6 f7 (f8 (f9 f27 (f11 f12 ?v0)) ?v_0))) (f6 f7 (f8 (f9 f27 (f11 f12 ?v2)) ?v_0))) f1) (or (= ?v1 (f6 f7 0)) (= (f42 (f43 ?v0) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f42 (f43 (f3 (f4 f44 ?v0) ?v1)) (f3 (f4 f44 ?v2) ?v1)) f1) (=> (not (= ?v1 (f6 f7 0))) (= (f42 (f43 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f42 (f43 ?v0) ?v1) f1) (= (f42 (f43 (f3 (f4 f44 ?v0) ?v2)) (f3 (f4 f44 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 ?v0))) (=> (= (f42 ?v_0 ?v1) f1) (= (f42 ?v_0 (f3 (f4 f44 ?v1) (f6 f7 (+ (f11 f12 ?v2) 1)))) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 (f6 f7 0))) (=> (= (f42 (f43 (f3 (f4 f44 ?v1) ?v0)) ?v2) f1) (= (f42 (f43 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 2)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (- (f11 f12 (f3 (f4 f44 ?v0) ?v_0)) (f11 f12 (f3 (f4 f44 ?v1) ?v_0)))) (f6 f7 (f8 (f9 f27 (+ ?v_1 ?v_2)) (f11 f12 (f6 f7 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 S2)) (= (= (f25 ?v0) f1) (and (< 1 (f11 f12 ?v0)) (forall ((?v1 S2)) (=> (= (f42 (f43 ?v1) ?v0) f1) (or (= ?v1 (f6 f7 1)) (= ?v1 ?v0))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (=> (= (f25 ?v0) f1) (=> (not (= ?v1 (f6 f7 0))) (=> (= ?v1 (f6 f7 (f8 (f9 f27 (f11 f12 ?v0)) ?v_0))) (< ?v_0 (f11 f12 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (=> (= (f25 (f6 f7 (f8 (f9 f27 (f11 f12 ?v0)) (f11 f12 ?v1)))) f1) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f25 (f3 (f4 f44 ?v0) ?v1)) f1) (and (= (f25 ?v0) f1) (= ?v1 (f6 f7 1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 ?v0))) (=> (= (f25 ?v0) f1) (= (= (f42 ?v_0 (f6 f7 (f8 (f9 f27 (f11 f12 ?v1)) (f11 f12 ?v2)))) f1) (or (= (f42 ?v_0 ?v1) f1) (= (f42 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 ?v0))) (=> (= (f25 ?v0) f1) (=> (= (f42 ?v_0 (f6 f7 (f8 (f9 f27 (f11 f12 ?v1)) (f11 f12 ?v2)))) f1) (or (= (f42 ?v_0 ?v1) f1) (= (f42 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 ?v0))) (=> (= (f25 ?v0) f1) (=> (= (f42 ?v_0 (f6 f7 (f8 (f9 f27 (f11 f12 ?v1)) (f11 f12 ?v2)))) f1) (or (= (f42 ?v_0 ?v1) f1) (= (f42 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
