(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (S4 Int) S1)
(declare-fun f8 (Int) S4)
(declare-fun f9 (Int) S1)
(declare-fun f10 (S5 Int) S4)
(declare-fun f11 (Int) S5)
(declare-fun f12 () S2)
(declare-fun f13 (Int S4) S1)
(declare-fun f14 (Int S4) S1)
(declare-fun f15 () S3)
(declare-fun f16 (S6 S7) Int)
(declare-fun f17 (S8 Int) S6)
(declare-fun f18 () S8)
(declare-fun f19 (S9 Int) S7)
(declare-fun f20 () S9)
(declare-fun f21 () S3)
(declare-fun f22 () S6)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (f4 f5 (- 1)) (+ (* 4 f6) 1)) 1))))
(assert (not (= (f7 (f8 (+ (* 4 f6) 1)) (- 1)) f1)))
(assert (not (= (f7 (f8 (+ (* 4 f6) 1)) (- 1)) f1)))
(assert (= (f3 (f4 f5 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (= (f9 (+ (* 4 f6) 1)) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f9 ?v_0) f1) (= (f3 (f4 f5 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (ite (= (f7 (f10 (f11 ?v0) 0) ?v1) f1) 0 (ite (= (f7 (f8 ?v1) ?v0) f1) 1 (- 1))))))
(assert (= (f9 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 (f10 (f11 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f7 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (f7 (f10 (f11 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 (f11 ?v0) ?v1))) (= (= (f7 ?v_0 (- ?v2)) f1) (= (f7 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (f7 (f10 (f11 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f10 (f11 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f10 (f11 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f7 (f10 (f11 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f7 (f10 (f11 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f7 (f10 (f11 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f7 (f10 (f11 ?v0) ?v1) ?v2) f1) (=> (= (f7 (f10 (f11 ?v3) ?v4) ?v2) f1) (= (f7 (f10 (f11 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f7 (f10 (f11 ?v0) ?v1) ?v2) f1) (=> (= (f7 (f10 (f11 ?v3) ?v4) ?v2) f1) (= (f7 (f10 (f11 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 ?v0))) (=> (= (f7 (f10 ?v_0 ?v1) ?v2) f1) (=> (= (f7 (f10 (f11 ?v1) ?v3) ?v2) f1) (= (f7 (f10 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f11 ?v0))) (=> (= (f7 (f10 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f7 (f10 (f11 ?v3) ?v4) ?v2) f1) (= (f7 (f10 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f7 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (f7 (f10 (f11 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 ?v1))) (=> (< 2 ?v0) (=> (= (f7 (f10 ?v_0 (- 1)) ?v0) f1) (not (= (f7 (f10 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f7 (f10 (f11 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f7 (f10 (f11 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f7 (f10 (f11 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (= (f7 (f10 (f11 (f3 f12 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f7 (f10 (f11 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f7 (f10 (f11 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f7 (f10 (f11 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (= (f13 ?v0 ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f14 ?v2 ?v1) f1) (and (= (f14 ?v3 ?v1) f1) (= (f7 (f10 (f11 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f11 ?v1)) (?v_0 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 ?v_1 0) ?v0) f1)) (=> (not (= (f7 (f10 (f11 ?v2) 0) ?v0) f1)) (=> (= (f7 (f10 (f11 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) ?v0) f1) (= (f7 (f10 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f7 (f10 (f11 (f3 ?v_0 (f3 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 (f11 ?v1) 0) ?v0) f1)) (not (= (f7 (f10 (f11 (f3 (f4 f15 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 (f8 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f7 (f10 (f11 (f16 (f17 f18 ?v2) (f19 f20 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 ?v1))) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (= (f7 (f10 (f11 (f3 (f4 f21 ?v1) ?v1)) 1) ?v0) f1) (or (= (f7 (f10 ?v_0 1) ?v0) f1) (= (f7 (f10 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (= (f7 (f10 (f11 (f3 (f4 f21 ?v1) ?v2)) 0) ?v0) f1) (or (= (f7 (f10 (f11 ?v1) 0) ?v0) f1) (= (f7 (f10 (f11 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (= (f16 (f17 f18 ?v0) (f19 f20 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f3 (f4 f21 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f4 f21 ?v1))) (= (+ (f3 (f4 f21 (- ?v0 (f3 ?v_0 ?v2))) ?v3) (f3 (f4 f21 (- ?v4 (f3 ?v_0 ?v5))) ?v6)) (- (+ (f3 (f4 f21 ?v0) ?v3) (f3 (f4 f21 ?v4) ?v6)) (f3 ?v_0 (+ (f3 (f4 f21 ?v2) ?v3) (f3 (f4 f21 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (= (f16 (f17 f18 ?v0) ?v_0) (f16 (f17 f18 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 2)) (?v_1 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_1 ?v_0)) ?v_0) (f16 ?v_1 (f19 f20 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f3 (f4 f21 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f16 (f17 f18 ?v0) ?v_0) (f16 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f19 f20 2)) (?v_0 (f19 f20 3)) (?v_3 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0))) (= (f16 (f17 f18 (- ?v0 ?v1)) ?v_0) (- (+ (- (f16 ?v_1 ?v_0) (f3 (f4 f21 (* 3 (f16 ?v_1 ?v_2))) ?v1)) (f3 (f4 f21 (* 3 ?v0)) (f16 ?v_3 ?v_2))) (f16 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f19 f20 2)) (?v_0 (f19 f20 3)) (?v_1 (f17 f18 ?v0)) (?v_3 (f17 f18 ?v1))) (= (f16 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f16 ?v_1 ?v_0) (f3 (f4 f21 (* 3 (f16 ?v_1 ?v_2))) ?v1)) (f3 (f4 f21 (* 3 ?v0)) (f16 ?v_3 ?v_2))) (f16 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f16 (f17 f18 (- ?v0 ?v1)) ?v_0) (+ (- (f16 (f17 f18 ?v0) ?v_0) (f3 (f4 f21 (* 2 ?v0)) ?v1)) (f16 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f16 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (f16 (f17 f18 ?v0) ?v_0) (f3 (f4 f21 (* 2 ?v0)) ?v1)) (f16 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 3))) (= (f16 (f17 f18 (- ?v0)) ?v_0) (- (f16 (f17 f18 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f3 (f4 f21 ?v0) (f16 ?v_0 (f19 f20 2))) (f16 ?v_0 (f19 f20 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f15 ?v0) ?v1) (f16 (f17 f18 ?v1) (f19 f20 (- ?v0 2))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f19 f20 3))) (let ((?v_0 (f16 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f16 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f19 f20 2))) (let ((?v_0 (f16 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f16 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f16 (f17 f18 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f16 (f17 f18 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f21 (f3 (f4 f15 ?v3) ?v0)))) (=> (= (f7 (f10 (f11 (f3 (f4 f21 ?v0) ?v1)) ?v2) ?v3) f1) (= (f7 (f10 (f11 (f3 (f4 f21 (f3 ?v_0 ?v0)) ?v1)) (f3 ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f3 (f4 f21 ?v1) (f3 (f4 f15 ?v2) ?v3)))) (=> (= (f7 (f10 (f11 ?v0) ?v_0) ?v2) f1) (= (f7 (f10 (f11 (f3 (f4 f21 ?v0) ?v3)) (f3 (f4 f21 ?v_0) ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f21 ?v3)) (?v_1 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f7 (f10 (f11 ?v1) ?v2) ?v0) f1) (= (f7 (f10 (f11 (f3 ?v_0 (f3 ?v_1 ?v1))) (f3 ?v_0 (f3 ?v_1 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 (- 1)))) (let ((?v_1 (f16 ?v_0 ?v1)) (?v_2 (f16 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f7 (f10 (f11 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f7 (f10 (f11 (f3 (f4 f21 ?v1) (f3 (f4 f15 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f15 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (let ((?v_2 (f3 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f7 (f10 (f11 ?v_2) (f3 (f4 f21 (f3 (f4 f21 ?v1) ?v_1)) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f7 (f10 (f11 (f3 (f4 f21 (f3 (f4 f15 ?v0) ?v1)) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f15 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f7 (f10 (f11 (f3 (f4 f21 (f3 (f4 f21 ?v1) ?v_1)) (f3 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_2 (f11 ?v3)) (?v_0 (f4 f21 ?v1)) (?v_1 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (not (= (f7 (f10 (f11 ?v2) 0) ?v0) f1)) (=> (not (= (f7 (f10 ?v_2 0) ?v0) f1)) (=> (= (f7 (f10 (f11 (f3 ?v_0 (f3 ?v_1 ?v3))) (f3 ?v_0 (f3 ?v_1 ?v2))) ?v0) f1) (= (f7 (f10 ?v_2 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f11 ?v1)) (?v_0 (f11 ?v2)) (?v_2 (f4 f21 ?v3)) (?v_3 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 ?v_1 0) ?v0) f1)) (=> (not (= (f7 (f10 ?v_0 0) ?v0) f1)) (=> (= (f7 (f10 ?v_0 (f3 ?v_2 (f3 ?v_3 ?v1))) ?v0) f1) (= (f7 (f10 ?v_1 (f3 ?v_2 (f3 ?v_3 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 (f3 (f4 f21 ?v2) ?v1)))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (= (f7 (f10 ?v_0 (f3 (f4 f21 (f3 (f4 f21 ?v3) (f3 (f4 f15 ?v0) ?v1))) ?v1)) ?v0) f1) (= (f7 (f10 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 S7)) (= (f19 f20 (f16 f22 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f22 (f19 f20 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f22 (f19 f20 ?v0)) 0))))
(check-sat)
(exit)
