(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (Int) S2)
(declare-fun f5 () Int)
(declare-fun f6 (S3 Int) Int)
(declare-fun f7 (S4 Int) S3)
(declare-fun f8 () S4)
(declare-fun f9 (Int) S1)
(declare-fun f10 (S5 Int) S2)
(declare-fun f11 (Int) S5)
(declare-fun f12 (S6 S7) Int)
(declare-fun f13 (S8 Int) S6)
(declare-fun f14 () S8)
(declare-fun f15 (S9 Int) S7)
(declare-fun f16 () S9)
(declare-fun f17 () S3)
(declare-fun f18 () S4)
(declare-fun f19 () S3)
(declare-fun f20 (S10 S7) S7)
(declare-fun f21 (S11 S7) S10)
(declare-fun f22 () S11)
(declare-fun f23 () S6)
(declare-fun f24 (S12 S2) S1)
(declare-fun f25 (Int) S12)
(declare-fun f26 (S2 S12) S1)
(declare-fun f27 (Int) S12)
(declare-fun f28 () S4)
(declare-fun f29 (S13 S12) S7)
(declare-fun f30 () S13)
(declare-fun f31 (S14 Int) S12)
(declare-fun f32 (Int) S14)
(declare-fun f33 () S4)
(declare-fun f34 (S15 S2) S7)
(declare-fun f35 () S15)
(declare-fun f36 () S11)
(declare-fun f37 (S16 Int) S5)
(declare-fun f38 (Int) S16)
(declare-fun f39 () S4)
(declare-fun f40 (Int) S5)
(declare-fun f41 (Int) S2)
(declare-fun f42 (Int) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (+ (* 4 f5) 1)) (- 1)) f1)))
(assert (= (f6 (f7 f8 (- 1)) (+ (* 4 f5) 1)) 1))
(assert (let ((?v_0 (+ (* 4 f5) 1))) (=> (not (= (f3 (f4 ?v_0) (- 1)) f1)) (not (= (f6 (f7 f8 (- 1)) ?v_0) 1)))))
(assert (= (f6 (f7 f8 (- 1)) (+ (* 4 f5) 1)) 1))
(assert (let ((?v_0 (+ (* 4 f5) 1))) (=> (not (= (f3 (f4 ?v_0) (- 1)) f1)) (not (= (f6 (f7 f8 (- 1)) ?v_0) 1)))))
(assert (= (f9 (+ (* 4 f5) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (ite (= (f3 (f10 (f11 ?v0) 0) ?v1) f1) 0 (ite (= (f3 (f4 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f3 (f10 (f11 (f12 (f13 f14 ?v2) (f15 f16 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f9 ?v_0) f1) (= (f6 (f7 f8 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f13 f14 (- 1)))) (let ((?v_1 (f12 ?v_0 ?v1)) (?v_2 (f12 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f3 (f10 (f11 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S7)) (=> (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (f3 (f10 (f11 (f12 (f13 f14 ?v0) ?v3)) (f12 (f13 f14 ?v1) ?v3)) ?v2) f1))))
(assert (= (f9 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S7)) (<= 0 (f12 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f12 (f13 f14 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f15 f16 2))) (let ((?v_0 (f12 (f13 f14 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f12 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f15 f16 3))) (let ((?v_0 (f12 (f13 f14 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f12 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (< 0 (f12 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f15 f16 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 3))) (= (f12 (f13 f14 (- ?v0)) ?v_0) (- (f12 (f13 f14 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2)) (?v_1 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_1 ?v_0)) ?v_0) (f12 ?v_1 (f15 f16 4))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f11 ?v0))) (=> (= (f3 (f10 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f3 (f10 (f11 ?v3) ?v4) ?v2) f1) (= (f3 (f10 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (f3 (f10 (f11 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 ?v1))) (=> (< 2 ?v0) (=> (= (f3 (f10 ?v_0 (- 1)) ?v0) f1) (not (= (f3 (f10 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f3 (f10 (f11 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f10 (f11 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 (f10 (f11 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f3 (f10 (f11 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int)) (=> (= (f12 (f13 f14 ?v0) (f15 f16 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f12 (f13 f14 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (= (f12 (f13 f14 ?v0) ?v_0) (f12 (f13 f14 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (= (f3 (f10 (f11 (f6 f17 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (<= 0 (f12 (f13 f14 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f10 (f11 ?v3) ?v4) ?v2) f1) (= (f3 (f10 (f11 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f10 (f11 ?v3) ?v4) ?v2) f1) (= (f3 (f10 (f11 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 ?v0))) (=> (= (f3 (f10 ?v_0 ?v1) ?v2) f1) (=> (= (f3 (f10 (f11 ?v1) ?v3) ?v2) f1) (= (f3 (f10 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f10 (f11 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f3 (f10 (f11 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f3 (f10 (f11 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f10 (f11 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f10 (f11 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f10 (f11 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (f3 (f10 (f11 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 (f11 ?v0) ?v1))) (= (= (f3 ?v_0 (- ?v2)) f1) (= (f3 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f3 (f10 (f11 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f3 (f10 (f11 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f4 ?v0) ?v1) f1)) (= (f3 (f10 (f11 (f6 f17 ?v_0)) (f12 (f13 f14 ?v1) (f15 f16 (f6 (f7 f18 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (= (f3 (f10 (f11 (f6 (f7 f8 ?v1) ?v0)) (f12 (f13 f14 ?v1) (f15 f16 (f6 (f7 f18 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f6 f19 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f14 (f6 f19 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 (f13 f14 ?v0) (f15 f16 2)))) (= (f6 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f20 (f21 f22 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f20 (f21 f22 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2))) (= (f12 (f13 f14 (f6 f19 ?v0)) ?v_0) (f12 (f13 f14 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f15 f16 (f12 (f13 f14 ?v0) ?v1)) (f20 (f21 f22 (f15 f16 ?v0)) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f12 (f13 f14 (f12 f23 ?v0)) ?v1) (f12 f23 (f20 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f12 f23 (f20 (f21 f22 ?v0) ?v1)) (f12 (f13 f14 (f12 f23 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f20 (f21 f22 (f15 f16 ?v0)) ?v1) (f15 f16 (f12 (f13 f14 ?v0) ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f12 (f13 f14 (f12 f23 ?v0)) ?v1) (f12 f23 (f20 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (= (f3 (f10 (f11 ?v1) 0) ?v0) f1) (= (f3 (f10 (f11 0) (f12 (f13 f14 ?v1) (f15 f16 (f6 (f7 f18 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (= (f3 (f4 ?v0) ?v1) f1) (= (f3 (f10 (f11 (f12 (f13 f14 ?v1) (f15 f16 (f6 (f7 f18 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f4 ?v0) ?v1) f1)) (= (f3 (f10 (f11 (f12 (f13 f14 ?v1) (f15 f16 (f6 (f7 f18 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_1 (f12 f23 ?v0)) (?v_0 (f13 f14 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f6 (f7 f18 (f12 ?v_0 ?v0)) ?v1) (f12 ?v_0 (f15 f16 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f6 (f7 f18 ?v1) ?v2) (f6 (f7 f18 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f6 (f7 f18 ?v0) ?v2) (f6 (f7 f18 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f6 (f7 f18 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f18 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f6 (f7 f18 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f6 (f7 f18 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f6 (f7 f18 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (< 0 (f12 f23 (f20 (f21 f22 ?v0) ?v1))) (or (< 0 (f12 f23 ?v0)) (= ?v1 (f15 f16 0))))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f15 f16 (+ 0 1)))) (= (f20 (f21 f22 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f15 f16 (+ 0 1)))) (= (= (f20 (f21 f22 ?v0) ?v1) ?v_0) (or (= ?v1 (f15 f16 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 0 (f12 f23 ?v0)) (=> (< (f12 f23 (f20 ?v_0 ?v1)) (f12 f23 (f20 ?v_0 ?v2))) (< (f12 f23 ?v1) (f12 f23 ?v2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f12 f23 ?v0)) (<= ?v_0 (f12 f23 (f20 (f21 f22 ?v0) ?v1)))))))
(assert (forall ((?v0 Int)) (= (f6 (f7 f18 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f6 (f7 f18 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f18 ?v0) (- ?v1)) (f6 (f7 f18 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f18 (- ?v0)) (- ?v1)) (f6 (f7 f18 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 (f7 f18 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f24 (f25 ?v0) ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S12)) (= (= (f26 ?v0 ?v1) f1) (= (f24 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f6 (f7 f18 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f6 (f7 f18 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f6 (f7 f18 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f6 (f7 f18 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f6 (f7 f18 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 (f7 f18 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f6 (f7 f18 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f6 (f7 f18 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f6 (f7 f18 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f6 (f7 f18 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f18 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f6 ?v_0 ?v2) (f6 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f6 (f7 f18 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f6 (f7 f18 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f6 (f7 f18 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f6 (f7 f18 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 (f7 f18 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f6 (f7 f18 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (< 0 (f12 f23 (f20 (f21 f22 ?v0) ?v1))) (or (= ?v1 (f15 f16 0)) (< 0 (f12 f23 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f15 f16 0))) (= (= (f20 (f21 f22 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f15 f16 1))) (= (= (f20 (f21 f22 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f15 f16 0)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f15 f16 (+ (f12 f23 ?v1) 1)))) (= (= (f20 (f21 f22 ?v0) ?v_0) (f20 (f21 f22 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f15 f16 (+ (f12 f23 ?v1) 1)))) (= (< (f12 f23 (f20 (f21 f22 ?v0) ?v_0)) (f12 f23 (f20 (f21 f22 ?v2) ?v_0))) (< (f12 f23 ?v0) (f12 f23 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f15 f16 (+ (f12 f23 ?v1) 1)))) (= (<= (f12 f23 (f20 (f21 f22 ?v0) ?v_0)) (f12 f23 (f20 (f21 f22 ?v2) ?v_0))) (<= (f12 f23 ?v0) (f12 f23 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f24 (f27 ?v0) ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f24 (f25 ?v2) ?v1) f1) (and (= (f24 (f25 ?v3) ?v1) f1) (= (f3 (f10 (f11 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f11 ?v1)) (?v_0 (f7 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f10 (f11 ?v2) 0) ?v0) f1)) (=> (= (f3 (f10 (f11 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) ?v0) f1) (= (f3 (f10 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f3 (f10 (f11 (f6 ?v_0 (f6 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (not (= (f3 (f10 (f11 (f6 (f7 f28 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f4 ?v0) ?v1) f1)) (= (f12 f23 (f29 f30 (f31 (f32 ?v1) ?v0))) (f6 (f7 f18 (- ?v0 1)) 2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f10 (f11 ?v1) ?v2) ?v0) f1) (= (f3 (f10 (f11 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f28 ?v0) ?v1) (f12 (f13 f14 ?v1) (f15 f16 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 ?v2))) (=> (= (f9 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f10 ?v_0 0) ?v0) f1)) (=> (not (= (f3 (f4 ?v0) ?v1) f1)) (not (= (f3 (f10 ?v_0 (f6 (f7 f33 ?v1) (f6 (f7 f28 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f4 ?v0) ?v1) f1)) (forall ((?v2 S2)) (=> (= (f26 ?v2 (f31 (f32 ?v1) ?v0)) f1) (= (f34 f35 ?v2) (f15 f16 2))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f6 (f7 f28 ?v0) ?v1))) (let ((?v_0 (f7 f33 ?v_1))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (= (f3 (f10 (f11 (f6 (f7 f33 (f6 ?v_0 ?v1)) ?v2)) (f6 ?v_0 ?v3)) ?v0) f1) (= (f3 (f10 (f11 ?v2) (f6 (f7 f33 ?v3) ?v_1)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 (f6 (f7 f33 ?v2) ?v1)))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (= (f3 (f10 ?v_0 (f6 (f7 f33 (f6 (f7 f33 ?v3) (f6 (f7 f28 ?v0) ?v1))) ?v1)) ?v0) f1) (= (f3 (f10 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f11 ?v1)) (?v_0 (f11 ?v2)) (?v_2 (f7 f33 ?v3)) (?v_3 (f7 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f10 ?v_0 0) ?v0) f1)) (=> (= (f3 (f10 ?v_0 (f6 ?v_2 (f6 ?v_3 ?v1))) ?v0) f1) (= (f3 (f10 ?v_1 (f6 ?v_2 (f6 ?v_3 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (* 2 (f12 f23 ?v1)) 1))) (f6 (f7 f33 ?v0) (f12 (f13 f14 (f12 ?v_0 ?v1)) (f15 f16 2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f15 f16 (+ (* 2 (f12 f23 ?v1)) 1))) (f20 (f21 f36 ?v0) (f20 (f21 f22 (f20 ?v_0 ?v1)) (f15 f16 2)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f15 f16 (+ (* 2 (f12 f23 ?v1)) 1))) (f6 (f7 f33 ?v0) (f6 (f7 f33 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f21 f22 ?v0))) (let ((?v_1 (f20 ?v_0 ?v1))) (= (f20 ?v_0 (f15 f16 (+ (* 2 (f12 f23 ?v1)) 1))) (f20 (f21 f36 ?v0) (f20 (f21 f36 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f15 f16 (* 2 (f12 f23 ?v1)))) (f6 (f7 f33 ?v_1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f21 f22 ?v0))) (let ((?v_1 (f20 ?v_0 ?v1))) (= (f20 ?v_0 (f15 f16 (* 2 (f12 f23 ?v1)))) (f20 (f21 f36 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f6 (f7 f33 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f6 (f7 f33 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f6 (f7 f33 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f6 (f7 f33 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f7 f33 ?v0))) (=> (<= (+ (f6 ?v_0 ?v1) ?v2) (+ (f6 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f6 (f7 f33 ?v3) ?v4) ?v5))) (=> (= (+ (f6 (f7 f33 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f7 f33 ?v0))) (=> (<= (+ (f6 ?v_0 ?v1) ?v2) (+ (f6 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f6 (f7 f33 ?v3) ?v4) ?v5))) (=> (= (+ (f6 (f7 f33 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f7 f33 ?v1))) (= (+ (f6 (f7 f33 (- ?v0 (f6 ?v_0 ?v2))) ?v3) (f6 (f7 f33 (- ?v4 (f6 ?v_0 ?v5))) ?v6)) (- (+ (f6 (f7 f33 ?v0) ?v3) (f6 (f7 f33 ?v4) ?v6)) (f6 ?v_0 (+ (f6 (f7 f33 ?v2) ?v3) (f6 (f7 f33 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f6 (f7 f33 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f33 ?v0) ?v1) (f6 (f7 f33 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f33 ?v0))) (= (f6 ?v_0 (+ ?v1 ?v2)) (+ (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f33 ?v0))) (= (f6 ?v_0 (- ?v1 ?v2)) (- (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f33 (- ?v0)) ?v1) (- (f6 (f7 f33 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 (f7 f33 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f33 ?v0))) (= (f6 (f7 f33 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f33 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f33 (+ ?v0 ?v1)) ?v2) (+ (f6 (f7 f33 ?v0) ?v2) (f6 (f7 f33 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f33 (- ?v0 ?v1)) ?v2) (- (f6 (f7 f33 ?v0) ?v2) (f6 (f7 f33 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f6 (f7 f33 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f6 (f7 f33 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f33 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (let ((?v_0 (f12 f23 ?v2))) (let ((?v_1 (f7 f33 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f6 ?v_1 ?v0) (f6 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 (f7 f33 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 (f7 f33 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f20 (f21 f36 ?v0) ?v1) (f20 (f21 f36 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f33 ?v0) ?v1) (f6 (f7 f33 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f21 f36 ?v0)) (?v_0 (f21 f36 ?v1))) (= (f20 ?v_1 (f20 ?v_0 ?v2)) (f20 ?v_0 (f20 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f7 f33 ?v0)) (?v_0 (f7 f33 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f21 f36 ?v0))) (= (f20 ?v_0 (f20 (f21 f36 ?v1) ?v2)) (f20 (f21 f36 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f33 ?v0))) (= (f6 ?v_0 (f6 (f7 f33 ?v1) ?v2)) (f6 (f7 f33 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f21 f36 ?v0))) (= (f20 (f21 f36 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f21 f36 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f33 ?v0))) (= (f6 (f7 f33 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f21 f36 ?v0))) (= (f20 (f21 f36 (f20 ?v_0 ?v1)) ?v2) (f20 (f21 f36 (f20 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f33 ?v0))) (= (f6 (f7 f33 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f33 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f21 f36 ?v0)) (?v_1 (f20 (f21 f36 ?v2) ?v3))) (= (f20 (f21 f36 (f20 ?v_0 ?v1)) ?v_1) (f20 ?v_0 (f20 (f21 f36 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f33 ?v0)) (?v_1 (f6 (f7 f33 ?v2) ?v3))) (= (f6 (f7 f33 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f33 ?v1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_1 (f21 f36 (f20 (f21 f36 ?v0) ?v1))) (?v_0 (f21 f36 ?v2))) (= (f20 ?v_1 (f20 ?v_0 ?v3)) (f20 ?v_0 (f20 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f7 f33 (f6 (f7 f33 ?v0) ?v1))) (?v_0 (f7 f33 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f21 f36 ?v0))) (= (f20 (f21 f36 (f20 ?v_0 ?v1)) (f20 (f21 f36 ?v2) ?v3)) (f20 (f21 f36 (f20 ?v_0 ?v2)) (f20 (f21 f36 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f33 ?v0))) (= (f6 (f7 f33 (f6 ?v_0 ?v1)) (f6 (f7 f33 ?v2) ?v3)) (f6 (f7 f33 (f6 ?v_0 ?v2)) (f6 (f7 f33 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 (f7 f33 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2)) (f12 ?v_0 (f15 f16 (+ (f12 f23 ?v1) (f12 f23 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f36 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) (f20 ?v_0 (f15 f16 (+ (f12 f23 ?v1) (f12 f23 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f12 (f13 f14 (f6 (f7 f33 ?v0) ?v1)) ?v2) (f6 (f7 f33 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f20 (f21 f22 (f20 (f21 f36 ?v0) ?v1)) ?v2) (f20 (f21 f36 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f12 (f13 f14 (f6 (f7 f33 ?v0) ?v1)) ?v2) (f6 (f7 f33 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f20 (f21 f22 (f20 (f21 f36 ?v0) ?v1)) ?v2) (f20 (f21 f36 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (= (f6 (f7 f33 ?v_0) ?v0) (f6 (f7 f33 ?v0) ?v_0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f20 (f21 f22 ?v0) ?v1))) (= (f20 (f21 f36 ?v_0) ?v0) (f20 (f21 f36 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 (f7 f33 (f12 ?v_0 ?v1)) ?v0) (f12 ?v_0 (f15 f16 (+ (f12 f23 ?v1) 1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f36 (f20 ?v_0 ?v1)) ?v0) (f20 ?v_0 (f15 f16 (+ (f12 f23 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f12 f23 ?v1) (f12 f23 ?v2)))) (f6 (f7 f33 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f15 f16 (+ (f12 f23 ?v1) (f12 f23 ?v2)))) (f20 (f21 f36 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 (f7 f33 ?v0) (f12 ?v_0 ?v1)) (f12 ?v_0 (f15 f16 (+ (f12 f23 ?v1) 1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f36 ?v0) (f20 ?v_0 ?v1)) (f20 ?v_0 (f15 f16 (+ (f12 f23 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) (f15 f16 3)) (f6 (f7 f33 (f6 (f7 f33 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S7)) (= (f20 (f21 f22 ?v0) (f15 f16 3)) (f20 (f21 f36 (f20 (f21 f36 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) (f15 f16 2)) (f6 (f7 f33 ?v0) ?v0))))
(assert (forall ((?v0 S7)) (= (f20 (f21 f22 ?v0) (f15 f16 2)) (f20 (f21 f36 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f12 f23 ?v1) 1))) (f6 (f7 f33 (f12 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f15 f16 (+ (f12 f23 ?v1) 1))) (f20 (f21 f36 (f20 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f12 f23 ?v1) 1))) (f6 (f7 f33 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f15 f16 (+ (f12 f23 ?v1) 1))) (f20 (f21 f36 ?v0) (f20 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f12 f23 ?v1) 1))) (f6 (f7 f33 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f15 f16 (+ (f12 f23 ?v1) 1))) (f20 (f21 f36 ?v0) (f20 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f6 (f7 f33 ?v0) ?v0) (f12 (f13 f14 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 S7)) (= (f20 (f21 f36 ?v0) ?v0) (f20 (f21 f22 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f11 ?v3)) (?v_1 (f7 f33 ?v4))) (=> (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (= (f3 (f10 ?v_0 (f6 ?v_1 ?v0)) ?v2) f1) (= (f3 (f10 ?v_0 (f6 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f11 ?v3))) (=> (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (= (f3 (f10 ?v_0 (f6 (f7 f33 ?v0) ?v4)) ?v2) f1) (= (f3 (f10 ?v_0 (f6 (f7 f33 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f3 (f10 (f11 (f6 (f7 f33 ?v0) ?v_0)) 1) ?v1) f1) (= (f3 (f10 (f11 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f10 (f11 ?v3) ?v4) ?v2) f1) (= (f3 (f10 (f11 (f6 (f7 f33 ?v0) ?v3)) (f6 (f7 f33 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f33 ?v3))) (=> (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (f3 (f10 (f11 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (f3 (f10 (f11 (f6 (f7 f33 ?v0) ?v3)) (f6 (f7 f33 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f10 (f11 (f6 (f7 f33 ?v0) ?v1)) (f6 (f7 f33 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f10 (f11 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f6 (f7 f33 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (f6 (f7 f33 ?v0) (f6 (f7 f18 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (f6 (f7 f33 ?v2) ?v0)) (< (f6 (f7 f18 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (f6 (f7 f33 ?v2) ?v0) ?v0)) (<= (f6 (f7 f18 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (f6 (f7 f18 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f3 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (f6 (f7 f33 ?v2) ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (f6 (f7 f33 ?v2) ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f18 ?v1))) (=> (< 0 ?v0) (= (f6 ?v_0 (f6 (f7 f33 ?v2) ?v0)) (f6 (f7 f18 (f6 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (f6 (f7 f33 ?v1) ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f6 (f7 f18 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 ?v1)) (?v_1 (f15 f16 ?v0))) (=> (< 0 ?v0) (= (f12 ?v_0 ?v_1) (f6 (f7 f33 ?v1) (f12 ?v_0 (f15 f16 (- (f12 f23 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f6 (f7 f33 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f12 (f13 f14 ?v0) ?v_0) (f12 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f15 f16 2)) (?v_0 (f15 f16 3)) (?v_3 (f13 f14 ?v1)) (?v_1 (f13 f14 ?v0))) (= (f12 (f13 f14 (- ?v0 ?v1)) ?v_0) (- (+ (- (f12 ?v_1 ?v_0) (f6 (f7 f33 (* 3 (f12 ?v_1 ?v_2))) ?v1)) (f6 (f7 f33 (* 3 ?v0)) (f12 ?v_3 ?v_2))) (f12 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f15 f16 2)) (?v_0 (f15 f16 3)) (?v_1 (f13 f14 ?v0)) (?v_3 (f13 f14 ?v1))) (= (f12 (f13 f14 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f12 ?v_1 ?v_0) (f6 (f7 f33 (* 3 (f12 ?v_1 ?v_2))) ?v1)) (f6 (f7 f33 (* 3 ?v0)) (f12 ?v_3 ?v_2))) (f12 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f12 (f13 f14 (- ?v0 ?v1)) ?v_0) (+ (- (f12 (f13 f14 ?v0) ?v_0) (f6 (f7 f33 (* 2 ?v0)) ?v1)) (f12 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f12 (f13 f14 (+ ?v0 ?v1)) ?v_0) (+ (+ (f12 (f13 f14 ?v0) ?v_0) (f6 (f7 f33 (* 2 ?v0)) ?v1)) (f12 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 (f7 f33 ?v0) (f12 ?v_0 (f15 f16 2))) (f12 ?v_0 (f15 f16 3))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f12 f23 ?v1) (f12 f23 ?v2)))) (f6 (f7 f33 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f10 (f11 (f6 (f7 f33 ?v1) ?v2)) 0) ?v0) f1) (or (= (f3 (f10 (f11 ?v1) 0) ?v0) f1) (= (f3 (f10 (f11 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (not (= (f3 (f10 (f11 ?v2) 0) ?v0) f1))) (not (= (f3 (f10 (f11 (f6 (f7 f33 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f10 (f11 ?v2) 0) ?v0) f1)) (not (= (f3 (f10 (f11 (f6 (f7 f33 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 ?v1))) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f10 (f11 (f6 (f7 f33 ?v1) ?v1)) 1) ?v0) f1) (or (= (f3 (f10 ?v_0 1) ?v0) f1) (= (f3 (f10 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f3 (f10 (f11 (f6 (f7 f33 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f33 (f6 (f7 f28 ?v3) ?v0)))) (=> (= (f3 (f10 (f11 (f6 (f7 f33 ?v0) ?v1)) ?v2) ?v3) f1) (= (f3 (f10 (f11 (f6 (f7 f33 (f6 ?v_0 ?v0)) ?v1)) (f6 ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 (f7 f33 ?v1) (f6 (f7 f28 ?v2) ?v3)))) (=> (= (f3 (f10 (f11 ?v0) ?v_0) ?v2) f1) (= (f3 (f10 (f11 (f6 (f7 f33 ?v0) ?v3)) (f6 (f7 f33 ?v_0) ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f33 ?v3)) (?v_1 (f7 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f10 (f11 ?v1) ?v2) ?v0) f1) (= (f3 (f10 (f11 (f6 ?v_0 (f6 ?v_1 ?v1))) (f6 ?v_0 (f6 ?v_1 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f3 (f10 (f11 (f6 (f7 f33 ?v1) (f6 (f7 f28 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f28 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (let ((?v_2 (f6 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f3 (f10 (f11 ?v_2) (f6 (f7 f33 (f6 (f7 f33 ?v1) ?v_1)) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f3 (f10 (f11 (f6 (f7 f33 (f6 (f7 f28 ?v0) ?v1)) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f28 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f3 (f10 (f11 (f6 (f7 f33 (f6 (f7 f33 ?v1) ?v_1)) (f6 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_2 (f11 ?v3)) (?v_0 (f7 f33 ?v1)) (?v_1 (f7 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f10 (f11 ?v2) 0) ?v0) f1)) (=> (not (= (f3 (f10 ?v_2 0) ?v0) f1)) (=> (= (f3 (f10 (f11 (f6 ?v_0 (f6 ?v_1 ?v3))) (f6 ?v_0 (f6 ?v_1 ?v2))) ?v0) f1) (= (f3 (f10 ?v_2 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f10 (f11 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f4 ?v0) ?v1) f1)) (=> (not (= (f3 (f10 (f11 ?v2) 0) ?v0) f1)) (= (f34 f35 (f10 (f37 (f38 ?v1) ?v0) ?v2)) (f15 f16 2)))))))))
(assert (forall ((?v0 Int)) (= (f6 f17 ?v0) (ite (<= ?v0 0) 1 (f6 (f7 f33 ?v0) (f6 f17 (- ?v0 1)))))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_0 (f12 f23 ?v0)) (?v_1 (f13 f14 ?v1))) (=> (< 0 ?v_0) (= (f6 (f7 f33 (f12 ?v_1 (f15 f16 (- ?v_0 1)))) ?v1) (f12 ?v_1 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f12 f23 ?v0)) (?v_1 (f21 f22 ?v1))) (=> (< 0 ?v_0) (= (f20 (f21 f36 (f20 ?v_1 (f15 f16 (- ?v_0 1)))) ?v1) (f20 ?v_1 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f12 f23 ?v1)) (?v_1 (f12 f23 ?v0)) (?v_2 (f13 f14 ?v2))) (=> (<= ?v_1 ?v_0) (= (f12 ?v_2 (f15 f16 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f33 (f12 ?v_2 (f15 f16 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f12 f23 ?v1)) (?v_1 (f12 f23 ?v0)) (?v_2 (f21 f22 ?v2))) (=> (<= ?v_1 ?v_0) (= (f20 ?v_2 (f15 f16 (- (+ ?v_0 1) ?v_1))) (f20 (f21 f36 (f20 ?v_2 (f15 f16 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f15 f16 (f6 (f7 f33 (f12 f23 ?v1)) (f12 f23 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f15 f16 (f6 (f7 f33 (f12 f23 ?v1)) (f12 f23 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (* 2 (f12 f23 ?v1)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f15 f16 (* 2 (f12 f23 ?v1)))) (f20 (f21 f22 (f20 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (f6 (f7 f33 (f12 f23 ?v1)) (f12 f23 ?v2)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f15 f16 (f6 (f7 f33 (f12 f23 ?v1)) (f12 f23 ?v2)))) (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f6 (f7 f33 (f12 f23 ?v0)) (f12 f23 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f15 f16 (f6 (f7 f33 (f12 f23 (f15 f16 ?v0))) (f12 f23 (f15 f16 ?v1)))) (f15 f16 (f6 (f7 f33 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 (f7 f33 ?v0) ?v1))) (= (f15 f16 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f15 f16 (f6 (f7 f33 (f12 f23 (f15 f16 (ite (< ?v0 0) (- ?v0) ?v0)))) (f12 f23 (f15 f16 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f6 (f7 f33 (f12 f23 ?v0)) (f12 f23 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f6 (f7 f33 (f12 f23 ?v0)) (f12 f23 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f15 f16 (f6 (f7 f33 ?v0) ?v1)) (f15 f16 (f6 (f7 f33 (f12 f23 (f15 f16 ?v0))) (f12 f23 (f15 f16 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f15 f16 (f6 (f7 f33 ?v0) ?v1)) (f15 f16 (f6 (f7 f33 (f12 f23 (f15 f16 (- ?v0)))) (f12 f23 (f15 f16 (- ?v1)))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f23 (f15 f16 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f15 f16 (f6 (f7 f33 ?v_0) ?v_0)) (f15 f16 (+ (f6 (f7 f33 (f12 f23 (f15 f16 (- ?v0 1)))) (f12 f23 (f15 f16 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f15 f16 0)) (?v_2 (f12 f23 ?v0)) (?v_1 (f12 f23 ?v1))) (= (f15 f16 (f6 (f7 f33 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f15 f16 (+ ?v_1 (f6 (f7 f33 (f12 f23 (f15 f16 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f12 f23 ?v0))) (= (f15 f16 (* ?v_0 2)) (f15 f16 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f12 f23 ?v0))) (= (f15 f16 (* 2 ?v_0)) (f15 f16 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f15 f16 1))) (= (= (f15 f16 (f6 (f7 f33 (f12 f23 ?v0)) (f12 f23 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 (f7 f18 (- ?v0 1)) 2))) (= (f15 f16 (* 2 (f12 f23 (f15 f16 ?v_0)))) (f15 f16 (* 2 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f15 f16 (f6 (f7 f33 (f12 f23 ?v1)) (f12 f23 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f15 f16 2)) (?v_1 (f12 f23 ?v0)) (?v_2 (f12 f23 ?v1))) (= (f15 f16 (- (f12 f23 (f20 (f21 f22 ?v0) ?v_0)) (f12 f23 (f20 (f21 f22 ?v1) ?v_0)))) (f15 f16 (f6 (f7 f33 (+ ?v_1 ?v_2)) (f12 f23 (f15 f16 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 ?v1) (ite (= ?v1 (f15 f16 0)) (f15 f16 1) (f15 f16 (f6 (f7 f33 (f12 f23 ?v0)) (f12 f23 (f20 ?v_0 (f15 f16 (- (f12 f23 ?v1) 1)))))))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S7)) (let ((?v_0 (f13 f14 ?v0))) (=> (= (f3 (f10 (f11 (f12 ?v_0 ?v1)) 1) ?v2) f1) (= (f3 (f10 (f11 (f12 ?v_0 (f15 f16 (f6 (f7 f33 (f12 f23 ?v1)) (f12 f23 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f3 (f10 (f11 (f6 (f7 f33 ?v1) (f6 (f7 f39 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (let ((?v_1 (f6 (f7 f33 ?v2) ?v0))) (let ((?v_0 (- ?v1 ?v_1))) (<= (ite (< ?v_0 0) (* (- 2) ?v_0) (- (* 2 ?v1) (* 2 ?v_1))) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f6 (f7 f39 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f6 (f7 f39 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f6 (f7 f39 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f6 (f7 f39 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f6 (f7 f39 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f6 (f7 f39 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f39 ?v0))) (=> (= (f9 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f6 ?v_0 (f6 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f10 (f40 ?v1) ?v0))) (=> (= (f9 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f24 (f25 (f6 (f7 f39 ?v0) ?v2)) ?v_1) f1) (= (f24 (f25 ?v2) ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 (f40 ?v1) ?v0))) (=> (= (f9 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f24 (f25 ?v2) ?v_0) f1) (= (f24 (f25 (f6 (f7 f39 ?v0) ?v2)) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f25 ?v1))) (=> (< 1 ?v0) (=> (not (= (f24 ?v_0 (f10 (f40 (- ?v0 1)) ?v2)) f1)) (=> (= (f24 ?v_0 (f10 (f40 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f6 (f7 f39 ?v2) ?v0)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f25 ?v1))) (=> (< 1 ?v0) (=> (= (f24 ?v_0 (f10 (f40 (- ?v0 1)) ?v2)) f1) (= (f24 ?v_0 (f10 (f40 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f24 (f25 ?v0) (f10 (f40 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f24 (f25 ?v2) (f10 (f40 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f24 (f25 ?v2) (f10 (f40 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f24 (f25 ?v2) (f10 (f40 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f9 ?v0) f1) (= (f41 ?v_0) (f10 (f40 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f42 ?v0) f1) (=> (= (f42 ?v1) f1) (= (f42 (f6 (f7 f33 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f24 (f25 ?v0) (f41 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f24 (f25 ?v1) (f41 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 (f25 ?v0) (f41 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 (f25 ?v0) (f41 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f12 f23 ?v0))) (<= ?v_0 (f6 (f7 f33 ?v_0) ?v_0)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f12 f23 ?v0))) (let ((?v_1 (f7 f33 ?v_0))) (<= ?v_0 (f6 ?v_1 (f6 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1)) (?v_2 (f12 f23 ?v0)) (?v_1 (f12 f23 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f6 (f7 f33 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1)) (?v_1 (f12 f23 ?v0)) (?v_2 (f12 f23 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f6 (f7 f33 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1)) (?v_1 (f12 f23 ?v0)) (?v_2 (f12 f23 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f6 (f7 f33 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= ?v0 (f15 f16 (f6 (f7 f33 (f12 f23 ?v0)) (f12 f23 ?v1)))) (or (= ?v1 (f15 f16 1)) (= ?v0 (f15 f16 0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_2 (f12 f23 ?v1)) (?v_0 (f12 f23 ?v0)) (?v_3 (f12 f23 ?v3)) (?v_1 (f12 f23 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f6 (f7 f33 ?v_0) ?v_1) (f6 (f7 f33 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_3 (f12 f23 ?v1)) (?v_1 (f12 f23 ?v0)) (?v_0 (f12 f23 ?v2))) (let ((?v_2 (f7 f33 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f6 ?v_2 ?v_1) (f6 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_2 (f12 f23 ?v1)) (?v_0 (f12 f23 ?v0)) (?v_1 (f12 f23 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f6 (f7 f33 ?v_0) ?v_1) (f6 (f7 f33 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S7)) (= (f15 f16 (f12 f23 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f23 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f23 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
