(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 (Int) S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 (S6 Int) S4)
(declare-fun f8 () S6)
(declare-fun f9 () Int)
(declare-fun f10 (S7 Int) S5)
(declare-fun f11 () S7)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 (Int) S1)
(declare-fun f15 (S8 Int) Int)
(declare-fun f16 (S9 Int) S8)
(declare-fun f17 () S9)
(declare-fun f18 (Int) S2)
(declare-fun f19 () S8)
(declare-fun f20 () S9)
(declare-fun f21 () S8)
(declare-fun f22 (S10 S5) S5)
(declare-fun f23 (S11 S5) S10)
(declare-fun f24 () S11)
(declare-fun f25 () S4)
(declare-fun f26 (Int S2) S1)
(declare-fun f27 (Int S2) S1)
(declare-fun f28 () S9)
(declare-fun f29 () S9)
(declare-fun f30 () S11)
(declare-fun f31 () S9)
(declare-fun f32 (Int) S3)
(declare-fun f33 (Int) S2)
(declare-fun f34 (Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f10 f11 2))) (not (= (f3 (f4 (f5 (f6 (f7 f8 f9) ?v_0)) (f6 (f7 f8 f12) ?v_0)) (+ (* 4 f13) 1)) f1))))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (and (<= 0 f9) (and (< f9 ?v_0) (= (f3 (f4 (f5 f12) f9) ?v_0) f1)))))
(assert (< 0 (+ (* 4 f13) 1)))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (and (<= 0 f9) (and (< f9 ?v_0) (= (f3 (f4 (f5 f12) f9) ?v_0) f1)))))
(assert (= (f3 (f4 (f5 (f6 (f7 f8 f12) (f10 f11 2))) (- 1)) (+ (* 4 f13) 1)) f1))
(assert (= (f14 (+ (* 4 f13) 1)) f1))
(assert (= (f15 (f16 f17 (- 1)) (+ (* 4 f13) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (f3 (f4 (f5 (f6 (f7 f8 ?v0) (f10 f11 2))) (- 1)) (+ (* 4 f13) 1)) f1) false)) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f3 (f4 (f5 f12) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f3 (f4 (f5 f12) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f3 (f4 (f5 f12) ?v0) ?v_0) f1))) false))) false))
(assert (= (f3 (f18 (+ (* 4 f13) 1)) (- 1)) f1))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 (- 1)))) (let ((?v_1 (f6 ?v_0 ?v1)) (?v_2 (f6 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f3 (f4 (f5 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S5)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (f3 (f4 (f5 (f6 (f7 f8 ?v0) ?v3)) (f6 (f7 f8 ?v1) ?v3)) ?v2) f1))))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (=> (not (= (f3 (f18 ?v_0) (- 1)) f1)) (not (= (f15 (f16 f17 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 (f7 f8 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 2))) (let ((?v_0 (f6 (f7 f8 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 3))) (let ((?v_0 (f6 (f7 f8 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f10 f11 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 3))) (= (f6 (f7 f8 (- ?v0)) ?v_0) (- (f6 (f7 f8 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2)) (?v_1 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_1 ?v_0)) ?v_0) (f6 ?v_1 (f10 f11 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (= (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (= (f14 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f14 ?v_0) f1) (= (f15 (f16 f17 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 ?v0))) (=> (= (f3 (f4 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f3 (f4 (f5 ?v3) ?v4) ?v2) f1) (= (f3 (f4 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (f3 (f4 (f5 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 ?v1))) (=> (< 2 ?v0) (=> (= (f3 (f4 ?v_0 (- 1)) ?v0) f1) (not (= (f3 (f4 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f3 (f4 (f5 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f4 (f5 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 (f4 (f5 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f3 (f4 (f5 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int)) (=> (= (f6 (f7 f8 ?v0) (f10 f11 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f6 (f7 f8 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f17 ?v0) ?v1) (ite (= (f3 (f4 (f5 ?v0) 0) ?v1) f1) 0 (ite (= (f3 (f18 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f18 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f3 (f4 (f5 (f6 (f7 f8 ?v2) (f10 f11 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f14 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (<= 0 (f6 (f7 f8 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f4 (f5 ?v3) ?v4) ?v2) f1) (= (f3 (f4 (f5 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f4 (f5 ?v3) ?v4) ?v2) f1) (= (f3 (f4 (f5 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 ?v0))) (=> (= (f3 (f4 ?v_0 ?v1) ?v2) f1) (=> (= (f3 (f4 (f5 ?v1) ?v3) ?v2) f1) (= (f3 (f4 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f4 (f5 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f3 (f4 (f5 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f3 (f4 (f5 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 (f5 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (f3 (f4 (f5 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 (f5 ?v0) ?v1))) (= (= (f3 ?v_0 (- ?v2)) f1) (= (f3 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 (f5 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 (f5 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int)) (=> (= (f14 ?v0) f1) (= (f3 (f4 (f5 (f15 f19 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f3 (f4 (f5 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f3 (f4 (f5 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (= (f3 (f4 (f5 (f15 (f16 f17 ?v1) ?v0)) (f6 (f7 f8 ?v1) (f10 f11 (f15 (f16 f20 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f15 f21 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f15 f21 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) (f10 f11 2)))) (= (f15 f21 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f6 (f7 f8 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f22 (f23 f24 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f6 (f7 f8 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f22 (f23 f24 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2))) (= (f6 (f7 f8 (f15 f21 ?v0)) ?v_0) (f6 (f7 f8 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f10 f11 (f6 (f7 f8 ?v0) ?v1)) (f22 (f23 f24 (f10 f11 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f6 f25 ?v0)) ?v1) (f6 f25 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f25 (f22 (f23 f24 ?v0) ?v1)) (f6 (f7 f8 (f6 f25 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f22 (f23 f24 (f10 f11 ?v0)) ?v1) (f10 f11 (f6 (f7 f8 ?v0) ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f6 f25 ?v0)) ?v1) (f6 f25 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (= (f3 (f4 (f5 ?v1) 0) ?v0) f1) (= (f3 (f4 (f5 0) (f6 (f7 f8 ?v1) (f10 f11 (f15 (f16 f20 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f14 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f18 ?v0) ?v1) f1)) (= (f3 (f4 (f5 (f15 f19 ?v_0)) (f6 (f7 f8 ?v1) (f10 f11 (f15 (f16 f20 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (=> (= (f3 (f18 ?v0) ?v1) f1) (= (f3 (f4 (f5 (f6 (f7 f8 ?v1) (f10 f11 (f15 (f16 f20 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f18 ?v0) ?v1) f1)) (= (f3 (f4 (f5 (f6 (f7 f8 ?v1) (f10 f11 (f15 (f16 f20 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 S5) (?v1 Int)) (let ((?v_1 (f6 f25 ?v0)) (?v_0 (f7 f8 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f15 (f16 f20 (f6 ?v_0 ?v0)) ?v1) (f6 ?v_0 (f10 f11 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int)) (= (f15 (f16 f20 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f15 (f16 f20 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f20 ?v0) (- ?v1)) (f15 (f16 f20 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f20 (- ?v0)) (- ?v1)) (f15 (f16 f20 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f16 f20 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f15 (f16 f20 ?v0) ?v0) 1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (< 0 (f6 f25 (f22 (f23 f24 ?v0) ?v1))) (or (< 0 (f6 f25 ?v0)) (= ?v1 (f10 f11 0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f10 f11 (+ 0 1)))) (= (f22 (f23 f24 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f10 f11 (+ 0 1)))) (= (= (f22 (f23 f24 ?v0) ?v1) ?v_0) (or (= ?v1 (f10 f11 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (< 0 (f6 f25 ?v0)) (=> (< (f6 f25 (f22 ?v_0 ?v1)) (f6 f25 (f22 ?v_0 ?v2))) (< (f6 f25 ?v1) (f6 f25 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f26 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f6 f25 ?v0)) (<= ?v_0 (f6 f25 (f22 (f23 f24 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f15 (f16 f20 ?v1) ?v2) (f15 (f16 f20 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f15 (f16 f20 ?v0) ?v2) (f15 (f16 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f15 (f16 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f20 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f15 (f16 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f15 (f16 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f15 (f16 f20 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f15 (f16 f20 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f15 (f16 f20 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f15 (f16 f20 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f15 (f16 f20 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f15 (f16 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f15 (f16 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f20 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f15 ?v_0 ?v2) (f15 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f15 (f16 f20 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f15 (f16 f20 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f15 (f16 f20 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f15 (f16 f20 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f15 (f16 f20 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f15 (f16 f20 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f15 (f16 f20 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f15 (f16 f20 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f15 (f16 f20 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (< 0 (f6 f25 (f22 (f23 f24 ?v0) ?v1))) (or (= ?v1 (f10 f11 0)) (< 0 (f6 f25 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f10 f11 0))) (= (= (f22 (f23 f24 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f10 f11 1))) (= (= (f22 (f23 f24 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f10 f11 0)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f10 f11 (+ (f6 f25 ?v1) 1)))) (= (= (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f10 f11 (+ (f6 f25 ?v1) 1)))) (= (< (f6 f25 (f22 (f23 f24 ?v0) ?v_0)) (f6 f25 (f22 (f23 f24 ?v2) ?v_0))) (< (f6 f25 ?v0) (f6 f25 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f10 f11 (+ (f6 f25 ?v1) 1)))) (= (<= (f6 f25 (f22 (f23 f24 ?v0) ?v_0)) (f6 f25 (f22 (f23 f24 ?v2) ?v_0))) (<= (f6 f25 ?v0) (f6 f25 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f27 ?v0 ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f26 ?v2 ?v1) f1) (and (= (f26 ?v3 ?v1) f1) (= (f3 (f4 (f5 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (not (= (f3 (f4 (f5 (f15 (f16 f28 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (= (f3 (f4 (f5 (f15 ?v_0 (f15 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f5 ?v1)) (?v_0 (f16 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f4 (f5 ?v2) 0) ?v0) f1)) (=> (= (f3 (f4 (f5 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) ?v0) f1) (= (f3 (f4 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f4 (f5 ?v1) ?v2) ?v0) f1) (= (f3 (f4 (f5 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f28 ?v0) ?v1) (f6 (f7 f8 ?v1) (f10 f11 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 ?v2))) (=> (= (f14 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f4 ?v_0 0) ?v0) f1)) (=> (not (= (f3 (f18 ?v0) ?v1) f1)) (not (= (f3 (f4 ?v_0 (f15 (f16 f29 ?v1) (f15 (f16 f28 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (= (f3 (f4 (f5 (f15 (f16 f29 ?v1) (f15 (f16 f28 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f28 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (let ((?v_2 (f15 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (= (f3 (f4 (f5 ?v_2) (f15 (f16 f29 (f15 (f16 f29 ?v1) ?v_1)) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (= (f3 (f4 (f5 (f15 (f16 f29 (f15 (f16 f28 ?v0) ?v1)) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f28 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (= (f3 (f4 (f5 (f15 (f16 f29 (f15 (f16 f29 ?v1) ?v_1)) (f15 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f15 (f16 f29 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f3 (f4 (f5 (f15 (f16 f29 ?v0) ?v_0)) 1) ?v1) f1) (= (f3 (f4 (f5 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 (f5 (f15 (f16 f29 ?v0) ?v1)) (f15 (f16 f29 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (f3 (f4 (f5 (f15 (f16 f29 ?v0) ?v3)) (f15 (f16 f29 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f29 ?v3))) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (f3 (f4 (f5 (f15 ?v_0 ?v0)) (f15 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f4 (f5 ?v3) ?v4) ?v2) f1) (= (f3 (f4 (f5 (f15 (f16 f29 ?v0) ?v3)) (f15 (f16 f29 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 ?v3))) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (= (f3 (f4 ?v_0 (f15 (f16 f29 ?v0) ?v4)) ?v2) f1) (= (f3 (f4 ?v_0 (f15 (f16 f29 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 ?v3)) (?v_1 (f16 f29 ?v4))) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (= (f3 (f4 ?v_0 (f15 ?v_1 ?v0)) ?v2) f1) (= (f3 (f4 ?v_0 (f15 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (f15 (f16 f20 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f3 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (f15 (f16 f29 ?v2) ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (f15 (f16 f29 ?v2) ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f20 ?v1))) (=> (< 0 ?v0) (= (f15 ?v_0 (f15 (f16 f29 ?v2) ?v0)) (f15 (f16 f20 (f15 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (f15 (f16 f29 ?v1) ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f15 (f16 f20 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (f15 (f16 f29 ?v0) (f15 (f16 f20 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (f15 (f16 f29 ?v2) ?v0)) (< (f15 (f16 f20 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (f15 (f16 f29 ?v2) ?v0) ?v0)) (<= (f15 (f16 f20 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f25 ?v1) (f6 f25 ?v2)))) (f15 (f16 f29 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f15 (f16 f29 ?v0) (f6 ?v_0 (f10 f11 2))) (f6 ?v_0 (f10 f11 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v_0) (+ (+ (f6 (f7 f8 ?v0) ?v_0) (f15 (f16 f29 (* 2 ?v0)) ?v1)) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f7 f8 ?v0) ?v_0) (f15 (f16 f29 (* 2 ?v0)) ?v1)) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f10 f11 2)) (?v_0 (f10 f11 3)) (?v_1 (f7 f8 ?v0)) (?v_3 (f7 f8 ?v1))) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f6 ?v_1 ?v_0) (f15 (f16 f29 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f15 (f16 f29 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f10 f11 2)) (?v_0 (f10 f11 3)) (?v_3 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v_0) (- (+ (- (f6 ?v_1 ?v_0) (f15 (f16 f29 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f15 (f16 f29 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f15 (f16 f29 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f10 f11 ?v0))) (=> (< 0 ?v0) (= (f6 ?v_0 ?v_1) (f15 (f16 f29 ?v1) (f6 ?v_0 (f10 f11 (- (f6 f25 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (* 2 (f6 f25 ?v1)) 1))) (f15 (f16 f29 ?v0) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f10 f11 2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f10 f11 (+ (* 2 (f6 f25 ?v1)) 1))) (f22 (f23 f30 ?v0) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f10 f11 2)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f10 f11 (+ (* 2 (f6 f25 ?v1)) 1))) (f15 (f16 f29 ?v0) (f15 (f16 f29 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f10 f11 (+ (* 2 (f6 f25 ?v1)) 1))) (f22 (f23 f30 ?v0) (f22 (f23 f30 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f10 f11 (* 2 (f6 f25 ?v1)))) (f15 (f16 f29 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f10 f11 (* 2 (f6 f25 ?v1)))) (f22 (f23 f30 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f15 (f16 f29 ?v3) ?v4) ?v5))) (=> (= (+ (f15 (f16 f29 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f16 f29 ?v0))) (=> (<= (+ (f15 ?v_0 ?v1) ?v2) (+ (f15 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f15 (f16 f29 ?v3) ?v4) ?v5))) (=> (= (+ (f15 (f16 f29 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f16 f29 ?v0))) (=> (<= (+ (f15 ?v_0 ?v1) ?v2) (+ (f15 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f15 (f16 f29 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f15 (f16 f29 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f15 (f16 f29 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f15 (f16 f29 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f15 (f16 f29 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f16 f29 ?v1))) (= (+ (f15 (f16 f29 (- ?v0 (f15 ?v_0 ?v2))) ?v3) (f15 (f16 f29 (- ?v4 (f15 ?v_0 ?v5))) ?v6)) (- (+ (f15 (f16 f29 ?v0) ?v3) (f15 (f16 f29 ?v4) ?v6)) (f15 ?v_0 (+ (f15 (f16 f29 ?v2) ?v3) (f15 (f16 f29 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 (f16 f29 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 (f16 f29 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f6 f25 ?v2))) (let ((?v_1 (f16 f29 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f15 ?v_1 ?v0) (f15 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f29 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f15 ?v_0 ?v0) (f15 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f15 (f16 f29 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f15 (f16 f29 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f15 (f16 f29 (- ?v0 ?v1)) ?v2) (- (f15 (f16 f29 ?v0) ?v2) (f15 (f16 f29 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f15 (f16 f29 (+ ?v0 ?v1)) ?v2) (+ (f15 (f16 f29 ?v0) ?v2) (f15 (f16 f29 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f29 ?v0))) (= (f15 (f16 f29 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f16 f29 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f29 (- ?v0)) ?v1) (- (f15 (f16 f29 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f29 ?v0))) (= (f15 ?v_0 (- ?v1 ?v2)) (- (f15 ?v_0 ?v1) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f29 ?v0))) (= (f15 ?v_0 (+ ?v1 ?v2)) (+ (f15 ?v_0 ?v1) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f29 ?v0) ?v1) (f15 (f16 f29 ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f23 f30 ?v0))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) (f22 (f23 f30 ?v2) ?v3)) (f22 (f23 f30 (f22 ?v_0 ?v2)) (f22 (f23 f30 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f29 ?v0))) (= (f15 (f16 f29 (f15 ?v_0 ?v1)) (f15 (f16 f29 ?v2) ?v3)) (f15 (f16 f29 (f15 ?v_0 ?v2)) (f15 (f16 f29 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f23 f30 (f22 (f23 f30 ?v0) ?v1))) (?v_0 (f23 f30 ?v2))) (= (f22 ?v_1 (f22 ?v_0 ?v3)) (f22 ?v_0 (f22 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f16 f29 (f15 (f16 f29 ?v0) ?v1))) (?v_0 (f16 f29 ?v2))) (= (f15 ?v_1 (f15 ?v_0 ?v3)) (f15 ?v_0 (f15 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f23 f30 ?v0)) (?v_1 (f22 (f23 f30 ?v2) ?v3))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v_1) (f22 ?v_0 (f22 (f23 f30 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f29 ?v0)) (?v_1 (f15 (f16 f29 ?v2) ?v3))) (= (f15 (f16 f29 (f15 ?v_0 ?v1)) ?v_1) (f15 ?v_0 (f15 (f16 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f30 ?v0))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v2) (f22 (f23 f30 (f22 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f29 ?v0))) (= (f15 (f16 f29 (f15 ?v_0 ?v1)) ?v2) (f15 (f16 f29 (f15 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f30 ?v0))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f23 f30 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f29 ?v0))) (= (f15 (f16 f29 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f30 ?v0))) (= (f22 ?v_0 (f22 (f23 f30 ?v1) ?v2)) (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f29 ?v0))) (= (f15 ?v_0 (f15 (f16 f29 ?v1) ?v2)) (f15 (f16 f29 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f23 f30 ?v0)) (?v_0 (f23 f30 ?v1))) (= (f22 ?v_1 (f22 ?v_0 ?v2)) (f22 ?v_0 (f22 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f16 f29 ?v0)) (?v_0 (f16 f29 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f22 (f23 f30 ?v0) ?v1) (f22 (f23 f30 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f29 ?v0) ?v1) (f15 (f16 f29 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f15 (f16 f29 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f10 f11 (+ (f6 f25 ?v1) (f6 f25 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2)) (f22 ?v_0 (f10 f11 (+ (f6 f25 ?v1) (f6 f25 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f6 (f7 f8 (f15 (f16 f29 ?v0) ?v1)) ?v2) (f15 (f16 f29 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f22 (f23 f24 (f22 (f23 f30 ?v0) ?v1)) ?v2) (f22 (f23 f30 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f6 (f7 f8 (f15 (f16 f29 ?v0) ?v1)) ?v2) (f15 (f16 f29 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f22 (f23 f24 (f22 (f23 f30 ?v0) ?v1)) ?v2) (f22 (f23 f30 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (= (f15 (f16 f29 ?v_0) ?v0) (f15 (f16 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f22 (f23 f24 ?v0) ?v1))) (= (f22 (f23 f30 ?v_0) ?v0) (f22 (f23 f30 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f15 (f16 f29 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f10 f11 (+ (f6 f25 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v0) (f22 ?v_0 (f10 f11 (+ (f6 f25 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f25 ?v1) (f6 f25 ?v2)))) (f15 (f16 f29 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f10 f11 (+ (f6 f25 ?v1) (f6 f25 ?v2)))) (f22 (f23 f30 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f15 (f16 f29 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f10 f11 (+ (f6 f25 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f30 ?v0) (f22 ?v_0 ?v1)) (f22 ?v_0 (f10 f11 (+ (f6 f25 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (f6 (f7 f8 ?v0) (f10 f11 3)) (f15 (f16 f29 (f15 (f16 f29 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S5)) (= (f22 (f23 f24 ?v0) (f10 f11 3)) (f22 (f23 f30 (f22 (f23 f30 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f6 (f7 f8 ?v0) (f10 f11 2)) (f15 (f16 f29 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f22 (f23 f24 ?v0) (f10 f11 2)) (f22 (f23 f30 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f25 ?v1) 1))) (f15 (f16 f29 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f10 f11 (+ (f6 f25 ?v1) 1))) (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f25 ?v1) 1))) (f15 (f16 f29 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f10 f11 (+ (f6 f25 ?v1) 1))) (f22 (f23 f30 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f25 ?v1) 1))) (f15 (f16 f29 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f10 f11 (+ (f6 f25 ?v1) 1))) (f22 (f23 f30 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f15 (f16 f29 ?v0) ?v0) (f6 (f7 f8 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 S5)) (= (f22 (f23 f30 ?v0) ?v0) (f22 (f23 f24 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f4 (f5 ?v2) 0) ?v0) f1)) (not (= (f3 (f4 (f5 (f15 (f16 f29 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (not (= (f3 (f4 (f5 ?v2) 0) ?v0) f1))) (not (= (f3 (f4 (f5 (f15 (f16 f29 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f4 (f5 (f15 (f16 f29 ?v1) ?v2)) 0) ?v0) f1) (or (= (f3 (f4 (f5 ?v1) 0) ?v0) f1) (= (f3 (f4 (f5 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f3 (f4 (f5 (f15 (f16 f29 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 ?v1))) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f4 (f5 (f15 (f16 f29 ?v1) ?v1)) 1) ?v0) f1) (or (= (f3 (f4 ?v_0 1) ?v0) f1) (= (f3 (f4 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f29 (f15 (f16 f28 ?v3) ?v0)))) (=> (= (f3 (f4 (f5 (f15 (f16 f29 ?v0) ?v1)) ?v2) ?v3) f1) (= (f3 (f4 (f5 (f15 (f16 f29 (f15 ?v_0 ?v0)) ?v1)) (f15 ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f15 (f16 f29 ?v1) (f15 (f16 f28 ?v2) ?v3)))) (=> (= (f3 (f4 (f5 ?v0) ?v_0) ?v2) f1) (= (f3 (f4 (f5 (f15 (f16 f29 ?v0) ?v3)) (f15 (f16 f29 ?v_0) ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f29 ?v3)) (?v_1 (f16 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f4 (f5 ?v1) ?v2) ?v0) f1) (= (f3 (f4 (f5 (f15 ?v_0 (f15 ?v_1 ?v1))) (f15 ?v_0 (f15 ?v_1 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f15 (f16 f28 ?v0) ?v1))) (let ((?v_0 (f16 f29 ?v_1))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (=> (= (f3 (f4 (f5 (f15 (f16 f29 (f15 ?v_0 ?v1)) ?v2)) (f15 ?v_0 ?v3)) ?v0) f1) (= (f3 (f4 (f5 ?v2) (f15 (f16 f29 ?v3) ?v_1)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 (f15 (f16 f29 ?v2) ?v1)))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (=> (= (f3 (f4 ?v_0 (f15 (f16 f29 (f15 (f16 f29 ?v3) (f15 (f16 f28 ?v0) ?v1))) ?v1)) ?v0) f1) (= (f3 (f4 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f5 ?v1)) (?v_0 (f5 ?v2)) (?v_2 (f16 f29 ?v3)) (?v_3 (f16 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f4 ?v_0 0) ?v0) f1)) (=> (= (f3 (f4 ?v_0 (f15 ?v_2 (f15 ?v_3 ?v1))) ?v0) f1) (= (f3 (f4 ?v_1 (f15 ?v_2 (f15 ?v_3 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_2 (f5 ?v3)) (?v_0 (f16 f29 ?v1)) (?v_1 (f16 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f4 (f5 ?v2) 0) ?v0) f1)) (=> (not (= (f3 (f4 ?v_2 0) ?v0) f1)) (=> (= (f3 (f4 (f5 (f15 ?v_0 (f15 ?v_1 ?v3))) (f15 ?v_0 (f15 ?v_1 ?v2))) ?v0) f1) (= (f3 (f4 ?v_2 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int)) (= (f15 f19 ?v0) (ite (<= ?v0 0) 1 (f15 (f16 f29 ?v0) (f15 f19 (- ?v0 1)))))))
(assert (forall ((?v0 S5) (?v1 Int)) (let ((?v_0 (f6 f25 ?v0)) (?v_1 (f7 f8 ?v1))) (=> (< 0 ?v_0) (= (f15 (f16 f29 (f6 ?v_1 (f10 f11 (- ?v_0 1)))) ?v1) (f6 ?v_1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f6 f25 ?v0)) (?v_1 (f23 f24 ?v1))) (=> (< 0 ?v_0) (= (f22 (f23 f30 (f22 ?v_1 (f10 f11 (- ?v_0 1)))) ?v1) (f22 ?v_1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f6 f25 ?v1)) (?v_1 (f6 f25 ?v0)) (?v_2 (f7 f8 ?v2))) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f10 f11 (- (+ ?v_0 1) ?v_1))) (f15 (f16 f29 (f6 ?v_2 (f10 f11 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f6 f25 ?v1)) (?v_1 (f6 f25 ?v0)) (?v_2 (f23 f24 ?v2))) (=> (<= ?v_1 ?v_0) (= (f22 ?v_2 (f10 f11 (- (+ ?v_0 1) ?v_1))) (f22 (f23 f30 (f22 ?v_2 (f10 f11 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f3 (f4 (f5 (f15 (f16 f29 ?v1) (f15 (f16 f31 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 (f16 f20 (- ?v0 1)) 2))) (= (f10 f11 (* 2 (f6 f25 (f10 f11 ?v_0)))) (f10 f11 (* 2 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f10 f11 (f15 (f16 f29 (f6 f25 ?v1)) (f6 f25 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f10 f11 0)) (f10 f11 1) (f10 f11 (f15 (f16 f29 (f6 f25 ?v0)) (f6 f25 (f22 ?v_0 (f10 f11 (- (f6 f25 ?v1) 1)))))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f10 f11 2)) (?v_1 (f6 f25 ?v0)) (?v_2 (f6 f25 ?v1))) (= (f10 f11 (- (f6 f25 (f22 (f23 f24 ?v0) ?v_0)) (f6 f25 (f22 (f23 f24 ?v1) ?v_0)))) (f10 f11 (f15 (f16 f29 (+ ?v_1 ?v_2)) (f6 f25 (f10 f11 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f25 (f10 f11 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f10 f11 (f15 (f16 f29 ?v_0) ?v_0)) (f10 f11 (+ (f15 (f16 f29 (f6 f25 (f10 f11 (- ?v0 1)))) (f6 f25 (f10 f11 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f10 f11 (f15 (f16 f29 (f6 f25 (f10 f11 ?v0))) (f6 f25 (f10 f11 ?v1)))) (f10 f11 (f15 (f16 f29 ?v0) ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f15 (f16 f29 (f6 f25 ?v0)) (f6 f25 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f10 f11 (f15 (f16 f29 ?v0) ?v1)) (f10 f11 (f15 (f16 f29 (f6 f25 (f10 f11 (- ?v0)))) (f6 f25 (f10 f11 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f10 f11 (f15 (f16 f29 ?v0) ?v1)) (f10 f11 (f15 (f16 f29 (f6 f25 (f10 f11 ?v0))) (f6 f25 (f10 f11 ?v1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f15 (f16 f29 (f6 f25 ?v0)) (f6 f25 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f15 (f16 f29 (f6 f25 ?v0)) (f6 f25 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 (f16 f29 ?v0) ?v1))) (= (f10 f11 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f10 f11 (f15 (f16 f29 (f6 f25 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)))) (f6 f25 (f10 f11 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f6 f25 ?v0))) (= (f10 f11 (* 2 ?v_0)) (f10 f11 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f6 f25 ?v0))) (= (f10 f11 (* ?v_0 2)) (f10 f11 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f10 f11 0)) (?v_2 (f6 f25 ?v0)) (?v_1 (f6 f25 ?v1))) (= (f10 f11 (f15 (f16 f29 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f10 f11 (+ ?v_1 (f15 (f16 f29 (f6 f25 (f10 f11 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f10 f11 (f15 (f16 f29 (f6 f25 ?v1)) (f6 f25 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f10 f11 (f15 (f16 f29 (f6 f25 ?v1)) (f6 f25 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (* 2 (f6 f25 ?v1)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f10 f11 2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f10 f11 (* 2 (f6 f25 ?v1)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f10 f11 2))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (f15 (f16 f29 (f6 f25 ?v1)) (f6 f25 ?v2)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f10 f11 (f15 (f16 f29 (f6 f25 ?v1)) (f6 f25 ?v2)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f10 f11 1))) (= (= (f10 f11 (f15 (f16 f29 (f6 f25 ?v0)) (f6 f25 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f31 ?v0))) (=> (= (f14 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f15 ?v_0 (f15 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f15 (f16 f31 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f15 (f16 f31 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f15 (f16 f31 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f15 (f16 f31 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f15 (f16 f31 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f15 (f16 f31 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 (f5 (f6 ?v_0 ?v1)) 1) ?v2) f1) (= (f3 (f4 (f5 (f6 ?v_0 (f10 f11 (f15 (f16 f29 (f6 f25 ?v1)) (f6 f25 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (let ((?v_1 (f15 (f16 f29 ?v2) ?v0))) (let ((?v_0 (- ?v1 ?v_1))) (<= (ite (< ?v_0 0) (* (- 2) ?v_0) (- (* 2 ?v1) (* 2 ?v_1))) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 (f32 ?v1) ?v0))) (=> (= (f14 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f26 ?v2 ?v_0) f1) (= (f26 (f15 (f16 f31 ?v0) ?v2) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (not (= (f26 ?v1 (f4 (f32 (- ?v0 1)) ?v2)) f1)) (=> (= (f26 ?v1 (f4 (f32 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f15 (f16 f31 ?v2) ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f14 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f26 ?v2 (f4 (f32 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f26 ?v2 (f4 (f32 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f26 ?v2 (f4 (f32 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f26 ?v1 (f4 (f32 (- ?v0 1)) ?v2)) f1) (= (f26 ?v1 (f4 (f32 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f26 ?v0 (f4 (f32 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f4 (f32 ?v1) ?v0))) (=> (= (f14 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f26 (f15 (f16 f31 ?v0) ?v2) ?v_1) f1) (= (f26 ?v2 ?v_1) f1))))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f14 ?v0) f1) (= (f33 ?v_0) (f4 (f32 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f34 ?v0) f1) (=> (= (f34 ?v1) f1) (= (f34 (f15 (f16 f29 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f26 ?v0 (f33 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f26 ?v1 (f33 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0 (f33 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0 (f33 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f6 f25 ?v0))) (<= ?v_0 (f15 (f16 f29 ?v_0) ?v_0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f6 f25 ?v0))) (let ((?v_1 (f16 f29 ?v_0))) (<= ?v_0 (f15 ?v_1 (f15 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1)) (?v_2 (f6 f25 ?v0)) (?v_1 (f6 f25 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f15 (f16 f29 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1)) (?v_1 (f6 f25 ?v0)) (?v_2 (f6 f25 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f15 (f16 f29 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1)) (?v_1 (f6 f25 ?v0)) (?v_2 (f6 f25 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f15 (f16 f29 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S5)) (= (f10 f11 (f6 f25 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f25 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f25 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
