(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 Int) Int)
(declare-fun f6 (S3 Int) S2)
(declare-fun f7 () S3)
(declare-fun f8 () Int)
(declare-fun f9 (Int) S1)
(declare-fun f10 () S3)
(declare-fun f11 (Int Int) S1)
(declare-fun f12 (S4 S5) Int)
(declare-fun f13 (S6 Int) S4)
(declare-fun f14 () S6)
(declare-fun f15 () Int)
(declare-fun f16 (S7 Int) S5)
(declare-fun f17 () S7)
(declare-fun f18 (Int Int Int) S1)
(declare-fun f19 () Int)
(declare-fun f20 (S8 S9) Int)
(declare-fun f21 () S8)
(declare-fun f22 (Int Int) S9)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 () S4)
(assert (not (= f1 f2)))
(assert (not (= (f3 (+ (* 4 f4) 1)) f1)))
(assert (= (f3 (f5 (f6 f7 (+ (* 4 f4) 1)) f8)) f1))
(assert (= f8 1))
(assert (<= 1 f8))
(assert (= (f3 (f5 (f6 f7 (+ (* 4 f4) 1)) f8)) f1))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (< f8 (+ (* 4 f4) 1)))
(assert (= (f9 (+ (* 4 f4) 1)) f1))
(assert (= (f5 (f6 f10 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (= (f11 (+ (* 4 f4) 1) (- 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f11 ?v_0 (- 1)) f1)) (not (= (f5 (f6 f10 (- 1)) ?v_0) 1)))))
(assert (= (+ (f12 (f13 f14 f15) (f16 f17 2)) 1) (f5 (f6 f7 (+ (* 4 f4) 1)) f8)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f18 f19 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f18 f19 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f18 f19 ?v0 ?v_0) f1))) false))) false))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f15) (and (< f15 ?v_0) (= (f18 f19 f15 ?v_0) f1)))))
(assert (= (f18 (f12 (f13 f14 f19) (f16 f17 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f18 (f12 (f13 f14 ?v0) (f16 f17 2)) (- 1) (+ (* 4 f4) 1)) f1) false)) false))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f12 (f13 f14 f15) (f16 f17 2)) 1) (f5 (f6 f7 (+ (* 4 f4) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int)) (= (= (f3 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f20 f21 (f22 ?v1 ?v2)) ?v0)))))
(assert (= (f20 f21 (f22 f15 1)) (f5 (f6 f7 (+ (* 4 f4) 1)) f8)))
(assert (= f8 1))
(assert (let ((?v_0 (f12 (f13 f14 f15) (f16 f17 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f18 (f12 (f13 f14 f15) (f16 f17 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (let ((?v_0 (f16 f17 2))) (= (f18 (f12 (f13 f14 f15) ?v_0) (f12 (f13 f14 f19) ?v_0) (+ (* 4 f4) 1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f7 ?v0)) (?v_1 (f6 f7 ?v1))) (= (f5 (f6 f7 (f20 f21 (f22 ?v0 ?v1))) (f20 f21 (f22 ?v2 ?v3))) (f20 f21 (f22 (+ (f5 ?v_0 ?v2) (f5 ?v_1 ?v3)) (- (f5 ?v_0 ?v3) (f5 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f9 ?v_0) f1) (= (f5 (f6 f10 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f10 ?v0) ?v1) (ite (= (f18 ?v0 0 ?v1) f1) 0 (ite (= (f11 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f18 (f12 (f13 f14 ?v2) (f16 f17 2)) ?v1 ?v0) f1)))))
(assert (= (f23 (+ (* 4 f4) 1) (- (f12 (f13 f14 f15) (f16 f17 2)) (- 1))) f1))
(assert (= (f23 (+ (* 4 f4) 1) (+ (f12 (f13 f14 f15) (f16 f17 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (not (= (f18 ?v1 0 ?v0) f1)) (=> (not (= (f18 ?v2 0 ?v0) f1)) (not (= (f18 (f5 (f6 f7 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f18 (f5 (f6 f7 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f18 ?v1 0 ?v0) f1)) (not (= (f18 ?v2 0 ?v0) f1))) (not (= (f18 (f5 (f6 f7 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (= (f18 (f5 (f6 f7 ?v1) ?v2) 0 ?v0) f1) (or (= (f18 ?v1 0 ?v0) f1) (= (f18 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 S5)) (= (f16 f17 (f12 f24 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f24 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f24 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
