(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (Int) S1)
(declare-fun f8 (S4 Int) Int)
(declare-fun f9 (S5 Int) S4)
(declare-fun f10 () S5)
(declare-fun f11 () Int)
(declare-fun f12 () S3)
(declare-fun f13 (S6 Int) S3)
(declare-fun f14 () S6)
(declare-fun f15 (Int) S1)
(declare-fun f16 () S5)
(declare-fun f17 (Int Int) S1)
(declare-fun f18 (S7 Int) S2)
(declare-fun f19 () S7)
(declare-fun f20 () Int)
(declare-fun f21 (Int Int) S1)
(declare-fun f22 (Int Int Int) S1)
(declare-fun f23 (S8 S9) Int)
(declare-fun f24 () S8)
(declare-fun f25 (Int Int) S9)
(declare-fun f26 () Int)
(declare-fun f27 (S10 S3) S3)
(declare-fun f28 (S11 S3) S10)
(declare-fun f29 () S11)
(declare-fun f30 () S11)
(declare-fun f31 () S4)
(declare-fun f32 (S3 S3) S1)
(declare-fun f33 () S5)
(assert (not (= f1 f2)))
(assert (not (< 0 (f3 f4 f5))))
(assert (< 0 (f3 f4 f5)))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f5)))) (not (=> (< ?v_1 ?v_0) (not (= (f7 (f8 (f9 f10 ?v_0) ?v_1)) f1))))))
(assert (not (= (f7 (f8 (f9 f10 (+ (* 4 f6) 1)) (+ 1 0))) f1)))
(assert (< 1 f11))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (< 0 (f3 f4 f5)))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f5)))) (not (=> (< ?v_1 ?v_0) (not (= (f7 (f8 (f9 f10 ?v_0) ?v_1)) f1))))))
(assert (= f12 (f13 f14 (- (f3 f4 (f13 f14 f11)) 1))))
(assert (= (f15 (+ (* 4 f6) 1)) f1))
(assert (= (f8 (f9 f16 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (<= 1 f11))
(assert (= (f17 (+ (* 4 f6) 1) (- 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (= (f7 ?v1) f1) (= (f7 (f8 (f9 f10 ?v0) ?v1)) f1)))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f13 f14 (- (f3 f4 (f13 f14 f11)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (< f11 (+ (* 4 f6) 1)))
(assert (< 0 (f3 f4 f12)))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (=> (not (= (f17 ?v_0 (- 1)) f1)) (not (= (f8 (f9 f16 (- 1)) ?v_0) 1)))))
(assert (= (f7 (f8 (f9 f10 (+ (* 4 f6) 1)) f11)) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f15 ?v_0) f1) (= (f8 (f9 f16 (- 1)) ?v_0) 1)))))
(assert (= (+ (f3 (f18 f19 f20) (f13 f14 2)) 1) (f8 (f9 f10 (+ (* 4 f6) 1)) f11)))
(assert (=> (= f11 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (+ (f3 (f18 f19 ?v0) ?v_0) (f3 (f18 f19 ?v1) ?v_0)) (+ (* 4 f6) 1))))))
(assert (= (f15 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f15 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (let ((?v_0 (f3 (f18 f19 f20) (f13 f14 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f18 f19 f20) (f13 f14 2)) 1) (f8 (f9 f10 (+ (* 4 f6) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int)) (=> (= (f3 (f18 f19 ?v0) (f13 f14 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (= (f3 (f18 f19 ?v0) ?v_0) (f3 (f18 f19 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2)) (?v_1 (f18 f19 ?v0))) (= (f3 (f18 f19 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f13 f14 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 3))) (= (f3 (f18 f19 (- ?v0)) ?v_0) (- (f3 (f18 f19 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f18 f19 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 3))) (let ((?v_0 (f3 (f18 f19 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f18 f19 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 2))) (let ((?v_0 (f3 (f18 f19 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f18 f19 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f18 f19 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f18 f19 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f8 (f9 f10 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f18 f19 ?v0) ?v_0) (f3 (f18 f19 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_3 (f18 f19 ?v1)) (?v_1 (f18 f19 ?v0))) (= (f3 (f18 f19 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_1 (f18 f19 ?v0)) (?v_3 (f18 f19 ?v1))) (= (f3 (f18 f19 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f18 f19 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f18 f19 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f3 (f18 f19 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f18 f19 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f18 f19 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f3 (f18 f19 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f19 ?v0))) (= (f8 (f9 f10 ?v0) (f3 ?v_0 (f13 f14 2))) (f3 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f8 (f9 f10 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f4 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f8 (f9 f10 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (= (f21 (+ (* 4 f6) 1) (- (f3 (f18 f19 f20) (f13 f14 2)) (- 1))) f1))
(assert (= (f21 (+ (* 4 f6) 1) (+ (f3 (f18 f19 f20) (f13 f14 2)) 1)) f1))
(assert (= (f22 (f3 (f18 f19 f20) (f13 f14 2)) (- 1) (+ (* 4 f6) 1)) f1))
(assert (= (f23 f24 (f25 f20 1)) (f8 (f9 f10 (+ (* 4 f6) 1)) f11)))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (and (<= 0 f20) (and (< f20 ?v_0) (= (f22 f26 f20 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 ?v1)) (?v_1 (f13 f14 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f8 (f9 f10 ?v1) (f3 ?v_0 (f13 f14 (- (f3 f4 ?v_1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f18 f19 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f13 f14 (- (+ ?v_0 1) ?v_1))) (f8 (f9 f10 (f3 ?v_2 (f13 f14 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f28 f29 ?v2))) (=> (<= ?v_1 ?v_0) (= (f27 ?v_2 (f13 f14 (- (+ ?v_0 1) ?v_1))) (f27 (f28 f30 (f27 ?v_2 (f13 f14 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f3 f4 ?v0)) (?v_1 (f18 f19 ?v1))) (=> (< 0 ?v_0) (= (f8 (f9 f10 (f3 ?v_1 (f13 f14 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f4 ?v0)) (?v_1 (f28 f29 ?v1))) (=> (< 0 ?v_0) (= (f27 (f28 f30 (f27 ?v_1 (f13 f14 (- ?v_0 1)))) ?v1) (f27 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f8 (f9 f10 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f13 f14 (+ (f3 f4 ?v1) (f3 f4 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 (f28 f30 (f27 ?v_0 ?v1)) (f27 ?v_0 ?v2)) (f27 ?v_0 (f13 f14 (+ (f3 f4 ?v1) (f3 f4 ?v2))))))))
(assert (= (f22 (f3 (f18 f19 f26) (f13 f14 2)) (- 1) (+ (* 4 f6) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f22 (f3 (f18 f19 ?v0) (f13 f14 2)) (- 1) (+ (* 4 f6) 1)) f1) false)) false))
(assert (let ((?v_0 (f13 f14 2))) (= (f22 (f3 (f18 f19 f20) ?v_0) (f3 (f18 f19 f26) ?v_0) (+ (* 4 f6) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f22 f26 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f22 f26 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f22 f26 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f22 (f3 ?v_0 ?v1) 1 ?v2) f1) (= (f22 (f3 ?v_0 (f13 f14 (f8 (f9 f10 (f3 f4 ?v1)) (f3 f4 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 ?v0 (- ?v1 ?v2)) f1) (=> (= (f21 ?v0 ?v2) f1) (= (f21 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (= (f21 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f21 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f21 ?v0 ?v1) f1) (=> (= (f21 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f22 ?v0 0 ?v1) f1)) (=> (= (f22 (f3 (f18 f19 ?v2) (f13 f14 2)) ?v0 ?v1) f1) (not (= (f21 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f21 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f21 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f3 (f18 f19 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f13 f14 (f8 (f9 f10 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2) (f27 ?v_0 (f13 f14 (f8 (f9 f10 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f9 f10 ?v1))) (= (f8 (f9 f10 (f23 f24 (f25 ?v0 ?v1))) (f23 f24 (f25 ?v2 ?v3))) (f23 f24 (f25 (+ (f8 ?v_0 ?v2) (f8 ?v_1 ?v3)) (- (f8 ?v_0 ?v3) (f8 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f22 (f8 (f9 f10 ?v0) ?v_0) 1 ?v1) f1) (= (f22 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f21 ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) f1) (= (f21 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f21 (f8 (f9 f10 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f21 ?v0 ?v1) f1) (= (= (f21 ?v0 (+ ?v2 ?v3)) f1) (= (f21 ?v0 (+ (+ ?v2 (f8 (f9 f10 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f21 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f21 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f13 f14 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f13 f14 (f8 (f9 f10 (f3 f4 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)))) (f3 f4 (f13 f14 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 (f9 f10 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 (f9 f10 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f13 f14 (f8 (f9 f10 ?v0) ?v1)) (f13 f14 (f8 (f9 f10 (f3 f4 (f13 f14 ?v0))) (f3 f4 (f13 f14 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f13 f14 (f8 (f9 f10 ?v0) ?v1)) (f13 f14 (f8 (f9 f10 (f3 f4 (f13 f14 (- ?v0)))) (f3 f4 (f13 f14 (- ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f27 (f28 f29 ?v0) ?v1)) (f3 (f18 f19 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f18 f19 (f3 f4 ?v0)) ?v1) (f3 f4 (f27 (f28 f29 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f13 f14 (f3 (f18 f19 ?v0) ?v1)) (f27 (f28 f29 (f13 f14 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f3 (f18 f19 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f13 f14 (f8 (f9 f10 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f15 ?v0) f1) (=> (= (f21 ?v0 (f3 (f18 f19 ?v1) ?v2)) f1) (= (f21 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f18 f19 ?v0) ?v2))) (=> (= (f15 ?v0) f1) (=> (not (= (f21 ?v0 ?v1) f1)) (=> (= (f21 ?v_0 (f8 (f9 f10 ?v1) ?v3)) f1) (= (f21 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f18 f19 ?v0) ?v2))) (=> (= (f15 ?v0) f1) (=> (not (= (f21 ?v0 ?v1) f1)) (=> (= (f21 ?v_0 (f8 (f9 f10 ?v3) ?v1)) f1) (= (f21 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f27 (f28 f30 ?v0) ?v1) (f27 (f28 f30 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f28 f30 ?v0)) (?v_0 (f28 f30 ?v1))) (= (f27 ?v_1 (f27 ?v_0 ?v2)) (f27 ?v_0 (f27 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f9 f10 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 f30 ?v0))) (= (f27 ?v_0 (f27 (f28 f30 ?v1) ?v2)) (f27 (f28 f30 (f27 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 f30 ?v0))) (= (f27 (f28 f30 (f27 ?v_0 ?v1)) ?v2) (f27 ?v_0 (f27 (f28 f30 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 f30 ?v0))) (= (f27 (f28 f30 (f27 ?v_0 ?v1)) ?v2) (f27 (f28 f30 (f27 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f28 f30 ?v0)) (?v_1 (f27 (f28 f30 ?v2) ?v3))) (= (f27 (f28 f30 (f27 ?v_0 ?v1)) ?v_1) (f27 ?v_0 (f27 (f28 f30 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f8 (f9 f10 ?v2) ?v3))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f28 f30 (f27 (f28 f30 ?v0) ?v1))) (?v_0 (f28 f30 ?v2))) (= (f27 ?v_1 (f27 ?v_0 ?v3)) (f27 ?v_0 (f27 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f9 f10 (f8 (f9 f10 ?v0) ?v1))) (?v_0 (f9 f10 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f28 f30 ?v0))) (= (f27 (f28 f30 (f27 ?v_0 ?v1)) (f27 (f28 f30 ?v2) ?v3)) (f27 (f28 f30 (f27 ?v_0 ?v2)) (f27 (f28 f30 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 (f9 f10 ?v2) ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v2)) (f8 (f9 f10 ?v1) ?v3))))))
(assert (forall ((?v0 Int)) (= (f3 (f18 f19 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f27 (f28 f29 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) ?v0) (f3 (f18 f19 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 S3)) (= (f27 (f28 f30 ?v0) ?v0) (f27 (f28 f29 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f4 ?v1) 1))) (f8 (f9 f10 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 ?v_0 (f13 f14 (+ (f3 f4 ?v1) 1))) (f27 (f28 f30 ?v0) (f27 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f13 f14 (+ (* 2 (f3 f4 ?v1)) 1))) (f8 (f9 f10 ?v0) (f8 (f9 f10 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f28 f29 ?v0))) (let ((?v_1 (f27 ?v_0 ?v1))) (= (f27 ?v_0 (f13 f14 (+ (* 2 (f3 f4 ?v1)) 1))) (f27 (f28 f30 ?v0) (f27 (f28 f30 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f8 (f9 f10 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f13 f14 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 (f28 f30 ?v0) (f27 ?v_0 ?v1)) (f27 ?v_0 (f13 f14 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f13 f14 (* 2 (f3 f4 ?v1)))) (f8 (f9 f10 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f28 f29 ?v0))) (let ((?v_1 (f27 ?v_0 ?v1))) (= (f27 ?v_0 (f13 f14 (* 2 (f3 f4 ?v1)))) (f27 (f28 f30 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f8 (f9 f10 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f13 f14 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 (f28 f30 (f27 ?v_0 ?v1)) ?v0) (f27 ?v_0 (f13 f14 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f18 f19 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f3 (f18 f19 ?v0) ?v2)) (f3 (f18 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f27 (f28 f29 (f27 (f28 f30 ?v0) ?v1)) ?v2) (f27 (f28 f30 (f27 (f28 f29 ?v0) ?v2)) (f27 (f28 f29 ?v1) ?v2)))))
(assert (forall ((?v0 Int)) (= (= (f7 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f23 f24 (f25 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (not (= (f21 ?v0 ?v1) f1)) (= (f22 (f3 (f18 f19 ?v1) (f13 f14 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f16 ?v0) ?v1) (ite (= (f22 ?v0 0 ?v1) f1) 0 (ite (= (f17 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f17 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f22 (f3 (f18 f19 ?v2) (f13 f14 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f15 ?v0) f1) (=> (= (f21 ?v0 (f3 (f18 f19 ?v1) ?v2)) f1) (=> (< 0 (f3 f4 ?v2)) (= (f21 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (= (f21 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1) (or (= (f21 ?v0 ?v1) f1) (= (f21 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f15 ?v1) f1) (=> (= (f21 ?v1 (f8 (f9 f10 ?v0) ?v2)) f1) (or (= (f21 ?v1 ?v0) f1) (= (f21 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f4 (f13 f14 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f13 f14 (f8 (f9 f10 ?v_0) ?v_0)) (f13 f14 (+ (f8 (f9 f10 (f3 f4 (f13 f14 (- ?v0 1)))) (f3 f4 (f13 f14 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f9 f10 ?v1))) (= (+ (f8 (f9 f10 (- ?v0 (f8 ?v_0 ?v2))) ?v3) (f8 (f9 f10 (- ?v4 (f8 ?v_0 ?v5))) ?v6)) (- (+ (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v4) ?v6)) (f8 ?v_0 (+ (f8 (f9 f10 ?v2) ?v3) (f8 (f9 f10 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (= (f22 ?v3 ?v4 ?v2) f1) (= (f22 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (= (f22 ?v3 ?v4 ?v2) f1) (= (f22 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (= (f22 ?v1 ?v3 ?v2) f1) (= (f22 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f22 ?v3 ?v4 ?v2) f1) (= (f22 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (f22 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f22 ?v1 (- 1) ?v0) f1) (not (= (f22 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f22 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f22 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f22 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f22 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f22 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int)) (= (f22 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 ?v1 (- ?v2)) f1) (= (f22 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 ?v1 ?v2) f1) (= (f22 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f8 (f9 f10 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f22 (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (= (f22 ?v3 (f8 (f9 f10 ?v0) ?v4) ?v2) f1) (= (f22 ?v3 (f8 (f9 f10 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v4))) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (= (f22 ?v3 (f8 ?v_0 ?v0) ?v2) f1) (= (f22 ?v3 (f8 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (f22 (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v3))) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (f22 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (= (f22 ?v3 ?v4 ?v2) f1) (= (f22 (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 ?v1 ?v2) f1) (= (f21 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 ?v0 0 ?v1) f1) (= (f21 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 ?v0 0 ?v1) f1) (= (f21 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (f22 (f3 (f18 f19 ?v0) ?v3) (f3 (f18 f19 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f21 ?v1 ?v2) f1) (= (f21 ?v1 (f3 (f18 f19 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f15 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f21 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (= (f22 (f8 (f9 f10 ?v1) ?v1) 1 ?v0) f1) (or (= (f22 ?v1 1 ?v0) f1) (= (f22 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (= (f22 (f8 (f9 f10 ?v1) ?v2) 0 ?v0) f1) (or (= (f22 ?v1 0 ?v0) f1) (= (f22 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f22 ?v1 0 ?v0) f1)) (not (= (f22 ?v2 0 ?v0) f1))) (not (= (f22 (f8 (f9 f10 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f22 (f8 (f9 f10 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (not (= (f22 ?v1 0 ?v0) f1)) (=> (not (= (f22 ?v2 0 ?v0) f1)) (not (= (f22 (f8 (f9 f10 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (* 2 (f3 f4 ?v1)) 1))) (f8 (f9 f10 ?v0) (f3 (f18 f19 (f3 ?v_0 ?v1)) (f13 f14 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 ?v_0 (f13 f14 (+ (* 2 (f3 f4 ?v1)) 1))) (f27 (f28 f30 ?v0) (f27 (f28 f29 (f27 ?v_0 ?v1)) (f13 f14 2)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f15 ?v1) f1) (= (f21 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f27 (f28 f29 (f13 f14 ?v0)) ?v1) (f13 f14 (f3 (f18 f19 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f18 f19 (f3 f4 ?v0)) ?v1) (f3 f4 (f27 (f28 f29 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f18 f19 ?v0) (f13 f14 2)))) (= (f8 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f18 f19 (f8 f31 ?v0)) ?v_0) (f3 (f18 f19 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 0)) (?v_2 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v1))) (= (f13 f14 (f8 (f9 f10 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f13 f14 (+ ?v_1 (f8 (f9 f10 (f3 f4 (f13 f14 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f4 ?v0))) (= (f13 f14 (* ?v_0 2)) (f13 f14 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f4 ?v0))) (= (f13 f14 (* 2 ?v_0)) (f13 f14 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f3 (f18 f19 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (= (f3 (f18 f19 ?v0) (f13 f14 2)) (f8 (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f27 (f28 f29 ?v0) (f13 f14 2)) (f27 (f28 f30 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f3 (f18 f19 ?v0) (f13 f14 3)) (f8 (f9 f10 (f8 (f9 f10 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3)) (= (f27 (f28 f29 ?v0) (f13 f14 3)) (f27 (f28 f30 (f27 (f28 f30 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f3 ?v_0 (f13 f14 (* 2 (f3 f4 ?v1)))) (f3 (f18 f19 (f3 ?v_0 ?v1)) (f13 f14 2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 ?v_0 (f13 f14 (* 2 (f3 f4 ?v1)))) (f27 (f28 f29 (f27 ?v_0 ?v1)) (f13 f14 2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 (f9 f10 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f13 f14 (f8 (f9 f10 (f3 f4 (f13 f14 ?v0))) (f3 f4 (f13 f14 ?v1)))) (f13 f14 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 ?v_0 ?v1) (ite (= ?v1 (f13 f14 0)) (f13 f14 1) (f13 f14 (f8 (f9 f10 (f3 f4 ?v0)) (f3 f4 (f27 ?v_0 (f13 f14 (- (f3 f4 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f13 f14 0))) (= (= (f21 (f3 (f18 f19 ?v1) ?v0) (f3 (f18 f19 ?v2) ?v0)) f1) (= (f21 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f21 (f3 (f18 f19 ?v0) ?v1) (f3 (f18 f19 ?v2) ?v1)) f1) (=> (not (= ?v1 (f13 f14 0))) (= (f21 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 f19 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f22 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f22 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f18 f19 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 2)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (= (f13 f14 (- (f3 f4 (f27 (f28 f29 ?v0) ?v_0)) (f3 f4 (f27 (f28 f29 ?v1) ?v_0)))) (f13 f14 (f8 (f9 f10 (+ ?v_1 ?v_2)) (f3 f4 (f13 f14 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (not (= ?v0 0)) (= (= (f21 ?v1 ?v2) f1) (= (f21 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f3 ?v_0 (f13 f14 (f8 (f9 f10 (f3 f4 ?v1)) (f3 f4 ?v2)))) (f3 (f18 f19 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 ?v_0 (f13 f14 (f8 (f9 f10 (f3 f4 ?v1)) (f3 f4 ?v2)))) (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f8 f31 (f3 (f18 f19 ?v0) ?v1)) (f3 (f18 f19 (f8 f31 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f3 (f18 f19 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f27 (f28 f29 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 1))) (= (= (f13 f14 (f8 (f9 f10 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 ?v0 ?v1) f1) (= (f21 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 ?v0 ?v1) f1) (= (f21 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f4 (f27 (f28 f29 ?v0) ?v1))) (or (< 0 (f3 f4 ?v0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f13 f14 (+ 0 1)))) (= (f27 (f28 f29 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 0))) (= (= (f27 (f28 f29 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 1))) (= (= (f27 (f28 f29 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f13 f14 0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 (+ 0 1)))) (= (= (f27 (f28 f29 ?v0) ?v1) ?v_0) (or (= ?v1 (f13 f14 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 (+ (f3 f4 ?v1) 1)))) (= (= (f27 (f28 f29 ?v0) ?v_0) (f27 (f28 f29 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 (+ (f3 f4 ?v1) 1)))) (= (< (f3 f4 (f27 (f28 f29 ?v0) ?v_0)) (f3 f4 (f27 (f28 f29 ?v2) ?v_0))) (< (f3 f4 ?v0) (f3 f4 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 (+ (f3 f4 ?v1) 1)))) (= (<= (f3 f4 (f27 (f28 f29 ?v0) ?v_0)) (f3 f4 (f27 (f28 f29 ?v2) ?v_0))) (<= (f3 f4 ?v0) (f3 f4 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 f29 ?v0))) (=> (< 0 (f3 f4 ?v0)) (=> (< (f3 f4 (f27 ?v_0 ?v1)) (f3 f4 (f27 ?v_0 ?v2))) (< (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f4 ?v0)) (<= ?v_0 (f3 f4 (f27 (f28 f29 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f4 ?v1) 1))) (f8 (f9 f10 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 ?v_0 (f13 f14 (+ (f3 f4 ?v1) 1))) (f27 (f28 f30 ?v0) (f27 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f4 ?v1) 1))) (f8 (f9 f10 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 ?v_0 (f13 f14 (+ (f3 f4 ?v1) 1))) (f27 (f28 f30 (f27 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f8 (f9 f10 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 ?v_0 (f13 f14 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f27 (f28 f30 (f27 ?v_0 ?v1)) (f27 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f3 (f18 f19 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f27 (f28 f29 ?v0) ?v1))) (= (f27 (f28 f30 ?v_0) ?v0) (f27 (f28 f30 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f18 f19 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f3 (f18 f19 ?v0) ?v2)) (f3 (f18 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f27 (f28 f29 (f27 (f28 f30 ?v0) ?v1)) ?v2) (f27 (f28 f30 (f27 (f28 f29 ?v0) ?v2)) (f27 (f28 f29 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f21 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f21 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f28 f29 ?v0))) (=> (= (f32 (f27 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f32 (f27 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f21 ?v0 ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f21 (f3 (f18 f19 ?v0) ?v2) (f3 (f18 f19 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f32 ?v0 ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f32 (f27 (f28 f29 ?v0) ?v2) (f27 (f28 f29 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f18 f19 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f21 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 f29 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f32 (f27 ?v_0 ?v0) (f27 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f21 ?v0 ?v1) f1) (= (f21 (f3 (f18 f19 ?v0) ?v2) (f3 (f18 f19 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f32 ?v0 ?v1) f1) (= (f32 (f27 (f28 f29 ?v0) ?v2) (f27 (f28 f29 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 (f8 (f9 f10 ?v0) ?v1) ?v2) f1) (= (f21 ?v1 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f32 (f27 (f28 f30 ?v0) ?v1) ?v2) f1) (= (f32 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 (f8 (f9 f10 ?v0) ?v1) ?v2) f1) (= (f21 ?v0 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f32 (f27 (f28 f30 ?v0) ?v1) ?v2) f1) (= (f32 ?v0 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 f29 ?v0))) (=> (= (f32 (f27 ?v_0 ?v1) (f27 ?v_0 ?v2)) f1) (=> (< 1 (f3 f4 ?v0)) (<= (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f32 (f27 (f28 f29 ?v0) ?v1) (f27 (f28 f29 ?v2) ?v1)) f1) (=> (not (= ?v1 (f13 f14 0))) (= (f32 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f32 ?v0 ?v1) f1) (= (f32 (f27 (f28 f29 ?v0) ?v2) (f27 (f28 f29 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f32 ?v0 ?v1) f1) (= (f32 ?v0 (f27 (f28 f29 ?v1) (f13 f14 (+ (f3 f4 ?v2) 1)))) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f13 f14 0))) (=> (= (f32 (f27 (f28 f29 ?v1) ?v0) ?v2) f1) (= (f32 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f3 f4 ?v2)) (?v_0 (f3 f4 ?v3))) (=> (= ?v0 (f13 f14 (+ (f8 (f9 f10 (f3 f4 ?v1)) ?v_1) ?v_0))) (=> (< 0 ?v_0) (=> (< ?v_0 ?v_1) (not (= (f32 ?v2 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f9 f10 (f3 f4 ?v2)))) (=> (= (f32 ?v0 ?v1) f1) (= (f32 (f13 f14 (f8 ?v_0 (f3 f4 ?v0))) (f13 f14 (f8 ?v_0 (f3 f4 ?v1)))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v2))) (=> (= (f32 ?v0 ?v1) f1) (= (f32 (f13 f14 (f8 (f9 f10 (f3 f4 ?v0)) ?v_0)) (f13 f14 (f8 (f9 f10 (f3 f4 ?v1)) ?v_0))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f32 ?v0 ?v1) f1) (or (= ?v1 (f13 f14 0)) (or (= ?v1 ?v0) (<= (* 2 (f3 f4 ?v0)) (f3 f4 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v1))) (= (= (f32 (f13 f14 (f8 (f9 f10 (f3 f4 ?v0)) ?v_0)) (f13 f14 (f8 (f9 f10 (f3 f4 ?v2)) ?v_0))) f1) (or (= ?v1 (f13 f14 0)) (= (f32 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f32 (f13 f14 ?v0) (f13 f14 ?v1)) f1) (= (f21 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f21 (f3 f4 ?v0) (f3 f4 ?v1)) f1) (= (f32 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f32 (f13 f14 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f21 ?v0 (f3 f4 ?v1)) f1) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f21 (f3 f4 ?v0) ?v1) f1) (= (f32 ?v0 (f13 f14 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f21 ?v0 (f3 f4 ?v1)) f1) (= (f32 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f32 ?v0 ?v1) f1) (= (f21 (f3 f4 ?v0) (f3 f4 ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f13 f14 0))) (= (= (f32 (f27 (f28 f29 ?v1) ?v0) (f27 (f28 f29 ?v2) ?v0)) f1) (= (f32 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f31 ?v0))) (= (f8 (f9 f10 ?v_0) ?v_0) (f8 (f9 f10 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f31 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f31 ?v0)) (f8 f31 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 f31 ?v0) (f8 f31 ?v1)) (= (f21 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (= (f21 ?v1 ?v2) f1) (= (f21 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f32 ?v0 ?v1) f1) (=> (= (f32 ?v1 ?v2) f1) (= (f32 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 (f8 f31 ?v0) ?v1) f1) (= (f21 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 ?v0 (f8 f31 ?v1)) f1) (= (f21 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int)) (= (f21 ?v0 ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f32 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 ?v0 (f8 (f9 f10 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f32 ?v0 (f27 (f28 f30 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 ?v0 (f8 (f9 f10 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f32 ?v0 (f27 (f28 f30 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 ?v0 ?v1) f1) (= (f21 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f32 ?v0 ?v1) f1) (= (f32 ?v0 (f27 (f28 f30 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 ?v0 ?v1) f1) (= (f21 ?v0 (f8 (f9 f10 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f32 ?v0 ?v1) f1) (= (f32 ?v0 (f27 (f28 f30 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (= (f21 ?v2 ?v3) f1) (= (f21 (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f32 ?v0 ?v1) f1) (=> (= (f32 ?v2 ?v3) f1) (= (f32 (f27 (f28 f30 ?v0) ?v2) (f27 (f28 f30 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f8 (f9 f10 ?v1) ?v2)) (= (f21 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 (f27 (f28 f30 ?v1) ?v2)) (= (f32 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (forall ((?v2 Int)) (=> (= ?v1 (f8 (f9 f10 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f32 ?v0 ?v1) f1) (=> (forall ((?v2 S3)) (=> (= ?v1 (f27 (f28 f30 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f22 ?v1 0 ?v0) f1)) (=> (not (= (f22 ?v2 0 ?v0) f1)) (=> (not (= (f17 ?v0 ?v1) f1)) (not (= (f22 ?v2 (f8 (f9 f10 ?v1) (f8 (f9 f33 ?v0) ?v2)) ?v0) f1)))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f32 ?v0 ?v1) f1) (=> (= (f32 ?v0 (f13 f14 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) f1) (= (f32 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f32 ?v0 ?v1) f1) (or (= ?v1 (f13 f14 0)) (<= (f3 f4 ?v0) (f3 f4 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (and (= (f32 ?v0 ?v1) f1) (= (f32 ?v1 ?v0) f1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f13 f14 1))) (=> (= (f32 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f32 ?v1 ?v0) f1) (< 0 (f3 f4 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f13 f14 0))) (=> (= (f32 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f13 f14 1))) (= (= (f32 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f13 f14 0))) (= (= (f32 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (= (f13 f14 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
