(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 () S3)
(declare-fun f8 (S4 Int) S3)
(declare-fun f9 () S4)
(declare-fun f10 () Int)
(declare-fun f11 (S5 Int) S1)
(declare-fun f12 () S5)
(declare-fun f13 (S6 Int) Int)
(declare-fun f14 (S7 Int) S6)
(declare-fun f15 () S7)
(declare-fun f16 (S8 Int) S2)
(declare-fun f17 () S8)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () S5)
(declare-fun f21 () S7)
(declare-fun f22 () Int)
(declare-fun f23 (S9 Int) S5)
(declare-fun f24 () S9)
(declare-fun f25 (S10 S3) S11)
(declare-fun f26 () S10)
(declare-fun f27 (S11 S3) S3)
(declare-fun f28 () S10)
(declare-fun f29 () S9)
(declare-fun f30 (S12 Int) S9)
(declare-fun f31 () S12)
(declare-fun f32 (S13 S14) Int)
(declare-fun f33 () S13)
(declare-fun f34 (Int Int) S14)
(declare-fun f35 () Int)
(declare-fun f36 (S15 S3) S1)
(declare-fun f37 (S16 S3) S15)
(declare-fun f38 () S16)
(declare-fun f39 () S6)
(assert (not (= f1 f2)))
(assert (not (< 0 (+ 1 (f3 f4 f5)))))
(assert (< 0 (f3 f4 f5)))
(assert (< 1 f6))
(assert (< 0 (f3 f4 f5)))
(assert (= f7 (f8 f9 (- (f3 f4 (f8 f9 f6)) 1))))
(assert (<= 1 f6))
(assert (let ((?v_1 (+ 1 (f3 f4 f5))) (?v_0 (+ (* 4 f10) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f11 f12 (f13 (f14 f15 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_1 (+ 1 (f3 f4 f5))) (?v_0 (+ (* 4 f10) 1))) (and (< ?v_1 ?v_0) (= (f11 f12 (f13 (f14 f15 ?v_0) ?v_1)) f1))))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f16 f17 f18) ?v_0) (f3 (f16 f17 f19) ?v_0)) (f13 (f14 f15 (+ (* 4 f10) 1)) (+ 1 (f3 f4 f5))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (=> (= (+ (f3 (f16 f17 ?v0) ?v_0) (f3 (f16 f17 ?v1) ?v_0)) (f13 (f14 f15 (+ (* 4 f10) 1)) (+ 1 (f3 f4 f5)))) false))) false))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f8 f9 (- (f3 f4 (f8 f9 f6)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (< 0 (+ (* 4 f10) 1)))
(assert (< 0 (f3 f4 f7)))
(assert (not (= (f11 f12 (f13 (f14 f15 (+ (* 4 f10) 1)) (+ 1 0))) f1)))
(assert (< f6 (+ (* 4 f10) 1)))
(assert (= (f11 f12 (f13 (f14 f15 (+ (* 4 f10) 1)) f6)) f1))
(assert (= (f11 f20 (+ (* 4 f10) 1)) f1))
(assert (= (f13 (f14 f21 (- 1)) (+ (* 4 f10) 1)) 1))
(assert (= (+ (f3 (f16 f17 f22) (f8 f9 2)) 1) (f13 (f14 f15 (+ (* 4 f10) 1)) f6)))
(assert (=> (= f6 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f16 f17 ?v0) ?v_0) (f3 (f16 f17 ?v1) ?v_0)) (+ (* 4 f10) 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 f12 ?v0) f1) (=> (= (f11 f12 ?v1) f1) (= (f11 f12 (f13 (f14 f15 ?v0) ?v1)) f1)))))
(assert (= (f11 (f23 f24 (+ (* 4 f10) 1)) (- 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f16 f17 f22) (f8 f9 2)) 1) (f13 (f14 f15 (+ (* 4 f10) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f13 (f14 f15 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f13 (f14 f15 ?v0) (f3 ?v_0 (f8 f9 2))) (f3 ?v_0 (f8 f9 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (f3 (f16 f17 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f16 f17 ?v0) ?v_0) (f13 (f14 f15 (* 2 ?v0)) ?v1)) (f3 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (f3 (f16 f17 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f16 f17 ?v0) ?v_0) (f13 (f14 f15 (* 2 ?v0)) ?v1)) (f3 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f8 f9 2)) (?v_0 (f8 f9 3)) (?v_1 (f16 f17 ?v0)) (?v_3 (f16 f17 ?v1))) (= (f3 (f16 f17 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f13 (f14 f15 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f13 (f14 f15 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f8 f9 2)) (?v_0 (f8 f9 3)) (?v_3 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0))) (= (f3 (f16 f17 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f13 (f14 f15 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f13 (f14 f15 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (f13 (f14 f15 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f16 f17 ?v0) ?v_0) (f3 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f8 f9 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f13 (f14 f15 ?v1) (f3 ?v_0 (f8 f9 (- (f3 f4 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (= (f13 (f14 f15 ?v0) ?v0) (f3 (f16 f17 ?v0) (f8 f9 2)))))
(assert (forall ((?v0 S3)) (= (f27 (f25 f26 ?v0) ?v0) (f27 (f25 f28 ?v0) (f8 f9 2)))))
(assert (let ((?v_0 (f3 (f16 f17 f22) (f8 f9 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f10) 1))) (=> (not (= (f11 (f23 f24 ?v_0) (- 1)) f1)) (not (= (f13 (f14 f21 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f11 f20 ?v_0) f1) (= (f13 (f14 f21 (- 1)) ?v_0) 1)))))
(assert (= (f11 f20 2) f1))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f3 (f16 f17 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f8 f9 (f13 (f14 f15 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f28 ?v0))) (= (f27 (f25 f28 (f27 ?v_0 ?v1)) ?v2) (f27 ?v_0 (f8 f9 (f13 (f14 f15 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f8 f9 (f13 (f14 f15 ?v0) ?v1)) (f8 f9 (f13 (f14 f15 (f3 f4 (f8 f9 (- ?v0)))) (f3 f4 (f8 f9 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f13 (f14 f15 ?v0) ?v1)) (f8 f9 (f13 (f14 f15 (f3 f4 (f8 f9 ?v0))) (f3 f4 (f8 f9 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 (f14 f15 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 (f14 f15 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 (f14 f15 ?v0) ?v1))) (= (f8 f9 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f8 f9 (f13 (f14 f15 (f3 f4 (f8 f9 (ite (< ?v0 0) (- ?v0) ?v0)))) (f3 f4 (f8 f9 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f8 f9 (f3 (f16 f17 ?v0) ?v1)) (f27 (f25 f28 (f8 f9 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f16 f17 (f3 f4 ?v0)) ?v1) (f3 f4 (f27 (f25 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f27 (f25 f28 ?v0) ?v1)) (f3 (f16 f17 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f3 (f16 f17 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f8 f9 (f13 (f14 f15 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f27 (f25 f26 (f27 ?v_0 ?v1)) (f27 (f25 f26 ?v2) ?v3)) (f27 (f25 f26 (f27 ?v_0 ?v2)) (f27 (f25 f26 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) (f13 (f14 f15 ?v2) ?v3)) (f13 (f14 f15 (f13 ?v_0 ?v2)) (f13 (f14 f15 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f25 f26 (f27 (f25 f26 ?v0) ?v1))) (?v_0 (f25 f26 ?v2))) (= (f27 ?v_1 (f27 ?v_0 ?v3)) (f27 ?v_0 (f27 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f14 f15 (f13 (f14 f15 ?v0) ?v1))) (?v_0 (f14 f15 ?v2))) (= (f13 ?v_1 (f13 ?v_0 ?v3)) (f13 ?v_0 (f13 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f27 (f25 f26 ?v2) ?v3))) (= (f27 (f25 f26 (f27 ?v_0 ?v1)) ?v_1) (f27 ?v_0 (f27 (f25 f26 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f13 (f14 f15 ?v2) ?v3))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v_1) (f13 ?v_0 (f13 (f14 f15 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f27 (f25 f26 (f27 ?v_0 ?v1)) ?v2) (f27 (f25 f26 (f27 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 (f14 f15 (f13 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f27 (f25 f26 (f27 ?v_0 ?v1)) ?v2) (f27 ?v_0 (f27 (f25 f26 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f13 (f14 f15 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f27 ?v_0 (f27 (f25 f26 ?v1) ?v2)) (f27 (f25 f26 (f27 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f13 (f14 f15 ?v1) ?v2)) (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f25 f26 ?v0)) (?v_0 (f25 f26 ?v1))) (= (f27 ?v_1 (f27 ?v_0 ?v2)) (f27 ?v_0 (f27 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f14 f15 ?v0)) (?v_0 (f14 f15 ?v1))) (= (f13 ?v_1 (f13 ?v_0 ?v2)) (f13 ?v_0 (f13 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f27 (f25 f26 ?v0) ?v1) (f27 (f25 f26 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f14 f15 ?v0) ?v1) (f13 (f14 f15 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (f3 (f16 f17 ?v0) (f8 f9 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f27 (f25 f28 ?v0) (f8 f9 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 (f14 f15 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 (f14 f15 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f4 ?v2))) (let ((?v_1 (f14 f15 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f13 ?v_1 ?v0) (f13 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f15 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f13 ?v_0 ?v0) (f13 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f13 (f14 f15 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f13 (f14 f15 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f13 (f14 f15 (- ?v0 ?v1)) ?v2) (- (f13 (f14 f15 ?v0) ?v2) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f13 (f14 f15 (+ ?v0 ?v1)) ?v2) (+ (f13 (f14 f15 ?v0) ?v2) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f13 (f14 f15 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f14 f15 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f14 f15 (- ?v0)) ?v1) (- (f13 (f14 f15 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (- ?v1 ?v2)) (- (f13 ?v_0 ?v1) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (+ ?v1 ?v2)) (+ (f13 ?v_0 ?v1) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f14 f15 ?v0) ?v1) (f13 (f14 f15 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f16 f17 ?v0) (f8 f9 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (= (f3 (f16 f17 ?v0) ?v_0) (f3 (f16 f17 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 2)) (?v_1 (f16 f17 ?v0))) (= (f3 (f16 f17 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f8 f9 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 3))) (= (f3 (f16 f17 (- ?v0)) ?v_0) (- (f3 (f16 f17 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f8 f9 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f8 f9 3))) (let ((?v_0 (f3 (f16 f17 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f8 f9 2))) (let ((?v_0 (f3 (f16 f17 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f16 f17 ?v0) (f8 f9 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f13 (f14 f15 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f8 f9 (+ (f3 f4 ?v1) (f3 f4 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f28 ?v0))) (= (f27 (f25 f26 (f27 ?v_0 ?v1)) (f27 ?v_0 ?v2)) (f27 ?v_0 (f8 f9 (+ (f3 f4 ?v1) (f3 f4 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f16 f17 (f13 (f14 f15 ?v0) ?v1)) ?v2) (f13 (f14 f15 (f3 (f16 f17 ?v0) ?v2)) (f3 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f27 (f25 f28 (f27 (f25 f26 ?v0) ?v1)) ?v2) (f27 (f25 f26 (f27 (f25 f28 ?v0) ?v2)) (f27 (f25 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f13 (f14 f15 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f8 f9 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f25 f28 ?v0))) (= (f27 (f25 f26 (f27 ?v_0 ?v1)) ?v0) (f27 ?v_0 (f8 f9 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f8 f9 (* 2 (f3 f4 ?v1)))) (f13 (f14 f15 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f25 f28 ?v0))) (let ((?v_1 (f27 ?v_0 ?v1))) (= (f27 ?v_0 (f8 f9 (* 2 (f3 f4 ?v1)))) (f27 (f25 f26 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f13 (f14 f15 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f8 f9 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f25 f28 ?v0))) (= (f27 (f25 f26 ?v0) (f27 ?v_0 ?v1)) (f27 ?v_0 (f8 f9 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f8 f9 (+ (* 2 (f3 f4 ?v1)) 1))) (f13 (f14 f15 ?v0) (f13 (f14 f15 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f25 f28 ?v0))) (let ((?v_1 (f27 ?v_0 ?v1))) (= (f27 ?v_0 (f8 f9 (+ (* 2 (f3 f4 ?v1)) 1))) (f27 (f25 f26 ?v0) (f27 (f25 f26 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (f3 f4 ?v1) 1))) (f13 (f14 f15 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f25 f28 ?v0))) (= (f27 ?v_0 (f8 f9 (+ (f3 f4 ?v1) 1))) (f27 (f25 f26 ?v0) (f27 ?v_0 ?v1))))))
(assert (= (f11 (f23 f29 (+ (* 4 f10) 1)) (- (f3 (f16 f17 f22) (f8 f9 2)) (- 1))) f1))
(assert (= (f11 (f23 f29 (+ (* 4 f10) 1)) (+ (f3 (f16 f17 f22) (f8 f9 2)) 1)) f1))
(assert (= (f11 (f23 (f30 f31 (f3 (f16 f17 f22) (f8 f9 2))) (- 1)) (+ (* 4 f10) 1)) f1))
(assert (= (f32 f33 (f34 f22 1)) (f13 (f14 f15 (+ (* 4 f10) 1)) f6)))
(assert (let ((?v_0 (+ (* 4 f10) 1))) (and (<= 0 f22) (and (< f22 ?v_0) (= (f11 (f23 (f30 f31 f35) f22) ?v_0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f16 f17 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f8 f9 (- (+ ?v_0 1) ?v_1))) (f13 (f14 f15 (f3 ?v_2 (f8 f9 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f25 f28 ?v2))) (=> (<= ?v_1 ?v_0) (= (f27 ?v_2 (f8 f9 (- (+ ?v_0 1) ?v_1))) (f27 (f25 f26 (f27 ?v_2 (f8 f9 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f3 f4 ?v0)) (?v_1 (f16 f17 ?v1))) (=> (< 0 ?v_0) (= (f13 (f14 f15 (f3 ?v_1 (f8 f9 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f4 ?v0)) (?v_1 (f25 f28 ?v1))) (=> (< 0 ?v_0) (= (f27 (f25 f26 (f27 ?v_1 (f8 f9 (- ?v_0 1)))) ?v1) (f27 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f16 f17 (f13 (f14 f15 ?v0) ?v1)) ?v2) (f13 (f14 f15 (f3 (f16 f17 ?v0) ?v2)) (f3 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f27 (f25 f28 (f27 (f25 f26 ?v0) ?v1)) ?v2) (f27 (f25 f26 (f27 (f25 f28 ?v0) ?v2)) (f27 (f25 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f3 (f16 f17 ?v0) ?v1))) (= (f13 (f14 f15 ?v_0) ?v0) (f13 (f14 f15 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f27 (f25 f28 ?v0) ?v1))) (= (f27 (f25 f26 ?v_0) ?v0) (f27 (f25 f26 ?v0) ?v_0)))))
(assert (= (f11 (f23 (f30 f31 (f3 (f16 f17 f35) (f8 f9 2))) (- 1)) (+ (* 4 f10) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f11 (f23 (f30 f31 (f3 (f16 f17 ?v0) (f8 f9 2))) (- 1)) (+ (* 4 f10) 1)) f1) false)) false))
(assert (let ((?v_0 (f8 f9 2))) (= (f11 (f23 (f30 f31 (f3 (f16 f17 f22) ?v_0)) (f3 (f16 f17 f35) ?v_0)) (+ (* 4 f10) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f10) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f11 (f23 (f30 f31 f35) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f11 (f23 (f30 f31 f35) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f10) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f11 (f23 (f30 f31 f35) ?v0) ?v_0) f1))) false))) false))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f4 (f27 (f25 f28 ?v0) ?v1))) (or (< 0 (f3 f4 ?v0)) (= ?v1 (f8 f9 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f8 f9 (+ 0 1)))) (= (f27 (f25 f28 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 f9 (+ 0 1)))) (= (= (f27 (f25 f28 ?v0) ?v1) ?v_0) (or (= ?v1 (f8 f9 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f11 (f23 (f30 f31 ?v0) 0) ?v1) f1)) (=> (= (f11 (f23 (f30 f31 (f3 (f16 f17 ?v2) (f8 f9 2))) ?v0) ?v1) f1) (not (= (f11 (f23 f29 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f28 ?v0))) (=> (< 0 (f3 f4 ?v0)) (=> (< (f3 f4 (f27 ?v_0 ?v1)) (f3 f4 (f27 ?v_0 ?v2))) (< (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f4 ?v0)) (<= ?v_0 (f3 f4 (f27 (f25 f28 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v0))) (=> (= (f11 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f11 ?v_0 ?v2) f1) (= (f11 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 (f23 f29 ?v0) ?v1) f1) (=> (= (f11 (f23 f29 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 (f23 f29 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f11 (f23 f29 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f11 (f23 f29 ?v0) ?v1) f1) (=> (= (f11 (f23 f29 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f11 (f23 f29 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f11 (f23 f29 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f11 (f23 f29 (f3 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f11 (f23 f29 (f3 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f25 f28 ?v0))) (=> (= (f36 (f37 f38 (f27 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f36 (f37 f38 (f27 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f11 (f23 f29 ?v0) ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f11 (f23 f29 (f3 (f16 f17 ?v0) ?v2)) (f3 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f36 (f37 f38 (f27 (f25 f28 ?v0) ?v2)) (f27 (f25 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f11 (f23 f29 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f28 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f36 (f37 f38 (f27 ?v_0 ?v0)) (f27 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f11 (f23 f29 ?v0) ?v1) f1) (= (f11 (f23 f29 (f3 (f16 f17 ?v0) ?v2)) (f3 (f16 f17 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f36 (f37 f38 (f27 (f25 f28 ?v0) ?v2)) (f27 (f25 f28 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f14 f15 ?v1))) (= (f13 (f14 f15 (f32 f33 (f34 ?v0 ?v1))) (f32 f33 (f34 ?v2 ?v3))) (f32 f33 (f34 (+ (f13 ?v_0 ?v2) (f13 ?v_1 ?v3)) (- (f13 ?v_0 ?v3) (f13 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v0))) (= (= (f11 ?v_0 (+ ?v1 (f13 (f14 f15 ?v0) ?v2))) f1) (= (f11 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f11 (f23 f29 (f13 (f14 f15 ?v0) ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f23 f29 ?v0))) (=> (= (f11 ?v_0 ?v1) f1) (= (= (f11 ?v_0 (+ ?v2 ?v3)) f1) (= (f11 ?v_0 (+ (+ ?v2 (f13 (f14 f15 ?v4) ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f15 ?v0))) (=> (= (f11 (f23 f29 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f11 (f23 f29 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f23 f29 ?v0))) (=> (= (f11 f20 ?v0) f1) (=> (= (f11 ?v_0 (f3 (f16 f17 ?v1) ?v2)) f1) (= (f11 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f23 f29 (f3 (f16 f17 ?v0) ?v2)))) (=> (= (f11 f20 ?v0) f1) (=> (not (= (f11 (f23 f29 ?v0) ?v1) f1)) (=> (= (f11 ?v_0 (f13 (f14 f15 ?v1) ?v3)) f1) (= (f11 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f23 f29 (f3 (f16 f17 ?v0) ?v2)))) (=> (= (f11 f20 ?v0) f1) (=> (not (= (f11 (f23 f29 ?v0) ?v1) f1)) (=> (= (f11 ?v_0 (f13 (f14 f15 ?v3) ?v1)) f1) (= (f11 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f13 f39 (f3 (f16 f17 ?v0) ?v1)) (f3 (f16 f17 (f13 f39 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f3 (f16 f17 ?v0) (f8 f9 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f27 (f25 f28 ?v0) (f8 f9 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f3 ?v_0 (f8 f9 (f13 (f14 f15 (f3 f4 ?v1)) (f3 f4 ?v2)))) (f3 (f16 f17 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f28 ?v0))) (= (f27 ?v_0 (f8 f9 (f13 (f14 f15 (f3 f4 ?v1)) (f3 f4 ?v2)))) (f27 (f25 f28 (f27 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (f3 f4 ?v1) 1))) (f13 (f14 f15 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f25 f28 ?v0))) (= (f27 ?v_0 (f8 f9 (+ (f3 f4 ?v1) 1))) (f27 (f25 f26 ?v0) (f27 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (f3 f4 ?v1) 1))) (f13 (f14 f15 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f25 f28 ?v0))) (= (f27 ?v_0 (f8 f9 (+ (f3 f4 ?v1) 1))) (f27 (f25 f26 (f27 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f13 (f14 f15 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f28 ?v0))) (= (f27 ?v_0 (f8 f9 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f27 (f25 f26 (f27 ?v_0 ?v1)) (f27 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (= (= (f11 f12 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f32 f33 (f34 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 f20 ?v0) f1) (=> (not (= (f11 (f23 f29 ?v0) ?v1) f1)) (= (f11 (f23 (f30 f31 (f3 (f16 f17 ?v1) (f8 f9 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f14 f21 ?v0) ?v1) (ite (= (f11 (f23 (f30 f31 ?v0) 0) ?v1) f1) 0 (ite (= (f11 (f23 f24 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 (f23 f24 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f11 (f23 (f30 f31 (f3 (f16 f17 ?v2) (f8 f9 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f23 f29 ?v0))) (=> (= (f11 f20 ?v0) f1) (=> (= (f11 ?v_0 (f3 (f16 f17 ?v1) ?v2)) f1) (=> (< 0 (f3 f4 ?v2)) (= (f11 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f11 (f23 f29 (f3 f4 ?v0)) (f3 f4 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f11 (f23 f29 ?v0) (f3 f4 ?v1)) f1) (= (f36 (f37 f38 (f8 f9 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f11 (f23 f29 (f3 f4 ?v0)) ?v1) f1) (= (f36 (f37 f38 ?v0) (f8 f9 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f36 (f37 f38 (f8 f9 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f11 (f23 f29 ?v0) (f3 f4 ?v1)) f1) (= ?v1 (f8 f9 0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f28 ?v0))) (=> (= (f36 (f37 f38 (f27 ?v_0 ?v1)) (f27 ?v_0 ?v2)) f1) (=> (< 1 (f3 f4 ?v0)) (<= (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f11 (f23 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f11 (f23 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f11 (f23 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f11 (f23 (f30 f31 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f30 f31 ?v1))) (=> (< 2 ?v0) (=> (= (f11 (f23 ?v_0 (- 1)) ?v0) f1) (not (= (f11 (f23 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f11 (f23 (f30 f31 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f11 (f23 (f30 f31 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f11 (f23 (f30 f31 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 (f23 f29 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f30 f31 ?v3))) (=> (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (= (= (f11 (f23 ?v_0 (f13 (f14 f15 ?v0) ?v4)) ?v2) f1) (= (f11 (f23 ?v_0 (f13 (f14 f15 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f30 f31 ?v3)) (?v_1 (f14 f15 ?v4))) (=> (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (= (= (f11 (f23 ?v_0 (f13 ?v_1 ?v0)) ?v2) f1) (= (f11 (f23 ?v_0 (f13 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 (f23 (f30 f31 ?v0) 0) ?v1) f1) (= (f11 (f23 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 (f23 (f30 f31 ?v0) 0) ?v1) f1) (= (f11 (f23 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f11 (f23 (f30 f31 (f3 (f16 f17 ?v0) ?v3)) (f3 (f16 f17 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v1))) (=> (< 0 (f3 f4 ?v0)) (=> (= (f11 ?v_0 ?v2) f1) (= (f11 ?v_0 (f3 (f16 f17 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 f20 ?v0) f1) (=> (not (= (f11 (f23 (f30 f31 ?v1) 0) ?v0) f1)) (=> (not (= (f11 (f23 (f30 f31 ?v2) 0) ?v0) f1)) (not (= (f11 (f23 (f30 f31 (f13 (f14 f15 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 f20 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f11 (f23 (f30 f31 ?v1) 0) ?v0) f1)) (not (= (f11 (f23 (f30 f31 ?v2) 0) ?v0) f1))) (not (= (f11 (f23 (f30 f31 (f13 (f14 f15 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 f20 ?v0) f1) (=> (< 0 ?v1) (=> (= (f11 (f23 (f30 f31 (f13 (f14 f15 ?v1) ?v2)) 0) ?v0) f1) (or (= (f11 (f23 (f30 f31 ?v1) 0) ?v0) f1) (= (f11 (f23 (f30 f31 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v0))) (=> (= (f11 f20 ?v0) f1) (=> (= (f11 ?v_0 (f13 (f14 f15 ?v1) ?v2)) f1) (or (= (f11 ?v_0 ?v1) f1) (= (f11 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v1))) (=> (<= 0 ?v0) (=> (= (f11 f20 ?v1) f1) (=> (= (f11 ?v_0 (f13 (f14 f15 ?v0) ?v2)) f1) (or (= (f11 ?v_0 ?v0) f1) (= (f11 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 f20 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f11 (f23 (f30 f31 (f13 (f14 f15 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f30 f31 ?v1))) (=> (= (f11 f20 ?v0) f1) (=> (< 0 ?v1) (=> (= (f11 (f23 (f30 f31 (f13 (f14 f15 ?v1) ?v1)) 1) ?v0) f1) (or (= (f11 (f23 ?v_0 1) ?v0) f1) (= (f11 (f23 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f11 (f23 (f30 f31 (f3 ?v_0 ?v1)) 1) ?v2) f1) (= (f11 (f23 (f30 f31 (f3 ?v_0 (f8 f9 (f13 (f14 f15 (f3 f4 ?v1)) (f3 f4 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f14 f15 ?v1))) (= (+ (f13 (f14 f15 (- ?v0 (f13 ?v_0 ?v2))) ?v3) (f13 (f14 f15 (- ?v4 (f13 ?v_0 ?v5))) ?v6)) (- (+ (f13 (f14 f15 ?v0) ?v3) (f13 (f14 f15 ?v4) ?v6)) (f13 ?v_0 (+ (f13 (f14 f15 ?v2) ?v3) (f13 (f14 f15 ?v5) ?v6))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f4 (f8 f9 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f8 f9 (f13 (f14 f15 ?v_0) ?v_0)) (f8 f9 (+ (f13 (f14 f15 (f3 f4 (f8 f9 (- ?v0 1)))) (f3 f4 (f8 f9 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 (f23 (f30 f31 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f11 (f23 (f30 f31 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 (f30 f31 ?v0) ?v1))) (= (= (f11 ?v_0 (- ?v2)) f1) (= (f11 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f23 (f30 f31 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f23 (f30 f31 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f11 (f23 (f30 f31 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f11 (f23 (f30 f31 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f11 (f23 (f30 f31 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f11 (f23 ?v_0 ?v1) ?v2) f1) (=> (= (f11 (f23 (f30 f31 ?v1) ?v3) ?v2) f1) (= (f11 (f23 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (= (f11 (f23 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f11 (f23 (f30 f31 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (= (f11 (f23 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f11 (f23 (f30 f31 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f11 f20 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (= (f11 (f23 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f11 (f23 (f30 f31 (f13 (f14 f15 ?v0) ?v3)) (f13 (f14 f15 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f14 f15 ?v3))) (=> (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f11 (f23 (f30 f31 (f13 ?v_0 ?v0)) (f13 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f11 (f23 (f30 f31 (f13 (f14 f15 ?v0) ?v3)) (f13 (f14 f15 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f23 (f30 f31 (f13 (f14 f15 ?v0) ?v1)) (f13 (f14 f15 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f11 (f23 (f30 f31 (f13 (f14 f15 ?v0) ?v_0)) 1) ?v1) f1) (= (f11 (f23 (f30 f31 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f13 (f14 f15 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f11 (f23 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f11 (f23 f29 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int)) (= (= (f11 f20 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f11 (f23 f29 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (* 2 (f3 f4 ?v1)) 1))) (f13 (f14 f15 ?v0) (f3 (f16 f17 (f3 ?v_0 ?v1)) (f8 f9 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f25 f28 ?v0))) (= (f27 ?v_0 (f8 f9 (+ (* 2 (f3 f4 ?v1)) 1))) (f27 (f25 f26 ?v0) (f27 (f25 f28 (f27 ?v_0 ?v1)) (f8 f9 2)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f11 f20 ?v1) f1) (= (f11 (f23 f29 ?v1) ?v0) f1))))))
(assert (forall ((?v0 S3)) (= (f36 (f37 f38 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f36 (f37 f38 (f8 f9 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 2))) (= (f3 (f16 f17 (f13 f39 ?v0)) ?v_0) (f3 (f16 f17 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f16 f17 ?v0) (f8 f9 2)))) (= (f13 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f36 (f37 f38 ?v0) ?v1) f1)) (?v_0 (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f37 f38 ?v0)) (?v_0 (f37 f38 ?v1)) (?v_2 (f37 f38 ?v2))) (=> (and (= (f36 ?v_1 ?v1) f1) (not (= (f36 ?v_0 ?v0) f1))) (=> (and (= (f36 ?v_0 ?v2) f1) (not (= (f36 ?v_2 ?v1) f1))) (and (= (f36 ?v_1 ?v2) f1) (not (= (f36 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f36 (f37 f38 ?v0) ?v1) f1)) (?v_0 (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f37 f38 ?v0)) (?v_0 (f37 f38 ?v1))) (=> (and (= (f36 ?v_1 ?v1) f1) (not (= (f36 ?v_0 ?v0) f1))) (=> (= (f36 ?v_0 ?v2) f1) (and (= (f36 ?v_1 ?v2) f1) (not (= (f36 (f37 f38 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (and (= (f36 ?v_0 ?v1) f1) (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f36 ?v_0 ?v2) f1) (not (= (f36 (f37 f38 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (let ((?v_1 (= (f36 (f37 f38 ?v0) ?v1) f1)) (?v_0 (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f36 (f37 f38 ?v0) ?v1) f1) (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f36 (f37 f38 ?v0) ?v1) f1) (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f36 (f37 f38 ?v0) ?v1) f1)) (?v_0 (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f36 (f37 f38 ?v0) ?v1) f1)) (?v_0 (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f36 (f37 f38 ?v0) ?v1) f1) (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (=> (= (f36 ?v_0 (f8 f9 (- ?v_2 ?v_1))) f1) (=> (= (f36 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f36 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (=> (= (f36 ?v_0 (f8 f9 (- ?v_2 ?v_1))) f1) (=> (= (f36 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f36 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f37 f38 ?v2))) (=> (= (f36 ?v_0 ?v1) f1) (=> (and (= (f36 (f37 f38 ?v1) ?v2) f1) (not (= (f36 ?v_1 ?v1) f1))) (and (= (f36 ?v_0 ?v2) f1) (not (= (f36 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f36 (f37 f38 ?v1) ?v2) f1) (not (= (f36 ?v_0 ?v1) f1))) (and (= (f36 (f37 f38 ?v0) ?v2) f1) (not (= (f36 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= (f36 ?v_0 ?v2) f1) (= (f36 ?v_0 (f8 f9 (- (f3 f4 ?v1) (f3 f4 ?v2)))) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= (f36 (f37 f38 ?v1) ?v2) f1) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (= (f36 (f37 f38 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (= (f36 (f37 f38 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f36 (f37 f38 ?v1) ?v2) f1) (= (f36 (f37 f38 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f4 ?v1))) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f3 f4 ?v0) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (= (= (f36 (f37 f38 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f36 (f37 f38 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f4 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f3 f4 ?v1)) (not (= (f36 (f37 f38 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (and (= (f36 (f37 f38 ?v0) ?v1) f1) (not (= (f36 (f37 f38 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f38 ?v0))) (= (= (f36 ?v_0 (f8 f9 (+ (f3 f4 ?v1) (f3 f4 ?v0)))) f1) (= (f36 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f8 f9 (+ 0 1)))) (= (= (f36 (f37 f38 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f36 (f37 f38 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f8 f9 1))) (= (= (f36 (f37 f38 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_2 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f13 (f14 f15 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f13 (f14 f15 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f13 (f14 f15 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 (f8 f9 (f13 (f14 f15 (f3 f4 ?v0)) (f3 f4 ?v1)))) (or (= ?v1 (f8 f9 1)) (= ?v0 (f8 f9 0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_3 (f3 f4 ?v3)) (?v_1 (f3 f4 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f13 (f14 f15 ?v_0) ?v_1) (f13 (f14 f15 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_3 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0)) (?v_0 (f3 f4 ?v2))) (let ((?v_2 (f14 f15 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f13 ?v_2 ?v_1) (f13 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f13 (f14 f15 ?v_0) ?v_1) (f13 (f14 f15 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_1 (f14 f15 (f3 f4 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f13 ?v_1 ?v_0) (f13 ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f13 (f14 f15 ?v_0) ?v_2) (f13 (f14 f15 ?v_1) ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 (+ (f3 f4 ?v0) 1))) (?v_2 (f3 f4 ?v2)) (?v_1 (f3 f4 ?v1))) (= (<= (f13 ?v_0 ?v_1) (f13 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 (+ (f3 f4 ?v0) 1))) (?v_2 (f3 f4 ?v2)) (?v_1 (f3 f4 ?v1))) (= (< (f13 ?v_0 ?v_1) (f13 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 (+ (f3 f4 ?v0) 1)))) (= (= (f8 f9 (f13 ?v_0 (f3 f4 ?v1))) (f8 f9 (f13 ?v_0 (f3 f4 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v1))) (= (= (f8 f9 (f13 (f14 f15 (f3 f4 ?v0)) ?v_0)) (f8 f9 (f13 (f14 f15 (f3 f4 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f8 f9 0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 (f3 f4 ?v0)))) (= (= (f8 f9 (f13 ?v_0 (f3 f4 ?v1))) (f8 f9 (f13 ?v_0 (f3 f4 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f8 f9 0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v2)) (?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0))) (= (<= (f13 (f14 f15 ?v_1) ?v_0) (f13 (f14 f15 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f3 f4 ?v0))) (let ((?v_0 (f14 f15 ?v_1)) (?v_3 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (= (<= (f13 ?v_0 ?v_2) (f13 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v2)) (?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0))) (= (< (f13 (f14 f15 ?v_1) ?v_0) (f13 (f14 f15 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f3 f4 ?v0))) (let ((?v_0 (f14 f15 ?v_1)) (?v_3 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (= (< (f13 ?v_0 ?v_2) (f13 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 f9 (+ 0 1)))) (= (= (f8 f9 (f13 (f14 f15 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v2))) (= (f8 f9 (f13 (f14 f15 (f3 f4 (f8 f9 (- ?v_0 ?v_2)))) ?v_1)) (f8 f9 (- (f13 (f14 f15 ?v_0) ?v_1) (f13 (f14 f15 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v2))) (= (f8 f9 (f13 (f14 f15 (+ ?v_0 ?v_2)) ?v_1)) (f8 f9 (+ (f13 (f14 f15 ?v_0) ?v_1) (f13 (f14 f15 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 (f3 f4 ?v0))) (?v_1 (f3 f4 ?v1)) (?v_2 (f3 f4 ?v2))) (= (f8 f9 (f13 (f14 f15 (f13 ?v_0 ?v_1)) ?v_2)) (f8 f9 (f13 ?v_0 (f13 (f14 f15 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 f9 0))) (= (= (f8 f9 (f13 (f14 f15 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 f9 1))) (= (= (f8 f9 (f13 (f14 f15 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f4 ?v0))) (= (f8 f9 (* 2 ?v_0)) (f8 f9 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3)) (= (f8 f9 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f8 f9 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f8 f9 ?v0)) 0))))
(check-sat)
(exit)
