(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 Int) Int)
(declare-fun f6 (S3 Int) S2)
(declare-fun f7 () S3)
(declare-fun f8 (S4 S5) Int)
(declare-fun f9 () S4)
(declare-fun f10 () S5)
(declare-fun f11 () Int)
(declare-fun f12 () S5)
(declare-fun f13 (S6 Int) S5)
(declare-fun f14 () S6)
(declare-fun f15 () Int)
(declare-fun f16 (Int) S1)
(declare-fun f17 (S7 Int) S4)
(declare-fun f18 () S7)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(declare-fun f21 () S3)
(declare-fun f22 () Int)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 (S8 S5) S5)
(declare-fun f25 (S9 S5) S8)
(declare-fun f26 () S9)
(declare-fun f27 () S9)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 (S10 S11) Int)
(declare-fun f31 () S10)
(declare-fun f32 (Int Int) S11)
(declare-fun f33 () Int)
(declare-fun f34 (S5 S5) S1)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f8 f9 f10)))) (=> (and (= ?v0 (- f4 (f5 (f6 f7 ?v1) ?v_0))) (<= (ite (< ?v0 0) (* (- 2) ?v0) (* 2 ?v0)) ?v_0)) (= f3 f1)))))
(assert (< 0 (+ 1 (f8 f9 f10))))
(assert (< 1 f11))
(assert (< 0 (+ 1 (f8 f9 f10))))
(assert (< 0 (f8 f9 f10)))
(assert (= f12 (f13 f14 (- (f8 f9 (f13 f14 f11)) 1))))
(assert (let ((?v_1 (+ 1 (f8 f9 f10))) (?v_0 (+ (* 4 f15) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f16 (f5 (f6 f7 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f8 (f17 f18 f4) ?v_0) (f8 (f17 f18 f19) ?v_0)) (f5 (f6 f7 (+ (* 4 f15) 1)) (+ 1 (f8 f9 f10))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (+ ?v1 ?v2)) (+ (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (- ?v1 ?v2)) (- (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 (- ?v0)) ?v1) (- (f5 (f6 f7 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f5 (f6 f7 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f5 (f6 f7 (+ ?v0 ?v1)) ?v2) (+ (f5 (f6 f7 ?v0) ?v2) (f5 (f6 f7 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f5 (f6 f7 (- ?v0 ?v1)) ?v2) (- (f5 (f6 f7 ?v0) ?v2) (f5 (f6 f7 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f6 f7 ?v1))) (= (+ (f5 (f6 f7 (- ?v0 (f5 ?v_0 ?v2))) ?v3) (f5 (f6 f7 (- ?v4 (f5 ?v_0 ?v5))) ?v6)) (- (+ (f5 (f6 f7 ?v0) ?v3) (f5 (f6 f7 ?v4) ?v6)) (f5 ?v_0 (+ (f5 (f6 f7 ?v2) ?v3) (f5 (f6 f7 ?v5) ?v6))))))))
(assert (< 0 (f8 f9 f12)))
(assert (< 0 (+ (* 4 f15) 1)))
(assert (not (= (f16 (f5 (f6 f7 (+ (* 4 f15) 1)) (+ 1 0))) f1)))
(assert (<= 1 f11))
(assert (< f11 (+ (* 4 f15) 1)))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f13 f14 (- (f8 f9 (f13 f14 f11)) 1))) (=> (< 0 (f8 f9 ?v0)) false))) false))
(assert (= (f16 (f5 (f6 f7 (+ (* 4 f15) 1)) f11)) f1))
(assert (let ((?v_1 (+ 1 (f8 f9 f10))) (?v_0 (+ (* 4 f15) 1))) (and (< ?v_1 ?v_0) (= (f16 (f5 (f6 f7 ?v_0) ?v_1)) f1))))
(assert (= (f20 (+ (* 4 f15) 1)) f1))
(assert (= (f5 (f6 f21 (- 1)) (+ (* 4 f15) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f8 (f17 f18 ?v0) ?v_0) (f8 (f17 f18 ?v1) ?v_0)) (f5 (f6 f7 (+ (* 4 f15) 1)) (+ 1 (f8 f9 f10)))) false))) false))
(assert (= (+ (f8 (f17 f18 f22) (f13 f14 2)) 1) (f5 (f6 f7 (+ (* 4 f15) 1)) f11)))
(assert (=> (= f11 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (+ (f8 (f17 f18 ?v0) ?v_0) (f8 (f17 f18 ?v1) ?v_0)) (+ (* 4 f15) 1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f8 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f8 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f8 ?v_0 (f13 f14 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f5 (f6 f7 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (= (f16 ?v1) f1) (= (f16 (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 (f6 f7 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 (f6 f7 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f8 f9 ?v2))) (let ((?v_1 (f6 f7 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f5 ?v_1 ?v0) (f5 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f5 ?v_0 ?v0) (f5 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f5 (f6 f7 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (= (f23 (+ (* 4 f15) 1) (- 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f8 (f17 f18 f22) (f13 f14 2)) 1) (f5 (f6 f7 (+ (* 4 f15) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f13 f14 ?v0))) (=> (< 0 ?v0) (= (f8 ?v_0 ?v_1) (f5 (f6 f7 ?v1) (f8 ?v_0 (f13 f14 (- (f8 f9 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f5 (f6 f7 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f8 (f17 f18 ?v0) ?v_0) (f8 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_3 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0))) (= (f8 (f17 f18 (- ?v0 ?v1)) ?v_0) (- (+ (- (f8 ?v_1 ?v_0) (f5 (f6 f7 (* 3 (f8 ?v_1 ?v_2))) ?v1)) (f5 (f6 f7 (* 3 ?v0)) (f8 ?v_3 ?v_2))) (f8 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_1 (f17 f18 ?v0)) (?v_3 (f17 f18 ?v1))) (= (f8 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f8 ?v_1 ?v_0) (f5 (f6 f7 (* 3 (f8 ?v_1 ?v_2))) ?v1)) (f5 (f6 f7 (* 3 ?v0)) (f8 ?v_3 ?v_2))) (f8 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f8 (f17 f18 (- ?v0 ?v1)) ?v_0) (+ (- (f8 (f17 f18 ?v0) ?v_0) (f5 (f6 f7 (* 2 ?v0)) ?v1)) (f8 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f8 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (f8 (f17 f18 ?v0) ?v_0) (f5 (f6 f7 (* 2 ?v0)) ?v1)) (f8 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f5 (f6 f7 ?v0) (f8 ?v_0 (f13 f14 2))) (f8 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f17 f18 ?v2))) (=> (<= ?v_1 ?v_0) (= (f8 ?v_2 (f13 f14 (- (+ ?v_0 1) ?v_1))) (f5 (f6 f7 (f8 ?v_2 (f13 f14 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f25 f26 ?v2))) (=> (<= ?v_1 ?v_0) (= (f24 ?v_2 (f13 f14 (- (+ ?v_0 1) ?v_1))) (f24 (f25 f27 (f24 ?v_2 (f13 f14 (- ?v_0 ?v_1)))) ?v2))))))
(assert (let ((?v_0 (f8 (f17 f18 f22) (f13 f14 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (=> (not (= (f23 ?v_0 (- 1)) f1)) (not (= (f5 (f6 f21 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f20 ?v_0) f1) (= (f5 (f6 f21 (- 1)) ?v_0) 1)))))
(assert (= (f20 2) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 (f6 f7 ?v0) ?v1))) (= (f13 f14 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f13 f14 (f5 (f6 f7 (f8 f9 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)))) (f8 f9 (f13 f14 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f5 (f6 f7 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f5 (f6 f7 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f13 f14 (f5 (f6 f7 ?v0) ?v1)) (f13 f14 (f5 (f6 f7 (f8 f9 (f13 f14 ?v0))) (f8 f9 (f13 f14 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f13 f14 (f5 (f6 f7 ?v0) ?v1)) (f13 f14 (f5 (f6 f7 (f8 f9 (f13 f14 (- ?v0)))) (f8 f9 (f13 f14 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f13 f14 (f8 (f17 f18 ?v0) ?v1)) (f24 (f25 f26 (f13 f14 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f17 f18 (f8 f9 ?v0)) ?v1) (f8 f9 (f24 (f25 f26 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 f9 (f24 (f25 f26 ?v0) ?v1)) (f8 (f17 f18 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f8 (f17 f18 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f13 f14 (f5 (f6 f7 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f5 (f6 f7 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f8 (f17 f18 ?v0) (f13 f14 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (= (f8 (f17 f18 ?v0) ?v_0) (f8 (f17 f18 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2)) (?v_1 (f17 f18 ?v0))) (= (f8 (f17 f18 (f8 ?v_1 ?v_0)) ?v_0) (f8 ?v_1 (f13 f14 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 3))) (= (f8 (f17 f18 (- ?v0)) ?v_0) (- (f8 (f17 f18 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 3))) (let ((?v_0 (f8 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 2))) (let ((?v_0 (f8 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f8 (f17 f18 ?v0) (f13 f14 2)))))
(assert (= (f28 (+ (* 4 f15) 1) (- (f8 (f17 f18 f22) (f13 f14 2)) (- 1))) f1))
(assert (= (f28 (+ (* 4 f15) 1) (+ (f8 (f17 f18 f22) (f13 f14 2)) 1)) f1))
(assert (= (f29 (f8 (f17 f18 f22) (f13 f14 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (= (f30 f31 (f32 f22 1)) (f5 (f6 f7 (+ (* 4 f15) 1)) f11)))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (and (<= 0 f22) (and (< f22 ?v_0) (= (f29 f33 f22 ?v_0) f1)))))
(assert (forall ((?v0 Int)) (= (f5 (f6 f7 ?v0) ?v0) (f8 (f17 f18 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 S5)) (= (f24 (f25 f27 ?v0) ?v0) (f24 (f25 f26 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f8 ?v_0 (f13 f14 (+ (f8 f9 ?v1) 1))) (f5 (f6 f7 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f13 f14 (+ (f8 f9 ?v1) 1))) (f24 (f25 f27 ?v0) (f24 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f8 ?v_0 (f13 f14 (+ (f8 f9 ?v1) 1))) (f5 (f6 f7 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f13 f14 (+ (f8 f9 ?v1) 1))) (f24 (f25 f27 ?v0) (f24 ?v_0 ?v1))))))
(assert (= (f29 (f8 (f17 f18 f33) (f13 f14 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f8 (f17 f18 ?v0) (f13 f14 2)) (- 1) (+ (* 4 f15) 1)) f1) false)) false))
(assert (let ((?v_0 (f13 f14 2))) (= (f29 (f8 (f17 f18 f22) ?v_0) (f8 (f17 f18 f33) ?v_0) (+ (* 4 f15) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f15) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f33 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f15) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 S5) (?v1 S5)) (= (< 0 (f8 f9 (f24 (f25 f26 ?v0) ?v1))) (or (< 0 (f8 f9 ?v0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f13 f14 (+ 0 1)))) (= (f24 (f25 f26 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f13 f14 (+ 0 1)))) (= (= (f24 (f25 f26 ?v0) ?v1) ?v_0) (or (= ?v1 (f13 f14 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f29 ?v0 0 ?v1) f1)) (=> (= (f29 (f8 (f17 f18 ?v2) (f13 f14 2)) ?v0 ?v1) f1) (not (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v0))) (=> (< 0 (f8 f9 ?v0)) (=> (< (f8 f9 (f24 ?v_0 ?v1)) (f8 f9 (f24 ?v_0 ?v2))) (< (f8 f9 ?v1) (f8 f9 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f8 f9 ?v0)) (<= ?v_0 (f8 f9 (f24 (f25 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f34 (f24 ?v_0 ?v1) ?v2) f1) (=> (<= (f8 f9 ?v3) (f8 f9 ?v1)) (= (f34 (f24 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f28 (f8 ?v_0 ?v1) ?v2) f1) (=> (<= (f8 f9 ?v3) (f8 f9 ?v1)) (= (f28 (f8 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f34 ?v0 ?v1) f1) (=> (<= (f8 f9 ?v2) (f8 f9 ?v3)) (= (f34 (f24 (f25 f26 ?v0) ?v2) (f24 (f25 f26 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S5)) (=> (= (f28 ?v0 ?v1) f1) (=> (<= (f8 f9 ?v2) (f8 f9 ?v3)) (= (f28 (f8 (f17 f18 ?v0) ?v2) (f8 (f17 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v2))) (=> (<= (f8 f9 ?v0) (f8 f9 ?v1)) (= (f34 (f24 ?v_0 ?v0) (f24 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f17 f18 ?v2))) (=> (<= (f8 f9 ?v0) (f8 f9 ?v1)) (= (f28 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 (f24 (f25 f26 ?v0) ?v2) (f24 (f25 f26 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f28 ?v0 ?v1) f1) (= (f28 (f8 (f17 f18 ?v0) ?v2) (f8 (f17 f18 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v1 ?v3 ?v2) f1) (= (f29 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 (- ?v1 ?v2)) f1) (=> (= (f28 ?v0 ?v2) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f29 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f29 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f28 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f28 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 (- ?v2)) f1) (= (f29 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f28 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (= (f28 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f7 ?v0)) (?v_1 (f6 f7 ?v1))) (= (f5 (f6 f7 (f30 f31 (f32 ?v0 ?v1))) (f30 f31 (f32 ?v2 ?v3))) (f30 f31 (f32 (+ (f5 ?v_0 ?v2) (f5 ?v_1 ?v3)) (- (f5 ?v_0 ?v3) (f5 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (f5 (f6 f7 ?v0) ?v3) (f5 (f6 f7 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f7 ?v3))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f5 ?v_0 ?v0) (f5 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f5 (f6 f7 ?v0) ?v3) (f5 (f6 f7 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f29 (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f5 (f6 f7 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f28 (f5 ?v_0 ?v1) (f5 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (= (f28 ?v0 (+ ?v2 ?v3)) f1) (= (f28 ?v0 (+ (+ ?v2 (f5 (f6 f7 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f28 (f5 (f6 f7 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 (+ ?v1 (f5 (f6 f7 ?v0) ?v2))) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int)) (= (= (f20 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f28 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f29 (f5 (f6 f7 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (< 0 ?v1) (=> (= (f29 (f5 (f6 f7 ?v1) ?v1) 1 ?v0) f1) (or (= (f29 ?v1 1 ?v0) f1) (= (f29 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f20 ?v1) f1) (=> (= (f28 ?v1 (f5 (f6 f7 ?v0) ?v2)) f1) (or (= (f28 ?v1 ?v0) f1) (= (f28 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f20 ?v0) f1) (=> (= (f28 ?v0 (f8 (f17 f18 ?v1) ?v2)) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 S5)) (= (f13 f14 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
