(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S9 Int) S8)
(declare-fun f14 () S9)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () S2)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 () S2)
(declare-fun f25 () S4)
(declare-fun f26 () S4)
(declare-fun f27 (S10 Int) S1)
(declare-fun f28 () S10)
(declare-fun f29 () S10)
(declare-fun f30 () S7)
(declare-fun f31 () Int)
(declare-fun f32 (S11 Int) S10)
(declare-fun f33 () S11)
(declare-fun f34 () S6)
(declare-fun f35 () S11)
(declare-fun f36 (S12 Int) S11)
(declare-fun f37 () S12)
(declare-fun f38 (S13 S14) Int)
(declare-fun f39 () S13)
(declare-fun f40 (Int Int) S14)
(declare-fun f41 () Int)
(declare-fun f42 (S15 S2) S1)
(declare-fun f43 (S16 S2) S15)
(declare-fun f44 () S16)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (let ((?v_0 (+ 1 (f11 f12 f17)))) (let ((?v_2 (f8 (f9 f10 f16) ?v_0)) (?v_1 (f6 f7 2)) (?v_3 (f8 (f9 f10 f19) ?v_0))) (not (= (+ (f11 (f13 f14 (- f15 ?v_2)) ?v_1) (f11 (f13 f14 (- f18 ?v_3)) ?v_1)) (+ (+ (- (- (+ (f11 (f13 f14 f15) ?v_1) (f11 (f13 f14 f18) ?v_1)) (f8 (f9 f10 (* 2 f15)) ?v_2)) (f8 (f9 f10 (* 2 f18)) ?v_3)) (f11 (f13 f14 ?v_2) ?v_1)) (f11 (f13 f14 ?v_3) ?v_1)))))))
(assert (< 1 f20))
(assert (< 0 (f11 f12 f17)))
(assert (< 0 (+ 1 (f11 f12 f17))))
(assert (let ((?v_0 (+ 1 (f11 f12 f17)))) (and (= f21 (- f15 (f8 (f9 f10 f16) ?v_0))) (<= (ite (< f21 0) (* (- 2) f21) (* 2 f21)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f11 f12 f17)))) (and (= f22 (- f18 (f8 (f9 f10 f19) ?v_0))) (<= (ite (< f22 0) (* (- 2) f22) (* 2 f22)) ?v_0))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f11 f12 f17)))) (=> (and (= ?v1 (- f15 (f8 (f9 f10 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f11 f12 f17)))) (=> (and (= ?v1 (- f18 (f8 (f9 f10 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f13 f14 f15) ?v_0) (f11 (f13 f14 f18) ?v_0)) (f8 (f9 f10 (+ (* 4 f23) 1)) (+ 1 (f11 f12 f17))))))
(assert (= f24 (f6 f7 (- (f11 f12 (f6 f7 f20)) 1))))
(assert (let ((?v_1 (+ 1 (f11 f12 f17))) (?v_0 (f6 f7 2))) (= (+ (f11 (f13 f14 f21) ?v_0) (f11 (f13 f14 f22) ?v_0)) (+ (f11 (f13 f14 (- f15 (f8 (f9 f10 f16) ?v_1))) ?v_0) (f11 (f13 f14 (- f18 (f8 (f9 f10 f19) ?v_1))) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f8 (f9 f10 ?v0) (f11 ?v_0 (f6 f7 2))) (f11 ?v_0 (f6 f7 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f13 f14 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f13 f14 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f11 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f13 f14 (- ?v0 ?v1)) ?v_0) (+ (- (f11 (f13 f14 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f11 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_1 (f13 f14 ?v0)) (?v_3 (f13 f14 ?v1))) (= (f11 (f13 f14 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f11 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f11 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_3 (f13 f14 ?v1)) (?v_1 (f13 f14 ?v0))) (= (f11 (f13 f14 (- ?v0 ?v1)) ?v_0) (- (+ (- (f11 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f11 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f9 f10 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f11 (f13 f14 ?v0) ?v_0) (f11 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 ?v1)) (?v_1 (f6 f7 ?v0))) (=> (< 0 ?v0) (= (f11 ?v_0 ?v_1) (f8 (f9 f10 ?v1) (f11 ?v_0 (f6 f7 (- (f11 f12 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) ?v0) (f11 (f13 f14 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) ?v0) (f3 (f4 f26 ?v0) (f6 f7 2)))))
(assert (< 0 (f11 f12 f24)))
(assert (< 0 (+ (* 4 f23) 1)))
(assert (<= 1 f20))
(assert (not (= (f27 f28 (f8 (f9 f10 (+ (* 4 f23) 1)) (+ 1 0))) f1)))
(assert (< f20 (+ (* 4 f23) 1)))
(assert (=> (forall ((?v0 S2)) (=> (= ?v0 (f6 f7 (- (f11 f12 (f6 f7 f20)) 1))) (=> (< 0 (f11 f12 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f11 f12 f17))) (?v_0 (+ (* 4 f23) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f27 f28 (f8 (f9 f10 ?v_0) ?v_1)) f1))))))
(assert (= (f27 f29 (+ (* 4 f23) 1)) f1))
(assert (= (f8 (f9 f30 (- 1)) (+ (* 4 f23) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (=> (= (+ (f11 (f13 f14 ?v0) ?v_0) (f11 (f13 f14 ?v1) ?v_0)) (f8 (f9 f10 (+ (* 4 f23) 1)) (+ 1 (f11 f12 f17)))) false))) false))
(assert (= (+ (f11 (f13 f14 f31) (f6 f7 2)) 1) (f8 (f9 f10 (+ (* 4 f23) 1)) f20)))
(assert (let ((?v_1 (+ 1 (f11 f12 f17))) (?v_0 (+ (* 4 f23) 1))) (and (< ?v_1 ?v_0) (= (f27 f28 (f8 (f9 f10 ?v_0) ?v_1)) f1))))
(assert (= (f27 f28 (f8 (f9 f10 (+ (* 4 f23) 1)) f20)) f1))
(assert (=> (= f20 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f13 f14 ?v0) ?v_0) (f11 (f13 f14 ?v1) ?v_0)) (+ (* 4 f23) 1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f11 (f13 f14 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f11 f12 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f13 f14 ?v0) ?v1)) (f3 (f4 f26 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f13 f14 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f26 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f26 ?v0) ?v1)) (f11 (f13 f14 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f11 (f13 f14 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) (f3 (f4 f25 ?v2) ?v3)) (f3 (f4 f25 (f3 ?v_0 ?v2)) (f3 (f4 f25 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 (f9 f10 ?v2) ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v2)) (f8 (f9 f10 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f25 (f3 (f4 f25 ?v0) ?v1))) (?v_0 (f4 f25 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f9 f10 (f8 (f9 f10 ?v0) ?v1))) (?v_0 (f9 f10 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f25 ?v0)) (?v_1 (f3 (f4 f25 ?v2) ?v3))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f25 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f8 (f9 f10 ?v2) ?v3))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f25 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f3 (f4 f25 ?v1) ?v2)) (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f25 ?v0)) (?v_0 (f4 f25 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f9 f10 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f25 ?v0) ?v1) (f3 (f4 f25 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f13 f14 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f8 (f9 f10 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f11 (f13 f14 ?v0) (f6 f7 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (f11 (f13 f14 ?v0) ?v_0) (f11 (f13 f14 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2)) (?v_1 (f13 f14 ?v0))) (= (f11 (f13 f14 (f11 ?v_1 ?v_0)) ?v_0) (f11 ?v_1 (f6 f7 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 3))) (= (f11 (f13 f14 (- ?v0)) ?v_0) (- (f11 (f13 f14 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f11 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 3))) (let ((?v_0 (f11 (f13 f14 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f11 (f13 f14 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 (f13 f14 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f11 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f13 f14 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f13 f14 ?v0) ?v2)) (f11 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f26 (f3 (f4 f25 ?v0) ?v1)) ?v2) (f3 (f4 f25 (f3 (f4 f26 ?v0) ?v2)) (f3 (f4 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f8 (f9 f10 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f25 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f25 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f8 (f9 f10 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f25 ?v0) (f3 (f4 f25 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f25 ?v0) (f3 ?v_0 ?v1))))))
(assert (= (f27 (f32 f33 (+ (* 4 f23) 1)) (- 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f11 (f13 f14 f31) (f6 f7 2)) 1) (f8 (f9 f10 (+ (* 4 f23) 1)) ?v0)) false)) false))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f13 f14 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f8 (f9 f10 (f11 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f4 f26 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f25 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f13 f14 ?v1))) (=> (< 0 ?v_0) (= (f8 (f9 f10 (f11 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f11 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f4 f26 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f25 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f13 f14 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f13 f14 ?v0) ?v2)) (f11 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f26 (f3 (f4 f25 ?v0) ?v1)) ?v2) (f3 (f4 f25 (f3 (f4 f26 ?v0) ?v2)) (f3 (f4 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f13 f14 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f26 ?v0) ?v1))) (= (f3 (f4 f25 ?v_0) ?v0) (f3 (f4 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f3 (f4 f25 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f11 (f13 f14 (f11 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f25 ?v0) (f3 (f4 f26 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int)) (= (f11 (f13 f14 ?v0) (f6 f7 3)) (f8 (f9 f10 (f8 (f9 f10 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) (f6 f7 3)) (f3 (f4 f25 (f3 (f4 f25 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f13 f14 ?v0) (f6 f7 2)) (f8 (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) (f6 f7 2)) (f3 (f4 f25 ?v0) ?v0))))
(assert (let ((?v_0 (f11 (f13 f14 f31) (f6 f7 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f23) 1))) (=> (not (= (f27 (f32 f33 ?v_0) (- 1)) f1)) (not (= (f8 (f9 f30 (- 1)) ?v_0) 1)))))
(assert (= (f27 f29 2) f1))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f26 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 (f3 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f26 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f26 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f3 ?v_0 ?v1)) (f11 f12 (f3 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f3 (f4 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f27 f29 ?v_0) f1) (= (f8 (f9 f30 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 f28 ?v0) f1) (=> (= (f27 f28 ?v1) f1) (= (f27 f28 (f8 (f9 f10 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f34 (f11 (f13 f14 ?v0) ?v1)) (f11 (f13 f14 (f8 f34 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f13 f14 ?v0) (f6 f7 2)))) (= (f8 f34 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f11 (f13 f14 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f13 f14 (f8 f34 ?v0)) ?v_0) (f11 (f13 f14 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f11 (f13 f14 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f11 (f13 f14 (f11 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f26 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f25 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v0)))))
(assert (= (f27 (f32 f35 (+ (* 4 f23) 1)) (+ (f11 (f13 f14 f31) (f6 f7 2)) 1)) f1))
(assert (= (f27 (f32 f35 (+ (* 4 f23) 1)) (- (f11 (f13 f14 f31) (f6 f7 2)) (- 1))) f1))
(assert (= (f27 (f32 (f36 f37 (f11 (f13 f14 f31) (f6 f7 2))) (- 1)) (+ (* 4 f23) 1)) f1))
(assert (= (f38 f39 (f40 f31 1)) (f8 (f9 f10 (+ (* 4 f23) 1)) f20)))
(assert (let ((?v_0 (+ (* 4 f23) 1))) (and (<= 0 f31) (and (< f31 ?v_0) (= (f27 (f32 (f36 f37 f41) f31) ?v_0) f1)))))
(assert (= (f27 (f32 (f36 f37 (f11 (f13 f14 f41) (f6 f7 2))) (- 1)) (+ (* 4 f23) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f27 (f32 (f36 f37 (f11 (f13 f14 ?v0) (f6 f7 2))) (- 1)) (+ (* 4 f23) 1)) f1) false)) false))
(assert (let ((?v_0 (f6 f7 2))) (= (f27 (f32 (f36 f37 (f11 (f13 f14 f31) ?v_0)) (f11 (f13 f14 f41) ?v_0)) (+ (* 4 f23) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f23) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f27 (f32 (f36 f37 f41) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f27 (f32 (f36 f37 f41) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f23) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f27 (f32 (f36 f37 f41) ?v0) ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f27 (f32 (f36 f37 ?v0) 0) ?v1) f1)) (=> (= (f27 (f32 (f36 f37 (f11 (f13 f14 ?v2) (f6 f7 2))) ?v0) ?v1) f1) (not (= (f27 (f32 f35 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f27 (f32 f35 ?v0) ?v1) f1) (= (f27 (f32 f35 (f11 (f13 f14 ?v0) ?v2)) (f11 (f13 f14 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f42 (f43 f44 ?v0) ?v1) f1) (= (f42 (f43 f44 (f3 (f4 f26 ?v0) ?v2)) (f3 (f4 f26 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f13 f14 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f27 (f32 f35 (f11 ?v_0 ?v0)) (f11 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f42 (f43 f44 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 S2)) (=> (= (f27 (f32 f35 ?v0) ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f27 (f32 f35 (f11 (f13 f14 ?v0) ?v2)) (f11 (f13 f14 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f42 (f43 f44 ?v0) ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f42 (f43 f44 (f3 (f4 f26 ?v0) ?v2)) (f3 (f4 f26 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f13 f14 ?v0))) (=> (= (f27 (f32 f35 (f11 ?v_0 ?v1)) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f27 (f32 f35 (f11 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f26 ?v0))) (=> (= (f42 (f43 f44 (f3 ?v_0 ?v1)) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f42 (f43 f44 (f3 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f9 f10 ?v1))) (= (f8 (f9 f10 (f38 f39 (f40 ?v0 ?v1))) (f38 f39 (f40 ?v2 ?v3))) (f38 f39 (f40 (+ (f8 ?v_0 ?v2) (f8 ?v_1 ?v3)) (- (f8 ?v_0 ?v3) (f8 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 f35 ?v0))) (=> (= (f27 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f27 ?v_0 ?v2) f1) (= (f27 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 (f32 f35 ?v0) ?v1) f1) (=> (= (f27 (f32 f35 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 (f32 f35 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f27 (f32 f35 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f27 (f32 f35 ?v0) ?v1) f1) (=> (= (f27 (f32 f35 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f27 (f32 f35 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f27 (f32 f35 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f27 (f32 f35 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f27 (f32 f35 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f32 f35 ?v0))) (=> (= (f27 ?v_0 ?v1) f1) (= (= (f27 ?v_0 (+ ?v2 ?v3)) f1) (= (f27 ?v_0 (+ (+ ?v2 (f8 (f9 f10 ?v4) ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f27 (f32 f35 (f8 (f9 f10 ?v0) ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 f35 ?v0))) (= (= (f27 ?v_0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) f1) (= (f27 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f32 f35 ?v0))) (=> (= (f27 f29 ?v0) f1) (=> (= (f27 ?v_0 (f11 (f13 f14 ?v1) ?v2)) f1) (= (f27 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f32 f35 (f11 (f13 f14 ?v0) ?v2)))) (=> (= (f27 f29 ?v0) f1) (=> (not (= (f27 (f32 f35 ?v0) ?v1) f1)) (=> (= (f27 ?v_0 (f8 (f9 f10 ?v3) ?v1)) f1) (= (f27 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f32 f35 (f11 (f13 f14 ?v0) ?v2)))) (=> (= (f27 f29 ?v0) f1) (=> (not (= (f27 (f32 f35 ?v0) ?v1) f1)) (=> (= (f27 ?v_0 (f8 (f9 f10 ?v1) ?v3)) f1) (= (f27 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int)) (= (= (f27 f28 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f38 f39 (f40 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 f29 ?v0) f1) (=> (not (= (f27 (f32 f35 ?v0) ?v1) f1)) (= (f27 (f32 (f36 f37 (f11 (f13 f14 ?v1) (f6 f7 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f30 ?v0) ?v1) (ite (= (f27 (f32 (f36 f37 ?v0) 0) ?v1) f1) 0 (ite (= (f27 (f32 f33 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f27 (f32 f33 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f27 (f32 (f36 f37 (f11 (f13 f14 ?v2) (f6 f7 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f42 (f43 f44 (f6 f7 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f27 (f32 f35 ?v0) (f11 f12 ?v1)) f1) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 Int)) (= (= (f27 (f32 f35 (f11 f12 ?v0)) ?v1) f1) (= (f42 (f43 f44 ?v0) (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f27 (f32 f35 ?v0) (f11 f12 ?v1)) f1) (= (f42 (f43 f44 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f42 (f43 f44 ?v0) ?v1) f1) (= (f27 (f32 f35 (f11 f12 ?v0)) (f11 f12 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (=> (= (f42 (f43 f44 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) f1) (=> (< 1 (f11 f12 ?v0)) (<= (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f32 f35 ?v0))) (=> (= (f27 f29 ?v0) f1) (=> (= (f27 ?v_0 (f11 (f13 f14 ?v1) ?v2)) f1) (=> (< 0 (f11 f12 ?v2)) (= (f27 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 f35 ?v0))) (=> (= (f27 f29 ?v0) f1) (=> (= (f27 ?v_0 (f8 (f9 f10 ?v1) ?v2)) f1) (or (= (f27 ?v_0 ?v1) f1) (= (f27 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 f35 ?v1))) (=> (<= 0 ?v0) (=> (= (f27 f29 ?v1) f1) (=> (= (f27 ?v_0 (f8 (f9 f10 ?v0) ?v2)) f1) (or (= (f27 ?v_0 ?v0) f1) (= (f27 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f9 f10 ?v1))) (= (+ (f8 (f9 f10 (- ?v0 (f8 ?v_0 ?v2))) ?v3) (f8 (f9 f10 (- ?v4 (f8 ?v_0 ?v5))) ?v6)) (- (+ (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v4) ?v6)) (f8 ?v_0 (+ (f8 (f9 f10 ?v2) ?v3) (f8 (f9 f10 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f27 (f32 (f36 f37 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (= (f27 (f32 (f36 f37 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 (f36 f37 ?v0) ?v1))) (= (= (f27 ?v_0 (- ?v2)) f1) (= (f27 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (f27 (f32 (f36 f37 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f27 (f32 (f36 f37 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f27 (f32 (f36 f37 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f27 (f32 (f36 f37 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f27 (f32 (f36 f37 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f27 (f32 (f36 f37 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f27 (f32 (f36 f37 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f27 (f32 (f36 f37 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f36 f37 ?v1))) (=> (< 2 ?v0) (=> (= (f27 (f32 ?v_0 (- 1)) ?v0) f1) (not (= (f27 (f32 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (= (f27 (f32 (f36 f37 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f27 (f32 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f27 (f32 (f36 f37 ?v3) ?v4) ?v2) f1) (= (f27 (f32 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f27 (f32 ?v_0 ?v1) ?v2) f1) (=> (= (f27 (f32 (f36 f37 ?v1) ?v3) ?v2) f1) (= (f27 (f32 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (=> (= (f27 (f32 (f36 f37 ?v3) ?v4) ?v2) f1) (= (f27 (f32 (f36 f37 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (=> (= (f27 (f32 (f36 f37 ?v3) ?v4) ?v2) f1) (= (f27 (f32 (f36 f37 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 (f32 f35 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f8 (f9 f10 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f27 (f32 (f36 f37 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f36 f37 ?v3))) (=> (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (= (= (f27 (f32 ?v_0 (f8 (f9 f10 ?v0) ?v4)) ?v2) f1) (= (f27 (f32 ?v_0 (f8 (f9 f10 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f36 f37 ?v3)) (?v_1 (f9 f10 ?v4))) (=> (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (= (= (f27 (f32 ?v_0 (f8 ?v_1 ?v0)) ?v2) f1) (= (f27 (f32 ?v_0 (f8 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (= (f27 (f32 (f36 f37 (f8 (f9 f10 ?v0) ?v3)) (f8 (f9 f10 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v3))) (=> (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (= (f27 (f32 (f36 f37 (f8 ?v_0 ?v0)) (f8 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (=> (= (f27 (f32 (f36 f37 ?v3) ?v4) ?v2) f1) (= (f27 (f32 (f36 f37 (f8 (f9 f10 ?v0) ?v3)) (f8 (f9 f10 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f27 (f32 (f36 f37 ?v0) 0) ?v1) f1) (= (f27 (f32 f35 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f27 (f32 (f36 f37 ?v0) 0) ?v1) f1) (= (f27 (f32 f35 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (= (f27 (f32 f35 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f27 (f32 (f36 f37 ?v0) ?v1) ?v2) f1) (= (f27 (f32 (f36 f37 (f11 (f13 f14 ?v0) ?v3)) (f11 (f13 f14 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 f35 ?v1))) (=> (< 0 (f11 f12 ?v0)) (=> (= (f27 ?v_0 ?v2) f1) (= (f27 ?v_0 (f11 (f13 f14 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int)) (= (= (f27 f29 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f27 (f32 f35 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f36 f37 ?v1))) (=> (= (f27 f29 ?v0) f1) (=> (< 0 ?v1) (=> (= (f27 (f32 (f36 f37 (f8 (f9 f10 ?v1) ?v1)) 1) ?v0) f1) (or (= (f27 (f32 ?v_0 1) ?v0) f1) (= (f27 (f32 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 f29 ?v0) f1) (=> (< 0 ?v1) (=> (= (f27 (f32 (f36 f37 (f8 (f9 f10 ?v1) ?v2)) 0) ?v0) f1) (or (= (f27 (f32 (f36 f37 ?v1) 0) ?v0) f1) (= (f27 (f32 (f36 f37 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 f29 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f27 (f32 (f36 f37 ?v1) 0) ?v0) f1)) (not (= (f27 (f32 (f36 f37 ?v2) 0) ?v0) f1))) (not (= (f27 (f32 (f36 f37 (f8 (f9 f10 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 f29 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f27 (f32 (f36 f37 (f8 (f9 f10 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 f29 ?v0) f1) (=> (not (= (f27 (f32 (f36 f37 ?v1) 0) ?v0) f1)) (=> (not (= (f27 (f32 (f36 f37 ?v2) 0) ?v0) f1)) (not (= (f27 (f32 (f36 f37 (f8 (f9 f10 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f13 f14 ?v0))) (=> (= (f27 (f32 (f36 f37 (f11 ?v_0 ?v1)) 1) ?v2) f1) (= (f27 (f32 (f36 f37 (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f27 f29 ?v1) f1) (= (f27 (f32 f35 ?v1) ?v0) f1))))))
(assert (forall ((?v0 S2)) (= (f42 (f43 f44 ?v0) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f42 (f43 f44 (f6 f7 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f42 (f43 f44 ?v0) ?v1) f1)) (?v_0 (= (f42 (f43 f44 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f43 f44 ?v0)) (?v_0 (f43 f44 ?v1)) (?v_2 (f43 f44 ?v2))) (=> (and (= (f42 ?v_1 ?v1) f1) (not (= (f42 ?v_0 ?v0) f1))) (=> (and (= (f42 ?v_0 ?v2) f1) (not (= (f42 ?v_2 ?v1) f1))) (and (= (f42 ?v_1 ?v2) f1) (not (= (f42 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f42 (f43 f44 ?v0) ?v1) f1)) (?v_0 (= (f42 (f43 f44 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f43 f44 ?v0)) (?v_0 (f43 f44 ?v1))) (=> (and (= (f42 ?v_1 ?v1) f1) (not (= (f42 ?v_0 ?v0) f1))) (=> (= (f42 ?v_0 ?v2) f1) (and (= (f42 ?v_1 ?v2) f1) (not (= (f42 (f43 f44 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v0))) (=> (and (= (f42 ?v_0 ?v1) f1) (not (= (f42 (f43 f44 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f42 ?v_0 ?v2) f1) (not (= (f42 (f43 f44 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S1)) (let ((?v_1 (= (f42 (f43 f44 ?v0) ?v1) f1)) (?v_0 (= (f42 (f43 f44 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f42 (f43 f44 ?v0) ?v1) f1) (not (= (f42 (f43 f44 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f42 (f43 f44 ?v0) ?v1) f1) (not (= (f42 (f43 f44 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f42 (f43 f44 ?v0) ?v1) f1)) (?v_0 (= (f42 (f43 f44 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f42 (f43 f44 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f42 (f43 f44 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f42 (f43 f44 ?v0) ?v1) f1)) (?v_0 (= (f42 (f43 f44 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f42 (f43 f44 ?v0) ?v1) f1) (not (= (f42 (f43 f44 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v0)) (?v_1 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (= (f42 ?v_0 (f6 f7 (- ?v_2 ?v_1))) f1) (=> (= (f42 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f42 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v0)) (?v_1 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (= (f42 ?v_0 (f6 f7 (- ?v_2 ?v_1))) f1) (=> (= (f42 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f42 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v0)) (?v_1 (f43 f44 ?v2))) (=> (= (f42 ?v_0 ?v1) f1) (=> (and (= (f42 (f43 f44 ?v1) ?v2) f1) (not (= (f42 ?v_1 ?v1) f1))) (and (= (f42 ?v_0 ?v2) f1) (not (= (f42 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f42 (f43 f44 ?v1) ?v2) f1) (not (= (f42 ?v_0 ?v1) f1))) (and (= (f42 (f43 f44 ?v0) ?v2) f1) (not (= (f42 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v0))) (=> (= (f42 ?v_0 ?v1) f1) (=> (= (f42 ?v_0 ?v2) f1) (= (f42 ?v_0 (f6 f7 (- (f11 f12 ?v1) (f11 f12 ?v2)))) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v0))) (=> (= (f42 ?v_0 ?v1) f1) (=> (= (f42 (f43 f44 ?v1) ?v2) f1) (= (f42 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f42 (f43 f44 ?v0) ?v1) f1) (=> (= (f42 (f43 f44 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f42 (f43 f44 ?v0) ?v1) f1) (=> (= (f42 (f43 f44 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v0))) (=> (= (f42 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f42 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f42 (f43 f44 ?v1) ?v2) f1) (= (f42 (f43 f44 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v1))) (=> (= (f42 (f43 f44 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f11 f12 ?v0) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f42 (f43 f44 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f42 (f43 f44 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f42 (f43 f44 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f42 (f43 f44 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f42 (f43 f44 ?v0) ?v1) f1) (= (= (f42 (f43 f44 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 ?v1) (= (f42 (f43 f44 ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f11 f12 ?v1)) (not (= (f42 (f43 f44 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f42 (f43 f44 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f42 (f43 f44 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (and (= (f42 (f43 f44 ?v0) ?v1) f1) (not (= (f42 (f43 f44 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f42 (f43 f44 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f42 (f43 f44 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f43 f44 ?v0))) (= (= (f42 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v0)))) f1) (= (f42 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f42 (f43 f44 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f42 (f43 f44 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f42 (f43 f44 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 ?v1) (and (= (f42 (f43 f44 ?v0) ?v1) f1) (= (f42 (f43 f44 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f42 (f43 f44 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (= (f42 (f43 f44 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (<= ?v_0 (f8 ?v_1 (f8 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f11 f12 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (f8 (f9 f10 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (f8 (f9 f10 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_1 (+ ?v_2 1))) (f6 f7 (+ ?v_0 (f8 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (f11 f12 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (f8 (f9 f10 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ ?v_1 1)) ?v_0)) (f6 f7 (+ ?v_0 (f8 (f9 f10 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
