(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) Int)
(declare-fun f8 (S6 Int) S5)
(declare-fun f9 () S6)
(declare-fun f10 () Int)
(declare-fun f11 () S2)
(declare-fun f12 () S3)
(declare-fun f13 (S7 Int) S3)
(declare-fun f14 () S7)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () S3)
(declare-fun f22 (S8 S3) S9)
(declare-fun f23 () S8)
(declare-fun f24 (S9 S3) S3)
(declare-fun f25 () S8)
(declare-fun f26 (Int) S1)
(declare-fun f27 (Int) S1)
(declare-fun f28 () S6)
(declare-fun f29 () Int)
(declare-fun f30 (Int Int) S1)
(declare-fun f31 () S5)
(declare-fun f32 (Int Int) S1)
(declare-fun f33 (Int Int Int) S1)
(declare-fun f34 (S10 S11) Int)
(declare-fun f35 () S10)
(declare-fun f36 (Int Int) S11)
(declare-fun f37 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (let ((?v_2 (f7 (f8 f9 f10) ?v_0)) (?v_1 (f13 f14 2)) (?v_3 (f7 (f8 f9 f16) ?v_0))) (not (= (+ (f3 (f4 f5 (- f6 ?v_2)) ?v_1) (f3 (f4 f5 (- f15 ?v_3)) ?v_1)) (+ (+ (- (- (+ (f3 (f4 f5 f6) ?v_1) (f3 (f4 f5 f15) ?v_1)) (f7 (f8 f9 (* 2 f6)) ?v_2)) (f7 (f8 f9 (* 2 f15)) ?v_3)) (f3 (f4 f5 ?v_2) ?v_1)) (f3 (f4 f5 ?v_3) ?v_1)))))))
(assert (< 1 f17))
(assert (< 0 (f3 f11 f12)))
(assert (< 0 (+ 1 (f3 f11 f12))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f18 (- f6 (f7 (f8 f9 f10) ?v_0))) (<= (ite (< f18 0) (* (- 2) f18) (* 2 f18)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f19 (- f15 (f7 (f8 f9 f16) ?v_0))) (<= (ite (< f19 0) (* (- 2) f19) (* 2 f19)) ?v_0))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f6 (f7 (f8 f9 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f15 (f7 (f8 f9 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f15) ?v_0)) (f7 (f8 f9 (+ (* 4 f20) 1)) (+ 1 (f3 f11 f12))))))
(assert (= f21 (f13 f14 (- (f3 f11 (f13 f14 f17)) 1))))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (f13 f14 2))) (= (+ (f3 (f4 f5 f18) ?v_0) (f3 (f4 f5 f19) ?v_0)) (+ (f3 (f4 f5 (- f6 (f7 (f8 f9 f10) ?v_1))) ?v_0) (f3 (f4 f5 (- f15 (f7 (f8 f9 f16) ?v_1))) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f11 ?v1) (f3 f11 ?v2)))) (f7 (f8 f9 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f7 (f8 f9 ?v0) (f3 ?v_0 (f13 f14 2))) (f3 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f7 (f8 f9 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f7 (f8 f9 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f7 (f8 f9 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f7 (f8 f9 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f7 (f8 f9 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f7 (f8 f9 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f7 (f8 f9 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f13 f14 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f7 (f8 f9 ?v1) (f3 ?v_0 (f13 f14 (- (f3 f11 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (= (f7 (f8 f9 ?v0) ?v0) (f3 (f4 f5 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 S3)) (= (f24 (f22 f23 ?v0) ?v0) (f24 (f22 f25 ?v0) (f13 f14 2)))))
(assert (< 0 (f3 f11 f21)))
(assert (< 0 (+ (* 4 f20) 1)))
(assert (<= 1 f17))
(assert (not (= (f26 (f7 (f8 f9 (+ (* 4 f20) 1)) (+ 1 0))) f1)))
(assert (< f17 (+ (* 4 f20) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f13 f14 (- (f3 f11 (f13 f14 f17)) 1))) (=> (< 0 (f3 f11 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f20) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f26 (f7 (f8 f9 ?v_0) ?v_1)) f1))))))
(assert (= (f27 (+ (* 4 f20) 1)) f1))
(assert (= (f7 (f8 f28 (- 1)) (+ (* 4 f20) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f7 (f8 f9 (+ (* 4 f20) 1)) (+ 1 (f3 f11 f12)))) false))) false))
(assert (= (+ (f3 (f4 f5 f29) (f13 f14 2)) 1) (f7 (f8 f9 (+ (* 4 f20) 1)) f17)))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f20) 1))) (and (< ?v_1 ?v_0) (= (f26 (f7 (f8 f9 ?v_0) ?v_1)) f1))))
(assert (= (f26 (f7 (f8 f9 (+ (* 4 f20) 1)) f17)) f1))
(assert (=> (= f17 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f20) 1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f13 f14 (f7 (f8 f9 (f3 f11 ?v1)) (f3 f11 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 (f22 f25 (f24 ?v_0 ?v1)) ?v2) (f24 ?v_0 (f13 f14 (f7 (f8 f9 (f3 f11 ?v1)) (f3 f11 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f13 f14 (f7 (f8 f9 ?v0) ?v1)) (f13 f14 (f7 (f8 f9 (f3 f11 (f13 f14 (- ?v0)))) (f3 f11 (f13 f14 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f13 f14 (f7 (f8 f9 ?v0) ?v1)) (f13 f14 (f7 (f8 f9 (f3 f11 (f13 f14 ?v0))) (f3 f11 (f13 f14 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 (f8 f9 (f3 f11 ?v0)) (f3 f11 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 (f8 f9 (f3 f11 ?v0)) (f3 f11 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 (f8 f9 ?v0) ?v1))) (= (f13 f14 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f13 f14 (f7 (f8 f9 (f3 f11 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)))) (f3 f11 (f13 f14 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f13 f14 (f3 (f4 f5 ?v0) ?v1)) (f24 (f22 f25 (f13 f14 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f11 ?v0)) ?v1) (f3 f11 (f24 (f22 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f11 (f24 (f22 f25 ?v0) ?v1)) (f3 (f4 f5 (f3 f11 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f13 f14 (f7 (f8 f9 (f3 f11 ?v1)) (f3 f11 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f24 (f22 f23 (f24 ?v_0 ?v1)) (f24 (f22 f23 ?v2) ?v3)) (f24 (f22 f23 (f24 ?v_0 ?v2)) (f24 (f22 f23 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 (f8 f9 ?v2) ?v3)) (f7 (f8 f9 (f7 ?v_0 ?v2)) (f7 (f8 f9 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f22 f23 (f24 (f22 f23 ?v0) ?v1))) (?v_0 (f22 f23 ?v2))) (= (f24 ?v_1 (f24 ?v_0 ?v3)) (f24 ?v_0 (f24 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f8 f9 (f7 (f8 f9 ?v0) ?v1))) (?v_0 (f8 f9 ?v2))) (= (f7 ?v_1 (f7 ?v_0 ?v3)) (f7 ?v_0 (f7 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f24 (f22 f23 ?v2) ?v3))) (= (f24 (f22 f23 (f24 ?v_0 ?v1)) ?v_1) (f24 ?v_0 (f24 (f22 f23 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f7 (f8 f9 ?v2) ?v3))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v_1) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f24 (f22 f23 (f24 ?v_0 ?v1)) ?v2) (f24 (f22 f23 (f24 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 (f8 f9 (f7 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f24 (f22 f23 (f24 ?v_0 ?v1)) ?v2) (f24 ?v_0 (f24 (f22 f23 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f24 ?v_0 (f24 (f22 f23 ?v1) ?v2)) (f24 (f22 f23 (f24 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f22 f23 ?v0)) (?v_0 (f22 f23 ?v1))) (= (f24 ?v_1 (f24 ?v_0 ?v2)) (f24 ?v_0 (f24 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f7 ?v_1 (f7 ?v_0 ?v2)) (f7 ?v_0 (f7 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f24 (f22 f23 ?v0) ?v1) (f24 (f22 f23 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f24 (f22 f25 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 (f8 f9 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 (f8 f9 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f11 ?v2))) (let ((?v_1 (f8 f9 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f7 ?v_1 ?v0) (f7 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f9 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f7 ?v_0 ?v0) (f7 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f7 (f8 f9 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f7 (f8 f9 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f7 (f8 f9 (- ?v0 ?v1)) ?v2) (- (f7 (f8 f9 ?v0) ?v2) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f7 (f8 f9 (+ ?v0 ?v1)) ?v2) (+ (f7 (f8 f9 ?v0) ?v2) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 (f8 f9 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f9 (- ?v0)) ?v1) (- (f7 (f8 f9 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (- ?v1 ?v2)) (- (f7 ?v_0 ?v1) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (+ ?v1 ?v2)) (+ (f7 ?v_0 ?v1) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f13 f14 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f13 f14 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f7 (f8 f9 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f13 f14 (+ (f3 f11 ?v1) (f3 f11 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 (f22 f23 (f24 ?v_0 ?v1)) (f24 ?v_0 ?v2)) (f24 ?v_0 (f13 f14 (+ (f3 f11 ?v1) (f3 f11 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f24 (f22 f25 (f24 (f22 f23 ?v0) ?v1)) ?v2) (f24 (f22 f23 (f24 (f22 f25 ?v0) ?v2)) (f24 (f22 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f7 (f8 f9 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f13 f14 (+ (f3 f11 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 (f22 f23 (f24 ?v_0 ?v1)) ?v0) (f24 ?v_0 (f13 f14 (+ (f3 f11 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f13 f14 (* 2 (f3 f11 ?v1)))) (f7 (f8 f9 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (let ((?v_1 (f24 ?v_0 ?v1))) (= (f24 ?v_0 (f13 f14 (* 2 (f3 f11 ?v1)))) (f24 (f22 f23 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f7 (f8 f9 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f13 f14 (+ (f3 f11 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 (f22 f23 ?v0) (f24 ?v_0 ?v1)) (f24 ?v_0 (f13 f14 (+ (f3 f11 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f13 f14 (+ (* 2 (f3 f11 ?v1)) 1))) (f7 (f8 f9 ?v0) (f7 (f8 f9 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (let ((?v_1 (f24 ?v_0 ?v1))) (= (f24 ?v_0 (f13 f14 (+ (* 2 (f3 f11 ?v1)) 1))) (f24 (f22 f23 ?v0) (f24 (f22 f23 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f11 ?v1) 1))) (f7 (f8 f9 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 ?v_0 (f13 f14 (+ (f3 f11 ?v1) 1))) (f24 (f22 f23 ?v0) (f24 ?v_0 ?v1))))))
(assert (= (f30 (+ (* 4 f20) 1) (- 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f29) (f13 f14 2)) 1) (f7 (f8 f9 (+ (* 4 f20) 1)) ?v0)) false)) false))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f3 f11 ?v1)) (?v_1 (f3 f11 ?v0)) (?v_2 (f4 f5 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f13 f14 (- (+ ?v_0 1) ?v_1))) (f7 (f8 f9 (f3 ?v_2 (f13 f14 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f11 ?v1)) (?v_1 (f3 f11 ?v0)) (?v_2 (f22 f25 ?v2))) (=> (<= ?v_1 ?v_0) (= (f24 ?v_2 (f13 f14 (- (+ ?v_0 1) ?v_1))) (f24 (f22 f23 (f24 ?v_2 (f13 f14 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f3 f11 ?v0)) (?v_1 (f4 f5 ?v1))) (=> (< 0 ?v_0) (= (f7 (f8 f9 (f3 ?v_1 (f13 f14 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f11 ?v0)) (?v_1 (f22 f25 ?v1))) (=> (< 0 ?v_0) (= (f24 (f22 f23 (f24 ?v_1 (f13 f14 (- ?v_0 1)))) ?v1) (f24 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f24 (f22 f25 (f24 (f22 f23 ?v0) ?v1)) ?v2) (f24 (f22 f23 (f24 (f22 f25 ?v0) ?v2)) (f24 (f22 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f7 (f8 f9 ?v_0) ?v0) (f7 (f8 f9 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f24 (f22 f25 ?v0) ?v1))) (= (f24 (f22 f23 ?v_0) ?v0) (f24 (f22 f23 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f11 ?v1) (f3 f11 ?v2)))) (f7 (f8 f9 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 ?v_0 (f13 f14 (+ (f3 f11 ?v1) (f3 f11 ?v2)))) (f24 (f22 f23 (f24 ?v_0 ?v1)) (f24 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (* 2 (f3 f11 ?v1)) 1))) (f7 (f8 f9 ?v0) (f3 (f4 f5 (f3 ?v_0 ?v1)) (f13 f14 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 ?v_0 (f13 f14 (+ (* 2 (f3 f11 ?v1)) 1))) (f24 (f22 f23 ?v0) (f24 (f22 f25 (f24 ?v_0 ?v1)) (f13 f14 2)))))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f13 f14 3)) (f7 (f8 f9 (f7 (f8 f9 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3)) (= (f24 (f22 f25 ?v0) (f13 f14 3)) (f24 (f22 f23 (f24 (f22 f23 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f13 f14 2)) (f7 (f8 f9 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f24 (f22 f25 ?v0) (f13 f14 2)) (f24 (f22 f23 ?v0) ?v0))))
(assert (let ((?v_0 (f3 (f4 f5 f29) (f13 f14 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f20) 1))) (=> (not (= (f30 ?v_0 (- 1)) f1)) (not (= (f7 (f8 f28 (- 1)) ?v_0) 1)))))
(assert (= (f27 2) f1))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f11 (f24 (f22 f25 ?v0) ?v1))) (or (< 0 (f3 f11 ?v0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 ?v_0 ?v1) (ite (= ?v1 (f13 f14 0)) (f13 f14 1) (f13 f14 (f7 (f8 f9 (f3 f11 ?v0)) (f3 f11 (f24 ?v_0 (f13 f14 (- (f3 f11 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 0)) (?v_2 (f3 f11 ?v0)) (?v_1 (f3 f11 ?v1))) (= (f13 f14 (f7 (f8 f9 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f13 f14 (+ ?v_1 (f7 (f8 f9 (f3 f11 (f13 f14 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f11 ?v0))) (= (f13 f14 (* ?v_0 2)) (f13 f14 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f13 f14 (+ 0 1)))) (= (f24 (f22 f25 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f11 ?v0))) (= (f13 f14 (* 2 ?v_0)) (f13 f14 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 (+ 0 1)))) (= (= (f24 (f22 f25 ?v0) ?v1) ?v_0) (or (= ?v1 (f13 f14 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f25 ?v0))) (=> (< 0 (f3 f11 ?v0)) (=> (< (f3 f11 (f24 ?v_0 ?v1)) (f3 f11 (f24 ?v_0 ?v2))) (< (f3 f11 ?v1) (f3 f11 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f11 ?v0)) (<= ?v_0 (f3 f11 (f24 (f22 f25 ?v0) ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f27 ?v_0) f1) (= (f7 (f8 f28 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0) f1) (=> (= (f26 ?v1) f1) (= (f26 (f7 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f7 f31 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f7 f31 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) (f13 f14 2)))) (= (f7 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f24 (f22 f25 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f4 f5 (f7 f31 ?v0)) ?v_0) (f3 (f4 f5 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (f7 (f8 f9 (f3 f11 ?v1)) (f3 f11 ?v2)))) (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 ?v_0 (f13 f14 (f7 (f8 f9 (f3 f11 ?v1)) (f3 f11 ?v2)))) (f24 (f22 f25 (f24 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (* 2 (f3 f11 ?v1)))) (f3 (f4 f5 (f3 ?v_0 ?v1)) (f13 f14 2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 ?v_0 (f13 f14 (* 2 (f3 f11 ?v1)))) (f24 (f22 f25 (f24 ?v_0 ?v1)) (f13 f14 2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f11 ?v1) 1))) (f7 (f8 f9 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 ?v_0 (f13 f14 (+ (f3 f11 ?v1) 1))) (f24 (f22 f23 ?v0) (f24 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f11 ?v1) 1))) (f7 (f8 f9 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f24 ?v_0 (f13 f14 (+ (f3 f11 ?v1) 1))) (f24 (f22 f23 (f24 ?v_0 ?v1)) ?v0)))))
(assert (= (f32 (+ (* 4 f20) 1) (+ (f3 (f4 f5 f29) (f13 f14 2)) 1)) f1))
(assert (= (f32 (+ (* 4 f20) 1) (- (f3 (f4 f5 f29) (f13 f14 2)) (- 1))) f1))
(assert (= (f33 (f3 (f4 f5 f29) (f13 f14 2)) (- 1) (+ (* 4 f20) 1)) f1))
(assert (= (f34 f35 (f36 f29 1)) (f7 (f8 f9 (+ (* 4 f20) 1)) f17)))
(assert (let ((?v_0 (+ (* 4 f20) 1))) (and (<= 0 f29) (and (< f29 ?v_0) (= (f33 f37 f29 ?v_0) f1)))))
(assert (= (f33 (f3 (f4 f5 f37) (f13 f14 2)) (- 1) (+ (* 4 f20) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f33 (f3 (f4 f5 ?v0) (f13 f14 2)) (- 1) (+ (* 4 f20) 1)) f1) false)) false))
(assert (let ((?v_0 (f13 f14 2))) (= (f33 (f3 (f4 f5 f29) ?v_0) (f3 (f4 f5 f37) ?v_0) (+ (* 4 f20) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f20) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f33 f37 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f33 f37 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f20) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f33 f37 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f33 ?v0 0 ?v1) f1)) (=> (= (f33 (f3 (f4 f5 ?v2) (f13 f14 2)) ?v0 ?v1) f1) (not (= (f32 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S3)) (= (f13 f14 (f3 f11 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f11 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f11 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
