(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 () S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 () S3)
(declare-fun f9 (S4 Int) S3)
(declare-fun f10 () S4)
(declare-fun f11 (S5 Int) S2)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 (S6 Int) Int)
(declare-fun f16 (S7 Int) S6)
(declare-fun f17 () S7)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 (Int) S1)
(declare-fun f24 (Int Int) S1)
(declare-fun f25 (Int) S1)
(declare-fun f26 () S7)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (not (< f3 (+ 1 (f4 f5 f6)))))
(assert (< 1 f7))
(assert (< 0 (f4 f5 f6)))
(assert (< 0 (+ 1 (f4 f5 f6))))
(assert (= f8 (f9 f10 (- (f4 f5 (f9 f10 f7)) 1))))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f11 f12 f13) ?v_0) (f4 (f11 f12 f14) ?v_0)) (f15 (f16 f17 (+ 1 (f4 f5 f6))) f3))))
(assert (<= 1 f7))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f4 f5 f6)))) (=> (and (= ?v1 (- f18 (f15 (f16 f17 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f4 f5 f6)))) (=> (and (= ?v1 (- f19 (f15 (f16 f17 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (+ 1 (f4 f5 f6)))) (and (= f13 (- f18 (f15 (f16 f17 f20) ?v_0))) (<= (ite (< f13 0) (* (- 2) f13) (* 2 f13)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f4 f5 f6)))) (and (= f14 (- f19 (f15 (f16 f17 f21) ?v_0))) (<= (ite (< f14 0) (* (- 2) f14) (* 2 f14)) ?v_0))))
(assert (let ((?v_1 (+ 1 (f4 f5 f6))) (?v_0 (+ (* 4 f22) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f23 (f15 (f16 f17 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_1 (+ 1 (f4 f5 f6))) (?v_0 (+ (* 4 f22) 1))) (and (< ?v_1 ?v_0) (= (f23 (f15 (f16 f17 ?v_0) ?v_1)) f1))))
(assert (let ((?v_0 (f9 f10 2))) (= (f24 (+ 1 (f4 f5 f6)) (+ (f4 (f11 f12 f13) ?v_0) (f4 (f11 f12 f14) ?v_0))) f1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f9 f10 (- (f4 f5 (f9 f10 f7)) 1))) (=> (< 0 (f4 f5 ?v0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f4 (f11 f12 ?v0) ?v_0) (f4 (f11 f12 ?v1) ?v_0)) (f15 (f16 f17 (+ (* 4 f22) 1)) (+ 1 (f4 f5 f6)))) false))) false))
(assert (< 0 (f4 f5 f8)))
(assert (< 0 (+ (* 4 f22) 1)))
(assert (not (= (f23 (f15 (f16 f17 (+ (* 4 f22) 1)) (+ 1 0))) f1)))
(assert (< f7 (+ (* 4 f22) 1)))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f11 f12 f18) ?v_0) (f4 (f11 f12 f19) ?v_0)) (f15 (f16 f17 (+ (* 4 f22) 1)) (+ 1 (f4 f5 f6))))))
(assert (= (f23 (f15 (f16 f17 (+ (* 4 f22) 1)) f7)) f1))
(assert (= (f25 (+ (* 4 f22) 1)) f1))
(assert (= (f15 (f16 f26 (- 1)) (+ (* 4 f22) 1)) 1))
(assert (= (+ (f4 (f11 f12 f27) (f9 f10 2)) 1) (f15 (f16 f17 (+ (* 4 f22) 1)) f7)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f4 (f11 f12 f13) ?v_0) (f4 (f11 f12 f14) ?v_0)) (f15 (f16 f17 (+ 1 (f4 f5 f6))) ?v0)) false))) false))
(assert (=> (= f7 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f11 f12 ?v0) ?v_0) (f4 (f11 f12 ?v1) ?v_0)) (+ (* 4 f22) 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0) f1) (=> (= (f23 ?v1) f1) (= (f23 (f15 (f16 f17 ?v0) ?v1)) f1)))))
(assert (= (f28 (+ (* 4 f22) 1) (- 1)) f1))
(assert (= (f24 (+ (* 4 f22) 1) (+ (f4 (f11 f12 f27) (f9 f10 2)) 1)) f1))
(assert (= (f24 (+ (* 4 f22) 1) (- (f4 (f11 f12 f27) (f9 f10 2)) (- 1))) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f4 (f11 f12 f27) (f9 f10 2)) 1) (f15 (f16 f17 (+ (* 4 f22) 1)) ?v0)) false)) false))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f24 (f4 (f11 f12 ?v1) ?v0) (f4 (f11 f12 ?v2) ?v0)) f1) (= (f24 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f4 f5 ?v0)) (=> (= (f24 ?v1 ?v2) f1) (= (f24 ?v1 (f4 (f11 f12 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f24 (f4 (f11 f12 ?v0) ?v1) (f4 (f11 f12 ?v2) ?v1)) f1) (=> (not (= ?v1 (f9 f10 0))) (= (f24 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f12 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (f4 f5 ?v1) (f4 f5 ?v2)))) (f15 (f16 f17 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f15 (f16 f17 ?v0) (f4 ?v_0 (f9 f10 2))) (f4 ?v_0 (f9 f10 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f4 (f11 f12 (+ ?v0 ?v1)) ?v_0) (+ (+ (f4 (f11 f12 ?v0) ?v_0) (f15 (f16 f17 (* 2 ?v0)) ?v1)) (f4 (f11 f12 ?v1) ?v_0))))))
(assert (let ((?v_0 (f4 (f11 f12 f27) (f9 f10 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f22) 1))) (=> (not (= (f28 ?v_0 (- 1)) f1)) (not (= (f15 (f16 f26 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f25 ?v_0) f1) (= (f15 (f16 f26 (- 1)) ?v_0) 1)))))
(assert (= (f25 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f25 ?v0) f1) (=> (= (f24 ?v0 (f15 (f16 f17 ?v1) ?v2)) f1) (or (= (f24 ?v0 ?v1) f1) (= (f24 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f25 ?v0) f1) (=> (= (f24 ?v0 (f4 (f11 f12 ?v1) ?v2)) f1) (=> (< 0 (f4 f5 ?v2)) (= (f24 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f25 ?v0) f1) (=> (= (f24 ?v0 (f4 (f11 f12 ?v1) ?v2)) f1) (= (f24 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f4 (f11 f12 ?v0) ?v2))) (=> (= (f25 ?v0) f1) (=> (not (= (f24 ?v0 ?v1) f1)) (=> (= (f24 ?v_0 (f15 (f16 f17 ?v3) ?v1)) f1) (= (f24 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f4 (f11 f12 ?v0) ?v2))) (=> (= (f25 ?v0) f1) (=> (not (= (f24 ?v0 ?v1) f1)) (=> (= (f24 ?v_0 (f15 (f16 f17 ?v1) ?v3)) f1) (= (f24 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 (f16 f17 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 (f16 f17 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (let ((?v_1 (f16 f17 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f15 ?v_1 ?v0) (f15 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f15 ?v_0 ?v0) (f15 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f15 (f16 f17 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f15 (f16 f17 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f15 (f16 f17 (- ?v0 ?v1)) ?v2) (- (f15 (f16 f17 ?v0) ?v2) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f15 (f16 f17 (+ ?v0 ?v1)) ?v2) (+ (f15 (f16 f17 ?v0) ?v2) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f16 f17 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f17 (- ?v0)) ?v1) (- (f15 (f16 f17 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (- ?v1 ?v2)) (- (f15 ?v_0 ?v1) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (+ ?v1 ?v2)) (+ (f15 ?v_0 ?v1) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 ?v0 (- ?v1 ?v2)) f1) (=> (= (f24 ?v0 ?v2) f1) (= (f24 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0 ?v1) f1) (=> (= (f24 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 S3)) (= (f9 f10 (f4 f5 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f5 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f5 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
