(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 (S6 Int) S4)
(declare-fun f8 () S6)
(declare-fun f9 () Int)
(declare-fun f10 (S7 Int) S5)
(declare-fun f11 () S7)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () S4)
(declare-fun f17 () S5)
(declare-fun f18 () S5)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 (S8 S5) S5)
(declare-fun f25 (S9 S5) S8)
(declare-fun f26 () S9)
(declare-fun f27 () S9)
(declare-fun f28 (Int) S1)
(declare-fun f29 (Int) S1)
(declare-fun f30 () S3)
(declare-fun f31 () Int)
(declare-fun f32 (S5 S5) S1)
(declare-fun f33 () S2)
(declare-fun f34 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f10 f11 2)) (?v_1 (f4 f5 f9)) (?v_2 (f4 f5 f12))) (not (= (f3 (f4 f5 (+ (f6 (f7 f8 f9) ?v_0) (f6 (f7 f8 f12) ?v_0))) (+ (f6 (f7 f8 f13) ?v_0) (f6 (f7 f8 f14) ?v_0))) (+ (f6 (f7 f8 (+ (f3 ?v_1 f13) (f3 ?v_2 f14))) ?v_0) (f6 (f7 f8 (- (f3 ?v_1 f14) (f3 ?v_2 f13))) ?v_0))))))
(assert (< 1 f15))
(assert (< 0 (f6 f16 f17)))
(assert (= f18 (f10 f11 (- (f6 f16 (f10 f11 f15)) 1))))
(assert (let ((?v_0 (+ 1 (f6 f16 f17)))) (and (= f13 (- f9 (f3 (f4 f5 f19) ?v_0))) (<= (ite (< f13 0) (* (- 2) f13) (* 2 f13)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f6 f16 f17)))) (and (= f14 (- f12 (f3 (f4 f5 f20) ?v_0))) (<= (ite (< f14 0) (* (- 2) f14) (* 2 f14)) ?v_0))))
(assert (let ((?v_0 (f10 f11 2))) (= (+ (f6 (f7 f8 f13) ?v_0) (f6 (f7 f8 f14) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f16 f17))) f21))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2))) (=> (= (+ (f6 (f7 f8 f13) ?v_0) (f6 (f7 f8 f14) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f16 f17))) ?v0)) false))) false))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f16 ?v1) (f6 f16 ?v2)))) (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f3 (f4 f5 ?v0) (f6 ?v_0 (f10 f11 2))) (f6 ?v_0 (f10 f11 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v_0) (+ (+ (f6 (f7 f8 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f7 f8 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f10 f11 2)) (?v_0 (f10 f11 3)) (?v_1 (f7 f8 ?v0)) (?v_3 (f7 f8 ?v1))) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f6 ?v_1 ?v_0) (f3 (f4 f5 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f3 (f4 f5 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f10 f11 2)) (?v_0 (f10 f11 3)) (?v_3 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v_0) (- (+ (- (f6 ?v_1 ?v_0) (f3 (f4 f5 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f3 (f4 f5 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (< 0 (f6 f16 f18)))
(assert (< 0 (+ 1 (f6 f16 f17))))
(assert (<= 1 f15))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f10 f11 (- (f6 f16 (f10 f11 f15)) 1))) (=> (< 0 (f6 f16 ?v0)) false))) false))
(assert (< f21 (+ 1 (f6 f16 f17))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f16 f17)))) (=> (and (= ?v1 (- f12 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f16 f17)))) (=> (and (= ?v1 (- f9 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f6 f16 ?v2))) (let ((?v_1 (f4 f5 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f3 ?v_1 ?v0) (f3 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f3 (f4 f5 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v2) (- (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 (- ?v0)) ?v1) (- (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (- ?v1 ?v2)) (- (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f6 (f7 f8 ?v0) (f10 f11 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (= (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2)) (?v_1 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_1 ?v_0)) ?v_0) (f6 ?v_1 (f10 f11 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 3))) (= (f6 (f7 f8 (- ?v0)) ?v_0) (- (f6 (f7 f8 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f10 f11 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 3))) (let ((?v_0 (f6 (f7 f8 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 2))) (let ((?v_0 (f6 (f7 f8 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 (f7 f8 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (let ((?v_0 (f10 f11 2))) (= (+ (f6 (f7 f8 f9) ?v_0) (f6 (f7 f8 f12) ?v_0)) (f3 (f4 f5 (+ (* 4 f22) 1)) (+ 1 (f6 f16 f17))))))
(assert (let ((?v_0 (f10 f11 2))) (let ((?v_1 (+ (f6 (f7 f8 f13) ?v_0) (f6 (f7 f8 f14) ?v_0)))) (= (f3 (f4 f5 (f3 (f4 f5 (+ (* 4 f22) 1)) (+ 1 (f6 f16 f17)))) ?v_1) (f3 (f4 f5 (+ (f6 (f7 f8 f9) ?v_0) (f6 (f7 f8 f12) ?v_0))) ?v_1)))))
(assert (let ((?v_0 (f10 f11 2))) (= (f23 (+ 1 (f6 f16 f17)) (+ (f6 (f7 f8 f13) ?v_0) (f6 (f7 f8 f14) ?v_0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f10 f11 ?v0))) (=> (< 0 ?v0) (= (f6 ?v_0 ?v_1) (f3 (f4 f5 ?v1) (f6 ?v_0 (f10 f11 (- (f6 f16 ?v_1) 1)))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f6 f16 ?v1)) (?v_1 (f6 f16 ?v0)) (?v_2 (f7 f8 ?v2))) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f10 f11 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f5 (f6 ?v_2 (f10 f11 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f6 f16 ?v1)) (?v_1 (f6 f16 ?v0)) (?v_2 (f25 f26 ?v2))) (=> (<= ?v_1 ?v_0) (= (f24 ?v_2 (f10 f11 (- (+ ?v_0 1) ?v_1))) (f24 (f25 f27 (f24 ?v_2 (f10 f11 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 Int)) (let ((?v_0 (f6 f16 ?v0)) (?v_1 (f7 f8 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f5 (f6 ?v_1 (f10 f11 (- ?v_0 1)))) ?v1) (f6 ?v_1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f6 f16 ?v0)) (?v_1 (f25 f26 ?v1))) (=> (< 0 ?v_0) (= (f24 (f25 f27 (f24 ?v_1 (f10 f11 (- ?v_0 1)))) ?v1) (f24 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f10 f11 (+ (f6 f16 ?v1) (f6 f16 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 (f25 f27 (f24 ?v_0 ?v1)) (f24 ?v_0 ?v2)) (f24 ?v_0 (f10 f11 (+ (f6 f16 ?v1) (f6 f16 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f6 (f7 f8 (f3 (f4 f5 ?v0) ?v1)) ?v2) (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f24 (f25 f26 (f24 (f25 f27 ?v0) ?v1)) ?v2) (f24 (f25 f27 (f24 (f25 f26 ?v0) ?v2)) (f24 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f6 (f7 f8 (f3 (f4 f5 ?v0) ?v1)) ?v2) (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f24 (f25 f26 (f24 (f25 f27 ?v0) ?v1)) ?v2) (f24 (f25 f27 (f24 (f25 f26 ?v0) ?v2)) (f24 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (= (f3 (f4 f5 ?v_0) ?v0) (f3 (f4 f5 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f24 (f25 f26 ?v0) ?v1))) (= (f24 (f25 f27 ?v_0) ?v0) (f24 (f25 f27 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f3 (f4 f5 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f10 f11 (+ (f6 f16 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 (f25 f27 (f24 ?v_0 ?v1)) ?v0) (f24 ?v_0 (f10 f11 (+ (f6 f16 ?v1) 1)))))))
(assert (< 0 (+ (* 4 f22) 1)))
(assert (not (= (f28 (f3 (f4 f5 (+ (* 4 f22) 1)) (+ 1 0))) f1)))
(assert (< f15 (+ (* 4 f22) 1)))
(assert (let ((?v_1 (+ 1 (f6 f16 f17))) (?v_0 (+ (* 4 f22) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f28 (f3 (f4 f5 ?v_0) ?v_1)) f1))))))
(assert (= (f29 (+ (* 4 f22) 1)) f1))
(assert (= (f3 (f4 f30 (- 1)) (+ (* 4 f22) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (=> (= (+ (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (f3 (f4 f5 (+ (* 4 f22) 1)) (+ 1 (f6 f16 f17)))) false))) false))
(assert (= (+ (f6 (f7 f8 f31) (f10 f11 2)) 1) (f3 (f4 f5 (+ (* 4 f22) 1)) f15)))
(assert (let ((?v_1 (+ 1 (f6 f16 f17))) (?v_0 (+ (* 4 f22) 1))) (and (< ?v_1 ?v_0) (= (f28 (f3 (f4 f5 ?v_0) ?v_1)) f1))))
(assert (= (f28 (f3 (f4 f5 (+ (* 4 f22) 1)) f15)) f1))
(assert (=> (= f15 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (+ (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (+ (* 4 f22) 1))))))
(assert (forall ((?v0 Int)) (= (= (f23 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f23 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f23 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f23 ?v0 (- ?v1 ?v2)) f1) (=> (= (f23 ?v0 ?v2) f1) (= (f23 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f23 ?v0 ?v1) f1) (= (f23 (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f32 ?v0 ?v1) f1) (= (f32 (f24 (f25 f26 ?v0) ?v2) (f24 (f25 f26 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f7 f8 ?v2))) (=> (<= (f6 f16 ?v0) (f6 f16 ?v1)) (= (f23 (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v2))) (=> (<= (f6 f16 ?v0) (f6 f16 ?v1)) (= (f32 (f24 ?v_0 ?v0) (f24 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S5)) (=> (= (f23 ?v0 ?v1) f1) (=> (<= (f6 f16 ?v2) (f6 f16 ?v3)) (= (f23 (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f32 ?v0 ?v1) f1) (=> (<= (f6 f16 ?v2) (f6 f16 ?v3)) (= (f32 (f24 (f25 f26 ?v0) ?v2) (f24 (f25 f26 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f23 (f6 ?v_0 ?v1) ?v2) f1) (=> (<= (f6 f16 ?v3) (f6 f16 ?v1)) (= (f23 (f6 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f32 (f24 ?v_0 ?v1) ?v2) f1) (=> (<= (f6 f16 ?v3) (f6 f16 ?v1)) (= (f32 (f24 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (f3 (f4 f5 (f6 f16 ?v1)) (f6 f16 ?v2)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f10 f11 (f3 (f4 f5 (f6 f16 ?v1)) (f6 f16 ?v2)))) (f24 (f25 f26 (f24 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f10 f11 (f3 (f4 f5 (f6 f16 ?v1)) (f6 f16 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 (f25 f26 (f24 ?v_0 ?v1)) ?v2) (f24 ?v_0 (f10 f11 (f3 (f4 f5 (f6 f16 ?v1)) (f6 f16 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 (+ ?v1 (f3 (f4 f5 ?v0) ?v2))) f1) (= (f23 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f23 (f3 (f4 f5 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1) f1) (= (= (f23 ?v0 (+ ?v2 ?v3)) f1) (= (f23 ?v0 (+ (+ ?v2 (f3 (f4 f5 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f23 (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f23 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f16 (f24 (f25 f26 ?v0) ?v1)) (f6 (f7 f8 (f6 f16 ?v0)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f6 f16 ?v0)) ?v1) (f6 f16 (f24 (f25 f26 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f10 f11 (f6 (f7 f8 ?v0) ?v1)) (f24 (f25 f26 (f10 f11 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f10 f11 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f10 f11 (f3 (f4 f5 (f6 f16 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)))) (f6 f16 (f10 f11 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f3 (f4 f5 (f6 f16 ?v0)) (f6 f16 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f3 (f4 f5 (f6 f16 ?v0)) (f6 f16 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f10 f11 (f3 (f4 f5 ?v0) ?v1)) (f10 f11 (f3 (f4 f5 (f6 f16 (f10 f11 ?v0))) (f6 f16 (f10 f11 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f10 f11 (f3 (f4 f5 ?v0) ?v1)) (f10 f11 (f3 (f4 f5 (f6 f16 (f10 f11 (- ?v0)))) (f6 f16 (f10 f11 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f10 f11 (f3 (f4 f5 (f6 f16 ?v1)) (f6 f16 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f24 (f25 f27 ?v0) ?v1) (f24 (f25 f27 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f25 f27 ?v0)) (?v_0 (f25 f27 ?v1))) (= (f24 ?v_1 (f24 ?v_0 ?v2)) (f24 ?v_0 (f24 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f4 f5 ?v0)) (?v_0 (f4 f5 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f27 ?v0))) (= (f24 ?v_0 (f24 (f25 f27 ?v1) ?v2)) (f24 (f25 f27 (f24 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2)) (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f27 ?v0))) (= (f24 (f25 f27 (f24 ?v_0 ?v1)) ?v2) (f24 ?v_0 (f24 (f25 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f27 ?v0))) (= (f24 (f25 f27 (f24 ?v_0 ?v1)) ?v2) (f24 (f25 f27 (f24 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f5 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f25 f27 ?v0)) (?v_1 (f24 (f25 f27 ?v2) ?v3))) (= (f24 (f25 f27 (f24 ?v_0 ?v1)) ?v_1) (f24 ?v_0 (f24 (f25 f27 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v0)) (?v_1 (f3 (f4 f5 ?v2) ?v3))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f25 f27 (f24 (f25 f27 ?v0) ?v1))) (?v_0 (f25 f27 ?v2))) (= (f24 ?v_1 (f24 ?v_0 ?v3)) (f24 ?v_0 (f24 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f4 f5 (f3 (f4 f5 ?v0) ?v1))) (?v_0 (f4 f5 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f25 f27 ?v0))) (= (f24 (f25 f27 (f24 ?v_0 ?v1)) (f24 (f25 f27 ?v2) ?v3)) (f24 (f25 f27 (f24 ?v_0 ?v2)) (f24 (f25 f27 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) (f3 (f4 f5 ?v2) ?v3)) (f3 (f4 f5 (f3 ?v_0 ?v2)) (f3 (f4 f5 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f3 f33 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f3 f33 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f6 (f7 f8 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f24 (f25 f26 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f6 (f7 f8 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f24 (f25 f26 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) ?v0) (f6 (f7 f8 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 S5)) (= (f24 (f25 f27 ?v0) ?v0) (f24 (f25 f26 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f16 ?v1) 1))) (f3 (f4 f5 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f10 f11 (+ (f6 f16 ?v1) 1))) (f24 (f25 f27 ?v0) (f24 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f16 ?v1) 1))) (f3 (f4 f5 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f10 f11 (+ (f6 f16 ?v1) 1))) (f24 (f25 f27 ?v0) (f24 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f16 ?v1) 1))) (f3 (f4 f5 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f10 f11 (+ (f6 f16 ?v1) 1))) (f24 (f25 f27 (f24 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f10 f11 (+ (* 2 (f6 f16 ?v1)) 1))) (f3 (f4 f5 ?v0) (f3 (f4 f5 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (let ((?v_1 (f24 ?v_0 ?v1))) (= (f24 ?v_0 (f10 f11 (+ (* 2 (f6 f16 ?v1)) 1))) (f24 (f25 f27 ?v0) (f24 (f25 f27 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f3 (f4 f5 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f10 f11 (+ (f6 f16 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 (f25 f27 ?v0) (f24 ?v_0 ?v1)) (f24 ?v_0 (f10 f11 (+ (f6 f16 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f16 ?v1) (f6 f16 ?v2)))) (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f10 f11 (+ (f6 f16 ?v1) (f6 f16 ?v2)))) (f24 (f25 f27 (f24 ?v_0 ?v1)) (f24 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f10 f11 (* 2 (f6 f16 ?v1)))) (f3 (f4 f5 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (let ((?v_1 (f24 ?v_0 ?v1))) (= (f24 ?v_0 (f10 f11 (* 2 (f6 f16 ?v1)))) (f24 (f25 f27 ?v_1) ?v_1))))))
(assert (= (f34 (+ (* 4 f22) 1) (- 1)) f1))
(assert (= (f23 (+ (* 4 f22) 1) (- (f6 (f7 f8 f31) (f10 f11 2)) (- 1))) f1))
(assert (= (f23 (+ (* 4 f22) 1) (+ (f6 (f7 f8 f31) (f10 f11 2)) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f7 f8 f31) (f10 f11 2)) 1) (f3 (f4 f5 (+ (* 4 f22) 1)) ?v0)) false)) false))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f10 f11 0))) (= (= (f23 (f6 (f7 f8 ?v1) ?v0) (f6 (f7 f8 ?v2) ?v0)) f1) (= (f23 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (=> (< 0 (f6 f16 ?v0)) (=> (= (f23 ?v1 ?v2) f1) (= (f23 ?v1 (f6 (f7 f8 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (= (f23 (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v2) ?v1)) f1) (=> (not (= ?v1 (f10 f11 0))) (= (f23 ?v0 ?v2) f1)))))
(assert (let ((?v_0 (f6 (f7 f8 f31) (f10 f11 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f22) 1))) (=> (not (= (f34 ?v_0 (- 1)) f1)) (not (= (f3 (f4 f30 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f32 (f24 ?v_0 ?v1) (f24 ?v_0 ?v2)) f1) (=> (< 1 (f6 f16 ?v0)) (<= (f6 f16 ?v1) (f6 f16 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f6 f16 ?v0)) (<= ?v_0 (f6 f16 (f24 (f25 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v0))) (=> (< 0 (f6 f16 ?v0)) (=> (< (f6 f16 (f24 ?v_0 ?v1)) (f6 f16 (f24 ?v_0 ?v2))) (< (f6 f16 ?v1) (f6 f16 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 (f10 f11 0))) (= (= (f32 (f24 (f25 f26 ?v1) ?v0) (f24 (f25 f26 ?v2) ?v0)) f1) (= (f32 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f10 f11 (+ 0 1)))) (= (= (f24 (f25 f26 ?v0) ?v1) ?v_0) (or (= ?v1 (f10 f11 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S5)) (= (f10 f11 (f6 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f16 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f16 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
