(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 (S6 Int) S4)
(declare-fun f8 () S6)
(declare-fun f9 () S4)
(declare-fun f10 () S5)
(declare-fun f11 (S7 Int) S5)
(declare-fun f12 () S7)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(declare-fun f21 (Int) S1)
(declare-fun f22 () S3)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 (Int Int) S1)
(declare-fun f26 () S5)
(declare-fun f27 (Int Int) S1)
(declare-fun f28 () Int)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(declare-fun f33 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f11 f12 2)) (?v_2 (f4 f5 f17)) (?v_1 (f4 f5 f15))) (not (= (f3 (f4 f5 (f6 (f7 f8 (+ 1 (f6 f9 f10))) ?v_0)) (- (- (f3 (f4 f5 (+ (* 4 f13) 1)) f14) (f6 (f7 f8 (+ (+ (f3 ?v_1 f16) (f3 ?v_2 f18)) f14)) ?v_0)) (f6 (f7 f8 (- (f3 ?v_1 f18) (f3 ?v_2 f16))) ?v_0))) 0))))
(assert (let ((?v_1 (f11 f12 2))) (let ((?v_0 (f4 f5 (f6 (f7 f8 (+ 1 (f6 f9 f10))) ?v_1))) (?v_3 (f4 f5 f17)) (?v_2 (f4 f5 f15))) (= (f3 ?v_0 (f3 (f4 f5 (+ (* 4 f13) 1)) f14)) (f3 ?v_0 (+ (f6 (f7 f8 (+ (+ (f3 ?v_2 f16) (f3 ?v_3 f18)) f14)) ?v_1) (f6 (f7 f8 (- (f3 ?v_2 f18) (f3 ?v_3 f16))) ?v_1)))))))
(assert (< 1 f19))
(assert (< 0 (f6 f9 f10)))
(assert (< 0 (+ 1 (f6 f9 f10))))
(assert (< 0 (+ (* 4 f13) 1)))
(assert (not (= (f20 (f3 (f4 f5 (+ (* 4 f13) 1)) (+ 1 0))) f1)))
(assert (< f14 (+ 1 (f6 f9 f10))))
(assert (let ((?v_1 (+ 1 (f6 f9 f10))) (?v_0 (+ (* 4 f13) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f20 (f3 (f4 f5 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f6 (f7 f8 f16) ?v_0) (f6 (f7 f8 f18) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f9 f10))) f14))))
(assert (let ((?v_1 (f11 f12 2))) (let ((?v_0 (f4 f5 (f6 (f7 f8 (+ 1 (f6 f9 f10))) ?v_1))) (?v_3 (f4 f5 f17)) (?v_2 (f4 f5 f15))) (= (f3 ?v_0 (f3 (f4 f5 (+ (* 4 f13) 1)) f14)) (f3 ?v_0 (+ (f6 (f7 f8 (+ (+ (f3 ?v_2 f16) (f3 ?v_3 f18)) f14)) ?v_1) (f6 (f7 f8 (- (f3 ?v_2 f18) (f3 ?v_3 f16))) ?v_1)))))))
(assert (= (f21 (+ (* 4 f13) 1)) f1))
(assert (= (f3 (f4 f22 (- 1)) (+ (* 4 f13) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (=> (= (+ (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (f3 (f4 f5 (+ (* 4 f13) 1)) (+ 1 (f6 f9 f10)))) false))) false))
(assert (let ((?v_0 (+ 1 (f6 f9 f10)))) (and (= f16 (- f23 (f3 (f4 f5 f15) ?v_0))) (<= (ite (< f16 0) (* (- 2) f16) (* 2 f16)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f6 f9 f10)))) (and (= f18 (- f24 (f3 (f4 f5 f17) ?v_0))) (<= (ite (< f18 0) (* (- 2) f18) (* 2 f18)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f6 f9 f10))) (?v_3 (f11 f12 2)) (?v_6 (f4 f5 f17)) (?v_4 (f4 f5 f15))) (let ((?v_5 (f4 f5 ?v_0)) (?v_1 (f4 f5 (+ (f3 ?v_4 ?v_0) f16))) (?v_2 (f4 f5 (+ (f3 ?v_6 ?v_0) f18)))) (= (+ (f6 (f7 f8 (+ (f3 ?v_1 f16) (f3 ?v_2 f18))) ?v_3) (f6 (f7 f8 (- (f3 ?v_1 f18) (f3 ?v_2 f16))) ?v_3)) (+ (f6 (f7 f8 (+ (+ (f3 ?v_5 (f3 ?v_4 f16)) (f3 ?v_5 (f3 ?v_6 f18))) (+ (f6 (f7 f8 f16) ?v_3) (f6 (f7 f8 f18) ?v_3)))) ?v_3) (f6 (f7 f8 (- (f3 ?v_5 (f3 ?v_4 f18)) (f3 ?v_5 (f3 ?v_6 f16)))) ?v_3))))))
(assert (let ((?v_1 (f11 f12 2)) (?v_3 (f4 f5 f17)) (?v_2 (f4 f5 f15)) (?v_0 (f4 f5 (+ 1 (f6 f9 f10))))) (let ((?v_4 (+ (f3 ?v_0 (f3 ?v_2 f16)) (f3 ?v_0 (f3 ?v_3 f18)))) (?v_5 (f6 (f7 f8 (- (f3 ?v_0 (f3 ?v_2 f18)) (f3 ?v_0 (f3 ?v_3 f16)))) ?v_1))) (= (+ (f6 (f7 f8 (+ ?v_4 (+ (f6 (f7 f8 f16) ?v_1) (f6 (f7 f8 f18) ?v_1)))) ?v_1) ?v_5) (+ (f6 (f7 f8 (+ ?v_4 (f3 ?v_0 f14))) ?v_1) ?v_5)))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f11 f12 2))) (=> (= (+ (f6 (f7 f8 f16) ?v_0) (f6 (f7 f8 f18) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f9 f10))) ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f6 f9 f10))) (?v_0 (f11 f12 2))) (let ((?v_2 (f4 f5 (f6 (f7 f8 ?v_1) ?v_0))) (?v_4 (f4 f5 f17)) (?v_3 (f4 f5 f15))) (= (f3 (f4 f5 (f3 (f4 f5 (+ (* 4 f13) 1)) ?v_1)) (+ (f6 (f7 f8 f16) ?v_0) (f6 (f7 f8 f18) ?v_0))) (+ (f3 ?v_2 (f6 (f7 f8 (+ (+ (f3 ?v_3 f16) (f3 ?v_4 f18)) f14)) ?v_0)) (f3 ?v_2 (f6 (f7 f8 (- (f3 ?v_3 f18) (f3 ?v_4 f16))) ?v_0)))))))
(assert (let ((?v_1 (+ 1 (f6 f9 f10))) (?v_0 (f11 f12 2)) (?v_4 (f4 f5 f17)) (?v_3 (f4 f5 f15))) (let ((?v_2 (f4 f5 ?v_1))) (= (f3 (f4 f5 (f3 (f4 f5 (+ (* 4 f13) 1)) ?v_1)) (+ (f6 (f7 f8 f16) ?v_0) (f6 (f7 f8 f18) ?v_0))) (+ (f6 (f7 f8 (+ (+ (f3 ?v_2 (f3 ?v_3 f16)) (f3 ?v_2 (f3 ?v_4 f18))) (f3 ?v_2 f14))) ?v_0) (f6 (f7 f8 (- (f3 ?v_2 (f3 ?v_3 f18)) (f3 ?v_2 (f3 ?v_4 f16)))) ?v_0))))))
(assert (let ((?v_1 (+ 1 (f6 f9 f10))) (?v_0 (+ (* 4 f13) 1))) (and (< ?v_1 ?v_0) (= (f20 (f3 (f4 f5 ?v_0) ?v_1)) f1))))
(assert (= (f25 (+ (* 4 f13) 1) (- 1)) f1))
(assert (= f26 (f11 f12 (- (f6 f9 (f11 f12 f19)) 1))))
(assert (let ((?v_0 (f11 f12 2))) (= (f27 (+ 1 (f6 f9 f10)) (+ (f6 (f7 f8 f16) ?v_0) (f6 (f7 f8 f18) ?v_0))) f1)))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f6 (f7 f8 f23) ?v_0) (f6 (f7 f8 f24) ?v_0)) (f3 (f4 f5 (+ (* 4 f13) 1)) (+ 1 (f6 f9 f10))))))
(assert (let ((?v_3 (+ 1 (f6 f9 f10))) (?v_2 (f11 f12 2))) (let ((?v_4 (f4 f5 (+ (f3 (f4 f5 f15) ?v_3) f16))) (?v_5 (f4 f5 (+ (f3 (f4 f5 f17) ?v_3) f18))) (?v_0 (f4 f5 f23)) (?v_1 (f4 f5 f24))) (= (+ (f6 (f7 f8 (+ (f3 ?v_0 f16) (f3 ?v_1 f18))) ?v_2) (f6 (f7 f8 (- (f3 ?v_0 f18) (f3 ?v_1 f16))) ?v_2)) (+ (f6 (f7 f8 (+ (f3 ?v_4 f16) (f3 ?v_5 f18))) ?v_2) (f6 (f7 f8 (- (f3 ?v_4 f18) (f3 ?v_5 f16))) ?v_2))))))
(assert (< f19 (+ (* 4 f13) 1)))
(assert (let ((?v_0 (f11 f12 2))) (let ((?v_1 (+ (f6 (f7 f8 f16) ?v_0) (f6 (f7 f8 f18) ?v_0)))) (= (f3 (f4 f5 (f3 (f4 f5 (+ (* 4 f13) 1)) (+ 1 (f6 f9 f10)))) ?v_1) (f3 (f4 f5 (+ (f6 (f7 f8 f23) ?v_0) (f6 (f7 f8 f24) ?v_0))) ?v_1)))))
(assert (= (+ (f6 (f7 f8 f28) (f11 f12 2)) 1) (f3 (f4 f5 (+ (* 4 f13) 1)) f19)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f7 f8 f28) (f11 f12 2)) 1) (f3 (f4 f5 (+ (* 4 f13) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f11 f12 (+ (f6 f9 ?v1) (f6 f9 ?v2)))) (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f3 (f4 f5 ?v0) (f6 ?v_0 (f11 f12 2))) (f6 ?v_0 (f11 f12 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v_0) (+ (+ (f6 (f7 f8 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (< 0 (f6 f9 f26)))
(assert (<= 1 f19))
(assert (let ((?v_0 (f6 (f7 f8 f28) (f11 f12 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f11 f12 (- (f6 f9 (f11 f12 f19)) 1))) (=> (< 0 (f6 f9 ?v0)) false))) false))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (=> (not (= (f25 ?v_0 (- 1)) f1)) (not (= (f3 (f4 f22 (- 1)) ?v_0) 1)))))
(assert (= (f27 (+ (* 4 f13) 1) (- (f6 (f7 f8 f28) (f11 f12 2)) (- 1))) f1))
(assert (= (f27 (+ (* 4 f13) 1) (+ (f6 (f7 f8 f28) (f11 f12 2)) 1)) f1))
(assert (= (f20 (f3 (f4 f5 (+ (* 4 f13) 1)) f19)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f9 f10)))) (=> (and (= ?v1 (- f24 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f9 f10)))) (=> (and (= ?v1 (- f23 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f11 f12 2)) (?v_1 (f4 f5 f23)) (?v_2 (f4 f5 f24))) (= (f3 (f4 f5 (+ (f6 (f7 f8 f23) ?v_0) (f6 (f7 f8 f24) ?v_0))) (+ (f6 (f7 f8 f16) ?v_0) (f6 (f7 f8 f18) ?v_0))) (+ (f6 (f7 f8 (+ (f3 ?v_1 f16) (f3 ?v_2 f18))) ?v_0) (f6 (f7 f8 (- (f3 ?v_1 f18) (f3 ?v_2 f16))) ?v_0)))))
(assert (=> (= f19 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (+ (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (+ (* 4 f13) 1))))))
(assert (= (f21 2) f1))
(assert (forall ((?v0 Int)) (= (= (f27 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f21 ?v0) f1) (=> (= (f27 ?v0 (f6 (f7 f8 ?v1) ?v2)) f1) (= (f27 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f27 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f21 ?v_0) f1) (= (f3 (f4 f22 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f27 ?v0 ?v1) f1) (=> (= (f27 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f27 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 ?v1) f1) (=> (= (f27 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 ?v0 (- ?v1 ?v2)) f1) (=> (= (f27 ?v0 ?v2) f1) (= (f27 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f27 (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f27 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 ?v0 ?v1) f1) (= (= (f27 ?v0 (+ ?v2 ?v3)) f1) (= (f27 ?v0 (+ (+ ?v2 (f3 (f4 f5 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f27 (f3 (f4 f5 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f27 ?v0 (+ ?v1 (f3 (f4 f5 ?v0) ?v2))) f1) (= (f27 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v2))) (=> (= (f21 ?v0) f1) (=> (not (= (f27 ?v0 ?v1) f1)) (=> (= (f27 ?v_0 (f3 (f4 f5 ?v3) ?v1)) f1) (= (f27 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v2))) (=> (= (f21 ?v0) f1) (=> (not (= (f27 ?v0 ?v1) f1)) (=> (= (f27 ?v_0 (f3 (f4 f5 ?v1) ?v3)) f1) (= (f27 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (= (f20 ?v1) f1) (= (f20 (f3 (f4 f5 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f6 f9 ?v2))) (let ((?v_1 (f4 f5 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f3 ?v_1 ?v0) (f3 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f3 (f4 f5 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v2) (- (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 (- ?v0)) ?v1) (- (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (- ?v1 ?v2)) (- (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f6 (f7 f8 ?v0) (f11 f12 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (= (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 2)) (?v_1 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_1 ?v_0)) ?v_0) (f6 ?v_1 (f11 f12 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 3))) (= (f6 (f7 f8 (- ?v0)) ?v_0) (- (f6 (f7 f8 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f11 f12 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f11 f12 3))) (let ((?v_0 (f6 (f7 f8 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f11 f12 2))) (let ((?v_0 (f6 (f7 f8 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 (f7 f8 ?v0) (f11 f12 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f11 f12 2)) (?v_0 (f11 f12 3)) (?v_3 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v_0) (- (+ (- (f6 ?v_1 ?v_0) (f3 (f4 f5 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f3 (f4 f5 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f11 f12 2)) (?v_0 (f11 f12 3)) (?v_1 (f7 f8 ?v0)) (?v_3 (f7 f8 ?v1))) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f6 ?v_1 ?v_0) (f3 (f4 f5 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f3 (f4 f5 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f7 f8 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f21 ?v0) f1) (=> (= (f27 ?v0 (f6 (f7 f8 ?v1) ?v2)) f1) (=> (< 0 (f6 f9 ?v2)) (= (f27 ?v0 ?v1) f1))))))
(assert (= (f29 (f6 (f7 f8 f28) (f11 f12 2)) (- 1) (+ (* 4 f13) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 ?v0) f1) (=> (= (f27 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (or (= (f27 ?v0 ?v1) f1) (= (f27 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f21 ?v1) f1) (=> (= (f27 ?v1 (f3 (f4 f5 ?v0) ?v2)) f1) (or (= (f27 ?v1 ?v0) f1) (= (f27 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f21 ?v1) f1) (= (f27 ?v1 ?v0) f1))))))
(assert (= (f30 f31 (f32 f28 1)) (f3 (f4 f5 (+ (* 4 f13) 1)) f19)))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (and (<= 0 f28) (and (< f28 ?v_0) (= (f29 f33 f28 ?v_0) f1)))))
(assert (forall ((?v0 Int)) (= (= (f21 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f27 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (= (f27 (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v2) ?v1)) f1) (=> (not (= ?v1 (f11 f12 0))) (= (f27 ?v0 ?v2) f1)))))
(assert (= (f29 (f6 (f7 f8 f33) (f11 f12 2)) (- 1) (+ (* 4 f13) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f6 (f7 f8 ?v0) (f11 f12 2)) (- 1) (+ (* 4 f13) 1)) f1) false)) false))
(assert (let ((?v_0 (f11 f12 2))) (= (f29 (f6 (f7 f8 f28) ?v_0) (f6 (f7 f8 f33) ?v_0) (+ (* 4 f13) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f33 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f27 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f27 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f27 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v3))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f4 f5 ?v4))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f3 ?v_0 ?v0) ?v2) f1) (= (f29 ?v3 (f3 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f3 (f4 f5 ?v0) ?v4) ?v2) f1) (= (f29 ?v3 (f3 (f4 f5 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f29 (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f3 (f4 f5 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S5)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f6 (f7 f8 ?v0) ?v3) (f6 (f7 f8 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v1 ?v3 ?v2) f1) (= (f29 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v1 (- 1) ?v0) f1) (not (= (f29 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f29 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f29 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 S5)) (= (f11 f12 (f6 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f9 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f9 (f11 f12 ?v0)) 0))))
(check-sat)
(exit)
