(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 (S2 Int) Int)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 () Int)
(declare-fun f9 (S4 S5) Int)
(declare-fun f10 (S6 Int) S4)
(declare-fun f11 () S6)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 (S7 Int) S5)
(declare-fun f17 () S7)
(declare-fun f18 () Int)
(declare-fun f19 () S4)
(declare-fun f20 () S5)
(declare-fun f21 (Int) S1)
(declare-fun f22 () S3)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 () S5)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(declare-fun f33 () Int)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) f8)) f1)))
(assert (let ((?v_0 (f5 f6 f12)) (?v_1 (f5 f6 f14)) (?v_2 (f16 f17 2))) (= (+ (f9 (f10 f11 (+ (+ (f4 ?v_0 f13) (f4 ?v_1 f15)) f8)) ?v_2) (f9 (f10 f11 (- (f4 ?v_0 f15) (f4 ?v_1 f13))) ?v_2)) (f4 (f5 f6 (+ (* 4 f7) 1)) f8))))
(assert (< 1 f18))
(assert (< 0 (f9 f19 f20)))
(assert (< 0 (+ (* 4 f7) 1)))
(assert (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (f5 f6 f12)) (?v_1 (f5 f6 f14)) (?v_2 (f16 f17 2))) (= (+ (f9 (f10 f11 (+ (+ (f4 ?v_0 f13) (f4 ?v_1 f15)) f8)) ?v_2) (f9 (f10 f11 (- (f4 ?v_0 f15) (f4 ?v_1 f13))) ?v_2)) (f4 (f5 f6 (+ (* 4 f7) 1)) f8))))
(assert (= (f21 (+ (* 4 f7) 1)) f1))
(assert (= (f4 (f5 f22 (- 1)) (+ (* 4 f7) 1)) 1))
(assert (let ((?v_0 (+ (* 4 f7) 1)) (?v_1 (+ 1 (f9 f19 f20)))) (not (=> (< ?v_1 ?v_0) (not (= (f3 (f4 (f5 f6 ?v_0) ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (= (f23 (+ (* 4 f7) 1) (- 1)) f1))
(assert (= f24 (f16 f17 (- (f9 f19 (f16 f17 f18)) 1))))
(assert (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) f18)) f1))
(assert (< f18 (+ (* 4 f7) 1)))
(assert (let ((?v_0 (+ (* 4 f7) 1)) (?v_1 (+ 1 (f9 f19 f20)))) (and (< ?v_1 ?v_0) (= (f3 (f4 (f5 f6 ?v_0) ?v_1)) f1))))
(assert (let ((?v_0 (f16 f17 2))) (= (+ (f9 (f10 f11 f13) ?v_0) (f9 (f10 f11 f15) ?v_0)) (f4 (f5 f6 (+ 1 (f9 f19 f20))) f8))))
(assert (< f8 (+ 1 (f9 f19 f20))))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (=> (not (= (f23 ?v_0 (- 1)) f1)) (not (= (f4 (f5 f22 (- 1)) ?v_0) 1)))))
(assert (= (+ (f9 (f10 f11 f25) (f16 f17 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) f18)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f9 (f10 f11 f25) (f16 f17 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (+ ?v1 ?v2)) (+ (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (< 0 (f9 f19 f24)))
(assert (< 0 (+ 1 (f9 f19 f20))))
(assert (<= 1 f18))
(assert (let ((?v_0 (f9 (f10 f11 f25) (f16 f17 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f16 f17 (- (f9 f19 (f16 f17 f18)) 1))) (=> (< 0 (f9 f19 ?v0)) false))) false))
(assert (let ((?v_0 (+ 1 (f9 f19 f20)))) (and (= f15 (- f26 (f4 (f5 f6 f14) ?v_0))) (<= (ite (< f15 0) (* (- 2) f15) (* 2 f15)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f9 f19 f20)))) (and (= f13 (- f27 (f4 (f5 f6 f12) ?v_0))) (<= (ite (< f13 0) (* (- 2) f13) (* 2 f13)) ?v_0))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (=> (= (+ (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v1) ?v_0)) (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 (f9 f19 f20)))) false))) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f16 f17 2))) (=> (= (+ (f9 (f10 f11 f13) ?v_0) (f9 (f10 f11 f15) ?v_0)) (f4 (f5 f6 (+ 1 (f9 f19 f20))) ?v0)) false))) false))
(assert (let ((?v_0 (f16 f17 2))) (= (+ (f9 (f10 f11 f27) ?v_0) (f9 (f10 f11 f26) ?v_0)) (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 (f9 f19 f20))))))
(assert (=> (= f18 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (+ (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v1) ?v_0)) (+ (* 4 f7) 1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f9 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f9 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f16 f17 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f21 ?v_0) f1) (= (f4 (f5 f22 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f16 f17 (+ (f9 f19 ?v1) (f9 f19 ?v2)))) (f4 (f5 f6 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f4 (f5 f6 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f9 f19 ?v2))) (let ((?v_1 (f5 f6 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f4 ?v_1 ?v0) (f4 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v2) (- (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v2) (+ (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 (- ?v0)) ?v1) (- (f4 (f5 f6 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (- ?v1 ?v2)) (- (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f9 f19 f20)))) (=> (and (= ?v1 (- f26 (f4 (f5 f6 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f9 f19 f20)))) (=> (and (= ?v1 (- f27 (f4 (f5 f6 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f16 f17 2))) (= (f28 (+ 1 (f9 f19 f20)) (+ (f9 (f10 f11 f13) ?v_0) (f9 (f10 f11 f15) ?v_0))) f1)))
(assert (= (f28 (+ (* 4 f7) 1) (- (f9 (f10 f11 f25) (f16 f17 2)) (- 1))) f1))
(assert (= (f28 (+ (* 4 f7) 1) (+ (f9 (f10 f11 f25) (f16 f17 2)) 1)) f1))
(assert (= (f29 (f9 (f10 f11 f25) (f16 f17 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (= (f30 f31 (f32 f25 1)) (f4 (f5 f6 (+ (* 4 f7) 1)) f18)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (and (<= 0 f25) (and (< f25 ?v_0) (= (f29 f33 f25 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 ?v1)) (?v_1 (f16 f17 ?v0))) (=> (< 0 ?v0) (= (f9 ?v_0 ?v_1) (f4 (f5 f6 ?v1) (f9 ?v_0 (f16 f17 (- (f9 f19 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f4 (f5 f6 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v1) ?v_0))))))
(assert (= (f29 (f9 (f10 f11 f33) (f16 f17 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f9 (f10 f11 ?v0) (f16 f17 2)) (- 1) (+ (* 4 f7) 1)) f1) false)) false))
(assert (let ((?v_0 (f16 f17 2))) (= (f29 (f9 (f10 f11 f25) ?v_0) (f9 (f10 f11 f33) ?v_0) (+ (* 4 f7) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f33 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int)) (= (= (f28 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f28 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f29 ?v0 0 ?v1) f1)) (=> (= (f29 (f9 (f10 f11 ?v2) (f16 f17 2)) ?v0 ?v1) f1) (not (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f28 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 (- ?v1 ?v2)) f1) (=> (= (f28 ?v0 ?v2) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 f6 ?v0)) (?v_1 (f5 f6 ?v1))) (= (f4 (f5 f6 (f30 f31 (f32 ?v0 ?v1))) (f30 f31 (f32 ?v2 ?v3))) (f30 f31 (f32 (+ (f4 ?v_0 ?v2) (f4 ?v_1 ?v3)) (- (f4 ?v_0 ?v3) (f4 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f28 (f4 (f5 f6 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (= (f28 ?v0 (+ ?v2 ?v3)) f1) (= (f28 ?v0 (+ (+ ?v2 (f4 (f5 f6 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f28 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f21 ?v0) f1) (=> (= (f28 ?v0 (f9 (f10 f11 ?v1) ?v2)) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v2))) (=> (= (f21 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (f4 (f5 f6 ?v3) ?v1)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v2))) (=> (= (f21 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (f4 (f5 f6 ?v1) ?v3)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f4 (f5 f6 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f9 (f10 f11 ?v0) (f16 f17 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (= (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 2)) (?v_1 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_1 ?v_0)) ?v_0) (f9 ?v_1 (f16 f17 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 3))) (= (f9 (f10 f11 (- ?v0)) ?v_0) (- (f9 (f10 f11 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f16 f17 3))) (let ((?v_0 (f9 (f10 f11 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f9 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f16 f17 2))) (let ((?v_0 (f9 (f10 f11 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f9 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f9 (f10 f11 ?v0) (f16 f17 2)))))
(assert (= (f21 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f4 (f5 f6 ?v0) (f9 ?v_0 (f16 f17 2))) (f9 ?v_0 (f16 f17 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f9 (f10 f11 (+ ?v0 ?v1)) ?v_0) (+ (+ (f9 (f10 f11 ?v0) ?v_0) (f4 (f5 f6 (* 2 ?v0)) ?v1)) (f9 (f10 f11 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f9 (f10 f11 (- ?v0 ?v1)) ?v_0) (+ (- (f9 (f10 f11 ?v0) ?v_0) (f4 (f5 f6 (* 2 ?v0)) ?v1)) (f9 (f10 f11 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f16 f17 2)) (?v_0 (f16 f17 3)) (?v_1 (f10 f11 ?v0)) (?v_3 (f10 f11 ?v1))) (= (f9 (f10 f11 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f9 ?v_1 ?v_0) (f4 (f5 f6 (* 3 (f9 ?v_1 ?v_2))) ?v1)) (f4 (f5 f6 (* 3 ?v0)) (f9 ?v_3 ?v_2))) (f9 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f16 f17 2)) (?v_0 (f16 f17 3)) (?v_3 (f10 f11 ?v1)) (?v_1 (f10 f11 ?v0))) (= (f9 (f10 f11 (- ?v0 ?v1)) ?v_0) (- (+ (- (f9 ?v_1 ?v_0) (f4 (f5 f6 (* 3 (f9 ?v_1 ?v_2))) ?v1)) (f4 (f5 f6 (* 3 ?v0)) (f9 ?v_3 ?v_2))) (f9 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int)) (= (= (f3 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f30 f31 (f32 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (= (f29 (f9 (f10 f11 ?v1) (f16 f17 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f22 ?v0) ?v1) (ite (= (f29 ?v0 0 ?v1) f1) 0 (ite (= (f23 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f29 (f9 (f10 f11 ?v2) (f16 f17 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f21 ?v0) f1) (=> (= (f28 ?v0 (f9 (f10 f11 ?v1) ?v2)) f1) (=> (< 0 (f9 f19 ?v2)) (= (f28 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f21 ?v1) f1) (=> (= (f28 ?v1 (f4 (f5 f6 ?v0) ?v2)) f1) (or (= (f28 ?v1 ?v0) f1) (= (f28 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 ?v0) f1) (=> (= (f28 ?v0 (f4 (f5 f6 ?v1) ?v2)) f1) (or (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f5 f6 ?v1))) (= (+ (f4 (f5 f6 (- ?v0 (f4 ?v_0 ?v2))) ?v3) (f4 (f5 f6 (- ?v4 (f4 ?v_0 ?v5))) ?v6)) (- (+ (f4 (f5 f6 ?v0) ?v3) (f4 (f5 f6 ?v4) ?v6)) (f4 ?v_0 (+ (f4 (f5 f6 ?v2) ?v3) (f4 (f5 f6 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 (- ?v2)) f1) (= (f29 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f29 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f29 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f29 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v1 (- 1) ?v0) f1) (not (= (f29 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v1 ?v3 ?v2) f1) (= (f29 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (f4 (f5 f6 ?v0) ?v3) (f4 (f5 f6 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 f6 ?v3))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f4 (f5 f6 ?v0) ?v3) (f4 (f5 f6 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 f6 ?v4))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f4 ?v_0 ?v0) ?v2) f1) (= (f29 ?v3 (f4 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f4 (f5 f6 ?v0) ?v4) ?v2) f1) (= (f29 ?v3 (f4 (f5 f6 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f29 (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 S5)) (= (f16 f17 (f9 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f19 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f9 f19 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
