(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 (Int Int) S1)
(declare-fun f7 () Int)
(declare-fun f8 () Int)
(declare-fun f9 (Int) S1)
(declare-fun f10 (S4 Int) Int)
(declare-fun f11 (S5 Int) S4)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 (Int Int) S1)
(declare-fun f15 () S3)
(declare-fun f16 (S6 Int) S3)
(declare-fun f17 () S6)
(declare-fun f18 () S5)
(declare-fun f19 (Int) S1)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 (S7 Int) S2)
(declare-fun f23 () S7)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 () Int)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(declare-fun f33 () Int)
(declare-fun f34 (S3 S3) S1)
(declare-fun f35 (S10 S3) S3)
(declare-fun f36 (S11 S3) S10)
(declare-fun f37 () S11)
(declare-fun f38 () S4)
(declare-fun f39 () S11)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (not (and (<= 0 ?v_0) (= (f6 ?v_0 (+ (* 4 f7) 1)) f1)))))
(assert (< 0 (+ 1 (f3 f4 f5))))
(assert (= (f6 (+ 1 (f3 f4 f5)) (+ (* 4 f7) 1)) f1))
(assert (< 1 f8))
(assert (< 0 (+ 1 (f3 f4 f5))))
(assert (< 0 (f3 f4 f5)))
(assert (= (f6 (+ 1 (f3 f4 f5)) (+ (* 4 f7) 1)) f1))
(assert (< 0 (+ (* 4 f7) 1)))
(assert (not (= (+ 1 (f3 f4 f5)) 0)))
(assert (= (f9 (+ (* 4 f7) 1)) f1))
(assert (= (f10 (f11 f12 (- 1)) (+ (* 4 f7) 1)) 1))
(assert (< f13 (+ 1 (f3 f4 f5))))
(assert (= (f14 (+ (* 4 f7) 1) (- 1)) f1))
(assert (= f15 (f16 f17 (- (f3 f4 (f16 f17 f8)) 1))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (let ((?v_1 (f11 f18 ?v_0))) (= (f6 (f10 ?v_1 ?v_0) (f10 ?v_1 (+ (* 4 f7) 1))) f1))))
(assert (< f8 (+ (* 4 f7) 1)))
(assert (let ((?v_1 (+ 1 (f3 f4 f5))) (?v_0 (+ (* 4 f7) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f19 (f10 (f11 f18 ?v_0) ?v_1)) f1))))))
(assert (not (= (f19 (f10 (f11 f18 (+ (* 4 f7) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (=> (not (= (f14 ?v_0 (- 1)) f1)) (not (= (f10 (f11 f12 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= (f6 ?v_0 f20) f1) (= (f6 ?v_0 f21) f1))))
(assert (let ((?v_1 (+ 1 (f3 f4 f5))) (?v_0 (+ (* 4 f7) 1))) (and (< ?v_1 ?v_0) (= (f19 (f10 (f11 f18 ?v_0) ?v_1)) f1))))
(assert (forall ((?v0 Int)) (= (f6 ?v0 (ite (< ?v0 0) (- ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int)) (= (f6 (ite (< ?v0 0) (- ?v0) ?v0) ?v0) f1)))
(assert (< 0 (f3 f4 f15)))
(assert (<= 1 f8))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f16 f17 (- (f3 f4 (f16 f17 f8)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (= (f19 (f10 (f11 f18 (+ (* 4 f7) 1)) f8)) f1))
(assert (= (f19 (f10 (f11 f18 (+ (* 4 f7) 1)) f13)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f21 (f10 (f11 f18 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f20 (f10 (f11 f18 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f16 f17 2))) (= (+ (f3 (f22 f23 f20) ?v_0) (f3 (f22 f23 f21) ?v_0)) (f10 (f11 f18 (+ (* 4 f7) 1)) (+ 1 (f3 f4 f5))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0) f1) (=> (= (f19 ?v1) f1) (= (f19 (f10 (f11 f18 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f9 ?v_0) f1) (= (f10 (f11 f12 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f24 (- f21 (f10 (f11 f18 f25) ?v_0))) (<= (ite (< f24 0) (* (- 2) f24) (* 2 f24)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f26 (- f20 (f10 (f11 f18 f27) ?v_0))) (<= (ite (< f26 0) (* (- 2) f26) (* 2 f26)) ?v_0))))
(assert (let ((?v_0 (f16 f17 2))) (let ((?v_1 (f3 (f22 f23 (+ 1 (f3 f4 f5))) ?v_0))) (and (= (f6 ?v_1 (f3 (f22 f23 f20) ?v_0)) f1) (= (f6 ?v_1 (f3 (f22 f23 f21) ?v_0)) f1)))))
(assert (let ((?v_0 (f16 f17 2))) (= (f6 (f3 (f22 f23 (+ 1 (f3 f4 f5))) ?v_0) (+ (f3 (f22 f23 f20) ?v_0) (f3 (f22 f23 f21) ?v_0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (= (f6 ?v0 (f10 (f11 f18 ?v1) ?v2)) f1) (or (= (f6 ?v0 ?v1) f1) (= (f6 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f9 ?v1) f1) (=> (= (f6 ?v1 (f10 (f11 f18 ?v0) ?v2)) f1) (or (= (f6 ?v1 ?v0) f1) (= (f6 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (= (= (f9 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f6 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f18 ?v0))) (=> (= (f6 (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f6 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f6 ?v0 ?v1) f1) (= (= (f6 ?v0 (+ ?v2 ?v3)) f1) (= (f6 ?v0 (+ (+ ?v2 (f10 (f11 f18 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f18 ?v0))) (=> (not (= ?v0 0)) (= (= (f6 ?v1 ?v2) f1) (= (f6 (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) f1))))))
(assert (let ((?v_0 (f16 f17 2))) (= (+ (f3 (f22 f23 f26) ?v_0) (f3 (f22 f23 f24) ?v_0)) 0)))
(assert (and (= f26 0) (= f24 0)))
(assert (let ((?v_0 (f16 f17 2))) (=> (not (= f24 0)) (< 0 (+ (f3 (f22 f23 f26) ?v_0) (f3 (f22 f23 f24) ?v_0))))))
(assert (let ((?v_0 (f16 f17 2))) (=> (not (= f26 0)) (< 0 (+ (f3 (f22 f23 f26) ?v_0) (f3 (f22 f23 f24) ?v_0))))))
(assert (let ((?v_0 (f16 f17 2))) (= (+ (f3 (f22 f23 f26) ?v_0) (f3 (f22 f23 f24) ?v_0)) (f10 (f11 f18 (+ 1 (f3 f4 f5))) f13))))
(assert (let ((?v_0 (f16 f17 2))) (= (f6 (+ 1 (f3 f4 f5)) (+ (f3 (f22 f23 f26) ?v_0) (f3 (f22 f23 f24) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (=> (= (+ (f3 (f22 f23 ?v0) ?v_0) (f3 (f22 f23 ?v1) ?v_0)) (f10 (f11 f18 (+ (* 4 f7) 1)) (+ 1 (f3 f4 f5)))) false))) false))
(assert (= (+ (f3 (f22 f23 f28) (f16 f17 2)) 1) (f10 (f11 f18 (+ (* 4 f7) 1)) f8)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f16 f17 2))) (=> (= (+ (f3 (f22 f23 f26) ?v_0) (f3 (f22 f23 f24) ?v_0)) (f10 (f11 f18 (+ 1 (f3 f4 f5))) ?v0)) false))) false))
(assert (let ((?v_2 (f16 f17 2)) (?v_1 (f11 f18 f25)) (?v_0 (f11 f18 f27))) (= (+ (f3 (f22 f23 (+ (+ (f10 ?v_0 f26) (f10 ?v_1 f24)) f13)) ?v_2) (f3 (f22 f23 (- (f10 ?v_0 f24) (f10 ?v_1 f26))) ?v_2)) (f10 (f11 f18 (+ (* 4 f7) 1)) f13))))
(assert (=> (= f8 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (+ (f3 (f22 f23 ?v0) ?v_0) (f3 (f22 f23 ?v1) ?v_0)) (+ (* 4 f7) 1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f16 f17 0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f16 f17 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f10 (f11 f18 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f6 ?v1 ?v2) f1) (= (f6 ?v1 (f3 (f22 f23 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f9 ?v0) f1) (=> (= (f6 ?v0 (f3 (f22 f23 ?v1) ?v2)) f1) (=> (< 0 (f3 f4 ?v2)) (= (f6 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f11 f18 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f11 f18 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f4 ?v2))) (let ((?v_1 (f11 f18 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f10 ?v_1 ?v0) (f10 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f18 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f10 (f11 f18 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f10 (f11 f18 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f10 (f11 f18 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f11 f18 ?v1))) (= (+ (f10 (f11 f18 (- ?v0 (f10 ?v_0 ?v2))) ?v3) (f10 (f11 f18 (- ?v4 (f10 ?v_0 ?v5))) ?v6)) (- (+ (f10 (f11 f18 ?v0) ?v3) (f10 (f11 f18 ?v4) ?v6)) (f10 ?v_0 (+ (f10 (f11 f18 ?v2) ?v3) (f10 (f11 f18 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f18 (- ?v0 ?v1)) ?v2) (- (f10 (f11 f18 ?v0) ?v2) (f10 (f11 f18 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f18 (+ ?v0 ?v1)) ?v2) (+ (f10 (f11 f18 ?v0) ?v2) (f10 (f11 f18 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f18 ?v0))) (= (f10 (f11 f18 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f18 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f11 f18 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f18 (- ?v0)) ?v1) (- (f10 (f11 f18 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f18 ?v0))) (= (f10 ?v_0 (- ?v1 ?v2)) (- (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f18 ?v0))) (= (f10 ?v_0 (+ ?v1 ?v2)) (+ (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f18 ?v0) ?v1) (f10 (f11 f18 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (= (f6 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f6 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f6 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0 (- ?v1 ?v2)) f1) (=> (= (f6 ?v0 ?v2) f1) (= (f6 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 ?v0 ?v1) f1) (= (f6 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 ?v0 ?v1) f1) (= (f6 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f6 ?v0 (+ ?v1 (f10 (f11 f18 ?v0) ?v2))) f1) (= (f6 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f6 (f10 (f11 f18 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (= (f6 (+ (* 4 f7) 1) (+ (f3 (f22 f23 f28) (f16 f17 2)) 1)) f1))
(assert (= (f6 (+ (* 4 f7) 1) (- (f3 (f22 f23 f28) (f16 f17 2)) (- 1))) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f22 f23 ?v0) ?v2))) (=> (= (f9 ?v0) f1) (=> (not (= (f6 ?v0 ?v1) f1)) (=> (= (f6 ?v_0 (f10 (f11 f18 ?v3) ?v1)) f1) (= (f6 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f22 f23 ?v0) ?v2))) (=> (= (f9 ?v0) f1) (=> (not (= (f6 ?v0 ?v1) f1)) (=> (= (f6 ?v_0 (f10 (f11 f18 ?v1) ?v3)) f1) (= (f6 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f9 ?v0) f1) (=> (= (f6 ?v0 (f3 (f22 f23 ?v1) ?v2)) f1) (= (f6 ?v0 ?v1) f1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f22 f23 f28) (f16 f17 2)) 1) (f10 (f11 f18 (+ (* 4 f7) 1)) ?v0)) false)) false))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f16 f17 0))) (= (= (f6 (f3 (f22 f23 ?v1) ?v0) (f3 (f22 f23 ?v2) ?v0)) f1) (= (f6 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f6 (f3 (f22 f23 ?v0) ?v1) (f3 (f22 f23 ?v2) ?v1)) f1) (=> (not (= ?v1 (f16 f17 0))) (= (f6 ?v0 ?v2) f1)))))
(assert (let ((?v_0 (f3 (f22 f23 f28) (f16 f17 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f10 (f11 f18 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f22 f23 ?v0) (f16 f17 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f16 f17 2))) (let ((?v_0 (f3 (f22 f23 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f16 f17 3))) (let ((?v_0 (f3 (f22 f23 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 3))) (= (f3 (f22 f23 (- ?v0)) ?v_0) (- (f3 (f22 f23 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 2)) (?v_1 (f22 f23 ?v0))) (= (f3 (f22 f23 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f16 f17 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (= (f3 (f22 f23 ?v0) ?v_0) (f3 (f22 f23 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f22 f23 ?v0) (f16 f17 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f9 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f10 (f11 f18 ?v0) (f3 ?v_0 (f16 f17 2))) (f3 ?v_0 (f16 f17 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f3 (f22 f23 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f22 f23 ?v0) ?v_0) (f10 (f11 f18 (* 2 ?v0)) ?v1)) (f3 (f22 f23 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f3 (f22 f23 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f22 f23 ?v0) ?v_0) (f10 (f11 f18 (* 2 ?v0)) ?v1)) (f3 (f22 f23 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f16 f17 2)) (?v_0 (f16 f17 3)) (?v_1 (f22 f23 ?v0)) (?v_3 (f22 f23 ?v1))) (= (f3 (f22 f23 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f10 (f11 f18 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f10 (f11 f18 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f16 f17 2)) (?v_0 (f16 f17 3)) (?v_3 (f22 f23 ?v1)) (?v_1 (f22 f23 ?v0))) (= (f3 (f22 f23 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f10 (f11 f18 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f10 (f11 f18 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f10 (f11 f18 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f22 f23 ?v0) ?v_0) (f3 (f22 f23 ?v1) ?v_0))))))
(assert (= (f29 (f3 (f22 f23 f28) (f16 f17 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f9 ?v1) f1) (= (f6 ?v1 ?v0) f1))))))
(assert (= (f30 f31 (f32 f28 1)) (f10 (f11 f18 (+ (* 4 f7) 1)) f8)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (and (<= 0 f28) (and (< f28 ?v_0) (= (f29 f33 f28 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f22 f23 ?v1)) (?v_1 (f16 f17 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f10 (f11 f18 ?v1) (f3 ?v_0 (f16 f17 (- (f3 f4 ?v_1) 1)))))))))
(assert (= (f29 (f3 (f22 f23 f33) (f16 f17 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f3 (f22 f23 ?v0) (f16 f17 2)) (- 1) (+ (* 4 f7) 1)) f1) false)) false))
(assert (let ((?v_0 (f16 f17 2))) (= (f29 (f3 (f22 f23 f28) ?v_0) (f3 (f22 f23 f33) ?v_0) (+ (* 4 f7) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f33 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f18 ?v0)) (?v_1 (f11 f18 ?v1))) (= (f10 (f11 f18 (f30 f31 (f32 ?v0 ?v1))) (f30 f31 (f32 ?v2 ?v3))) (f30 f31 (f32 (+ (f10 ?v_0 ?v2) (f10 ?v_1 ?v3)) (- (f10 ?v_0 ?v3) (f10 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f10 (f11 f18 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f29 (f10 (f11 f18 ?v0) ?v1) (f10 (f11 f18 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f10 (f11 f18 ?v0) ?v4) ?v2) f1) (= (f29 ?v3 (f10 (f11 f18 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f11 f18 ?v4))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f10 ?v_0 ?v0) ?v2) f1) (= (f29 ?v3 (f10 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f10 (f11 f18 ?v0) ?v3) (f10 (f11 f18 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f18 ?v3))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f10 ?v_0 ?v0) (f10 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (f10 (f11 f18 ?v0) ?v3) (f10 (f11 f18 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 (- ?v2)) f1) (= (f29 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f29 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f29 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f29 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v1 (- 1) ?v0) f1) (not (= (f29 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v1 ?v3 ?v2) f1) (= (f29 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f6 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f6 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f6 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f3 (f22 f23 ?v0) ?v3) (f3 (f22 f23 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f29 ?v0 0 ?v1) f1)) (=> (= (f29 (f3 (f22 f23 ?v2) (f16 f17 2)) ?v0 ?v1) f1) (not (= (f6 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (= (f29 (f10 (f11 f18 ?v1) ?v1) 1 ?v0) f1) (or (= (f29 ?v1 1 ?v0) f1) (= (f29 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (= (f29 (f10 (f11 f18 ?v1) ?v2) 0 ?v0) f1) (or (= (f29 ?v1 0 ?v0) f1) (= (f29 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f29 ?v1 0 ?v0) f1)) (not (= (f29 ?v2 0 ?v0) f1))) (not (= (f29 (f10 (f11 f18 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f29 (f10 (f11 f18 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (not (= (f29 ?v1 0 ?v0) f1)) (=> (not (= (f29 ?v2 0 ?v0) f1)) (not (= (f29 (f10 (f11 f18 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int)) (= (= (f19 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f30 f31 (f32 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (not (= (f6 ?v0 ?v1) f1)) (= (f29 (f3 (f22 f23 ?v1) (f16 f17 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 ?v0) ?v1) (ite (= (f29 ?v0 0 ?v1) f1) 0 (ite (= (f14 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f29 (f3 (f22 f23 ?v2) (f16 f17 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f29 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f29 (f10 (f11 f18 ?v0) ?v_0) 1 ?v1) f1) (= (f29 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f6 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f6 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f34 (f35 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f34 (f35 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f34 (f16 f17 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f6 ?v0 (f3 f4 ?v1)) f1) (= ?v1 (f16 f17 0))))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f6 (f3 f4 ?v0) ?v1) f1) (= (f34 ?v0 (f16 f17 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f6 ?v0 (f3 f4 ?v1)) f1) (= (f34 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f34 ?v0 ?v1) f1) (= (f6 (f3 f4 ?v0) (f3 f4 ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f35 (f36 f37 ?v0) ?v1)) (f3 (f22 f23 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f22 f23 (f3 f4 ?v0)) ?v1) (f3 f4 (f35 (f36 f37 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f16 f17 (f3 (f22 f23 ?v0) ?v1)) (f35 (f36 f37 (f16 f17 ?v0)) ?v1)))))
(assert (forall ((?v0 Int)) (= (f3 (f22 f23 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f35 (f36 f37 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f10 f38 (f3 (f22 f23 ?v0) ?v1)) (f3 (f22 f23 (f10 f38 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f29 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f22 f23 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f22 f23 (f10 (f11 f18 ?v0) ?v1)) ?v2) (f10 (f11 f18 (f3 (f22 f23 ?v0) ?v2)) (f3 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f35 (f36 f37 (f35 (f36 f39 ?v0) ?v1)) ?v2) (f35 (f36 f39 (f35 (f36 f37 ?v0) ?v2)) (f35 (f36 f37 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f3 (f22 f23 ?v0) ?v1))) (= (f10 (f11 f18 ?v_0) ?v0) (f10 (f11 f18 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 (f36 f37 ?v0) ?v1))) (= (f35 (f36 f39 ?v_0) ?v0) (f35 (f36 f39 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f16 f17 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f10 (f11 f18 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f16 f17 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f35 (f36 f39 (f35 ?v_0 ?v1)) (f35 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f16 f17 (+ (f3 f4 ?v1) 1))) (f10 (f11 f18 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f16 f17 (+ (f3 f4 ?v1) 1))) (f35 (f36 f39 (f35 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f16 f17 (+ (f3 f4 ?v1) 1))) (f10 (f11 f18 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f16 f17 (+ (f3 f4 ?v1) 1))) (f35 (f36 f39 ?v0) (f35 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f6 ?v0 ?v1) f1) (= (f6 (f3 (f22 f23 ?v0) ?v2) (f3 (f22 f23 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f22 f23 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f6 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f34 (f35 ?v_0 ?v0) (f35 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f6 ?v0 ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f6 (f3 (f22 f23 ?v0) ?v2) (f3 (f22 f23 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f34 ?v0 ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f34 (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 ?v0 (f10 (f11 f18 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f34 ?v0 (f35 (f36 f39 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 ?v0 (f10 (f11 f18 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f34 ?v0 (f35 (f36 f39 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0 ?v1) f1) (= (f6 ?v0 (f10 (f11 f18 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 ?v0 (f35 (f36 f39 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f16 f17 0))) (= (= (f34 (f35 (f36 f37 ?v1) ?v0) (f35 (f36 f37 ?v2) ?v0)) f1) (= (f34 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f16 f17 0))) (not (and (= (f34 ?v_0 ?v0) f1) (not (= (f34 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f16 f17 1))) (not (and (= (f34 ?v0 ?v_0) f1) (not (= (f34 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S3)) (= (f34 (f16 f17 1) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f34 ?v0 (f16 f17 0)) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f16 f17 1))) (= (not (= ?v0 ?v_0)) (and (= (f34 ?v_0 ?v0) f1) (not (= (f34 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f16 f17 0))) (= (not (= ?v0 ?v_0)) (and (= (f34 ?v0 ?v_0) f1) (not (= (f34 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f16 f17 0))) (= (= (f34 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f16 f17 1))) (= (= (f34 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f16 f17 0))) (=> (= (f34 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f34 ?v1 ?v0) f1) (< 0 (f3 f4 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f16 f17 1))) (=> (= (f34 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f34 ?v0 ?v1) f1) (or (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= ?v1 (f16 f17 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f4 (f35 (f36 f37 ?v0) ?v1))) (or (< 0 (f3 f4 ?v0)) (= ?v1 (f16 f17 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f16 f17 (+ 0 1)))) (= (f35 (f36 f37 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 (+ 0 1)))) (= (= (f35 (f36 f37 ?v0) ?v1) ?v_0) (or (= ?v1 (f16 f17 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (=> (< 0 (f3 f4 ?v0)) (=> (< (f3 f4 (f35 ?v_0 ?v1)) (f3 f4 (f35 ?v_0 ?v2))) (< (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f4 ?v0)) (<= ?v_0 (f3 f4 (f35 (f36 f37 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f34 (f35 ?v_0 ?v1) (f35 ?v_0 ?v2)) f1) (=> (< 1 (f3 f4 ?v0)) (<= (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f16 f17 (f10 (f11 f18 (f3 f4 ?v1)) (f3 f4 ?v2)))) (f3 (f22 f23 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f16 f17 (f10 (f11 f18 (f3 f4 ?v1)) (f3 f4 ?v2)))) (f35 (f36 f37 (f35 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 (f22 f23 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f16 f17 (f10 (f11 f18 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f16 f17 (f10 (f11 f18 ?v0) ?v1)) (f16 f17 (f10 (f11 f18 (f3 f4 (f16 f17 (- ?v0)))) (f3 f4 (f16 f17 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f10 (f11 f18 ?v0) ?v1)) (f16 f17 (f10 (f11 f18 (f3 f4 (f16 f17 ?v0))) (f3 f4 (f16 f17 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f10 (f11 f18 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f10 (f11 f18 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f11 f18 ?v0) ?v1))) (= (f16 f17 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f16 f17 (f10 (f11 f18 (f3 f4 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)))) (f3 f4 (f16 f17 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f29 (f3 ?v_0 ?v1) 1 ?v2) f1) (= (f29 (f3 ?v_0 (f16 f17 (f10 (f11 f18 (f3 f4 ?v1)) (f3 f4 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 f38 (f10 (f11 f18 ?v0) ?v1)) (f10 (f11 f18 (f10 f38 ?v0)) (f10 f38 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f38 ?v0))) (= (f10 (f11 f18 ?v_0) ?v_0) (f10 (f11 f18 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 f38 ?v0) (f10 f38 ?v1)) (= (f6 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 ?v1 ?v2) f1) (= (f6 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 ?v0 ?v1) f1) (=> (= (f34 ?v1 ?v2) f1) (= (f34 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 (f10 f38 ?v0) ?v1) f1) (= (f6 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 ?v0 (f10 f38 ?v1)) f1) (= (f6 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int)) (= (f6 ?v0 ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f34 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 (f10 (f11 f18 ?v0) ?v1) ?v2) f1) (= (f6 ?v1 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 (f35 (f36 f39 ?v0) ?v1) ?v2) f1) (= (f34 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 (f10 (f11 f18 ?v0) ?v1) ?v2) f1) (= (f6 ?v0 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 (f35 (f36 f39 ?v0) ?v1) ?v2) f1) (= (f34 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f10 (f11 f18 ?v1) ?v2)) (= (f6 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 (f35 (f36 f39 ?v1) ?v2)) (= (f34 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 ?v2 ?v3) f1) (= (f6 (f10 (f11 f18 ?v0) ?v2) (f10 (f11 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f34 ?v0 ?v1) f1) (=> (= (f34 ?v2 ?v3) f1) (= (f34 (f35 (f36 f39 ?v0) ?v2) (f35 (f36 f39 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0 ?v1) f1) (= (f6 ?v0 (f10 (f11 f18 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 ?v0 (f35 (f36 f39 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S3)) (= (f34 (f16 f17 (+ 0 1)) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f34 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f4 (f16 f17 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f16 f17 (f10 (f11 f18 ?v_0) ?v_0)) (f16 f17 (+ (f10 (f11 f18 (f3 f4 (f16 f17 (- ?v0 1)))) (f3 f4 (f16 f17 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_2 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f10 (f11 f18 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f10 (f11 f18 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f10 (f11 f18 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 (f16 f17 (f10 (f11 f18 (f3 f4 ?v0)) (f3 f4 ?v1)))) (or (= ?v1 (f16 f17 1)) (= ?v0 (f16 f17 0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_3 (f3 f4 ?v3)) (?v_1 (f3 f4 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f10 (f11 f18 ?v_0) ?v_1) (f10 (f11 f18 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_3 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0)) (?v_0 (f3 f4 ?v2))) (let ((?v_2 (f11 f18 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f10 ?v_2 ?v_1) (f10 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f10 (f11 f18 ?v_0) ?v_1) (f10 (f11 f18 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_1 (f11 f18 (f3 f4 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f10 ?v_1 ?v_0) (f10 ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f10 (f11 f18 ?v_0) ?v_2) (f10 (f11 f18 ?v_1) ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f18 (+ (f3 f4 ?v0) 1))) (?v_2 (f3 f4 ?v2)) (?v_1 (f3 f4 ?v1))) (= (<= (f10 ?v_0 ?v_1) (f10 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f18 (+ (f3 f4 ?v0) 1))) (?v_2 (f3 f4 ?v2)) (?v_1 (f3 f4 ?v1))) (= (< (f10 ?v_0 ?v_1) (f10 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f18 (+ (f3 f4 ?v0) 1)))) (= (= (f16 f17 (f10 ?v_0 (f3 f4 ?v1))) (f16 f17 (f10 ?v_0 (f3 f4 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v1))) (= (= (f16 f17 (f10 (f11 f18 (f3 f4 ?v0)) ?v_0)) (f16 f17 (f10 (f11 f18 (f3 f4 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f16 f17 0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f18 (f3 f4 ?v0)))) (= (= (f16 f17 (f10 ?v_0 (f3 f4 ?v1))) (f16 f17 (f10 ?v_0 (f3 f4 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f16 f17 0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v2)) (?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0))) (= (<= (f10 (f11 f18 ?v_1) ?v_0) (f10 (f11 f18 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f3 f4 ?v0))) (let ((?v_0 (f11 f18 ?v_1)) (?v_3 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (= (<= (f10 ?v_0 ?v_2) (f10 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v2)) (?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0))) (= (< (f10 (f11 f18 ?v_1) ?v_0) (f10 (f11 f18 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f3 f4 ?v0))) (let ((?v_0 (f11 f18 ?v_1)) (?v_3 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (= (< (f10 ?v_0 ?v_2) (f10 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 (+ 0 1)))) (= (= (f16 f17 (f10 (f11 f18 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v2))) (= (f16 f17 (f10 (f11 f18 (f3 f4 (f16 f17 (- ?v_0 ?v_2)))) ?v_1)) (f16 f17 (- (f10 (f11 f18 ?v_0) ?v_1) (f10 (f11 f18 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v2))) (= (f16 f17 (f10 (f11 f18 (+ ?v_0 ?v_2)) ?v_1)) (f16 f17 (+ (f10 (f11 f18 ?v_0) ?v_1) (f10 (f11 f18 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f18 (f3 f4 ?v0))) (?v_1 (f3 f4 ?v1)) (?v_2 (f3 f4 ?v2))) (= (f16 f17 (f10 (f11 f18 (f10 ?v_0 ?v_1)) ?v_2)) (f16 f17 (f10 ?v_0 (f10 (f11 f18 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 0))) (= (= (f16 f17 (f10 (f11 f18 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 1))) (= (= (f16 f17 (f10 (f11 f18 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3)) (= (f16 f17 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
