(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S2) Int)
(declare-fun f7 () S4)
(declare-fun f8 () Int)
(declare-fun f9 (Int) S1)
(declare-fun f10 (S5 Int) Int)
(declare-fun f11 (S6 Int) S5)
(declare-fun f12 () S6)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () S2)
(declare-fun f16 (Int) S1)
(declare-fun f17 () S6)
(declare-fun f18 (Int Int) S1)
(declare-fun f19 () S2)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 (S7 Int) S4)
(declare-fun f23 () S7)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 () Int)
(declare-fun f29 (Int Int) S1)
(declare-fun f30 (Int Int Int) S1)
(declare-fun f31 (S8 S9) Int)
(declare-fun f32 () S8)
(declare-fun f33 (Int Int) S9)
(declare-fun f34 () Int)
(declare-fun f35 (S10 S2) S11)
(declare-fun f36 () S10)
(declare-fun f37 (S11 S2) S2)
(declare-fun f38 () S10)
(declare-fun f39 () S5)
(declare-fun f40 (S2 S2) S1)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 S2)) (=> (and (= ?v0 (f4 f5 (- (f6 f7 (f4 f5 f8)) 1))) (= (f9 (f10 (f11 f12 (+ (* 4 f13) 1)) (+ 1 (f6 f7 ?v0)))) f1)) (= f3 f1))))
(assert (= (f9 (f10 (f11 f12 (+ (* 4 f13) 1)) (+ 1 (f6 f7 (f4 f5 (- (f6 f7 (f4 f5 f8)) 1)))))) f1))
(assert (< 1 f14))
(assert (< 0 (f6 f7 f15)))
(assert (< 0 (+ (* 4 f13) 1)))
(assert (not (= (f9 (f10 (f11 f12 (+ (* 4 f13) 1)) (+ 1 0))) f1)))
(assert (= (f9 (f10 (f11 f12 (+ (* 4 f13) 1)) (+ 1 (f6 f7 (f4 f5 (- (f6 f7 (f4 f5 f8)) 1)))))) f1))
(assert (< 0 f8))
(assert (= (+ 1 (f6 f7 (f4 f5 (- (f6 f7 (f4 f5 f8)) 1)))) f8))
(assert (= (f9 (f10 (f11 f12 (+ (* 4 f13) 1)) f8)) f1))
(assert (= (f16 (+ (* 4 f13) 1)) f1))
(assert (= (f10 (f11 f17 (- 1)) (+ (* 4 f13) 1)) 1))
(assert (let ((?v_0 (+ (* 4 f13) 1)) (?v_1 (+ 1 (f6 f7 f15)))) (not (=> (< ?v_1 ?v_0) (not (= (f9 (f10 (f11 f12 ?v_0) ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (= (f9 ?v1) f1) (= (f9 (f10 (f11 f12 ?v0) ?v1)) f1)))))
(assert (= (f18 (+ (* 4 f13) 1) (- 1)) f1))
(assert (= f19 (f4 f5 (- (f6 f7 (f4 f5 f14)) 1))))
(assert (= (f9 (f10 (f11 f12 (+ (* 4 f13) 1)) f14)) f1))
(assert (< f14 (+ (* 4 f13) 1)))
(assert (let ((?v_0 (+ (* 4 f13) 1)) (?v_1 (+ 1 (f6 f7 f15)))) (and (< ?v_1 ?v_0) (= (f9 (f10 (f11 f12 ?v_0) ?v_1)) f1))))
(assert (< f8 (+ 1 (f6 f7 f15))))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (=> (not (= (f18 ?v_0 (- 1)) f1)) (not (= (f10 (f11 f17 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 ?v0) ?v1) (f10 (f11 f12 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (+ ?v1 ?v2)) (+ (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (- ?v1 ?v2)) (- (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 (- ?v0)) ?v1) (- (f10 (f11 f12 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f11 f12 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (< 0 (f6 f7 f19)))
(assert (< 0 (+ 1 (f6 f7 f15))))
(assert (<= 1 f14))
(assert (=> (forall ((?v0 S2)) (=> (= ?v0 (f4 f5 (- (f6 f7 (f4 f5 f14)) 1))) (=> (< 0 (f6 f7 ?v0)) false))) false))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f16 ?v_0) f1) (= (f10 (f11 f17 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f11 f12 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f11 f12 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f6 f7 ?v2))) (let ((?v_1 (f11 f12 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f10 ?v_1 ?v0) (f10 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f10 (f11 f12 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f12 (- ?v0 ?v1)) ?v2) (- (f10 (f11 f12 ?v0) ?v2) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f12 (+ ?v0 ?v1)) ?v2) (+ (f10 (f11 f12 ?v0) ?v2) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f15)))) (=> (and (= ?v1 (- f20 (f10 (f11 f12 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f15)))) (=> (and (= ?v1 (- f21 (f10 (f11 f12 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (=> (= (+ (f6 (f22 f23 ?v0) ?v_0) (f6 (f22 f23 ?v1) ?v_0)) (f10 (f11 f12 (+ (* 4 f13) 1)) (+ 1 (f6 f7 f15)))) false))) false))
(assert (= (+ (f6 (f22 f23 f24) (f4 f5 2)) 1) (f10 (f11 f12 (+ (* 4 f13) 1)) f14)))
(assert (let ((?v_0 (+ 1 (f6 f7 f15)))) (and (= f25 (- f20 (f10 (f11 f12 f26) ?v_0))) (<= (ite (< f25 0) (* (- 2) f25) (* 2 f25)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f6 f7 f15)))) (and (= f27 (- f21 (f10 (f11 f12 f28) ?v_0))) (<= (ite (< f27 0) (* (- 2) f27) (* 2 f27)) ?v_0))))
(assert (let ((?v_0 (f4 f5 2))) (= (+ (f6 (f22 f23 f21) ?v_0) (f6 (f22 f23 f20) ?v_0)) (f10 (f11 f12 (+ (* 4 f13) 1)) (+ 1 (f6 f7 f15))))))
(assert (=> (= f14 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (+ (f6 (f22 f23 ?v0) ?v_0) (f6 (f22 f23 ?v1) ?v_0)) (+ (* 4 f13) 1))))))
(assert (let ((?v_0 (f4 f5 2))) (= (+ (f6 (f22 f23 f27) ?v_0) (f6 (f22 f23 f25) ?v_0)) (f10 (f11 f12 (+ 1 (f6 f7 f15))) f8))))
(assert (= (f16 2) f1))
(assert (let ((?v_0 (f6 (f22 f23 f24) (f4 f5 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f22 f23 f24) (f4 f5 2)) 1) (f10 (f11 f12 (+ (* 4 f13) 1)) ?v0)) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f4 f5 2))) (=> (= (+ (f6 (f22 f23 f27) ?v_0) (f6 (f22 f23 f25) ?v_0)) (f10 (f11 f12 (+ 1 (f6 f7 f15))) ?v0)) false))) false))
(assert (let ((?v_2 (f4 f5 2)) (?v_1 (f11 f12 f26)) (?v_0 (f11 f12 f28))) (= (+ (f6 (f22 f23 (+ (+ (f10 ?v_0 f27) (f10 ?v_1 f25)) f8)) ?v_2) (f6 (f22 f23 (- (f10 ?v_0 f25) (f10 ?v_1 f27))) ?v_2)) (f10 (f11 f12 (+ (* 4 f13) 1)) f8))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f6 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f6 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f4 f5 0))))))
(assert (forall ((?v0 Int)) (=> (= (f6 (f22 f23 ?v0) (f4 f5 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (= (f6 (f22 f23 ?v0) ?v_0) (f6 (f22 f23 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 2)) (?v_1 (f22 f23 ?v0))) (= (f6 (f22 f23 (f6 ?v_1 ?v_0)) ?v_0) (f6 ?v_1 (f4 f5 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 3))) (= (f6 (f22 f23 (- ?v0)) ?v_0) (- (f6 (f22 f23 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f4 f5 3))) (let ((?v_0 (f6 (f22 f23 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f4 f5 2))) (let ((?v_0 (f6 (f22 f23 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 (f22 f23 ?v0) (f4 f5 2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f10 (f11 f12 ?v0) (f6 ?v_0 (f4 f5 2))) (f6 ?v_0 (f4 f5 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (f6 (f22 f23 (+ ?v0 ?v1)) ?v_0) (+ (+ (f6 (f22 f23 ?v0) ?v_0) (f10 (f11 f12 (* 2 ?v0)) ?v1)) (f6 (f22 f23 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (f6 (f22 f23 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f22 f23 ?v0) ?v_0) (f10 (f11 f12 (* 2 ?v0)) ?v1)) (f6 (f22 f23 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f4 f5 2)) (?v_0 (f4 f5 3)) (?v_1 (f22 f23 ?v0)) (?v_3 (f22 f23 ?v1))) (= (f6 (f22 f23 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f6 ?v_1 ?v_0) (f10 (f11 f12 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f10 (f11 f12 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f4 f5 2)) (?v_0 (f4 f5 3)) (?v_3 (f22 f23 ?v1)) (?v_1 (f22 f23 ?v0))) (= (f6 (f22 f23 (- ?v0 ?v1)) ?v_0) (- (+ (- (f6 ?v_1 ?v_0) (f10 (f11 f12 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f10 (f11 f12 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (f10 (f11 f12 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f6 (f22 f23 ?v0) ?v_0) (f6 (f22 f23 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f6 ?v_0 (f4 f5 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (f10 (f11 f12 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f10 (f11 f12 ?v0) ?v1)) (< 0 ?v1)))))
(assert (let ((?v_0 (f4 f5 2))) (= (f29 (+ 1 (f6 f7 f15)) (+ (f6 (f22 f23 f27) ?v_0) (f6 (f22 f23 f25) ?v_0))) f1)))
(assert (= (f29 (+ (* 4 f13) 1) (+ (f6 (f22 f23 f24) (f4 f5 2)) 1)) f1))
(assert (= (f29 (+ (* 4 f13) 1) (- (f6 (f22 f23 f24) (f4 f5 2)) (- 1))) f1))
(assert (= (f30 (f6 (f22 f23 f24) (f4 f5 2)) (- 1) (+ (* 4 f13) 1)) f1))
(assert (= (f31 f32 (f33 f24 1)) (f10 (f11 f12 (+ (* 4 f13) 1)) f14)))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (and (<= 0 f24) (and (< f24 ?v_0) (= (f30 f34 f24 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f22 f23 ?v1)) (?v_1 (f4 f5 ?v0))) (=> (< 0 ?v0) (= (f6 ?v_0 ?v_1) (f10 (f11 f12 ?v1) (f6 ?v_0 (f4 f5 (- (f6 f7 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (= (f10 (f11 f12 ?v0) ?v0) (f6 (f22 f23 ?v0) (f4 f5 2)))))
(assert (forall ((?v0 S2)) (= (f37 (f35 f36 ?v0) ?v0) (f37 (f35 f38 ?v0) (f4 f5 2)))))
(assert (= (f30 (f6 (f22 f23 f34) (f4 f5 2)) (- 1) (+ (* 4 f13) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f30 (f6 (f22 f23 ?v0) (f4 f5 2)) (- 1) (+ (* 4 f13) 1)) f1) false)) false))
(assert (let ((?v_0 (f4 f5 2))) (= (f30 (f6 (f22 f23 f24) ?v_0) (f6 (f22 f23 f34) ?v_0) (+ (* 4 f13) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f30 f34 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f30 f34 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f30 f34 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f30 ?v0 0 ?v1) f1)) (=> (= (f30 (f6 (f22 f23 ?v2) (f4 f5 2)) ?v0 ?v1) f1) (not (= (f29 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f6 (f22 f23 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f4 f5 (f10 (f11 f12 (f6 f7 ?v1)) (f6 f7 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 (f35 f38 (f37 ?v_0 ?v1)) ?v2) (f37 ?v_0 (f4 f5 (f10 (f11 f12 (f6 f7 ?v1)) (f6 f7 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0 (- ?v1 ?v2)) f1) (=> (= (f29 ?v0 ?v2) f1) (= (f29 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f29 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f29 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f10 (f11 f12 (f31 f32 (f33 ?v0 ?v1))) (f31 f32 (f33 ?v2 ?v3))) (f31 f32 (f33 (+ (f10 ?v_0 ?v2) (f10 ?v_1 ?v3)) (- (f10 ?v_0 ?v3) (f10 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (=> (= (f29 (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f29 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1) f1) (= (= (f29 ?v0 (+ ?v2 ?v3)) f1) (= (f29 ?v0 (+ (+ ?v2 (f10 (f11 f12 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f29 (f10 (f11 f12 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 (+ ?v1 (f10 (f11 f12 ?v0) ?v2))) f1) (= (f29 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f4 f5 (f6 (f22 f23 ?v0) ?v1)) (f37 (f35 f38 (f4 f5 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f6 (f22 f23 (f6 f7 ?v0)) ?v1) (f6 f7 (f37 (f35 f38 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f6 f7 (f37 (f35 f38 ?v0) ?v1)) (f6 (f22 f23 (f6 f7 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f4 f5 (f10 (f11 f12 ?v0) ?v1)) (f4 f5 (f10 (f11 f12 (f6 f7 (f4 f5 (- ?v0)))) (f6 f7 (f4 f5 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f4 f5 (f10 (f11 f12 ?v0) ?v1)) (f4 f5 (f10 (f11 f12 (f6 f7 (f4 f5 ?v0))) (f6 f7 (f4 f5 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 (f11 f12 (f6 f7 ?v0)) (f6 f7 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 (f11 f12 (f6 f7 ?v0)) (f6 f7 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f11 f12 ?v0) ?v1))) (= (f4 f5 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f4 f5 (f10 (f11 f12 (f6 f7 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)))) (f6 f7 (f4 f5 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f6 (f22 f23 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f4 f5 (f10 (f11 f12 (f6 f7 ?v1)) (f6 f7 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f16 ?v0) f1) (=> (= (f29 ?v0 (f6 (f22 f23 ?v1) ?v2)) f1) (= (f29 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f6 (f22 f23 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (=> (= (f29 ?v_0 (f10 (f11 f12 ?v1) ?v3)) f1) (= (f29 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f6 (f22 f23 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (=> (= (f29 ?v_0 (f10 (f11 f12 ?v3) ?v1)) f1) (= (f29 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f35 f36 ?v0))) (= (f37 (f35 f36 (f37 ?v_0 ?v1)) (f37 (f35 f36 ?v2) ?v3)) (f37 (f35 f36 (f37 ?v_0 ?v2)) (f37 (f35 f36 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) (f10 (f11 f12 ?v2) ?v3)) (f10 (f11 f12 (f10 ?v_0 ?v2)) (f10 (f11 f12 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f35 f36 (f37 (f35 f36 ?v0) ?v1))) (?v_0 (f35 f36 ?v2))) (= (f37 ?v_1 (f37 ?v_0 ?v3)) (f37 ?v_0 (f37 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f11 f12 (f10 (f11 f12 ?v0) ?v1))) (?v_0 (f11 f12 ?v2))) (= (f10 ?v_1 (f10 ?v_0 ?v3)) (f10 ?v_0 (f10 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f35 f36 ?v0)) (?v_1 (f37 (f35 f36 ?v2) ?v3))) (= (f37 (f35 f36 (f37 ?v_0 ?v1)) ?v_1) (f37 ?v_0 (f37 (f35 f36 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f10 (f11 f12 ?v2) ?v3))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v_1) (f10 ?v_0 (f10 (f11 f12 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f36 ?v0))) (= (f37 (f35 f36 (f37 ?v_0 ?v1)) ?v2) (f37 (f35 f36 (f37 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 (f11 f12 (f10 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f36 ?v0))) (= (f37 (f35 f36 (f37 ?v_0 ?v1)) ?v2) (f37 ?v_0 (f37 (f35 f36 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f36 ?v0))) (= (f37 ?v_0 (f37 (f35 f36 ?v1) ?v2)) (f37 (f35 f36 (f37 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2)) (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f35 f36 ?v0)) (?v_0 (f35 f36 ?v1))) (= (f37 ?v_1 (f37 ?v_0 ?v2)) (f37 ?v_0 (f37 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f10 ?v_1 (f10 ?v_0 ?v2)) (f10 ?v_0 (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f37 (f35 f36 ?v0) ?v1) (f37 (f35 f36 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 ?v0) ?v1) (f10 (f11 f12 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (f6 (f22 f23 ?v0) (f4 f5 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f37 (f35 f38 ?v0) (f4 f5 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f10 (f11 f12 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f4 f5 (+ (f6 f7 ?v1) (f6 f7 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 (f35 f36 (f37 ?v_0 ?v1)) (f37 ?v_0 ?v2)) (f37 ?v_0 (f4 f5 (+ (f6 f7 ?v1) (f6 f7 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f6 (f22 f23 (f10 (f11 f12 ?v0) ?v1)) ?v2) (f10 (f11 f12 (f6 (f22 f23 ?v0) ?v2)) (f6 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f37 (f35 f38 (f37 (f35 f36 ?v0) ?v1)) ?v2) (f37 (f35 f36 (f37 (f35 f38 ?v0) ?v2)) (f37 (f35 f38 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f10 (f11 f12 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f4 f5 (+ (f6 f7 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 (f35 f36 (f37 ?v_0 ?v1)) ?v0) (f37 ?v_0 (f4 f5 (+ (f6 f7 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f4 f5 (* 2 (f6 f7 ?v1)))) (f10 (f11 f12 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f35 f38 ?v0))) (let ((?v_1 (f37 ?v_0 ?v1))) (= (f37 ?v_0 (f4 f5 (* 2 (f6 f7 ?v1)))) (f37 (f35 f36 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f10 (f11 f12 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f4 f5 (+ (f6 f7 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 (f35 f36 ?v0) (f37 ?v_0 ?v1)) (f37 ?v_0 (f4 f5 (+ (f6 f7 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f4 f5 (+ (* 2 (f6 f7 ?v1)) 1))) (f10 (f11 f12 ?v0) (f10 (f11 f12 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f35 f38 ?v0))) (let ((?v_1 (f37 ?v_0 ?v1))) (= (f37 ?v_0 (f4 f5 (+ (* 2 (f6 f7 ?v1)) 1))) (f37 (f35 f36 ?v0) (f37 (f35 f36 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f6 ?v_0 (f4 f5 (+ (f6 f7 ?v1) 1))) (f10 (f11 f12 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 ?v_0 (f4 f5 (+ (f6 f7 ?v1) 1))) (f37 (f35 f36 ?v0) (f37 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (= (f9 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f31 f32 (f33 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (= (f30 (f6 (f22 f23 ?v1) (f4 f5 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f17 ?v0) ?v1) (ite (= (f30 ?v0 0 ?v1) f1) 0 (ite (= (f18 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f30 (f6 (f22 f23 ?v2) (f4 f5 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f16 ?v0) f1) (=> (= (f29 ?v0 (f6 (f22 f23 ?v1) ?v2)) f1) (=> (< 0 (f6 f7 ?v2)) (= (f29 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (= (f29 ?v0 (f10 (f11 f12 ?v1) ?v2)) f1) (or (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f30 ?v1 (- 1) ?v0) f1) (not (= (f30 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f30 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f30 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f30 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f11 f12 ?v4))) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (= (f30 ?v3 (f10 ?v_0 ?v0) ?v2) f1) (= (f30 ?v3 (f10 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (= (f30 ?v3 (f10 (f11 f12 ?v0) ?v4) ?v2) f1) (= (f30 ?v3 (f10 (f11 f12 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f6 (f22 f23 ?v0) ?v3) (f6 (f22 f23 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (< 0 (f6 f7 ?v0)) (=> (= (f29 ?v1 ?v2) f1) (= (f29 ?v1 (f6 (f22 f23 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f30 (f10 (f11 f12 ?v1) ?v2) 0 ?v0) f1) (or (= (f30 ?v1 0 ?v0) f1) (= (f30 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f30 ?v1 0 ?v0) f1)) (not (= (f30 ?v2 0 ?v0) f1))) (not (= (f30 (f10 (f11 f12 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f30 ?v1 0 ?v0) f1)) (=> (not (= (f30 ?v2 0 ?v0) f1)) (not (= (f30 (f10 (f11 f12 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f16 ?v1) f1) (=> (= (f29 ?v1 (f10 (f11 f12 ?v0) ?v2)) f1) (or (= (f29 ?v1 ?v0) f1) (= (f29 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f30 (f10 (f11 f12 ?v1) ?v1) 1 ?v0) f1) (or (= (f30 ?v1 1 ?v0) f1) (= (f30 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f30 (f10 (f11 f12 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f30 (f6 ?v_0 ?v1) 1 ?v2) f1) (= (f30 (f6 ?v_0 (f4 f5 (f10 (f11 f12 (f6 f7 ?v1)) (f6 f7 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f11 f12 ?v1))) (= (+ (f10 (f11 f12 (- ?v0 (f10 ?v_0 ?v2))) ?v3) (f10 (f11 f12 (- ?v4 (f10 ?v_0 ?v5))) ?v6)) (- (+ (f10 (f11 f12 ?v0) ?v3) (f10 (f11 f12 ?v4) ?v6)) (f10 ?v_0 (+ (f10 (f11 f12 ?v2) ?v3) (f10 (f11 f12 ?v5) ?v6))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f4 f5 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f4 f5 (f10 (f11 f12 ?v_0) ?v_0)) (f4 f5 (+ (f10 (f11 f12 (f6 f7 (f4 f5 (- ?v0 1)))) (f6 f7 (f4 f5 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 (- ?v2)) f1) (= (f30 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f30 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f30 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f30 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v1 ?v3 ?v2) f1) (= (f30 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f16 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f10 (f11 f12 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f30 (f10 (f11 f12 ?v0) ?v_0) 1 ?v1) f1) (= (f30 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f30 (f10 (f11 f12 ?v0) ?v1) (f10 (f11 f12 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f10 (f11 f12 ?v0) ?v3) (f10 (f11 f12 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f12 ?v3))) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f10 ?v_0 ?v0) (f10 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (f10 (f11 f12 ?v0) ?v3) (f10 (f11 f12 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (= (f29 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int)) (= (= (f16 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f29 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f6 ?v_0 (f4 f5 (+ (* 2 (f6 f7 ?v1)) 1))) (f10 (f11 f12 ?v0) (f6 (f22 f23 (f6 ?v_0 ?v1)) (f4 f5 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 ?v_0 (f4 f5 (+ (* 2 (f6 f7 ?v1)) 1))) (f37 (f35 f36 ?v0) (f37 (f35 f38 (f37 ?v_0 ?v1)) (f4 f5 2)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f16 ?v1) f1) (= (f29 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f37 (f35 f38 (f4 f5 ?v0)) ?v1) (f4 f5 (f6 (f22 f23 ?v0) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 2))) (= (f6 (f22 f23 (f10 f39 ?v0)) ?v_0) (f6 (f22 f23 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 (f22 f23 ?v0) (f4 f5 2)))) (= (f10 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f10 (f11 f12 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 0)) (?v_2 (f6 f7 ?v0)) (?v_1 (f6 f7 ?v1))) (= (f4 f5 (f10 (f11 f12 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f4 f5 (+ ?v_1 (f10 (f11 f12 (f6 f7 (f4 f5 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 ?v0))) (= (f4 f5 (* ?v_0 2)) (f4 f5 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 ?v0))) (= (f4 f5 (* 2 ?v_0)) (f4 f5 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f6 (f22 f23 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (= (f6 (f22 f23 ?v0) (f4 f5 2)) (f10 (f11 f12 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f37 (f35 f38 ?v0) (f4 f5 2)) (f37 (f35 f36 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f6 (f22 f23 ?v0) (f4 f5 3)) (f10 (f11 f12 (f10 (f11 f12 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f37 (f35 f38 ?v0) (f4 f5 3)) (f37 (f35 f36 (f37 (f35 f36 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f6 ?v_0 (f4 f5 (* 2 (f6 f7 ?v1)))) (f6 (f22 f23 (f6 ?v_0 ?v1)) (f4 f5 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 ?v_0 (f4 f5 (* 2 (f6 f7 ?v1)))) (f37 (f35 f38 (f37 ?v_0 ?v1)) (f4 f5 2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f4 f5 (f10 (f11 f12 (f6 f7 (f4 f5 ?v0))) (f6 f7 (f4 f5 ?v1)))) (f4 f5 (f10 (f11 f12 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 (f11 f12 (f6 f7 ?v0)) (f6 f7 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 ?v_0 ?v1) (ite (= ?v1 (f4 f5 0)) (f4 f5 1) (f4 f5 (f10 (f11 f12 (f6 f7 ?v0)) (f6 f7 (f37 ?v_0 (f4 f5 (- (f6 f7 ?v1) 1)))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f6 (f22 f23 (f6 f7 ?v0)) ?v1) (f6 f7 (f37 (f35 f38 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f4 f5 0))) (= (= (f29 (f6 (f22 f23 ?v1) ?v0) (f6 (f22 f23 ?v2) ?v0)) f1) (= (f29 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int)) (=> (= (f29 (f6 (f22 f23 ?v0) ?v1) (f6 (f22 f23 ?v2) ?v1)) f1) (=> (not (= ?v1 (f4 f5 0))) (= (f29 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 (- 1)))) (let ((?v_1 (f6 ?v_0 ?v1)) (?v_2 (f6 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f30 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f30 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 (f22 f23 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 2)) (?v_1 (f6 f7 ?v0)) (?v_2 (f6 f7 ?v1))) (= (f4 f5 (- (f6 f7 (f37 (f35 f38 ?v0) ?v_0)) (f6 f7 (f37 (f35 f38 ?v1) ?v_0)))) (f4 f5 (f10 (f11 f12 (+ ?v_1 ?v_2)) (f6 f7 (f4 f5 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (=> (not (= ?v0 0)) (= (= (f29 ?v1 ?v2) f1) (= (f29 (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f10 (f11 f12 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f10 (f11 f12 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 1))) (= (= (f4 f5 (f10 (f11 f12 (f6 f7 ?v0)) (f6 f7 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1) f1) (= (f29 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 (+ (f6 f7 ?v1) 1)))) (= (<= (f6 f7 (f37 (f35 f38 ?v0) ?v_0)) (f6 f7 (f37 (f35 f38 ?v2) ?v_0))) (<= (f6 f7 ?v0) (f6 f7 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 (+ (f6 f7 ?v1) 1)))) (= (< (f6 f7 (f37 (f35 f38 ?v0) ?v_0)) (f6 f7 (f37 (f35 f38 ?v2) ?v_0))) (< (f6 f7 ?v0) (f6 f7 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 (+ (f6 f7 ?v1) 1)))) (= (= (f37 (f35 f38 ?v0) ?v_0) (f37 (f35 f38 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 1))) (= (= (f37 (f35 f38 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f4 f5 0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 0))) (= (= (f37 (f35 f38 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f6 ?v_0 (f4 f5 (f10 (f11 f12 (f6 f7 ?v1)) (f6 f7 ?v2)))) (f6 (f22 f23 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 ?v_0 (f4 f5 (f10 (f11 f12 (f6 f7 ?v1)) (f6 f7 ?v2)))) (f37 (f35 f38 (f37 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f29 ?v0 ?v1) f1) (= (f29 (f6 (f22 f23 ?v0) ?v2) (f6 (f22 f23 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f40 ?v0 ?v1) f1) (= (f40 (f37 (f35 f38 ?v0) ?v2) (f37 (f35 f38 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f6 f7 ?v2)) (?v_0 (f6 f7 ?v3))) (=> (= ?v0 (f4 f5 (+ (f10 (f11 f12 (f6 f7 ?v1)) ?v_1) ?v_0))) (=> (< 0 ?v_0) (=> (< ?v_0 ?v_1) (not (= (f40 ?v2 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 (f6 f7 ?v2)))) (=> (= (f40 ?v0 ?v1) f1) (= (f40 (f4 f5 (f10 ?v_0 (f6 f7 ?v0))) (f4 f5 (f10 ?v_0 (f6 f7 ?v1)))) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f40 ?v0 ?v1) f1) (= (f40 (f4 f5 (f10 (f11 f12 (f6 f7 ?v0)) ?v_0)) (f4 f5 (f10 (f11 f12 (f6 f7 ?v1)) ?v_0))) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f40 ?v0 ?v1) f1) (or (= ?v1 (f4 f5 0)) (or (= ?v1 ?v0) (<= (* 2 (f6 f7 ?v0)) (f6 f7 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 ?v1))) (= (= (f40 (f4 f5 (f10 (f11 f12 (f6 f7 ?v0)) ?v_0)) (f4 f5 (f10 (f11 f12 (f6 f7 ?v2)) ?v_0))) f1) (or (= ?v1 (f4 f5 0)) (= (f40 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 (f4 f5 0))) (=> (= (f40 (f37 (f35 f38 ?v1) ?v0) ?v2) f1) (= (f40 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f40 ?v0 ?v1) f1) (= (f40 ?v0 (f37 (f35 f38 ?v1) (f4 f5 (+ (f6 f7 ?v2) 1)))) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f40 ?v0 ?v1) f1) (= (f40 (f37 (f35 f38 ?v0) ?v2) (f37 (f35 f38 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f40 (f37 (f35 f38 ?v0) ?v1) (f37 (f35 f38 ?v2) ?v1)) f1) (=> (not (= ?v1 (f4 f5 0))) (= (f40 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f29 (f6 f7 ?v0) (f6 f7 ?v1)) f1) (= (f40 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f40 (f4 f5 ?v0) (f4 f5 ?v1)) f1) (= (f29 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f38 ?v0))) (=> (= (f40 (f37 ?v_0 ?v1) (f37 ?v_0 ?v2)) f1) (=> (< 1 (f6 f7 ?v0)) (<= (f6 f7 ?v1) (f6 f7 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f40 ?v0 ?v1) f1) (= (f29 (f6 f7 ?v0) (f6 f7 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f29 ?v0 (f6 f7 ?v1)) f1) (= (f40 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 Int)) (= (= (f29 (f6 f7 ?v0) ?v1) f1) (= (f40 ?v0 (f4 f5 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f40 (f4 f5 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f29 ?v0 (f6 f7 ?v1)) f1) (= ?v1 (f4 f5 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 (f4 f5 0))) (= (= (f40 (f37 (f35 f38 ?v1) ?v0) (f37 (f35 f38 ?v2) ?v0)) f1) (= (f40 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f10 f39 (f6 (f22 f23 ?v0) ?v1)) (f6 (f22 f23 (f10 f39 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f6 (f22 f23 ?v0) (f4 f5 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f37 (f35 f38 ?v0) (f4 f5 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f6 f7 (f37 (f35 f38 ?v0) ?v1))) (or (< 0 (f6 f7 ?v0)) (= ?v1 (f4 f5 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f5 (+ 0 1)))) (= (f37 (f35 f38 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 (+ 0 1)))) (= (= (f37 (f35 f38 ?v0) ?v1) ?v_0) (or (= ?v1 (f4 f5 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f38 ?v0))) (=> (< 0 (f6 f7 ?v0)) (=> (< (f6 f7 (f37 ?v_0 ?v1)) (f6 f7 (f37 ?v_0 ?v2))) (< (f6 f7 ?v1) (f6 f7 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f6 f7 ?v0)) (<= ?v_0 (f6 f7 (f37 (f35 f38 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f6 (f22 f23 (f10 (f11 f12 ?v0) ?v1)) ?v2) (f10 (f11 f12 (f6 (f22 f23 ?v0) ?v2)) (f6 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f37 (f35 f38 (f37 (f35 f36 ?v0) ?v1)) ?v2) (f37 (f35 f36 (f37 (f35 f38 ?v0) ?v2)) (f37 (f35 f38 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f6 (f22 f23 ?v0) ?v1))) (= (f10 (f11 f12 ?v_0) ?v0) (f10 (f11 f12 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f37 (f35 f38 ?v0) ?v1))) (= (f37 (f35 f36 ?v_0) ?v0) (f37 (f35 f36 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f6 ?v_0 (f4 f5 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (f10 (f11 f12 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 ?v_0 (f4 f5 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (f37 (f35 f36 (f37 ?v_0 ?v1)) (f37 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f6 ?v_0 (f4 f5 (+ (f6 f7 ?v1) 1))) (f10 (f11 f12 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 ?v_0 (f4 f5 (+ (f6 f7 ?v1) 1))) (f37 (f35 f36 (f37 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f6 ?v_0 (f4 f5 (+ (f6 f7 ?v1) 1))) (f10 (f11 f12 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f35 f38 ?v0))) (= (f37 ?v_0 (f4 f5 (+ (f6 f7 ?v1) 1))) (f37 (f35 f36 ?v0) (f37 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f29 (f6 ?v_0 ?v1) ?v2) f1) (=> (<= (f6 f7 ?v3) (f6 f7 ?v1)) (= (f29 (f6 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f35 f38 ?v0))) (=> (= (f40 (f37 ?v_0 ?v1) ?v2) f1) (=> (<= (f6 f7 ?v3) (f6 f7 ?v1)) (= (f40 (f37 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 S2)) (=> (= (f29 ?v0 ?v1) f1) (=> (<= (f6 f7 ?v2) (f6 f7 ?v3)) (= (f29 (f6 (f22 f23 ?v0) ?v2) (f6 (f22 f23 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f40 ?v0 ?v1) f1) (=> (<= (f6 f7 ?v2) (f6 f7 ?v3)) (= (f40 (f37 (f35 f38 ?v0) ?v2) (f37 (f35 f38 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f22 f23 ?v2))) (=> (<= (f6 f7 ?v0) (f6 f7 ?v1)) (= (f29 (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f38 ?v2))) (=> (<= (f6 f7 ?v0) (f6 f7 ?v1)) (= (f40 (f37 ?v_0 ?v0) (f37 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 (f10 (f11 f12 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f40 ?v0 (f37 (f35 f36 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 (f10 (f11 f12 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f40 ?v0 (f37 (f35 f36 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (and (= (f40 ?v0 ?v1) f1) (= (f40 ?v1 ?v0) f1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f40 ?v0 ?v1) f1) (or (= ?v1 (f4 f5 0)) (<= (f6 f7 ?v0) (f6 f7 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 ?v0 (f4 f5 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) f1) (= (f40 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f5 0))) (not (and (= (f40 ?v_0 ?v0) f1) (not (= (f40 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f5 1))) (not (and (= (f40 ?v0 ?v_0) f1) (not (= (f40 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S2)) (= (f40 (f4 f5 1) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f40 ?v0 (f4 f5 0)) f1)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f5 1))) (= (not (= ?v0 ?v_0)) (and (= (f40 ?v_0 ?v0) f1) (not (= (f40 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S2)) (= (f4 f5 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f4 f5 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f7 (f4 f5 ?v0)) 0))))
(check-sat)
(exit)
