(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (Int) S1)
(declare-fun f8 (S4 Int) Int)
(declare-fun f9 (S5 Int) S4)
(declare-fun f10 () S5)
(declare-fun f11 () S3)
(declare-fun f12 (S6 Int) S3)
(declare-fun f13 () S6)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_2 (f3 f4 f5))) (let ((?v_1 (+ 1 ?v_2)) (?v_3 (f3 f4 f11))) (not (=> (and (< ?v_1 ?v_0) (= (f7 (f8 (f9 f10 ?v_0) ?v_1)) f1)) (=> (< ?v_3 ?v_2) (< (+ 1 ?v_3) ?v_0)))))))
(assert (forall ((?v0 S3)) (= (f12 f13 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
