(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sls/sls_quicksort.spl:45:1-2:A postcondition of procedure split might not hold at this return point
  tests/spl/sls/sls_quicksort.spl:18:11:Related location: This is the postcondition that might not hold
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetLoc)
(declare-fun setenum$0 (Loc) SetLoc)
(declare-fun union$0 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun in$0 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_61$0 () Bool)
(declare-fun Axiom_62$0 () Bool)
(declare-fun Axiom_63$0 () Bool)
(declare-fun Axiom_64$0 () Bool)
(declare-fun Axiom_65$0 () Bool)
(declare-fun Axiom_66$0 () Bool)
(declare-fun Axiom_67$0 () Bool)
(declare-fun Axiom_68$0 () Bool)
(declare-fun Axiom_69$0 () Bool)
(declare-fun Axiom_70$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_7$0 () SetLoc)
(declare-fun FP_8$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_2$0 () SetLoc)
(declare-fun FP_Caller_final_2$0 () SetLoc)
(declare-fun blseg_domain$0 (FldInt FldLoc Loc Loc Int Int) SetLoc)
(declare-fun blseg_struct$0 (SetLoc FldInt FldLoc Loc Loc Int Int) Bool)
(declare-fun curr_2$0 () Loc)
(declare-fun curr_3$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun data_4$0 () FldInt)
(declare-fun lb_1$0 () Int)
(declare-fun lb_4$0 () Int)
(declare-fun next$0 () FldLoc)
(declare-fun pivot_4$0 () Loc)
(declare-fun pivot_5$0 () Loc)
(declare-fun sk_?X_90$0 () SetLoc)
(declare-fun sk_?X_91$0 () SetLoc)
(declare-fun sk_?X_92$0 () SetLoc)
(declare-fun sk_?X_93$0 () SetLoc)
(declare-fun sk_?X_94$0 () SetLoc)
(declare-fun sk_?X_95$0 () SetLoc)
(declare-fun sk_?X_96$0 () SetLoc)
(declare-fun sk_?X_97$0 () SetLoc)
(declare-fun sk_?X_98$0 () SetLoc)
(declare-fun sk_?X_99$0 () SetLoc)
(declare-fun sk_?X_100$0 () SetLoc)
(declare-fun sk_?X_101$0 () SetLoc)
(declare-fun sk_?X_102$0 () SetLoc)
(declare-fun sk_?X_103$0 () SetLoc)
(declare-fun sk_?X_104$0 () SetLoc)
(declare-fun sk_?X_105$0 () SetLoc)
(declare-fun sk_?X_106$0 () SetLoc)
(declare-fun sk_?X_107$0 () SetLoc)
(declare-fun sk_?X_108$0 () SetLoc)
(declare-fun sk_?X_109$0 () SetLoc)
(declare-fun sk_?X_110$0 () SetLoc)
(declare-fun sk_?X_111$0 () SetLoc)
(declare-fun sk_?X_112$0 () SetLoc)
(declare-fun sk_?X_113$0 () SetLoc)
(declare-fun sk_?X_114$0 () SetLoc)
(declare-fun sk_?X_115$0 () SetLoc)
(declare-fun sk_?X_116$0 () SetLoc)
(declare-fun sk_?X_117$0 () SetLoc)
(declare-fun sk_?X_118$0 () SetLoc)
(declare-fun sk_l1_5$0 () Loc)
(declare-fun t_65$0 () Int)
(declare-fun t_66$0 () Int)
(declare-fun t_67$0 () Int)
(declare-fun t_68$0 () Loc)
(declare-fun t_69$0 () Loc)
(declare-fun t_70$0 () Loc)
(declare-fun t_71$0 () Loc)
(declare-fun t_72$0 () Loc)
(declare-fun t_73$0 () Loc)
(declare-fun t_74$0 () Loc)
(declare-fun t_75$0 () Loc)
(declare-fun ub_1$0 () Int)
(declare-fun ub_4$0 () Int)
(declare-fun x_1$0 () Loc)
(declare-fun x_4$0 () Loc)
(declare-fun y_1$0 () Loc)
(declare-fun y_4$0 () Loc)

(assert (= (ep$0 next$0 FP_7$0 x_4$0) t_75$0))

(assert (= (ep$0 next$0 FP_7$0 x_1$0) t_74$0))

(assert (= (ep$0 next$0 FP_7$0 sk_l1_5$0) t_73$0))

(assert (= (ep$0 next$0 FP_7$0 pivot_5$0) t_72$0))

(assert (= (ep$0 next$0 FP_7$0 pivot_4$0) t_71$0))

(assert (= (ep$0 next$0 FP_7$0 curr_3$0) t_70$0))

(assert (= (ep$0 next$0 FP_7$0 curr_2$0) t_69$0))

(assert (= (ep$0 next$0 FP_7$0 null$0) t_68$0))

(assert (= (read$1 data_4$0 pivot_4$0) t_67$0))

(assert (= (read$1 data$0 sk_l1_5$0) t_66$0))

(assert (= (read$1 data$0 pivot_5$0) t_65$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Loc)) (not (in$0 x emptyset$0))))

(assert (or (and (Btwn$0 next$0 curr_2$0 y_1$0 y_1$0) Axiom_61$0)
    (not
         (blseg_struct$0 sk_?X_105$0 data$0 next$0 curr_2$0 y_1$0 lb_1$0
           ub_1$0))))

(assert (or (not Axiom_62$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data_4$0 l1) ub_4$0)
                     (<= lb_4$0 (read$1 data_4$0 l1)))
                (not (in$0 l1 sk_?X_94$0))))))

(assert (or (and (Btwn$0 next$0 pivot_4$0 curr_2$0 curr_2$0) Axiom_63$0)
    (not
         (blseg_struct$0 sk_?X_108$0 data$0 next$0 pivot_4$0 curr_2$0
           (read$1 data$0 pivot_4$0) ub_1$0))))

(assert (or (not Axiom_64$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data_4$0 l1) ub_4$0)
                     (<= (read$1 data_4$0 pivot_5$0) (read$1 data_4$0 l1)))
                (not (in$0 l1 sk_?X_91$0))))))

(assert (or (and (Btwn$0 next$0 pivot_5$0 y_1$0 y_1$0) Axiom_65$0)
    (not
         (blseg_struct$0 sk_?X_113$0 data_4$0 next$0 pivot_5$0 y_1$0
           (read$1 data_4$0 pivot_5$0) ub_1$0))))

(assert (or (not Axiom_66$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data$0 l1) (read$1 data$0 pivot_4$0))
                     (<= lb_1$0 (read$1 data$0 l1)))
                (not (in$0 l1 sk_?X_109$0))))))

(assert (or (and (Btwn$0 next$0 x_1$0 pivot_5$0 pivot_5$0) Axiom_67$0)
    (not
         (blseg_struct$0 sk_?X_112$0 data_4$0 next$0 x_1$0 pivot_5$0 lb_1$0
           (read$1 data_4$0 pivot_5$0)))))

(assert (or (not Axiom_68$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data$0 l1) ub_1$0)
                     (<= lb_1$0 (read$1 data$0 l1)))
                (not (in$0 l1 sk_?X_111$0))))))

(assert (or (and (Btwn$0 next$0 x_4$0 pivot_5$0 pivot_5$0) Axiom_69$0)
    (not
         (blseg_struct$0 sk_?X_90$0 data_4$0 next$0 x_4$0 pivot_5$0 lb_4$0
           (read$1 data_4$0 pivot_5$0)))))

(assert (= FP_Caller_2$0 (setminus$0 FP_Caller$0 FP$0)))

(assert (= curr_2$0 (read$0 next$0 x_1$0)))

(assert (= lb_4$0 lb_1$0))

(assert (= ub_4$0 ub_1$0))

(assert (= y_4$0 y_1$0))

(assert (Frame$1 FP_7$0 Alloc$0 next$0 next$0))

(assert (= Alloc$0 (union$0 FP_Caller$0 Alloc$0)))

(assert (= emptyset$0 (intersection$0 sk_?X_90$0 sk_?X_92$0)))

(assert (= emptyset$0 (intersection$0 sk_?X_95$0 sk_?X_96$0)))

(assert (= sk_?X_91$0
  (blseg_domain$0 data_4$0 next$0 pivot_5$0 curr_3$0
    (read$1 data_4$0 pivot_5$0) ub_4$0)))

(assert (= sk_?X_93$0 (union$0 sk_?X_90$0 sk_?X_92$0)))

(assert (= sk_?X_95$0 (union$0 sk_?X_93$0 sk_?X_94$0)))

(assert (= sk_?X_97$0 (union$0 sk_?X_95$0 sk_?X_96$0)))

(assert (= sk_?X_99$0
  (union$0 (intersection$0 Alloc$0 FP_7$0) (setminus$0 Alloc$0 Alloc$0))))

(assert (<= (read$1 data_4$0 pivot_5$0) ub_4$0))

(assert (Btwn$0 next$0 pivot_5$0 curr_3$0 y_4$0))

(assert (blseg_struct$0 sk_?X_90$0 data_4$0 next$0 x_4$0 pivot_5$0 lb_4$0
  (read$1 data_4$0 pivot_5$0)))

(assert (blseg_struct$0 sk_?X_94$0 data_4$0 next$0 curr_3$0 y_4$0 lb_4$0 ub_4$0))

(assert (= emptyset$0 emptyset$0))

(assert (= emptyset$0 (intersection$0 sk_?X_106$0 sk_?X_105$0)))

(assert (= sk_?X_100$0 sk_?X_101$0))

(assert (= sk_?X_101$0 sk_?X_102$0))

(assert (= sk_?X_103$0 emptyset$0))

(assert (= sk_?X_105$0 (blseg_domain$0 data$0 next$0 curr_2$0 y_1$0 lb_1$0 ub_1$0)))

(assert (= sk_?X_107$0 sk_?X_108$0))

(assert (= sk_?X_109$0
  (blseg_domain$0 data$0 next$0 x_1$0 pivot_4$0 lb_1$0
    (read$1 data$0 pivot_4$0))))

(assert (<= lb_1$0 (read$1 data$0 pivot_4$0)))

(assert (Btwn$0 next$0 x_1$0 pivot_4$0 y_1$0))

(assert (blseg_struct$0 sk_?X_105$0 data$0 next$0 curr_2$0 y_1$0 lb_1$0 ub_1$0))

(assert (blseg_struct$0 sk_?X_109$0 data$0 next$0 x_1$0 pivot_4$0 lb_1$0
  (read$1 data$0 pivot_4$0)))

(assert (= emptyset$0 emptyset$0))

(assert (= sk_?X_110$0 FP$0))

(assert (= FP_Caller$0 (union$0 FP$0 FP_Caller$0)))

(assert (not (= x_1$0 y_1$0)))

(assert (= sk_?X_113$0
  (blseg_domain$0 data_4$0 next$0 pivot_5$0 y_1$0 (read$1 data_4$0 pivot_5$0)
    ub_1$0)))

(assert (= sk_?X_115$0 (union$0 sk_?X_112$0 sk_?X_114$0)))

(assert (= sk_?X_117$0 (union$0 sk_?X_115$0 sk_?X_116$0)))

(assert (or (= pivot_5$0 y_1$0)
    (in$0 sk_l1_5$0 (intersection$0 sk_?X_112$0 sk_?X_114$0))
    (in$0 sk_l1_5$0 (intersection$0 sk_?X_115$0 sk_?X_116$0))
    (and
         (in$0 sk_l1_5$0
           (union$0 (intersection$0 Alloc$0 FP$0)
             (setminus$0 Alloc$0 Alloc$0)))
         (not (in$0 sk_l1_5$0 sk_?X_118$0)))
    (and (in$0 sk_l1_5$0 sk_?X_112$0)
         (or
             (not
                  (<= (read$1 data_4$0 sk_l1_5$0)
                    (read$1 data_4$0 pivot_5$0)))
             (not (<= lb_1$0 (read$1 data_4$0 sk_l1_5$0)))))
    (and (in$0 sk_l1_5$0 sk_?X_113$0)
         (or (not (<= (read$1 data_4$0 sk_l1_5$0) ub_1$0))
             (not
                  (<= (read$1 data_4$0 pivot_5$0)
                    (read$1 data_4$0 sk_l1_5$0)))))
    (and (in$0 sk_l1_5$0 sk_?X_118$0)
         (not
              (in$0 sk_l1_5$0
                (union$0 (intersection$0 Alloc$0 FP$0)
                  (setminus$0 Alloc$0 Alloc$0)))))
    (not (<= (read$1 data_4$0 pivot_5$0) ub_1$0))
    (not (<= lb_1$0 (read$1 data_4$0 pivot_5$0)))
    (not (Btwn$0 next$0 pivot_5$0 y_1$0 y_1$0))
    (not (Btwn$0 next$0 x_1$0 pivot_5$0 pivot_5$0))
    (not (Btwn$0 next$0 x_1$0 pivot_5$0 y_1$0))))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_3$0 l1 y_4$0)
                 (in$0 l1
                   (blseg_domain$0 data_4$0 next$0 curr_3$0 y_4$0 lb_4$0
                     ub_4$0))
                 (not (= l1 y_4$0)))
            (and (or (= l1 y_4$0) (not (Btwn$0 next$0 curr_3$0 l1 y_4$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_4$0 next$0 curr_3$0 y_4$0 lb_4$0
                          ub_4$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 pivot_5$0 l1 curr_3$0)
                 (in$0 l1
                   (blseg_domain$0 data_4$0 next$0 pivot_5$0 curr_3$0
                     (read$1 data_4$0 pivot_5$0) ub_4$0))
                 (not (= l1 curr_3$0)))
            (and
                 (or (= l1 curr_3$0)
                     (not (Btwn$0 next$0 pivot_5$0 l1 curr_3$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_4$0 next$0 pivot_5$0 curr_3$0
                          (read$1 data_4$0 pivot_5$0) ub_4$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 x_1$0 l1 pivot_4$0)
                 (in$0 l1
                   (blseg_domain$0 data$0 next$0 x_1$0 pivot_4$0 lb_1$0
                     (read$1 data$0 pivot_4$0)))
                 (not (= l1 pivot_4$0)))
            (and
                 (or (= l1 pivot_4$0)
                     (not (Btwn$0 next$0 x_1$0 l1 pivot_4$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data$0 next$0 x_1$0 pivot_4$0 lb_1$0
                          (read$1 data$0 pivot_4$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 x_1$0 l1 y_1$0)
                 (in$0 l1
                   (blseg_domain$0 data$0 next$0 x_1$0 y_1$0 lb_1$0 ub_1$0))
                 (not (= l1 y_1$0)))
            (and (or (= l1 y_1$0) (not (Btwn$0 next$0 x_1$0 l1 y_1$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data$0 next$0 x_1$0 y_1$0 lb_1$0
                          ub_1$0)))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$0 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$0 ?y ?X))
            (in$0 (ep$0 ?f ?X ?x) ?X))))

(assert (or (not (Frame$0 FP_7$0 Alloc$0 data$0 data_4$0)) Axiom_70$0))

(assert (or (not Axiom_61$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data$0 l1) ub_1$0)
                     (<= lb_1$0 (read$1 data$0 l1)))
                (not (in$0 l1 sk_?X_105$0))))))

(assert (or (and (Btwn$0 next$0 curr_3$0 y_4$0 y_4$0) Axiom_62$0)
    (not
         (blseg_struct$0 sk_?X_94$0 data_4$0 next$0 curr_3$0 y_4$0 lb_4$0
           ub_4$0))))

(assert (or (not Axiom_63$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data$0 l1) ub_1$0)
                     (<= (read$1 data$0 pivot_4$0) (read$1 data$0 l1)))
                (not (in$0 l1 sk_?X_108$0))))))

(assert (or (and (Btwn$0 next$0 pivot_5$0 curr_3$0 curr_3$0) Axiom_64$0)
    (not
         (blseg_struct$0 sk_?X_91$0 data_4$0 next$0 pivot_5$0 curr_3$0
           (read$1 data_4$0 pivot_5$0) ub_4$0))))

(assert (or (not Axiom_65$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data_4$0 l1) ub_1$0)
                     (<= (read$1 data_4$0 pivot_5$0) (read$1 data_4$0 l1)))
                (not (in$0 l1 sk_?X_113$0))))))

(assert (or (and (Btwn$0 next$0 x_1$0 pivot_4$0 pivot_4$0) Axiom_66$0)
    (not
         (blseg_struct$0 sk_?X_109$0 data$0 next$0 x_1$0 pivot_4$0 lb_1$0
           (read$1 data$0 pivot_4$0)))))

(assert (or (not Axiom_67$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data_4$0 l1) (read$1 data_4$0 pivot_5$0))
                     (<= lb_1$0 (read$1 data_4$0 l1)))
                (not (in$0 l1 sk_?X_112$0))))))

(assert (or (and (Btwn$0 next$0 x_1$0 y_1$0 y_1$0) Axiom_68$0)
    (not
         (blseg_struct$0 sk_?X_111$0 data$0 next$0 x_1$0 y_1$0 lb_1$0 ub_1$0))))

(assert (or (not Axiom_69$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data_4$0 l1) (read$1 data_4$0 pivot_5$0))
                     (<= lb_4$0 (read$1 data_4$0 l1)))
                (not (in$0 l1 sk_?X_90$0))))))

(assert (= FP_8$0
  (union$0 (setminus$0 FP$0 FP_7$0)
    (union$0 (intersection$0 Alloc$0 FP_7$0) (setminus$0 Alloc$0 Alloc$0)))))

(assert (= FP_Caller_final_2$0 (union$0 FP_Caller_2$0 FP_8$0)))

(assert (= curr_3$0 y_4$0))

(assert (= pivot_4$0 x_1$0))

(assert (= x_4$0 x_1$0))

(assert (Frame$0 FP_7$0 Alloc$0 data$0 data_4$0))

(assert (= Alloc$0 (union$0 FP_8$0 Alloc$0)))

(assert (= emptyset$0 emptyset$0))

(assert (= emptyset$0 (intersection$0 sk_?X_93$0 sk_?X_94$0)))

(assert (= sk_?X_90$0
  (blseg_domain$0 data_4$0 next$0 x_4$0 pivot_5$0 lb_4$0
    (read$1 data_4$0 pivot_5$0))))

(assert (= sk_?X_92$0 sk_?X_91$0))

(assert (= sk_?X_94$0 (blseg_domain$0 data_4$0 next$0 curr_3$0 y_4$0 lb_4$0 ub_4$0)))

(assert (= sk_?X_96$0 emptyset$0))

(assert (= sk_?X_98$0 sk_?X_97$0))

(assert (= sk_?X_99$0 sk_?X_98$0))

(assert (<= lb_4$0 (read$1 data_4$0 pivot_5$0)))

(assert (Btwn$0 next$0 x_4$0 pivot_5$0 y_4$0))

(assert (blseg_struct$0 sk_?X_91$0 data_4$0 next$0 pivot_5$0 curr_3$0
  (read$1 data_4$0 pivot_5$0) ub_4$0))

(assert (not (= pivot_5$0 curr_3$0)))

(assert (= emptyset$0 (intersection$0 sk_?X_104$0 sk_?X_103$0)))

(assert (= emptyset$0 (intersection$0 sk_?X_109$0 sk_?X_107$0)))

(assert (= sk_?X_100$0 FP_7$0))

(assert (= sk_?X_102$0 (union$0 sk_?X_104$0 sk_?X_103$0)))

(assert (= sk_?X_104$0 (union$0 sk_?X_106$0 sk_?X_105$0)))

(assert (= sk_?X_106$0 (union$0 sk_?X_109$0 sk_?X_107$0)))

(assert (= sk_?X_108$0
  (blseg_domain$0 data$0 next$0 pivot_4$0 curr_2$0 (read$1 data$0 pivot_4$0)
    ub_1$0)))

(assert (<= (read$1 data$0 pivot_4$0) ub_1$0))

(assert (Btwn$0 next$0 pivot_4$0 curr_2$0 y_1$0))

(assert (= FP$0 (union$0 FP_7$0 FP$0)))

(assert (blseg_struct$0 sk_?X_108$0 data$0 next$0 pivot_4$0 curr_2$0
  (read$1 data$0 pivot_4$0) ub_1$0))

(assert (not (= pivot_4$0 curr_2$0)))

(assert (= sk_?X_110$0 sk_?X_111$0))

(assert (= sk_?X_111$0 (blseg_domain$0 data$0 next$0 x_1$0 y_1$0 lb_1$0 ub_1$0)))

(assert (blseg_struct$0 sk_?X_111$0 data$0 next$0 x_1$0 y_1$0 lb_1$0 ub_1$0))

(assert (= sk_?X_112$0
  (blseg_domain$0 data_4$0 next$0 x_1$0 pivot_5$0 lb_1$0
    (read$1 data_4$0 pivot_5$0))))

(assert (= sk_?X_114$0 sk_?X_113$0))

(assert (= sk_?X_116$0 emptyset$0))

(assert (= sk_?X_118$0 sk_?X_117$0))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_2$0 l1 y_1$0)
                 (in$0 l1
                   (blseg_domain$0 data$0 next$0 curr_2$0 y_1$0 lb_1$0
                     ub_1$0))
                 (not (= l1 y_1$0)))
            (and (or (= l1 y_1$0) (not (Btwn$0 next$0 curr_2$0 l1 y_1$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data$0 next$0 curr_2$0 y_1$0 lb_1$0
                          ub_1$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 pivot_4$0 l1 curr_2$0)
                 (in$0 l1
                   (blseg_domain$0 data$0 next$0 pivot_4$0 curr_2$0
                     (read$1 data$0 pivot_4$0) ub_1$0))
                 (not (= l1 curr_2$0)))
            (and
                 (or (= l1 curr_2$0)
                     (not (Btwn$0 next$0 pivot_4$0 l1 curr_2$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data$0 next$0 pivot_4$0 curr_2$0
                          (read$1 data$0 pivot_4$0) ub_1$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 pivot_5$0 l1 y_1$0)
                 (in$0 l1
                   (blseg_domain$0 data_4$0 next$0 pivot_5$0 y_1$0
                     (read$1 data_4$0 pivot_5$0) ub_1$0))
                 (not (= l1 y_1$0)))
            (and (or (= l1 y_1$0) (not (Btwn$0 next$0 pivot_5$0 l1 y_1$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_4$0 next$0 pivot_5$0 y_1$0
                          (read$1 data_4$0 pivot_5$0) ub_1$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 x_1$0 l1 pivot_5$0)
                 (in$0 l1
                   (blseg_domain$0 data_4$0 next$0 x_1$0 pivot_5$0 lb_1$0
                     (read$1 data_4$0 pivot_5$0)))
                 (not (= l1 pivot_5$0)))
            (and
                 (or (= l1 pivot_5$0)
                     (not (Btwn$0 next$0 x_1$0 l1 pivot_5$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_4$0 next$0 x_1$0 pivot_5$0
                          lb_1$0 (read$1 data_4$0 pivot_5$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 x_4$0 l1 pivot_5$0)
                 (in$0 l1
                   (blseg_domain$0 data_4$0 next$0 x_4$0 pivot_5$0 lb_4$0
                     (read$1 data_4$0 pivot_5$0)))
                 (not (= l1 pivot_5$0)))
            (and
                 (or (= l1 pivot_5$0)
                     (not (Btwn$0 next$0 x_4$0 l1 pivot_5$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_4$0 next$0 x_4$0 pivot_5$0
                          lb_4$0 (read$1 data_4$0 pivot_5$0))))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$0 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (not Axiom_70$0)
    (forall ((?x Loc))
            (or (= (read$1 data$0 ?x) (read$1 data_4$0 ?x))
                (not (in$0 ?x (setminus$0 Alloc$0 FP_7$0)))))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
