(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sls/sls_strand_sort.spl:118:3-4:An invariant might not be maintained by a loop in procedure strand_sort
  tests/spl/sls/sls_strand_sort.spl:112:14:Related location: This is the loop invariant that might not be maintained
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldInt Loc) Int)
(declare-fun read$1 (FldLoc Loc) Loc)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetLoc)
(declare-fun setenum$0 (Loc) SetLoc)
(declare-fun union$0 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun in$0 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_111$0 () Bool)
(declare-fun Axiom_112$0 () Bool)
(declare-fun Axiom_113$0 () Bool)
(declare-fun Axiom_114$0 () Bool)
(declare-fun Axiom_115$0 () Bool)
(declare-fun Axiom_116$0 () Bool)
(declare-fun Axiom_117$0 () Bool)
(declare-fun Axiom_118$0 () Bool)
(declare-fun Axiom_119$0 () Bool)
(declare-fun Axiom_120$0 () Bool)
(declare-fun Axiom_121$0 () Bool)
(declare-fun Axiom_122$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_11$0 () SetLoc)
(declare-fun FP_12$0 () SetLoc)
(declare-fun FP_13$0 () SetLoc)
(declare-fun FP_14$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_6$0 () SetLoc)
(declare-fun data$0 () FldInt)
(declare-fun lseg_domain$0 (FldLoc Loc Loc) SetLoc)
(declare-fun lseg_struct$0 (SetLoc FldLoc Loc Loc) Bool)
(declare-fun lst_3$0 () Loc)
(declare-fun lst_4$0 () Loc)
(declare-fun lst_init$0 () Loc)
(declare-fun new_sorted_2$0 () Loc)
(declare-fun new_sorted_4$0 () Loc)
(declare-fun new_sorted_init$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun next_12$0 () FldLoc)
(declare-fun next_13$0 () FldLoc)
(declare-fun sk_?X_378$0 () SetLoc)
(declare-fun sk_?X_379$0 () SetLoc)
(declare-fun sk_?X_380$0 () SetLoc)
(declare-fun sk_?X_381$0 () SetLoc)
(declare-fun sk_?X_382$0 () SetLoc)
(declare-fun sk_?X_383$0 () SetLoc)
(declare-fun sk_?X_384$0 () SetLoc)
(declare-fun sk_?X_385$0 () SetLoc)
(declare-fun sk_?X_386$0 () SetLoc)
(declare-fun sk_?X_387$0 () SetLoc)
(declare-fun sk_?X_388$0 () SetLoc)
(declare-fun sk_?X_389$0 () SetLoc)
(declare-fun sk_?X_390$0 () SetLoc)
(declare-fun sk_?X_391$0 () SetLoc)
(declare-fun sk_?X_392$0 () SetLoc)
(declare-fun sk_FP_11$0 () SetLoc)
(declare-fun sk_l1_15$0 () Loc)
(declare-fun sk_l2_15$0 () Loc)
(declare-fun slseg_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun slseg_struct$0 (SetLoc FldInt FldLoc Loc Loc) Bool)
(declare-fun sorted_12$0 () Loc)
(declare-fun sorted_13$0 () Loc)
(declare-fun sorted_init_1$0 () Loc)
(declare-fun t_120$0 () Loc)
(declare-fun t_121$0 () Loc)
(declare-fun t_122$0 () Loc)
(declare-fun t_123$0 () Loc)
(declare-fun t_124$0 () Loc)
(declare-fun t_125$0 () Loc)
(declare-fun t_126$0 () Loc)
(declare-fun t_127$0 () Loc)
(declare-fun t_128$0 () Loc)
(declare-fun t_129$0 () Loc)
(declare-fun t_130$0 () Loc)
(declare-fun t_131$0 () Loc)
(declare-fun t_132$0 () Loc)
(declare-fun t_133$0 () Loc)
(declare-fun t_134$0 () Loc)
(declare-fun t_135$0 () Loc)
(declare-fun t_136$0 () Loc)
(declare-fun t_137$0 () Loc)
(declare-fun t_138$0 () Loc)
(declare-fun t_139$0 () Loc)

(assert (= (ep$0 next_12$0 FP_13$0 sorted_init_1$0) t_139$0))

(assert (= (ep$0 next_12$0 FP_13$0 sorted_13$0) t_138$0))

(assert (= (ep$0 next_12$0 FP_13$0 sorted_12$0) t_137$0))

(assert (= (ep$0 next_12$0 FP_13$0 sk_l2_15$0) t_136$0))

(assert (= (ep$0 next_12$0 FP_13$0 sk_l1_15$0) t_135$0))

(assert (= (ep$0 next_12$0 FP_13$0 new_sorted_4$0) t_134$0))

(assert (= (ep$0 next_12$0 FP_13$0 lst_init$0) t_133$0))

(assert (= (ep$0 next_12$0 FP_13$0 lst_4$0) t_132$0))

(assert (= (ep$0 next_12$0 FP_13$0 lst_3$0) t_131$0))

(assert (= (ep$0 next_12$0 FP_13$0 null$0) t_130$0))

(assert (= (ep$0 next$0 FP_11$0 sorted_init_1$0) t_129$0))

(assert (= (ep$0 next$0 FP_11$0 sorted_13$0) t_128$0))

(assert (= (ep$0 next$0 FP_11$0 sorted_12$0) t_127$0))

(assert (= (ep$0 next$0 FP_11$0 sk_l2_15$0) t_126$0))

(assert (= (ep$0 next$0 FP_11$0 sk_l1_15$0) t_125$0))

(assert (= (ep$0 next$0 FP_11$0 new_sorted_4$0) t_124$0))

(assert (= (ep$0 next$0 FP_11$0 lst_init$0) t_123$0))

(assert (= (ep$0 next$0 FP_11$0 lst_4$0) t_122$0))

(assert (= (ep$0 next$0 FP_11$0 lst_3$0) t_121$0))

(assert (= (ep$0 next$0 FP_11$0 null$0) t_120$0))

(assert (forall ((?f FldLoc)) (= (read$1 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Loc)) (not (in$0 x emptyset$0))))

(assert (or (Btwn$0 next$0 lst_3$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_385$0 next$0 lst_3$0 null$0))))

(assert (or (Btwn$0 next_12$0 lst_4$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_382$0 next_12$0 lst_4$0 null$0))))

(assert (or (and (Btwn$0 next$0 sorted_init_1$0 null$0 null$0) Axiom_111$0)
    (not (slseg_struct$0 sk_?X_379$0 data$0 next$0 sorted_init_1$0 null$0))))

(assert (or (not Axiom_112$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next_12$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_381$0)) (not (in$0 l2 sk_?X_381$0))))))

(assert (or (and (Btwn$0 next_12$0 new_sorted_4$0 null$0 null$0) Axiom_113$0)
    (not (slseg_struct$0 sk_?X_388$0 data$0 next_12$0 new_sorted_4$0 null$0))))

(assert (or (not Axiom_114$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next_12$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_389$0)) (not (in$0 l2 sk_?X_389$0))))))

(assert (or (and (Btwn$0 next_13$0 sorted_13$0 null$0 null$0) Axiom_115$0)
    (not (slseg_struct$0 sk_?X_386$0 data$0 next_13$0 sorted_13$0 null$0))))

(assert (or (not Axiom_116$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next_13$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_391$0)) (not (in$0 l2 sk_?X_391$0))))))

(assert (= FP_12$0
  (union$0 (setminus$0 FP$0 FP_11$0)
    (union$0 (intersection$0 Alloc$0 FP_11$0) (setminus$0 Alloc$0 Alloc$0)))))

(assert (= FP_Caller_6$0 (setminus$0 FP_Caller$0 FP$0)))

(assert (= new_sorted_2$0 new_sorted_init$0))

(assert (Frame$1 FP_11$0 Alloc$0 data$0 data$0))

(assert (Frame$1 FP_13$0 Alloc$0 data$0 data$0))

(assert (= Alloc$0 (union$0 FP_12$0 Alloc$0)))

(assert (= Alloc$0 (union$0 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_384$0 sk_?X_385$0))

(assert (= sk_?X_385$0 (lseg_domain$0 next$0 lst_3$0 null$0)))

(assert (lseg_struct$0 sk_?X_385$0 next$0 lst_3$0 null$0))

(assert (= emptyset$0 (intersection$0 sk_?X_380$0 sk_?X_379$0)))

(assert (= sk_?X_378$0 FP$0))

(assert (= sk_?X_380$0 (lseg_domain$0 next$0 lst_init$0 null$0)))

(assert (lseg_struct$0 sk_?X_380$0 next$0 lst_init$0 null$0))

(assert (= emptyset$0 (intersection$0 sk_?X_381$0 sk_?X_382$0)))

(assert (= sk_?X_382$0 (lseg_domain$0 next_12$0 lst_4$0 null$0)))

(assert (= sk_?X_383$0 (union$0 sk_?X_381$0 sk_?X_382$0)))

(assert (slseg_struct$0 sk_?X_381$0 data$0 next_12$0 new_sorted_4$0 null$0))

(assert (= sk_?X_387$0 (union$0 sk_?X_389$0 sk_?X_388$0)))

(assert (= sk_?X_388$0 (slseg_domain$0 data$0 next_12$0 new_sorted_4$0 null$0)))

(assert (= FP_12$0 (union$0 FP_13$0 FP_12$0)))

(assert (slseg_struct$0 sk_?X_389$0 data$0 next_12$0 sorted_12$0 null$0))

(assert (= sk_?X_386$0 (slseg_domain$0 data$0 next_13$0 sorted_13$0 null$0)))

(assert (= sk_?X_390$0 (union$0 sk_?X_392$0 sk_?X_391$0)))

(assert (= sk_?X_392$0 (lseg_domain$0 next_13$0 lst_4$0 null$0)))

(assert (or (in$0 sk_l1_15$0 (intersection$0 sk_?X_392$0 sk_?X_391$0))
    (and (in$0 sk_l2_15$0 sk_FP_11$0) (not (in$0 sk_l2_15$0 FP_14$0)))
    (not (Btwn$0 next_13$0 lst_4$0 null$0 null$0))
    (not (Btwn$0 next_13$0 sorted_13$0 null$0 null$0))
    (and (Btwn$0 next_13$0 sk_l1_15$0 sk_l2_15$0 null$0)
         (in$0 sk_l1_15$0 sk_?X_391$0) (in$0 sk_l2_15$0 sk_?X_391$0)
         (not (<= (read$0 data$0 sk_l1_15$0) (read$0 data$0 sk_l2_15$0))))))

(assert (not (in$0 null$0 Alloc$0)))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next$0 lst_init$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next$0 lst_init$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_12$0 lst_4$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next_12$0 lst_4$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next_12$0 lst_4$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next_12$0 lst_4$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_12$0 sorted_12$0 l1 null$0)
                 (in$0 l1
                   (slseg_domain$0 data$0 next_12$0 sorted_12$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next_12$0 sorted_12$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (slseg_domain$0 data$0 next_12$0 sorted_12$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_13$0 sorted_13$0 l1 null$0)
                 (in$0 l1
                   (slseg_domain$0 data$0 next_13$0 sorted_13$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next_13$0 sorted_13$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (slseg_domain$0 data$0 next_13$0 sorted_13$0 null$0)))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$0 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (not Axiom_117$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (in$0 ?x FP_13$0)
                (and (Btwn$0 next_12$0 ?x ?z ?y) (Btwn$0 next_13$0 ?x ?z ?y))
                (and (not (Btwn$0 next_12$0 ?x ?z ?y))
                     (not (Btwn$0 next_13$0 ?x ?z ?y)))
                (not (= ?x (ep$0 next_12$0 FP_13$0 ?x)))))))

(assert (or (not Axiom_118$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (and (Btwn$0 next_12$0 ?x ?z ?y) (Btwn$0 next_13$0 ?x ?z ?y))
                (and (not (Btwn$0 next_12$0 ?x ?z ?y))
                     (not (Btwn$0 next_13$0 ?x ?z ?y)))
                (not
                     (or (Btwn$0 next_12$0 ?x ?y (ep$0 next_12$0 FP_13$0 ?x))
                         (and (Btwn$0 next_12$0 ?x ?y ?y)
                              (not
                                   (Btwn$0 next_12$0 ?x
                                     (ep$0 next_12$0 FP_13$0 ?x)
                                     (ep$0 next_12$0 FP_13$0 ?x))))))))))

(assert (or (not Axiom_119$0)
    (forall ((?x Loc))
            (or (= (read$1 next_12$0 ?x) (read$1 next_13$0 ?x))
                (not (in$0 ?x (setminus$0 Alloc$0 FP_13$0)))))))

(assert (or (and Axiom_122$0 Axiom_121$0 Axiom_120$0)
    (not (Frame$0 FP_11$0 Alloc$0 next$0 next_12$0))))

(assert (or (Btwn$0 next$0 lst_init$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_380$0 next$0 lst_init$0 null$0))))

(assert (or (Btwn$0 next_13$0 lst_4$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_392$0 next_13$0 lst_4$0 null$0))))

(assert (or (not Axiom_111$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_379$0)) (not (in$0 l2 sk_?X_379$0))))))

(assert (or (and (Btwn$0 next_12$0 new_sorted_4$0 null$0 null$0) Axiom_112$0)
    (not (slseg_struct$0 sk_?X_381$0 data$0 next_12$0 new_sorted_4$0 null$0))))

(assert (or (not Axiom_113$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next_12$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_388$0)) (not (in$0 l2 sk_?X_388$0))))))

(assert (or (and (Btwn$0 next_12$0 sorted_12$0 null$0 null$0) Axiom_114$0)
    (not (slseg_struct$0 sk_?X_389$0 data$0 next_12$0 sorted_12$0 null$0))))

(assert (or (not Axiom_115$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next_13$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_386$0)) (not (in$0 l2 sk_?X_386$0))))))

(assert (or (and (Btwn$0 next_13$0 sorted_13$0 null$0 null$0) Axiom_116$0)
    (not (slseg_struct$0 sk_?X_391$0 data$0 next_13$0 sorted_13$0 null$0))))

(assert (= FP_14$0
  (union$0 (setminus$0 FP_12$0 FP_13$0)
    (union$0 (intersection$0 Alloc$0 FP_13$0) (setminus$0 Alloc$0 Alloc$0)))))

(assert (= lst_3$0 lst_init$0))

(assert (= sorted_12$0 sorted_init_1$0))

(assert (Frame$0 FP_11$0 Alloc$0 next$0 next_12$0))

(assert (Frame$0 FP_13$0 Alloc$0 next_12$0 next_13$0))

(assert (= Alloc$0 (union$0 FP_14$0 Alloc$0)))

(assert (= emptyset$0 emptyset$0))

(assert (= sk_?X_384$0 FP_11$0))

(assert (= FP$0 (union$0 FP_11$0 FP$0)))

(assert (not (= lst_3$0 null$0)))

(assert (= sk_?X_378$0 (union$0 sk_?X_380$0 sk_?X_379$0)))

(assert (= sk_?X_379$0 (slseg_domain$0 data$0 next$0 sorted_init_1$0 null$0)))

(assert (= FP_Caller$0 (union$0 FP$0 FP_Caller$0)))

(assert (slseg_struct$0 sk_?X_379$0 data$0 next$0 sorted_init_1$0 null$0))

(assert (= sk_?X_381$0 (slseg_domain$0 data$0 next_12$0 new_sorted_4$0 null$0)))

(assert (= sk_?X_383$0
  (union$0 (intersection$0 Alloc$0 FP_11$0) (setminus$0 Alloc$0 Alloc$0))))

(assert (lseg_struct$0 sk_?X_382$0 next_12$0 lst_4$0 null$0))

(assert (= emptyset$0 (intersection$0 sk_?X_389$0 sk_?X_388$0)))

(assert (= sk_?X_387$0 FP_13$0))

(assert (= sk_?X_389$0 (slseg_domain$0 data$0 next_12$0 sorted_12$0 null$0)))

(assert (slseg_struct$0 sk_?X_388$0 data$0 next_12$0 new_sorted_4$0 null$0))

(assert (= sk_?X_386$0
  (union$0 (intersection$0 Alloc$0 FP_13$0) (setminus$0 Alloc$0 Alloc$0))))

(assert (slseg_struct$0 sk_?X_386$0 data$0 next_13$0 sorted_13$0 null$0))

(assert (= sk_?X_391$0 (slseg_domain$0 data$0 next_13$0 sorted_13$0 null$0)))

(assert (= sk_FP_11$0 sk_?X_390$0))

(assert (not (= lst_3$0 null$0)))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_3$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next$0 lst_3$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst_3$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next$0 lst_3$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 sorted_init_1$0 l1 null$0)
                 (in$0 l1
                   (slseg_domain$0 data$0 next$0 sorted_init_1$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 sorted_init_1$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (slseg_domain$0 data$0 next$0 sorted_init_1$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_12$0 new_sorted_4$0 l1 null$0)
                 (in$0 l1
                   (slseg_domain$0 data$0 next_12$0 new_sorted_4$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next_12$0 new_sorted_4$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (slseg_domain$0 data$0 next_12$0 new_sorted_4$0
                          null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_13$0 lst_4$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next_13$0 lst_4$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next_13$0 lst_4$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next_13$0 lst_4$0 null$0)))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$0 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$0 ?y ?X))
            (in$0 (ep$0 ?f ?X ?x) ?X))))

(assert (or (and Axiom_119$0 Axiom_118$0 Axiom_117$0)
    (not (Frame$0 FP_13$0 Alloc$0 next_12$0 next_13$0))))

(assert (or (not Axiom_120$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (in$0 ?x FP_11$0)
                (and (Btwn$0 next$0 ?x ?z ?y) (Btwn$0 next_12$0 ?x ?z ?y))
                (and (not (Btwn$0 next$0 ?x ?z ?y))
                     (not (Btwn$0 next_12$0 ?x ?z ?y)))
                (not (= ?x (ep$0 next$0 FP_11$0 ?x)))))))

(assert (or (not Axiom_121$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (and (Btwn$0 next$0 ?x ?z ?y) (Btwn$0 next_12$0 ?x ?z ?y))
                (and (not (Btwn$0 next$0 ?x ?z ?y))
                     (not (Btwn$0 next_12$0 ?x ?z ?y)))
                (not
                     (or (Btwn$0 next$0 ?x ?y (ep$0 next$0 FP_11$0 ?x))
                         (and (Btwn$0 next$0 ?x ?y ?y)
                              (not
                                   (Btwn$0 next$0 ?x (ep$0 next$0 FP_11$0 ?x)
                                     (ep$0 next$0 FP_11$0 ?x))))))))))

(assert (or (not Axiom_122$0)
    (forall ((?x Loc))
            (or (= (read$1 next$0 ?x) (read$1 next_12$0 ?x))
                (not (in$0 ?x (setminus$0 Alloc$0 FP_11$0)))))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$1 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$1 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$1 ?f ?x) (read$1 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
