(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source | Simple list theorem |)
(set-info :category "crafted")
(set-info :status sat)
(declare-sort List 0)
(declare-sort Elem 0)
(declare-fun cons (Elem List) List)
(declare-fun nil () List)
(declare-fun car (List) Elem)
(declare-fun cdr (List) List)
(declare-fun len (List) Int)
(assert (forall ((?x Elem) (?y List)) (= (car (cons ?x ?y)) ?x)))
(assert (forall ((?x Elem) (?y List)) (= (cdr (cons ?x ?y)) ?y)))
(assert (= (len nil) 0))
(declare-fun append (List List) List)
(assert (forall ((?y List)) (= (append nil ?y) ?y)))
(assert (forall ((?x Elem) (?y1 List) (?y2 List)) (= (append (cons ?x ?y1) ?y2) (cons ?x (append ?y1 ?y2)))))
(assert (not (forall ((?x1 Elem) (?x2 Elem) (?x3 Elem) (?y1 List) (?y2 List)) (> (len (append (cons ?x1 (cons ?x2 (cons ?x3 ?y1))) ?y2)) (len (append ?y1 ?y2))))))
(check-sat)
(exit)
