(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S4 S5) S1)
(declare-fun f6 () S5)
(declare-fun f7 (S6 S7) S1)
(declare-fun f8 (S2 S4) S6)
(declare-fun f9 () S7)
(declare-fun f10 (S8) S2)
(declare-fun f11 (S9 S8) Int)
(declare-fun f12 () S9)
(declare-fun f13 (S10 S4) S8)
(declare-fun f14 () S10)
(declare-fun f15 () S6)
(declare-fun f16 () S6)
(declare-fun f17 (S3) S3)
(declare-fun f18 (S7) S7)
(declare-fun f19 (S11) S7)
(declare-fun f20 () S11)
(declare-fun f21 (S5 S4) S1)
(declare-fun f22 (S2 S3) S1)
(declare-fun f23 (S7 S6) S1)
(declare-fun f24 (S12 Int) S8)
(declare-fun f25 () S12)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (forall ((?v1 S4)) (=> (= (f5 ?v1 f6) f1) (= (f7 (f8 ?v0 ?v1) f9) f1))))))
(assert (forall ((?v0 S8) (?v1 S4)) (= (f8 (f10 ?v0) ?v1) (ite (< (f11 f12 (f13 f14 ?v1)) (f11 f12 ?v0)) f15 f16))))
(assert (forall ((?v0 S3)) (= (f17 ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 ?v0) ?v0)))
(assert (= f9 (f18 (f19 f20))))
(assert (forall ((?v0 S4) (?v1 S5)) (= (= (f5 ?v0 ?v1) f1) (= (f21 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (= (f22 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S6) (?v1 S7)) (= (= (f7 ?v0 ?v1) f1) (= (f23 ?v1 ?v0) f1))))
(assert (not (forall ((?v0 S8)) (=> (= (f7 f15 f9) f1) (=> (= (f7 f16 f9) f1) (= (f22 (f10 ?v0) (f17 f4)) f1))))))
(assert (forall ((?v0 S8)) (= (f24 f25 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f24 f25 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f24 f25 ?v0)) 0))))
(check-sat)
(exit)
