(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 S3) S3)
(declare-fun f5 (S2) S4)
(declare-fun f6 (S2 S3) S1)
(declare-fun f7 () S3)
(declare-fun f8 (S5 S2) Int)
(declare-fun f9 () S5)
(declare-fun f10 (S6 S2) S3)
(declare-fun f11 (S2) S6)
(declare-fun f12 (S7 Int) S2)
(declare-fun f13 () S7)
(declare-fun f14 (S3) S4)
(declare-fun f15 (S2) S4)
(declare-fun f16 (S3) S3)
(declare-fun f17 () S3)
(declare-fun f18 (S2) S3)
(declare-fun f19 (S8 S3) S2)
(declare-fun f20 () S8)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f6 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f7 ?v0) f1) false)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f11 ?v0))) (let ((?v_2 (f12 f13 (+ ?v_0 (f8 f9 ?v2))))) (=> (<= (f8 f9 ?v0) ?v_0) (= (f10 ?v_1 ?v_2) (f4 (f14 (f10 ?v_1 ?v1)) (f10 (f11 ?v1) ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f4 (f15 ?v0) ?v1) (f16 (f4 (f5 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f10 ?v_1 (f12 f13 (+ ?v_0 1))) (ite (<= (f8 f9 ?v0) ?v_0) (f4 (f15 ?v1) (f10 ?v_1 ?v1)) f17)))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f15 ?v0))) (= (f4 ?v_0 ?v1) (f4 (f14 (f4 ?v_0 f17)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (let ((?v_1 (f15 ?v0)) (?v_0 (f15 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (= f17 (f16 f7)))
(assert (forall ((?v0 S2)) (= (f10 (f11 ?v0) (f12 f13 (+ (f8 f9 ?v0) 1))) (f4 (f15 ?v0) f17))))
(assert (let ((?v_0 (f12 f13 0))) (= (f18 ?v_0) (f4 (f15 ?v_0) f17))))
(assert (forall ((?v0 S2)) (= (f19 f20 (f4 (f15 ?v0) f17)) ?v0)))
(assert (let ((?v_0 (f12 f13 0))) (not (= (f10 (f11 ?v_0) (f12 f13 (+ (+ (+ (+ 0 1) 1) 1) 1))) (f4 (f15 ?v_0) (f4 (f15 (f12 f13 1)) (f4 (f15 (f12 f13 2)) (f4 (f15 (f12 f13 3)) f17))))))))
(assert (forall ((?v0 S2)) (= (f12 f13 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
