(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 () S3)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S2) Int)
(declare-fun f8 () S5)
(declare-fun f9 () S3)
(declare-fun f10 () S3)
(declare-fun f11 (S6 S2) S1)
(declare-fun f12 (S7 S6) S6)
(declare-fun f13 () S7)
(declare-fun f14 (S8 S6) S1)
(declare-fun f15 (S9 S2) S8)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S2) S3)
(declare-fun f18 () S10)
(declare-fun f19 (S11 S6) S7)
(declare-fun f20 () S11)
(declare-fun f21 () S11)
(declare-fun f22 () S3)
(declare-fun f23 () S6)
(declare-fun f24 () S11)
(declare-fun f25 (S12 S3) S7)
(declare-fun f26 () S12)
(declare-fun f27 (S13 S2) S6)
(declare-fun f28 (S14 S2) S13)
(declare-fun f29 () S14)
(declare-fun f30 () S2)
(declare-fun f31 () S6)
(declare-fun f32 () S10)
(declare-fun f33 () S10)
(declare-fun f34 (S15 S1) S1)
(declare-fun f35 (S16 S1) S15)
(declare-fun f36 () S16)
(declare-fun f37 () S7)
(declare-fun f38 () S10)
(declare-fun f39 () S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 f6 (+ (* 2 (f7 f8 ?v0)) 1)))))
(assert (forall ((?v0 S2)) (= (f3 f9 ?v0) (f5 f6 (* 2 (f7 f8 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 f10 ?v0) (f5 f6 (+ (f7 f8 ?v0) 1)))))
(assert (forall ((?v0 S6) (?v1 S2)) (= (= (f11 (f12 f13 ?v0) ?v1) f1) (= (f14 (f15 f16 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f17 f18 ?v0) ?v1) (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f15 f16 ?v2))) (= (= (f11 (f12 (f19 f20 ?v0) ?v1) ?v2) f1) (and (= (f14 ?v_0 ?v0) f1) (= (f14 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (= (= (f11 (f12 (f19 f21 ?v0) ?v1) ?v2) f1) (and (= (f11 ?v0 ?v2) f1) (= (f11 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2)) (= (f3 f22 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (= (f11 f23 ?v0) f1) false)))
(assert (let ((?v_0 (f27 (f28 f29 (f5 f6 0)) f30))) (not (= (f12 (f19 f24 (f12 (f25 f26 f9) ?v_0)) (f12 (f25 f26 f4) ?v_0)) f31))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f12 (f19 f24 (f27 (f28 f29 ?v0) ?v1)) (f27 (f28 f29 ?v1) ?v2)) f31)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (f12 (f25 f26 (f17 f18 ?v0)) (f27 (f28 f29 ?v1) ?v2)) (f27 (f28 f29 (f5 f6 (+ (f7 f8 ?v1) ?v_0))) (f5 f6 (+ (f7 f8 ?v2) ?v_0)))))))
(assert (forall ((?v0 S6) (?v1 S2) (?v2 S6)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v2 ?v1) f1) (= (f11 (f12 (f19 f24 ?v0) ?v2) ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f15 f16 ?v0))) (=> (= (f14 ?v_0 ?v1) f1) (=> (= (f14 ?v_0 ?v2) f1) (= (f14 ?v_0 (f12 (f19 f24 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f15 f16 ?v0))) (=> (= (f14 ?v_0 (f12 (f19 f24 ?v1) ?v2)) f1) (=> (=> (= (f14 ?v_0 ?v1) f1) (=> (= (f14 ?v_0 ?v2) f1) false)) false)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (=> (= (f11 (f12 (f19 f24 ?v0) ?v1) ?v2) f1) (=> (=> (= (f11 ?v0 ?v2) f1) (=> (= (f11 ?v1 ?v2) f1) false)) false))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2) (?v3 S6)) (=> (= ?v0 (f3 ?v1 ?v2)) (=> (= (f14 (f15 f16 ?v2) ?v3) f1) (= (f14 (f15 f16 ?v0) (f12 (f25 f26 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f14 (f15 f16 ?v0) f31) f1) false)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f12 (f25 f26 f10) (f27 (f28 f29 ?v0) ?v1)) (f27 (f28 f29 (f5 f6 (+ (f7 f8 ?v0) 1))) (f5 f6 (+ (f7 f8 ?v1) 1))))))
(assert (forall ((?v0 S2)) (= (f27 (f28 f29 ?v0) (f5 f6 0)) f31)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f12 (f19 f24 (f27 (f28 f29 ?v0) ?v1)) (f27 (f28 f29 ?v2) ?v3)) (f27 (f28 f29 (f3 (f17 f32 ?v0) ?v2)) (f3 (f17 f33 ?v1) ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (= (= (f11 (f12 (f19 f24 ?v0) ?v1) ?v2) f1) (= (f34 (f35 f36 (f11 ?v0 ?v2)) (f11 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S6) (?v1 S2)) (=> (= ?v0 f31) (not (= (f14 (f15 f16 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S6)) (= (= (f12 f37 ?v0) f31) (forall ((?v1 S2)) (not (= (f11 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2)) (= (= (f14 (f15 f16 ?v0) f31) f1) false)))
(assert (forall ((?v0 S6)) (= (= f31 (f12 f37 ?v0)) (forall ((?v1 S2)) (not (= (f11 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S6)) (= (forall ((?v1 S2)) (=> (= (f14 (f15 f16 ?v1) f31) f1) (= (f11 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S6)) (= (exists ((?v1 S2)) (and (= (f14 (f15 f16 ?v1) f31) f1) (= (f11 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S6)) (= (exists ((?v1 S2)) (= (f14 (f15 f16 ?v1) ?v0) f1)) (not (= ?v0 f31)))))
(assert (forall ((?v0 S6)) (= (forall ((?v1 S2)) (not (= (f14 (f15 f16 ?v1) ?v0) f1))) (= ?v0 f31))))
(assert (= f31 (f12 f37 f23)))
(assert (forall ((?v0 S2)) (= (= (f11 f31 ?v0) f1) (= (f14 (f15 f16 ?v0) f31) f1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f19 f24 ?v0))) (= (f12 (f19 f24 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f19 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f17 f38 ?v0))) (= (f3 (f17 f38 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f17 f38 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f35 f36 ?v0))) (= (= (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v2) f1) (= (f34 ?v_0 (f34 (f35 f36 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f19 f24 ?v0))) (= (f12 (f19 f24 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f19 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f17 f38 ?v0))) (= (f3 (f17 f38 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f17 f38 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f35 f36 ?v0))) (= (= (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v2) f1) (= (f34 ?v_0 (f34 (f35 f36 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f19 f24 ?v0))) (= (f12 (f19 f24 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f19 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f17 f38 ?v0))) (= (f3 (f17 f38 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f17 f38 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f35 f36 ?v0))) (= (= (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v2) f1) (= (f34 ?v_0 (f34 (f35 f36 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f19 f24 ?v0)) (?v_0 (f19 f24 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f17 f38 ?v0)) (?v_0 (f17 f38 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f35 f36 ?v0)) (?v_0 (f35 f36 ?v1))) (= (= (f34 ?v_1 (f34 ?v_0 ?v2)) f1) (= (f34 ?v_0 (f34 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f19 f24 ?v0)) (?v_0 (f19 f24 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f17 f38 ?v0)) (?v_0 (f17 f38 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f35 f36 ?v0)) (?v_0 (f35 f36 ?v1))) (= (= (f34 ?v_1 (f34 ?v_0 ?v2)) f1) (= (f34 ?v_0 (f34 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f19 f24 ?v0)) (?v_0 (f19 f24 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f17 f38 ?v0)) (?v_0 (f17 f38 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f35 f36 ?v0)) (?v_0 (f35 f36 ?v1))) (= (= (f34 ?v_1 (f34 ?v_0 ?v2)) f1) (= (f34 ?v_0 (f34 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f19 f24 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f17 f38 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f35 f36 ?v0))) (let ((?v_1 (f34 ?v_0 ?v1))) (= (= (f34 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f19 f24 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f17 f38 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f35 f36 ?v0))) (let ((?v_1 (f34 ?v_0 ?v1))) (= (= (f34 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f19 f24 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f17 f38 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f35 f36 ?v0))) (let ((?v_1 (f34 ?v_0 ?v1))) (= (= (f34 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f12 (f19 f24 ?v0) ?v1) (f12 (f19 f24 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f17 f38 ?v0) ?v1) (f3 (f17 f38 ?v1) ?v0))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f34 (f35 f36 ?v0) ?v1) f1) (= (f34 (f35 f36 ?v1) ?v0) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f12 (f19 f24 ?v0) ?v1) (f12 (f19 f24 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f17 f38 ?v0) ?v1) (f3 (f17 f38 ?v1) ?v0))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f34 (f35 f36 ?v0) ?v1) f1) (= (f34 (f35 f36 ?v1) ?v0) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f12 (f19 f24 ?v0) ?v1) (f12 (f19 f24 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f17 f38 ?v0) ?v1) (f3 (f17 f38 ?v1) ?v0))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f34 (f35 f36 ?v0) ?v1) f1) (= (f34 (f35 f36 ?v1) ?v0) f1))))
(assert (forall ((?v0 S6)) (= (f12 (f19 f24 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f17 f38 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S1)) (= (= (f34 (f35 f36 ?v0) ?v0) f1) (= ?v0 f1))))
(assert (forall ((?v0 S6)) (= (f12 (f19 f24 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f17 f38 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S1)) (= (= (f34 (f35 f36 ?v0) ?v0) f1) (= ?v0 f1))))
(assert (= f38 f33))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2) (?v3 S3)) (=> (= (f14 (f15 f16 ?v0) ?v1) f1) (=> (= ?v2 (f3 ?v3 ?v0)) (= (f14 (f15 f16 ?v2) (f12 (f25 f26 ?v3) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S3)) (=> (= (f14 (f15 f16 ?v0) ?v1) f1) (= (f14 (f15 f16 (f3 ?v2 ?v0)) (f12 (f25 f26 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S6)) (= (= (f14 (f15 f16 ?v0) (f12 (f25 f26 ?v1) ?v2)) f1) (exists ((?v3 S2)) (and (= (f14 (f15 f16 ?v3) ?v2) f1) (= ?v0 (f3 ?v1 ?v3)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (=> (= (f11 (f12 (f19 f24 ?v0) ?v1) ?v2) f1) (= (f11 ?v1 ?v2) f1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (=> (= (f11 (f12 (f19 f24 ?v0) ?v1) ?v2) f1) (= (f11 ?v0 ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f15 f16 ?v0))) (=> (= (f14 ?v_0 (f12 (f19 f24 ?v1) ?v2)) f1) (= (f14 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f15 f16 ?v0))) (=> (= (f14 ?v_0 (f12 (f19 f24 ?v1) ?v2)) f1) (= (f14 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f19 f24 ?v0))) (= (f12 (f19 f24 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f19 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f15 f16 ?v0))) (= (= (f14 ?v_0 (f12 (f19 f24 ?v1) ?v2)) f1) (and (= (f14 ?v_0 ?v1) f1) (= (f14 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f19 f24 ?v0)) (?v_0 (f19 f24 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f19 f24 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f12 (f19 f24 ?v0) ?v1) (f12 (f19 f24 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f12 (f19 f24 ?v0) ?v1) (f12 f37 (f12 (f19 f20 ?v0) ?v1)))))
(assert (forall ((?v0 S6)) (= (f12 (f19 f24 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f12 (f25 f26 f22) ?v0) ?v0)))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (= (= (f11 (f12 (f19 f24 (f12 f13 ?v0)) (f12 f13 ?v1)) ?v2) f1) (= (f14 (f15 f16 ?v2) (f12 (f19 f24 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f15 f16 ?v0))) (= (= (f14 ?v_0 (f12 (f19 f24 ?v1) (f12 f37 ?v2))) f1) (and (= (f14 ?v_0 ?v1) f1) (= (f11 ?v2 ?v0) f1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f12 f37 (f12 (f19 f21 ?v0) ?v1)) (f12 (f19 f24 (f12 f37 ?v0)) (f12 f37 ?v1)))))
(assert (forall ((?v0 S6)) (= (f12 (f19 f24 ?v0) f31) f31)))
(assert (forall ((?v0 S1)) (= (= (f34 (f35 f36 ?v0) f39) f1) (= f39 f1))))
(assert (forall ((?v0 S6)) (= (f12 (f19 f24 f31) ?v0) f31)))
(assert (forall ((?v0 S1)) (= (= (f34 (f35 f36 f39) ?v0) f1) (= f39 f1))))
(assert (forall ((?v0 S3) (?v1 S6)) (= (= (f12 (f25 f26 ?v0) ?v1) f31) (= ?v1 f31))))
(assert (forall ((?v0 S3)) (= (f12 (f25 f26 ?v0) f31) f31)))
(assert (forall ((?v0 S2)) (= (f5 f6 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
