(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 () S5)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 () S3)
(declare-fun f9 () S4)
(declare-fun f10 (S6 S3) Int)
(declare-fun f11 () S6)
(declare-fun f12 (S7 S3) S3)
(declare-fun f13 (S8 S3) S7)
(declare-fun f14 () S8)
(declare-fun f15 () S3)
(declare-fun f16 (S9 Int) S6)
(declare-fun f17 () S9)
(declare-fun f18 (S10 Int) S3)
(declare-fun f19 () S10)
(declare-fun f20 (S11 Int) Int)
(declare-fun f21 () S11)
(declare-fun f22 (S12 Int) S11)
(declare-fun f23 () S12)
(declare-fun f24 () S8)
(declare-fun f25 (S13 S4) S4)
(declare-fun f26 (S14 S4) S13)
(declare-fun f27 () S14)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (f4 f5 (f3 f6 f7)) f8) f9))))
(assert (< 0 (f10 f11 f8)))
(assert (< (f10 f11 f8) (f10 f11 f7)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f3 f6 ?v0)) ?v0) f9)))
(assert (forall ((?v0 S3)) (= (f12 (f13 f14 f15) ?v0) f15)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f9) ?v0) f9)))
(assert (forall ((?v0 S3)) (= (f10 (f16 f17 1) ?v0) 1)))
(assert (= (f12 (f13 f14 f15) (f18 f19 2)) f15))
(assert (= (f3 (f4 f5 f9) (f18 f19 2)) f9))
(assert (= (f10 (f16 f17 1) (f18 f19 2)) 1))
(assert (forall ((?v0 S3)) (= (f12 (f13 f14 ?v0) (f18 f19 0)) f15)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f18 f19 0)) f9)))
(assert (forall ((?v0 Int)) (= (f10 (f16 f17 ?v0) (f18 f19 0)) 1)))
(assert (forall ((?v0 S3)) (= (f12 (f13 f14 ?v0) (f18 f19 0)) f15)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f18 f19 0)) f9)))
(assert (forall ((?v0 Int)) (= (f10 (f16 f17 ?v0) (f18 f19 0)) 1)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f20 f21 (f10 (f16 f17 ?v0) ?v1)) (f10 (f16 f17 (f20 f21 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 (f16 f17 ?v0) (f18 f19 2)))) (= (f20 f21 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f10 (f16 f17 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f12 (f13 f14 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f10 (f16 f17 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f12 (f13 f14 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f19 2))) (= (f10 (f16 f17 (f20 f21 ?v0)) ?v_0) (f10 (f16 f17 ?v0) ?v_0)))))
(assert (= (f20 f21 1) 1))
(assert (forall ((?v0 S3)) (= (= f15 ?v0) (= ?v0 f15))))
(assert (forall ((?v0 S4)) (= (= f9 ?v0) (= ?v0 f9))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f11 ?v0))) (let ((?v_1 (f22 f23 ?v_0))) (=> (< 0 ?v_0) (= (f3 (f4 f5 (f3 f6 (f18 f19 (f20 ?v_1 (f10 f11 ?v1))))) (f18 f19 (f20 ?v_1 (f10 f11 ?v2)))) (f3 (f4 f5 (f3 f6 ?v1)) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 f21 (f20 (f22 f23 ?v0) ?v1)) (f20 (f22 f23 (f20 f21 ?v0)) (f20 f21 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f12 (f13 f24 ?v0) ?v1) (f12 (f13 f24 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f25 (f26 f27 ?v0) ?v1) (f25 (f26 f27 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 (f22 f23 ?v0) ?v1) (f20 (f22 f23 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 ?v1) (ite (= ?v1 (f18 f19 0)) (f18 f19 1) (f18 f19 (f20 (f22 f23 (f10 f11 ?v0)) (f10 f11 (f12 ?v_0 (f18 f19 (- (f10 f11 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f18 f19 0)) (?v_2 (f10 f11 ?v0)) (?v_1 (f10 f11 ?v1))) (= (f18 f19 (f20 (f22 f23 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f18 f19 (+ ?v_1 (f20 (f22 f23 (f10 f11 (f18 f19 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f10 f11 ?v0))) (= (f18 f19 (* ?v_0 2)) (f18 f19 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f10 ?v_0 (f18 f19 (+ (* 2 (f10 f11 ?v1)) 1))) (f20 (f22 f23 ?v0) (f10 (f16 f17 (f10 ?v_0 ?v1)) (f18 f19 2)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f18 f19 (+ (* 2 (f10 f11 ?v1)) 1))) (f25 (f26 f27 ?v0) (f3 (f4 f5 (f3 ?v_0 ?v1)) (f18 f19 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f18 f19 (+ (* 2 (f10 f11 ?v1)) 1))) (f12 (f13 f24 ?v0) (f12 (f13 f14 (f12 ?v_0 ?v1)) (f18 f19 2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 (f18 f19 (+ (* 2 (f10 f11 ?v1)) 1))) (f20 (f22 f23 ?v0) (f20 (f22 f23 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f18 f19 (+ (* 2 (f10 f11 ?v1)) 1))) (f25 (f26 f27 ?v0) (f25 (f26 f27 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f18 f19 (+ (* 2 (f10 f11 ?v1)) 1))) (f12 (f13 f24 ?v0) (f12 (f13 f24 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f13 f24 ?v0)) (?v_0 (f13 f24 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f26 f27 ?v0)) (?v_0 (f26 f27 ?v1))) (= (f25 ?v_1 (f25 ?v_0 ?v2)) (f25 ?v_0 (f25 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f22 f23 ?v0)) (?v_0 (f22 f23 ?v1))) (= (f20 ?v_1 (f20 ?v_0 ?v2)) (f20 ?v_0 (f20 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f24 ?v0))) (= (f12 ?v_0 (f12 (f13 f24 ?v1) ?v2)) (f12 (f13 f24 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2)) (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f20 ?v_0 (f20 (f22 f23 ?v1) ?v2)) (f20 (f22 f23 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 (f18 f19 (* 2 (f10 f11 ?v1)))) (f20 (f22 f23 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f18 f19 (* 2 (f10 f11 ?v1)))) (f25 (f26 f27 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f18 f19 (* 2 (f10 f11 ?v1)))) (f12 (f13 f24 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (f20 (f22 f23 ?v_0) ?v_0) (f20 (f22 f23 ?v0) ?v0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f10 f11 ?v0))) (= (f18 f19 (* 2 ?v_0)) (f18 f19 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f24 ?v0))) (= (f12 (f13 f24 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f20 (f22 f23 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f22 f23 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f24 ?v0))) (= (f12 (f13 f24 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f20 (f22 f23 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f22 f23 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f24 ?v0))) (= (f12 (f13 f24 (f12 ?v_0 ?v1)) ?v2) (f12 (f13 f24 (f12 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 (f26 f27 (f25 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f20 (f22 f23 (f20 ?v_0 ?v1)) ?v2) (f20 (f22 f23 (f20 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f13 f24 ?v0)) (?v_1 (f12 (f13 f24 ?v2) ?v3))) (= (f12 (f13 f24 (f12 ?v_0 ?v1)) ?v_1) (f12 ?v_0 (f12 (f13 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f25 (f26 f27 ?v2) ?v3))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v_1) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f20 (f22 f23 ?v2) ?v3))) (= (f20 (f22 f23 (f20 ?v_0 ?v1)) ?v_1) (f20 ?v_0 (f20 (f22 f23 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f13 f24 (f12 (f13 f24 ?v0) ?v1))) (?v_0 (f13 f24 ?v2))) (= (f12 ?v_1 (f12 ?v_0 ?v3)) (f12 ?v_0 (f12 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f26 f27 (f25 (f26 f27 ?v0) ?v1))) (?v_0 (f26 f27 ?v2))) (= (f25 ?v_1 (f25 ?v_0 ?v3)) (f25 ?v_0 (f25 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f22 f23 (f20 (f22 f23 ?v0) ?v1))) (?v_0 (f22 f23 ?v2))) (= (f20 ?v_1 (f20 ?v_0 ?v3)) (f20 ?v_0 (f20 ?v_1 ?v3))))))
(assert (forall ((?v0 S3)) (= (f18 f19 (f10 f11 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f10 f11 (f18 f19 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f10 f11 (f18 f19 ?v0)) 0))))
(check-sat)
(exit)
