(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 () S3)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 () S3)
(declare-fun f11 (S7 S3) S3)
(declare-fun f12 () S7)
(declare-fun f13 () S7)
(declare-fun f14 (S8 S2) S7)
(declare-fun f15 () S8)
(declare-fun f16 () S2)
(declare-fun f17 () S2)
(declare-fun f18 (S9 S4) S4)
(declare-fun f19 (S10 S4) S9)
(declare-fun f20 () S10)
(declare-fun f21 () S10)
(declare-fun f22 (S11 S4) S3)
(declare-fun f23 () S11)
(declare-fun f24 () S3)
(declare-fun f25 (S12 Int) Int)
(declare-fun f26 (S13 Int) S12)
(declare-fun f27 () S13)
(declare-fun f28 (S14 Int) S6)
(declare-fun f29 () S14)
(declare-fun f30 (S15 S2) S2)
(declare-fun f31 (S16 S2) S15)
(declare-fun f32 () S16)
(declare-fun f33 () S16)
(declare-fun f34 () S10)
(declare-fun f35 () S16)
(declare-fun f36 () S12)
(declare-fun f37 () S13)
(declare-fun f38 () S16)
(declare-fun f39 () S13)
(declare-fun f40 () S16)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f3 f5 (f6 f7 (+ (* 2 (f8 f9 ?v0)) 1))))))
(assert (forall ((?v0 S2)) (= (f3 f10 ?v0) (f3 f5 (f6 f7 (* 2 (f8 f9 ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S2)) (= (f3 (f11 f12 ?v0) ?v1) (f3 ?v0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))))))
(assert (forall ((?v0 S3) (?v1 S2)) (= (f3 (f11 f13 ?v0) ?v1) (f3 ?v0 (f6 f7 (* 2 (f8 f9 ?v1)))))))
(assert (let ((?v_0 (f8 f9 f16))) (let ((?v_1 (f6 f7 (* 2 ?v_0))) (?v_3 (f14 f15 f16)) (?v_2 (f6 f7 (- (f8 f9 f17) ?v_0)))) (not (= (f3 (f11 (f14 f15 ?v_1) f5) f17) (f18 (f19 f20 (f3 (f11 ?v_3 f10) ?v_2)) (f18 (f19 f21 (f3 (f22 f23 (f3 f24 ?v_1)) ?v_2)) (f3 (f11 ?v_3 f4) ?v_2))))))))
(assert (< 0 (f8 f9 f16)))
(assert (<= (f8 f9 f16) (f8 f9 f17)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 (f8 f9 ?v1))) (?v_1 (f8 f9 ?v2))) (= (f3 (f22 f23 (f3 f24 (f6 f7 (* 2 (f8 f9 ?v0))))) (f6 f7 (f25 ?v_0 (* 2 ?v_1)))) (f3 (f22 f23 (f3 f24 ?v0)) (f6 f7 (f25 ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (let ((?v_1 (f26 f27 ?v_0))) (=> (< 0 ?v_0) (= (f3 (f22 f23 (f3 f24 (f6 f7 (f25 ?v_1 (f8 f9 ?v1))))) (f6 f7 (f25 ?v_1 (f8 f9 ?v2)))) (f3 (f22 f23 (f3 f24 ?v1)) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f25 (f26 f27 ?v0) (f8 (f28 f29 (f8 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f30 (f31 f33 ?v0) (f30 (f31 f32 (f30 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f18 (f19 f21 ?v0) (f3 (f22 f23 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f28 f29 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f25 (f26 f27 ?v0) (f25 (f26 f27 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (let ((?v_1 (f30 ?v_0 ?v1))) (= (f30 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f30 (f31 f33 ?v0) (f30 (f31 f33 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f18 (f19 f21 ?v0) (f18 (f19 f21 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f28 f29 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f25 (f26 f27 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (let ((?v_1 (f30 ?v_0 ?v1))) (= (f30 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f30 (f31 f33 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f18 (f19 f21 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f8 ?v_0 (f6 f7 (f25 (f26 f27 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f8 (f28 f29 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f6 f7 (f25 (f26 f27 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f30 (f31 f32 (f30 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (f25 (f26 f27 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f3 (f22 f23 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f8 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f8 (f28 f29 (f8 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f30 (f31 f32 (f30 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f3 (f22 f23 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f8 (f28 f29 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f6 f7 (f25 (f26 f27 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 (f31 f32 (f30 ?v_0 ?v1)) ?v2) (f30 ?v_0 (f6 f7 (f25 (f26 f27 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 (f22 f23 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f25 (f26 f27 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (let ((?v_0 (f6 f7 (* 2 (f8 f9 ?v0)))) (?v_1 (f14 f15 ?v0))) (= (f3 (f11 (f14 f15 ?v_0) ?v1) ?v2) (f18 (f19 f34 (f3 (f11 ?v_1 (f11 f13 ?v1)) ?v2)) (f18 (f19 f21 (f3 (f22 f23 (f3 f24 ?v_0)) ?v2)) (f3 (f11 ?v_1 (f11 f12 ?v1)) ?v2)))))))
(assert (forall ((?v0 Int)) (= (f25 (f26 f27 ?v0) ?v0) (f8 (f28 f29 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S2)) (= (f30 (f31 f33 ?v0) ?v0) (f30 (f31 f32 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S4)) (= (f18 (f19 f21 ?v0) ?v0) (f3 (f22 f23 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f25 (f26 f27 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f30 (f31 f33 ?v0) (f30 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f18 (f19 f21 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f25 (f26 f27 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f30 (f31 f33 ?v0) (f30 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f18 (f19 f21 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f25 (f26 f27 (f8 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f30 (f31 f33 (f30 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f18 (f19 f21 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f8 (f28 f29 ?v0) (f6 f7 2)) (f25 (f26 f27 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f30 (f31 f32 ?v0) (f6 f7 2)) (f30 (f31 f33 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f3 (f22 f23 ?v0) (f6 f7 2)) (f18 (f19 f21 ?v0) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f34 ?v0) ?v1) (f18 (f19 f34 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f30 (f31 f35 ?v0) ?v1) (f30 (f31 f35 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f19 f34 ?v0)) (?v_0 (f19 f34 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f31 f35 ?v0)) (?v_0 (f31 f35 ?v1))) (= (f30 ?v_1 (f30 ?v_0 ?v2)) (f30 ?v_0 (f30 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f34 ?v0))) (= (f18 ?v_0 (f18 (f19 f34 ?v1) ?v2)) (f18 (f19 f34 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f35 ?v0))) (= (f30 ?v_0 (f30 (f31 f35 ?v1) ?v2)) (f30 (f31 f35 (f30 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f34 ?v0))) (= (f18 (f19 f34 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f34 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f35 ?v0))) (= (f30 (f31 f35 (f30 ?v_0 ?v1)) ?v2) (f30 ?v_0 (f30 (f31 f35 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f34 ?v0))) (= (f18 (f19 f34 (f18 ?v_0 ?v1)) ?v2) (f18 (f19 f34 (f18 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f35 ?v0))) (= (f30 (f31 f35 (f30 ?v_0 ?v1)) ?v2) (f30 (f31 f35 (f30 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f34 ?v0))) (= (f18 (f19 f34 (f18 ?v_0 ?v1)) (f18 (f19 f34 ?v2) ?v3)) (f18 (f19 f34 (f18 ?v_0 ?v2)) (f18 (f19 f34 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f31 f35 ?v0))) (= (f30 (f31 f35 (f30 ?v_0 ?v1)) (f30 (f31 f35 ?v2) ?v3)) (f30 (f31 f35 (f30 ?v_0 ?v2)) (f30 (f31 f35 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f21 ?v0)) (?v_1 (f19 f21 ?v2))) (= (= (f18 (f19 f34 (f18 ?v_0 ?v1)) (f18 ?v_1 ?v3)) (f18 (f19 f34 (f18 ?v_0 ?v3)) (f18 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f26 f27 ?v2))) (= (= (+ (f25 ?v_0 ?v1) (f25 ?v_1 ?v3)) (+ (f25 ?v_0 ?v3) (f25 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f31 f33 ?v0)) (?v_1 (f31 f33 ?v2))) (= (= (f30 (f31 f35 (f30 ?v_0 ?v1)) (f30 ?v_1 ?v3)) (f30 (f31 f35 (f30 ?v_0 ?v3)) (f30 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f34 (f18 (f19 f21 ?v0) ?v1)) (f18 (f19 f21 ?v2) ?v1)) (f18 (f19 f21 (f18 (f19 f34 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f25 (f26 f27 ?v0) ?v1) (f25 (f26 f27 ?v2) ?v1)) (f25 (f26 f27 (+ ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f30 (f31 f35 (f30 (f31 f33 ?v0) ?v1)) (f30 (f31 f33 ?v2) ?v1)) (f30 (f31 f33 (f30 (f31 f35 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f21 (f18 (f19 f34 ?v0) ?v1)) ?v2) (f18 (f19 f34 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f25 (f26 f27 (+ ?v0 ?v1)) ?v2) (+ (f25 (f26 f27 ?v0) ?v2) (f25 (f26 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f30 (f31 f33 (f30 (f31 f35 ?v0) ?v1)) ?v2) (f30 (f31 f35 (f30 (f31 f33 ?v0) ?v2)) (f30 (f31 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f21 ?v0)) (?v_1 (f19 f21 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f18 (f19 f34 (f18 ?v_0 ?v2)) (f18 ?v_1 ?v3)) (f18 (f19 f34 (f18 ?v_0 ?v3)) (f18 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f26 f27 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (f25 ?v_0 ?v2) (f25 ?v_1 ?v3)) (+ (f25 ?v_0 ?v3) (f25 ?v_1 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f31 f33 ?v0)) (?v_1 (f31 f33 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f30 (f31 f35 (f30 ?v_0 ?v2)) (f30 ?v_1 ?v3)) (f30 (f31 f35 (f30 ?v_0 ?v3)) (f30 ?v_1 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f34 ?v1) ?v2)) (f18 (f19 f34 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (+ ?v1 ?v2)) (+ (f25 ?v_0 ?v1) (f25 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f33 ?v0))) (= (f30 ?v_0 (f30 (f31 f35 ?v1) ?v2)) (f30 (f31 f35 (f30 ?v_0 ?v1)) (f30 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f25 (f26 f27 (f8 f9 ?v0)) (f8 f9 (f30 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 (f19 f21 (f18 ?v_0 ?v1)) (f18 (f19 f21 ?v2) ?v3)) (f18 (f19 f21 (f18 ?v_0 ?v2)) (f18 (f19 f21 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) (f25 (f26 f27 ?v2) ?v3)) (f25 (f26 f27 (f25 ?v_0 ?v2)) (f25 (f26 f27 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f31 f33 ?v0))) (= (f30 (f31 f33 (f30 ?v_0 ?v1)) (f30 (f31 f33 ?v2) ?v3)) (f30 (f31 f33 (f30 ?v_0 ?v2)) (f30 (f31 f33 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f19 f21 (f18 (f19 f21 ?v0) ?v1))) (?v_0 (f19 f21 ?v2))) (= (f18 ?v_1 (f18 ?v_0 ?v3)) (f18 ?v_0 (f18 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f26 f27 (f25 (f26 f27 ?v0) ?v1))) (?v_0 (f26 f27 ?v2))) (= (f25 ?v_1 (f25 ?v_0 ?v3)) (f25 ?v_0 (f25 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f31 f33 (f30 (f31 f33 ?v0) ?v1))) (?v_0 (f31 f33 ?v2))) (= (f30 ?v_1 (f30 ?v_0 ?v3)) (f30 ?v_0 (f30 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f21 ?v0)) (?v_1 (f18 (f19 f21 ?v2) ?v3))) (= (f18 (f19 f21 (f18 ?v_0 ?v1)) ?v_1) (f18 ?v_0 (f18 (f19 f21 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f25 (f26 f27 ?v2) ?v3))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v_1) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f31 f33 ?v0)) (?v_1 (f30 (f31 f33 ?v2) ?v3))) (= (f30 (f31 f33 (f30 ?v_0 ?v1)) ?v_1) (f30 ?v_0 (f30 (f31 f33 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 (f19 f21 (f18 ?v_0 ?v1)) ?v2) (f18 (f19 f21 (f18 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 (f26 f27 (f25 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f33 ?v0))) (= (f30 (f31 f33 (f30 ?v_0 ?v1)) ?v2) (f30 (f31 f33 (f30 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 (f19 f21 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f21 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f33 ?v0))) (= (f30 (f31 f33 (f30 ?v_0 ?v1)) ?v2) (f30 ?v_0 (f30 (f31 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f21 ?v1) ?v2)) (f18 (f19 f21 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2)) (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f33 ?v0))) (= (f30 ?v_0 (f30 (f31 f33 ?v1) ?v2)) (f30 (f31 f33 (f30 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f19 f21 ?v0)) (?v_0 (f19 f21 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f26 f27 ?v0)) (?v_0 (f26 f27 ?v1))) (= (f25 ?v_1 (f25 ?v_0 ?v2)) (f25 ?v_0 (f25 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f31 f33 ?v0)) (?v_0 (f31 f33 ?v1))) (= (f30 ?v_1 (f30 ?v_0 ?v2)) (f30 ?v_0 (f30 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f21 ?v0) ?v1) (f18 (f19 f21 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f25 (f26 f27 ?v0) ?v1) (f25 (f26 f27 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f30 (f31 f33 ?v0) ?v1) (f30 (f31 f33 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f28 f29 (f25 f36 ?v0)) ?v_0) (f8 (f28 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f8 (f28 f29 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f30 (f31 f32 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f22 f23 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 (f28 f29 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f30 (f31 f32 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f22 f23 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 (f28 f29 ?v0) (f6 f7 2)))) (= (f25 f36 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f25 f36 (f8 (f28 f29 ?v0) ?v1)) (f8 (f28 f29 (f25 f36 ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (f25 (f26 f27 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f25 (f26 f27 (f8 f9 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f25 (f26 f27 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 (f31 f33 (f30 ?v_0 ?v1)) (f30 ?v_0 ?v2)) (f30 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 (f19 f21 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f8 (f28 f29 (f25 (f26 f27 ?v0) ?v1)) ?v2) (f25 (f26 f27 (f8 (f28 f29 ?v0) ?v2)) (f8 (f28 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f30 (f31 f32 (f30 (f31 f33 ?v0) ?v1)) ?v2) (f30 (f31 f33 (f30 (f31 f32 ?v0) ?v2)) (f30 (f31 f32 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (= (f3 (f22 f23 (f18 (f19 f21 ?v0) ?v1)) ?v2) (f18 (f19 f21 (f3 (f22 f23 ?v0) ?v2)) (f3 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f8 (f28 f29 (f25 (f26 f27 ?v0) ?v1)) ?v2) (f25 (f26 f27 (f8 (f28 f29 ?v0) ?v2)) (f8 (f28 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f30 (f31 f32 (f30 (f31 f33 ?v0) ?v1)) ?v2) (f30 (f31 f33 (f30 (f31 f32 ?v0) ?v2)) (f30 (f31 f32 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (= (f3 (f22 f23 (f18 (f19 f21 ?v0) ?v1)) ?v2) (f18 (f19 f21 (f3 (f22 f23 ?v0) ?v2)) (f3 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f8 (f28 f29 ?v0) ?v1))) (= (f25 (f26 f27 ?v_0) ?v0) (f25 (f26 f27 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f30 (f31 f32 ?v0) ?v1))) (= (f30 (f31 f33 ?v_0) ?v0) (f30 (f31 f33 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f3 (f22 f23 ?v0) ?v1))) (= (f18 (f19 f21 ?v_0) ?v0) (f18 (f19 f21 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f25 (f26 f27 (f8 ?v_0 ?v1)) ?v0) (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 (f31 f33 (f30 ?v_0 ?v1)) ?v0) (f30 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 (f19 f21 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f25 (f26 f27 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f30 (f31 f33 (f30 ?v_0 ?v1)) (f30 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f18 (f19 f21 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f25 (f26 f27 ?v0) (f8 ?v_0 ?v1)) (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 (f31 f33 ?v0) (f30 ?v_0 ?v1)) (f30 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 (f19 f21 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (f8 (f28 f29 ?v0) (f6 f7 3)) (f25 (f26 f27 (f25 (f26 f27 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f30 (f31 f32 ?v0) (f6 f7 3)) (f30 (f31 f33 (f30 (f31 f33 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S4)) (= (f3 (f22 f23 ?v0) (f6 f7 3)) (f18 (f19 f21 (f18 (f19 f21 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f6 f7 (+ (+ 0 1) 1)))) (= (f18 (f19 f20 (f3 (f22 f23 ?v0) ?v_0)) (f3 (f22 f23 ?v1) ?v_0)) (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v1)) (f18 (f19 f34 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 (+ (+ 0 1) 1)))) (= (- (f8 (f28 f29 ?v0) ?v_0) (f8 (f28 f29 ?v1) ?v_0)) (f25 (f26 f27 (- ?v0 ?v1)) (+ ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (= (= (f18 (f19 f34 (f18 (f19 f21 ?v0) ?v1)) ?v2) (f18 (f19 f34 (f18 (f19 f21 ?v3) ?v1)) ?v4)) (= (f18 (f19 f34 (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v3)) ?v1)) ?v2) ?v4))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (f25 (f26 f27 ?v0) ?v1) ?v2) (+ (f25 (f26 f27 ?v3) ?v1) ?v4)) (= (+ (f25 (f26 f27 (- ?v0 ?v3)) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (= (= (f18 (f19 f34 (f18 (f19 f21 ?v0) ?v1)) ?v2) (f18 (f19 f34 (f18 (f19 f21 ?v3) ?v1)) ?v4)) (= ?v2 (f18 (f19 f34 (f18 (f19 f21 (f18 (f19 f20 ?v3) ?v0)) ?v1)) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (f25 (f26 f27 ?v0) ?v1) ?v2) (+ (f25 (f26 f27 ?v3) ?v1) ?v4)) (= ?v2 (+ (f25 (f26 f27 (- ?v3 ?v0)) ?v1) ?v4)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f19 f21 ?v2)) (?v_0 (f19 f21 (f18 (f19 f20 ?v0) ?v2))) (?v_2 (f18 (f19 f20 ?v1) ?v3))) (= (f18 (f19 f20 (f18 (f19 f21 ?v0) ?v1)) (f18 ?v_1 ?v3)) (f18 (f19 f34 (f18 (f19 f34 (f18 ?v_0 ?v_2)) (f18 ?v_0 ?v3))) (f18 ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 (f19 f21 ?v2) ?v3)) (f18 (f19 f34 (f18 ?v_0 (f18 (f19 f20 ?v1) ?v3))) (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v2)) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f26 f27 ?v0))) (= (- (f25 ?v_0 ?v1) (f25 (f26 f27 ?v2) ?v3)) (+ (f25 ?v_0 (- ?v1 ?v3)) (f25 (f26 f27 (- ?v0 ?v2)) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f28 f29 ?v2))) (=> (<= ?v_1 ?v_0) (= (f8 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f25 (f26 f27 (f8 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f31 f32 ?v2))) (=> (<= ?v_1 ?v_0) (= (f30 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f30 (f31 f33 (f30 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f22 f23 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f18 (f19 f21 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f28 f29 ?v1))) (=> (< 0 ?v_0) (= (f25 (f26 f27 (f8 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f8 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f31 f32 ?v1))) (=> (< 0 ?v_0) (= (f30 (f31 f33 (f30 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f30 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S4)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f22 f23 ?v1))) (=> (< 0 ?v_0) (= (f18 (f19 f21 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f18 (f19 f20 (f18 (f19 f34 ?v0) ?v1)) (f18 (f19 f34 ?v2) ?v3)) (f18 (f19 f34 (f18 (f19 f20 ?v0) ?v2)) (f18 (f19 f20 ?v1) ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (- ?v0 ?v2) (- ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f20 (f18 (f19 f34 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f34 (f18 (f19 f20 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f8 f9 (f30 (f31 f32 ?v0) ?v1))) (or (< 0 (f8 f9 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f30 (f31 f32 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f30 (f31 f32 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (=> (< 0 (f8 f9 ?v0)) (=> (< (f8 f9 (f30 ?v_0 ?v1)) (f8 f9 (f30 ?v_0 ?v2))) (< (f8 f9 ?v1) (f8 f9 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f8 f9 ?v0)) (<= ?v_0 (f8 f9 (f30 (f31 f32 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f25 f36 (f25 (f26 f27 ?v0) ?v1)) (f25 (f26 f27 (f25 f36 ?v0)) (f25 f36 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f25 f36 ?v0))) (= (f25 (f26 f27 ?v_0) ?v_0) (f25 (f26 f27 ?v0) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 (f19 f21 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f21 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f33 ?v0))) (= (f30 (f31 f33 (f30 ?v_0 ?v1)) ?v2) (f30 ?v_0 (f30 (f31 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f18 (f19 f34 ?v0) ?v1) (f18 (f19 f34 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f30 (f31 f35 ?v0) ?v1) (f30 (f31 f35 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f34 ?v0))) (=> (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f35 ?v0))) (=> (= (f30 ?v_0 ?v1) (f30 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f34 ?v0))) (=> (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f35 ?v0))) (=> (= (f30 ?v_0 ?v1) (f30 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f18 (f19 f34 ?v0) ?v1) (f18 (f19 f34 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f30 (f31 f35 ?v0) ?v1) (f30 (f31 f35 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f34 ?v0))) (= (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f35 ?v0))) (= (= (f30 ?v_0 ?v1) (f30 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f25 (f26 f37 ?v0) ?v1) ?v2) (f25 (f26 f37 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f30 (f31 f35 (f30 (f31 f38 ?v0) ?v1)) ?v2) (f30 (f31 f38 (f30 (f31 f35 ?v0) ?v2)) (f30 (f31 f35 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f25 (f26 f39 ?v0) ?v1) ?v2) (f25 (f26 f39 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f30 (f31 f35 (f30 (f31 f40 ?v0) ?v1)) ?v2) (f30 (f31 f40 (f30 (f31 f35 ?v0) ?v2)) (f30 (f31 f35 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f34 ?v0))) (= (f18 (f19 f34 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f34 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f35 ?v0))) (= (f30 (f31 f35 (f30 ?v_0 ?v1)) ?v2) (f30 ?v_0 (f30 (f31 f35 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f25 f36 ?v0) (f25 f36 ?v1)))) (= (f25 f36 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f25 f36 (- ?v0 ?v1)) (f25 f36 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f25 (f26 f39 ?v0) ?v1) ?v2) (f25 (f26 f39 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f25 (f26 f37 ?v0) ?v1) ?v2) (f25 (f26 f37 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f34 ?v1) ?v2)) (f18 (f19 f34 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f34 ?v1) ?v2)) (f18 (f19 f34 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f21 (f18 (f19 f34 ?v0) ?v1)) ?v2) (f18 (f19 f34 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f25 (f26 f27 (+ ?v0 ?v1)) ?v2) (+ (f25 (f26 f27 ?v0) ?v2) (f25 (f26 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f30 (f31 f33 (f30 (f31 f35 ?v0) ?v1)) ?v2) (f30 (f31 f35 (f30 (f31 f33 ?v0) ?v2)) (f30 (f31 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f21 (f18 (f19 f34 ?v0) ?v1)) ?v2) (f18 (f19 f34 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f21 (f18 (f19 f34 ?v0) ?v1)) ?v2) (f18 (f19 f34 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f18 (f19 f34 (f18 (f19 f21 ?v0) ?v1)) (f18 (f19 f34 (f18 (f19 f21 ?v2) ?v1)) ?v3)) (f18 (f19 f34 (f18 (f19 f21 (f18 (f19 f34 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (f25 (f26 f27 ?v0) ?v1) (+ (f25 (f26 f27 ?v2) ?v1) ?v3)) (+ (f25 (f26 f27 (+ ?v0 ?v2)) ?v1) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f30 (f31 f35 (f30 (f31 f33 ?v0) ?v1)) (f30 (f31 f35 (f30 (f31 f33 ?v2) ?v1)) ?v3)) (f30 (f31 f35 (f30 (f31 f33 (f30 (f31 f35 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v1)) ?v2) (f18 (f19 f20 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v1)) ?v2) (f18 (f19 f20 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 f9 (f30 (f31 f32 ?v0) ?v1)) (f8 (f28 f29 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f8 f9 (f30 (f31 f32 ?v0) ?v1))) (or (= ?v1 (f6 f7 0)) (< 0 (f8 f9 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f28 f29 (f8 f9 ?v0)) ?v1) (f8 f9 (f30 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f28 f29 (f8 f9 ?v0)) ?v1) (f8 f9 (f30 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f28 f29 ?v0) ?v1)) (f30 (f31 f32 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f30 (f31 f32 (f6 f7 ?v0)) ?v1) (f6 f7 (f8 (f28 f29 ?v0) ?v1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (f25 (f26 f27 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f8 (f28 f29 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f8 (f28 f29 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f25 (f26 f27 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f8 (f28 f29 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f28 f29 ?v0))) (= (f8 (f28 f29 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f6 f7 (f25 (f26 f27 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f25 (f26 f27 ?v0) ?v1)) (f6 f7 (f25 (f26 f27 (f8 f9 (f6 f7 (- ?v0)))) (f8 f9 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f25 (f26 f27 (f8 f9 (f6 f7 ?v0))) (f8 f9 (f6 f7 ?v1)))) (f6 f7 (f25 (f26 f27 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f25 (f26 f27 ?v0) ?v1)) (f6 f7 (f25 (f26 f27 (f8 f9 (f6 f7 ?v0))) (f8 f9 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f25 (f26 f27 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f25 (f26 f27 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f25 (f26 f27 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f25 (f26 f27 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f25 (f26 f27 (f8 f9 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f8 f9 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_2 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f25 (f26 f27 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f25 (f26 f27 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f25 (f26 f27 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (f25 (f26 f27 (f8 f9 ?v0)) (f8 f9 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_3 (f8 f9 ?v3)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f25 (f26 f27 ?v_0) ?v_1) (f25 (f26 f27 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_3 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v2))) (let ((?v_2 (f26 f27 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f25 ?v_2 ?v_1) (f25 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f25 (f26 f27 ?v_0) ?v_1) (f25 (f26 f27 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f26 f27 (f8 f9 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f25 ?v_1 ?v_0) (f25 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f25 (f26 f27 ?v_0) ?v_2) (f25 (f26 f27 ?v_1) ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 (+ (f8 f9 ?v0) 1))) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (f25 ?v_0 ?v_1) (f25 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 (+ (f8 f9 ?v0) 1))) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (f25 ?v_0 ?v_1) (f25 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 (+ (f8 f9 ?v0) 1)))) (= (= (f6 f7 (f25 ?v_0 (f8 f9 ?v1))) (f6 f7 (f25 ?v_0 (f8 f9 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
