(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S9 S2) S10)
(declare-fun f14 (S11 S9) S9)
(declare-fun f15 (S12 S2) S11)
(declare-fun f16 () S12)
(declare-fun f17 () S4)
(declare-fun f18 () S2)
(declare-fun f19 () S9)
(declare-fun f20 () S2)
(declare-fun f21 () S12)
(declare-fun f22 () S6)
(declare-fun f23 (S13 Int) S8)
(declare-fun f24 () S13)
(declare-fun f25 (S14 S10) S9)
(declare-fun f26 () S14)
(declare-fun f27 () S9)
(declare-fun f28 () S3)
(declare-fun f29 () S6)
(declare-fun f30 (S15 S2) S1)
(declare-fun f31 (S16 S2) S15)
(declare-fun f32 () S16)
(declare-fun f33 () S12)
(declare-fun f34 () S12)
(declare-fun f35 () S4)
(declare-fun f36 (S17 S10) S10)
(declare-fun f37 (S18 S10) S17)
(declare-fun f38 () S18)
(declare-fun f39 () S5)
(declare-fun f40 (S19 Int) S10)
(declare-fun f41 () S19)
(declare-fun f42 (S20 S10) S1)
(declare-fun f43 (S21 S10) S20)
(declare-fun f44 () S21)
(declare-fun f45 (S22 Int) S1)
(declare-fun f46 (S23 Int) S22)
(declare-fun f47 () S23)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (not (= (f13 (f14 (f15 f16 (f3 (f4 f17 (f6 f7 2)) f18)) f19) f20) (f13 (f14 (f15 f21 f18) f19) f20))))
(assert (< (f11 f12 f20) (f11 f12 (f3 (f4 f17 (f6 f7 2)) f18))))
(assert (forall ((?v0 S9)) (= (f14 (f15 f21 (f6 f7 0)) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f17 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f17 ?v0) ?v1))) (or (= ?v1 (f6 f7 0)) (< 0 (f11 f12 ?v0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f17 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f17 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f17 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f3 ?v_0 ?v1)) (f11 f12 (f3 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f3 (f4 f17 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f22 (f11 (f23 f24 ?v0) ?v1)) (f11 (f23 f24 (f8 f22 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f23 f24 ?v0) (f6 f7 2)))) (= (f8 f22 ?v_0) ?v_0))))
(assert (forall ((?v0 S10)) (= (f13 (f25 f26 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f17 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f23 f24 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S10)) (= (f13 (f25 f26 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f17 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f23 f24 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f23 f24 (f8 f22 ?v0)) ?v_0) (f11 (f23 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f13 f27 (f3 (f4 f17 ?v0) ?v1)) (f13 (f25 f26 (f13 f27 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 f28 (f3 (f4 f17 ?v0) ?v1)) (f3 (f4 f17 (f3 f28 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f17 ?v0) ?v1)) (f11 (f23 f24 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f3 (f4 f17 (f6 f7 ?v0)) ?v1) (f6 f7 (f11 (f23 f24 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f23 f24 ?v0) ?v1)) (f3 (f4 f17 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f23 f24 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f17 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f23 f24 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f17 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f17 ?v0) ?v1)) (f11 (f23 f24 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f8 f22 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f28 ?v0) (f3 f28 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f11 f12 ?v0) (f11 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f13 f27 ?v0) (f13 f27 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 (f3 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f6 f7 (f8 f29 ?v1)))) (= (< 0 (f11 f12 (f3 (f4 f17 ?v0) ?v_0))) (or (= ?v_0 (f6 f7 0)) (< 0 (f11 f12 ?v0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f17 ?v0))) (=> (= (f30 (f31 f32 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) f1) (=> (< 1 (f11 f12 ?v0)) (<= (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S9)) (let ((?v_0 (f3 (f4 f17 (f6 f7 2)) ?v1))) (=> (< (f11 f12 ?v0) (f11 f12 ?v_0)) (= (f13 (f14 (f15 f33 ?v_0) ?v2) ?v0) (f13 (f14 (f15 f34 ?v1) ?v2) ?v0))))))
(assert (forall ((?v0 S2)) (= (f30 (f31 f32 (f6 f7 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f30 (f31 f32 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f11 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 f28 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (f3 (f4 f35 (f3 f28 ?v0)) (f3 f28 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= (f11 f12 (f6 f7 ?v_0)) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f13 f27 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (f36 (f37 f38 (f13 f27 ?v0)) (f13 f27 ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f11 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f35 ?v0) ?v1) (f3 (f4 f35 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f36 (f37 f38 ?v0) ?v1) (f36 (f37 f38 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f35 ?v0)) (?v_0 (f4 f35 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f9 f10 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_1 (f37 f38 ?v0)) (?v_0 (f37 f38 ?v1))) (= (f36 ?v_1 (f36 ?v_0 ?v2)) (f36 ?v_0 (f36 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f35 ?v0))) (= (f3 ?v_0 (f3 (f4 f35 ?v1) ?v2)) (f3 (f4 f35 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f37 f38 ?v0))) (= (f36 ?v_0 (f36 (f37 f38 ?v1) ?v2)) (f36 (f37 f38 (f36 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 (f23 f24 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f35 ?v0))) (= (f3 (f4 f35 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f35 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f37 f38 ?v0))) (= (f36 (f37 f38 (f36 ?v_0 ?v1)) ?v2) (f36 ?v_0 (f36 (f37 f38 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f35 ?v0))) (= (f3 (f4 f35 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f35 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f37 f38 ?v0))) (= (f36 (f37 f38 (f36 ?v_0 ?v1)) ?v2) (f36 (f37 f38 (f36 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f35 ?v0)) (?v_1 (f3 (f4 f35 ?v2) ?v3))) (= (f3 (f4 f35 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f35 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f8 (f9 f10 ?v2) ?v3))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v_1))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f36 (f37 f38 ?v2) ?v3))) (= (f36 (f37 f38 (f36 ?v_0 ?v1)) ?v_1) (f36 ?v_0 (f36 (f37 f38 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f35 (f3 (f4 f35 ?v0) ?v1))) (?v_0 (f4 f35 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f9 f10 (f8 (f9 f10 ?v0) ?v1))) (?v_0 (f9 f10 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_1 (f37 f38 (f36 (f37 f38 ?v0) ?v1))) (?v_0 (f37 f38 ?v2))) (= (f36 ?v_1 (f36 ?v_0 ?v3)) (f36 ?v_0 (f36 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f35 ?v0))) (= (f3 (f4 f35 (f3 ?v_0 ?v1)) (f3 (f4 f35 ?v2) ?v3)) (f3 (f4 f35 (f3 ?v_0 ?v2)) (f3 (f4 f35 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 (f9 f10 ?v2) ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v2)) (f8 (f9 f10 ?v1) ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f37 f38 ?v0))) (= (f36 (f37 f38 (f36 ?v_0 ?v1)) (f36 (f37 f38 ?v2) ?v3)) (f36 (f37 f38 (f36 ?v_0 ?v2)) (f36 (f37 f38 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f11 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 (f6 f39 ?v0)))) (=> (< 0 ?v_0) (= (f6 f7 (f8 f29 ?v0)) (f6 f7 (+ (f11 f12 (f6 f7 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1))) (=> (= (f30 (f31 f32 (f6 f7 (f8 ?v_0 (f11 f12 ?v1)))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) f1) (=> (< 0 ?v_1) (= (f30 (f31 f32 ?v1) ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f30 (f31 f32 ?v0) ?v1) f1)) (?v_0 (= (f30 (f31 f32 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f31 f32 ?v0)) (?v_0 (f31 f32 ?v1)) (?v_2 (f31 f32 ?v2))) (=> (and (= (f30 ?v_1 ?v1) f1) (not (= (f30 ?v_0 ?v0) f1))) (=> (and (= (f30 ?v_0 ?v2) f1) (not (= (f30 ?v_2 ?v1) f1))) (and (= (f30 ?v_1 ?v2) f1) (not (= (f30 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f30 (f31 f32 ?v0) ?v1) f1)) (?v_0 (= (f30 (f31 f32 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f31 f32 ?v0)) (?v_0 (f31 f32 ?v1))) (=> (and (= (f30 ?v_1 ?v1) f1) (not (= (f30 ?v_0 ?v0) f1))) (=> (= (f30 ?v_0 ?v2) f1) (and (= (f30 ?v_1 ?v2) f1) (not (= (f30 (f31 f32 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (=> (and (= (f30 ?v_0 ?v1) f1) (not (= (f30 (f31 f32 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f30 ?v_0 ?v2) f1) (not (= (f30 (f31 f32 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S1)) (let ((?v_1 (= (f30 (f31 f32 ?v0) ?v1) f1)) (?v_0 (= (f30 (f31 f32 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f30 (f31 f32 ?v0) ?v1) f1) (not (= (f30 (f31 f32 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f30 (f31 f32 ?v0) ?v1) f1) (not (= (f30 (f31 f32 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f30 (f31 f32 ?v0) ?v1) f1)) (?v_0 (= (f30 (f31 f32 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f30 (f31 f32 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f30 (f31 f32 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f30 (f31 f32 ?v0) ?v1) f1)) (?v_0 (= (f30 (f31 f32 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f30 (f31 f32 ?v0) ?v1) f1) (not (= (f30 (f31 f32 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0)) (?v_1 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (= (f30 ?v_0 (f6 f7 (- ?v_2 ?v_1))) f1) (=> (= (f30 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f30 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0)) (?v_1 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (= (f30 ?v_0 (f6 f7 (- ?v_2 ?v_1))) f1) (=> (= (f30 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f30 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0)) (?v_1 (f31 f32 ?v2))) (=> (= (f30 ?v_0 ?v1) f1) (=> (and (= (f30 (f31 f32 ?v1) ?v2) f1) (not (= (f30 ?v_1 ?v1) f1))) (and (= (f30 ?v_0 ?v2) f1) (not (= (f30 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f30 (f31 f32 ?v1) ?v2) f1) (not (= (f30 ?v_0 ?v1) f1))) (and (= (f30 (f31 f32 ?v0) ?v2) f1) (not (= (f30 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (=> (= (f30 ?v_0 ?v1) f1) (=> (= (f30 ?v_0 ?v2) f1) (= (f30 ?v_0 (f6 f7 (- (f11 f12 ?v1) (f11 f12 ?v2)))) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (=> (= (f30 ?v_0 ?v1) f1) (=> (= (f30 (f31 f32 ?v1) ?v2) f1) (= (f30 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f30 (f31 f32 ?v0) ?v1) f1) (=> (= (f30 (f31 f32 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f30 (f31 f32 ?v0) ?v1) f1) (=> (= (f30 (f31 f32 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (=> (= (f30 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f30 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f30 (f31 f32 ?v1) ?v2) f1) (= (f30 (f31 f32 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_3 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (let ((?v_2 (f9 f10 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f8 ?v_2 ?v_1) (f8 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v1))) (=> (= (f30 (f31 f32 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f11 f12 ?v0) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f30 (f31 f32 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f30 (f31 f32 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f30 (f31 f32 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f30 (f31 f32 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f9 f10 (f11 f12 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f8 ?v_1 ?v_0) (f8 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f8 (f9 f10 ?v_0) ?v_2) (f8 (f9 f10 ?v_1) ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f30 (f31 f32 ?v0) ?v1) f1) (= (= (f30 (f31 f32 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 ?v1) (= (f30 (f31 f32 ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f11 f12 ?v1)) (not (= (f30 (f31 f32 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (= (f30 (f31 f32 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) ?v_0))) ?v0) f1) (= ?v1 (f6 f7 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (= (f30 (f31 f32 (f6 f7 (f8 (f9 f10 ?v_0) (f11 f12 ?v1)))) ?v0) f1) (= ?v1 (f6 f7 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f30 (f31 f32 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f30 (f31 f32 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (and (= (f30 (f31 f32 ?v0) ?v1) f1) (not (= (f30 (f31 f32 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f30 (f31 f32 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f30 (f31 f32 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_2)))) ?v_1)) (f6 f7 (- (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_2)) ?v_1)) (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f8 ?v_0 ?v_1)) ?v_2)) (f6 f7 (f8 ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (f8 f29 ?v0)) (f8 (f9 f10 (f8 f29 ?v1)) ?v2)) (f8 (f9 f10 (f8 f29 (f8 (f9 f10 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (f36 (f37 f38 (f40 f41 ?v0)) (f36 (f37 f38 (f40 f41 ?v1)) ?v2)) (f36 (f37 f38 (f40 f41 (f8 (f9 f10 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f40 f41 ?v0) (f40 f41 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f29 ?v0) (f8 f29 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (f8 f29 ?v0)) (f8 f29 ?v1)) (f8 f29 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f36 (f37 f38 (f40 f41 ?v0)) (f40 f41 ?v1)) (f40 f41 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ ?v_1 1)) ?v_0)) (f6 f7 (+ ?v_0 (f8 (f9 f10 ?v_1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f40 f41 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f29 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f6 f39 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (f8 (f9 f10 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (f11 f12 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (= (f30 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v0)))) f1) (= (f30 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_1 (+ ?v_2 1))) (f6 f7 (+ ?v_0 (f8 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f30 (f31 f32 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f30 (f31 f32 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f30 (f31 f32 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 ?v1) (and (= (f30 (f31 f32 ?v0) ?v1) f1) (= (f30 (f31 f32 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (f8 (f9 f10 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f30 (f31 f32 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (f8 (f9 f10 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f11 f12 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f29 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f29 ?v0)) (f8 f29 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f40 f41 (f8 (f9 f10 ?v0) ?v1)) (f36 (f37 f38 (f40 f41 ?v0)) (f40 f41 ?v1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (<= ?v_0 (f8 ?v_1 (f8 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (= (f30 (f31 f32 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f40 f41 ?v0))) (= (f13 (f25 f26 ?v_0) (f6 f7 2)) (f36 (f37 f38 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f39 ?v0))) (= (f3 (f4 f17 ?v_0) (f6 f7 2)) (f3 (f4 f35 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f29 ?v0))) (= (f11 (f23 f24 ?v_0) (f6 f7 2)) (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f36 (f37 f38 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f17 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f35 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f8 (f9 f10 ?v_1) ?v_1))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f36 (f37 f38 ?v0) (f36 (f37 f38 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f17 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f35 ?v0) (f3 (f4 f35 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f8 (f9 f10 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f36 (f37 f38 ?v0) (f13 (f25 f26 (f13 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f35 ?v0) (f3 (f4 f17 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f11 (f23 f24 (f11 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S2)) (= (f40 f41 (f11 f12 ?v0)) (f13 f27 ?v0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f8 f29 ?v_0) ?v_0))))
(assert (forall ((?v0 S2)) (= (f6 f39 (f11 f12 ?v0)) (f3 f28 ?v0))))
(assert (forall ((?v0 S9)) (= (f14 (f15 f34 (f6 f7 0)) ?v0) ?v0)))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2)) (=> (= (f42 (f43 f44 ?v0) ?v1) f1) (= (f42 (f43 f44 (f13 (f25 f26 ?v0) ?v2)) (f13 (f25 f26 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f30 (f31 f32 ?v0) ?v1) f1) (= (f30 (f31 f32 (f3 (f4 f17 ?v0) ?v2)) (f3 (f4 f17 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f45 (f46 f47 ?v0) ?v1) f1) (= (f45 (f46 f47 (f11 (f23 f24 ?v0) ?v2)) (f11 (f23 f24 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S10)) (let ((?v_0 (f25 f26 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f42 (f43 f44 (f13 ?v_0 ?v0)) (f13 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f17 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f30 (f31 f32 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f23 f24 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f45 (f46 f47 (f11 ?v_0 ?v0)) (f11 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2) (?v3 S2)) (=> (= (f42 (f43 f44 ?v0) ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f42 (f43 f44 (f13 (f25 f26 ?v0) ?v2)) (f13 (f25 f26 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f30 (f31 f32 ?v0) ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f30 (f31 f32 (f3 (f4 f17 ?v0) ?v2)) (f3 (f4 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 S2)) (=> (= (f45 (f46 f47 ?v0) ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f45 (f46 f47 (f11 (f23 f24 ?v0) ?v2)) (f11 (f23 f24 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S10) (?v3 S2)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f42 (f43 f44 (f13 ?v_0 ?v1)) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f42 (f43 f44 (f13 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f17 ?v0))) (=> (= (f30 (f31 f32 (f3 ?v_0 ?v1)) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f30 (f31 f32 (f3 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f45 (f46 f47 (f11 ?v_0 ?v1)) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f45 (f46 f47 (f11 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S10)) (= (f36 (f37 f38 ?v0) ?v0) (f13 (f25 f26 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f35 ?v0) ?v0) (f3 (f4 f17 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) ?v0) (f11 (f23 f24 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f36 (f37 f38 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f35 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f36 (f37 f38 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f35 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f36 (f37 f38 (f13 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f35 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S10)) (= (f13 (f25 f26 ?v0) (f6 f7 2)) (f36 (f37 f38 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f17 ?v0) (f6 f7 2)) (f3 (f4 f35 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f23 f24 ?v0) (f6 f7 2)) (f8 (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 S10)) (= (f13 (f25 f26 ?v0) (f6 f7 3)) (f36 (f37 f38 (f36 (f37 f38 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f17 ?v0) (f6 f7 3)) (f3 (f4 f35 (f3 (f4 f35 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f23 f24 ?v0) (f6 f7 3)) (f8 (f9 f10 (f8 (f9 f10 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f36 (f37 f38 ?v0) (f13 ?v_0 ?v1)) (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 (f4 f35 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f36 (f37 f38 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f3 (f4 f35 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f36 (f37 f38 (f13 ?v_0 ?v1)) ?v0) (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 (f4 f35 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f13 (f25 f26 ?v0) ?v1))) (= (f36 (f37 f38 ?v_0) ?v0) (f36 (f37 f38 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f17 ?v0) ?v1))) (= (f3 (f4 f35 ?v_0) ?v0) (f3 (f4 f35 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f23 f24 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2)) (= (f13 (f25 f26 (f36 (f37 f38 ?v0) ?v1)) ?v2) (f36 (f37 f38 (f13 (f25 f26 ?v0) ?v2)) (f13 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f17 (f3 (f4 f35 ?v0) ?v1)) ?v2) (f3 (f4 f35 (f3 (f4 f17 ?v0) ?v2)) (f3 (f4 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f23 f24 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f23 f24 ?v0) ?v2)) (f11 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2)) (= (f13 (f25 f26 (f36 (f37 f38 ?v0) ?v1)) ?v2) (f36 (f37 f38 (f13 (f25 f26 ?v0) ?v2)) (f13 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f17 (f3 (f4 f35 ?v0) ?v1)) ?v2) (f3 (f4 f35 (f3 (f4 f17 ?v0) ?v2)) (f3 (f4 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f23 f24 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f23 f24 ?v0) ?v2)) (f11 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f36 (f37 f38 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2)) (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 (f4 f35 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f13 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f13 (f25 f26 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f3 (f4 f17 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f11 (f23 f24 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f13 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f13 (f25 f26 (f13 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f17 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f11 (f23 f24 (f11 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f13 (f25 f26 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f17 ?v0))) (= (f3 (f4 f17 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 (f23 f24 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f30 (f31 f32 (f3 (f4 f17 ?v1) ?v0)) (f3 (f4 f17 ?v2) ?v0)) f1) (= (f30 (f31 f32 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f30 (f31 f32 (f3 (f4 f17 ?v0) ?v1)) (f3 (f4 f17 ?v2) ?v1)) f1) (=> (not (= ?v1 (f6 f7 0))) (= (f30 (f31 f32 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< 0 ?v_0) (= (= (f30 (f31 f32 (f6 f7 (f8 ?v_1 (f11 f12 ?v1)))) (f6 f7 (f8 ?v_1 (f11 f12 ?v2)))) f1) (= (f30 (f31 f32 ?v1) ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f30 (f31 f32 (f6 f7 (f8 ?v_0 (f11 f12 ?v1)))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) f1) (or (= ?v0 (f6 f7 0)) (= (f30 (f31 f32 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (=> (= (f42 (f43 f44 (f36 (f37 f38 ?v0) ?v1)) ?v2) f1) (= (f42 (f43 f44 ?v1) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f30 (f31 f32 (f3 (f4 f35 ?v0) ?v1)) ?v2) f1) (= (f30 (f31 f32 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f45 (f46 f47 (f8 (f9 f10 ?v0) ?v1)) ?v2) f1) (= (f45 (f46 f47 ?v1) ?v2) f1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (=> (= (f42 (f43 f44 (f36 (f37 f38 ?v0) ?v1)) ?v2) f1) (= (f42 (f43 f44 ?v0) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f30 (f31 f32 (f3 (f4 f35 ?v0) ?v1)) ?v2) f1) (= (f30 (f31 f32 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f45 (f46 f47 (f8 (f9 f10 ?v0) ?v1)) ?v2) f1) (= (f45 (f46 f47 ?v0) ?v2) f1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (=> (= ?v0 (f36 (f37 f38 ?v1) ?v2)) (= (f42 (f43 f44 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 (f3 (f4 f35 ?v1) ?v2)) (= (f30 (f31 f32 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f8 (f9 f10 ?v1) ?v2)) (= (f45 (f46 f47 ?v1) ?v0) f1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (=> (= (f42 (f43 f44 ?v0) ?v1) f1) (=> (= (f42 (f43 f44 ?v2) ?v3) f1) (= (f42 (f43 f44 (f36 (f37 f38 ?v0) ?v2)) (f36 (f37 f38 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f30 (f31 f32 ?v0) ?v1) f1) (=> (= (f30 (f31 f32 ?v2) ?v3) f1) (= (f30 (f31 f32 (f3 (f4 f35 ?v0) ?v2)) (f3 (f4 f35 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f45 (f46 f47 ?v0) ?v1) f1) (=> (= (f45 (f46 f47 ?v2) ?v3) f1) (= (f45 (f46 f47 (f8 (f9 f10 ?v0) ?v2)) (f8 (f9 f10 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f43 f44 ?v0))) (=> (= (f42 ?v_0 ?v1) f1) (= (f42 ?v_0 (f36 (f37 f38 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (=> (= (f30 ?v_0 ?v1) f1) (= (f30 ?v_0 (f3 (f4 f35 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f46 f47 ?v0))) (=> (= (f45 ?v_0 ?v1) f1) (= (f45 ?v_0 (f8 (f9 f10 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f43 f44 ?v0))) (=> (= (f42 ?v_0 ?v1) f1) (= (f42 ?v_0 (f36 (f37 f38 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (=> (= (f30 ?v_0 ?v1) f1) (= (f30 ?v_0 (f3 (f4 f35 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f46 f47 ?v0))) (=> (= (f45 ?v_0 ?v1) f1) (= (f45 ?v_0 (f8 (f9 f10 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f45 (f46 f47 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f45 (f46 f47 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f46 f47 ?v0))) (=> (= (f45 ?v_0 ?v1) f1) (= (= (f45 ?v_0 (+ ?v2 ?v3)) f1) (= (f45 ?v_0 (+ (+ ?v2 (f8 (f9 f10 ?v4) ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f45 (f46 f47 (f8 (f9 f10 ?v0) ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (f8 f29 ?v0)) (f8 f29 ?v1)) (f8 f29 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f46 f47 ?v0))) (= (= (f45 ?v_0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) f1) (= (f45 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int)) (=> (= (f45 (f46 f47 (f11 (f23 f24 ?v0) ?v1)) (f11 (f23 f24 ?v2) ?v1)) f1) (=> (not (= ?v1 (f6 f7 0))) (= (f45 (f46 f47 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f45 (f46 f47 (f11 (f23 f24 ?v1) ?v0)) (f11 (f23 f24 ?v2) ?v0)) f1) (= (f45 (f46 f47 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f30 (f31 f32 ?v0) ?v1) f1) (= (f45 (f46 f47 (f11 f12 ?v0)) (f11 f12 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f45 (f46 f47 ?v0) (f11 f12 ?v1)) f1) (= (f30 (f31 f32 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 Int)) (= (= (f45 (f46 f47 (f11 f12 ?v0)) ?v1) f1) (= (f30 (f31 f32 ?v0) (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f30 (f31 f32 (f6 f7 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f45 (f46 f47 ?v0) (f11 f12 ?v1)) f1) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f45 (f46 f47 (f11 f12 ?v0)) (f11 f12 ?v1)) f1) (= (f30 (f31 f32 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f30 (f31 f32 (f6 f7 ?v0)) (f6 f7 ?v1)) f1) (= (f45 (f46 f47 ?v0) ?v1) f1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f8 f29 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f8 f29 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f11 f12 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1)))) (f6 f7 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S9)) (=> (< (f11 f12 ?v0) (f11 f12 ?v1)) (= (f13 (f14 (f15 f16 ?v1) (f14 (f15 f33 ?v1) ?v2)) ?v0) (f36 (f37 f38 (f13 f27 ?v1)) (f13 ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f22 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f22 ?v0)) (f8 f22 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f22 ?v0))) (= (f8 (f9 f10 ?v_0) ?v_0) (f8 (f9 f10 ?v0) ?v0)))))
(assert (forall ((?v0 S10)) (= (f42 (f43 f44 ?v0) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f30 (f31 f32 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (= (f45 (f46 f47 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f46 f47 ?v0))) (= (= (f45 ?v_0 (f8 f22 ?v1)) f1) (= (f45 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f45 (f46 f47 (f8 f22 ?v0)) ?v1) f1) (= (f45 (f46 f47 ?v0) ?v1) f1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f43 f44 ?v0))) (=> (= (f42 ?v_0 ?v1) f1) (=> (= (f42 (f43 f44 ?v1) ?v2) f1) (= (f42 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (=> (= (f30 ?v_0 ?v1) f1) (=> (= (f30 (f31 f32 ?v1) ?v2) f1) (= (f30 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f46 f47 ?v0))) (=> (= (f45 ?v_0 ?v1) f1) (=> (= (f45 (f46 f47 ?v1) ?v2) f1) (= (f45 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 f22 ?v0) (f8 f22 ?v1)) (= (f45 (f46 f47 ?v0) ?v1) f1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (not (and (= (f30 (f31 f32 ?v_0) ?v0) f1) (not (= (f30 (f31 f32 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (not (and (= (f30 (f31 f32 ?v0) ?v_0) f1) (not (= (f30 (f31 f32 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S2)) (= (f30 (f31 f32 (f6 f7 1)) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f30 (f31 f32 ?v0) (f6 f7 0)) f1)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (not (= ?v0 ?v_0)) (and (= (f30 (f31 f32 ?v_0) ?v0) f1) (not (= (f30 (f31 f32 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (= (not (= ?v0 ?v_0)) (and (= (f30 (f31 f32 ?v0) ?v_0) f1) (not (= (f30 (f31 f32 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f30 (f31 f32 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f30 (f31 f32 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (=> (= (f30 (f31 f32 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (< 0 (f11 f12 ?v0)) (=> (= (f30 (f31 f32 ?v1) ?v0) f1) (< 0 (f11 f12 ?v1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (=> (= (f30 (f31 f32 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v0 (f6 f7 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (= (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_0) (+ (f8 (f9 f10 ?v_2) ?v_0) ?v_3))) (f6 f7 (+ (f8 (f9 f10 (+ ?v_1 ?v_2)) ?v_0) ?v_3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< 0 ?v_0) (= (= (f6 f7 (f8 ?v_1 (f11 f12 ?v1))) (f6 f7 (f8 ?v_1 (f11 f12 ?v2)))) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (< (f8 ?v_1 ?v_2) (f8 ?v_1 ?v_3)) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (<= (f8 ?v_1 ?v_2) (f8 ?v_1 ?v_3)) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_2) (f11 f12 ?v3))) (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_3))) (= ?v3 (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (f6 f7 (- (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4))) (f6 f7 (- ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (< ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (<= ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3)) (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_2) (f11 f12 ?v4)))) (= (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (f6 f7 (- (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4))) (f6 f7 (- (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (< (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (<= (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f42 (f43 f44 ?v0) (f36 (f37 f38 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f30 (f31 f32 ?v0) (f3 (f4 f35 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f45 (f46 f47 ?v0) (f8 (f9 f10 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f42 (f43 f44 ?v0) (f36 (f37 f38 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f30 (f31 f32 ?v0) (f3 (f4 f35 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f45 (f46 f47 ?v0) (f8 (f9 f10 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f42 (f43 f44 ?v0) ?v1) f1) (=> (forall ((?v2 S10)) (=> (= ?v1 (f36 (f37 f38 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f30 (f31 f32 ?v0) ?v1) f1) (=> (forall ((?v2 S2)) (=> (= ?v1 (f3 (f4 f35 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f45 (f46 f47 ?v0) ?v1) f1) (=> (forall ((?v2 Int)) (=> (= ?v1 (f8 (f9 f10 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S10)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f25 f26 ?v2))) (=> (<= ?v_1 ?v_0) (= (f13 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f36 (f37 f38 (f13 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f4 f17 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f35 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f23 f24 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f8 (f9 f10 (f11 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S10)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f25 f26 ?v1))) (=> (< 0 ?v_0) (= (f36 (f37 f38 (f13 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f13 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f4 f17 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f35 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f23 f24 ?v1))) (=> (< 0 ?v_0) (= (f8 (f9 f10 (f11 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f11 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f46 f47 ?v0))) (=> (= (f45 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f45 ?v_0 ?v2) f1) (= (f45 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f45 (f46 f47 ?v0) ?v1) f1) (=> (= (f45 (f46 f47 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f45 (f46 f47 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f45 (f46 f47 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f45 (f46 f47 ?v0) ?v1) f1) (=> (= (f45 (f46 f47 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f45 (f46 f47 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f8 f29 ?v1))) (= (= (f11 f12 ?v0) ?v_0) (and (= ?v0 (f6 f7 ?v_0)) (<= 0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f29 ?v0) (f8 f29 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f29 ?v0) (f8 f29 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 f29 ?v0) (f8 f29 ?v1)) (f8 f29 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f8 f29 ?v0) (f8 f29 ?v1)) (f8 f29 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (= (f45 (f46 f47 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int)) (= (- (f8 f29 ?v0)) (f8 f29 (- ?v0)))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
