(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) Int)
(declare-fun f4 () S3)
(declare-fun f5 (S4 Int) S3)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S5) S1)
(declare-fun f8 () S5)
(declare-fun f9 () S5)
(declare-fun f10 (S6 S2) S5)
(declare-fun f11 (S7 S5) S6)
(declare-fun f12 () S7)
(declare-fun f13 (S5 S5) S1)
(declare-fun f14 () S5)
(declare-fun f15 (S8 Int) S2)
(declare-fun f16 () S8)
(declare-fun f17 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v0))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5)) (let ((?v_0 (f11 f12 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (=> (= (f7 f8 ?v2) f1) (=> (= (f7 ?v2 f9) f1) (= (f7 (f10 ?v_0 ?v1) (f10 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f7 ?v0 ?v1) f1) false) (=> (=> (= (f7 ?v1 ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f13 ?v0 ?v1) f1) (=> (= (f7 ?v1 ?v2) f1) (= (f13 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (= (f13 f14 f9) f1))
(assert (forall ((?v0 S5)) (not (= (f13 ?v0 ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (= (f3 (f5 f6 1) (f15 f16 2)) 1))
(assert (= (f10 (f11 f12 f9) (f15 f16 2)) f9))
(assert (forall ((?v0 Int)) (= (f3 (f5 f6 ?v0) (f15 f16 0)) 1)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f15 f16 0)) f9)))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f13 ?v0 ?v1) f1) (= (f7 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (= (f10 (f11 f12 f8) (f15 f16 2)) f8))
(assert (= (f3 (f5 f6 0) (f15 f16 2)) 0))
(assert (let ((?v_0 (f10 (f11 f12 f14) f17))) (not (=> (=> (= (f7 f8 f14) f1) (=> (< 0 (f3 f4 f17)) (= (f13 ?v_0 (f10 (f11 f12 f9) f17)) f1))) (=> (= (f13 f8 f14) f1) (=> (not (= f17 (f15 f16 0))) (= (f7 ?v_0 f9) f1)))))))
(assert (forall ((?v0 S2)) (= (f15 f16 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
