(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 Int) Int)
(declare-fun f7 (S5 Int) S4)
(declare-fun f8 () S5)
(declare-fun f9 () S6)
(declare-fun f10 () S6)
(declare-fun f11 () S6)
(declare-fun f12 () S6)
(declare-fun f13 (S7 S6) S6)
(declare-fun f14 (S8 S6) S7)
(declare-fun f15 () S8)
(declare-fun f16 () S8)
(declare-fun f17 () S6)
(declare-fun f18 () S4)
(declare-fun f19 () S5)
(declare-fun f20 () S5)
(declare-fun f21 () S5)
(declare-fun f22 () S7)
(declare-fun f23 (S10 S9) S1)
(declare-fun f24 () S10)
(declare-fun f25 (S9 Int) S6)
(declare-fun f26 (S12 S11) S1)
(declare-fun f27 () S12)
(declare-fun f28 (S11 S6) Int)
(declare-fun f29 (S13 S6) S1)
(declare-fun f30 (S14 S3) S5)
(declare-fun f31 () S14)
(declare-fun f32 () S14)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (=> (= f9 f10) (=> (not (= f11 f10)) (= (= f12 f10) (= (f13 (f14 f15 (f13 (f14 f16 f11) f12)) (f13 (f14 f16 f17) f9)) f10))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f14 f16 ?v0))) (= (f13 ?v_0 (f13 (f14 f15 ?v1) ?v2)) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f14 f16 ?v0))) (= (f13 ?v_0 (f13 (f14 f15 ?v1) ?v2)) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f13 (f14 f16 (f13 (f14 f15 ?v0) ?v1)) ?v2) (f13 (f14 f15 (f13 (f14 f16 ?v0) ?v2)) (f13 (f14 f16 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f13 (f14 f16 (f13 (f14 f15 ?v0) ?v1)) ?v2) (f13 (f14 f15 (f13 (f14 f16 ?v0) ?v2)) (f13 (f14 f16 ?v1) ?v2)))))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S6)) (= (f13 (f14 f15 ?v0) f10) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S6)) (= (f13 (f14 f15 ?v0) ?v0) f10)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= ?v0 ?v1) (= (f13 (f14 f15 ?v0) ?v1) f10))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f13 (f14 f15 ?v0) ?v1) f10) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S6)) (= (f13 (f14 f16 f10) ?v0) f10)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S6)) (= (f13 (f14 f16 f10) ?v0) f10)))
(assert (forall ((?v0 S6)) (= (f13 (f14 f16 f10) ?v0) f10)))
(assert (forall ((?v0 S6)) (= (f13 (f14 f16 f10) ?v0) f10)))
(assert (forall ((?v0 Int)) (= (= (f6 f18 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S6)) (= (= f10 ?v0) (= ?v0 f10))))
(assert (= (f6 f18 0) 0))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f14 f16 ?v0))) (= (f13 (f14 f16 (f13 ?v_0 ?v1)) (f13 (f14 f16 ?v2) ?v3)) (f13 (f14 f16 (f13 ?v_0 ?v2)) (f13 (f14 f16 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 (f7 f19 (f6 ?v_0 ?v1)) (f6 (f7 f19 ?v2) ?v3)) (f6 (f7 f19 (f6 ?v_0 ?v2)) (f6 (f7 f19 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f14 f16 (f13 (f14 f16 ?v0) ?v1))) (?v_0 (f14 f16 ?v2))) (= (f13 ?v_1 (f13 ?v_0 ?v3)) (f13 ?v_0 (f13 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f7 f19 (f6 (f7 f19 ?v0) ?v1))) (?v_0 (f7 f19 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f14 f16 ?v0)) (?v_1 (f13 (f14 f16 ?v2) ?v3))) (= (f13 (f14 f16 (f13 ?v_0 ?v1)) ?v_1) (f13 ?v_0 (f13 (f14 f16 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f19 ?v0)) (?v_1 (f6 (f7 f19 ?v2) ?v3))) (= (f6 (f7 f19 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f19 ?v1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f14 f16 ?v0))) (= (f13 (f14 f16 (f13 ?v_0 ?v1)) ?v2) (f13 (f14 f16 (f13 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 (f7 f19 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f19 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f14 f16 ?v0))) (= (f13 (f14 f16 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f13 (f14 f16 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 (f7 f19 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f19 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f14 f16 ?v0))) (= (f13 (f14 f16 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f13 (f14 f16 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 (f7 f19 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f19 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f18 ?v0))) (= (f6 (f7 f19 ?v_0) ?v_0) (f6 (f7 f19 ?v0) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f14 f16 ?v0))) (= (f13 ?v_0 (f13 (f14 f16 ?v1) ?v2)) (f13 (f14 f16 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (= (f6 ?v_0 (f6 (f7 f19 ?v1) ?v2)) (f6 (f7 f19 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f14 f16 ?v0)) (?v_0 (f14 f16 ?v1))) (= (f13 ?v_1 (f13 ?v_0 ?v2)) (f13 ?v_0 (f13 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f7 f19 ?v0)) (?v_0 (f7 f19 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f13 (f14 f16 ?v0) ?v1) (f13 (f14 f16 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f19 ?v0) ?v1) (f6 (f7 f19 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f18 (f6 (f7 f19 ?v0) ?v1)) (f6 (f7 f19 (f6 f18 ?v0)) (f6 f18 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f13 (f14 f15 ?v0) ?v1) (f13 (f14 f15 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f6 (f7 f20 ?v0) ?v1) ?v2) (f6 (f7 f20 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f6 (f7 f21 ?v0) ?v1) ?v2) (f6 (f7 f21 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f18 (- ?v0 ?v1)) (f6 f18 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 (f7 f19 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f13 (f14 f16 ?v0) ?v1) f10) (or (= ?v0 f10) (= ?v1 f10)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f6 (f7 f19 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f10)) (=> (not (= ?v1 f10)) (not (= (f13 (f14 f16 ?v0) ?v1) f10))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 (f7 f19 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f13 (f14 f16 ?v0) ?v1) f10) (or (= ?v0 f10) (= ?v1 f10)))))
(assert (forall ((?v0 S6)) (= (f13 (f14 f16 ?v0) f10) f10)))
(assert (forall ((?v0 S6)) (= (f13 (f14 f16 ?v0) f10) f10)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S6)) (= (f13 (f14 f16 ?v0) f10) f10)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S6)) (= (f13 (f14 f16 ?v0) f10) f10)))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f13 f22 ?v0)) (?v_1 (f13 f22 ?v1))) (=> (not (= ?v0 f10)) (=> (not (= ?v1 f10)) (= (f13 (f14 f15 ?v_0) ?v_1) (f13 (f14 f16 (f13 (f14 f16 ?v_0) (f13 (f14 f15 ?v1) ?v0))) ?v_1)))))))
(assert (forall ((?v0 S9) (?v1 Int) (?v2 Int)) (=> (= (f23 f24 ?v0) f1) (= (f25 ?v0 (- ?v1 ?v2)) (f13 (f14 f15 (f25 ?v0 ?v1)) (f25 ?v0 ?v2))))))
(assert (forall ((?v0 S11) (?v1 S6) (?v2 S6)) (=> (= (f26 f27 ?v0) f1) (= (f28 ?v0 (f13 (f14 f15 ?v1) ?v2)) (- (f28 ?v0 ?v1) (f28 ?v0 ?v2))))))
(assert (forall ((?v0 S13) (?v1 S6) (?v2 S13)) (=> (forall ((?v3 S6) (?v4 S6)) (= (= (f29 ?v0 ?v3) f1) (= (f29 ?v0 (f13 (f14 f15 ?v3) (f13 (f14 f16 ?v4) ?v1))) f1))) (=> (forall ((?v3 S6) (?v4 S6)) (= (= (f29 ?v2 ?v3) f1) (= (f29 ?v2 (f13 (f14 f15 ?v3) (f13 (f14 f16 ?v4) ?v1))) f1))) (forall ((?v3 S6) (?v4 S6)) (let ((?v_0 (f13 (f14 f15 ?v3) (f13 (f14 f16 ?v4) ?v1)))) (= (or (= (f29 ?v0 ?v3) f1) (= (f29 ?v2 ?v3) f1)) (or (= (f29 ?v0 ?v_0) f1) (= (f29 ?v2 ?v_0) f1)))))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 S2)) (=> (forall ((?v3 Int) (?v4 Int)) (= (= (f3 ?v0 ?v3) f1) (= (f3 ?v0 (- ?v3 (f6 (f7 f19 ?v4) ?v1))) f1))) (=> (forall ((?v3 Int) (?v4 Int)) (= (= (f3 ?v2 ?v3) f1) (= (f3 ?v2 (- ?v3 (f6 (f7 f19 ?v4) ?v1))) f1))) (forall ((?v3 Int) (?v4 Int)) (let ((?v_0 (- ?v3 (f6 (f7 f19 ?v4) ?v1)))) (= (or (= (f3 ?v0 ?v3) f1) (= (f3 ?v2 ?v3) f1)) (or (= (f3 ?v0 ?v_0) f1) (= (f3 ?v2 ?v_0) f1)))))))))
(assert (forall ((?v0 S13) (?v1 S6) (?v2 S13)) (=> (forall ((?v3 S6) (?v4 S6)) (= (= (f29 ?v0 ?v3) f1) (= (f29 ?v0 (f13 (f14 f15 ?v3) (f13 (f14 f16 ?v4) ?v1))) f1))) (=> (forall ((?v3 S6) (?v4 S6)) (= (= (f29 ?v2 ?v3) f1) (= (f29 ?v2 (f13 (f14 f15 ?v3) (f13 (f14 f16 ?v4) ?v1))) f1))) (forall ((?v3 S6) (?v4 S6)) (let ((?v_0 (f13 (f14 f15 ?v3) (f13 (f14 f16 ?v4) ?v1)))) (= (and (= (f29 ?v0 ?v3) f1) (= (f29 ?v2 ?v3) f1)) (and (= (f29 ?v0 ?v_0) f1) (= (f29 ?v2 ?v_0) f1)))))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 S2)) (=> (forall ((?v3 Int) (?v4 Int)) (= (= (f3 ?v0 ?v3) f1) (= (f3 ?v0 (- ?v3 (f6 (f7 f19 ?v4) ?v1))) f1))) (=> (forall ((?v3 Int) (?v4 Int)) (= (= (f3 ?v2 ?v3) f1) (= (f3 ?v2 (- ?v3 (f6 (f7 f19 ?v4) ?v1))) f1))) (forall ((?v3 Int) (?v4 Int)) (let ((?v_0 (- ?v3 (f6 (f7 f19 ?v4) ?v1)))) (= (and (= (f3 ?v0 ?v3) f1) (= (f3 ?v2 ?v3) f1)) (and (= (f3 ?v0 ?v_0) f1) (= (f3 ?v2 ?v_0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (<= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S11)) (=> (= (f26 f27 ?v0) f1) (= (f28 ?v0 f10) 0))))
(assert (forall ((?v0 S9)) (=> (= (f23 f24 ?v0) f1) (= (f25 ?v0 0) f10))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 f18 ?v0))))
(assert (forall ((?v0 S6)) (= (f13 f22 (f13 f22 ?v0)) ?v0)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f13 f22 ?v0) (f13 f22 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f6 f18 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f13 f22 ?v0) (f13 f22 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f6 (f7 f21 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f6 (f7 f20 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f6 (f7 f20 ?v0) ?v2) (f6 (f7 f20 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f6 (f7 f21 ?v0) ?v2) (f6 (f7 f21 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f6 (f7 f21 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f6 (f7 f21 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f6 (f7 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f6 (f7 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f20 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f21 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f20 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f21 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f6 (f7 f20 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f6 (f7 f20 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f6 (f7 f21 ?v2) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f6 (f7 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f20 ?v0))) (<= (f6 (f7 f21 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 (f7 f21 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f6 (f7 f21 ?v0) ?v1) ?v2) (and (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f21 ?v0))) (<= (f6 ?v_0 (f6 (f7 f20 ?v1) ?v2)) (f6 (f7 f20 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f6 (f7 f20 ?v1) ?v2)) (and (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f6 (f7 f20 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f6 (f7 f21 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 (f7 f20 ?v0) ?v1) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 (f7 f20 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f6 (f7 f21 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f6 (f7 f21 ?v0) ?v1))))
(assert (= (f13 f22 f10) f10))
(assert (forall ((?v0 S6)) (= (= (f13 f22 ?v0) f10) (= ?v0 f10))))
(assert (forall ((?v0 S6)) (=> (not (= ?v0 f10)) (not (= (f13 f22 ?v0) f10)))))
(assert (forall ((?v0 S6)) (=> (not (= ?v0 f10)) (= (f13 f22 (f13 f22 ?v0)) ?v0))))
(assert (forall ((?v0 S6)) (=> (= (f13 f22 ?v0) f10) (= ?v0 f10))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f13 f22 ?v0) (f13 f22 ?v1)) (=> (not (= ?v0 f10)) (=> (not (= ?v1 f10)) (= ?v0 ?v1))))))
(assert (forall ((?v0 Int)) (<= 0 (f6 f18 ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f6 f18 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f18 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 f18 (- (f6 f18 ?v0) (f6 f18 ?v1))) (f6 f18 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f6 f18 ?v0) (f6 f18 ?v1)) (f6 f18 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f6 f18 ?v0) (f6 f18 ?v1)) (f6 f18 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f10)) (=> (not (= ?v1 f10)) (= (f13 f22 (f13 (f14 f16 ?v0) ?v1)) (f13 (f14 f16 (f13 f22 ?v1)) (f13 f22 ?v0)))))))
(assert (forall ((?v0 Int)) (<= 0 (f6 (f7 f19 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (f6 (f7 f19 ?v0) ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f6 (f7 f19 ?v0) ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 (f7 f19 (f6 f18 ?v1)) ?v0) (f6 f18 (f6 (f7 f19 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f6 (f7 f19 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f6 (f7 f19 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f6 (f7 f19 ?v1) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f6 (f7 f19 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f6 (f7 f19 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f6 (f7 f19 ?v0) ?v2) (f6 (f7 f19 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f6 (f7 f19 ?v1) ?v2) (f6 (f7 f19 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f6 ?v_0 ?v1) (f6 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f6 (f7 f19 ?v0) ?v2) (f6 (f7 f19 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f6 (f7 f19 ?v0) ?v2) (f6 (f7 f19 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f6 (f7 f19 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f6 f18 (f6 (f7 f19 ?v0) ?v1)) (f6 (f7 f19 (f6 f18 ?v0)) (f6 f18 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f6 (f7 f19 ?v0) ?v1) 0))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f13 f22 (f13 (f14 f16 ?v0) ?v1)) (f13 (f14 f16 (f13 f22 ?v0)) (f13 f22 ?v1)))))
(assert (= (f13 f22 f10) f10))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f6 (f7 f21 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f6 (f7 f20 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f21 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f21 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f20 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f20 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f6 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f6 ?v1 ?v5) (f6 ?v1 ?v4)))) (<= (f6 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (= (f6 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f6 ?v2 ?v5) (f6 ?v2 ?v4)))) (<= ?v3 (f6 ?v2 ?v1)))))))
(assert (= f21 (f30 f31 f5)))
(assert (= f20 (f30 f32 f5)))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f6 (f7 f21 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f6 (f7 f20 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f6 (f7 f21 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f6 (f7 f20 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f6 f18 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f6 f18 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f6 f18 ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f18 ?v0)) (?v_1 (f6 f18 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f6 (f7 f19 ?v_0) ?v_1) (f6 (f7 f19 ?v1) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f6 (f7 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f6 (f7 f21 ?v2) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f6 (f7 f20 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f6 (f7 f20 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int)) (not (< (f6 (f7 f19 ?v0) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f6 (f7 f19 ?v0) ?v1) (f6 (f7 f19 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (= (< (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (=> (< 0 ?v0) (= (< (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (f6 (f7 f19 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f6 (f7 f19 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f6 (f7 f19 ?v1) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f6 (f7 f19 ?v0) ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f6 (f7 f19 ?v0) ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (=> (< ?v0 0) (= (< (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (< ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f6 (f7 f19 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (f6 (f7 f19 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f6 (f7 f19 ?v0) ?v2) (f6 (f7 f19 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f6 (f7 f19 ?v1) ?v2) (f6 (f7 f19 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v2))) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f6 ?v_0 ?v1) (f6 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (< (- ?v0 ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (=> (< 0 ?v0) (= (<= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (<= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (=> (< ?v0 0) (= (<= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (<= ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (f6 (f7 f19 ?v0) ?v2) (f6 (f7 f19 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (f6 (f7 f19 ?v0) ?v2) (f6 (f7 f19 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (f6 (f7 f19 ?v0) ?v2) (f6 (f7 f19 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (f6 (f7 f19 ?v0) ?v2) (f6 (f7 f19 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f6 (f7 f19 ?v0) ?v1) (f6 (f7 f19 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f6 (f7 f19 ?v0) ?v1) (f6 (f7 f19 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (=> (< (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v0))) (=> (< (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(check-sat)
(exit)
