(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S2)
(declare-fun f4 () S2)
(declare-fun f5 (S3 S4) Int)
(declare-fun f6 () S3)
(declare-fun f7 (S5 S2) S4)
(declare-fun f8 () S5)
(declare-fun f9 () S2)
(declare-fun f10 (S6 Int) S4)
(declare-fun f11 () S6)
(assert (not (= f1 f2)))
(assert (not (= f3 f4)))
(assert (< (f5 f6 (f7 f8 f3)) (f5 f6 (f7 f8 f9))))
(assert (<= (f5 f6 (f7 f8 f9)) (f5 f6 (f7 f8 f3))))
(assert (< (f5 f6 (f7 f8 f3)) (f5 f6 (f7 f8 f9))))
(assert (<= (f5 f6 (f7 f8 f9)) (f5 f6 (f7 f8 f3))))
(assert (forall ((?v0 S4)) (= (f10 f11 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
