(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S3)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S2)
(declare-fun f7 () S4)
(declare-fun f8 () S4)
(declare-fun f9 () S4)
(declare-fun f10 () S3)
(declare-fun f11 () S3)
(declare-fun f12 (S5 Int) S3)
(declare-fun f13 () S5)
(declare-fun f14 (S6 Int) Int)
(declare-fun f15 () S6)
(declare-fun f16 () S6)
(declare-fun f17 () Int)
(declare-fun f18 () S3)
(declare-fun f19 (S7 S8) S3)
(declare-fun f20 (S9 S3) S7)
(declare-fun f21 () S9)
(declare-fun f22 (S10 Int) S8)
(declare-fun f23 () S10)
(declare-fun f24 (S11 Int) S6)
(declare-fun f25 () S11)
(declare-fun f26 () S6)
(declare-fun f27 (S12 S8) Int)
(declare-fun f28 () S12)
(assert (not (= f1 f2)))
(assert (let ((?v_1 (f3 f6 (f3 (f4 f9 (f3 (f4 f8 f10) f10)) (f3 (f4 f8 f11) f11))))) (let ((?v_0 (f3 (f4 f9 ?v_1) f10)) (?v_3 (f12 f13 (f14 f15 (f14 f15 (f14 f16 f17))))) (?v_2 (f3 (f4 f5 ?v_1) f10))) (not (= (f3 (f4 f5 (f3 f6 (f3 (f4 f7 (f3 (f4 f8 ?v_0) ?v_0)) ?v_3))) (f3 f6 (f3 (f4 f7 (f3 (f4 f8 ?v_2) ?v_2)) ?v_3))) f10)))))
(assert (let ((?v_0 (f3 (f4 f9 (f3 f6 (f3 (f4 f9 (f3 (f4 f8 f10) f10)) (f3 (f4 f8 f11) f11)))) f10)) (?v_1 (f14 f15 (f14 f16 f17)))) (= (f3 f6 (f3 (f4 f7 (f3 (f4 f8 ?v_0) ?v_0)) (f12 f13 (f14 f15 ?v_1)))) (f3 (f4 f7 ?v_0) (f12 f13 ?v_1)))))
(assert (let ((?v_1 (f14 f15 (f14 f16 f17))) (?v_0 (f3 (f4 f5 (f3 f6 (f3 (f4 f9 (f3 (f4 f8 f10) f10)) (f3 (f4 f8 f11) f11)))) f10))) (= (f3 f6 (f3 (f4 f7 (f3 (f4 f8 ?v_0) ?v_0)) (f12 f13 (f14 f15 ?v_1)))) (f3 (f4 f7 ?v_0) (f12 f13 ?v_1)))))
(assert (let ((?v_0 (f3 (f4 f9 (f3 f6 (f3 (f4 f9 (f3 (f4 f8 f10) f10)) (f3 (f4 f8 f11) f11)))) f10)) (?v_1 (f14 f15 (f14 f16 f17)))) (= (f3 f6 (f3 (f4 f7 (f3 (f4 f8 ?v_0) ?v_0)) (f12 f13 (f14 f15 ?v_1)))) (f3 (f4 f7 ?v_0) (f12 f13 ?v_1)))))
(assert (let ((?v_1 (f14 f15 (f14 f16 f17))) (?v_0 (f3 (f4 f5 (f3 f6 (f3 (f4 f9 (f3 (f4 f8 f10) f10)) (f3 (f4 f8 f11) f11)))) f10))) (= (f3 f6 (f3 (f4 f7 (f3 (f4 f8 ?v_0) ?v_0)) (f12 f13 (f14 f15 ?v_1)))) (f3 (f4 f7 ?v_0) (f12 f13 ?v_1)))))
(assert (not (= f11 f18)))
(assert (let ((?v_1 (f14 f15 (f14 f16 f17))) (?v_0 (f3 (f4 f5 (f3 f6 (f3 (f4 f9 (f3 (f4 f8 f10) f10)) (f3 (f4 f8 f11) f11)))) f10))) (= (f3 f6 (f3 (f4 f7 (f19 (f20 f21 ?v_0) (f22 f23 2))) (f12 f13 (f14 f15 ?v_1)))) (f3 (f4 f7 ?v_0) (f12 f13 ?v_1)))))
(assert (let ((?v_0 (f3 (f4 f9 (f3 f6 (f3 (f4 f9 (f3 (f4 f8 f10) f10)) (f3 (f4 f8 f11) f11)))) f10)) (?v_1 (f14 f15 (f14 f16 f17)))) (= (f3 f6 (f3 (f4 f7 (f19 (f20 f21 ?v_0) (f22 f23 2))) (f12 f13 (f14 f15 ?v_1)))) (f3 (f4 f7 ?v_0) (f12 f13 ?v_1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f12 f13 (f14 f15 (f14 f16 f17))))) (= (f3 (f4 f5 (f3 (f4 f7 (f3 (f4 f9 ?v0) ?v1)) ?v_0)) ?v0) (f3 (f4 f7 (f3 (f4 f5 ?v1) ?v0)) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f12 f13 (f14 f15 (f14 f16 f17))))) (= (f3 (f4 f5 (f3 (f4 f7 (f3 (f4 f9 ?v0) ?v1)) ?v_0)) ?v1) (f3 (f4 f7 (f3 (f4 f5 ?v0) ?v1)) ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f4 f7 ?v0) (f12 f13 (f14 f15 (f14 f16 f17)))))) (= (f3 (f4 f9 ?v_0) ?v_0) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f7 ?v1)) (?v_0 (f4 f8 (f12 f13 (f14 f15 (f14 f16 f17)))))) (= (= ?v0 (f3 ?v_1 (f3 ?v_0 ?v2))) (= (f3 ?v_0 ?v0) (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f8 ?v0) (f12 f13 (f14 f15 (f14 f16 f17)))) (f3 (f4 f9 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f8 ?v0) (f12 f13 (f14 f15 (f14 f16 f17)))) (f3 (f4 f9 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f8 (f12 f13 (f14 f15 (f14 f16 f17)))) ?v0) (f3 (f4 f9 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f8 (f12 f13 (f14 f15 (f14 f16 f17)))) ?v0) (f3 (f4 f9 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f7 ?v0) (f12 f13 (f14 f16 f17))) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f7 ?v0) (f12 f13 (f14 f16 f17))) ?v0)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f14 f15 (f14 f16 f17))) (?v_1 (f22 f23 2))) (= (f3 (f4 f7 (f19 (f20 f21 ?v0) ?v_1)) (f12 f13 (f14 f15 ?v_0))) (f19 (f20 f21 (f3 (f4 f7 ?v0) (f12 f13 ?v_0))) ?v_1)))))
(assert (forall ((?v0 Int)) (= (f14 (f24 f25 f17) ?v0) f17)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 (f24 f25 (f14 f15 ?v0)) ?v1) (f14 f15 (f14 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f9 ?v0) ?v0) f18) (= ?v0 f18))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 (f24 f25 (f14 f16 ?v0)) ?v1) (+ (f14 f15 (f14 (f24 f25 ?v0) ?v1)) ?v1))))
(assert (= 0 0))
(assert (= (f12 f13 f17) f18))
(assert (= 0 0))
(assert (= (f12 f13 f17) f18))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f26 ?v0))) (= (f14 f26 (f14 f15 ?v0)) (+ (+ 0 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f12 f13 (f14 f15 ?v0)) (f3 (f4 f9 (f3 (f4 f9 f18) ?v_0)) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 S3)) (let ((?v_0 (f12 f13 ?v1))) (= (= (f3 (f4 f7 ?v0) ?v_0) ?v2) (ite (not (= ?v_0 f18)) (= ?v0 (f3 (f4 f8 ?v2) ?v_0)) (= ?v2 f18))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f12 f13 ?v2))) (= (= (f3 (f4 f7 ?v0) ?v1) ?v_0) (ite (not (= ?v1 f18)) (= ?v0 (f3 (f4 f8 ?v_0) ?v1)) (= ?v_0 f18))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 ?v0))) (= (= ?v_0 (f3 (f4 f7 ?v1) ?v2)) (ite (not (= ?v2 f18)) (= (f3 (f4 f8 ?v_0) ?v2) ?v1) (= ?v_0 f18))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f12 f13 ?v2))) (= (= ?v0 (f3 (f4 f7 ?v1) ?v_0)) (ite (not (= ?v_0 f18)) (= (f3 (f4 f8 ?v0) ?v_0) ?v1) (= ?v0 f18))))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f7 ?v0) (f12 f13 f17)) f18)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f26 ?v0) (f14 f26 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 f13 ?v0) (f12 f13 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f26 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f12 f13 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 S8)) (= (f22 f23 (f27 f28 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f27 f28 (f22 f23 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f27 f28 (f22 f23 ?v0)) 0))))
(check-sat)
(exit)
