(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) S4)
(declare-fun f7 (S6 S4) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S4)
(declare-fun f10 () S4)
(declare-fun f11 () S2)
(declare-fun f12 () S6)
(declare-fun f13 () S4)
(declare-fun f14 (S7 S2) S2)
(declare-fun f15 () S7)
(declare-fun f16 (S8 S2) S7)
(declare-fun f17 () S8)
(declare-fun f18 () S7)
(declare-fun f19 () S8)
(declare-fun f20 (S9 Int) Int)
(declare-fun f21 () S9)
(declare-fun f22 () S8)
(declare-fun f23 (S10 Int) S9)
(declare-fun f24 () S10)
(declare-fun f25 () S8)
(declare-fun f26 () S10)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 f9)) (?v_1 (f7 f12 f9))) (not (or (= (f3 (f4 f5 (f6 ?v_0 f10)) f11) f1) (or (= (f3 (f4 f5 (f6 ?v_1 f10)) f11) f1) (or (= (f3 (f4 f5 (f6 ?v_0 f13)) f11) f1) (= (f3 (f4 f5 (f6 ?v_1 f13)) f11) f1)))))))
(assert (= (f4 f5 f9) f11))
(assert (= (f14 f15 f11) f11))
(assert (= (f4 f5 f10) f11))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f14 f15 ?v0) ?v1) f1) (=> (= (f3 (f14 f15 ?v2) ?v3) f1) (= (f3 (f14 f15 (f14 (f16 f17 ?v0) ?v2)) (f14 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4) (?v3 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f14 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f14 f18 (f14 (f16 f19 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f14 (f16 f19 ?v1) ?v2) ?v0) f1) (= (f3 ?v0 (f14 (f16 f17 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f20 f21 (- ?v0 ?v1)) ?v2) (and (< (- ?v1 ?v2) ?v0) (< ?v0 (+ ?v1 ?v2))))))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 S2)) (= (f3 ?v0 (f14 (f16 f17 ?v0) f11)) f1)))
(assert (not (= f13 f10)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f4 f5 (f6 (f7 f12 ?v0) ?v1)) (f4 f5 (f6 (f7 f12 ?v1) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f14 f15 (f14 (f16 f19 ?v0) ?v1)) (f14 f15 (f14 (f16 f19 ?v1) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f14 (f16 f17 (f14 (f16 f19 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f8 (f6 (f7 f12 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f14 (f16 f19 (f14 (f16 f17 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f12 (f6 (f7 f8 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f14 (f16 f19 (f14 (f16 f17 ?v0) ?v1)) (f14 (f16 f17 ?v2) ?v3)) (f14 (f16 f17 (f14 (f16 f19 ?v0) ?v2)) (f14 (f16 f19 ?v1) ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f6 (f7 f12 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v3)) (f6 (f7 f8 (f6 (f7 f12 ?v0) ?v2)) (f6 (f7 f12 ?v1) ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (- ?v0 ?v2) (- ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f14 (f16 f19 ?v0) ?v1) (f14 (f16 f19 ?v2) ?v3)) (= (= (f3 ?v0 ?v1) f1) (= (f3 ?v2 ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f14 (f16 f17 ?v0) ?v1) (f14 (f16 f17 ?v2) ?v1)) f1) (= (f3 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f16 f17 ?v0))) (= (= (f3 (f14 ?v_0 ?v1) (f14 ?v_0 ?v2)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 ?v0 ?v1) f1) false) (=> (=> (= (f3 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f14 (f16 f17 ?v0) ?v1) (f14 (f16 f17 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f14 ?v_0 ?v1) (f14 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f14 ?v_0 ?v1) (f14 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f14 (f16 f17 ?v0) ?v1) (f14 (f16 f17 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f16 f17 ?v0))) (= (= (f14 ?v_0 ?v1) (f14 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f14 (f16 f17 (f14 (f16 f22 ?v0) ?v1)) ?v2) (f14 (f16 f22 (f14 (f16 f17 ?v0) ?v2)) (f14 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f20 (f23 f24 ?v0) ?v1) ?v2) (f20 (f23 f24 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f14 (f16 f17 (f14 (f16 f25 ?v0) ?v1)) ?v2) (f14 (f16 f25 (f14 (f16 f17 ?v0) ?v2)) (f14 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f20 (f23 f26 ?v0) ?v1) ?v2) (f20 (f23 f26 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f16 f17 ?v0))) (= (f14 (f16 f17 (f14 ?v_0 ?v1)) ?v2) (f14 ?v_0 (f14 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 (f16 f17 (f14 f18 ?v0)) (f14 f18 ?v1)))) (= (f14 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f20 f21 ?v0) (f20 f21 ?v1)))) (= (f20 f21 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S2)) (= (= f11 ?v0) (= ?v0 f11))))
(assert (forall ((?v0 S4)) (= (= f10 ?v0) (= ?v0 f10))))
(assert (= (f14 f18 f11) f11))
(assert (= (f20 f21 1) 1))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f6 (f7 f12 ?v0) ?v1) (f6 (f7 f12 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f14 (f16 f19 ?v0) ?v1) (f14 (f16 f19 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f20 (f23 f24 ?v0) ?v1) ?v2) (f20 (f23 f24 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f14 (f16 f19 (f14 (f16 f22 ?v0) ?v1)) ?v2) (f14 (f16 f22 (f14 (f16 f19 ?v0) ?v2)) (f14 (f16 f19 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f20 (f23 f26 ?v0) ?v1) ?v2) (f20 (f23 f26 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f14 (f16 f19 (f14 (f16 f25 ?v0) ?v1)) ?v2) (f14 (f16 f25 (f14 (f16 f19 ?v0) ?v2)) (f14 (f16 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f14 f18 (f14 (f16 f19 ?v0) ?v1)) (f14 f18 (f14 (f16 f19 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 f21 (- ?v0 ?v1)) (f20 f21 (- ?v1 ?v0)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f4 f5 ?v0))) (= (f14 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f14 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f3 (f14 ?v_0 ?v1) (f14 ?v_0 ?v2)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f14 (f16 f17 ?v0) ?v1) (f14 (f16 f17 ?v2) ?v1)) f1) (= (f3 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(check-sat)
(exit)
