(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S2)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () S2)
(declare-fun f7 (S4 S2) Int)
(declare-fun f8 () S4)
(declare-fun f9 (S2) S1)
(declare-fun f10 () S5)
(declare-fun f11 () S5)
(declare-fun f12 (S6 Int) Int)
(declare-fun f13 (S7 Int) S6)
(declare-fun f14 () S7)
(declare-fun f15 (S8 S5) S5)
(declare-fun f16 (S9 S5) S8)
(declare-fun f17 () S9)
(declare-fun f18 () S6)
(assert (not (= f1 f2)))
(assert (not (not (= f3 (f4 f5 0)))))
(assert (not (= f6 (f4 f5 0))))
(assert (= f6 (f4 f5 (* 2 (f7 f8 f3)))))
(assert (= f6 (f4 f5 (* 2 (f7 f8 f3)))))
(assert (= (f9 f6) f1))
(assert (exists ((?v0 S2)) (= f6 (f4 f5 (* 2 (f7 f8 ?v0))))))
(assert (=> (forall ((?v0 S2)) (=> (= f6 (f4 f5 (* 2 (f7 f8 ?v0)))) false)) false))
(assert (not (= f10 f11)))
(assert (not (= f6 (f4 f5 0))))
(assert (forall ((?v0 S2)) (= (= (f9 ?v0) f1) (exists ((?v1 S2)) (= ?v0 (f4 f5 (f12 (f13 f14 (+ (+ 0 1) 1)) (f7 f8 ?v1))))))))
(assert (forall ((?v0 S2)) (= (= (f9 ?v0) f1) (exists ((?v1 S2)) (= ?v0 (f4 f5 (* 2 (f7 f8 ?v1))))))))
(assert (forall ((?v0 S2)) (= (not (= (f9 ?v0) f1)) (exists ((?v1 S2)) (= ?v0 (f4 f5 (+ (f12 (f13 f14 (+ (+ 0 1) 1)) (f7 f8 ?v1)) 1)))))))
(assert (forall ((?v0 S2)) (= (not (= (f9 ?v0) f1)) (exists ((?v1 S2)) (= ?v0 (f4 f5 (+ (* 2 (f7 f8 ?v1)) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f9 (f4 f5 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) f1) (or (= (f9 ?v0) f1) (= (f9 ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 f11) ?v0) f11)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 f11) ?v0) f11)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 f11) ?v0) f11)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 f11) ?v0) f11)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) f11) f11)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) f11) f11)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) (f15 (f16 f17 ?v2) ?v3)) (f15 (f16 f17 (f15 ?v_0 ?v2)) (f15 (f16 f17 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) (f12 (f13 f14 ?v2) ?v3)) (f12 (f13 f14 (f12 ?v_0 ?v2)) (f12 (f13 f14 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f16 f17 (f15 (f16 f17 ?v0) ?v1))) (?v_0 (f16 f17 ?v2))) (= (f15 ?v_1 (f15 ?v_0 ?v3)) (f15 ?v_0 (f15 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f13 f14 (f12 (f13 f14 ?v0) ?v1))) (?v_0 (f13 f14 ?v2))) (= (f12 ?v_1 (f12 ?v_0 ?v3)) (f12 ?v_0 (f12 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f15 (f16 f17 ?v2) ?v3))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v_1) (f15 ?v_0 (f15 (f16 f17 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f12 (f13 f14 ?v2) ?v3))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v_1) (f12 ?v_0 (f12 (f13 f14 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 (f16 f17 (f15 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 (f13 f14 (f12 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f14 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f18 ?v0))) (= (f12 (f13 f14 ?v_0) ?v_0) (f12 (f13 f14 ?v0) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2)) (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f12 (f13 f14 ?v1) ?v2)) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f16 f17 ?v0)) (?v_0 (f16 f17 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f13 f14 ?v0)) (?v_0 (f13 f14 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 ?v0) ?v1) (f12 (f13 f14 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 f18 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f14 (f12 f18 ?v0)) (f12 f18 ?v1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (=> (< 0 ?v_0) (= (= (f9 ?v0) f1) (not (= (f9 (f4 f5 (- ?v_0 1))) f1)))))))
(assert (forall ((?v0 S2)) (=> (not (= (f9 ?v0) f1)) (< 0 (f7 f8 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f9 ?v0) f1)) (?v_1 (= (f9 ?v1) f1))) (= (= (f9 (f4 f5 (+ (f7 f8 ?v0) (f7 f8 ?v1)))) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (= (f9 ?v0) f1)) (?v_3 (= (f9 ?v1) f1))) (= (= (f9 (f4 f5 (- ?v_0 ?v_1))) f1) (or (< ?v_0 ?v_1) (or (and ?v_2 ?v_3) (and (not ?v_2) (not ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f9 (f4 f5 (+ (f7 f8 ?v0) (f7 f8 ?v1)))) f1) (= (= (f9 ?v0) f1) (= (f9 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= (f9 (f4 f5 (+ (f7 f8 ?v0) (f7 f8 ?v1)))) f1)) (not (= (not (= (f9 ?v0) f1)) (not (= (f9 ?v1) f1)))))))
(assert (forall ((?v0 S2)) (= (= (f9 (f4 f5 (+ (f7 f8 ?v0) 1))) f1) (not (= (f9 ?v0) f1)))))
(assert (not (= (f9 (f4 f5 1)) f1)))
(assert (= (f9 (f4 f5 0)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 (f13 f14 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f15 (f16 f17 ?v0) ?v1) f11) (or (= ?v0 f11) (= ?v1 f11)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f12 (f13 f14 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f11)) (=> (not (= ?v1 f11)) (not (= (f15 (f16 f17 ?v0) ?v1) f11))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 (f13 f14 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f15 (f16 f17 ?v0) ?v1) f11) (or (= ?v0 f11) (= ?v1 f11)))))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) f11) f11)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) f11) f11)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f4 f5 (f12 (f13 f14 ?v0) ?v1)) (f4 f5 (f12 (f13 f14 (f7 f8 (f4 f5 (- ?v0)))) (f7 f8 (f4 f5 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f4 f5 (f12 (f13 f14 (f7 f8 (f4 f5 ?v0))) (f7 f8 (f4 f5 ?v1)))) (f4 f5 (f12 (f13 f14 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f4 f5 (f12 (f13 f14 ?v0) ?v1)) (f4 f5 (f12 (f13 f14 (f7 f8 (f4 f5 ?v0))) (f7 f8 (f4 f5 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (= (f4 f5 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f4 f5 (f12 (f13 f14 (f7 f8 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)))) (f7 f8 (f4 f5 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_2 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f12 (f13 f14 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f12 (f13 f14 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f12 (f13 f14 ?v_2) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 ?v0) ?v1) (f12 (f13 f14 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (+ ?v1 ?v2)) (+ (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (- ?v1 ?v2)) (- (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 (- ?v0)) ?v1) (- (f12 (f13 f14 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 (f13 f14 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f14 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f12 (f13 f14 (+ ?v0 ?v1)) ?v2) (+ (f12 (f13 f14 ?v0) ?v2) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f12 (f13 f14 (- ?v0 ?v1)) ?v2) (- (f12 (f13 f14 ?v0) ?v2) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f12 (f13 f14 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f12 (f13 f14 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f12 ?v_0 ?v0) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f7 f8 ?v2))) (let ((?v_1 (f13 f14 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f12 ?v_1 ?v0) (f12 ?v_1 ?v1))))))))
(assert (forall ((?v0 S2)) (= (f4 f5 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f4 f5 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f4 f5 ?v0)) 0))))
(check-sat)
(exit)
