(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S3) S3)
(declare-fun f7 () S4)
(declare-fun f8 () S3)
(declare-fun f9 () S3)
(declare-fun f10 (S4) S1)
(declare-fun f11 (S5 S4) S4)
(declare-fun f12 (S6 S4) S5)
(declare-fun f13 () S6)
(declare-fun f14 () S4)
(declare-fun f15 (S7 Int) S3)
(declare-fun f16 () S7)
(declare-fun f17 (S8 S3) S5)
(declare-fun f18 (S9 S3) S8)
(declare-fun f19 () S9)
(declare-fun f20 (S10 S3) S4)
(declare-fun f21 (S11 S3) S10)
(declare-fun f22 (S12 S4) S11)
(declare-fun f23 () S12)
(declare-fun f24 (S13) S1)
(declare-fun f25 () S13)
(assert (not (= f1 f2)))
(assert (not (<= (f3 f4 f5) (f3 f4 (f6 f7 f8)))))
(assert (<= (+ (f3 f4 f5) (f3 f4 f9)) (f3 f4 f8)))
(assert (<= (f3 f4 f8) (f3 f4 (f6 f7 f8))))
(assert (<= (f3 f4 f8) (f3 f4 (f6 f7 f8))))
(assert (<= (+ (f3 f4 f5) (f3 f4 f9)) (f3 f4 f8)))
(assert (= (f10 f7) f1))
(assert (= (f10 (f11 (f12 f13 f14) f7)) f1))
(assert (= (f10 f14) f1))
(assert (forall ((?v0 S4)) (= (= (f10 ?v0) f1) (forall ((?v1 S3) (?v2 S3)) (=> (< (f3 f4 ?v1) (f3 f4 ?v2)) (< (f3 f4 (f6 ?v0 ?v1)) (f3 f4 (f6 ?v0 ?v2))))))))
(assert (forall ((?v0 S4)) (= (= (f10 ?v0) f1) (forall ((?v1 S3)) (< (f3 f4 (f6 ?v0 ?v1)) (f3 f4 (f6 ?v0 (f15 f16 (+ (f3 f4 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (= (f10 ?v0) f1) (<= (f3 f4 ?v1) (f3 f4 (f6 ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S3)) (= (f6 (f11 (f12 f13 ?v0) ?v1) ?v2) (f6 ?v0 (f6 ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S3)) (= (f6 (f11 (f12 f13 ?v0) ?v1) ?v2) (f6 ?v0 (f6 ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S3)) (=> (= (f11 (f12 f13 ?v0) ?v1) ?v2) (= (f6 ?v0 (f6 ?v1 ?v3)) (f6 ?v2 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3) (?v3 S4)) (let ((?v_1 (f12 f13 ?v0)) (?v_0 (f17 (f18 f19 ?v1) ?v2))) (= (f11 ?v_1 (f11 ?v_0 ?v3)) (f11 ?v_0 (f11 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S3) (?v3 S3)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 ?v_0 (f20 (f21 (f22 f23 ?v1) ?v2) ?v3)) (f20 (f21 (f22 f23 (f11 ?v_0 ?v1)) ?v2) (f6 ?v0 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S3)) (= (f20 (f21 (f22 f23 ?v0) ?v1) (f6 ?v0 ?v1)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f6 (f20 (f21 (f22 f23 ?v0) ?v1) ?v2) ?v3) (ite (= ?v3 ?v1) ?v2 (f6 ?v0 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (=> (= (f6 ?v0 ?v1) ?v2) (= (f20 (f21 (f22 f23 ?v0) ?v1) ?v2) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S4)) (let ((?v_1 (f18 f19 ?v0))) (let ((?v_0 (f17 ?v_1 ?v2))) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v1)) (= (f11 ?v_0 (f11 (f17 (f18 f19 ?v2) ?v1) (f11 ?v_0 ?v3))) (f11 (f17 ?v_1 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S4) (?v3 S3)) (=> (not (= ?v0 ?v1)) (= (f6 (f20 (f21 (f22 f23 ?v2) ?v1) ?v3) ?v0) (f6 ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S4) (?v3 S3) (?v4 S3)) (let ((?v_0 (f22 f23 ?v2))) (=> (not (= ?v0 ?v1)) (= (f20 (f21 (f22 f23 (f20 (f21 ?v_0 ?v0) ?v3)) ?v1) ?v4) (f20 (f21 (f22 f23 (f20 (f21 ?v_0 ?v1) ?v4)) ?v0) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f6 (f20 (f21 (f22 f23 ?v0) ?v1) ?v2) ?v3) (ite (= ?v3 ?v1) ?v2 (f6 ?v0 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (= (f6 (f20 (f21 (f22 f23 ?v0) ?v1) ?v2) ?v1) ?v2)))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f21 (f22 f23 ?v0) ?v1))) (= (f20 (f21 (f22 f23 (f20 ?v_0 ?v2)) ?v1) ?v3) (f20 ?v_0 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S4)) (let ((?v_0 (f17 (f18 f19 ?v0) ?v1))) (= (f11 ?v_0 (f11 ?v_0 ?v2)) ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S4)) (= (f11 (f17 (f18 f19 ?v0) ?v1) ?v2) (f20 (f21 (f22 f23 (f20 (f21 (f22 f23 ?v2) ?v0) (f6 ?v2 ?v1))) ?v1) (f6 ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S4)) (= (f11 (f17 (f18 f19 ?v0) ?v1) ?v2) (f11 (f17 (f18 f19 ?v1) ?v0) ?v2))))
(assert (forall ((?v0 S3) (?v1 S4)) (= (f11 (f17 (f18 f19 ?v0) ?v0) ?v1) ?v1)))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (= (= (f20 (f21 (f22 f23 ?v0) ?v1) ?v2) ?v0) (= (f6 ?v0 ?v1) ?v2))))
(assert (not (= (f24 f25) f1)))
(assert (forall ((?v0 S3)) (= (f15 f16 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
