(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 (S3 S2) S1)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S2)
(declare-fun f8 () S2)
(declare-fun f9 (S5 S2) S2)
(declare-fun f10 (S6 S2) S5)
(declare-fun f11 () S6)
(declare-fun f12 () S2)
(declare-fun f13 () S2)
(declare-fun f14 () S5)
(declare-fun f15 (S7 Int) Int)
(declare-fun f16 () S7)
(declare-fun f17 () S7)
(declare-fun f18 () S5)
(declare-fun f19 () S5)
(declare-fun f20 () S5)
(declare-fun f21 () S6)
(declare-fun f22 () S6)
(declare-fun f23 (S8 Int) S7)
(declare-fun f24 () S8)
(declare-fun f25 () S8)
(declare-fun f26 (S10 S9) S1)
(declare-fun f27 (S11 Int) S10)
(declare-fun f28 () S11)
(declare-fun f29 (S9 Int) S1)
(declare-fun f30 (S12 S3) S1)
(declare-fun f31 (S13 S2) S12)
(declare-fun f32 () S13)
(declare-fun f33 (S14 S2) Int)
(declare-fun f34 (S15 Int) S2)
(declare-fun f35 () S3)
(declare-fun f36 () S6)
(declare-fun f37 () S9)
(declare-fun f38 () S3)
(declare-fun f39 () S4)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 (f5 f6 f7) ?v0) f1) (=> (= (f4 ?v_0 f8) f1) (=> (= (f4 ?v_0 (f9 (f10 f11 f12) f13)) f1) (= f3 f1)))))))
(assert (exists ((?v0 S2)) (let ((?v_0 (f5 f6 ?v0))) (and (= (f4 (f5 f6 f7) ?v0) f1) (and (= (f4 ?v_0 f8) f1) (= (f4 ?v_0 (f9 (f10 f11 f12) f13)) f1))))))
(assert (= (f4 (f5 f6 f7) f12) f1))
(assert (= (f4 (f5 f6 f7) f13) f1))
(assert (= (f4 (f5 f6 f7) f8) f1))
(assert (exists ((?v0 S2)) (let ((?v_0 (f5 f6 ?v0))) (and (= (f4 (f5 f6 f7) ?v0) f1) (and (= (f4 ?v_0 f8) f1) (= (f4 ?v_0 (f9 (f10 f11 f12) f13)) f1))))))
(assert (= (f4 (f5 f6 f7) (f9 (f10 f11 f12) f13)) f1))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) ?v0) (ite (= ?v0 f7) f7 f8))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f7)) (= (f9 (f10 f11 ?v0) ?v0) f8))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f7)) (= (= (f9 (f10 f11 ?v1) ?v0) f8) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 f7))) (= (= (f4 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1) (or (and (= (f4 ?v_0 ?v0) f1) (= (f4 ?v_0 ?v1) f1)) (and (= (f4 (f5 f6 ?v0) f7) f1) (= (f4 (f5 f6 ?v1) f7) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 f7))) (= (= (f4 (f5 f6 (f9 (f10 f11 ?v0) ?v1)) f7) f1) (or (and (= (f4 ?v_0 ?v0) f1) (= (f4 (f5 f6 ?v1) f7) f1)) (and (= (f4 (f5 f6 ?v0) f7) f1) (= (f4 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f4 (f5 f6 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 ?v2) ?v1)) f1) (and (=> (= (f4 (f5 f6 f7) ?v1) f1) (= (f4 (f5 f6 ?v0) ?v2) f1)) (and (=> (= (f4 (f5 f6 ?v1) f7) f1) (= (f4 (f5 f6 ?v2) ?v0) f1)) (not (= ?v1 f7)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 f7) ?v0) f1) (= (f9 (f10 f11 (f9 f14 ?v1)) ?v0) (f9 f14 (f9 (f10 f11 ?v1) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 f7))) (=> (= (f4 ?v_0 ?v0) f1) (=> (= (f4 ?v_0 ?v1) f1) (= (f4 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 f7) ?v0) f1) (=> (= (f4 (f5 f6 ?v1) f7) f1) (= (f4 (f5 f6 (f9 (f10 f11 ?v0) ?v1)) f7) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) f7) f1) (=> (= (f4 (f5 f6 f7) ?v1) f1) (= (f4 (f5 f6 (f9 (f10 f11 ?v0) ?v1)) f7) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) f7) f1) (=> (= (f4 (f5 f6 ?v1) f7) f1) (= (f4 (f5 f6 f7) (f9 (f10 f11 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= (f4 (f5 f6 f7) ?v2) f1) (= (f4 (f5 f6 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f4 (f5 f6 ?v0) ?v1) f1) false) (=> (=> (= (f4 (f5 f6 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (= (f9 f14 f8) f8))
(assert (= (f15 f16 1) 1))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 f14 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 (f9 f14 ?v0)) (f9 f14 ?v1)))))
(assert (not (= 0 1)))
(assert (not (= f7 f8)))
(assert (not (= 1 0)))
(assert (not (= f8 f7)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f7)) (= (f9 f14 (f9 (f10 f11 ?v1) ?v0)) (f9 (f10 f11 (f9 f14 ?v1)) (f9 f14 ?v0))))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) f7) f7)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 f7) ?v0) f7)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) f8) ?v0)))
(assert (< 0 1))
(assert (= (f4 (f5 f6 f7) f8) f1))
(assert (not (< 1 0)))
(assert (not (= (f4 (f5 f6 f8) f7) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= (f4 (f5 f6 ?v2) f7) f1) (= (f4 (f5 f6 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 ?v0) ?v2)) f1)))))
(assert (not (= f7 f8)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 f7) ?v0) f7)))
(assert (forall ((?v0 S2)) (=> (= (f4 (f5 f6 f7) ?v0) f1) (= (f9 f14 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f15 f16 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (= (f4 (f5 f6 f7) (f9 f14 ?v0)) f1) (not (= ?v0 f7)))))
(assert (forall ((?v0 Int)) (= (< 0 (f15 f16 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S2)) (not (= (f4 (f5 f6 (f9 f14 ?v0)) f7) f1))))
(assert (forall ((?v0 Int)) (not (< (f15 f16 ?v0) 0))))
(assert (forall ((?v0 S3)) (=> (exists ((?v1 S2)) (= (f4 ?v0 ?v1) f1)) (=> (exists ((?v1 S2)) (forall ((?v2 S2)) (=> (= (f4 ?v0 ?v2) f1) (= (f4 (f5 f6 ?v2) ?v1) f1)))) (exists ((?v1 S2)) (forall ((?v2 S2)) (= (exists ((?v3 S2)) (and (= (f4 ?v0 ?v3) f1) (= (f4 (f5 f6 ?v2) ?v3) f1))) (= (f4 (f5 f6 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (= (f4 (f5 f6 ?v0) ?v1) f1))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (= (f4 (f5 f6 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f15 f17 ?v0) 1))))
(assert (forall ((?v0 S2)) (=> (= (f4 (f5 f6 f7) ?v0) f1) (= (f9 f18 ?v0) f8))))
(assert (forall ((?v0 Int)) (= (= (f15 f17 ?v0) 1) (< 0 ?v0))))
(assert (forall ((?v0 S2)) (= (= (f9 f18 ?v0) f8) (= (f4 (f5 f6 f7) ?v0) f1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f9 f18 ?v0))) (= (f9 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f17 ?v0))) (= (f15 f17 ?v_0) ?v_0))))
(assert (= (f9 f18 f7) f7))
(assert (= (f15 f17 0) 0))
(assert (= (f9 f18 f7) f7))
(assert (forall ((?v0 S2)) (= (= (f9 f18 ?v0) f7) (= ?v0 f7))))
(assert (= (f9 f18 f8) f8))
(assert (forall ((?v0 S2)) (= (f9 f18 ?v0) (f9 (f10 f11 ?v0) (f9 f14 ?v0)))))
(assert (forall ((?v0 S2)) (= (= (f9 f18 ?v0) f7) (= ?v0 f7))))
(assert (forall ((?v0 Int)) (= (= (f15 f17 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (=> (= (f4 (f5 f6 f7) ?v0) f1) (= (f9 f18 ?v0) f8))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f5 f6 f7))) (= (= (f4 ?v_0 (f9 f18 ?v0)) f1) (= (f4 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f15 f17 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S2)) (= (= (f4 (f5 f6 (f9 f18 ?v0)) f7) f1) (= (f4 (f5 f6 ?v0) f7) f1))))
(assert (forall ((?v0 Int)) (= (< (f15 f17 ?v0) 0) (< ?v0 0))))
(assert (= (f9 f14 f7) f7))
(assert (= (f15 f16 0) 0))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= f7 ?v0) (= ?v0 f7))))
(assert (forall ((?v0 S2)) (= (= (f9 f14 ?v0) f7) (= ?v0 f7))))
(assert (forall ((?v0 Int)) (= (= (f15 f16 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S2)) (= (= f8 ?v0) (= ?v0 f8))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 f7))) (=> (= (f4 ?v_0 ?v0) f1) (=> (= (f4 ?v_0 ?v1) f1) (exists ((?v2 S2)) (let ((?v_1 (f5 f6 ?v2))) (and (= (f4 ?v_0 ?v2) f1) (and (= (f4 ?v_1 ?v0) f1) (= (f4 ?v_1 ?v1) f1))))))))))
(assert (forall ((?v0 S2)) (= (f9 f19 (f9 f18 ?v0)) (ite (= ?v0 f7) f7 f8))))
(assert (forall ((?v0 Int)) (= (f15 f17 ?v0) (ite (= ?v0 0) 0 (ite (< 0 ?v0) 1 (- 1))))))
(assert (forall ((?v0 S2)) (= (f9 f18 ?v0) (ite (= ?v0 f7) f7 (ite (= (f4 (f5 f6 f7) ?v0) f1) f8 (f9 f20 f8))))))
(assert (forall ((?v0 Int)) (= (= (f15 f17 ?v0) (- 1)) (< ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f9 f18 ?v0) (f9 f20 f8)) (= (f4 (f5 f6 ?v0) f7) f1))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f15 f17 ?v0) (- 1)))))
(assert (forall ((?v0 S2)) (=> (= (f4 (f5 f6 ?v0) f7) f1) (= (f9 f18 ?v0) (f9 f20 f8)))))
(assert (forall ((?v0 S2)) (not (= (f4 (f5 f6 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= ?v0 ?v1)) (or (= (f4 (f5 f6 ?v0) ?v1) f1) (= (f4 (f5 f6 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= (f4 (f5 f6 ?v0) ?v1) f1)) (or (= (f4 (f5 f6 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f9 f20 ?v0) (f9 f20 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f9 f20 ?v0) ?v1) (= (f9 f20 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 (f9 f20 ?v1)) (= ?v1 (f9 f20 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 f20 (f9 (f10 f21 ?v0) ?v1)) (f9 (f10 f22 (f9 f20 ?v0)) (f9 f20 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f15 (f23 f24 ?v0) ?v1)) (f15 (f23 f25 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 f20 (f9 (f10 f22 ?v0) ?v1)) (f9 (f10 f21 (f9 f20 ?v0)) (f9 f20 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f15 (f23 f25 ?v0) ?v1)) (f15 (f23 f24 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S2)) (= (f9 f19 (f9 f20 ?v0)) (f9 f19 ?v0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f9 f19 ?v0))) (= (f9 f14 ?v_0) ?v_0))))
(assert (forall ((?v0 S2)) (= (f9 f14 (f9 f20 ?v0)) (f9 f14 ?v0))))
(assert (forall ((?v0 Int)) (= (f15 f16 (- ?v0)) (f15 f16 ?v0))))
(assert (forall ((?v0 S2)) (= (f9 f20 (f9 f20 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (= (- ?v0) ?v0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f9 f20 ?v0) ?v0) (= ?v0 f7))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f9 f20 ?v0) f7) (= ?v0 f7))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= ?v0 (f9 f20 ?v0)) (= ?v0 f7))))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (forall ((?v0 S2)) (= (= f7 (f9 f20 ?v0)) (= f7 ?v0))))
(assert (= 0 0))
(assert (= (f9 f20 f7) f7))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f26 (f27 f28 ?v0) ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (= (f30 (f31 f32 ?v0) ?v1) f1) (= (f4 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f6 (f9 f14 ?v0)) ?v1) f1) (and (= (f4 (f5 f6 ?v0) ?v1) f1) (= (f4 (f5 f6 (f9 f20 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f15 f16 ?v0) ?v1) (and (< ?v0 ?v1) (< (- ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f6 (f9 f20 ?v0)) (f9 f20 ?v1)) f1) (= (f4 (f5 f6 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) (- ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f6 (f9 f20 ?v0)) ?v1) f1) (= (f4 (f5 f6 (f9 f20 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) ?v1) (< (- ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f6 ?v0) (f9 f20 ?v1)) f1) (= (f4 (f5 f6 ?v1) (f9 f20 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 (- ?v1)) (< ?v1 (- ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f10 f11 (f9 f20 ?v0)) (f9 f20 ?v1)) (f9 (f10 f11 ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 f20 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 (f9 f20 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 f20 (f9 ?v_0 ?v1)) (f9 ?v_0 (f9 f20 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f10 f11 (f9 f20 ?v0)) ?v1) (f9 f20 (f9 (f10 f11 ?v0) ?v1)))))
(assert (forall ((?v0 S2)) (= (f9 f18 (f9 f20 ?v0)) (f9 f20 (f9 f18 ?v0)))))
(assert (forall ((?v0 Int)) (= (< ?v0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (= (f4 ?v_0 (f9 f20 ?v0)) f1) (= (f4 ?v_0 f7) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f4 (f5 f6 ?v0) f7) f1) (= (f9 f14 ?v0) (f9 f20 ?v0)))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f15 f16 ?v0) (- ?v0)))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) ?v0) (< 0 ?v0))))
(assert (forall ((?v0 S2)) (= (= (f4 (f5 f6 (f9 f20 ?v0)) ?v0) f1) (= (f4 (f5 f6 f7) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) 0) (< 0 ?v0))))
(assert (forall ((?v0 S2)) (= (= (f4 (f5 f6 (f9 f20 ?v0)) f7) f1) (= (f4 (f5 f6 f7) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f4 (f5 f6 f7) (f9 f20 ?v0)) f1) (= (f4 (f5 f6 ?v0) f7) f1))))
(assert (forall ((?v0 S2)) (= (f9 f14 ?v0) (ite (= (f4 (f5 f6 ?v0) f7) f1) (f9 f20 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f15 f16 ?v0) (ite (< ?v0 0) (- ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (= (f9 f19 ?v0) f7) (= ?v0 f7))))
(assert (= (f9 f19 f7) f7))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f7)) (= (f9 (f10 f11 (f9 f20 ?v1)) (f9 f20 ?v0)) (f9 (f10 f11 ?v1) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f11 ?v1))) (=> (not (= ?v0 f7)) (= (f9 f20 (f9 ?v_0 ?v0)) (f9 ?v_0 (f9 f20 ?v0)))))))
(assert (forall ((?v0 S2)) (not (= (f4 (f5 f6 (f9 f19 ?v0)) f7) f1))))
(assert (= (f9 f19 f8) f8))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 f19 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 (f9 f19 ?v0)) (f9 f19 ?v1)))))
(assert (forall ((?v0 S2)) (= (f9 f14 ?v0) (ite (= (f4 (f5 f6 ?v0) f7) f1) (f9 f20 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f9 f14 ?v0) (ite (= (f4 (f5 f6 ?v0) f7) f1) (f9 f20 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (= (f4 (f5 f6 f7) (f9 f19 ?v0)) f1) (not (= ?v0 f7)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f7)) (= (f9 f19 (f9 (f10 f11 ?v1) ?v0)) (f9 (f10 f11 (f9 f19 ?v1)) (f9 f19 ?v0))))))
(assert (forall ((?v0 S2)) (= (f9 f18 ?v0) (ite (= ?v0 f7) f7 (ite (= (f4 (f5 f6 f7) ?v0) f1) f8 (f9 f20 f8))))))
(assert (forall ((?v0 S2)) (= (f9 f18 ?v0) (ite (= ?v0 f7) f7 (ite (= (f4 (f5 f6 f7) ?v0) f1) f8 (f9 f20 f8))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (=> (= (f4 (f5 f6 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f4 (f5 f6 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (=> (not false) (= (f4 (f5 f6 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v2))) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= (f4 ?v_0 ?v0) f1) (= (f4 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 ?v_0 ?v1) f1) (=> (= (f4 (f5 f6 ?v1) ?v2) f1) (= (f4 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f4 (f5 f6 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f4 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v2))) (=> (= ?v0 ?v1) (=> (= (f4 ?v_0 ?v1) f1) (= (f4 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f4 (f5 f6 ?v1) ?v2) f1) (= (f4 (f5 f6 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= (f4 (f5 f6 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= (f4 (f5 f6 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S1)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (= (=> (= (f4 (f5 f6 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (= (not (= (f4 (f5 f6 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (not (= (f4 (f5 f6 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f4 (f5 f6 ?v0) ?v1) f1) false) (=> (=> (= (f4 (f5 f6 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= (f4 (f5 f6 ?v0) ?v1) f1)) (= (not (= (f4 (f5 f6 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f4 (f5 f6 (f9 (f10 f21 ?v0) ?v1)) ?v2) f1) (or (= (f4 (f5 f6 ?v0) ?v2) f1) (= (f4 (f5 f6 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f15 (f23 f24 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f4 (f5 f6 (f9 (f10 f22 ?v0) ?v1)) ?v2) f1) (and (= (f4 (f5 f6 ?v0) ?v2) f1) (= (f4 (f5 f6 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f15 (f23 f25 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (= (f4 ?v_0 (f9 (f10 f21 ?v1) ?v2)) f1) (and (= (f4 ?v_0 ?v1) f1) (= (f4 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f15 (f23 f24 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (= (f4 ?v_0 (f9 (f10 f22 ?v1) ?v2)) f1) (or (= (f4 ?v_0 ?v1) f1) (= (f4 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f15 (f23 f25 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f4 (f5 f6 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f4 (f5 f6 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S14) (?v1 S2) (?v2 Int) (?v3 S2)) (=> (< (f33 ?v0 ?v1) ?v2) (=> (= (f4 (f5 f6 ?v3) ?v1) f1) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f4 (f5 f6 ?v5) ?v4) f1) (< (f33 ?v0 ?v5) (f33 ?v0 ?v4)))) (< (f33 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S15) (?v1 Int) (?v2 S2) (?v3 Int)) (=> (= (f4 (f5 f6 (f34 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f4 (f5 f6 (f34 ?v0 ?v5)) (f34 ?v0 ?v4)) f1))) (= (f4 (f5 f6 (f34 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S2) (?v3 S2)) (=> (= ?v0 (f9 ?v1 ?v2)) (=> (= (f4 (f5 f6 ?v3) ?v2) f1) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f4 (f5 f6 ?v5) ?v4) f1) (= (f4 (f5 f6 (f9 ?v1 ?v5)) (f9 ?v1 ?v4)) f1))) (= (f4 (f5 f6 (f9 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f15 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f15 ?v1 ?v5) (f15 ?v1 ?v4)))) (< (f15 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S2) (?v3 S2)) (=> (< ?v0 (f33 ?v1 ?v2)) (=> (= (f4 (f5 f6 ?v2) ?v3) f1) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f4 (f5 f6 ?v4) ?v5) f1) (< (f33 ?v1 ?v4) (f33 ?v1 ?v5)))) (< ?v0 (f33 ?v1 ?v3)))))))
(assert (forall ((?v0 S2) (?v1 S15) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 ?v_0 (f34 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f4 (f5 f6 (f34 ?v1 ?v4)) (f34 ?v1 ?v5)) f1))) (= (f4 ?v_0 (f34 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 S2) (?v1 S15) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f34 ?v1 ?v2)) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f4 (f5 f6 (f34 ?v1 ?v4)) (f34 ?v1 ?v5)) f1))) (= (f4 (f5 f6 ?v0) (f34 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S2) (?v3 S2)) (=> (= ?v0 (f33 ?v1 ?v2)) (=> (= (f4 (f5 f6 ?v2) ?v3) f1) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f4 (f5 f6 ?v4) ?v5) f1) (< (f33 ?v1 ?v4) (f33 ?v1 ?v5)))) (< ?v0 (f33 ?v1 ?v3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 ?v_0 ?v1) f1) (= (f4 ?v_0 (f9 (f10 f22 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f15 (f23 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 ?v_0 ?v1) f1) (= (f4 ?v_0 (f9 (f10 f22 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f15 (f23 f25 ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (= (f4 (f5 f6 (f9 (f10 f21 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f15 (f23 f24 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (= (f4 (f5 f6 (f9 (f10 f21 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f15 (f23 f24 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (= (f4 (f5 f6 ?v0) ?v1) f1))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (= (f4 (f5 f6 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (exists ((?v2 S2)) (and (= (f4 (f5 f6 ?v0) ?v2) f1) (= (f4 (f5 f6 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 S15)) (let ((?v_0 (f5 f6 ?v2))) (=> (< ?v0 ?v1) (=> (= (f4 ?v_0 (f34 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f4 (f5 f6 (f34 ?v3 ?v5)) (f34 ?v3 ?v4)) f1))) (= (f4 ?v_0 (f34 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int) (?v3 S14)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (< ?v2 (f33 ?v3 ?v0)) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f4 (f5 f6 ?v5) ?v4) f1) (< (f33 ?v3 ?v5) (f33 ?v3 ?v4)))) (< ?v2 (f33 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 S2)) (=> (< ?v0 ?v1) (=> (= (f4 (f5 f6 (f34 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f4 (f5 f6 (f34 ?v2 ?v4)) (f34 ?v2 ?v5)) f1))) (= (f4 (f5 f6 (f34 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S14) (?v3 Int)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (< (f33 ?v2 ?v1) ?v3) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f4 (f5 f6 ?v4) ?v5) f1) (< (f33 ?v2 ?v4) (f33 ?v2 ?v5)))) (< (f33 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 S2)) (=> (< ?v0 ?v1) (=> (= (f34 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f4 (f5 f6 (f34 ?v2 ?v4)) (f34 ?v2 ?v5)) f1))) (= (f4 (f5 f6 (f34 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S14) (?v3 Int)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= (f33 ?v2 ?v1) ?v3) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f4 (f5 f6 ?v4) ?v5) f1) (< (f33 ?v2 ?v4) (f33 ?v2 ?v5)))) (< (f33 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5) (?v3 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= (f9 ?v2 ?v0) ?v3) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f4 (f5 f6 ?v5) ?v4) f1) (= (f4 (f5 f6 (f9 ?v2 ?v5)) (f9 ?v2 ?v4)) f1))) (= (f4 (f5 f6 ?v3) (f9 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f15 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f15 ?v2 ?v5) (f15 ?v2 ?v4)))) (< ?v3 (f15 ?v2 ?v1)))))))
(assert (forall ((?v0 S2)) (=> (not (= (f4 f35 ?v0) f1)) (=> (not (= ?v0 f7)) (= (f4 f35 (f9 f20 ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f6 f7) (f9 (f10 f36 ?v0) ?v1)) f1) (= (f4 (f5 f6 (f9 f20 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f6 (f9 (f10 f36 ?v0) ?v1)) f7) f1) (= (f4 (f5 f6 ?v1) (f9 f20 ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f4 (f5 f6 (f9 f19 ?v0)) ?v1) f1) (=> (= (f4 (f5 f6 (f9 f19 ?v2)) ?v3) f1) (= (f4 (f5 f6 (f9 f19 (f9 (f10 f36 ?v0) ?v2))) (f9 (f10 f36 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f36 f7) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f36 f7) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (= f7 (f9 (f10 f36 ?v0) ?v0)) (= ?v0 f7))))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f36 ?v0) f7) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f36 ?v0) f7) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f4 (f5 f6 (f9 (f10 f36 ?v0) ?v1)) (f9 (f10 f36 ?v2) ?v1)) f1) (= (f4 (f5 f6 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (= (f4 (f5 f6 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (= (f4 (f5 f6 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (= (f4 (f5 f6 (f9 (f10 f36 ?v0) ?v2)) (f9 (f10 f36 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v2))) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (= (f4 (f5 f6 (f9 ?v_0 ?v0)) (f9 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= (f4 (f5 f6 ?v2) ?v3) f1) (= (f4 (f5 f6 (f9 (f10 f36 ?v0) ?v2)) (f9 (f10 f36 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f4 (f5 f6 (f9 (f10 f36 ?v0) ?v1)) (f9 (f10 f36 ?v2) ?v1)) f1) (= (f4 (f5 f6 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (=> (= (f4 (f5 f6 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (= (f4 (f5 f6 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f9 (f10 f11 (f9 (f10 f36 ?v0) ?v1)) ?v2) (f9 (f10 f36 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f9 (f10 f11 (f9 (f10 f36 ?v0) ?v1)) ?v2) (f9 (f10 f36 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f9 (f10 f36 ?v0) ?v1) (f9 (f10 f36 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (=> (= (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (=> (= (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 f35 ?v0) f1) (=> (= (f4 f35 ?v1) f1) (= (f4 f35 (f9 (f10 f36 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f9 (f10 f36 ?v0) ?v1) (f9 (f10 f36 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (= (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f9 (f10 f36 (f9 (f10 f21 ?v0) ?v1)) ?v2) (f9 (f10 f21 (f9 (f10 f36 ?v0) ?v2)) (f9 (f10 f36 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f15 (f23 f24 ?v0) ?v1) ?v2) (f15 (f23 f24 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f9 (f10 f36 (f9 (f10 f22 ?v0) ?v1)) ?v2) (f9 (f10 f22 (f9 (f10 f36 ?v0) ?v2)) (f9 (f10 f36 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f15 (f23 f25 ?v0) ?v1) ?v2) (f15 (f23 f25 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f9 (f10 f36 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f36 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f9 (f10 f36 (f9 f14 ?v0)) (f9 f14 ?v1)))) (= (f9 f14 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f15 f16 ?v0) (f15 f16 ?v1)))) (= (f15 f16 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f10 f36 (f9 f20 ?v0)) (f9 (f10 f36 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0) (+ ?v0 ?v1)) ?v1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f10 f36 ?v0) (f9 (f10 f36 (f9 f20 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (+ (- ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 f20 (f9 (f10 f36 ?v0) ?v1)) (f9 (f10 f36 (f9 f20 ?v1)) (f9 f20 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 f20 (f9 (f10 f36 ?v0) ?v1)) (f9 (f10 f36 (f9 f20 ?v0)) (f9 f20 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v0) (- ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 f14 (f9 (f10 f36 ?v0) (f9 f20 ?v1))) (f9 f14 (f9 (f10 f36 ?v1) (f9 f20 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v1))) (=> (= (f4 (f5 f6 f7) ?v0) f1) (=> (= (f4 ?v_0 ?v2) f1) (= (f4 ?v_0 (f9 (f10 f36 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) f7) f1) (=> (= (f4 (f5 f6 ?v1) f7) f1) (= (f4 (f5 f6 (f9 (f10 f36 ?v0) ?v1)) f7) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 f7))) (=> (= (f4 ?v_0 ?v0) f1) (=> (= (f4 ?v_0 ?v1) f1) (= (f4 ?v_0 (f9 (f10 f36 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S2)) (= (= (f4 (f5 f6 (f9 (f10 f36 ?v0) ?v0)) f7) f1) (= (f4 (f5 f6 ?v0) f7) f1))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f5 f6 f7))) (= (= (f4 ?v_0 (f9 (f10 f36 ?v0) ?v0)) f1) (= (f4 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (+ ?v0 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) (f9 (f10 f36 ?v0) f8)) f1)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f36 ?v0) (f9 f20 ?v0)) f7)))
(assert (forall ((?v0 Int)) (= (+ ?v0 (- ?v0)) 0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 (f9 f20 ?v1)) (= (f9 (f10 f36 ?v0) ?v1) f7))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= (+ ?v0 ?v1) 0))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f36 (f9 f20 ?v0)) ?v0) f7)))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f36 (f9 f20 ?v0)) ?v0) f7)))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f9 (f10 f36 ?v0) ?v1) f7) (= ?v1 (f9 f20 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ ?v0 ?v1) 0) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f10 f36 ?v0) ?v1) f7) (= (f9 f20 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (+ ?v0 ?v1) 0) (= (- ?v0) ?v1))))
(assert (not (= (f4 f35 f7) f1)))
(assert (forall ((?v0 S2)) (not (= (f4 (f5 f6 (f9 (f10 f36 (f9 f14 ?v0)) f8)) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f9 (f10 f36 ?v0) ?v1) f7) (= ?v1 (f9 f20 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f9 (f10 f36 ?v0) (f9 f20 ?v1)) f7) (= ?v0 ?v1))))
(assert (< 0 (+ 1 1)))
(assert (= (f4 (f5 f6 f7) (f9 (f10 f36 f8) f8)) f1))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (= (f4 (f5 f6 (f9 (f10 f11 (f9 (f10 f36 ?v0) ?v1)) (f9 (f10 f36 f8) f8))) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 ?v_0 ?v1) f1) (= (f4 ?v_0 (f9 (f10 f11 (f9 (f10 f36 ?v0) ?v1)) (f9 (f10 f36 f8) f8))) f1)))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f7) (f9 (f10 f36 f8) (f9 f14 ?v0))) f1)))
(assert (forall ((?v0 S2)) (= (= (f4 (f5 f6 (f9 (f10 f36 ?v0) ?v0)) f7) f1) (= (f4 (f5 f6 ?v0) f7) f1))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f36 f7) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f36 ?v0) f7) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f9 (f10 f36 (f9 ?v_0 ?v1)) (f9 (f10 f36 ?v2) ?v3)) (f9 (f10 f36 (f9 ?v_0 ?v2)) (f9 (f10 f36 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f9 (f10 f36 (f9 ?v_0 ?v1)) ?v2) (f9 (f10 f36 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f9 (f10 f36 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f36 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f9 ?v_0 (f9 (f10 f36 ?v1) ?v2)) (f9 (f10 f36 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f10 f36 ?v0)) (?v_0 (f10 f36 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f10 f36 ?v0) ?v1) (f9 (f10 f36 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S2)) (= (= (f9 (f10 f36 ?v0) ?v0) f7) (= ?v0 f7))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 (f9 (f10 f36 ?v0) ?v1)) (= ?v1 f7))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 Int)) (=> (= (f26 (f27 f28 ?v0) f37) f1) (= (< (+ (+ 1 ?v0) ?v0) 0) (< ?v0 0)))))
(assert (forall ((?v0 S2)) (=> (= (f30 (f31 f32 ?v0) f38) f1) (= (= (f4 (f5 f6 (f9 (f10 f36 (f9 (f10 f36 f8) ?v0)) ?v0)) f7) f1) (= (f4 (f5 f6 ?v0) f7) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f26 (f27 f28 ?v0) f37) f1) (not (= (+ (+ 1 ?v0) ?v0) 0)))))
(assert (forall ((?v0 S2)) (=> (= (f30 (f31 f32 ?v0) f38) f1) (not (= (f9 (f10 f36 (f9 (f10 f36 f8) ?v0)) ?v0) f7)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f30 (f31 f32 ?v0) f38) f1) (=> (= (f30 (f31 f32 ?v1) f38) f1) (= (f30 (f31 f32 (f9 (f10 f36 ?v0) ?v1)) f38) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 (f27 f28 ?v0) f37) f1) (=> (= (f26 (f27 f28 ?v1) f37) f1) (= (f26 (f27 f28 (+ ?v0 ?v1)) f37) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f30 (f31 f32 ?v0) f38) f1) (= (f30 (f31 f32 (f9 f20 ?v0)) f38) f1))))
(assert (forall ((?v0 Int)) (=> (= (f26 (f27 f28 ?v0) f37) f1) (= (f26 (f27 f28 (- ?v0)) f37) f1))))
(assert (= (f26 (f27 f28 0) f37) f1))
(assert (= (f30 (f31 f32 f7) f38) f1))
(assert (= (f26 (f27 f28 1) f37) f1))
(assert (= (f30 (f31 f32 f8) f38) f1))
(assert (forall ((?v0 S2)) (=> (= (f30 (f31 f32 ?v0) f38) f1) (= (= (f9 (f10 f36 ?v0) ?v0) f7) (= ?v0 f7)))))
(assert (forall ((?v0 Int)) (=> (= (f26 (f27 f28 ?v0) f37) f1) (= (= (+ ?v0 ?v0) 0) (= ?v0 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f39 (f9 (f10 f36 ?v0) ?v1)) f7) f1) (= (f4 (f5 f39 ?v1) (f9 f20 ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f39 f7) (f9 (f10 f36 ?v0) ?v1)) f1) (= (f4 (f5 f39 (f9 f20 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f39 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f39 (f9 f14 ?v0)) ?v1) f1) (and (= (f4 (f5 f39 (f9 f20 ?v1)) ?v0) f1) (= (f4 (f5 f39 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f39 (f9 f20 ?v0)) (f9 f14 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= (- ?v0) (f15 f16 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f39 ?v0) (f9 f20 ?v1)) f1) (= (f4 (f5 f39 ?v1) (f9 f20 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 (- ?v1)) (<= ?v1 (- ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f39 (f9 f20 ?v0)) ?v1) f1) (= (f4 (f5 f39 (f9 f20 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) ?v1) (<= (- ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f39 (f9 f14 ?v0)) ?v1) f1) (and (= (f4 (f5 f39 ?v0) ?v1) f1) (= (f4 (f5 f39 (f9 f20 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f15 f16 ?v0) ?v1) (and (<= ?v0 ?v1) (<= (- ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f39 (f9 f20 ?v0)) (f9 f20 ?v1)) f1) (= (f4 (f5 f39 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) (- ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f39 ?v0) ?v1) f1) (= (f4 (f5 f39 (f9 f20 ?v1)) (f9 f20 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (<= (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f39 ?v0) ?v1) f1) (=> (= (f4 (f5 f39 (f9 f20 ?v0)) ?v1) f1) (= (f4 (f5 f39 (f9 f14 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= (- ?v0) ?v1) (<= (f15 f16 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f39 (f9 f14 ?v0)) ?v1) f1) (= (f4 (f5 f39 (f9 f20 ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f15 f16 ?v0) ?v1) (<= (- ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f4 (f5 f39 ?v0) ?v1) f1) (= (f4 (f5 f39 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 ?v1) (and (= (f4 (f5 f39 ?v0) ?v1) f1) (= (f4 (f5 f39 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f39 ?v0))) (= (= (f4 ?v_0 (f9 (f10 f22 ?v1) ?v2)) f1) (or (= (f4 ?v_0 ?v1) f1) (= (f4 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f15 (f23 f25 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f4 (f5 f39 (f9 (f10 f21 ?v0) ?v1)) ?v2) f1) (or (= (f4 (f5 f39 ?v0) ?v2) f1) (= (f4 (f5 f39 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f15 (f23 f24 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 ?v1) (= (f4 (f5 f39 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f39 ?v0) ?v1) f1) (= (= (f4 (f5 f39 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f4 (f5 f39 ?v1) ?v2) f1) (= (f4 (f5 f39 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f39 ?v2))) (=> (= ?v0 ?v1) (=> (= (f4 ?v_0 ?v1) f1) (= (f4 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f39 ?v0))) (=> (= (f4 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f4 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f4 (f5 f39 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f4 (f5 f39 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f39 ?v0) ?v1) f1) (=> (= (f4 (f5 f39 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(check-sat)
(exit)
