(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S3 S2) S2)
(declare-fun f6 (S4 S2) S3)
(declare-fun f7 () S4)
(declare-fun f8 () S4)
(declare-fun f9 () S3)
(declare-fun f10 () S4)
(declare-fun f11 () S2)
(declare-fun f12 () S2)
(declare-fun f13 (S5 Int) S2)
(declare-fun f14 () S5)
(declare-fun f15 (S6 Int) Int)
(declare-fun f16 () S6)
(declare-fun f17 () S6)
(declare-fun f18 () Int)
(declare-fun f19 () S4)
(declare-fun f20 (S7 S8) S2)
(declare-fun f21 () S7)
(declare-fun f22 (S2 S2) S8)
(declare-fun f23 () S2)
(declare-fun f24 () S3)
(declare-fun f25 () S8)
(declare-fun f26 () S2)
(declare-fun f27 () S6)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 (f6 f7 (f5 (f6 f8 (f5 f9 (f5 (f6 f8 (f5 (f6 f10 f11) f11)) (f5 (f6 f10 f12) f12)))) f11)) (f13 f14 (f15 f16 (f15 f17 f18))))) f1)))
(assert (= (f3 f4 (f5 (f6 f19 (f20 f21 (f22 f11 f12))) f11)) f1))
(assert (= (f3 f4 (f5 (f6 f8 (f20 f21 (f22 f11 f12))) f11)) f1))
(assert (not (= f23 f4)))
(assert (= (f3 f4 (f5 (f6 f8 (f20 f21 (f22 f11 f12))) f11)) f1))
(assert (= (f3 f4 (f5 (f6 f19 (f20 f21 (f22 f11 f12))) f11)) f1))
(assert (= (f3 (f5 f24 f11) (f20 f21 (f22 f11 f12))) f1))
(assert (= (f3 f4 (f5 f9 (f13 f14 (f15 f16 (f15 f17 f18))))) f1))
(assert (forall ((?v0 S2)) (let ((?v_0 (f5 (f6 f7 ?v0) (f13 f14 (f15 f16 (f15 f17 f18)))))) (= (f5 (f6 f8 ?v_0) ?v_0) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f6 f7 ?v1)) (?v_0 (f6 f10 (f13 f14 (f15 f16 (f15 f17 f18)))))) (= (= ?v0 (f5 ?v_1 (f5 ?v_0 ?v2))) (= (f5 ?v_0 ?v0) (f5 ?v_1 ?v2))))))
(assert (forall ((?v0 S2)) (= (f5 (f6 f10 ?v0) (f13 f14 (f15 f16 (f15 f17 f18)))) (f5 (f6 f8 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f5 (f6 f10 ?v0) (f13 f14 (f15 f16 (f15 f17 f18)))) (f5 (f6 f8 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f5 (f6 f10 (f13 f14 (f15 f16 (f15 f17 f18)))) ?v0) (f5 (f6 f8 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f5 (f6 f10 (f13 f14 (f15 f16 (f15 f17 f18)))) ?v0) (f5 (f6 f8 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 f4 (f5 f9 (f5 (f6 f8 (f5 (f6 f10 ?v0) ?v0)) (f5 (f6 f10 ?v1) ?v1)))) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 ?v0 (f5 f9 (f5 (f6 f8 (f5 (f6 f10 ?v0) ?v0)) (f5 (f6 f10 ?v1) ?v1)))) f1)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f13 f14 (f15 f17 f18))) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f13 f14 (f15 f17 f18))) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f10 ?v0) (f13 f14 (f15 f17 f18))) ?v0)))
(assert (= f25 (f22 f26 f23)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f5 (f6 f19 (f5 (f6 f8 ?v0) ?v1)) (f5 (f6 f8 ?v2) ?v3)) (f5 (f6 f8 (f5 (f6 f19 ?v0) ?v2)) (f5 (f6 f19 ?v1) ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (- ?v0 ?v2) (- ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f19 (f13 f14 ?v0)) (f13 f14 ?v1)) (f13 f14 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f15 f27 ?v0) (f15 f27 ?v1)) (f15 f27 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 f14 (- ?v0 ?v1)) (f5 (f6 f19 (f13 f14 ?v0)) (f13 f14 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 f27 (- ?v0 ?v1)) (- (f15 f27 ?v0) (f15 f27 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 f14 ?v0) (f13 f14 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 f27 ?v0) (f15 f27 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f27 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f15 f17 ?v0) (f15 f17 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f15 f17 ?v0) (f15 f17 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f15 f17 ?v0) (f15 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f15 f17 ?v0) (f15 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 f17 ?v0) (f15 f17 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f15 f17 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f15 f17 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f18) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f18) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f18 ?v0) ?v0)))
(check-sat)
(exit)
