(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S5 S3 S4 S3) S1)
(declare-fun f4 (S6 S2) S5)
(declare-fun f5 () S6)
(declare-fun f6 (S7 Int) S4)
(declare-fun f7 () S7)
(declare-fun f8 (S8 S4) Int)
(declare-fun f9 () S8)
(declare-fun f10 (S9 S10) S5)
(declare-fun f11 () S9)
(declare-fun f12 (S2) S10)
(declare-fun f13 (S4 S12) S1)
(declare-fun f14 (S11 S5 S11) S12)
(declare-fun f15 (S13 S5) S4)
(declare-fun f16 () S13)
(declare-fun f17 () S5)
(declare-fun f18 (S15 S3) S1)
(declare-fun f19 (S11 S14) S15)
(declare-fun f20 () S4)
(declare-fun f21 () S11)
(declare-fun f22 () S2)
(declare-fun f23 () S11)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S4) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1 ?v2 ?v3) f1) (=> (forall ((?v4 S4)) (=> (= ?v2 (f6 f7 (+ (f8 f9 ?v4) 1))) (=> (= (f3 (f10 f11 (f12 ?v0)) ?v1 ?v4 ?v3) f1) false))) false))))
(assert (forall ((?v0 S5) (?v1 S3) (?v2 S4) (?v3 S3) (?v4 S4)) (=> (= (f3 ?v0 ?v1 ?v2 ?v3) f1) (=> (<= (f8 f9 ?v2) (f8 f9 ?v4)) (= (f3 ?v0 ?v1 ?v4 ?v3) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S4) (?v3 S3)) (=> (= (f3 (f10 f11 (f12 ?v0)) ?v1 ?v2 ?v3) f1) (= (f3 (f4 f5 ?v0) ?v1 (f6 f7 (+ (f8 f9 ?v2) 1)) ?v3) f1))))
(assert (forall ((?v0 S11) (?v1 S2) (?v2 S11)) (= (f13 (f6 f7 0) (f14 ?v0 (f4 f5 ?v1) ?v2)) f1)))
(assert (= (f15 f16 f17) (f6 f7 0)))
(assert (forall ((?v0 S4) (?v1 S11) (?v2 S5) (?v3 S11)) (= (= (f13 ?v0 (f14 ?v1 ?v2 ?v3)) f1) (forall ((?v4 S14) (?v5 S3)) (=> (= (f18 (f19 ?v1 ?v4) ?v5) f1) (forall ((?v6 S3)) (=> (= (f3 ?v2 ?v5 ?v0 ?v6) f1) (= (f18 (f19 ?v3 ?v4) ?v6) f1))))))))
(assert (not (= (= (f13 f20 (f14 f21 (f10 f11 (f12 f22)) f23)) f1) (= (f13 (f6 f7 (+ (f8 f9 f20) 1)) (f14 f21 (f4 f5 f22) f23)) f1))))
(assert (forall ((?v0 S4)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
