(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S5 S4) S1)
(declare-fun f6 () S5)
(declare-fun f7 (S5 S5) S1)
(declare-fun f8 (S5 S5) S1)
(declare-fun f9 (S3 S3) S1)
(declare-fun f10 (S6 S3) S3)
(declare-fun f11 (S2) S6)
(declare-fun f12 (S2 S3) S1)
(declare-fun f13 (S7 S5) S5)
(declare-fun f14 (S4) S7)
(declare-fun f15 (S4 S5) S1)
(declare-fun f16 (S8 S4) S2)
(declare-fun f17 (S9 S5) S3)
(declare-fun f18 (S8) S9)
(declare-fun f19 (S10 S2) S2)
(declare-fun f20 (S10) S6)
(declare-fun f21 (S11 S4) S4)
(declare-fun f22 (S11) S7)
(declare-fun f23 (S12 S2) S4)
(declare-fun f24 (S13 S3) S5)
(declare-fun f25 (S12) S13)
(declare-fun f26 (S14) S1)
(declare-fun f27 () S3)
(declare-fun f28 () S12)
(declare-fun f29 () S5)
(declare-fun f30 (S15 S14) S4)
(declare-fun f31 () S15)
(declare-fun f32 () S3)
(declare-fun f33 (S3) S3)
(declare-fun f34 (S5) S5)
(declare-fun f35 (S3) S1)
(declare-fun f36 (S16 S17) Int)
(declare-fun f37 () S16)
(declare-fun f38 (S18 S3) S17)
(declare-fun f39 () S18)
(declare-fun f40 (S5) S1)
(declare-fun f41 (S19 S5) S17)
(declare-fun f42 () S19)
(declare-fun f43 (S21) S1)
(declare-fun f44 (S20 S3) S21)
(declare-fun f45 () S5)
(declare-fun f46 (S22 Int) S17)
(declare-fun f47 () S22)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) false)))
(assert (forall ((?v0 S4)) (= (= (f5 f6 ?v0) f1) false)))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f7 ?v0 ?v1) f1) (= (f8 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (= (= (f9 (f10 (f11 ?v0) ?v1) ?v2) f1) (and (= (f12 ?v0 ?v2) f1) (= (f9 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S5) (?v2 S5)) (= (= (f7 (f13 (f14 ?v0) ?v1) ?v2) f1) (and (= (f15 ?v0 ?v2) f1) (= (f7 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f12 ?v0 (f10 (f11 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S4) (?v1 S5)) (= (f15 ?v0 (f13 (f14 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S4) (?v1 S5) (?v2 S8)) (let ((?v_0 (f17 (f18 ?v2) ?v1))) (=> (= (f15 ?v0 ?v1) f1) (= (f10 (f11 (f16 ?v2 ?v0)) ?v_0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S10)) (let ((?v_0 (f10 (f20 ?v2) ?v1))) (=> (= (f12 ?v0 ?v1) f1) (= (f10 (f11 (f19 ?v2 ?v0)) ?v_0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S5) (?v2 S11)) (let ((?v_0 (f13 (f22 ?v2) ?v1))) (=> (= (f15 ?v0 ?v1) f1) (= (f13 (f14 (f21 ?v2 ?v0)) ?v_0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S12)) (let ((?v_0 (f24 (f25 ?v2) ?v1))) (=> (= (f12 ?v0 ?v1) f1) (= (f13 (f14 (f23 ?v2 ?v0)) ?v_0) ?v_0)))))
(assert (forall ((?v0 S14) (?v1 S5)) (=> (= (f26 ?v0) f1) (=> (forall ((?v2 S2)) (=> (= (f12 ?v2 f27) f1) (= (f8 ?v1 (f13 (f14 (f23 f28 ?v2)) f29)) f1))) (= (f8 ?v1 (f13 (f14 (f30 f31 ?v0)) f29)) f1)))))
(assert (forall ((?v0 S3)) (= (f9 f32 ?v0) f1)))
(assert (forall ((?v0 S5)) (= (f7 f29 ?v0) f1)))
(assert (= f32 (f33 f4)))
(assert (= f29 (f34 f6)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f35 ?v0) f1) (=> (= (f9 ?v1 ?v0) f1) (=> (<= (f36 f37 (f38 f39 ?v0)) (f36 f37 (f38 f39 ?v1))) (= ?v1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f40 ?v0) f1) (=> (= (f7 ?v1 ?v0) f1) (=> (<= (f36 f37 (f41 f42 ?v0)) (f36 f37 (f41 f42 ?v1))) (= ?v1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S11)) (=> (= (f40 ?v0) f1) (= (f40 (f13 (f22 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S3) (?v1 S10)) (=> (= (f35 ?v0) f1) (= (f35 (f10 (f20 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S3) (?v1 S20)) (=> (= (f35 ?v0) f1) (= (f43 (f44 ?v1 ?v0)) f1))))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (= (f40 ?v0) f1) (= (f35 (f17 (f18 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S3) (?v1 S12)) (=> (= (f35 ?v0) f1) (= (f40 (f24 (f25 ?v1) ?v0)) f1))))
(assert (not (=> (= (f35 f27) f1) (=> (= f45 (f24 (f25 f28) f27)) (forall ((?v0 S5)) (let ((?v_0 (f36 f37 (f41 f42 f45)))) (=> (= (f7 ?v0 f45) f1) (=> (<= 0 ?v_0) (=> (= (f41 f42 ?v0) (f46 f47 (- ?v_0 0))) (forall ((?v1 S14)) (=> (= (f26 ?v1) f1) (= (f8 ?v0 (f13 (f14 (f30 f31 ?v1)) f29)) f1))))))))))))
(assert (forall ((?v0 S17)) (= (f46 f47 (f36 f37 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f36 f37 (f46 f47 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f36 f37 (f46 f47 ?v0)) 0))))
(check-sat)
(exit)
