(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2 S3) S1)
(declare-fun f6 (S4) S3)
(declare-fun f7 () S4)
(declare-fun f8 (S5 S6) S3)
(declare-fun f9 (S7 S6) S5)
(declare-fun f10 (S8) S7)
(declare-fun f11 () S8)
(declare-fun f12 () S6)
(declare-fun f13 () S3)
(declare-fun f14 () S8)
(declare-fun f15 () S3)
(declare-fun f16 () S8)
(declare-fun f17 () S6)
(declare-fun f18 (S8 Int) S9)
(declare-fun f19 (S1 S8) S9)
(declare-fun f20 () S8)
(declare-fun f21 () S8)
(declare-fun f22 (S9 S10) S1)
(declare-fun f23 (S6 Int) S8)
(declare-fun f24 (S3) S3)
(declare-fun f25 (S11 S3) S3)
(declare-fun f26 (S3) S11)
(declare-fun f27 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 f11) f12) f12) ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f13 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 f14) f12) f12) ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f15 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 f16) f17) f17) ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (f18 f11 ?v0) (f19 f2 f20))))
(assert (forall ((?v0 Int)) (= (f18 f14 ?v0) (f19 f2 f21))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f22 (f18 f20 ?v0) ?v1) f1) (< ?v0 0))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f22 (f18 f21 ?v0) ?v1) f1) (< 0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (= (f22 (f18 (f23 f12 ?v0) ?v1) ?v2) f1) false)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (= (f22 (f18 (f23 f17 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f22 (f18 f16 ?v0) ?v1) f1) false)))
(assert (forall ((?v0 S3)) (= (f24 ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S3)) (= (= (f5 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (= (= (f5 ?v0 (f25 (f26 ?v1) ?v2)) f1) (or (= (f5 ?v0 ?v1) f1) (= (f5 ?v0 ?v2) f1)))))
(assert (not (=> (= (f5 f27 (f25 (f26 (f25 (f26 (f24 f15)) (f24 f13))) (f24 f4))) f1) (= (f5 f27 (f6 f7)) f1))))
(check-sat)
(exit)
