(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2 S3) S1)
(declare-fun f6 (S4) S3)
(declare-fun f7 () S4)
(declare-fun f8 (S5 S6) S3)
(declare-fun f9 (S7 S6) S5)
(declare-fun f10 (S8) S7)
(declare-fun f11 () S8)
(declare-fun f12 () S6)
(declare-fun f13 () S3)
(declare-fun f14 () S8)
(declare-fun f15 () S3)
(declare-fun f16 () S8)
(declare-fun f17 () S6)
(declare-fun f18 (S8 Int) S9)
(declare-fun f19 (S1 S8) S9)
(declare-fun f20 () S8)
(declare-fun f21 () S8)
(declare-fun f22 (S3) S3)
(declare-fun f23 (S10 Int) S1)
(declare-fun f24 (S10) S10)
(declare-fun f25 (Int S10) S1)
(declare-fun f26 (S2) S3)
(declare-fun f27 (Int) S10)
(declare-fun f28 (S2) S3)
(declare-fun f29 (Int) S10)
(declare-fun f30 (S9 S11) S1)
(declare-fun f31 (S12 S3) S3)
(declare-fun f32 (S3) S12)
(declare-fun f33 (S13 S10) S10)
(declare-fun f34 (S10) S13)
(declare-fun f35 (S2) S12)
(declare-fun f36 (Int) S13)
(declare-fun f37 (S2) S12)
(declare-fun f38 (Int) S13)
(declare-fun f39 (S2) S12)
(declare-fun f40 (Int) S13)
(declare-fun f41 (S3) S12)
(declare-fun f42 (S10) S13)
(declare-fun f43 (S2) S8)
(declare-fun f44 (S14 S2) Int)
(declare-fun f45 () S14)
(declare-fun f46 (Int) S13)
(declare-fun f47 () S10)
(declare-fun f48 (S6 Int) S8)
(declare-fun f49 (S2) S6)
(declare-fun f50 () S3)
(declare-fun f51 () S10)
(declare-fun f52 (S3) S12)
(declare-fun f53 (S3) S3)
(declare-fun f54 () S14)
(declare-fun f55 (S10) S13)
(declare-fun f56 (S1 S1) S1)
(declare-fun f57 (S10) S10)
(declare-fun f58 () S3)
(declare-fun f59 (S2) S12)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 f11) f12) f12) ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f13 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 f14) f12) f12) ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f15 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 f16) f17) f17) ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (f18 f11 ?v0) (f19 f2 f20))))
(assert (forall ((?v0 Int)) (= (f18 f14 ?v0) (f19 f2 f21))))
(assert (forall ((?v0 S3) (?v1 S2)) (= (= (f3 (f22 ?v0) ?v1) f1) (= (f5 ?v1 ?v0) f1))))
(assert (forall ((?v0 S10) (?v1 Int)) (= (= (f23 (f24 ?v0) ?v1) f1) (= (f25 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f26 ?v0) ?v1) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 (f27 ?v0) ?v1) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f28 ?v0) ?v1) f1) (= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 (f29 ?v0) ?v1) f1) (= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 S11)) (= (= (f30 (f18 f20 ?v0) ?v1) f1) (< ?v0 0))))
(assert (forall ((?v0 Int) (?v1 S11)) (= (= (f30 (f18 f21 ?v0) ?v1) f1) (< 0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f31 (f32 ?v0) ?v1) ?v2) f1) (or (= (f5 ?v2 ?v0) f1) (= (f5 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (= (= (f23 (f33 (f34 ?v0) ?v1) ?v2) f1) (or (= (f25 ?v2 ?v0) f1) (= (f25 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f31 (f35 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f5 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f23 (f33 (f36 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f25 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f31 (f37 ?v0) ?v1) ?v2) f1) (and (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f23 (f33 (f38 ?v0) ?v1) ?v2) f1) (and (= ?v0 ?v2) (= (f23 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f31 (f39 ?v0) ?v1) ?v2) f1) (and (= ?v2 ?v0) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f23 (f33 (f40 ?v0) ?v1) ?v2) f1) (and (= ?v2 ?v0) (= (f23 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f31 (f41 ?v0) ?v1) ?v2) f1) (or (= (f3 ?v0 ?v2) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (= (= (f23 (f33 (f42 ?v0) ?v1) ?v2) f1) (or (= (f23 ?v0 ?v2) f1) (= (f23 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 S11)) (= (= (f30 (f18 (f43 ?v0) ?v1) ?v2) f1) (= (f25 (f44 f45 ?v0) (f33 (f46 1) (f33 (f46 (- 1)) f47))) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int) (?v3 S11)) (= (= (f30 (f18 (f48 (f49 ?v0) ?v1) ?v2) ?v3) f1) (= (f44 f45 ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11)) (= (= (f30 (f18 (f48 f12 ?v0) ?v1) ?v2) f1) false)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11)) (= (= (f30 (f18 (f48 f17 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S11)) (= (= (f30 (f18 f16 ?v0) ?v1) f1) false)))
(assert (forall ((?v0 S2)) (= (= (f3 f50 ?v0) f1) false)))
(assert (forall ((?v0 Int)) (= (= (f23 f51 ?v0) f1) false)))
(assert (not (= (f6 f7) (f31 (f52 (f31 (f52 (f53 f15)) (f53 f13))) (f53 f4)))))
(assert (forall ((?v0 S2)) (=> (= (f5 ?v0 (f6 f7)) f1) (= (f5 ?v0 (f31 (f52 (f31 (f52 (f53 f15)) (f53 f13))) (f53 f4))) f1))))
(assert (forall ((?v0 S2)) (=> (= (f5 ?v0 (f31 (f52 (f31 (f52 (f53 f15)) (f53 f13))) (f53 f4))) f1) (= (f5 ?v0 (f6 f7)) f1))))
(assert (forall ((?v0 S2)) (=> (= (f5 ?v0 (f6 f7)) f1) (not (= (f44 f54 ?v0) 0)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (=> (= (f5 ?v0 (f31 (f52 ?v1) ?v2)) f1) (=> (=> (= (f5 ?v0 ?v1) f1) false) (=> (=> (= (f5 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (=> (= (f25 ?v0 (f33 (f55 ?v1) ?v2)) f1) (=> (=> (= (f25 ?v0 ?v1) f1) false) (=> (=> (= (f25 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (=> (= (f23 (f33 (f55 ?v0) ?v1) ?v2) f1) (=> (=> (= (f23 ?v0 ?v2) f1) false) (=> (=> (= (f23 ?v1 ?v2) f1) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (=> (= (f3 (f31 (f52 ?v0) ?v1) ?v2) f1) (=> (=> (= (f3 ?v0 ?v2) f1) false) (=> (=> (= (f3 ?v1 ?v2) f1) false) false)))))
(assert (forall ((?v0 S10) (?v1 Int) (?v2 S10)) (=> (=> (not (= (f23 ?v0 ?v1) f1)) (= (f23 ?v2 ?v1) f1)) (= (f23 (f33 (f55 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (=> (=> (not (= (f3 ?v0 ?v1) f1)) (= (f3 ?v2 ?v1) f1)) (= (f3 (f31 (f52 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (=> (=> (not (= (f5 ?v0 ?v1) f1)) (= (f5 ?v0 ?v2) f1)) (= (f5 ?v0 (f31 (f52 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (=> (=> (not (= (f25 ?v0 ?v1) f1)) (= (f25 ?v0 ?v2) f1)) (= (f25 ?v0 (f33 (f55 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (= (= (f23 (f33 (f55 ?v0) ?v1) ?v2) f1) (= (f56 (f23 ?v0 ?v2) (f23 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f31 (f52 ?v0) ?v1) ?v2) f1) (= (f56 (f3 ?v0 ?v2) (f3 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (= (= (f23 (f33 (f55 ?v0) ?v1) ?v2) f1) (= (f56 (f23 ?v0 ?v2) (f23 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f31 (f52 ?v0) ?v1) ?v2) f1) (= (f56 (f3 ?v0 ?v2) (f3 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f57 (f33 (f42 ?v0) ?v1)) (f33 (f55 (f57 ?v0)) (f57 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f53 (f31 (f41 ?v0) ?v1)) (f31 (f52 (f53 ?v0)) (f53 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f31 (f52 (f22 ?v0)) (f22 ?v1)) ?v2) f1) (= (f5 ?v2 (f31 (f52 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (= (= (f23 (f33 (f55 (f24 ?v0)) (f24 ?v1)) ?v2) f1) (= (f25 ?v2 (f33 (f55 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f49 ?v0))) (=> (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 (f43 ?v0)) ?v_0) ?v_0) ?v0) f1)))))
(assert (forall ((?v0 S10)) (= (f33 (f55 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f31 (f52 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f31 (f52 ?v0) ?v1) (f53 (f31 (f32 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f33 (f55 ?v0) ?v1) (f57 (f33 (f34 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f33 (f55 ?v0) ?v1) (f33 (f55 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f31 (f52 ?v0) ?v1) (f31 (f52 ?v1) ?v0))))
(assert (forall ((?v0 S2)) (=> (= (f5 ?v0 f58) f1) false)))
(assert (forall ((?v0 Int)) (=> (= (f25 ?v0 f47) f1) false)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (=> (= (f5 ?v0 (f31 (f59 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f5 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (=> (= (f25 ?v0 (f33 (f46 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f25 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (=> (not (= (f5 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f5 ?v0 (f31 (f59 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (=> (not (= (f25 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f25 ?v0 (f33 (f46 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= f58 (f31 (f59 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (not (= f47 (f33 (f46 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= (f31 (f59 ?v0) ?v1) f58))))
(assert (forall ((?v0 Int) (?v1 S10)) (not (= (f33 (f46 ?v0) ?v1) f47))))
(assert (forall ((?v0 S2)) (= (= (f3 f58 ?v0) f1) (= (f5 ?v0 f58) f1))))
(assert (forall ((?v0 Int)) (= (= (f23 f47 ?v0) f1) (= (f25 ?v0 f47) f1))))
(assert (= f47 (f57 f51)))
(assert (= f58 (f53 f50)))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f5 ?v0 (f31 (f59 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f25 ?v0 (f33 (f46 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (not (= (f5 ?v1 ?v0) f1))) (= ?v0 f58))))
(assert (forall ((?v0 S10)) (= (forall ((?v1 Int)) (not (= (f25 ?v1 ?v0) f1))) (= ?v0 f47))))
(assert (forall ((?v0 S2)) (= (f53 (f26 ?v0)) (f31 (f59 ?v0) f58))))
(assert (forall ((?v0 Int)) (= (f57 (f27 ?v0)) (f33 (f46 ?v0) f47))))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (= (f5 ?v1 ?v0) f1)) (not (= ?v0 f58)))))
(assert (forall ((?v0 S10)) (= (exists ((?v1 Int)) (= (f25 ?v1 ?v0) f1)) (not (= ?v0 f47)))))
(assert (forall ((?v0 S2)) (= (f53 (f28 ?v0)) (f31 (f59 ?v0) f58))))
(assert (forall ((?v0 Int)) (= (f57 (f29 ?v0)) (f33 (f46 ?v0) f47))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f53 (f31 (f37 ?v0) ?v1)) (ite (= (f3 ?v1 ?v0) f1) (f31 (f59 ?v0) f58) f58))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f57 (f33 (f38 ?v0) ?v1)) (ite (= (f23 ?v1 ?v0) f1) (f33 (f46 ?v0) f47) f47))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f53 (f31 (f39 ?v0) ?v1)) (ite (= (f3 ?v1 ?v0) f1) (f31 (f59 ?v0) f58) f58))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f57 (f33 (f40 ?v0) ?v1)) (ite (= (f23 ?v1 ?v0) f1) (f33 (f46 ?v0) f47) f47))))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (and (= (f5 ?v1 f58) f1) (= (f3 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S10)) (= (exists ((?v1 Int)) (and (= (f25 ?v1 f47) f1) (= (f23 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (=> (= (f5 ?v1 f58) f1) (= (f3 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S10)) (= (forall ((?v1 Int)) (=> (= (f25 ?v1 f47) f1) (= (f23 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S10)) (= (= f47 (f57 ?v0)) (forall ((?v1 Int)) (not (= (f23 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (= f58 (f53 ?v0)) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2)) (= (= (f5 ?v0 f58) f1) false)))
(assert (forall ((?v0 Int)) (= (= (f25 ?v0 f47) f1) false)))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f31 (f59 ?v0) ?v1) (f53 (f31 (f35 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f33 (f46 ?v0) ?v1) (f57 (f33 (f36 ?v0) ?v1)))))
(check-sat)
(exit)
