(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2 S3) S1)
(declare-fun f6 (S4) S3)
(declare-fun f7 () S4)
(declare-fun f8 (S5 S6 S6) S3)
(declare-fun f9 () S5)
(declare-fun f10 () S6)
(declare-fun f11 (S5 Int) S7)
(declare-fun f12 (S1 S5) S7)
(declare-fun f13 () S5)
(declare-fun f14 (S8 Int) S1)
(declare-fun f15 () S8)
(declare-fun f16 (S10 S9) Int)
(declare-fun f17 (S11 S9) S10)
(declare-fun f18 () S11)
(declare-fun f19 (S12 S9) S9)
(declare-fun f20 () S12)
(declare-fun f21 () S9)
(declare-fun f22 (S13 S9) S2)
(declare-fun f23 (S14 Int) S13)
(declare-fun f24 () S14)
(declare-fun f25 (S3) S3)
(declare-fun f26 (S7 S9) S1)
(declare-fun f27 (S6 Int) S5)
(declare-fun f28 () S6)
(declare-fun f29 () S5)
(declare-fun f30 (S15 Int) Int)
(declare-fun f31 (S16 Int) S15)
(declare-fun f32 () S16)
(declare-fun f33 () Int)
(declare-fun f34 () S16)
(declare-fun f35 () S16)
(declare-fun f36 (S17 S8) Int)
(declare-fun f37 () S17)
(declare-fun f38 (S8) S8)
(declare-fun f39 () S10)
(declare-fun f40 (S18 S4) S9)
(declare-fun f41 (S19 S20) S18)
(declare-fun f42 () S19)
(declare-fun f43 () S20)
(declare-fun f44 (S3 S4) S4)
(declare-fun f45 (S20 S2) Int)
(declare-fun f46 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 f9 f10 f10) ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (f11 f9 ?v0) (f12 f2 f13))))
(assert (forall ((?v0 Int)) (= (= (f14 f15 ?v0) f1) (exists ((?v1 S9) (?v2 Int)) (and (= ?v0 (- (f16 (f17 f18 (f19 f20 ?v1)) f21) ?v2)) (= (f5 (f22 (f23 f24 ?v2) ?v1) (f25 f4)) f1))))))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f26 (f11 f13 ?v0) ?v1) f1) (< ?v0 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9)) (= (= (f26 (f11 (f27 f10 ?v0) ?v1) ?v2) f1) false)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9)) (= (= (f26 (f11 (f27 f28 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f26 (f11 f29 ?v0) ?v1) f1) false)))
(assert (let ((?v_0 (f16 f39 (f40 (f41 f42 f43) (f44 (f8 f29 f28 f28) f7)))) (?v_1 (f45 f43 f46))) (not (= (f30 (f31 f32 (- f33 (f30 (f31 f34 (+ (f30 (f31 f35 (- f33 (f36 f37 (f38 f15)))) ?v_0) 1)) ?v_0))) ?v_1) (f30 (f31 f32 f33) ?v_1)))))
(assert (let ((?v_0 (f16 f39 (f40 (f41 f42 f43) (f44 (f8 f29 f28 f28) f7)))) (?v_1 (f45 f43 f46))) (= (f30 (f31 f32 (- f33 (f30 (f31 f34 (+ (f30 (f31 f35 (- f33 (f36 f37 (f38 f15)))) ?v_0) 1)) ?v_0))) ?v_1) (f30 (f31 f32 (- (f30 (f31 f32 f33) ?v_1) 0)) ?v_1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f30 (f31 f32 ?v0) ?v1))) (= (f30 (f31 f32 ?v_0) ?v1) ?v_0))))
(check-sat)
(exit)
