(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () S3)
(declare-fun f7 (S4 S5) S3)
(declare-fun f8 (S6 Int) S4)
(declare-fun f9 () S6)
(declare-fun f10 () Int)
(declare-fun f11 () S5)
(declare-fun f12 () S2)
(declare-fun f13 (S3 S7) S1)
(declare-fun f14 (S8) S7)
(declare-fun f15 (S9 S8) S8)
(declare-fun f16 () S9)
(declare-fun f17 () S8)
(declare-fun f18 (S10 S3) S3)
(declare-fun f19 (S11 S5) S10)
(declare-fun f20 (S12 Int) S11)
(declare-fun f21 () S12)
(declare-fun f22 (S13 Int) S10)
(declare-fun f23 () S13)
(declare-fun f24 (S14 S5) Int)
(declare-fun f25 () S14)
(declare-fun f26 (S15 S8) S5)
(declare-fun f27 (S16 S2) S15)
(declare-fun f28 () S16)
(declare-fun f29 (S17 Int) S6)
(declare-fun f30 () S17)
(declare-fun f31 () S17)
(declare-fun f32 () S10)
(declare-fun f33 (S18 S5) S5)
(declare-fun f34 (S19 Int) S18)
(declare-fun f35 () S19)
(declare-fun f36 () S5)
(declare-fun f37 (S20 S3) S21)
(declare-fun f38 () S20)
(declare-fun f39 (S22 Int) S21)
(declare-fun f40 () S22)
(declare-fun f41 (S23 S21) Int)
(declare-fun f42 () S23)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 f4 f5) 0))))
(assert (= f6 (f7 (f8 f9 f10) f11)))
(assert (not (= (f3 f12 f6) 0)))
(assert (not (= (f3 f4 f6) 0)))
(assert (not (= (f3 f4 f6) 0)))
(assert (= (f13 f5 (f14 (f15 f16 f17))) f1))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f3 f4 (f7 (f8 f9 ?v0) ?v1)) 1)))
(assert (forall ((?v0 S3)) (=> (= (f13 ?v0 (f14 f17)) f1) (not (= (f3 f4 ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S3)) (= (f3 f4 (f18 (f19 (f20 f21 ?v0) ?v1) ?v2)) (f3 f4 ?v2))))
(assert (= f5 (f18 (f22 f23 (f24 f25 (f26 (f27 f28 f12) f17))) f6)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f3 f4 (f7 (f8 (f29 f30 ?v0) ?v1) ?v2)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f3 f4 (f7 (f8 (f29 f31 ?v0) ?v1) ?v2)) ?v0)))
(assert (forall ((?v0 S3)) (=> (not (not (= (f3 f12 ?v0) 0))) (=> (not (= (f3 f4 ?v0) 0)) (not (= (f3 f4 (f18 f32 ?v0)) 0))))))
(assert (exists ((?v0 S3)) (and (= (f13 ?v0 (f14 f17)) f1) (= f5 (f18 (f22 f23 (f24 f25 (f26 (f27 f28 f12) f17))) ?v0)))))
(assert (=> (forall ((?v0 S3)) (=> (= (f13 ?v0 (f14 f17)) f1) (=> (= f5 (f18 (f22 f23 (f24 f25 (f26 (f27 f28 f12) f17))) ?v0)) false))) false))
(assert (not (= (f3 f12 f6) 0)))
(assert (= f6 (f7 (f8 f9 f10) f11)))
(assert (forall ((?v0 S3)) (=> (= (f13 ?v0 (f14 f17)) f1) (not (= (f3 f12 ?v0) 0)))))
(assert (= (f13 f6 (f14 f17)) f1))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 Int) (?v4 S5)) (not (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 (f29 f31 ?v2) ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 Int) (?v4 S5)) (not (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 (f29 f30 ?v2) ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int) (?v4 S5)) (not (= (f7 (f8 (f29 f31 ?v0) ?v1) ?v2) (f7 (f8 f9 ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int) (?v4 S5)) (not (= (f7 (f8 (f29 f30 ?v0) ?v1) ?v2) (f7 (f8 f9 ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int) (?v4 Int) (?v5 S5)) (not (= (f7 (f8 (f29 f31 ?v0) ?v1) ?v2) (f7 (f8 (f29 f30 ?v3) ?v4) ?v5)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int) (?v4 Int) (?v5 S5)) (not (= (f7 (f8 (f29 f30 ?v0) ?v1) ?v2) (f7 (f8 (f29 f31 ?v3) ?v4) ?v5)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (= (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int) (?v4 Int) (?v5 S5)) (= (= (f7 (f8 (f29 f31 ?v0) ?v1) ?v2) (f7 (f8 (f29 f31 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int) (?v4 Int) (?v5 S5)) (= (= (f7 (f8 (f29 f30 ?v0) ?v1) ?v2) (f7 (f8 (f29 f30 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (or (= f5 (f7 (f8 (f29 f31 (f24 f25 (f26 (f27 f28 f12) f17))) 0) (f33 (f34 f35 1) f36))) (exists ((?v0 S3)) (and (= (f13 ?v0 (f14 f17)) f1) (= f5 (f18 (f22 f23 (f24 f25 (f26 (f27 f28 f12) f17))) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S2)) (= (= (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) (forall ((?v3 S3)) (=> (= (f13 ?v3 (f14 ?v1)) f1) (= (f3 ?v0 ?v3) (f3 ?v2 ?v3)))))))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 Int) (?v2 S5)) (=> (= ?v0 (f7 (f8 f9 ?v1) ?v2)) false)) (=> (forall ((?v1 Int) (?v2 Int) (?v3 S5)) (=> (= ?v0 (f7 (f8 (f29 f31 ?v1) ?v2) ?v3)) false)) (=> (forall ((?v1 Int) (?v2 Int) (?v3 S5)) (=> (= ?v0 (f7 (f8 (f29 f30 ?v1) ?v2) ?v3)) false)) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f37 f38 (f7 (f8 (f29 f30 ?v0) ?v1) ?v2)) (f39 f40 0))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f37 f38 (f7 (f8 f9 ?v0) ?v1)) (f39 f40 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f37 f38 (f7 (f8 (f29 f31 ?v0) ?v1) ?v2)) (f39 f40 0))))
(assert (forall ((?v0 S21)) (= (f39 f40 (f41 f42 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f41 f42 (f39 f40 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f41 f42 (f39 f40 ?v0)) 0))))
(check-sat)
(exit)
