(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 () S4)
(declare-fun f8 (S6 S7) S5)
(declare-fun f9 (S8 S9) S6)
(declare-fun f10 () S8)
(declare-fun f11 () S9)
(declare-fun f12 () S7)
(declare-fun f13 () Int)
(declare-fun f14 (S9 S10) Int)
(declare-fun f15 () S10)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S11) S1)
(declare-fun f18 (S7) S11)
(declare-fun f19 (Int Int) S1)
(declare-fun f20 () S10)
(declare-fun f21 (S7) S7)
(declare-fun f22 (S12 S10) S10)
(declare-fun f23 (S13 Int) S12)
(declare-fun f24 () S13)
(declare-fun f25 (Int S14) S1)
(declare-fun f26 (S5) S14)
(declare-fun f27 () S5)
(declare-fun f28 (S15 S5) S5)
(declare-fun f29 (S16 Int) S15)
(declare-fun f30 () S16)
(declare-fun f31 () S5)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (f4 f5 (f6 f7 (f8 (f9 f10 f11) f12))) f13) 0))))
(assert (not (= (f14 f11 f15) 0)))
(assert (not (= (f14 f16 f15) 0)))
(assert (forall ((?v0 S10)) (=> (= (f17 ?v0 (f18 f12)) f1) (not (= (f14 f11 ?v0) 0)))))
(assert (= (f19 f13 (f6 f7 (f8 (f9 f10 f11) f12))) f1))
(assert (not (= (f14 f11 f15) 0)))
(assert (forall ((?v0 S10)) (=> (= (f17 ?v0 (f18 f12)) f1) (not (= (f14 f11 ?v0) 0)))))
(assert (= (f17 f15 (f18 f12)) f1))
(assert (forall ((?v0 S10)) (=> (= (f17 ?v0 (f18 f12)) f1) (not (= (f14 f16 ?v0) 0)))))
(assert (= (f19 f13 (f6 f7 (f8 (f9 f10 f11) f12))) f1))
(assert (= (f17 f20 (f18 (f21 f12))) f1))
(assert (= f20 (f22 (f23 f24 (f6 f7 (f8 (f9 f10 f11) f12))) f15)))
(assert (= (f25 f13 (f26 (f8 (f9 f10 f11) f12))) f1))
(assert (exists ((?v0 S10)) (and (= (f17 ?v0 (f18 f12)) f1) (= f20 (f22 (f23 f24 (f6 f7 (f8 (f9 f10 f11) f12))) ?v0)))))
(assert (= f27 (f28 (f29 f30 f13) f31)))
(assert (=> (forall ((?v0 S10)) (=> (= (f17 ?v0 (f18 f12)) f1) (=> (= f20 (f22 (f23 f24 (f6 f7 (f8 (f9 f10 f11) f12))) ?v0)) false))) false))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) (- ?v1)) (f3 (f4 f5 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 (- ?v0)) (- ?v1)) (f3 (f4 f5 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f3 (f4 f5 ?v0) ?v0) 1))))
(assert (not (= (f14 f16 f15) 0)))
(assert (=> (forall ((?v0 Int) (?v1 S5)) (=> (= f27 (f28 (f29 f30 ?v0) ?v1)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f19 ?v0 ?v1) f1) (=> (= (f19 ?v0 ?v2) f1) (= (= (f19 (f3 (f4 f5 ?v1) ?v0) (f3 (f4 f5 ?v2) ?v0)) f1) (= (f19 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v1) ?v0))) (=> (= (f19 ?v0 ?v1) f1) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v1 0) (- ?v1) ?v1)) (ite (< ?v0 0) (- ?v0) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f3 (f4 f5 ?v1) ?v2) (f3 (f4 f5 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f3 (f4 f5 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f3 (f4 f5 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f3 (f4 f5 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f3 (f4 f5 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f3 (f4 f5 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f3 (f4 f5 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f3 (f4 f5 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f3 (f4 f5 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f3 (f4 f5 ?v0) ?v1) 0)))))
(check-sat)
(exit)
