(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 (S5 S2) S3)
(declare-fun f6 (S6 S2) S5)
(declare-fun f7 () S6)
(declare-fun f8 () S2)
(declare-fun f9 () S3)
(declare-fun f10 () S4)
(declare-fun f11 () S4)
(declare-fun f12 (S7 S4) Int)
(declare-fun f13 () S7)
(declare-fun f14 (S8 Int) S4)
(declare-fun f15 () S8)
(declare-fun f16 () S5)
(declare-fun f17 (S9 S2) S4)
(declare-fun f18 () S9)
(declare-fun f19 () S6)
(declare-fun f20 () S9)
(declare-fun f21 (S10 S4) S5)
(declare-fun f22 () S10)
(declare-fun f23 (S11 S2) S2)
(declare-fun f24 () S11)
(declare-fun f25 (S12 S2) S1)
(declare-fun f26 (S13 S2) S12)
(declare-fun f27 () S13)
(declare-fun f28 (S14 S2) S11)
(declare-fun f29 () S14)
(declare-fun f30 (S16 S15) S2)
(declare-fun f31 (S17 S2) S16)
(declare-fun f32 (S18 S14) S17)
(declare-fun f33 () S18)
(declare-fun f34 (S13 S2 S2) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 (f6 f7 f8) (f4 f9 f10)) f11)) f1)))
(assert (= (f3 f8) f1))
(assert (forall ((?v0 S4) (?v1 S2)) (= (f4 (f5 (f6 f7 (f4 f9 ?v0)) ?v1) ?v0) ?v1)))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_1 (f4 f9 ?v0)) (?v_0 (f12 f13 ?v0))) (= (f4 (f5 (f6 f7 ?v_1) ?v1) ?v2) (ite (< (f12 f13 ?v2) ?v_0) (f4 f9 (f14 f15 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (f4 f9 ?v0))) (=> (< (f12 f13 ?v0) (f12 f13 ?v1)) (= (f4 (f5 (f6 f7 ?v_0) ?v2) ?v1) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (f12 f13 ?v1))) (=> (< (f12 f13 ?v0) ?v_0) (= (f4 (f5 (f6 f7 (f4 f9 ?v1)) ?v2) ?v0) (f4 f9 (f14 f15 (- ?v_0 1))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f4 f9 ?v0) (f4 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f5 f16 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S4)) (= (f17 f18 (f4 f9 ?v0)) (f14 f15 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 f15 0))) (= (f4 (f5 (f6 f19 ?v0) ?v1) ?v_0) (f4 (f5 (f6 f7 ?v0) ?v1) ?v_0)))))
(assert (forall ((?v0 S4)) (= (f17 f20 (f4 f9 ?v0)) (f14 f15 0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f4 f9 ?v1)) (?v_1 (f12 f13 ?v1))) (= (f4 (f5 (f21 f22 ?v0) ?v_0) ?v2) (ite (< ?v_1 (f12 f13 ?v2)) ?v_0 (f4 f9 (f14 f15 (+ ?v_1 (f12 f13 ?v0)))))))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f4 (f5 (f21 f22 (f14 f15 0)) ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (= (f4 (f5 (f21 f22 (f14 f15 (+ (f12 f13 ?v0) 1))) ?v1) ?v2) (f4 (f5 f16 (f4 (f5 (f21 f22 ?v0) ?v1) ?v2)) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (+ (f12 f13 ?v1) 1)) (?v_1 (f5 f16 ?v2))) (=> (< (f12 f13 ?v0) ?v_0) (= (f4 (f5 f16 (f4 ?v_1 ?v0)) (f14 f15 ?v_0)) (f4 (f5 f16 (f4 ?v_1 ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_1 (f4 f9 ?v0)) (?v_0 (f12 f13 ?v0))) (= (f4 (f5 (f6 f19 ?v_1) ?v1) ?v2) (ite (< (f12 f13 ?v2) ?v_0) (f4 f9 (f14 f15 (- ?v_0 1))) (ite (= ?v0 ?v2) (f4 (f5 (f21 f22 ?v2) ?v1) (f14 f15 0)) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f5 (f6 f19 ?v0) ?v1) ?v2) (f4 (f5 (f6 f7 ?v0) (f4 (f5 (f21 f22 ?v2) ?v1) (f14 f15 0))) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f4 f9 ?v0)) (?v_1 (f12 f13 ?v0))) (= (f4 (f5 f16 ?v_0) ?v1) (ite (< ?v_1 (f12 f13 ?v1)) ?v_0 (f4 f9 (f14 f15 (+ ?v_1 1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (+ (f12 f13 ?v1) 1)) (?v_1 (f6 f7 ?v2))) (=> (< (f12 f13 ?v0) ?v_0) (= (f4 (f5 (f6 f7 (f4 (f5 ?v_1 (f4 (f5 f16 ?v3) ?v0)) (f14 f15 ?v_0))) (f4 (f5 (f6 f7 ?v4) ?v3) ?v1)) ?v0) (f4 (f5 (f6 f7 (f4 (f5 ?v_1 ?v4) ?v0)) ?v3) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f12 f13 ?v1) 1))) (=> (< (f12 f13 ?v0) ?v_0) (= (f4 (f5 f16 (f4 (f5 (f6 f7 ?v2) ?v3) ?v0)) ?v1) (f4 (f5 (f6 f7 (f4 (f5 f16 ?v2) (f14 f15 ?v_0))) (f4 (f5 f16 ?v3) ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f12 f13 ?v1) 1))) (=> (< (f12 f13 ?v0) ?v_0) (= (f4 (f5 f16 (f4 (f5 (f6 f7 ?v2) ?v3) ?v1)) ?v0) (f4 (f5 (f6 f7 (f4 (f5 f16 ?v2) ?v0)) (f4 (f5 f16 ?v3) ?v0)) (f14 f15 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f4 (f5 (f6 f7 (f4 (f5 f16 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f5 (f6 f7 (f23 f24 ?v0)) ?v1) ?v2) (f23 f24 (f4 (f5 (f6 f7 ?v0) (f4 (f5 f16 ?v1) (f14 f15 0))) (f14 f15 (+ (f12 f13 ?v2) 1)))))))
(assert (forall ((?v0 S2)) (= (f17 f18 (f23 f24 ?v0)) (f14 f15 (+ (f12 f13 (f17 f18 ?v0)) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f5 (f6 f19 (f23 f24 ?v0)) ?v1) ?v2) (f23 f24 (f4 (f5 (f6 f19 ?v0) ?v1) (f14 f15 (+ (f12 f13 ?v2) 1)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (=> (= (f25 (f26 f27 (f4 f9 ?v0)) ?v1) f1) false)))
(assert (forall ((?v0 S2)) (= (f17 f20 (f23 f24 ?v0)) (f14 f15 (+ (f12 f13 (f17 f20 ?v0)) (+ 0 1))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f4 (f5 ?v_0 (f23 f24 ?v1)) ?v2) (f23 f24 (f4 (f5 ?v_0 ?v1) (f14 f15 (+ (f12 f13 ?v2) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f17 f18 (f23 (f28 f29 ?v0) ?v1)) (f14 f15 (+ (+ (f12 f13 (f17 f18 ?v0)) (f12 f13 (f17 f18 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (= (f25 (f26 f27 (f23 (f28 f29 ?v0) ?v2)) (f23 (f28 f29 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f28 f29 ?v2))) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (= (f25 (f26 f27 (f23 ?v_0 ?v0)) (f23 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (= (f25 (f26 f27 (f23 f24 ?v0)) (f23 f24 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f25 (f26 f27 (f23 (f28 f29 (f23 f24 ?v0)) ?v1)) (f4 (f5 (f6 f7 ?v0) ?v1) (f14 f15 0))) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f23 f24 ?v0) (f23 (f28 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f23 (f28 f29 ?v0) ?v1) (f23 f24 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f23 f24 ?v0) (f23 f24 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f23 (f28 f29 ?v0) ?v1) (f23 (f28 f29 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (not (= (f4 f9 ?v0) (f23 (f28 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (not (= (f23 (f28 f29 ?v0) ?v1) (f4 f9 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S4)) (= (f4 (f5 (f6 f7 (f23 (f28 f29 ?v0) ?v1)) ?v2) ?v3) (f23 (f28 f29 (f4 (f5 (f6 f7 ?v0) ?v2) ?v3)) (f4 (f5 (f6 f7 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f5 f16 (f23 (f28 f29 ?v0) ?v1)) ?v2) (f23 (f28 f29 (f4 (f5 f16 ?v0) ?v2)) (f4 (f5 f16 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2) (?v3 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f4 (f5 ?v_0 (f23 (f28 f29 ?v1) ?v2)) ?v3) (f23 (f28 f29 (f4 (f5 ?v_0 ?v1) ?v3)) (f4 (f5 ?v_0 ?v2) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S4)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (= (f25 (f26 f27 (f4 (f5 (f6 f7 ?v0) ?v2) ?v3)) (f4 (f5 (f6 f7 ?v1) ?v2) ?v3)) f1))))
(assert (forall ((?v0 S2) (?v1 S4)) (not (= (f23 f24 ?v0) (f4 f9 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S2)) (not (= (f4 f9 ?v0) (f23 f24 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f17 f20 (f23 (f28 f29 ?v0) ?v1)) (f14 f15 (+ (+ (f12 f13 (f17 f20 ?v0)) (f12 f13 (f17 f20 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (= (f25 (f26 f27 (f4 (f5 f16 ?v0) ?v2)) (f4 (f5 f16 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S4)) (= (f4 (f5 (f6 f19 (f23 (f28 f29 ?v0) ?v1)) ?v2) ?v3) (f23 (f28 f29 (f4 (f5 (f6 f19 ?v0) ?v2) ?v3)) (f4 (f5 (f6 f19 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f4 (f5 f16 (f23 f24 ?v0)) ?v1) (f23 f24 (f4 (f5 f16 ?v0) (f14 f15 (+ (f12 f13 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f25 (f26 f27 (f23 f24 ?v0)) ?v1) f1) (=> (forall ((?v2 S2)) (=> (= ?v1 (f23 f24 ?v2)) (=> (= (f25 (f26 f27 ?v0) ?v2) f1) false))) false))))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0) f1) (= (f3 (f23 f24 ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f25 (f26 f27 (f23 (f28 f29 ?v0) ?v1)) ?v2) f1) (=> (forall ((?v3 S2)) (=> (= ?v2 (f4 (f5 (f6 f7 ?v3) ?v1) (f14 f15 0))) (=> (= ?v0 (f23 f24 ?v3)) false))) (=> (forall ((?v3 S2)) (=> (= ?v2 (f23 (f28 f29 ?v3) ?v1)) (=> (= (f25 (f26 f27 ?v0) ?v3) f1) false))) (=> (forall ((?v3 S2)) (=> (= ?v2 (f23 (f28 f29 ?v0) ?v3)) (=> (= (f25 (f26 f27 ?v1) ?v3) f1) false))) false))))))
(assert (forall ((?v0 S2)) (=> (forall ((?v1 S4)) (=> (= ?v0 (f4 f9 ?v1)) false)) (=> (forall ((?v1 S2) (?v2 S2)) (=> (= ?v0 (f23 (f28 f29 ?v1) ?v2)) false)) (=> (forall ((?v1 S2)) (=> (= ?v0 (f23 f24 ?v1)) false)) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S15)) (let ((?v_0 (f32 f33 f29))) (=> (= (f3 (f30 (f31 ?v_0 (f4 (f5 (f6 f7 ?v0) ?v1) (f14 f15 0))) ?v2)) f1) (=> (= (f3 ?v1) f1) (= (f3 (f30 (f31 ?v_0 (f23 (f28 f29 (f23 f24 ?v0)) ?v1)) ?v2)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f25 (f26 f27 ?v0) ?v1) f1) (or (exists ((?v2 S2) (?v3 S2)) (and (= ?v0 (f23 (f28 f29 (f23 f24 ?v2)) ?v3)) (= ?v1 (f4 (f5 (f6 f7 ?v2) ?v3) (f14 f15 0))))) (or (exists ((?v2 S2) (?v3 S2) (?v4 S2)) (and (= ?v0 (f23 (f28 f29 ?v2) ?v4)) (and (= ?v1 (f23 (f28 f29 ?v3) ?v4)) (= (f25 (f26 f27 ?v2) ?v3) f1)))) (or (exists ((?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f28 f29 ?v4))) (and (= ?v0 (f23 ?v_0 ?v2)) (and (= ?v1 (f23 ?v_0 ?v3)) (= (f25 (f26 f27 ?v2) ?v3) f1))))) (exists ((?v2 S2) (?v3 S2)) (and (= ?v0 (f23 f24 ?v2)) (and (= ?v1 (f23 f24 ?v3)) (= (f25 (f26 f27 ?v2) ?v3) f1))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f34 f27 ?v0 ?v1) f1) (= (f34 f27 (f23 f24 ?v0) (f23 f24 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f34 f27 ?v0 ?v1) f1) (=> (= (f34 f27 ?v2 ?v3) f1) (= (f34 f27 (f23 (f28 f29 ?v0) ?v2) (f23 (f28 f29 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (=> (= (f34 f27 ?v0 ?v1) f1) (= (f34 f27 (f4 (f5 f16 ?v0) ?v2) (f4 (f5 f16 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f28 f29 ?v2))) (=> (= (f34 f27 ?v0 ?v1) f1) (= (f34 f27 (f23 ?v_0 ?v0) (f23 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S4)) (= (f14 f15 (f12 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f13 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f13 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
