(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 () S3)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S2) S3)
(declare-fun f8 (S6 S2) S5)
(declare-fun f9 () S6)
(declare-fun f10 () S5)
(declare-fun f11 (S7 S2) S4)
(declare-fun f12 () S7)
(declare-fun f13 (S8 Int) S4)
(declare-fun f14 () S8)
(declare-fun f15 () S7)
(declare-fun f16 (S9 S4) S5)
(declare-fun f17 () S9)
(declare-fun f18 (S10 S4) Int)
(declare-fun f19 () S10)
(declare-fun f20 (S11 S2) S2)
(declare-fun f21 () S11)
(declare-fun f22 (S12 S4) S13)
(declare-fun f23 (S12 S2 S13) S1)
(declare-fun f24 (S14 S2) S1)
(declare-fun f25 (S15 S2) S14)
(declare-fun f26 () S15)
(declare-fun f27 () S6)
(declare-fun f28 (S16 S13) S12)
(declare-fun f29 (S17 S4) S16)
(declare-fun f30 (S18 S12) S17)
(declare-fun f31 () S18)
(declare-fun f32 (S19 S2) S11)
(declare-fun f33 () S19)
(declare-fun f34 (S15 S2 S2) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 f6)) f1)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f4 f5 ?v0) (f4 f5 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f7 (f8 f9 ?v0) (f4 f5 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f7 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S4)) (= (f11 f12 (f4 f5 ?v0)) (f13 f14 0))))
(assert (forall ((?v0 S4)) (= (f11 f15 (f4 f5 ?v0)) (f13 f14 0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f18 f19 ?v1))) (= (f4 (f7 (f16 f17 ?v0) ?v_0) ?v2) (ite (< ?v_1 (f18 f19 ?v2)) ?v_0 (f4 f5 (f13 f14 (+ ?v_1 (f18 f19 ?v0)))))))))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0) f1) (= (f3 (f20 f21 ?v0)) f1))))
(assert (forall ((?v0 S12) (?v1 S4) (?v2 S13)) (=> (= (f22 ?v0 ?v1) ?v2) (= (f23 ?v0 (f4 f5 ?v1) ?v2) f1))))
(assert (forall ((?v0 S12) (?v1 S4) (?v2 S13)) (=> (= (f23 ?v0 (f4 f5 ?v1) ?v2) f1) (=> (=> (= (f22 ?v0 ?v1) ?v2) false) false))))
(assert (forall ((?v0 S4) (?v1 S2)) (=> (= (f24 (f25 f26 (f4 f5 ?v0)) ?v1) f1) false)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f24 (f25 f26 ?v0) ?v1) f1) (= (f24 (f25 f26 (f20 f21 ?v0)) (f20 f21 ?v1)) f1))))
(assert (forall ((?v0 S2)) (= (f11 f12 (f20 f21 ?v0)) (f13 f14 (+ (f18 f19 (f11 f12 ?v0)) (+ 0 1))))))
(assert (forall ((?v0 S2)) (= (f11 f15 (f20 f21 ?v0)) (f13 f14 (+ (f18 f19 (f11 f15 ?v0)) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f4 (f7 f10 (f20 f21 ?v0)) ?v1) (f20 f21 (f4 (f7 f10 ?v0) (f13 f14 (+ (f18 f19 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f20 f21 ?v0) (f20 f21 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f4 (f7 (f16 f17 (f13 f14 0)) ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_0 (f16 f17 ?v0))) (= (f4 (f7 ?v_0 (f20 f21 ?v1)) ?v2) (f20 f21 (f4 (f7 ?v_0 ?v1) (f13 f14 (+ (f18 f19 ?v2) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f7 (f8 f9 (f20 f21 ?v0)) ?v1) ?v2) (f20 f21 (f4 (f7 (f8 f9 ?v0) (f4 (f7 f10 ?v1) (f13 f14 0))) (f13 f14 (+ (f18 f19 ?v2) 1)))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (= (f4 (f7 (f16 f17 (f13 f14 (+ (f18 f19 ?v0) 1))) ?v1) ?v2) (f4 (f7 f10 (f4 (f7 (f16 f17 ?v0) ?v1) ?v2)) ?v2))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f4 (f7 (f8 f9 (f4 (f7 f10 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (=> (= (f24 (f25 f26 ?v0) ?v1) f1) (= (f24 (f25 f26 (f4 (f7 f10 ?v0) ?v2)) (f4 (f7 f10 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S4)) (=> (= (f24 (f25 f26 ?v0) ?v1) f1) (= (f24 (f25 f26 (f4 (f7 (f8 f9 ?v0) ?v2) ?v3)) (f4 (f7 (f8 f9 ?v1) ?v2) ?v3)) f1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (+ (f18 f19 ?v1) 1)) (?v_1 (f7 f10 ?v2))) (=> (< (f18 f19 ?v0) ?v_0) (= (f4 (f7 f10 (f4 ?v_1 ?v0)) (f13 f14 ?v_0)) (f4 (f7 f10 (f4 ?v_1 ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f18 f19 ?v1) 1))) (=> (< (f18 f19 ?v0) ?v_0) (= (f4 (f7 f10 (f4 (f7 (f8 f9 ?v2) ?v3) ?v1)) ?v0) (f4 (f7 (f8 f9 (f4 (f7 f10 ?v2) ?v0)) (f4 (f7 f10 ?v3) ?v0)) (f13 f14 ?v_0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f18 f19 ?v1) 1))) (=> (< (f18 f19 ?v0) ?v_0) (= (f4 (f7 f10 (f4 (f7 (f8 f9 ?v2) ?v3) ?v0)) ?v1) (f4 (f7 (f8 f9 (f4 (f7 f10 ?v2) (f13 f14 ?v_0))) (f4 (f7 f10 ?v3) ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (+ (f18 f19 ?v1) 1)) (?v_1 (f8 f9 ?v2))) (=> (< (f18 f19 ?v0) ?v_0) (= (f4 (f7 (f8 f9 (f4 (f7 ?v_1 (f4 (f7 f10 ?v3) ?v0)) (f13 f14 ?v_0))) (f4 (f7 (f8 f9 ?v4) ?v3) ?v1)) ?v0) (f4 (f7 (f8 f9 (f4 (f7 ?v_1 ?v4) ?v0)) ?v3) ?v1))))))
(assert (forall ((?v0 S12) (?v1 S2) (?v2 S13) (?v3 S2)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (= (f24 (f25 f26 ?v1) ?v3) f1) (= (f23 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S2)) (not (= (f4 f5 ?v0) (f20 f21 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S4)) (not (= (f20 f21 ?v0) (f4 f5 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (f18 f19 ?v1))) (=> (< (f18 f19 ?v0) ?v_0) (= (f4 (f7 (f8 f9 (f4 f5 ?v1)) ?v2) ?v0) (f4 f5 (f13 f14 (- ?v_0 1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (=> (< (f18 f19 ?v0) (f18 f19 ?v1)) (= (f4 (f7 (f8 f9 ?v_0) ?v2) ?v1) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_1 (f4 f5 ?v0)) (?v_0 (f18 f19 ?v0))) (= (f4 (f7 (f8 f9 ?v_1) ?v1) ?v2) (ite (< (f18 f19 ?v2) ?v_0) (f4 f5 (f13 f14 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (= (f4 (f7 (f8 f9 (f4 f5 ?v0)) ?v1) ?v0) ?v1)))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f4 f5 ?v0)) (?v_1 (f18 f19 ?v0))) (= (f4 (f7 f10 ?v_0) ?v1) (ite (< ?v_1 (f18 f19 ?v1)) ?v_0 (f4 f5 (f13 f14 (+ ?v_1 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f24 (f25 f26 (f20 f21 ?v0)) ?v1) f1) (=> (forall ((?v2 S2)) (=> (= ?v1 (f20 f21 ?v2)) (=> (= (f24 (f25 f26 ?v0) ?v2) f1) false))) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f7 (f8 f27 ?v0) ?v1) ?v2) (f4 (f7 (f8 f9 ?v0) (f4 (f7 (f16 f17 ?v2) ?v1) (f13 f14 0))) ?v2))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_1 (f4 f5 ?v0)) (?v_0 (f18 f19 ?v0))) (= (f4 (f7 (f8 f27 ?v_1) ?v1) ?v2) (ite (< (f18 f19 ?v2) ?v_0) (f4 f5 (f13 f14 (- ?v_0 1))) (ite (= ?v0 ?v2) (f4 (f7 (f16 f17 ?v2) ?v1) (f13 f14 0)) ?v_1))))))
(assert (forall ((?v0 S12) (?v1 S2) (?v2 S13) (?v3 S4) (?v4 S13)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (= (f23 (f28 (f29 (f30 f31 ?v0) ?v3) ?v4) (f4 (f7 f10 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f24 (f25 f26 (f20 (f32 f33 (f20 f21 ?v0)) ?v1)) (f4 (f7 (f8 f9 ?v0) ?v1) (f13 f14 0))) f1)))
(assert (forall ((?v0 S12) (?v1 S2) (?v2 S13) (?v3 S12) (?v4 S2) (?v5 S13) (?v6 S4)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (= (f23 ?v3 ?v4 ?v5) f1) (=> (= ?v0 (f28 (f29 (f30 f31 ?v3) ?v6) ?v5)) (= (f23 ?v3 (f4 (f7 (f8 f9 ?v1) ?v4) ?v6) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f34 f26 ?v0 ?v1) f1) (= (f34 f26 (f20 f21 ?v0) (f20 f21 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f14 0))) (= (f4 (f7 (f8 f27 ?v0) ?v1) ?v_0) (f4 (f7 (f8 f9 ?v0) ?v1) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f7 (f8 f27 (f20 f21 ?v0)) ?v1) ?v2) (f20 f21 (f4 (f7 (f8 f27 ?v0) ?v1) (f13 f14 (+ (f18 f19 ?v2) 1)))))))
(assert (forall ((?v0 S12) (?v1 S2) (?v2 S13)) (=> (= (f23 ?v0 (f20 f21 ?v1) ?v2) f1) (=> (forall ((?v3 S13) (?v4 S13)) (=> (= (f23 (f28 (f29 (f30 f31 ?v0) (f13 f14 0)) ?v3) ?v1 ?v4) f1) false)) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (=> (= (f34 f26 ?v0 ?v1) f1) (= (f34 f26 (f4 (f7 f10 ?v0) ?v2) (f4 (f7 f10 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v2))) (=> (= (f24 (f25 f26 ?v0) ?v1) f1) (= (f24 (f25 f26 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f24 (f25 f26 ?v0) ?v1) f1) (= (f24 (f25 f26 (f20 (f32 f33 ?v0) ?v2)) (f20 (f32 f33 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f34 f26 ?v0 ?v1) f1) (=> (= (f34 f26 ?v2 ?v3) f1) (= (f34 f26 (f20 (f32 f33 ?v0) ?v2) (f20 (f32 f33 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f20 (f32 f33 ?v0) ?v1) (f20 (f32 f33 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S4)) (= (f4 (f7 (f8 f27 (f20 (f32 f33 ?v0) ?v1)) ?v2) ?v3) (f20 (f32 f33 (f4 (f7 (f8 f27 ?v0) ?v2) ?v3)) (f4 (f7 (f8 f27 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S12) (?v3 S13)) (let ((?v_0 (f18 f19 ?v1))) (=> (< (f18 f19 ?v0) ?v_0) (= (f22 (f28 (f29 (f30 f31 ?v2) ?v0) ?v3) ?v1) (f22 ?v2 (f13 f14 (- ?v_0 1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S12) (?v3 S13)) (=> (< (f18 f19 ?v0) (f18 f19 ?v1)) (= (f22 (f28 (f29 (f30 f31 ?v2) ?v1) ?v3) ?v0) (f22 ?v2 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S12) (?v3 S13)) (=> (= ?v0 ?v1) (= (f22 (f28 (f29 (f30 f31 ?v2) ?v0) ?v3) ?v1) ?v3))))
(assert (forall ((?v0 S12) (?v1 S4) (?v2 S13) (?v3 S13)) (let ((?v_1 (f13 f14 0)) (?v_0 (f30 f31 ?v0))) (= (f28 (f29 (f30 f31 (f28 (f29 ?v_0 ?v1) ?v2)) ?v_1) ?v3) (f28 (f29 (f30 f31 (f28 (f29 ?v_0 ?v_1) ?v3)) (f13 f14 (+ (f18 f19 ?v1) 1))) ?v2)))))
(assert (forall ((?v0 S12) (?v1 S4) (?v2 S13) (?v3 S4)) (let ((?v_0 (f18 f19 ?v3))) (= (f22 (f28 (f29 (f30 f31 ?v0) ?v1) ?v2) ?v3) (ite (< ?v_0 (f18 f19 ?v1)) (f22 ?v0 ?v3) (ite (= ?v3 ?v1) ?v2 (f22 ?v0 (f13 f14 (- ?v_0 1)))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v2))) (=> (= (f34 f26 ?v0 ?v1) f1) (= (f34 f26 (f20 ?v_0 ?v0) (f20 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f34 f26 ?v0 ?v1) f1) (= (f34 f26 (f20 (f32 f33 ?v0) ?v2) (f20 (f32 f33 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (not (= (f4 f5 ?v0) (f20 (f32 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (not (= (f20 (f32 f33 ?v0) ?v1) (f4 f5 ?v2)))))
(assert (forall ((?v0 S4)) (= (f13 f14 (f18 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f18 f19 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f18 f19 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
