(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 (S5 S2) S3)
(declare-fun f6 (S6 S2) S5)
(declare-fun f7 () S6)
(declare-fun f8 (S7 S2) S2)
(declare-fun f9 () S7)
(declare-fun f10 () S2)
(declare-fun f11 () S2)
(declare-fun f12 () S4)
(declare-fun f13 (S8 S2 S9) S1)
(declare-fun f14 () S8)
(declare-fun f15 () S9)
(declare-fun f16 (S10 S9) S8)
(declare-fun f17 (S11 S4) S10)
(declare-fun f18 (S12 S8) S11)
(declare-fun f19 () S12)
(declare-fun f20 () S9)
(declare-fun f21 () S2)
(declare-fun f22 () S2)
(declare-fun f23 (S13 S9) S9)
(declare-fun f24 (S14 S9) S13)
(declare-fun f25 () S14)
(declare-fun f26 () S3)
(declare-fun f27 () S5)
(declare-fun f28 (S15 Int) S4)
(declare-fun f29 () S15)
(declare-fun f30 (S16 S4) Int)
(declare-fun f31 () S16)
(declare-fun f32 () S8)
(declare-fun f33 () S4)
(declare-fun f34 () S9)
(declare-fun f35 (S8 S4) S9)
(declare-fun f36 (S17 S9) S4)
(declare-fun f37 () S17)
(declare-fun f38 () S17)
(declare-fun f39 (S18 S2) S4)
(declare-fun f40 () S18)
(declare-fun f41 () S8)
(declare-fun f42 (S19 S2) S7)
(declare-fun f43 () S19)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 (f6 f7 (f8 f9 f10)) f11) f12)) f1)))
(assert (= (f3 f11) f1))
(assert (= (f13 f14 f11 f15) f1))
(assert (= (f13 (f16 (f17 (f18 f19 f14) f12) f15) (f8 f9 f10) f20) f1))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S9) (?v3 S2)) (=> (= (f13 (f16 (f17 (f18 f19 ?v0) ?v1) f15) f10 ?v2) f1) (=> (= (f3 ?v3) f1) (=> (= (f13 ?v0 ?v3 f15) f1) (= (f3 (f4 (f5 (f6 f7 f10) ?v3) ?v1)) f1))))))
(assert (= (f3 f21) f1))
(assert (= (f3 f22) f1))
(assert (= (f3 f11) f1))
(assert (= (f13 f14 f11 f15) f1))
(assert (= (f3 f10) f1))
(assert (= (f13 (f16 (f17 (f18 f19 f14) f12) f15) (f8 f9 f10) f20) f1))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0) f1) (= (f3 (f8 f9 ?v0)) f1))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S9) (?v3 S2)) (=> (= (f13 (f16 (f17 (f18 f19 ?v0) ?v1) f15) f10 ?v2) f1) (=> (= (f3 ?v3) f1) (=> (= (f13 ?v0 ?v3 f15) f1) (= (f3 (f4 (f5 (f6 f7 f10) ?v3) ?v1)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f8 f9 ?v0) (f8 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S2) (?v3 S8) (?v4 S4) (?v5 S9) (?v6 S2)) (=> (= f15 (f23 (f24 f25 ?v0) ?v1)) (=> (= (f3 ?v2) f1) (=> (= (f13 (f16 (f17 (f18 f19 ?v3) ?v4) ?v0) ?v2 ?v5) f1) (=> (= (f3 ?v6) f1) (=> (= (f13 ?v3 ?v6 ?v0) f1) (= (f3 (f4 (f5 (f6 f7 ?v2) ?v6) ?v4)) f1))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S2) (?v3 S8) (?v4 S4) (?v5 S9) (?v6 S2)) (=> (= f15 (f23 (f24 f25 ?v0) ?v1)) (=> (= (f3 ?v2) f1) (=> (= (f13 (f16 (f17 (f18 f19 ?v3) ?v4) ?v1) ?v2 ?v5) f1) (=> (= (f3 ?v6) f1) (=> (= (f13 ?v3 ?v6 ?v1) f1) (= (f3 (f4 (f5 (f6 f7 ?v2) ?v6) ?v4)) f1))))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) (f4 f26 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f5 f27 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f5 (f6 f7 (f8 f9 ?v0)) ?v1) ?v2) (f8 f9 (f4 (f5 (f6 f7 ?v0) (f4 (f5 f27 ?v1) (f28 f29 0))) (f28 f29 (+ (f30 f31 ?v2) 1)))))))
(assert (forall ((?v0 S4)) (= (f3 (f4 f26 ?v0)) f1)))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S9) (?v3 S8) (?v4 S2) (?v5 S9) (?v6 S4)) (=> (= (f13 ?v0 ?v1 ?v2) f1) (=> (= (f13 ?v3 ?v4 ?v5) f1) (=> (= ?v0 (f16 (f17 (f18 f19 ?v3) ?v6) ?v5)) (= (f13 ?v3 (f4 (f5 (f6 f7 ?v1) ?v4) ?v6) ?v2) f1))))))
(assert (= (f13 (f16 (f17 (f18 f19 f32) f33) f15) (f8 f9 f10) f34) f1))
(assert (= (f13 f32 f22 f15) f1))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S9)) (=> (= (f35 ?v0 ?v1) ?v2) (= (f13 ?v0 (f4 f26 ?v1) ?v2) f1))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S9)) (=> (= (f13 ?v0 (f4 f26 ?v1) ?v2) f1) (=> (=> (= (f35 ?v0 ?v1) ?v2) false) false))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S9) (?v3 S4) (?v4 S9)) (=> (= (f13 ?v0 ?v1 ?v2) f1) (= (f13 (f16 (f17 (f18 f19 ?v0) ?v3) ?v4) (f4 (f5 f27 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S8) (?v1 S9) (?v2 S2) (?v3 S9)) (=> (= (f13 (f16 (f17 (f18 f19 ?v0) (f28 f29 0)) ?v1) ?v2 ?v3) f1) (= (f13 ?v0 (f8 f9 ?v2) (f23 (f24 f25 ?v1) ?v3)) f1))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f4 f26 ?v0)) (?v_1 (f30 f31 ?v0))) (= (f4 (f5 f27 ?v_0) ?v1) (ite (< ?v_1 (f30 f31 ?v1)) ?v_0 (f4 f26 (f28 f29 (+ ?v_1 1))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f4 f26 ?v0) (f4 f26 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (= (= (f23 (f24 f25 ?v0) ?v1) (f23 (f24 f25 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S9) (?v3 S4)) (let ((?v_0 (f30 f31 ?v3))) (= (f35 (f16 (f17 (f18 f19 ?v0) ?v1) ?v2) ?v3) (ite (< ?v_0 (f30 f31 ?v1)) (f35 ?v0 ?v3) (ite (= ?v3 ?v1) ?v2 (f35 ?v0 (f28 f29 (- ?v_0 1)))))))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S9) (?v3 S9)) (let ((?v_1 (f28 f29 0)) (?v_0 (f18 f19 ?v0))) (= (f16 (f17 (f18 f19 (f16 (f17 ?v_0 ?v1) ?v2)) ?v_1) ?v3) (f16 (f17 (f18 f19 (f16 (f17 ?v_0 ?v_1) ?v3)) (f28 f29 (+ (f30 f31 ?v1) 1))) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8) (?v3 S9)) (=> (= ?v0 ?v1) (= (f35 (f16 (f17 (f18 f19 ?v2) ?v0) ?v3) ?v1) ?v3))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8) (?v3 S9)) (=> (< (f30 f31 ?v0) (f30 f31 ?v1)) (= (f35 (f16 (f17 (f18 f19 ?v2) ?v1) ?v3) ?v0) (f35 ?v2 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8) (?v3 S9)) (let ((?v_0 (f30 f31 ?v1))) (=> (< (f30 f31 ?v0) ?v_0) (= (f35 (f16 (f17 (f18 f19 ?v2) ?v0) ?v3) ?v1) (f35 ?v2 (f28 f29 (- ?v_0 1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (+ (f30 f31 ?v1) 1)) (?v_1 (f5 f27 ?v2))) (=> (< (f30 f31 ?v0) ?v_0) (= (f4 (f5 f27 (f4 ?v_1 ?v0)) (f28 f29 ?v_0)) (f4 (f5 f27 (f4 ?v_1 ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S2)) (not (= (f4 f26 ?v0) (f8 f9 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S4)) (not (= (f8 f9 ?v0) (f4 f26 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (f30 f31 ?v1))) (=> (< (f30 f31 ?v0) ?v_0) (= (f4 (f5 (f6 f7 (f4 f26 ?v1)) ?v2) ?v0) (f4 f26 (f28 f29 (- ?v_0 1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (=> (< (f30 f31 ?v0) (f30 f31 ?v1)) (= (f4 (f5 (f6 f7 ?v_0) ?v2) ?v1) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_1 (f4 f26 ?v0)) (?v_0 (f30 f31 ?v0))) (= (f4 (f5 (f6 f7 ?v_1) ?v1) ?v2) (ite (< (f30 f31 ?v2) ?v_0) (f4 f26 (f28 f29 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (= (f4 (f5 (f6 f7 (f4 f26 ?v0)) ?v1) ?v0) ?v1)))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f4 (f5 f27 (f8 f9 ?v0)) ?v1) (f8 f9 (f4 (f5 f27 ?v0) (f28 f29 (+ (f30 f31 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (+ (f30 f31 ?v1) 1)) (?v_1 (f6 f7 ?v2))) (=> (< (f30 f31 ?v0) ?v_0) (= (f4 (f5 (f6 f7 (f4 (f5 ?v_1 (f4 (f5 f27 ?v3) ?v0)) (f28 f29 ?v_0))) (f4 (f5 (f6 f7 ?v4) ?v3) ?v1)) ?v0) (f4 (f5 (f6 f7 (f4 (f5 ?v_1 ?v4) ?v0)) ?v3) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f30 f31 ?v1) 1))) (=> (< (f30 f31 ?v0) ?v_0) (= (f4 (f5 f27 (f4 (f5 (f6 f7 ?v2) ?v3) ?v0)) ?v1) (f4 (f5 (f6 f7 (f4 (f5 f27 ?v2) (f28 f29 ?v_0))) (f4 (f5 f27 ?v3) ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f30 f31 ?v1) 1))) (=> (< (f30 f31 ?v0) ?v_0) (= (f4 (f5 f27 (f4 (f5 (f6 f7 ?v2) ?v3) ?v1)) ?v0) (f4 (f5 (f6 f7 (f4 (f5 f27 ?v2) ?v0)) (f4 (f5 f27 ?v3) ?v0)) (f28 f29 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f4 (f5 (f6 f7 (f4 (f5 f27 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S9)) (=> (= (f13 ?v0 (f8 f9 ?v1) ?v2) f1) (=> (forall ((?v3 S9) (?v4 S9)) (=> (= ?v2 (f23 (f24 f25 ?v3) ?v4)) (=> (= (f13 (f16 (f17 (f18 f19 ?v0) (f28 f29 0)) ?v3) ?v1 ?v4) f1) false))) false))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S9)) (=> (= (f13 ?v0 (f8 f9 ?v1) ?v2) f1) (=> (forall ((?v3 S9) (?v4 S9)) (=> (= (f13 (f16 (f17 (f18 f19 ?v0) (f28 f29 0)) ?v3) ?v1 ?v4) f1) false)) false))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f36 f37 (f23 (f24 f25 ?v0) ?v1)) (f28 f29 (+ (+ (f30 f31 (f36 f37 ?v0)) (f30 f31 (f36 f37 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f36 f38 (f23 (f24 f25 ?v0) ?v1)) (f28 f29 (+ (+ (f30 f31 (f36 f38 ?v0)) (f30 f31 (f36 f38 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S2)) (= (f39 f40 (f8 f9 ?v0)) (f28 f29 (+ (f30 f31 (f39 f40 ?v0)) (+ 0 1))))))
(assert (forall ((?v0 S4)) (= (f39 f40 (f4 f26 ?v0)) (f28 f29 0))))
(assert (forall ((?v0 S4)) (= (f36 f38 (f35 f41 ?v0)) (f28 f29 0))))
(assert (forall ((?v0 S4)) (= (f36 f37 (f35 f41 ?v0)) (f28 f29 0))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S9) (?v3 S9) (?v4 S2)) (=> (= (f13 ?v0 ?v1 (f23 (f24 f25 ?v2) ?v3)) f1) (=> (= (f13 ?v0 ?v4 ?v2) f1) (= (f13 ?v0 (f8 (f42 f43 ?v1) ?v4) ?v3) f1)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S4)) (not (= (f23 (f24 f25 ?v0) ?v1) (f35 f41 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S9) (?v2 S9)) (not (= (f35 f41 ?v0) (f23 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f35 f41 ?v0) (f35 f41 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f8 (f42 f43 ?v0) ?v1) (f8 (f42 f43 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S4)) (= (f28 f29 (f30 f31 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f30 f31 (f28 f29 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f30 f31 (f28 f29 ?v0)) 0))))
(check-sat)
(exit)
