(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 (Int) S3)
(declare-fun f6 (S4 Int) Int)
(declare-fun f7 (S5 Int) S4)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 (S6 S7) Int)
(declare-fun f11 (S8 Int) S6)
(declare-fun f12 () S8)
(declare-fun f13 (S9 Int) S7)
(declare-fun f14 () S9)
(declare-fun f15 () S6)
(declare-fun f16 (Int) S1)
(declare-fun f17 () S5)
(declare-fun f18 () S5)
(declare-fun f19 (S10 S7) S7)
(declare-fun f20 (S11 S7) S10)
(declare-fun f21 () S11)
(declare-fun f22 () S11)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (not (= (f3 (f4 (f5 1) (f6 (f7 f8 (- 1)) ?v_0)) ?v_0) f1))))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (= (f3 (f4 (f5 (f6 (f7 f8 (- 1)) ?v_0)) (f10 (f11 f12 (- 1)) (f13 f14 (* 2 (f10 f15 (f13 f14 f9)))))) ?v_0) f1)))
(assert (<= 1 f9))
(assert (< 2 (+ (* 4 f9) 1)))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (= (f3 (f4 (f5 (f6 (f7 f8 (- 1)) ?v_0)) (f10 (f11 f12 (- 1)) (f13 f14 (* 2 (f10 f15 (f13 f14 f9)))))) ?v_0) f1)))
(assert (= (f16 (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (= (f3 (f4 (f5 (f6 (f7 f8 (- 1)) ?v_0)) (f10 (f11 f12 (- 1)) (f13 f14 (f6 (f7 f17 (- ?v_0 1)) 2)))) ?v_0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 (f5 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (f3 (f4 (f5 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 (f5 ?v0) ?v1))) (= (= (f3 ?v_0 (- ?v2)) f1) (= (f3 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (f3 (f4 (f5 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 (f5 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 (f5 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 (f4 (f5 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f3 (f4 (f5 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f3 (f4 (f5 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f4 (f5 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S7)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (f3 (f4 (f5 (f10 (f11 f12 ?v0) ?v3)) (f10 (f11 f12 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f4 (f5 ?v3) ?v4) ?v2) f1) (= (f3 (f4 (f5 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f4 (f5 ?v3) ?v4) ?v2) f1) (= (f3 (f4 (f5 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 ?v0))) (=> (= (f3 (f4 ?v_0 ?v1) ?v2) f1) (=> (= (f3 (f4 (f5 ?v1) ?v3) ?v2) f1) (= (f3 (f4 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 ?v0))) (=> (= (f3 (f4 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f3 (f4 (f5 ?v3) ?v4) ?v2) f1) (= (f3 (f4 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (f3 (f4 (f5 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 ?v1))) (=> (< 2 ?v0) (=> (= (f3 (f4 ?v_0 (- 1)) ?v0) f1) (not (= (f3 (f4 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f4 (f5 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f16 ?v0) f1) (= (f3 (f4 (f5 (f6 (f7 f8 ?v1) ?v0)) (f10 (f11 f12 ?v1) (f13 f14 (f6 (f7 f17 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f16 ?v0) f1) (=> (= (f3 (f4 (f5 ?v1) 0) ?v0) f1) (= (f3 (f4 (f5 0) (f10 (f11 f12 ?v1) (f13 f14 (f6 (f7 f17 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S7)) (let ((?v_0 (f11 f12 ?v0))) (=> (= (f3 (f4 (f5 (f10 ?v_0 ?v1)) 1) ?v2) f1) (= (f3 (f4 (f5 (f10 ?v_0 (f13 f14 (f6 (f7 f18 (f10 f15 ?v1)) (f10 f15 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f13 f14 (+ (* 2 (f10 f15 ?v1)) 1))) (f6 (f7 f18 ?v0) (f10 (f11 f12 (f10 ?v_0 ?v1)) (f13 f14 2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f13 f14 (+ (* 2 (f10 f15 ?v1)) 1))) (f19 (f20 f22 ?v0) (f19 (f20 f21 (f19 ?v_0 ?v1)) (f13 f14 2)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 (f13 f14 (+ (* 2 (f10 f15 ?v1)) 1))) (f6 (f7 f18 ?v0) (f6 (f7 f18 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f19 ?v_0 ?v1))) (= (f19 ?v_0 (f13 f14 (+ (* 2 (f10 f15 ?v1)) 1))) (f19 (f20 f22 ?v0) (f19 (f20 f22 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 (f13 f14 (* 2 (f10 f15 ?v1)))) (f6 (f7 f18 ?v_1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f19 ?v_0 ?v1))) (= (f19 ?v_0 (f13 f14 (* 2 (f10 f15 ?v1)))) (f19 (f20 f22 ?v_1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_1 (f10 f15 ?v0)) (?v_0 (f11 f12 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f6 (f7 f17 (f10 ?v_0 ?v0)) ?v1) (f10 ?v_0 (f13 f14 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f11 f12 (- 1)))) (let ((?v_1 (f10 ?v_0 ?v1)) (?v_2 (f10 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f3 (f4 (f5 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f13 f14 (f6 (f7 f18 (f10 f15 ?v1)) (f10 f15 ?v2))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 (f7 f17 (- ?v0 1)) 2))) (= (f13 f14 (* 2 (f10 f15 (f13 f14 ?v_0)))) (f13 f14 (* 2 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 ?v1) (ite (= ?v1 (f13 f14 0)) (f13 f14 1) (f13 f14 (f6 (f7 f18 (f10 f15 ?v0)) (f10 f15 (f19 ?v_0 (f13 f14 (- (f10 f15 ?v1) 1)))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f13 f14 (f6 (f7 f18 ?v0) ?v1)) (f13 f14 (f6 (f7 f18 (f10 f15 (f13 f14 (- ?v0)))) (f10 f15 (f13 f14 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f13 f14 (f6 (f7 f18 ?v0) ?v1)) (f13 f14 (f6 (f7 f18 (f10 f15 (f13 f14 ?v0))) (f10 f15 (f13 f14 ?v1))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f6 (f7 f18 (f10 f15 ?v0)) (f10 f15 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f6 (f7 f18 (f10 f15 ?v0)) (f10 f15 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 (f7 f18 ?v0) ?v1))) (= (f13 f14 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f13 f14 (f6 (f7 f18 (f10 f15 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)))) (f10 f15 (f13 f14 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f13 f14 (f10 (f11 f12 ?v0) ?v1)) (f19 (f20 f21 (f13 f14 ?v0)) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f10 (f11 f12 (f10 f15 ?v0)) ?v1) (f10 f15 (f19 (f20 f21 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f10 f15 (f19 (f20 f21 ?v0) ?v1)) (f10 (f11 f12 (f10 f15 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f3 (f4 (f5 (f6 (f7 f18 ?v0) ?v_0)) 1) ?v1) f1) (= (f3 (f4 (f5 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (f6 (f7 f18 ?v1) ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f6 (f7 f17 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f17 ?v1))) (=> (< 0 ?v0) (= (f6 ?v_0 (f6 (f7 f18 ?v2) ?v0)) (f6 (f7 f17 (f6 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (f6 (f7 f17 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f3 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (f6 (f7 f18 ?v2) ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (f6 (f7 f18 ?v2) ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f13 f14 ?v0))) (=> (< 0 ?v0) (= (f10 ?v_0 ?v_1) (f6 (f7 f18 ?v1) (f10 ?v_0 (f13 f14 (- (f10 f15 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f13 f14 (+ (f10 f15 ?v1) (f10 f15 ?v2)))) (f6 (f7 f18 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f6 (f7 f18 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 (f5 (f6 (f7 f18 ?v0) ?v1)) (f6 (f7 f18 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 ?v3))) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (= (f3 (f4 ?v_0 (f6 (f7 f18 ?v0) ?v4)) ?v2) f1) (= (f3 (f4 ?v_0 (f6 (f7 f18 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 ?v3)) (?v_1 (f7 f18 ?v4))) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (= (f3 (f4 ?v_0 (f6 ?v_1 ?v0)) ?v2) f1) (= (f3 (f4 ?v_0 (f6 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (f3 (f4 (f5 (f6 (f7 f18 ?v0) ?v3)) (f6 (f7 f18 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f18 ?v3))) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (= (f3 (f4 (f5 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f4 (f5 ?v3) ?v4) ?v2) f1) (= (f3 (f4 (f5 (f6 (f7 f18 ?v0) ?v3)) (f6 (f7 f18 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (f6 (f7 f18 ?v2) ?v0) ?v0)) (<= (f6 (f7 f17 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (f6 (f7 f18 ?v2) ?v0)) (< (f6 (f7 f17 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (f6 (f7 f18 ?v0) (f6 (f7 f17 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 ?v1))) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f4 (f5 (f6 (f7 f18 ?v1) ?v1)) 1) ?v0) f1) (or (= (f3 (f4 ?v_0 1) ?v0) f1) (= (f3 (f4 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f4 (f5 (f6 (f7 f18 ?v1) ?v2)) 0) ?v0) f1) (or (= (f3 (f4 (f5 ?v1) 0) ?v0) f1) (= (f3 (f4 (f5 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f3 (f4 (f5 ?v1) 0) ?v0) f1)) (not (= (f3 (f4 (f5 ?v2) 0) ?v0) f1))) (not (= (f3 (f4 (f5 (f6 (f7 f18 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f3 (f4 (f5 (f6 (f7 f18 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 S7)) (= (f13 f14 (f10 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f10 f15 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f10 f15 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
