(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S3)
(declare-fun f7 () S5)
(declare-fun f8 () Int)
(declare-fun f9 (S6 Int) S1)
(declare-fun f10 () S6)
(declare-fun f11 (S7 Int) Int)
(declare-fun f12 (S8 Int) S7)
(declare-fun f13 () S8)
(declare-fun f14 () S7)
(declare-fun f15 (S9 S3) S3)
(declare-fun f16 (S10 S3) S9)
(declare-fun f17 () S10)
(declare-fun f18 (S11 Int) S6)
(declare-fun f19 () S11)
(declare-fun f20 () S8)
(declare-fun f21 (S12 S3) S1)
(declare-fun f22 (S13 S3) S12)
(declare-fun f23 () S13)
(declare-fun f24 () S2)
(declare-fun f25 (S14 S6) S1)
(declare-fun f26 (S15 Int) S14)
(declare-fun f27 () S15)
(declare-fun f28 (S16 Int) S11)
(declare-fun f29 () S16)
(declare-fun f30 () S11)
(declare-fun f31 () S8)
(declare-fun f32 () S10)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f8) 1))))))
(assert (= (f9 f10 (+ (* 4 f8) 1)) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f9 f10 ?v_0) f1) (= (f11 (f12 f13 (- 1)) ?v_0) 1)))))
(assert (= (f9 f10 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f9 f10 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f6 f7 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f4 f5 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f6 f7 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f3 (f4 f5 (f11 f14 ?v0)) ?v_0) (f3 (f4 f5 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f15 (f16 f17 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f15 (f16 f17 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) (f6 f7 2)))) (= (f11 f14 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f11 f14 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f11 f14 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f9 f10 ?v0) f1) (=> (= (f9 ?v_0 (f3 (f4 f5 ?v1) ?v2)) f1) (= (f9 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f20 ?v0))) (=> (= (f9 f10 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f11 ?v_0 (f11 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f11 (f12 f20 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f11 (f12 f20 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f11 (f12 f20 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int)) (= (= (f9 (f18 f19 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f9 (f18 f19 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f9 (f18 f19 ?v0) ?v1) f1) (=> (= (f9 (f18 f19 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f9 (f18 f19 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 (f18 f19 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 (f18 f19 ?v0) ?v1) f1) (=> (= (f9 (f18 f19 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f9 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f9 (f18 f19 ?v0) ?v1) f1) (= (f9 (f18 f19 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (= (f21 (f22 f23 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (<= (f3 f24 ?v0) (f3 f24 ?v1)) (= (f9 (f18 f19 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v2))) (=> (<= (f3 f24 ?v0) (f3 f24 ?v1)) (= (f21 (f22 f23 (f15 ?v_0 ?v0)) (f15 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f9 (f18 f19 ?v0) ?v1) f1) (=> (<= (f3 f24 ?v2) (f3 f24 ?v3)) (= (f9 (f18 f19 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (=> (<= (f3 f24 ?v2) (f3 f24 ?v3)) (= (f21 (f22 f23 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f9 (f18 f19 (f3 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f24 ?v3) (f3 f24 ?v1)) (= (f9 (f18 f19 (f3 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f21 (f22 f23 (f15 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f24 ?v3) (f3 f24 ?v1)) (= (f21 (f22 f23 (f15 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f24 ?v0)) ?v1) (f3 f24 (f15 (f16 f17 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f15 (f16 f17 (f6 f7 ?v0)) ?v1) (f6 f7 (f3 (f4 f5 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f24 (f15 (f16 f17 ?v0) ?v1)) (f3 (f4 f5 (f3 f24 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f24 ?v0)) ?v1) (f3 f24 (f15 (f16 f17 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f6 f7 (f3 (f4 f5 ?v0) ?v1)) (f15 (f16 f17 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f11 (f12 f20 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f11 (f12 f20 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f11 (f12 f20 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f9 f10 ?v0) f1) (=> (= (f9 ?v_0 (f3 (f4 f5 ?v1) ?v2)) f1) (=> (< 0 (f3 f24 ?v2)) (= (f9 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f9 f10 ?v1) f1) (= (f9 (f18 f19 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int)) (= (= (f9 f10 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f9 (f18 f19 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f9 (f18 f19 (f3 (f4 f5 ?v1) ?v0)) (f3 (f4 f5 ?v2) ?v0)) f1) (= (f9 (f18 f19 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f19 ?v1))) (=> (< 0 (f3 f24 ?v0)) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f3 (f4 f5 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f9 (f18 f19 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 ?v2) ?v1)) f1) (=> (not (= ?v1 (f6 f7 0))) (= (f9 (f18 f19 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f18 (f28 f29 ?v1) ?v0))) (=> (= (f9 f10 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f25 (f26 f27 (f11 (f12 f20 ?v0) ?v2)) ?v_1) f1) (= (f25 (f26 f27 ?v2) ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 (f28 f29 ?v1) ?v0))) (=> (= (f9 f10 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f25 (f26 f27 ?v2) ?v_0) f1) (= (f25 (f26 f27 (f11 (f12 f20 ?v0) ?v2)) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f9 (f18 f19 ?v0) ?v1) f1) (= (f9 (f18 f19 (- ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 ?v0))) (= (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (- ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f21 (f22 f23 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) f1) (=> (< 1 (f3 f24 ?v0)) (<= (f3 f24 ?v1) (f3 f24 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f24 ?v0)) (<= ?v_0 (f3 f24 (f15 (f16 f17 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (=> (< 0 (f3 f24 ?v0)) (=> (< (f3 f24 (f15 ?v_0 ?v1)) (f3 f24 (f15 ?v_0 ?v2))) (< (f3 f24 ?v1) (f3 f24 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f21 (f22 f23 (f15 (f16 f17 ?v1) ?v0)) (f15 (f16 f17 ?v2) ?v0)) f1) (= (f21 (f22 f23 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f15 (f16 f17 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f15 (f16 f17 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f24 (f15 (f16 f17 ?v0) ?v1))) (or (< 0 (f3 f24 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 f27 ?v1))) (=> (< 1 ?v0) (=> (= (f25 ?v_0 (f18 (f28 f29 (- ?v0 1)) ?v2)) f1) (= (f25 ?v_0 (f18 (f28 f29 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f25 (f26 f27 ?v0) (f18 (f28 f29 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f9 (f18 f19 (f3 f24 ?v0)) (f3 f24 ?v1)) f1) (= (f21 (f22 f23 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f21 (f22 f23 (f6 f7 ?v0)) (f6 f7 ?v1)) f1) (= (f9 (f18 f19 ?v0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f21 (f22 f23 (f6 f7 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f9 (f18 f19 ?v0) (f3 f24 ?v1)) f1) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f9 (f18 f19 (f3 f24 ?v0)) ?v1) f1) (= (f21 (f22 f23 ?v0) (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f9 (f18 f19 ?v0) (f3 f24 ?v1)) f1) (= (f21 (f22 f23 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f21 (f22 f23 ?v0) ?v1) f1) (= (f9 (f18 f19 (f3 f24 ?v0)) (f3 f24 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 f10 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f25 (f26 f27 ?v2) (f18 (f28 f29 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 f10 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f25 (f26 f27 ?v2) (f18 (f28 f29 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 f10 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f25 (f26 f27 ?v2) (f18 (f28 f29 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 f27 ?v1))) (=> (< 1 ?v0) (=> (not (= (f25 ?v_0 (f18 (f28 f29 (- ?v0 1)) ?v2)) f1)) (=> (= (f25 ?v_0 (f18 (f28 f29 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f11 (f12 f20 ?v2) ?v0)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 (f18 f19 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f9 f10 ?v0) f1) (= (f18 f30 ?v_0) (f18 (f28 f29 ?v_0) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f21 (f22 f23 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 ?v2) ?v1)) f1) (=> (not (= ?v1 (f6 f7 0))) (= (f21 (f22 f23 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (= (f25 (f26 f27 ?v0) ?v1) f1) (= (f9 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (= (f21 (f22 f23 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 ?v_0 ?v1) f1) (= (f21 ?v_0 (f15 (f16 f17 ?v1) (f6 f7 (+ (f3 f24 ?v2) 1)))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f6 f7 0))) (=> (= (f21 (f22 f23 (f15 (f16 f17 ?v1) ?v0)) ?v2) f1) (= (f21 (f22 f23 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 (+ (f3 f24 ?v1) 1)))) (= (<= (f3 f24 (f15 (f16 f17 ?v0) ?v_0)) (f3 f24 (f15 (f16 f17 ?v2) ?v_0))) (<= (f3 f24 ?v0) (f3 f24 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 (+ (f3 f24 ?v1) 1)))) (= (< (f3 f24 (f15 (f16 f17 ?v0) ?v_0)) (f3 f24 (f15 (f16 f17 ?v2) ?v_0))) (< (f3 f24 ?v0) (f3 f24 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 ?v_0 ?v1) f1) (=> (= (f21 ?v_0 (f6 f7 (+ (f3 f24 ?v1) (f3 f24 ?v2)))) f1) (= (f21 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (or (= ?v1 (f6 f7 0)) (<= (f3 f24 ?v0) (f3 f24 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 1))) (=> (= (f21 (f22 f23 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (< 0 (f3 f24 ?v0)) (=> (= (f21 (f22 f23 ?v1) ?v0) f1) (< 0 (f3 f24 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 0))) (=> (= (f21 (f22 f23 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (and (= (f21 (f22 f23 ?v0) ?v1) f1) (= (f21 (f22 f23 ?v1) ?v0) f1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 1))) (= (= (f21 (f22 f23 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 0))) (= (= (f21 (f22 f23 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 0))) (= (not (= ?v0 ?v_0)) (and (= (f21 (f22 f23 ?v0) ?v_0) f1) (not (= (f21 (f22 f23 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 1))) (= (not (= ?v0 ?v_0)) (and (= (f21 (f22 f23 ?v_0) ?v0) f1) (not (= (f21 (f22 f23 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 ?v0) (f6 f7 0)) f1)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 (f6 f7 1)) ?v0) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 1))) (not (and (= (f21 (f22 f23 ?v0) ?v_0) f1) (not (= (f21 (f22 f23 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 0))) (not (and (= (f21 (f22 f23 ?v_0) ?v0) f1) (not (= (f21 (f22 f23 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 0))) (= (= (f15 (f16 f17 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 1))) (= (= (f15 (f16 f17 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 (+ (f3 f24 ?v1) 1)))) (= (= (f15 (f16 f17 ?v0) ?v_0) (f15 (f16 f17 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 (f6 f7 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f25 (f26 f27 ?v0) (f18 f30 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f25 (f26 f27 ?v0) (f18 f30 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f25 (f26 f27 ?v1) (f18 f30 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f25 (f26 f27 ?v0) (f18 f30 ?v1)) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (= (f21 (f22 f23 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 1))) (= (= (f21 (f22 f23 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f21 (f22 f23 ?v0) ?v1) f1) (= (f21 (f22 f23 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f21 (f22 f23 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f21 (f22 f23 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f21 (f22 f23 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (= (f21 ?v_0 (f6 f7 (+ (f3 f24 ?v1) (f3 f24 ?v0)))) f1) (= (f21 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f21 (f22 f23 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f21 (f22 f23 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (and (= (f21 (f22 f23 ?v0) ?v1) f1) (not (= (f21 (f22 f23 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f21 (f22 f23 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f21 (f22 f23 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f24 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f3 f24 ?v1)) (not (= (f21 (f22 f23 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f21 (f22 f23 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (= (= (f21 (f22 f23 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f21 (f22 f23 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f21 (f22 f23 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f21 (f22 f23 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f21 (f22 f23 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f24 ?v1))) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f3 f24 ?v0) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f21 (f22 f23 ?v1) ?v2) f1) (= (f21 (f22 f23 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f21 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (=> (= (f21 (f22 f23 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (=> (= (f21 (f22 f23 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 ?v_0 ?v1) f1) (=> (= (f21 (f22 f23 ?v1) ?v2) f1) (= (f21 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 ?v_0 ?v1) f1) (=> (= (f21 ?v_0 ?v2) f1) (= (f21 ?v_0 (f6 f7 (- (f3 f24 ?v1) (f3 f24 ?v2)))) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f21 (f22 f23 ?v1) ?v2) f1) (not (= (f21 ?v_0 ?v1) f1))) (and (= (f21 (f22 f23 ?v0) ?v2) f1) (not (= (f21 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f22 f23 ?v2))) (=> (= (f21 ?v_0 ?v1) f1) (=> (and (= (f21 (f22 f23 ?v1) ?v2) f1) (not (= (f21 ?v_1 ?v1) f1))) (and (= (f21 ?v_0 ?v2) f1) (not (= (f21 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f3 f24 ?v2)) (?v_2 (f3 f24 ?v1))) (=> (= (f21 ?v_0 (f6 f7 (- ?v_2 ?v_1))) f1) (=> (= (f21 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f21 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f3 f24 ?v2)) (?v_2 (f3 f24 ?v1))) (=> (= (f21 ?v_0 (f6 f7 (- ?v_2 ?v_1))) f1) (=> (= (f21 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f21 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f21 (f22 f23 ?v0) ?v1) f1) (not (= (f21 (f22 f23 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f21 (f22 f23 ?v0) ?v1) f1)) (?v_0 (= (f21 (f22 f23 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f21 (f22 f23 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f21 (f22 f23 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f21 (f22 f23 ?v0) ?v1) f1)) (?v_0 (= (f21 (f22 f23 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f21 (f22 f23 ?v0) ?v1) f1) (not (= (f21 (f22 f23 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f21 (f22 f23 ?v0) ?v1) f1) (not (= (f21 (f22 f23 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (let ((?v_1 (= (f21 (f22 f23 ?v0) ?v1) f1)) (?v_0 (= (f21 (f22 f23 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (and (= (f21 ?v_0 ?v1) f1) (not (= (f21 (f22 f23 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f21 ?v_0 ?v2) f1) (not (= (f21 (f22 f23 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f22 f23 ?v0)) (?v_0 (f22 f23 ?v1))) (=> (and (= (f21 ?v_1 ?v1) f1) (not (= (f21 ?v_0 ?v0) f1))) (=> (= (f21 ?v_0 ?v2) f1) (and (= (f21 ?v_1 ?v2) f1) (not (= (f21 (f22 f23 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f21 (f22 f23 ?v0) ?v1) f1)) (?v_0 (= (f21 (f22 f23 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f22 f23 ?v0)) (?v_0 (f22 f23 ?v1)) (?v_2 (f22 f23 ?v2))) (=> (and (= (f21 ?v_1 ?v1) f1) (not (= (f21 ?v_0 ?v0) f1))) (=> (and (= (f21 ?v_0 ?v2) f1) (not (= (f21 ?v_2 ?v1) f1))) (and (= (f21 ?v_1 ?v2) f1) (not (= (f21 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f21 (f22 f23 ?v0) ?v1) f1)) (?v_0 (= (f21 (f22 f23 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S9) (?v1 S3) (?v2 S3)) (=> (forall ((?v3 S3)) (= (f21 (f22 f23 (f15 ?v0 ?v3)) (f15 ?v0 (f6 f7 (+ (f3 f24 ?v3) 1)))) f1)) (=> (<= (f3 f24 ?v1) (f3 f24 ?v2)) (= (f21 (f22 f23 (f15 ?v0 ?v1)) (f15 ?v0 ?v2)) f1)))))
(assert (forall ((?v0 S9) (?v1 S3) (?v2 S3)) (let ((?v_1 (f15 ?v0 ?v1)) (?v_0 (f15 ?v0 ?v2))) (=> (forall ((?v3 S3)) (let ((?v_3 (f15 ?v0 ?v3)) (?v_2 (f15 ?v0 (f6 f7 (+ (f3 f24 ?v3) 1))))) (and (= (f21 (f22 f23 ?v_3) ?v_2) f1) (not (= (f21 (f22 f23 ?v_2) ?v_3) f1))))) (= (and (= (f21 (f22 f23 ?v_1) ?v_0) f1) (not (= (f21 (f22 f23 ?v_0) ?v_1) f1))) (< (f3 f24 ?v1) (f3 f24 ?v2)))))))
(assert (forall ((?v0 S9) (?v1 S3) (?v2 S3)) (let ((?v_1 (f15 ?v0 ?v1)) (?v_0 (f15 ?v0 ?v2))) (=> (forall ((?v3 S3)) (let ((?v_3 (f15 ?v0 ?v3)) (?v_2 (f15 ?v0 (f6 f7 (+ (f3 f24 ?v3) 1))))) (and (= (f21 (f22 f23 ?v_3) ?v_2) f1) (not (= (f21 (f22 f23 ?v_2) ?v_3) f1))))) (=> (< (f3 f24 ?v1) (f3 f24 ?v2)) (and (= (f21 (f22 f23 ?v_1) ?v_0) f1) (not (= (f21 (f22 f23 ?v_0) ?v_1) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f24 (f15 (f16 f17 ?v0) ?v1))) (or (= ?v1 (f6 f7 0)) (< 0 (f3 f24 ?v0))))))
(assert (forall ((?v0 Int)) (= (f9 (f18 f19 ?v0) (ite (< ?v0 0) (- ?v0) ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (or (<= (f3 f24 ?v0) (f3 f24 ?v1)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int)) (= (f9 (f18 f19 (ite (< ?v0 0) (- ?v0) ?v0)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f18 f19 (f3 (f4 f5 ?v0) ?v2)))) (=> (= (f9 f10 ?v0) f1) (=> (not (= (f9 (f18 f19 ?v0) ?v1) f1)) (=> (= (f9 ?v_0 (f11 (f12 f31 ?v1) ?v3)) f1) (= (f9 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f18 f19 (f3 (f4 f5 ?v0) ?v2)))) (=> (= (f9 f10 ?v0) f1) (=> (not (= (f9 (f18 f19 ?v0) ?v1) f1)) (=> (= (f9 ?v_0 (f11 (f12 f31 ?v3) ?v1)) f1) (= (f9 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 f14 ?v0) (f11 f14 ?v1)) (= (f9 (f18 f19 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f19 ?v0))) (= (= (f9 ?v_0 (+ ?v1 (f11 (f12 f31 ?v0) ?v2))) f1) (= (f9 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f9 (f18 f19 (f11 (f12 f31 ?v0) ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (= (f9 ?v_0 (+ ?v2 ?v3)) f1) (= (f9 ?v_0 (+ (+ ?v2 (f11 (f12 f31 ?v4) ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f31 ?v0))) (=> (= (f9 (f18 f19 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f9 (f18 f19 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f31 ?v0))) (=> (not (= ?v0 0)) (= (= (f9 (f18 f19 ?v1) ?v2) f1) (= (f9 (f18 f19 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f3 f24 ?v1) (f3 f24 ?v2)))) (f11 (f12 f31 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f11 (f12 f31 ?v0) (f3 ?v_0 (f6 f7 2))) (f3 ?v_0 (f6 f7 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f11 (f12 f31 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f11 (f12 f31 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f11 (f12 f31 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f11 (f12 f31 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f11 (f12 f31 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f11 (f12 f31 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f12 f31 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f18 f19 ?v0) (f11 (f12 f31 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f21 (f22 f23 ?v0) (f15 (f16 f32 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f18 f19 ?v0) (f11 (f12 f31 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f21 (f22 f23 ?v0) (f15 (f16 f32 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f11 (f12 f31 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 ?v_0 ?v1) f1) (= (f21 ?v_0 (f15 (f16 f32 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f11 (f12 f31 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 ?v_0 ?v1) f1) (= (f21 ?v_0 (f15 (f16 f32 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f9 (f18 f19 ?v0) ?v1) f1) (=> (= (f9 (f18 f19 ?v2) ?v3) f1) (= (f9 (f18 f19 (f11 (f12 f31 ?v0) ?v2)) (f11 (f12 f31 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (=> (= (f21 (f22 f23 ?v2) ?v3) f1) (= (f21 (f22 f23 (f15 (f16 f32 ?v0) ?v2)) (f15 (f16 f32 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f11 (f12 f31 ?v1) ?v2)) (= (f9 (f18 f19 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 (f15 (f16 f32 ?v1) ?v2)) (= (f21 (f22 f23 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 (f18 f19 (f11 (f12 f31 ?v0) ?v1)) ?v2) f1) (= (f9 (f18 f19 ?v0) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f21 (f22 f23 (f15 (f16 f32 ?v0) ?v1)) ?v2) f1) (= (f21 (f22 f23 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 (f18 f19 (f11 (f12 f31 ?v0) ?v1)) ?v2) f1) (= (f9 (f18 f19 ?v1) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f21 (f22 f23 (f15 (f16 f32 ?v0) ?v1)) ?v2) f1) (= (f21 (f22 f23 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f11 (f12 f31 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f16 f32 ?v0))) (= (f15 (f16 f32 (f15 ?v_0 ?v1)) (f15 (f16 f32 ?v2) ?v3)) (f15 (f16 f32 (f15 ?v_0 ?v2)) (f15 (f16 f32 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f31 ?v0))) (= (f11 (f12 f31 (f11 ?v_0 ?v1)) (f11 (f12 f31 ?v2) ?v3)) (f11 (f12 f31 (f11 ?v_0 ?v2)) (f11 (f12 f31 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f16 f32 (f15 (f16 f32 ?v0) ?v1))) (?v_0 (f16 f32 ?v2))) (= (f15 ?v_1 (f15 ?v_0 ?v3)) (f15 ?v_0 (f15 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f12 f31 (f11 (f12 f31 ?v0) ?v1))) (?v_0 (f12 f31 ?v2))) (= (f11 ?v_1 (f11 ?v_0 ?v3)) (f11 ?v_0 (f11 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f16 f32 ?v0)) (?v_1 (f15 (f16 f32 ?v2) ?v3))) (= (f15 (f16 f32 (f15 ?v_0 ?v1)) ?v_1) (f15 ?v_0 (f15 (f16 f32 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f31 ?v0)) (?v_1 (f11 (f12 f31 ?v2) ?v3))) (= (f11 (f12 f31 (f11 ?v_0 ?v1)) ?v_1) (f11 ?v_0 (f11 (f12 f31 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f32 ?v0))) (= (f15 (f16 f32 (f15 ?v_0 ?v1)) ?v2) (f15 (f16 f32 (f15 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f31 ?v0))) (= (f11 (f12 f31 (f11 ?v_0 ?v1)) ?v2) (f11 (f12 f31 (f11 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f32 ?v0))) (= (f15 (f16 f32 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f32 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f31 ?v0))) (= (f11 (f12 f31 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f11 (f12 f31 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f32 ?v0))) (= (f15 ?v_0 (f15 (f16 f32 ?v1) ?v2)) (f15 (f16 f32 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f31 ?v0))) (= (f11 ?v_0 (f11 (f12 f31 ?v1) ?v2)) (f11 (f12 f31 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f16 f32 ?v0)) (?v_0 (f16 f32 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f12 f31 ?v0)) (?v_0 (f12 f31 ?v1))) (= (f11 ?v_1 (f11 ?v_0 ?v2)) (f11 ?v_0 (f11 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f15 (f16 f32 ?v0) ?v1) (f15 (f16 f32 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f31 ?v0) ?v1) (f11 (f12 f31 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 f14 (f11 (f12 f31 ?v0) ?v1)) (f11 (f12 f31 (f11 f14 ?v0)) (f11 f14 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f14 ?v0))) (= (f11 (f12 f31 ?v_0) ?v_0) (f11 (f12 f31 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 (f12 f31 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f31 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f24 ?v2))) (let ((?v_1 (f12 f31 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f11 ?v_1 ?v0) (f11 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f31 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f11 ?v_0 ?v0) (f11 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f11 (f12 f31 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f11 (f12 f31 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f31 (- ?v0 ?v1)) ?v2) (- (f11 (f12 f31 ?v0) ?v2) (f11 (f12 f31 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f31 (+ ?v0 ?v1)) ?v2) (+ (f11 (f12 f31 ?v0) ?v2) (f11 (f12 f31 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f31 ?v0))) (= (f11 (f12 f31 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f11 (f12 f31 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 (f12 f31 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f31 (- ?v0)) ?v1) (- (f11 (f12 f31 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f31 ?v0))) (= (f11 ?v_0 (- ?v1 ?v2)) (- (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f31 ?v0))) (= (f11 ?v_0 (+ ?v1 ?v2)) (+ (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f31 ?v0) ?v1) (f11 (f12 f31 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f11 (f12 f31 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f11 (f12 f31 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f12 f31 ?v1))) (= (+ (f11 (f12 f31 (- ?v0 (f11 ?v_0 ?v2))) ?v3) (f11 (f12 f31 (- ?v4 (f11 ?v_0 ?v5))) ?v6)) (- (+ (f11 (f12 f31 ?v0) ?v3) (f11 (f12 f31 ?v4) ?v6)) (f11 ?v_0 (+ (f11 (f12 f31 ?v2) ?v3) (f11 (f12 f31 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f3 f24 ?v1)) 1))) (f11 (f12 f31 ?v0) (f3 (f4 f5 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f6 f7 (+ (* 2 (f3 f24 ?v1)) 1))) (f15 (f16 f32 ?v0) (f15 (f16 f17 (f15 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f3 f24 ?v1)) 1))) (f11 (f12 f31 ?v0) (f11 (f12 f31 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 (f6 f7 (+ (* 2 (f3 f24 ?v1)) 1))) (f15 (f16 f32 ?v0) (f15 (f16 f32 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f3 f24 ?v1)))) (f11 (f12 f31 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 (f6 f7 (* 2 (f3 f24 ?v1)))) (f15 (f16 f32 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f31 ?v0) ?v0) (f3 (f4 f5 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S3)) (= (f15 (f16 f32 ?v0) ?v0) (f15 (f16 f17 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f3 f24 ?v1) 1))) (f11 (f12 f31 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f6 f7 (+ (f3 f24 ?v1) 1))) (f15 (f16 f32 ?v0) (f15 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f3 f24 ?v1) 1))) (f11 (f12 f31 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f6 f7 (+ (f3 f24 ?v1) 1))) (f15 (f16 f32 ?v0) (f15 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f3 f24 ?v1) 1))) (f11 (f12 f31 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f6 f7 (+ (f3 f24 ?v1) 1))) (f15 (f16 f32 (f15 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f6 f7 2)) (f11 (f12 f31 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f15 (f16 f17 ?v0) (f6 f7 2)) (f15 (f16 f32 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f6 f7 3)) (f11 (f12 f31 (f11 (f12 f31 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3)) (= (f15 (f16 f17 ?v0) (f6 f7 3)) (f15 (f16 f32 (f15 (f16 f32 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f11 (f12 f31 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f6 f7 (+ (f3 f24 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f32 ?v0) (f15 ?v_0 ?v1)) (f15 ?v_0 (f6 f7 (+ (f3 f24 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f3 f24 ?v1) (f3 f24 ?v2)))) (f11 (f12 f31 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f6 f7 (+ (f3 f24 ?v1) (f3 f24 ?v2)))) (f15 (f16 f32 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f11 (f12 f31 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f6 f7 (+ (f3 f24 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f32 (f15 ?v_0 ?v1)) ?v0) (f15 ?v_0 (f6 f7 (+ (f3 f24 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f11 (f12 f31 ?v_0) ?v0) (f11 (f12 f31 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f15 (f16 f17 ?v0) ?v1))) (= (f15 (f16 f32 ?v_0) ?v0) (f15 (f16 f32 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f4 f5 (f11 (f12 f31 ?v0) ?v1)) ?v2) (f11 (f12 f31 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f15 (f16 f17 (f15 (f16 f32 ?v0) ?v1)) ?v2) (f15 (f16 f32 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f4 f5 (f11 (f12 f31 ?v0) ?v1)) ?v2) (f11 (f12 f31 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f15 (f16 f17 (f15 (f16 f32 ?v0) ?v1)) ?v2) (f15 (f16 f32 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f11 (f12 f31 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f6 f7 (+ (f3 f24 ?v1) (f3 f24 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f32 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) (f15 ?v_0 (f6 f7 (+ (f3 f24 ?v1) (f3 f24 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f9 f10 ?v0) f1) (=> (= (f9 ?v_0 (f11 (f12 f31 ?v1) ?v2)) f1) (or (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f19 ?v1))) (=> (<= 0 ?v0) (=> (= (f9 f10 ?v1) f1) (=> (= (f9 ?v_0 (f11 (f12 f31 ?v0) ?v2)) f1) (or (= (f9 ?v_0 ?v0) f1) (= (f9 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int)) (= (f9 (f18 f19 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 ?v0))) (= (= (f9 ?v_0 (f11 f14 ?v1)) f1) (= (f9 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f9 (f18 f19 (f11 f14 ?v0)) ?v1) f1) (= (f9 (f18 f19 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 (f18 f19 ?v1) ?v2) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 ?v_0 ?v1) f1) (=> (= (f21 (f22 f23 ?v1) ?v2) f1) (= (f21 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 (f18 f19 ?v0) ?v1) f1) (=> (forall ((?v2 Int)) (=> (= ?v1 (f11 (f12 f31 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (=> (forall ((?v2 S3)) (=> (= ?v1 (f15 (f16 f32 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f6 f7 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f11 (f12 f31 ?v1) (f3 ?v_0 (f6 f7 (- (f3 f24 ?v_1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f3 f24 ?v0)) (?v_1 (f4 f5 ?v1))) (=> (< 0 ?v_0) (= (f11 (f12 f31 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f24 ?v0)) (?v_1 (f16 f17 ?v1))) (=> (< 0 ?v_0) (= (f15 (f16 f32 (f15 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f15 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f11 (f12 f31 (f3 f24 ?v1)) (f3 f24 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 2)) (?v_1 (f3 f24 ?v0)) (?v_2 (f3 f24 ?v1))) (= (f6 f7 (- (f3 f24 (f15 (f16 f17 ?v0) ?v_0)) (f3 f24 (f15 (f16 f17 ?v1) ?v_0)))) (f6 f7 (f11 (f12 f31 (+ ?v_1 ?v_2)) (f3 f24 (f6 f7 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f11 (f12 f31 (f3 f24 ?v0)) (f3 f24 (f15 ?v_0 (f6 f7 (- (f3 f24 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f11 (f12 f31 (f3 f24 ?v0)) (f3 f24 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f11 (f12 f31 (f3 f24 (f6 f7 ?v0))) (f3 f24 (f6 f7 ?v1)))) (f6 f7 (f11 (f12 f31 ?v0) ?v1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f24 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f11 (f12 f31 (f3 f24 ?v0)) (f3 f24 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f24 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 0)) (?v_2 (f3 f24 ?v0)) (?v_1 (f3 f24 ?v1))) (= (f6 f7 (f11 (f12 f31 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f11 (f12 f31 (f3 f24 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f24 (f6 f7 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f6 f7 (f11 (f12 f31 ?v_0) ?v_0)) (f6 f7 (+ (f11 (f12 f31 (f3 f24 (f6 f7 (- ?v0 1)))) (f3 f24 (f6 f7 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f11 (f12 f31 ?v0) ?v1)) (f6 f7 (f11 (f12 f31 (f3 f24 (f6 f7 (- ?v0)))) (f3 f24 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f12 f31 ?v0) ?v1)) (f6 f7 (f11 (f12 f31 (f3 f24 (f6 f7 ?v0))) (f3 f24 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f11 (f12 f31 (f3 f24 ?v0)) (f3 f24 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f11 (f12 f31 (f3 f24 ?v0)) (f3 f24 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f31 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f11 (f12 f31 (f3 f24 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f3 f24 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f3 f24 ?v2)) (?v_0 (f3 f24 ?v3))) (=> (= ?v0 (f6 f7 (+ (f11 (f12 f31 (f3 f24 ?v1)) ?v_1) ?v_0))) (=> (< 0 ?v_0) (=> (< ?v_0 ?v_1) (not (= (f21 (f22 f23 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f31 (f3 f24 ?v2)))) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (= (f21 (f22 f23 (f6 f7 (f11 ?v_0 (f3 f24 ?v0)))) (f6 f7 (f11 ?v_0 (f3 f24 ?v1)))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f24 ?v2))) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (= (f21 (f22 f23 (f6 f7 (f11 (f12 f31 (f3 f24 ?v0)) ?v_0))) (f6 f7 (f11 (f12 f31 (f3 f24 ?v1)) ?v_0))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (or (= ?v1 (f6 f7 0)) (or (= ?v1 ?v0) (<= (* 2 (f3 f24 ?v0)) (f3 f24 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f24 ?v1))) (= (= (f21 (f22 f23 (f6 f7 (f11 (f12 f31 (f3 f24 ?v0)) ?v_0))) (f6 f7 (f11 (f12 f31 (f3 f24 ?v2)) ?v_0))) f1) (or (= ?v1 (f6 f7 0)) (= (f21 (f22 f23 ?v0) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f6 f7 (f11 (f12 f31 (f3 f24 ?v1)) (f3 f24 ?v2)))) (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f6 f7 (f11 (f12 f31 (f3 f24 ?v1)) (f3 f24 ?v2)))) (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f3 f24 ?v1)))) (f3 (f4 f5 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f6 f7 (* 2 (f3 f24 ?v1)))) (f15 (f16 f17 (f15 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f11 (f12 f31 (f3 f24 ?v1)) (f3 f24 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f6 f7 (f11 (f12 f31 (f3 f24 ?v1)) (f3 f24 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_2 (f3 f24 ?v0)) (?v_1 (f3 f24 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f11 (f12 f31 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f24 ?v0)) (?v_2 (f3 f24 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f11 (f12 f31 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f24 ?v0)) (?v_2 (f3 f24 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f11 (f12 f31 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3)) (= (f6 f7 (f3 f24 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f24 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f24 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
