(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 () Int)
(declare-fun f5 (Int) S1)
(declare-fun f6 (S2 Int) Int)
(declare-fun f7 (S3 Int) S2)
(declare-fun f8 () S3)
(declare-fun f9 (Int Int) S1)
(declare-fun f10 (Int) S1)
(declare-fun f11 () S3)
(declare-fun f12 (S4 S5) Int)
(declare-fun f13 (S6 Int) S4)
(declare-fun f14 () S6)
(declare-fun f15 () Int)
(declare-fun f16 (S7 Int) S5)
(declare-fun f17 () S7)
(declare-fun f18 (S8 S9) Int)
(declare-fun f19 () S8)
(declare-fun f20 (Int Int) S9)
(declare-fun f21 (Int Int Int) S1)
(declare-fun f22 () Int)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 () S4)
(assert (not (= f1 f2)))
(assert (not (< f3 (+ (* 4 f4) 1))))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (= (f5 (+ (* 4 f4) 1)) f1))
(assert (= (f6 (f7 f8 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (= (f9 (+ (* 4 f4) 1) (- 1)) f1))
(assert (= (f10 (f6 (f7 f11 (+ (* 4 f4) 1)) f3)) f1))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f9 ?v_0 (- 1)) f1)) (not (= (f6 (f7 f8 (- 1)) ?v_0) 1)))))
(assert (= (+ (f12 (f13 f14 f15) (f16 f17 2)) 1) (f6 (f7 f11 (+ (* 4 f4) 1)) f3)))
(assert (= (f18 f19 (f20 f15 1)) (f6 (f7 f11 (+ (* 4 f4) 1)) f3)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 f22 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f21 f22 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 f22 ?v0 ?v_0) f1))) false))) false))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f15) (and (< f15 ?v_0) (= (f21 f22 f15 ?v_0) f1)))))
(assert (= (f21 (f12 (f13 f14 f22) (f16 f17 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f21 (f12 (f13 f14 ?v0) (f16 f17 2)) (- 1) (+ (* 4 f4) 1)) f1) false)) false))
(assert (= (f23 (+ (* 4 f4) 1) (+ (f12 (f13 f14 f15) (f16 f17 2)) 1)) f1))
(assert (= (f23 (+ (* 4 f4) 1) (- (f12 (f13 f14 f15) (f16 f17 2)) (- 1))) f1))
(assert (let ((?v_0 (f12 (f13 f14 f15) (f16 f17 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f21 (f12 (f13 f14 f15) (f16 f17 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (let ((?v_0 (f16 f17 2))) (= (f21 (f12 (f13 f14 f15) ?v_0) (f12 (f13 f14 f22) ?v_0) (+ (* 4 f4) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f12 (f13 f14 f15) (f16 f17 2)) 1) (f6 (f7 f11 (+ (* 4 f4) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f11 ?v0)) (?v_1 (f7 f11 ?v1))) (= (f6 (f7 f11 (f18 f19 (f20 ?v0 ?v1))) (f18 f19 (f20 ?v2 ?v3))) (f18 f19 (f20 (+ (f6 ?v_0 ?v2) (f6 ?v_1 ?v3)) (- (f6 ?v_0 ?v3) (f6 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (= (f10 ?v1) f1) (= (f10 (f6 (f7 f11 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f5 ?v_0) f1) (= (f6 (f7 f8 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (= (= (f10 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f18 f19 (f20 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (= (f21 (f12 (f13 f14 ?v1) (f16 f17 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v2))) (=> (= (f5 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (=> (= (f23 ?v_0 (f6 (f7 f11 ?v1) ?v3)) f1) (= (f23 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v2))) (=> (= (f5 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (=> (= (f23 ?v_0 (f6 (f7 f11 ?v3) ?v1)) f1) (= (f23 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (ite (= (f21 ?v0 0 ?v1) f1) 0 (ite (= (f9 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f9 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f21 (f12 (f13 f14 ?v2) (f16 f17 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f5 ?v0) f1) (=> (= (f23 ?v0 (f12 (f13 f14 ?v1) ?v2)) f1) (= (f23 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f5 ?v0) f1) (=> (= (f23 ?v0 (f12 (f13 f14 ?v1) ?v2)) f1) (=> (< 0 (f12 f24 ?v2)) (= (f23 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f5 ?v0) f1) (=> (= (f23 ?v0 (f6 (f7 f11 ?v1) ?v2)) f1) (or (= (f23 ?v0 ?v1) f1) (= (f23 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f5 ?v1) f1) (=> (= (f23 ?v1 (f6 (f7 f11 ?v0) ?v2)) f1) (or (= (f23 ?v1 ?v0) f1) (= (f23 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 S5)) (= (f16 f17 (f12 f24 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f24 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f24 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
