(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 () Int)
(declare-fun f5 (Int Int Int) S1)
(declare-fun f6 () Int)
(declare-fun f7 (S3 S2) Int)
(declare-fun f8 (S4 Int) S3)
(declare-fun f9 () S4)
(declare-fun f10 (S5 Int) S2)
(declare-fun f11 () S5)
(declare-fun f12 (S6 Int) Int)
(declare-fun f13 (S7 Int) S6)
(declare-fun f14 () S7)
(declare-fun f15 () Int)
(declare-fun f16 () S3)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f3) (and (< f3 ?v_0) (= (f5 f6 f3 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f7 (f8 f9 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (= (+ (f7 (f8 f9 f3) (f10 f11 2)) 1) (f12 (f13 f14 (+ (* 4 f4) 1)) f15)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f12 (f13 f14 ?v0) ?v1)) (< 0 ?v1)))))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (not (=> (< 0 ?v_0) (=> (< f15 0) (< (f12 (f13 f14 ?v_0) f15) (+ (* 0 f4) 0)))))))
(assert (forall ((?v0 S2)) (= (f10 f11 (f7 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f16 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f16 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
