(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S3)
(declare-fun f7 () S5)
(declare-fun f8 () Int)
(declare-fun f9 (Int) S1)
(declare-fun f10 () Int)
(declare-fun f11 (Int) S1)
(declare-fun f12 (S6 Int) Int)
(declare-fun f13 (S7 Int) S6)
(declare-fun f14 () S7)
(declare-fun f15 (Int Int) S1)
(declare-fun f16 (Int Int Int) S1)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () S7)
(declare-fun f20 (Int Int) S1)
(declare-fun f21 () S2)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f8) 1))))))
(assert (= (f9 (+ (* 4 f8) 1)) f1))
(assert (= f10 1))
(assert (= (f9 (+ (* 4 f8) 1)) f1))
(assert (< 0 (+ (* 4 f8) 1)))
(assert (= (f11 (+ (* 4 f8) 1)) f1))
(assert (= (f12 (f13 f14 (- 1)) (+ (* 4 f8) 1)) 1))
(assert (= (f15 (+ (* 4 f8) 1) (- 1)) f1))
(assert (< f10 (+ (* 4 f8) 1)))
(assert (<= 1 f10))
(assert (= (f16 (f3 (f4 f5 f17) (f6 f7 2)) (- 1) (+ (* 4 f8) 1)) f1))
(assert (let ((?v_0 (f3 (f4 f5 f18) (f6 f7 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f8) 1))) (=> (not (= (f15 ?v_0 (- 1)) f1)) (not (= (f12 (f13 f14 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f16 (f3 (f4 f5 ?v0) (f6 f7 2)) (- 1) (+ (* 4 f8) 1)) f1) false)) false))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (let ((?v_0 (+ (* 4 f8) 1))) (and (<= 0 f18) (and (< f18 ?v_0) (= (f16 f17 f18 ?v_0) f1)))))
(assert (= (f16 (f3 (f4 f5 f18) (f6 f7 2)) (- 1) (+ (* 4 f8) 1)) f1))
(assert (let ((?v_0 (f6 f7 2))) (= (f16 (f3 (f4 f5 f18) ?v_0) (f3 (f4 f5 f17) ?v_0) (+ (* 4 f8) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f8) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f16 f17 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f8) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f16 f17 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f16 f17 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (= (+ (f3 (f4 f5 f18) (f6 f7 2)) 1) (f12 (f13 f19 (+ (* 4 f8) 1)) f10)))
(assert (= (f11 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f11 ?v_0) f1) (= (f12 (f13 f14 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f6 f7 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f6 f7 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (= (f9 (f12 (f13 f19 (+ (* 4 f8) 1)) f10)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 ?v0) ?v1) (ite (= (f16 ?v0 0 ?v1) f1) 0 (ite (= (f15 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f16 (f3 (f4 f5 ?v2) (f6 f7 2)) ?v1 ?v0) f1)))))
(assert (= (f20 (+ (* 4 f8) 1) (- (f3 (f4 f5 f18) (f6 f7 2)) (- 1))) f1))
(assert (= (f20 (+ (* 4 f8) 1) (+ (f3 (f4 f5 f18) (f6 f7 2)) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f18) (f6 f7 2)) 1) (f12 (f13 f19 (+ (* 4 f8) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (= (f16 (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f16 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (= (f11 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (= (= (f20 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f19 ?v0) ?v1) (f12 (f13 f19 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f19 ?v0))) (= (f12 ?v_0 (+ ?v1 ?v2)) (+ (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f19 ?v0))) (= (f12 ?v_0 (- ?v1 ?v2)) (- (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 (+ ?v1 (f12 (f13 f19 ?v0) ?v2))) f1) (= (f20 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f19 (- ?v0)) ?v1) (- (f12 (f13 f19 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 (f13 f19 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f19 ?v0))) (= (f12 (f13 f19 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f19 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f12 (f13 f19 (+ ?v0 ?v1)) ?v2) (+ (f12 (f13 f19 ?v0) ?v2) (f12 (f13 f19 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f12 (f13 f19 (- ?v0 ?v1)) ?v2) (- (f12 (f13 f19 ?v0) ?v2) (f12 (f13 f19 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 ?v0) f1) (=> (= (f20 ?v0 (f12 (f13 f19 ?v1) ?v2)) f1) (or (= (f20 ?v0 ?v1) f1) (= (f20 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f20 (f12 (f13 f19 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f20 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f12 (f13 f19 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f20 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f12 (f13 f19 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f20 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1) f1) (= (= (f20 ?v0 (+ ?v2 ?v3)) f1) (= (f20 ?v0 (+ (+ ?v2 (f12 (f13 f19 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f19 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f12 ?v_0 ?v0) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f21 ?v2))) (let ((?v_1 (f13 f19 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f12 ?v_1 ?v0) (f12 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f20 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0 (- ?v1 ?v2)) f1) (=> (= (f20 ?v0 ?v2) f1) (= (f20 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 (f13 f19 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 S3)) (= (f6 f7 (f3 f21 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f21 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f21 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
