(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 (S6 Int) Int)
(declare-fun f11 (S7 Int) S6)
(declare-fun f12 () S7)
(declare-fun f13 () S2)
(declare-fun f14 () S3)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (Int) S1)
(declare-fun f22 (Int) S1)
(declare-fun f23 () S7)
(declare-fun f24 (Int Int) S1)
(declare-fun f25 () S3)
(declare-fun f26 () Int)
(declare-fun f27 (Int Int) S1)
(declare-fun f28 (Int Int Int) S1)
(declare-fun f29 (S8 S9) Int)
(declare-fun f30 () S8)
(declare-fun f31 (Int Int) S9)
(declare-fun f32 () Int)
(declare-fun f33 (S10 S3) S3)
(declare-fun f34 (S11 S3) S10)
(declare-fun f35 () S11)
(declare-fun f36 () S11)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (f11 f12 (+ 1 (f3 f13 f14))))) (not (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (f10 ?v_1 (+ (- (- (+ (* 4 f15) 1) (f10 (f11 f12 (* 2 f16)) f17)) (f10 (f11 f12 (* 2 f18)) f19)) (f10 ?v_1 (+ (f3 (f4 f5 f17) ?v_0) (f3 (f4 f5 f19) ?v_0)))))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_2 (+ 1 (f3 f13 f14)))) (let ((?v_1 (f11 f12 ?v_2)) (?v_3 (f11 f12 (f3 (f4 f5 ?v_2) ?v_0)))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (+ (- (- (f10 ?v_1 (+ (* 4 f15) 1)) (f10 ?v_1 (f10 (f11 f12 (* 2 f16)) f17))) (f10 ?v_1 (f10 (f11 f12 (* 2 f18)) f19))) (f10 ?v_3 (f3 (f4 f5 f17) ?v_0))) (f10 ?v_3 (f3 (f4 f5 f19) ?v_0)))))))
(assert (< 1 f20))
(assert (< 0 (f3 f13 f14)))
(assert (< 0 (+ 1 (f3 f13 f14))))
(assert (< 0 (+ (* 4 f15) 1)))
(assert (not (= (f21 (f10 (f11 f12 (+ (* 4 f15) 1)) (+ 1 0))) f1)))
(assert (let ((?v_1 (+ 1 (f3 f13 f14))) (?v_0 (+ (* 4 f15) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f21 (f10 (f11 f12 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (+ 1 (f3 f13 f14)))) (and (= f6 (- f16 (f10 (f11 f12 f17) ?v_0))) (<= (ite (< f6 0) (* (- 2) f6) (* 2 f6)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f13 f14)))) (and (= f9 (- f18 (f10 (f11 f12 f19) ?v_0))) (<= (ite (< f9 0) (* (- 2) f9) (* 2 f9)) ?v_0))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f18) ?v_0)) (f10 (f11 f12 (+ (* 4 f15) 1)) (+ 1 (f3 f13 f14))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_2 (+ 1 (f3 f13 f14)))) (let ((?v_1 (f11 f12 ?v_2)) (?v_3 (f11 f12 (f3 (f4 f5 ?v_2) ?v_0)))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (+ (- (- (f10 ?v_1 (+ (* 4 f15) 1)) (f10 ?v_1 (f10 (f11 f12 (* 2 f16)) f17))) (f10 ?v_1 (f10 (f11 f12 (* 2 f18)) f19))) (f10 ?v_3 (f3 (f4 f5 f17) ?v_0))) (f10 ?v_3 (f3 (f4 f5 f19) ?v_0)))))))
(assert (= (f22 (+ (* 4 f15) 1)) f1))
(assert (= (f10 (f11 f23 (- 1)) (+ (* 4 f15) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f13 f14)))) (=> (and (= ?v1 (- f16 (f10 (f11 f12 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f13 f14)))) (=> (and (= ?v1 (- f18 (f10 (f11 f12 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f10 (f11 f12 (+ (* 4 f15) 1)) (+ 1 (f3 f13 f14)))) false))) false))
(assert (let ((?v_1 (f7 f8 2)) (?v_0 (+ 1 (f3 f13 f14)))) (let ((?v_2 (f10 (f11 f12 f17) ?v_0)) (?v_3 (f10 (f11 f12 f19) ?v_0))) (= (+ (f3 (f4 f5 (- f16 ?v_2)) ?v_1) (f3 (f4 f5 (- f18 ?v_3)) ?v_1)) (+ (+ (- (- (+ (f3 (f4 f5 f16) ?v_1) (f3 (f4 f5 f18) ?v_1)) (f10 (f11 f12 (* 2 f16)) ?v_2)) (f10 (f11 f12 (* 2 f18)) ?v_3)) (f3 (f4 f5 ?v_2) ?v_1)) (f3 (f4 f5 ?v_3) ?v_1))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f13 f14)))) (let ((?v_4 (f11 f12 ?v_1)) (?v_6 (f11 f12 (* 2 f18))) (?v_5 (f11 f12 (* 2 f16))) (?v_7 (f11 f12 (f3 (f4 f5 ?v_1) ?v_0))) (?v_2 (f10 (f11 f12 f17) ?v_1)) (?v_3 (f10 (f11 f12 f19) ?v_1))) (= (+ (+ (- (- (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f18) ?v_0)) (f10 ?v_5 ?v_2)) (f10 ?v_6 ?v_3)) (f3 (f4 f5 ?v_2) ?v_0)) (f3 (f4 f5 ?v_3) ?v_0)) (+ (+ (- (- (f10 ?v_4 (+ (* 4 f15) 1)) (f10 ?v_4 (f10 ?v_5 f17))) (f10 ?v_4 (f10 ?v_6 f19))) (f10 ?v_7 (f3 (f4 f5 f17) ?v_0))) (f10 ?v_7 (f3 (f4 f5 f19) ?v_0)))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f13 f14)))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (f3 (f4 f5 (- f16 (f10 (f11 f12 f17) ?v_1))) ?v_0) (f3 (f4 f5 (- f18 (f10 (f11 f12 f19) ?v_1))) ?v_0)))))
(assert (let ((?v_1 (+ 1 (f3 f13 f14))) (?v_0 (+ (* 4 f15) 1))) (and (< ?v_1 ?v_0) (= (f21 (f10 (f11 f12 ?v_0) ?v_1)) f1))))
(assert (= (f24 (+ (* 4 f15) 1) (- 1)) f1))
(assert (= f25 (f7 f8 (- (f3 f13 (f7 f8 f20)) 1))))
(assert (< f20 (+ (* 4 f15) 1)))
(assert (= (+ (f3 (f4 f5 f26) (f7 f8 2)) 1) (f10 (f11 f12 (+ (* 4 f15) 1)) f20)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f26) (f7 f8 2)) 1) (f10 (f11 f12 (+ (* 4 f15) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f13 ?v1) (f3 f13 ?v2)))) (f10 (f11 f12 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f10 (f11 f12 ?v0) (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f10 (f11 f12 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f10 (f11 f12 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f10 (f11 f12 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f10 (f11 f12 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f10 (f11 f12 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f10 (f11 f12 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f10 (f11 f12 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (< 0 (f3 f13 f25)))
(assert (<= 1 f20))
(assert (let ((?v_0 (f3 (f4 f5 f26) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f13 (f7 f8 f20)) 1))) (=> (< 0 (f3 f13 ?v0)) false))) false))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (=> (not (= (f24 ?v_0 (- 1)) f1)) (not (= (f10 (f11 f23 (- 1)) ?v_0) 1)))))
(assert (= (f21 (f10 (f11 f12 (+ (* 4 f15) 1)) f20)) f1))
(assert (=> (= f20 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f15) 1))))))
(assert (= (f22 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f22 ?v_0) f1) (= (f10 (f11 f23 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0) f1) (=> (= (f21 ?v1) f1) (= (f21 (f10 (f11 f12 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f11 f12 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f11 f12 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f13 ?v2))) (let ((?v_1 (f11 f12 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f10 ?v_1 ?v0) (f10 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f10 (f11 f12 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f10 (f11 f12 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f12 (- ?v0 ?v1)) ?v2) (- (f10 (f11 f12 ?v0) ?v2) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f12 (+ ?v0 ?v1)) ?v2) (+ (f10 (f11 f12 ?v0) ?v2) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f11 f12 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 (- ?v0)) ?v1) (- (f10 (f11 f12 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (- ?v1 ?v2)) (- (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (+ ?v1 ?v2)) (+ (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 ?v0) ?v1) (f10 (f11 f12 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (= (f27 (+ (* 4 f15) 1) (- (f3 (f4 f5 f26) (f7 f8 2)) (- 1))) f1))
(assert (= (f27 (+ (* 4 f15) 1) (+ (f3 (f4 f5 f26) (f7 f8 2)) 1)) f1))
(assert (= (f28 (f3 (f4 f5 f26) (f7 f8 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (= (f29 f30 (f31 f26 1)) (f10 (f11 f12 (+ (* 4 f15) 1)) f20)))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (and (<= 0 f26) (and (< f26 ?v_0) (= (f28 f32 f26 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f10 (f11 f12 ?v1) (f3 ?v_0 (f7 f8 (- (f3 f13 ?v_1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f3 f13 ?v1)) (?v_1 (f3 f13 ?v0)) (?v_2 (f4 f5 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f7 f8 (- (+ ?v_0 1) ?v_1))) (f10 (f11 f12 (f3 ?v_2 (f7 f8 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f13 ?v1)) (?v_1 (f3 f13 ?v0)) (?v_2 (f34 f35 ?v2))) (=> (<= ?v_1 ?v_0) (= (f33 ?v_2 (f7 f8 (- (+ ?v_0 1) ?v_1))) (f33 (f34 f36 (f33 ?v_2 (f7 f8 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f3 f13 ?v0)) (?v_1 (f4 f5 ?v1))) (=> (< 0 ?v_0) (= (f10 (f11 f12 (f3 ?v_1 (f7 f8 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f13 ?v0)) (?v_1 (f34 f35 ?v1))) (=> (< 0 ?v_0) (= (f33 (f34 f36 (f33 ?v_1 (f7 f8 (- ?v_0 1)))) ?v1) (f33 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f10 (f11 f12 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f7 f8 (+ (f3 f13 ?v1) (f3 f13 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) (f33 ?v_0 ?v2)) (f33 ?v_0 (f7 f8 (+ (f3 f13 ?v1) (f3 f13 ?v2))))))))
(assert (= (f28 (f3 (f4 f5 f32) (f7 f8 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f28 (f3 (f4 f5 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f15) 1)) f1) false)) false))
(assert (let ((?v_0 (f7 f8 2))) (= (f28 (f3 (f4 f5 f26) ?v_0) (f3 (f4 f5 f32) ?v_0) (+ (* 4 f15) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f15) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 f32 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f28 f32 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f15) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 f32 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int)) (= (= (f27 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f27 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f27 ?v0 ?v1) f1) (=> (= (f27 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f27 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 ?v1) f1) (=> (= (f27 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 ?v0 (- ?v1 ?v2)) f1) (=> (= (f27 ?v0 ?v2) f1) (= (f27 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f7 f8 (f10 (f11 f12 (f3 f13 ?v1)) (f3 f13 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 (f34 f35 (f33 ?v_0 ?v1)) ?v2) (f33 ?v_0 (f7 f8 (f10 (f11 f12 (f3 f13 ?v1)) (f3 f13 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f28 ?v0 0 ?v1) f1)) (=> (= (f28 (f3 (f4 f5 ?v2) (f7 f8 2)) ?v0 ?v1) f1) (not (= (f27 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f10 (f11 f12 (f29 f30 (f31 ?v0 ?v1))) (f29 f30 (f31 ?v2 ?v3))) (f29 f30 (f31 (+ (f10 ?v_0 ?v2) (f10 ?v_1 ?v3)) (- (f10 ?v_0 ?v3) (f10 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f27 ?v0 (+ ?v1 (f10 (f11 f12 ?v0) ?v2))) f1) (= (f27 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f27 (f10 (f11 f12 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 ?v0 ?v1) f1) (= (= (f27 ?v0 (+ ?v2 ?v3)) f1) (= (f27 ?v0 (+ (+ ?v2 (f10 (f11 f12 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (=> (= (f27 (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f27 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f13 (f33 (f34 f35 ?v0) ?v1)) (f3 (f4 f5 (f3 f13 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f13 ?v0)) ?v1) (f3 f13 (f33 (f34 f35 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f7 f8 (f3 (f4 f5 ?v0) ?v1)) (f33 (f34 f35 (f7 f8 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f11 f12 ?v0) ?v1))) (= (f7 f8 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f7 f8 (f10 (f11 f12 (f3 f13 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)))) (f3 f13 (f7 f8 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f10 (f11 f12 (f3 f13 ?v0)) (f3 f13 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f10 (f11 f12 (f3 f13 ?v0)) (f3 f13 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f10 (f11 f12 ?v0) ?v1)) (f7 f8 (f10 (f11 f12 (f3 f13 (f7 f8 ?v0))) (f3 f13 (f7 f8 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f7 f8 (f10 (f11 f12 ?v0) ?v1)) (f7 f8 (f10 (f11 f12 (f3 f13 (f7 f8 (- ?v0)))) (f3 f13 (f7 f8 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f7 f8 (f10 (f11 f12 (f3 f13 ?v1)) (f3 f13 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f22 ?v0) f1) (=> (= (f27 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (= (f27 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f22 ?v0) f1) (=> (not (= (f27 ?v0 ?v1) f1)) (=> (= (f27 ?v_0 (f10 (f11 f12 ?v1) ?v3)) f1) (= (f27 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f22 ?v0) f1) (=> (not (= (f27 ?v0 ?v1) f1)) (=> (= (f27 ?v_0 (f10 (f11 f12 ?v3) ?v1)) f1) (= (f27 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f33 (f34 f36 ?v0) ?v1) (f33 (f34 f36 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 ?v0) ?v1) (f10 (f11 f12 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f34 f36 ?v0)) (?v_0 (f34 f36 ?v1))) (= (f33 ?v_1 (f33 ?v_0 ?v2)) (f33 ?v_0 (f33 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f10 ?v_1 (f10 ?v_0 ?v2)) (f10 ?v_0 (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f34 f36 ?v0))) (= (f33 ?v_0 (f33 (f34 f36 ?v1) ?v2)) (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2)) (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f34 f36 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v2) (f33 ?v_0 (f33 (f34 f36 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f34 f36 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v2) (f33 (f34 f36 (f33 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 (f11 f12 (f10 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f34 f36 ?v0)) (?v_1 (f33 (f34 f36 ?v2) ?v3))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v_1) (f33 ?v_0 (f33 (f34 f36 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f10 (f11 f12 ?v2) ?v3))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v_1) (f10 ?v_0 (f10 (f11 f12 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f34 f36 (f33 (f34 f36 ?v0) ?v1))) (?v_0 (f34 f36 ?v2))) (= (f33 ?v_1 (f33 ?v_0 ?v3)) (f33 ?v_0 (f33 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f11 f12 (f10 (f11 f12 ?v0) ?v1))) (?v_0 (f11 f12 ?v2))) (= (f10 ?v_1 (f10 ?v_0 ?v3)) (f10 ?v_0 (f10 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f34 f36 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) (f33 (f34 f36 ?v2) ?v3)) (f33 (f34 f36 (f33 ?v_0 ?v2)) (f33 (f34 f36 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) (f10 (f11 f12 ?v2) ?v3)) (f10 (f11 f12 (f10 ?v_0 ?v2)) (f10 (f11 f12 ?v1) ?v3))))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f33 (f34 f35 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f10 (f11 f12 ?v0) ?v0) (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 S3)) (= (f33 (f34 f36 ?v0) ?v0) (f33 (f34 f35 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f13 ?v1) 1))) (f10 (f11 f12 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f7 f8 (+ (f3 f13 ?v1) 1))) (f33 (f34 f36 ?v0) (f33 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f7 f8 (+ (* 2 (f3 f13 ?v1)) 1))) (f10 (f11 f12 ?v0) (f10 (f11 f12 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f34 f35 ?v0))) (let ((?v_1 (f33 ?v_0 ?v1))) (= (f33 ?v_0 (f7 f8 (+ (* 2 (f3 f13 ?v1)) 1))) (f33 (f34 f36 ?v0) (f33 (f34 f36 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f10 (f11 f12 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f7 f8 (+ (f3 f13 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 (f34 f36 ?v0) (f33 ?v_0 ?v1)) (f33 ?v_0 (f7 f8 (+ (f3 f13 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f7 f8 (* 2 (f3 f13 ?v1)))) (f10 (f11 f12 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f34 f35 ?v0))) (let ((?v_1 (f33 ?v_0 ?v1))) (= (f33 ?v_0 (f7 f8 (* 2 (f3 f13 ?v1)))) (f33 (f34 f36 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f10 (f11 f12 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f7 f8 (+ (f3 f13 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v0) (f33 ?v_0 (f7 f8 (+ (f3 f13 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f4 f5 (f10 (f11 f12 ?v0) ?v1)) ?v2) (f10 (f11 f12 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f33 (f34 f35 (f33 (f34 f36 ?v0) ?v1)) ?v2) (f33 (f34 f36 (f33 (f34 f35 ?v0) ?v2)) (f33 (f34 f35 ?v1) ?v2)))))
(assert (forall ((?v0 Int)) (= (= (f21 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f29 f30 (f31 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0) f1) (=> (not (= (f27 ?v0 ?v1) f1)) (= (f28 (f3 (f4 f5 ?v1) (f7 f8 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f23 ?v0) ?v1) (ite (= (f28 ?v0 0 ?v1) f1) 0 (ite (= (f24 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f24 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f28 (f3 (f4 f5 ?v2) (f7 f8 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f22 ?v0) f1) (=> (= (f27 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (=> (< 0 (f3 f13 ?v2)) (= (f27 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f13 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f13 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
