(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 () S4)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 (S6 Int) S4)
(declare-fun f11 () S6)
(declare-fun f12 () Int)
(declare-fun f13 (S7 Int) S5)
(declare-fun f14 () S7)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () S5)
(declare-fun f22 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f13 f14 2))) (not (= (f3 (f4 f5 (+ 4 (* 4 (f6 f7 f8)))) f9) (+ (* 4 (f6 (f10 f11 f12) ?v_0)) (* 4 (f6 (f10 f11 f15) ?v_0)))))))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f6 (f10 f11 f12) ?v_0) (f6 (f10 f11 f15) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f7 f8))) f9))))
(assert (< 1 f16))
(assert (< 0 (f6 f7 f8)))
(assert (< 0 (+ 1 (f6 f7 f8))))
(assert (not (< f9 (+ 1 (f6 f7 f8)))))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f6 (f10 f11 f12) ?v_0) (f6 (f10 f11 f15) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f7 f8))) f9))))
(assert (<= (- (+ 1 (f6 f7 f8)) f9) 0))
(assert (< (- (+ 2 (* 2 (f6 f7 f8))) (* 4 f9)) 0))
(assert (<= (- (+ 4 (* 4 (f6 f7 f8))) (* 4 f9)) 0))
(assert (and (<= 0 (ite (< f12 0) (* (- 2) f12) (* 2 f12))) (<= 0 (ite (< f15 0) (* (- 2) f15) (* 2 f15)))))
(assert (let ((?v_0 (f6 f7 f8))) (< (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))) 0)))
(assert (let ((?v_0 (f6 f7 f8))) (< (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))) (+ 0 (* 0 ?v_0)))))
(assert (let ((?v_0 (+ 1 (f6 f7 f8)))) (and (= f12 (- f17 (f3 (f4 f5 f18) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f6 f7 f8)))) (and (= f15 (- f19 (f3 (f4 f5 f20) ?v_0))) (<= (ite (< f15 0) (* (- 2) f15) (* 2 f15)) ?v_0))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f6 (f10 f11 f12) ?v_0) (f6 (f10 f11 f15) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f7 f8))) ?v0)) false))) false))
(assert (= f21 (f13 f14 (- (f6 f7 (f13 f14 f16)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f8)))) (=> (and (= ?v1 (- f17 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f8)))) (=> (and (= ?v1 (- f19 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f13 f14 2))) (= (f22 (+ 1 (f6 f7 f8)) (+ (f6 (f10 f11 f12) ?v_0) (f6 (f10 f11 f15) ?v_0))) f1)))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f10 f11 ?v0))) (= (f6 ?v_0 (f13 f14 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f3 (f4 f5 ?v0) (f6 ?v_0 (f13 f14 2))) (f6 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f6 (f10 f11 (+ ?v0 ?v1)) ?v_0) (+ (+ (f6 (f10 f11 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f10 f11 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f6 (f10 f11 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f10 f11 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f10 f11 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_1 (f10 f11 ?v0)) (?v_3 (f10 f11 ?v1))) (= (f6 (f10 f11 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f6 ?v_1 ?v_0) (f3 (f4 f5 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f3 (f4 f5 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_3 (f10 f11 ?v1)) (?v_1 (f10 f11 ?v0))) (= (f6 (f10 f11 (- ?v0 ?v1)) ?v_0) (- (+ (- (f6 ?v_1 ?v_0) (f3 (f4 f5 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f3 (f4 f5 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f6 (f10 f11 ?v0) ?v_0) (f6 (f10 f11 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 ?v1)) (?v_1 (f13 f14 ?v0))) (=> (< 0 ?v0) (= (f6 ?v_0 ?v_1) (f3 (f4 f5 ?v1) (f6 ?v_0 (f13 f14 (- (f6 f7 ?v_1) 1)))))))))
(assert (< 0 (f6 f7 f21)))
(assert (<= 1 f16))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f13 f14 (- (f6 f7 (f13 f14 f16)) 1))) (=> (< 0 (f6 f7 ?v0)) false))) false))
(assert (forall ((?v0 Int)) (= (= (f22 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f22 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f22 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f22 ?v0 (- ?v1 ?v2)) f1) (=> (= (f22 ?v0 ?v2) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f22 (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f22 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1) f1) (= (= (f22 ?v0 (+ ?v2 ?v3)) f1) (= (f22 ?v0 (+ (+ ?v2 (f3 (f4 f5 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f22 (f3 (f4 f5 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 (+ ?v1 (f3 (f4 f5 ?v0) ?v2))) f1) (= (f22 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f6 f7 ?v2))) (let ((?v_1 (f4 f5 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f3 ?v_1 ?v0) (f3 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f3 (f4 f5 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v2) (- (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 (- ?v0)) ?v1) (- (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (- ?v1 ?v2)) (- (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f6 (f10 f11 ?v0) (f13 f14 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (= (f6 (f10 f11 ?v0) ?v_0) (f6 (f10 f11 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2)) (?v_1 (f10 f11 ?v0))) (= (f6 (f10 f11 (f6 ?v_1 ?v_0)) ?v_0) (f6 ?v_1 (f13 f14 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 3))) (= (f6 (f10 f11 (- ?v0)) ?v_0) (- (f6 (f10 f11 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f6 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 3))) (let ((?v_0 (f6 (f10 f11 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 2))) (let ((?v_0 (f6 (f10 f11 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 (f10 f11 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f6 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S5)) (= (f13 f14 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f7 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
