(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) Int)
(declare-fun f7 (S6 Int) S5)
(declare-fun f8 () S6)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 (S7 Int) S3)
(declare-fun f14 () S7)
(declare-fun f15 () Int)
(declare-fun f16 () S2)
(declare-fun f17 () S3)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () S3)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 (Int) S1)
(declare-fun f25 (Int) S1)
(declare-fun f26 () S6)
(declare-fun f27 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 f9)) (?v_1 (f7 f8 f11)) (?v_2 (f13 f14 2)) (?v_3 (+ 1 (f3 f16 f17)))) (let ((?v_4 (f7 f8 (+ (f6 (f7 f8 f15) ?v_3) f10))) (?v_5 (f7 f8 (+ (f6 (f7 f8 f18) ?v_3) f12)))) (not (= (+ (f3 (f4 f5 (+ (f6 ?v_0 f10) (f6 ?v_1 f12))) ?v_2) (f3 (f4 f5 (- (f6 ?v_0 f12) (f6 ?v_1 f10))) ?v_2)) (+ (f3 (f4 f5 (+ (f6 ?v_4 f10) (f6 ?v_5 f12))) ?v_2) (f3 (f4 f5 (- (f6 ?v_4 f12) (f6 ?v_5 f10))) ?v_2)))))))
(assert (let ((?v_0 (+ 1 (f3 f16 f17)))) (and (= f10 (- f9 (f6 (f7 f8 f15) ?v_0))) (<= (ite (< f10 0) (* (- 2) f10) (* 2 f10)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f16 f17)))) (and (= f12 (- f11 (f6 (f7 f8 f18) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (let ((?v_1 (f7 f8 f9)) (?v_2 (f7 f8 f11)) (?v_0 (f13 f14 2))) (= (f6 (f7 f8 (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0))) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) (+ (f3 (f4 f5 (+ (f6 ?v_1 f10) (f6 ?v_2 f12))) ?v_0) (f3 (f4 f5 (- (f6 ?v_1 f12) (f6 ?v_2 f10))) ?v_0)))))
(assert (< 1 f19))
(assert (< 0 (f3 f16 f17)))
(assert (< 0 (+ 1 (f3 f16 f17))))
(assert (let ((?v_1 (f7 f8 f9)) (?v_2 (f7 f8 f11)) (?v_0 (f13 f14 2))) (= (f6 (f7 f8 (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0))) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) (+ (f3 (f4 f5 (+ (f6 ?v_1 f10) (f6 ?v_2 f12))) ?v_0) (f3 (f4 f5 (- (f6 ?v_1 f12) (f6 ?v_2 f10))) ?v_0)))))
(assert (let ((?v_0 (+ 1 (f3 f16 f17)))) (and (= f10 (- f9 (f6 (f7 f8 f15) ?v_0))) (<= (ite (< f10 0) (* (- 2) f10) (* 2 f10)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f16 f17)))) (and (= f12 (- f11 (f6 (f7 f8 f18) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (< f20 (+ 1 (f3 f16 f17))))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f16 f17))) f20))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f16 f17)))) (=> (and (= ?v1 (- f9 (f6 (f7 f8 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f16 f17)))) (=> (and (= ?v1 (- f11 (f6 (f7 f8 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f16 f17))) ?v0)) false))) false))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0)) (f6 (f7 f8 (+ (* 4 f21) 1)) (+ 1 (f3 f16 f17))))))
(assert (= f22 (f13 f14 (- (f3 f16 (f13 f14 f19)) 1))))
(assert (let ((?v_0 (f13 f14 2))) (let ((?v_1 (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)))) (= (f6 (f7 f8 (f6 (f7 f8 (+ (* 4 f21) 1)) (+ 1 (f3 f16 f17)))) ?v_1) (f6 (f7 f8 (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0))) ?v_1)))))
(assert (let ((?v_1 (f7 f8 f9)) (?v_2 (f7 f8 f11)) (?v_0 (f13 f14 2))) (= (f6 (f7 f8 (f6 (f7 f8 (+ (* 4 f21) 1)) (+ 1 (f3 f16 f17)))) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) (+ (f3 (f4 f5 (+ (f6 ?v_1 f10) (f6 ?v_2 f12))) ?v_0) (f3 (f4 f5 (- (f6 ?v_1 f12) (f6 ?v_2 f10))) ?v_0)))))
(assert (let ((?v_0 (f13 f14 2))) (= (f23 (+ 1 (f3 f16 f17)) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) f1)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f16 ?v1) (f3 f16 ?v2)))) (f6 (f7 f8 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f6 (f7 f8 ?v0) (f3 ?v_0 (f13 f14 2))) (f3 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (< 0 (f3 f16 f22)))
(assert (< 0 (+ (* 4 f21) 1)))
(assert (<= 1 f19))
(assert (not (= (f24 (f6 (f7 f8 (+ (* 4 f21) 1)) (+ 1 0))) f1)))
(assert (< f19 (+ (* 4 f21) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f13 f14 (- (f3 f16 (f13 f14 f19)) 1))) (=> (< 0 (f3 f16 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f3 f16 f17))) (?v_0 (+ (* 4 f21) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f24 (f6 (f7 f8 ?v_0) ?v_1)) f1))))))
(assert (= (f25 (+ (* 4 f21) 1)) f1))
(assert (= (f6 (f7 f26 (- 1)) (+ (* 4 f21) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f6 (f7 f8 (+ (* 4 f21) 1)) (+ 1 (f3 f16 f17)))) false))) false))
(assert (= (+ (f3 (f4 f5 f27) (f13 f14 2)) 1) (f6 (f7 f8 (+ (* 4 f21) 1)) f19)))
(assert (let ((?v_1 (+ 1 (f3 f16 f17))) (?v_0 (+ (* 4 f21) 1))) (and (< ?v_1 ?v_0) (= (f24 (f6 (f7 f8 ?v_0) ?v_1)) f1))))
(assert (= (f24 (f6 (f7 f8 (+ (* 4 f21) 1)) f19)) f1))
(assert (=> (= f19 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f21) 1))))))
(assert (forall ((?v0 Int)) (= (= (f23 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f23 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f23 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f23 ?v0 (- ?v1 ?v2)) f1) (=> (= (f23 ?v0 ?v2) f1) (= (f23 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f23 (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f23 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1) f1) (= (= (f23 ?v0 (+ ?v2 ?v3)) f1) (= (f23 ?v0 (+ (+ ?v2 (f6 (f7 f8 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f23 (f6 (f7 f8 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 (+ ?v1 (f6 (f7 f8 ?v0) ?v2))) f1) (= (f23 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f16 ?v2))) (let ((?v_1 (f7 f8 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f6 ?v_1 ?v0) (f6 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f6 (f7 f8 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v2) (- (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v2) (+ (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 (- ?v0)) ?v1) (- (f6 (f7 f8 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (- ?v1 ?v2)) (- (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (+ ?v1 ?v2)) (+ (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f13 f14 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 S3)) (= (f13 f14 (f3 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f16 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f16 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
