(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 (S5 Int) S3)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 () S3)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 (S6 Int) Int)
(declare-fun f15 (S7 Int) S6)
(declare-fun f16 () S7)
(declare-fun f17 () Int)
(declare-fun f18 () S6)
(declare-fun f19 (S8 S3) S3)
(declare-fun f20 (S9 S3) S8)
(declare-fun f21 () S9)
(declare-fun f22 (S10 Int) S8)
(declare-fun f23 () S10)
(declare-fun f24 (S11 Int) S1)
(declare-fun f25 () S11)
(declare-fun f26 () S11)
(declare-fun f27 () S7)
(declare-fun f28 () S9)
(declare-fun f29 (S12 Int) S11)
(declare-fun f30 () S12)
(declare-fun f31 () Int)
(declare-fun f32 () Int)
(declare-fun f33 () S12)
(declare-fun f34 (S13 Int) S12)
(declare-fun f35 () S13)
(declare-fun f36 (S14 S15) Int)
(declare-fun f37 () S14)
(declare-fun f38 (Int Int) S15)
(declare-fun f39 () Int)
(declare-fun f40 (S16 S3) S1)
(declare-fun f41 (S17 S3) S16)
(declare-fun f42 () S17)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (f4 f5 (+ 1 (f3 f6 f7))) (f8 f9 2)) 0))))
(assert (< 0 (+ 1 (f3 f6 f7))))
(assert (< 1 f10))
(assert (< 0 (+ 1 (f3 f6 f7))))
(assert (< 0 (f3 f6 f7)))
(assert (= f11 (f8 f9 (- (f3 f6 (f8 f9 f10)) 1))))
(assert (< f12 (+ 1 (f3 f6 f7))))
(assert (let ((?v_0 (f3 (f4 f5 f13) (f8 f9 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f8 f9 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f8 f9 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f8 f9 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f8 f9 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f8 f9 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f4 f5 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (< 0 (f3 f6 f11)))
(assert (<= 1 f10))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f8 f9 (- (f3 f6 (f8 f9 f10)) 1))) (=> (< 0 (f3 f6 ?v0)) false))) false))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f8 f9 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (+ (f3 (f4 f5 f13) (f8 f9 2)) 1) (f14 (f15 f16 (+ (* 4 f17) 1)) f10)))
(assert (< f10 (+ (* 4 f17) 1)))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 2))) (= (f3 (f4 f5 (f14 f18 ?v0)) ?v_0) (f3 (f4 f5 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f8 f9 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f19 (f20 f21 ?v0) (f8 f9 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f8 f9 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f19 (f20 f21 ?v0) (f8 f9 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) (f8 f9 2)))) (= (f14 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f14 f18 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f14 f18 ?v0)) ?v1))))
(assert (=> (= f10 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f17) 1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f19 (f22 f23 ?v0) ?v1) (f8 f9 (+ (f3 f6 (f8 f9 ?v0)) (f3 f6 ?v1))))))
(assert (< 0 (+ (* 4 f17) 1)))
(assert (not (= (f24 f25 (f14 (f15 f16 (+ (* 4 f17) 1)) (+ 1 0))) f1)))
(assert (let ((?v_1 (+ 1 (f3 f6 f7))) (?v_0 (+ (* 4 f17) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f24 f25 (f14 (f15 f16 ?v_0) ?v_1)) f1))))))
(assert (= (f24 f26 (+ (* 4 f17) 1)) f1))
(assert (= (f14 (f15 f27 (- 1)) (+ (* 4 f17) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f14 (f15 f16 (+ (* 4 f17) 1)) (+ 1 (f3 f6 f7)))) false))) false))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f13) (f8 f9 2)) 1) (f14 (f15 f16 (+ (* 4 f17) 1)) ?v0)) false)) false))
(assert (let ((?v_1 (+ 1 (f3 f6 f7))) (?v_0 (+ (* 4 f17) 1))) (and (< ?v_1 ?v_0) (= (f24 f25 (f14 (f15 f16 ?v_0) ?v_1)) f1))))
(assert (= (f24 f25 (f14 (f15 f16 (+ (* 4 f17) 1)) f10)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 (f15 f16 ?v0) ?v1) (f14 (f15 f16 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (+ ?v1 ?v2)) (+ (f14 ?v_0 ?v1) (f14 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (- ?v1 ?v2)) (- (f14 ?v_0 ?v1) (f14 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 (f15 f16 (- ?v0)) ?v1) (- (f14 (f15 f16 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 (f15 f16 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 (f15 f16 (f14 ?v_0 ?v1)) ?v2) (f14 ?v_0 (f14 (f15 f16 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f14 (f15 f16 (+ ?v0 ?v1)) ?v2) (+ (f14 (f15 f16 ?v0) ?v2) (f14 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f14 (f15 f16 (- ?v0 ?v1)) ?v2) (- (f14 (f15 f16 ?v0) ?v2) (f14 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f14 (f15 f16 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f14 (f15 f16 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f14 ?v_0 ?v0) (f14 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f6 ?v2))) (let ((?v_1 (f15 f16 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f14 ?v_1 ?v0) (f14 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 (f15 f16 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 (f15 f16 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f14 (f15 f16 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f20 f28 ?v0))) (= (f19 (f20 f28 (f19 ?v_0 ?v1)) (f19 (f20 f28 ?v2) ?v3)) (f19 (f20 f28 (f19 ?v_0 ?v2)) (f19 (f20 f28 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 (f15 f16 (f14 ?v_0 ?v1)) (f14 (f15 f16 ?v2) ?v3)) (f14 (f15 f16 (f14 ?v_0 ?v2)) (f14 (f15 f16 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f20 f28 (f19 (f20 f28 ?v0) ?v1))) (?v_0 (f20 f28 ?v2))) (= (f19 ?v_1 (f19 ?v_0 ?v3)) (f19 ?v_0 (f19 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f15 f16 (f14 (f15 f16 ?v0) ?v1))) (?v_0 (f15 f16 ?v2))) (= (f14 ?v_1 (f14 ?v_0 ?v3)) (f14 ?v_0 (f14 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f20 f28 ?v0)) (?v_1 (f19 (f20 f28 ?v2) ?v3))) (= (f19 (f20 f28 (f19 ?v_0 ?v1)) ?v_1) (f19 ?v_0 (f19 (f20 f28 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f15 f16 ?v0)) (?v_1 (f14 (f15 f16 ?v2) ?v3))) (= (f14 (f15 f16 (f14 ?v_0 ?v1)) ?v_1) (f14 ?v_0 (f14 (f15 f16 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f28 ?v0))) (= (f19 (f20 f28 (f19 ?v_0 ?v1)) ?v2) (f19 (f20 f28 (f19 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 (f15 f16 (f14 ?v_0 ?v1)) ?v2) (f14 (f15 f16 (f14 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f28 ?v0))) (= (f19 (f20 f28 (f19 ?v_0 ?v1)) ?v2) (f19 ?v_0 (f19 (f20 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 (f15 f16 (f14 ?v_0 ?v1)) ?v2) (f14 ?v_0 (f14 (f15 f16 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f8 f9 (* 2 (f3 f6 ?v1)))) (f14 (f15 f16 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f19 ?v_0 ?v1))) (= (f19 ?v_0 (f8 f9 (* 2 (f3 f6 ?v1)))) (f19 (f20 f28 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f28 ?v0))) (= (f19 ?v_0 (f19 (f20 f28 ?v1) ?v2)) (f19 (f20 f28 (f19 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f14 (f15 f16 ?v1) ?v2)) (f14 (f15 f16 (f14 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f20 f28 ?v0)) (?v_0 (f20 f28 ?v1))) (= (f19 ?v_1 (f19 ?v_0 ?v2)) (f19 ?v_0 (f19 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f15 f16 ?v0)) (?v_0 (f15 f16 ?v1))) (= (f14 ?v_1 (f14 ?v_0 ?v2)) (f14 ?v_0 (f14 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f8 f9 (+ (* 2 (f3 f6 ?v1)) 1))) (f14 (f15 f16 ?v0) (f14 (f15 f16 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f19 ?v_0 ?v1))) (= (f19 ?v_0 (f8 f9 (+ (* 2 (f3 f6 ?v1)) 1))) (f19 (f20 f28 ?v0) (f19 (f20 f28 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (* 2 (f3 f6 ?v1)) 1))) (f14 (f15 f16 ?v0) (f3 (f4 f5 (f3 ?v_0 ?v1)) (f8 f9 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f8 f9 (+ (* 2 (f3 f6 ?v1)) 1))) (f19 (f20 f28 ?v0) (f19 (f20 f21 (f19 ?v_0 ?v1)) (f8 f9 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f19 (f20 f28 ?v0) ?v1) (f19 (f20 f28 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 (f15 f16 ?v0) ?v1) (f14 (f15 f16 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (f14 (f15 f16 ?v0) ?v0) (f3 (f4 f5 ?v0) (f8 f9 2)))))
(assert (forall ((?v0 S3)) (= (f19 (f20 f28 ?v0) ?v0) (f19 (f20 f21 ?v0) (f8 f9 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (f3 f6 ?v1) 1))) (f14 (f15 f16 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f8 f9 (+ (f3 f6 ?v1) 1))) (f19 (f20 f28 ?v0) (f19 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (f3 f6 ?v1) 1))) (f14 (f15 f16 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f8 f9 (+ (f3 f6 ?v1) 1))) (f19 (f20 f28 ?v0) (f19 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (f3 f6 ?v1) 1))) (f14 (f15 f16 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f8 f9 (+ (f3 f6 ?v1) 1))) (f19 (f20 f28 (f19 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f8 f9 2)) (f14 (f15 f16 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f19 (f20 f21 ?v0) (f8 f9 2)) (f19 (f20 f28 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f8 f9 3)) (f14 (f15 f16 (f14 (f15 f16 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3)) (= (f19 (f20 f21 ?v0) (f8 f9 3)) (f19 (f20 f28 (f19 (f20 f28 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f14 (f15 f16 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f8 f9 (+ (f3 f6 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 (f20 f28 ?v0) (f19 ?v_0 ?v1)) (f19 ?v_0 (f8 f9 (+ (f3 f6 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (f3 f6 ?v1) (f3 f6 ?v2)))) (f14 (f15 f16 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f8 f9 (+ (f3 f6 ?v1) (f3 f6 ?v2)))) (f19 (f20 f28 (f19 ?v_0 ?v1)) (f19 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f14 (f15 f16 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f8 f9 (+ (f3 f6 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 (f20 f28 (f19 ?v_0 ?v1)) ?v0) (f19 ?v_0 (f8 f9 (+ (f3 f6 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f14 (f15 f16 ?v_0) ?v0) (f14 (f15 f16 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f19 (f20 f21 ?v0) ?v1))) (= (f19 (f20 f28 ?v_0) ?v0) (f19 (f20 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f4 f5 (f14 (f15 f16 ?v0) ?v1)) ?v2) (f14 (f15 f16 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f19 (f20 f21 (f19 (f20 f28 ?v0) ?v1)) ?v2) (f19 (f20 f28 (f19 (f20 f21 ?v0) ?v2)) (f19 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f4 f5 (f14 (f15 f16 ?v0) ?v1)) ?v2) (f14 (f15 f16 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f19 (f20 f21 (f19 (f20 f28 ?v0) ?v1)) ?v2) (f19 (f20 f28 (f19 (f20 f21 ?v0) ?v2)) (f19 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f14 (f15 f16 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f8 f9 (+ (f3 f6 ?v1) (f3 f6 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 (f20 f28 (f19 ?v_0 ?v1)) (f19 ?v_0 ?v2)) (f19 ?v_0 (f8 f9 (+ (f3 f6 ?v1) (f3 f6 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f6 ?v0)) ?v1) (f3 f6 (f19 (f20 f21 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f19 (f20 f21 (f8 f9 ?v0)) ?v1) (f8 f9 (f3 (f4 f5 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f6 (f19 (f20 f21 ?v0) ?v1)) (f3 (f4 f5 (f3 f6 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f6 ?v0)) ?v1) (f3 f6 (f19 (f20 f21 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f8 f9 (f3 (f4 f5 ?v0) ?v1)) (f19 (f20 f21 (f8 f9 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f8 f9 (+ (f3 f6 ?v1) (f3 f6 ?v2)))) (f14 (f15 f16 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f14 (f15 f16 ?v0) (f3 ?v_0 (f8 f9 2))) (f3 ?v_0 (f8 f9 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f14 (f15 f16 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f14 (f15 f16 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f8 f9 2)) (?v_0 (f8 f9 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f14 (f15 f16 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f14 (f15 f16 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f8 f9 2)) (?v_0 (f8 f9 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f14 (f15 f16 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f14 (f15 f16 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (f14 (f15 f16 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (= (f24 (f29 f30 (+ (* 4 f17) 1)) (- 1)) f1))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f4 f5 f31) ?v_0) (f3 (f4 f5 f32) ?v_0)) (f14 (f15 f16 (+ (* 4 f17) 1)) (+ 1 (f3 f6 f7))))))
(assert (= (f24 (f29 f33 (+ (* 4 f17) 1)) (- (f3 (f4 f5 f13) (f8 f9 2)) (- 1))) f1))
(assert (= (f24 (f29 f33 (+ (* 4 f17) 1)) (+ (f3 (f4 f5 f13) (f8 f9 2)) 1)) f1))
(assert (= (f24 (f29 (f34 f35 (f3 (f4 f5 f13) (f8 f9 2))) (- 1)) (+ (* 4 f17) 1)) f1))
(assert (= (f36 f37 (f38 f13 1)) (f14 (f15 f16 (+ (* 4 f17) 1)) f10)))
(assert (let ((?v_0 (+ (* 4 f17) 1))) (and (<= 0 f13) (and (< f13 ?v_0) (= (f24 (f29 (f34 f35 f39) f13) ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f8 f9 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f14 (f15 f16 ?v1) (f3 ?v_0 (f8 f9 (- (f3 f6 ?v_1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f3 f6 ?v0)) (?v_1 (f4 f5 ?v1))) (=> (< 0 ?v_0) (= (f14 (f15 f16 (f3 ?v_1 (f8 f9 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f6 ?v0)) (?v_1 (f20 f21 ?v1))) (=> (< 0 ?v_0) (= (f19 (f20 f28 (f19 ?v_1 (f8 f9 (- ?v_0 1)))) ?v1) (f19 ?v_1 ?v0))))))
(assert (= (f24 (f29 (f34 f35 (f3 (f4 f5 f39) (f8 f9 2))) (- 1)) (+ (* 4 f17) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f17) 1))) (=> (not (= (f24 (f29 f30 ?v_0) (- 1)) f1)) (not (= (f14 (f15 f27 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f24 (f29 (f34 f35 (f3 (f4 f5 ?v0) (f8 f9 2))) (- 1)) (+ (* 4 f17) 1)) f1) false)) false))
(assert (let ((?v_0 (f8 f9 2))) (= (f24 (f29 (f34 f35 (f3 (f4 f5 f13) ?v_0)) (f3 (f4 f5 f39) ?v_0)) (+ (* 4 f17) 1)) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f6 f7)))) (=> (and (= ?v1 (- f32 (f14 (f15 f16 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f6 f7)))) (=> (and (= ?v1 (- f31 (f14 (f15 f16 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f17) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f24 (f29 (f34 f35 f39) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f24 (f29 (f34 f35 f39) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f17) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f24 (f29 (f34 f35 f39) ?v0) ?v_0) f1))) false))) false))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f6 ?v0)) (<= ?v_0 (f3 f6 (f19 (f20 f21 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (=> (< 0 (f3 f6 ?v0)) (=> (< (f3 f6 (f19 ?v_0 ?v1)) (f3 f6 (f19 ?v_0 ?v2))) (< (f3 f6 ?v1) (f3 f6 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f24 (f29 (f34 f35 ?v0) 0) ?v1) f1)) (=> (= (f24 (f29 (f34 f35 (f3 (f4 f5 ?v2) (f8 f9 2))) ?v0) ?v1) f1) (not (= (f24 (f29 f33 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 f9 (+ 0 1)))) (= (= (f19 (f20 f21 ?v0) ?v1) ?v_0) (or (= ?v1 (f8 f9 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f6 ?v0))) (= (f8 f9 (* 2 ?v_0)) (f8 f9 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f8 f9 (+ 0 1)))) (= (f19 (f20 f21 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f6 ?v0))) (= (f8 f9 (* ?v_0 2)) (f8 f9 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 f9 0)) (?v_2 (f3 f6 ?v0)) (?v_1 (f3 f6 ?v1))) (= (f8 f9 (f14 (f15 f16 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f8 f9 (+ ?v_1 (f14 (f15 f16 (f3 f6 (f8 f9 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 ?v1) (ite (= ?v1 (f8 f9 0)) (f8 f9 1) (f8 f9 (f14 (f15 f16 (f3 f6 ?v0)) (f3 f6 (f19 ?v_0 (f8 f9 (- (f3 f6 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f6 (f19 (f20 f21 ?v0) ?v1))) (or (< 0 (f3 f6 ?v0)) (= ?v1 (f8 f9 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f29 f33 ?v0))) (=> (= (f24 f26 ?v0) f1) (=> (= (f24 ?v_0 (f3 (f4 f5 ?v1) ?v2)) f1) (= (f24 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f24 f26 ?v_0) f1) (= (f14 (f15 f27 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f24 (f29 (f34 f35 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f33 ?v0))) (=> (= (f24 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f24 ?v_0 ?v2) f1) (= (f24 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 (f29 f33 ?v0) ?v1) f1) (=> (= (f24 (f29 f33 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 (f29 f33 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f24 (f29 f33 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f24 (f29 f33 ?v0) ?v1) f1) (=> (= (f24 (f29 f33 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f24 (f29 f33 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f24 (f29 f33 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f24 f26 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f15 f16 ?v0)) (?v_1 (f15 f16 ?v1))) (= (f14 (f15 f16 (f36 f37 (f38 ?v0 ?v1))) (f36 f37 (f38 ?v2 ?v3))) (f36 f37 (f38 (+ (f14 ?v_0 ?v2) (f14 ?v_1 ?v3)) (- (f14 ?v_0 ?v3) (f14 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f29 f33 (f3 (f4 f5 ?v0) ?v2)))) (=> (= (f24 f26 ?v0) f1) (=> (not (= (f24 (f29 f33 ?v0) ?v1) f1)) (=> (= (f24 ?v_0 (f14 (f15 f16 ?v3) ?v1)) f1) (= (f24 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f29 f33 (f3 (f4 f5 ?v0) ?v2)))) (=> (= (f24 f26 ?v0) f1) (=> (not (= (f24 (f29 f33 ?v0) ?v1) f1)) (=> (= (f24 ?v_0 (f14 (f15 f16 ?v1) ?v3)) f1) (= (f24 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f24 (f29 f33 (f3 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f6 ?v3) (f3 f6 ?v1)) (= (f24 (f29 f33 (f3 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f40 (f41 f42 (f19 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f6 ?v3) (f3 f6 ?v1)) (= (f40 (f41 f42 (f19 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f24 (f29 f33 ?v0) ?v1) f1) (=> (<= (f3 f6 ?v2) (f3 f6 ?v3)) (= (f24 (f29 f33 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f40 (f41 f42 ?v0) ?v1) f1) (=> (<= (f3 f6 ?v2) (f3 f6 ?v3)) (= (f40 (f41 f42 (f19 (f20 f21 ?v0) ?v2)) (f19 (f20 f21 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (<= (f3 f6 ?v0) (f3 f6 ?v1)) (= (f24 (f29 f33 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v2))) (=> (<= (f3 f6 ?v0) (f3 f6 ?v1)) (= (f40 (f41 f42 (f19 ?v_0 ?v0)) (f19 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f24 (f29 f33 ?v0) ?v1) f1) (= (f24 (f29 f33 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f40 (f41 f42 ?v0) ?v1) f1) (= (f40 (f41 f42 (f19 (f20 f21 ?v0) ?v2)) (f19 (f20 f21 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v0))) (=> (= (f24 (f29 f33 (f14 ?v_0 ?v1)) (f14 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f24 (f29 f33 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f29 f33 ?v0))) (=> (= (f24 ?v_0 ?v1) f1) (= (= (f24 ?v_0 (+ ?v2 ?v3)) f1) (= (f24 ?v_0 (+ (+ ?v2 (f14 (f15 f16 ?v4) ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f24 (f29 f33 (f14 (f15 f16 ?v0) ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f33 ?v0))) (= (= (f24 ?v_0 (+ ?v1 (f14 (f15 f16 ?v0) ?v2))) f1) (= (f24 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f24 (f29 (f34 f35 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f8 f9 (f14 (f15 f16 (f3 f6 ?v1)) (f3 f6 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 (f20 f21 (f19 ?v_0 ?v1)) ?v2) (f19 ?v_0 (f8 f9 (f14 (f15 f16 (f3 f6 ?v1)) (f3 f6 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f8 f9 (* 2 (f3 f6 ?v1)))) (f3 (f4 f5 (f3 ?v_0 ?v1)) (f8 f9 2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f8 f9 (* 2 (f3 f6 ?v1)))) (f19 (f20 f21 (f19 ?v_0 ?v1)) (f8 f9 2))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f8 f9 (f14 (f15 f16 (f3 f6 ?v1)) (f3 f6 ?v2)))) (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f8 f9 (f14 (f15 f16 (f3 f6 ?v1)) (f3 f6 ?v2)))) (f19 (f20 f21 (f19 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f14 (f15 f16 (f3 f6 ?v0)) (f3 f6 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f8 f9 (f14 (f15 f16 (f3 f6 (f8 f9 ?v0))) (f3 f6 (f8 f9 ?v1)))) (f8 f9 (f14 (f15 f16 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f8 f9 (f14 (f15 f16 ?v0) ?v1)) (f8 f9 (f14 (f15 f16 (f3 f6 (f8 f9 (- ?v0)))) (f3 f6 (f8 f9 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f14 (f15 f16 ?v0) ?v1)) (f8 f9 (f14 (f15 f16 (f3 f6 (f8 f9 ?v0))) (f3 f6 (f8 f9 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f14 (f15 f16 (f3 f6 ?v0)) (f3 f6 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f14 (f15 f16 (f3 f6 ?v0)) (f3 f6 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 (f15 f16 ?v0) ?v1))) (= (f8 f9 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f8 f9 (f14 (f15 f16 (f3 f6 (f8 f9 (ite (< ?v0 0) (- ?v0) ?v0)))) (f3 f6 (f8 f9 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f8 f9 (f14 (f15 f16 (f3 f6 ?v1)) (f3 f6 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 f25 ?v0) f1) (=> (= (f24 f25 ?v1) f1) (= (f24 f25 (f14 (f15 f16 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f24 f25 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f36 f37 (f38 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 f26 ?v0) f1) (=> (not (= (f24 (f29 f33 ?v0) ?v1) f1)) (= (f24 (f29 (f34 f35 (f3 (f4 f5 ?v1) (f8 f9 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 (f15 f27 ?v0) ?v1) (ite (= (f24 (f29 (f34 f35 ?v0) 0) ?v1) f1) 0 (ite (= (f24 (f29 f30 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f24 (f29 f30 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f24 (f29 (f34 f35 (f3 (f4 f5 ?v2) (f8 f9 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f29 f33 ?v0))) (=> (= (f24 f26 ?v0) f1) (=> (= (f24 ?v_0 (f3 (f4 f5 ?v1) ?v2)) f1) (=> (< 0 (f3 f6 ?v2)) (= (f24 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f40 (f41 f42 ?v0) ?v1) f1) (= (f24 (f29 f33 (f3 f6 ?v0)) (f3 f6 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f24 (f29 f33 ?v0) (f3 f6 ?v1)) f1) (= (f40 (f41 f42 (f8 f9 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f24 (f29 f33 (f3 f6 ?v0)) ?v1) f1) (= (f40 (f41 f42 ?v0) (f8 f9 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f40 (f41 f42 (f8 f9 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f24 (f29 f33 ?v0) (f3 f6 ?v1)) f1) (= ?v1 (f8 f9 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f24 (f29 f33 (f3 f6 ?v0)) (f3 f6 ?v1)) f1) (= (f40 (f41 f42 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f40 (f41 f42 (f8 f9 ?v0)) (f8 f9 ?v1)) f1) (= (f24 (f29 f33 ?v0) ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f40 (f41 f42 (f19 ?v_0 ?v1)) (f19 ?v_0 ?v2)) f1) (=> (< 1 (f3 f6 ?v0)) (<= (f3 f6 ?v1) (f3 f6 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f34 f35 ?v0))) (=> (= (f24 (f29 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f24 (f29 (f34 f35 ?v3) ?v4) ?v2) f1) (= (f24 (f29 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (= (f24 (f29 (f34 f35 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f34 f35 ?v1))) (=> (< 2 ?v0) (=> (= (f24 (f29 ?v_0 (- 1)) ?v0) f1) (not (= (f24 (f29 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f24 (f29 (f34 f35 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f24 (f29 (f34 f35 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f24 (f29 (f34 f35 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 (f29 f33 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f34 f35 ?v3))) (=> (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (= (= (f24 (f29 ?v_0 (f14 (f15 f16 ?v0) ?v4)) ?v2) f1) (= (f24 (f29 ?v_0 (f14 (f15 f16 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f34 f35 ?v3)) (?v_1 (f15 f16 ?v4))) (=> (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (= (= (f24 (f29 ?v_0 (f14 ?v_1 ?v0)) ?v2) f1) (= (f24 (f29 ?v_0 (f14 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (= (f24 (f29 (f34 f35 (f3 (f4 f5 ?v0) ?v3)) (f3 (f4 f5 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f33 ?v1))) (=> (< 0 (f3 f6 ?v0)) (=> (= (f24 ?v_0 ?v2) f1) (= (f24 ?v_0 (f3 (f4 f5 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f24 (f29 (f34 f35 ?v0) 0) ?v1) f1) (= (f24 (f29 f33 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f24 (f29 (f34 f35 ?v0) 0) ?v1) f1) (= (f24 (f29 f33 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 f26 ?v0) f1) (=> (not (= (f24 (f29 (f34 f35 ?v1) 0) ?v0) f1)) (=> (not (= (f24 (f29 (f34 f35 ?v2) 0) ?v0) f1)) (not (= (f24 (f29 (f34 f35 (f14 (f15 f16 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 f26 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f24 (f29 (f34 f35 ?v1) 0) ?v0) f1)) (not (= (f24 (f29 (f34 f35 ?v2) 0) ?v0) f1))) (not (= (f24 (f29 (f34 f35 (f14 (f15 f16 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 f26 ?v0) f1) (=> (< 0 ?v1) (=> (= (f24 (f29 (f34 f35 (f14 (f15 f16 ?v1) ?v2)) 0) ?v0) f1) (or (= (f24 (f29 (f34 f35 ?v1) 0) ?v0) f1) (= (f24 (f29 (f34 f35 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f33 ?v0))) (=> (= (f24 f26 ?v0) f1) (=> (= (f24 ?v_0 (f14 (f15 f16 ?v1) ?v2)) f1) (or (= (f24 ?v_0 ?v1) f1) (= (f24 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f33 ?v1))) (=> (<= 0 ?v0) (=> (= (f24 f26 ?v1) f1) (=> (= (f24 ?v_0 (f14 (f15 f16 ?v0) ?v2)) f1) (or (= (f24 ?v_0 ?v0) f1) (= (f24 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 f26 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f24 (f29 (f34 f35 (f14 (f15 f16 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f34 f35 ?v1))) (=> (= (f24 f26 ?v0) f1) (=> (< 0 ?v1) (=> (= (f24 (f29 (f34 f35 (f14 (f15 f16 ?v1) ?v1)) 1) ?v0) f1) (or (= (f24 (f29 ?v_0 1) ?v0) f1) (= (f24 (f29 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f15 f16 ?v1))) (= (+ (f14 (f15 f16 (- ?v0 (f14 ?v_0 ?v2))) ?v3) (f14 (f15 f16 (- ?v4 (f14 ?v_0 ?v5))) ?v6)) (- (+ (f14 (f15 f16 ?v0) ?v3) (f14 (f15 f16 ?v4) ?v6)) (f14 ?v_0 (+ (f14 (f15 f16 ?v2) ?v3) (f14 (f15 f16 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f24 (f29 (f34 f35 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (= (f24 (f29 (f34 f35 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 (f34 f35 ?v0) ?v1))) (= (= (f24 ?v_0 (- ?v2)) f1) (= (f24 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f24 (f29 (f34 f35 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f24 (f29 (f34 f35 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f24 (f29 (f34 f35 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f24 (f29 (f34 f35 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f24 (f29 (f34 f35 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f34 f35 ?v0))) (=> (= (f24 (f29 ?v_0 ?v1) ?v2) f1) (=> (= (f24 (f29 (f34 f35 ?v1) ?v3) ?v2) f1) (= (f24 (f29 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (=> (= (f24 (f29 (f34 f35 ?v3) ?v4) ?v2) f1) (= (f24 (f29 (f34 f35 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (=> (= (f24 (f29 (f34 f35 ?v3) ?v4) ?v2) f1) (= (f24 (f29 (f34 f35 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (=> (= (f24 (f29 (f34 f35 ?v3) ?v4) ?v2) f1) (= (f24 (f29 (f34 f35 (f14 (f15 f16 ?v0) ?v3)) (f14 (f15 f16 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f15 f16 ?v3))) (=> (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (= (f24 (f29 (f34 f35 (f14 ?v_0 ?v0)) (f14 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (= (f24 (f29 (f34 f35 (f14 (f15 f16 ?v0) ?v3)) (f14 (f15 f16 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f24 (f29 (f34 f35 (f14 (f15 f16 ?v0) ?v1)) (f14 (f15 f16 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f14 (f15 f16 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f24 (f29 (f34 f35 ?v0) ?v1) ?v2) f1) (= (f24 (f29 f33 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int)) (= (= (f24 f26 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f24 (f29 f33 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f24 (f29 (f34 f35 (f3 ?v_0 ?v1)) 1) ?v2) f1) (= (f24 (f29 (f34 f35 (f3 ?v_0 (f8 f9 (f14 (f15 f16 (f3 f6 ?v1)) (f3 f6 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f24 f26 ?v1) f1) (= (f24 (f29 f33 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f6 (f8 f9 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f8 f9 (f14 (f15 f16 ?v_0) ?v_0)) (f8 f9 (+ (f14 (f15 f16 (f3 f6 (f8 f9 (- ?v0 1)))) (f3 f6 (f8 f9 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int)) (=> (= (f24 f26 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f24 (f29 (f34 f35 (f14 (f15 f16 ?v0) ?v_0)) 1) ?v1) f1) (= (f24 (f29 (f34 f35 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 S3)) (= (f40 (f41 f42 (f8 f9 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f40 (f41 f42 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (= (f40 (f41 f42 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f8 f9 1))) (= (= (f40 (f41 f42 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f40 (f41 f42 ?v0) ?v1) f1) (= (f40 (f41 f42 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f40 (f41 f42 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f40 (f41 f42 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f8 f9 (+ 0 1)))) (= (= (f40 (f41 f42 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f41 f42 ?v0))) (= (= (f40 ?v_0 (f8 f9 (+ (f3 f6 ?v1) (f3 f6 ?v0)))) f1) (= (f40 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f40 (f41 f42 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f40 (f41 f42 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (and (= (f40 (f41 f42 ?v0) ?v1) f1) (not (= (f40 (f41 f42 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f40 (f41 f42 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f40 (f41 f42 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f6 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f3 f6 ?v1)) (not (= (f40 (f41 f42 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f40 (f41 f42 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f40 (f41 f42 ?v0) ?v1) f1) (= (= (f40 (f41 f42 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f40 (f41 f42 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f40 (f41 f42 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f40 (f41 f42 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f40 (f41 f42 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f6 ?v1))) (=> (= (f40 (f41 f42 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f3 f6 ?v0) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f40 (f41 f42 ?v1) ?v2) f1) (= (f40 (f41 f42 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0))) (=> (= (f40 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f40 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f40 (f41 f42 ?v0) ?v1) f1) (=> (= (f40 (f41 f42 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f40 (f41 f42 ?v0) ?v1) f1) (=> (= (f40 (f41 f42 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0))) (=> (= (f40 ?v_0 ?v1) f1) (=> (= (f40 (f41 f42 ?v1) ?v2) f1) (= (f40 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0))) (=> (= (f40 ?v_0 ?v1) f1) (=> (= (f40 ?v_0 ?v2) f1) (= (f40 ?v_0 (f8 f9 (- (f3 f6 ?v1) (f3 f6 ?v2)))) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f40 (f41 f42 ?v1) ?v2) f1) (not (= (f40 ?v_0 ?v1) f1))) (and (= (f40 (f41 f42 ?v0) ?v2) f1) (not (= (f40 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0)) (?v_1 (f41 f42 ?v2))) (=> (= (f40 ?v_0 ?v1) f1) (=> (and (= (f40 (f41 f42 ?v1) ?v2) f1) (not (= (f40 ?v_1 ?v1) f1))) (and (= (f40 ?v_0 ?v2) f1) (not (= (f40 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0)) (?v_1 (f3 f6 ?v2)) (?v_2 (f3 f6 ?v1))) (=> (= (f40 ?v_0 (f8 f9 (- ?v_2 ?v_1))) f1) (=> (= (f40 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f40 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0)) (?v_1 (f3 f6 ?v2)) (?v_2 (f3 f6 ?v1))) (=> (= (f40 ?v_0 (f8 f9 (- ?v_2 ?v_1))) f1) (=> (= (f40 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f40 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f40 (f41 f42 ?v0) ?v1) f1) (not (= (f40 (f41 f42 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f40 (f41 f42 ?v0) ?v1) f1)) (?v_0 (= (f40 (f41 f42 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f40 (f41 f42 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f40 (f41 f42 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f40 (f41 f42 ?v0) ?v1) f1)) (?v_0 (= (f40 (f41 f42 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f40 (f41 f42 ?v0) ?v1) f1) (not (= (f40 (f41 f42 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f40 (f41 f42 ?v0) ?v1) f1) (not (= (f40 (f41 f42 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (let ((?v_1 (= (f40 (f41 f42 ?v0) ?v1) f1)) (?v_0 (= (f40 (f41 f42 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0))) (=> (and (= (f40 ?v_0 ?v1) f1) (not (= (f40 (f41 f42 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f40 ?v_0 ?v2) f1) (not (= (f40 (f41 f42 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f41 f42 ?v0)) (?v_0 (f41 f42 ?v1))) (=> (and (= (f40 ?v_1 ?v1) f1) (not (= (f40 ?v_0 ?v0) f1))) (=> (= (f40 ?v_0 ?v2) f1) (and (= (f40 ?v_1 ?v2) f1) (not (= (f40 (f41 f42 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f40 (f41 f42 ?v0) ?v1) f1)) (?v_0 (= (f40 (f41 f42 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f41 f42 ?v0)) (?v_0 (f41 f42 ?v1)) (?v_2 (f41 f42 ?v2))) (=> (and (= (f40 ?v_1 ?v1) f1) (not (= (f40 ?v_0 ?v0) f1))) (=> (and (= (f40 ?v_0 ?v2) f1) (not (= (f40 ?v_2 ?v1) f1))) (and (= (f40 ?v_1 ?v2) f1) (not (= (f40 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f40 (f41 f42 ?v0) ?v1) f1)) (?v_0 (= (f40 (f41 f42 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_2 (f3 f6 ?v0)) (?v_1 (f3 f6 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f14 (f15 f16 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f6 ?v0)) (?v_2 (f3 f6 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f14 (f15 f16 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f6 ?v0)) (?v_2 (f3 f6 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f14 (f15 f16 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3)) (= (f8 f9 (f3 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f6 (f8 f9 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f6 (f8 f9 ?v0)) 0))))
(check-sat)
(exit)
