(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) Int)
(declare-fun f7 (S6 Int) S5)
(declare-fun f8 () S6)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 (S7 Int) S3)
(declare-fun f15 () S7)
(declare-fun f16 () Int)
(declare-fun f17 () S2)
(declare-fun f18 () S3)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(declare-fun f21 (Int) S1)
(declare-fun f22 () S6)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 (Int Int) S1)
(declare-fun f26 () S3)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(declare-fun f33 () Int)
(declare-fun f34 (S10 S3) S3)
(declare-fun f35 (S11 S3) S10)
(declare-fun f36 () S11)
(declare-fun f37 () S11)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 f9)) (?v_1 (f7 f8 f11)) (?v_2 (f14 f15 2))) (not (= (+ (f3 (f4 f5 (+ (+ (f6 ?v_0 f10) (f6 ?v_1 f12)) f13)) ?v_2) (f3 (f4 f5 (- (f6 ?v_0 f12) (f6 ?v_1 f10))) ?v_2)) (f6 (f7 f8 (+ (* 4 f16) 1)) f13)))))
(assert (let ((?v_1 (f7 f8 f9)) (?v_2 (f7 f8 f11)) (?v_0 (f14 f15 2))) (= (f6 (f7 f8 (f3 (f4 f5 (+ 1 (f3 f17 f18))) ?v_0)) (- (- (f6 (f7 f8 (+ (* 4 f16) 1)) f13) (f3 (f4 f5 (+ (+ (f6 ?v_1 f10) (f6 ?v_2 f12)) f13)) ?v_0)) (f3 (f4 f5 (- (f6 ?v_1 f12) (f6 ?v_2 f10))) ?v_0))) 0)))
(assert (not (= (f3 (f4 f5 (+ 1 (f3 f17 f18))) (f14 f15 2)) 0)))
(assert (< 1 f19))
(assert (not (= (f3 (f4 f5 (+ 1 (f3 f17 f18))) (f14 f15 2)) 0)))
(assert (< 0 (+ 1 (f3 f17 f18))))
(assert (< 0 (+ (* 4 f16) 1)))
(assert (not (= (f20 (f6 (f7 f8 (+ (* 4 f16) 1)) (+ 1 0))) f1)))
(assert (< f13 (+ 1 (f3 f17 f18))))
(assert (let ((?v_0 (f14 f15 2))) (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f17 f18))) f13))))
(assert (let ((?v_0 (+ (* 4 f16) 1)) (?v_1 (+ 1 (f3 f17 f18)))) (not (=> (< ?v_1 ?v_0) (not (= (f20 (f6 (f7 f8 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_1 (f7 f8 f9)) (?v_2 (f7 f8 f11)) (?v_0 (f14 f15 2))) (= (f6 (f7 f8 (f3 (f4 f5 (+ 1 (f3 f17 f18))) ?v_0)) (- (- (f6 (f7 f8 (+ (* 4 f16) 1)) f13) (f3 (f4 f5 (+ (+ (f6 ?v_1 f10) (f6 ?v_2 f12)) f13)) ?v_0)) (f3 (f4 f5 (- (f6 ?v_1 f12) (f6 ?v_2 f10))) ?v_0))) 0)))
(assert (= (f21 (+ (* 4 f16) 1)) f1))
(assert (= (f6 (f7 f22 (- 1)) (+ (* 4 f16) 1)) 1))
(assert (let ((?v_4 (f7 f8 f9)) (?v_6 (f7 f8 f11)) (?v_3 (f14 f15 2)) (?v_0 (+ 1 (f3 f17 f18)))) (let ((?v_5 (f7 f8 ?v_0)) (?v_1 (f7 f8 (+ (f6 ?v_4 ?v_0) f10))) (?v_2 (f7 f8 (+ (f6 ?v_6 ?v_0) f12)))) (= (+ (f3 (f4 f5 (+ (f6 ?v_1 f10) (f6 ?v_2 f12))) ?v_3) (f3 (f4 f5 (- (f6 ?v_1 f12) (f6 ?v_2 f10))) ?v_3)) (+ (f3 (f4 f5 (+ (+ (f6 ?v_5 (f6 ?v_4 f10)) (f6 ?v_5 (f6 ?v_6 f12))) (+ (f3 (f4 f5 f10) ?v_3) (f3 (f4 f5 f12) ?v_3)))) ?v_3) (f3 (f4 f5 (- (f6 ?v_5 (f6 ?v_4 f12)) (f6 ?v_5 (f6 ?v_6 f10)))) ?v_3))))))
(assert (let ((?v_2 (f7 f8 f9)) (?v_3 (f7 f8 f11)) (?v_1 (f14 f15 2)) (?v_0 (f7 f8 (+ 1 (f3 f17 f18))))) (let ((?v_4 (+ (f6 ?v_0 (f6 ?v_2 f10)) (f6 ?v_0 (f6 ?v_3 f12)))) (?v_5 (f3 (f4 f5 (- (f6 ?v_0 (f6 ?v_2 f12)) (f6 ?v_0 (f6 ?v_3 f10)))) ?v_1))) (= (+ (f3 (f4 f5 (+ ?v_4 (+ (f3 (f4 f5 f10) ?v_1) (f3 (f4 f5 f12) ?v_1)))) ?v_1) ?v_5) (+ (f3 (f4 f5 (+ ?v_4 (f6 ?v_0 f13))) ?v_1) ?v_5)))))
(assert (let ((?v_2 (f7 f8 f9)) (?v_3 (f7 f8 f11)) (?v_1 (f14 f15 2))) (let ((?v_0 (f7 f8 (f3 (f4 f5 (+ 1 (f3 f17 f18))) ?v_1)))) (= (f6 ?v_0 (f6 (f7 f8 (+ (* 4 f16) 1)) f13)) (f6 ?v_0 (+ (f3 (f4 f5 (+ (+ (f6 ?v_2 f10) (f6 ?v_3 f12)) f13)) ?v_1) (f3 (f4 f5 (- (f6 ?v_2 f12) (f6 ?v_3 f10))) ?v_1)))))))
(assert (let ((?v_3 (f7 f8 f9)) (?v_4 (f7 f8 f11)) (?v_0 (f14 f15 2)) (?v_1 (+ 1 (f3 f17 f18)))) (let ((?v_2 (f7 f8 (f3 (f4 f5 ?v_1) ?v_0)))) (= (f6 (f7 f8 (f6 (f7 f8 (+ (* 4 f16) 1)) ?v_1)) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) (+ (f6 ?v_2 (f3 (f4 f5 (+ (+ (f6 ?v_3 f10) (f6 ?v_4 f12)) f13)) ?v_0)) (f6 ?v_2 (f3 (f4 f5 (- (f6 ?v_3 f12) (f6 ?v_4 f10))) ?v_0)))))))
(assert (let ((?v_3 (f7 f8 f9)) (?v_4 (f7 f8 f11)) (?v_0 (f14 f15 2)) (?v_1 (+ 1 (f3 f17 f18)))) (let ((?v_2 (f7 f8 ?v_1))) (= (f6 (f7 f8 (f6 (f7 f8 (+ (* 4 f16) 1)) ?v_1)) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) (+ (f3 (f4 f5 (+ (+ (f6 ?v_2 (f6 ?v_3 f10)) (f6 ?v_2 (f6 ?v_4 f12))) (f6 ?v_2 f13))) ?v_0) (f3 (f4 f5 (- (f6 ?v_2 (f6 ?v_3 f12)) (f6 ?v_2 (f6 ?v_4 f10)))) ?v_0))))))
(assert (let ((?v_0 (+ 1 (f3 f17 f18)))) (and (= f10 (- f23 (f6 (f7 f8 f9) ?v_0))) (<= (ite (< f10 0) (* (- 2) f10) (* 2 f10)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f17 f18)))) (and (= f12 (- f24 (f6 (f7 f8 f11) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f14 f15 2))) (=> (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f17 f18))) ?v0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f6 (f7 f8 (+ (* 4 f16) 1)) (+ 1 (f3 f17 f18)))) false))) false))
(assert (= (f25 (+ (* 4 f16) 1) (- 1)) f1))
(assert (= f26 (f14 f15 (- (f3 f17 (f14 f15 f19)) 1))))
(assert (let ((?v_0 (+ (* 4 f16) 1)) (?v_1 (+ 1 (f3 f17 f18)))) (and (< ?v_1 ?v_0) (= (f20 (f6 (f7 f8 ?v_0) ?v_1)) f1))))
(assert (< f19 (+ (* 4 f16) 1)))
(assert (= (+ (f3 (f4 f5 f27) (f14 f15 2)) 1) (f6 (f7 f8 (+ (* 4 f16) 1)) f19)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f27) (f14 f15 2)) 1) (f6 (f7 f8 (+ (* 4 f16) 1)) ?v0)) false)) false))
(assert (let ((?v_2 (f14 f15 2)) (?v_3 (+ 1 (f3 f17 f18)))) (let ((?v_4 (f7 f8 (+ (f6 (f7 f8 f9) ?v_3) f10))) (?v_5 (f7 f8 (+ (f6 (f7 f8 f11) ?v_3) f12))) (?v_0 (f7 f8 f23)) (?v_1 (f7 f8 f24))) (= (+ (f3 (f4 f5 (+ (f6 ?v_0 f10) (f6 ?v_1 f12))) ?v_2) (f3 (f4 f5 (- (f6 ?v_0 f12) (f6 ?v_1 f10))) ?v_2)) (+ (f3 (f4 f5 (+ (f6 ?v_4 f10) (f6 ?v_5 f12))) ?v_2) (f3 (f4 f5 (- (f6 ?v_4 f12) (f6 ?v_5 f10))) ?v_2))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f14 f15 (+ (f3 f17 ?v1) (f3 f17 ?v2)))) (f6 (f7 f8 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f6 (f7 f8 ?v0) (f3 ?v_0 (f14 f15 2))) (f3 ?v_0 (f14 f15 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (< 0 (f3 f17 f18)))
(assert (< 0 (f3 f17 f26)))
(assert (<= 1 f19))
(assert (let ((?v_0 (f3 (f4 f5 f27) (f14 f15 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f14 f15 (- (f3 f17 (f14 f15 f19)) 1))) (=> (< 0 (f3 f17 ?v0)) false))) false))
(assert (let ((?v_0 (+ (* 4 f16) 1))) (=> (not (= (f25 ?v_0 (- 1)) f1)) (not (= (f6 (f7 f22 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (f14 f15 2))) (= (+ (f3 (f4 f5 f23) ?v_0) (f3 (f4 f5 f24) ?v_0)) (f6 (f7 f8 (+ (* 4 f16) 1)) (+ 1 (f3 f17 f18))))))
(assert (= (f20 (f6 (f7 f8 (+ (* 4 f16) 1)) f19)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f17 f18)))) (=> (and (= ?v1 (- f24 (f6 (f7 f8 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f17 f18)))) (=> (and (= ?v1 (- f23 (f6 (f7 f8 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f14 f15 2)) (?v_1 (f7 f8 f23)) (?v_2 (f7 f8 f24))) (= (f6 (f7 f8 (+ (f3 (f4 f5 f23) ?v_0) (f3 (f4 f5 f24) ?v_0))) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) (+ (f3 (f4 f5 (+ (f6 ?v_1 f10) (f6 ?v_2 f12))) ?v_0) (f3 (f4 f5 (- (f6 ?v_1 f12) (f6 ?v_2 f10))) ?v_0)))))
(assert (let ((?v_0 (f14 f15 2))) (let ((?v_1 (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)))) (= (f6 (f7 f8 (f6 (f7 f8 (+ (* 4 f16) 1)) (+ 1 (f3 f17 f18)))) ?v_1) (f6 (f7 f8 (+ (f3 (f4 f5 f23) ?v_0) (f3 (f4 f5 f24) ?v_0))) ?v_1)))))
(assert (=> (= f19 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f16) 1))))))
(assert (= (f21 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f21 ?v_0) f1) (= (f6 (f7 f22 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (= (f20 ?v1) f1) (= (f20 (f6 (f7 f8 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f17 ?v2))) (let ((?v_1 (f7 f8 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f6 ?v_1 ?v0) (f6 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f6 (f7 f8 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v2) (- (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v2) (+ (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 (- ?v0)) ?v1) (- (f6 (f7 f8 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (- ?v1 ?v2)) (- (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (+ ?v1 ?v2)) (+ (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f14 f15 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f14 f15 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f14 f15 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f14 f15 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f14 f15 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f14 f15 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f14 f15 2)) (?v_0 (f14 f15 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f14 f15 2)) (?v_0 (f14 f15 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (let ((?v_0 (f14 f15 2))) (= (f28 (+ 1 (f3 f17 f18)) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) f1)))
(assert (= (f28 (+ (* 4 f16) 1) (- (f3 (f4 f5 f27) (f14 f15 2)) (- 1))) f1))
(assert (= (f28 (+ (* 4 f16) 1) (+ (f3 (f4 f5 f27) (f14 f15 2)) 1)) f1))
(assert (= (f29 (f3 (f4 f5 f27) (f14 f15 2)) (- 1) (+ (* 4 f16) 1)) f1))
(assert (= (f30 f31 (f32 f27 1)) (f6 (f7 f8 (+ (* 4 f16) 1)) f19)))
(assert (let ((?v_0 (+ (* 4 f16) 1))) (and (<= 0 f27) (and (< f27 ?v_0) (= (f29 f33 f27 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f14 f15 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f6 (f7 f8 ?v1) (f3 ?v_0 (f14 f15 (- (f3 f17 ?v_1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f3 f17 ?v1)) (?v_1 (f3 f17 ?v0)) (?v_2 (f4 f5 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f8 (f3 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f17 ?v1)) (?v_1 (f3 f17 ?v0)) (?v_2 (f35 f36 ?v2))) (=> (<= ?v_1 ?v_0) (= (f34 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f34 (f35 f37 (f34 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f3 f17 ?v0)) (?v_1 (f4 f5 ?v1))) (=> (< 0 ?v_0) (= (f6 (f7 f8 (f3 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f17 ?v0)) (?v_1 (f35 f36 ?v1))) (=> (< 0 ?v_0) (= (f34 (f35 f37 (f34 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f34 ?v_1 ?v0))))))
(assert (= (f29 (f3 (f4 f5 f33) (f14 f15 2)) (- 1) (+ (* 4 f16) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f3 (f4 f5 ?v0) (f14 f15 2)) (- 1) (+ (* 4 f16) 1)) f1) false)) false))
(assert (let ((?v_0 (f14 f15 2))) (= (f29 (f3 (f4 f5 f27) ?v_0) (f3 (f4 f5 f33) ?v_0) (+ (* 4 f16) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f16) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f33 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f16) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int)) (= (= (f28 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f28 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f28 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 (- ?v1 ?v2)) f1) (=> (= (f28 ?v0 ?v2) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f29 ?v0 0 ?v1) f1)) (=> (= (f29 (f3 (f4 f5 ?v2) (f14 f15 2)) ?v0 ?v1) f1) (not (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1))) (= (f6 (f7 f8 (f30 f31 (f32 ?v0 ?v1))) (f30 f31 (f32 ?v2 ?v3))) (f30 f31 (f32 (+ (f6 ?v_0 ?v2) (f6 ?v_1 ?v3)) (- (f6 ?v_0 ?v3) (f6 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 (+ ?v1 (f6 (f7 f8 ?v0) ?v2))) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f28 (f6 (f7 f8 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (= (f28 ?v0 (+ ?v2 ?v3)) f1) (= (f28 ?v0 (+ (+ ?v2 (f6 (f7 f8 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f28 (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f17 (f34 (f35 f36 ?v0) ?v1)) (f3 (f4 f5 (f3 f17 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f17 ?v0)) ?v1) (f3 f17 (f34 (f35 f36 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f14 f15 (f3 (f4 f5 ?v0) ?v1)) (f34 (f35 f36 (f14 f15 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (= (f14 f15 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f14 f15 (f6 (f7 f8 (f3 f17 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)))) (f3 f17 (f14 f15 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 (f7 f8 (f3 f17 ?v0)) (f3 f17 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 (f7 f8 (f3 f17 ?v0)) (f3 f17 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f14 f15 (f6 (f7 f8 ?v0) ?v1)) (f14 f15 (f6 (f7 f8 (f3 f17 (f14 f15 ?v0))) (f3 f17 (f14 f15 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f14 f15 (f6 (f7 f8 ?v0) ?v1)) (f14 f15 (f6 (f7 f8 (f3 f17 (f14 f15 (- ?v0)))) (f3 f17 (f14 f15 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f14 f15 (f6 (f7 f8 (f3 f17 ?v1)) (f3 f17 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f21 ?v0) f1) (=> (= (f28 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f21 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (f6 (f7 f8 ?v1) ?v3)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f21 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (f6 (f7 f8 ?v3) ?v1)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int)) (= (= (f20 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f30 f31 (f32 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (= (f29 (f3 (f4 f5 ?v1) (f14 f15 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f22 ?v0) ?v1) (ite (= (f29 ?v0 0 ?v1) f1) 0 (ite (= (f25 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f25 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f29 (f3 (f4 f5 ?v2) (f14 f15 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f21 ?v0) f1) (=> (= (f28 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (=> (< 0 (f3 f17 ?v2)) (= (f28 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f21 ?v1) f1) (=> (= (f28 ?v1 (f6 (f7 f8 ?v0) ?v2)) f1) (or (= (f28 ?v1 ?v0) f1) (= (f28 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f7 f8 ?v1))) (= (+ (f6 (f7 f8 (- ?v0 (f6 ?v_0 ?v2))) ?v3) (f6 (f7 f8 (- ?v4 (f6 ?v_0 ?v5))) ?v6)) (- (+ (f6 (f7 f8 ?v0) ?v3) (f6 (f7 f8 ?v4) ?v6)) (f6 ?v_0 (+ (f6 (f7 f8 ?v2) ?v3) (f6 (f7 f8 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 (- ?v2)) f1) (= (f29 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f29 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 S3)) (= (f14 f15 (f3 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f17 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f17 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
