(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int Int) S1)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 () S2)
(declare-fun f8 () S3)
(declare-fun f9 (S5 Int) S3)
(declare-fun f10 () S5)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () S3)
(declare-fun f16 (S6 Int) Int)
(declare-fun f17 (S7 Int) S6)
(declare-fun f18 () S7)
(declare-fun f19 () Int)
(declare-fun f20 (S8 S3) S1)
(declare-fun f21 (S3) S8)
(declare-fun f22 (S9 S3) S3)
(declare-fun f23 (S10 S3) S9)
(declare-fun f24 () S10)
(declare-fun f25 (Int) S1)
(declare-fun f26 (Int) S1)
(declare-fun f27 () S7)
(declare-fun f28 () Int)
(declare-fun f29 () S10)
(declare-fun f30 () S6)
(declare-fun f31 (Int Int) S1)
(declare-fun f32 () Int)
(declare-fun f33 () Int)
(declare-fun f34 () Int)
(declare-fun f35 () Int)
(declare-fun f36 (Int Int Int) S1)
(declare-fun f37 (S11 S12) Int)
(declare-fun f38 () S11)
(declare-fun f39 (Int Int) S12)
(declare-fun f40 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f9 f10 2))) (not (= (f3 (f4 (f5 f6 (+ 1 (f4 f7 f8))) ?v_0) (+ (f4 (f5 f6 f11) ?v_0) (f4 (f5 f6 f12) ?v_0))) f1))))
(assert (let ((?v_0 (f9 f10 2))) (let ((?v_1 (f4 (f5 f6 (+ 1 (f4 f7 f8))) ?v_0))) (and (= (f3 ?v_1 (f4 (f5 f6 f11) ?v_0)) f1) (= (f3 ?v_1 (f4 (f5 f6 f12) ?v_0)) f1)))))
(assert (< 1 f13))
(assert (< 0 (f4 f7 f8)))
(assert (< 0 (+ 1 (f4 f7 f8))))
(assert (let ((?v_0 (f9 f10 2))) (let ((?v_1 (f4 (f5 f6 (+ 1 (f4 f7 f8))) ?v_0))) (and (= (f3 ?v_1 (f4 (f5 f6 f11) ?v_0)) f1) (= (f3 ?v_1 (f4 (f5 f6 f12) ?v_0)) f1)))))
(assert (let ((?v_0 (+ 1 (f4 f7 f8)))) (and (= (f3 ?v_0 f11) f1) (= (f3 ?v_0 f12) f1))))
(assert (< f14 (+ 1 (f4 f7 f8))))
(assert (= f15 (f9 f10 (- (f4 f7 (f9 f10 f13)) 1))))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f5 f6 f11) ?v_0) (f4 (f5 f6 f12) ?v_0)) (f16 (f17 f18 (+ (* 4 f19) 1)) (+ 1 (f4 f7 f8))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f3 (f4 (f5 f6 ?v1) ?v0) (f4 (f5 f6 ?v2) ?v0)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f4 f7 ?v0)) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v1 (f4 (f5 f6 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f3 (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v1)) f1) (=> (not (= ?v1 (f9 f10 0))) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f3 ?v0 ?v1) f1) (= (f3 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f20 (f21 ?v0) ?v1) f1) (= (f20 (f21 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (=> (<= (f4 f7 ?v0) (f4 f7 ?v1)) (= (f3 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v2))) (=> (<= (f4 f7 ?v0) (f4 f7 ?v1)) (= (f20 (f21 (f22 ?v_0 ?v0)) (f22 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f3 ?v0 ?v1) f1) (=> (<= (f4 f7 ?v2) (f4 f7 ?v3)) (= (f3 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f20 (f21 ?v0) ?v1) f1) (=> (<= (f4 f7 ?v2) (f4 f7 ?v3)) (= (f20 (f21 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f3 (f4 ?v_0 ?v1) ?v2) f1) (=> (<= (f4 f7 ?v3) (f4 f7 ?v1)) (= (f3 (f4 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f20 (f21 (f22 ?v_0 ?v1)) ?v2) f1) (=> (<= (f4 f7 ?v3) (f4 f7 ?v1)) (= (f20 (f21 (f22 ?v_0 ?v3)) ?v2) f1))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f4 f7 f8)))) (=> (and (= ?v1 (- f11 (f16 (f17 f18 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f4 f7 f8)))) (=> (and (= ?v1 (- f12 (f16 (f17 f18 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (< 0 (f4 f7 f15)))
(assert (< 0 (+ (* 4 f19) 1)))
(assert (<= 1 f13))
(assert (not (= (f25 (f16 (f17 f18 (+ (* 4 f19) 1)) (+ 1 0))) f1)))
(assert (< f13 (+ (* 4 f19) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f9 f10 (- (f4 f7 (f9 f10 f13)) 1))) (=> (< 0 (f4 f7 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f4 f7 f8))) (?v_0 (+ (* 4 f19) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f25 (f16 (f17 f18 ?v_0) ?v_1)) f1))))))
(assert (= (f26 (+ (* 4 f19) 1)) f1))
(assert (= (f16 (f17 f27 (- 1)) (+ (* 4 f19) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (f16 (f17 f18 (+ (* 4 f19) 1)) (+ 1 (f4 f7 f8)))) false))) false))
(assert (= (+ (f4 (f5 f6 f28) (f9 f10 2)) 1) (f16 (f17 f18 (+ (* 4 f19) 1)) f13)))
(assert (let ((?v_1 (+ 1 (f4 f7 f8))) (?v_0 (+ (* 4 f19) 1))) (and (< ?v_1 ?v_0) (= (f25 (f16 (f17 f18 ?v_0) ?v_1)) f1))))
(assert (= (f25 (f16 (f17 f18 (+ (* 4 f19) 1)) f13)) f1))
(assert (= (f25 (f16 (f17 f18 (+ (* 4 f19) 1)) f14)) f1))
(assert (=> (= f13 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (+ (* 4 f19) 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f4 (f5 f6 (f16 (f17 f18 ?v0) ?v1)) ?v2) (f16 (f17 f18 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f22 (f23 f24 (f22 (f23 f29 ?v0) ?v1)) ?v2) (f22 (f23 f29 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (= (f16 (f17 f18 ?v_0) ?v0) (f16 (f17 f18 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 (f23 f24 ?v0) ?v1))) (= (f22 (f23 f29 ?v_0) ?v0) (f22 (f23 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) (f4 f7 ?v2)))) (f16 (f17 f18 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f9 f10 (+ (f4 f7 ?v1) (f4 f7 ?v2)))) (f22 (f23 f29 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1))) (f16 (f17 f18 (f4 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1))) (f22 (f23 f29 (f22 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1))) (f16 (f17 f18 ?v0) (f4 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1))) (f22 (f23 f29 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f4 (f5 f6 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f22 (f23 f24 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f16 f30 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f16 f30 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (= (f31 (+ (* 4 f19) 1) (- 1)) f1))
(assert (let ((?v_0 (+ 1 (f4 f7 f8)))) (and (= f32 (- f12 (f16 (f17 f18 f33) ?v_0))) (<= (ite (< f32 0) (* (- 2) f32) (* 2 f32)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f4 f7 f8)))) (and (= f34 (- f11 (f16 (f17 f18 f35) ?v_0))) (<= (ite (< f34 0) (* (- 2) f34) (* 2 f34)) ?v_0))))
(assert (= (f3 (+ (* 4 f19) 1) (- (f4 (f5 f6 f28) (f9 f10 2)) (- 1))) f1))
(assert (= (f3 (+ (* 4 f19) 1) (+ (f4 (f5 f6 f28) (f9 f10 2)) 1)) f1))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f5 f6 f34) ?v_0) (f4 (f5 f6 f32) ?v_0)) (f16 (f17 f18 (+ 1 (f4 f7 f8))) f14))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f4 (f5 f6 f28) (f9 f10 2)) 1) (f16 (f17 f18 (+ (* 4 f19) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 f6 ?v1)) (?v_1 (f9 f10 ?v0))) (=> (< 0 ?v0) (= (f4 ?v_0 ?v_1) (f16 (f17 f18 ?v1) (f4 ?v_0 (f9 f10 (- (f4 f7 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f16 (f17 f18 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f9 f10 2)) (?v_0 (f9 f10 3)) (?v_3 (f5 f6 ?v1)) (?v_1 (f5 f6 ?v0))) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v_0) (- (+ (- (f4 ?v_1 ?v_0) (f16 (f17 f18 (* 3 (f4 ?v_1 ?v_2))) ?v1)) (f16 (f17 f18 (* 3 ?v0)) (f4 ?v_3 ?v_2))) (f4 ?v_3 ?v_0))))))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f5 f6 f34) ?v_0) (f4 (f5 f6 f32) ?v_0)) 0)))
(assert (let ((?v_0 (f4 (f5 f6 f28) (f9 f10 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (and (= f34 0) (= f32 0)))
(assert (let ((?v_0 (+ (* 4 f19) 1))) (=> (not (= (f31 ?v_0 (- 1)) f1)) (not (= (f16 (f17 f27 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (f9 f10 2))) (=> (not (= f34 0)) (< 0 (+ (f4 (f5 f6 f34) ?v_0) (f4 (f5 f6 f32) ?v_0))))))
(assert (let ((?v_0 (f9 f10 2))) (=> (not (= f32 0)) (< 0 (+ (f4 (f5 f6 f34) ?v_0) (f4 (f5 f6 f32) ?v_0))))))
(assert (let ((?v_0 (f9 f10 2))) (= (f3 (+ 1 (f4 f7 f8)) (+ (f4 (f5 f6 f34) ?v_0) (f4 (f5 f6 f32) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f4 (f5 f6 f34) ?v_0) (f4 (f5 f6 f32) ?v_0)) (f16 (f17 f18 (+ 1 (f4 f7 f8))) ?v0)) false))) false))
(assert (let ((?v_2 (f9 f10 2)) (?v_1 (f17 f18 f33)) (?v_0 (f17 f18 f35))) (= (+ (f4 (f5 f6 (+ (+ (f16 ?v_0 f34) (f16 ?v_1 f32)) f14)) ?v_2) (f4 (f5 f6 (- (f16 ?v_0 f32) (f16 ?v_1 f34))) ?v_2)) (f16 (f17 f18 (+ (* 4 f19) 1)) f14))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f26 ?v_0) f1) (= (f16 (f17 f27 (- 1)) ?v_0) 1)))))
(assert (= (f26 2) f1))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (f16 (f17 f18 (f4 f7 ?v1)) (f4 f7 ?v2)))) (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f9 f10 (f16 (f17 f18 (f4 f7 ?v1)) (f4 f7 ?v2)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f26 ?v0) f1) (=> (= (f3 ?v0 (f4 (f5 f6 ?v1) ?v2)) f1) (= (f3 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v2))) (=> (= (f26 ?v0) f1) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 ?v_0 (f16 (f17 f18 ?v1) ?v3)) f1) (= (f3 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v2))) (=> (= (f26 ?v0) f1) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 ?v_0 (f16 (f17 f18 ?v3) ?v1)) f1) (= (f3 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f26 ?v0) f1) (=> (= (f3 ?v0 (f16 (f17 f18 ?v1) ?v2)) f1) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f26 ?v0) f1) (=> (= (f3 ?v0 (f4 (f5 f6 ?v1) ?v2)) f1) (=> (< 0 (f4 f7 ?v2)) (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f25 ?v0) f1) (=> (= (f25 ?v1) f1) (= (f25 (f16 (f17 f18 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f16 (f17 f18 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f4 (f5 f6 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 2))) (let ((?v_0 (f4 (f5 f6 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 3))) (let ((?v_0 (f4 (f5 f6 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 3))) (= (f4 (f5 f6 (- ?v0)) ?v_0) (- (f4 (f5 f6 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2)) (?v_1 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_1 ?v_0)) ?v_0) (f4 ?v_1 (f9 f10 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (= (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (=> (= (f4 (f5 f6 ?v0) (f9 f10 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f16 (f17 f18 ?v0) (f4 ?v_0 (f9 f10 2))) (f4 ?v_0 (f9 f10 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v_0) (+ (+ (f4 (f5 f6 ?v0) ?v_0) (f16 (f17 f18 (* 2 ?v0)) ?v1)) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v_0) (+ (- (f4 (f5 f6 ?v0) ?v_0) (f16 (f17 f18 (* 2 ?v0)) ?v1)) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f9 f10 2)) (?v_0 (f9 f10 3)) (?v_1 (f5 f6 ?v0)) (?v_3 (f5 f6 ?v1))) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f4 ?v_1 ?v_0) (f16 (f17 f18 (* 3 (f4 ?v_1 ?v_2))) ?v1)) (f16 (f17 f18 (* 3 ?v0)) (f4 ?v_3 ?v_2))) (f4 ?v_3 ?v_0))))))
(assert (= (f36 (f4 (f5 f6 f28) (f9 f10 2)) (- 1) (+ (* 4 f19) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f26 ?v1) f1) (=> (= (f3 ?v1 (f16 (f17 f18 ?v0) ?v2)) f1) (or (= (f3 ?v1 ?v0) f1) (= (f3 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f26 ?v1) f1) (= (f3 ?v1 ?v0) f1))))))
(assert (= (f37 f38 (f39 f28 1)) (f16 (f17 f18 (+ (* 4 f19) 1)) f13)))
(assert (let ((?v_0 (+ (* 4 f19) 1))) (and (<= 0 f28) (and (< f28 ?v_0) (= (f36 f40 f28 ?v_0) f1)))))
(assert (forall ((?v0 Int)) (= (= (f26 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f3 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) (f4 f7 ?v2)))) (f16 (f17 f18 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (+ ?v1 (f16 (f17 f18 ?v0) ?v2))) f1) (= (f3 ?v0 ?v1) f1))))
(assert (= (f36 (f4 (f5 f6 f40) (f9 f10 2)) (- 1) (+ (* 4 f19) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f36 (f4 (f5 f6 ?v0) (f9 f10 2)) (- 1) (+ (* 4 f19) 1)) f1) false)) false))
(assert (let ((?v_0 (f9 f10 2))) (= (f36 (f4 (f5 f6 f28) ?v_0) (f4 (f5 f6 f40) ?v_0) (+ (* 4 f19) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f19) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f36 f40 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f36 f40 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f19) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f36 f40 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f36 ?v0 ?v1 ?v2) f1) (=> (= (f36 ?v3 ?v4 ?v2) f1) (= (f36 (f16 (f17 f18 ?v0) ?v3) (f16 (f17 f18 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f17 f18 ?v3))) (=> (= (f36 ?v0 ?v1 ?v2) f1) (= (f36 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f36 ?v0 ?v1 ?v2) f1) (= (f36 (f16 (f17 f18 ?v0) ?v3) (f16 (f17 f18 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f36 (f16 (f17 f18 ?v0) ?v1) (f16 (f17 f18 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f36 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f16 (f17 f18 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f36 ?v0 ?v1 ?v2) f1) (= (f3 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f36 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f36 ?v0 ?v1 ?v2) f1) (= (f36 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f36 ?v0 ?v1 (- ?v2)) f1) (= (f36 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f36 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f36 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f36 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f36 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f36 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f36 ?v0 ?v1 ?v2) f1) (=> (= (f36 ?v1 ?v3 ?v2) f1) (= (f36 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f36 ?v0 ?v1 ?v2) f1) (=> (= (f36 ?v3 ?v4 ?v2) f1) (= (f36 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f36 ?v0 ?v1 ?v2) f1) (=> (= (f36 ?v3 ?v4 ?v2) f1) (= (f36 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f36 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f36 ?v3 ?v4 ?v2) f1) (= (f36 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f36 ?v0 ?v1 ?v2) f1) (= (f36 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f36 ?v1 (- 1) ?v0) f1) (not (= (f36 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f36 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f36 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f36 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f36 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f17 f18 ?v1))) (= (f16 (f17 f18 (f37 f38 (f39 ?v0 ?v1))) (f37 f38 (f39 ?v2 ?v3))) (f37 f38 (f39 (+ (f16 ?v_0 ?v2) (f16 ?v_1 ?v3)) (- (f16 ?v_0 ?v3) (f16 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f36 ?v0 ?v1 ?v2) f1) (= (= (f36 ?v3 (f16 (f17 f18 ?v0) ?v4) ?v2) f1) (= (f36 ?v3 (f16 (f17 f18 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f17 f18 ?v4))) (=> (= (f36 ?v0 ?v1 ?v2) f1) (= (= (f36 ?v3 (f16 ?v_0 ?v0) ?v2) f1) (= (f36 ?v3 (f16 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f36 ?v0 0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f36 ?v0 0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f36 ?v0 ?v1 ?v2) f1) (= (f36 (f4 (f5 f6 ?v0) ?v3) (f4 (f5 f6 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0) f1) (=> (< 0 ?v1) (=> (= (f36 (f16 (f17 f18 ?v1) ?v1) 1 ?v0) f1) (or (= (f36 ?v1 1 ?v0) f1) (= (f36 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f36 (f16 (f17 f18 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f36 ?v0 0 ?v1) f1)) (=> (= (f36 (f4 (f5 f6 ?v2) (f9 f10 2)) ?v0 ?v1) f1) (not (= (f3 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f26 ?v0) f1) (=> (not (= (f36 ?v1 0 ?v0) f1)) (=> (not (= (f36 ?v2 0 ?v0) f1)) (not (= (f36 (f16 (f17 f18 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f26 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f36 ?v1 0 ?v0) f1)) (not (= (f36 ?v2 0 ?v0) f1))) (not (= (f36 (f16 (f17 f18 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f26 ?v0) f1) (=> (< 0 ?v1) (=> (= (f36 (f16 (f17 f18 ?v1) ?v2) 0 ?v0) f1) (or (= (f36 ?v1 0 ?v0) f1) (= (f36 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f18 ?v0) ?v1) (f16 (f17 f18 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (+ ?v1 ?v2)) (+ (f16 ?v_0 ?v1) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (- ?v1 ?v2)) (- (f16 ?v_0 ?v1) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f18 (- ?v0)) ?v1) (- (f16 (f17 f18 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 (f17 f18 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f17 f18 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f17 f18 (+ ?v0 ?v1)) ?v2) (+ (f16 (f17 f18 ?v0) ?v2) (f16 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f17 f18 (- ?v0 ?v1)) ?v2) (- (f16 (f17 f18 ?v0) ?v2) (f16 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f17 f18 ?v1))) (= (+ (f16 (f17 f18 (- ?v0 (f16 ?v_0 ?v2))) ?v3) (f16 (f17 f18 (- ?v4 (f16 ?v_0 ?v5))) ?v6)) (- (+ (f16 (f17 f18 ?v0) ?v3) (f16 (f17 f18 ?v4) ?v6)) (f16 ?v_0 (+ (f16 (f17 f18 ?v2) ?v3) (f16 (f17 f18 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f16 (f17 f18 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f4 f7 ?v2))) (let ((?v_1 (f17 f18 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f16 ?v_1 ?v0) (f16 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 (f17 f18 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 (f17 f18 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 (f17 f18 ?v0) ?v1))) (= (f9 f10 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f9 f10 (f16 (f17 f18 (f4 f7 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0)))) (f4 f7 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 (f17 f18 (f4 f7 ?v0)) (f4 f7 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 (f17 f18 (f4 f7 ?v0)) (f4 f7 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f9 f10 (f16 (f17 f18 ?v0) ?v1)) (f9 f10 (f16 (f17 f18 (f4 f7 (f9 f10 ?v0))) (f4 f7 (f9 f10 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f9 f10 (f16 (f17 f18 ?v0) ?v1)) (f9 f10 (f16 (f17 f18 (f4 f7 (f9 f10 (- ?v0)))) (f4 f7 (f9 f10 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f20 (f21 (f9 f10 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f3 ?v0 (f4 f7 ?v1)) f1) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f3 (f4 f7 ?v0) ?v1) f1) (= (f20 (f21 ?v0) (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f3 ?v0 (f4 f7 ?v1)) f1) (= (f20 (f21 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f20 (f21 ?v0) ?v1) f1) (= (f3 (f4 f7 ?v0) (f4 f7 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f3 ?v0 (- ?v1 ?v2)) f1) (=> (= (f3 ?v0 ?v2) f1) (= (f3 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f3 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f3 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f9 f10 (f4 (f5 f6 ?v0) ?v1)) (f22 (f23 f24 (f9 f10 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f4 (f5 f6 (f4 f7 ?v0)) ?v1) (f4 f7 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f4 f7 (f22 (f23 f24 ?v0) ?v1)) (f4 (f5 f6 (f4 f7 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f9 f10 (f16 (f17 f18 (f4 f7 ?v1)) (f4 f7 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f3 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f3 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 ?v0 ?v1) f1) (= (= (f3 ?v0 (+ ?v2 ?v3)) f1) (= (f3 ?v0 (+ (+ ?v2 (f16 (f17 f18 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f3 (f16 (f17 f18 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int)) (= (= (f25 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f37 f38 (f39 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0) f1) (=> (not (= (f3 ?v0 ?v1) f1)) (= (f36 (f4 (f5 f6 ?v1) (f9 f10 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f27 ?v0) ?v1) (ite (= (f36 ?v0 0 ?v1) f1) 0 (ite (= (f31 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f31 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f36 (f4 (f5 f6 ?v2) (f9 f10 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f36 (f4 ?v_0 ?v1) 1 ?v2) f1) (= (f36 (f4 ?v_0 (f9 f10 (f16 (f17 f18 (f4 f7 ?v1)) (f4 f7 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 0))) (not (and (= (f20 (f21 ?v_0) ?v0) f1) (not (= (f20 (f21 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 1))) (not (and (= (f20 (f21 ?v0) ?v_0) f1) (not (= (f20 (f21 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S3)) (= (f20 (f21 (f9 f10 1)) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f20 (f21 ?v0) (f9 f10 0)) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 1))) (= (not (= ?v0 ?v_0)) (and (= (f20 (f21 ?v_0) ?v0) f1) (not (= (f20 (f21 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 0))) (= (not (= ?v0 ?v_0)) (and (= (f20 (f21 ?v0) ?v_0) f1) (not (= (f20 (f21 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 0))) (= (= (f20 (f21 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f4 f7 (f22 (f23 f24 ?v0) ?v1))) (or (< 0 (f4 f7 ?v0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 1))) (= (= (f20 (f21 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (f22 (f23 f24 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f22 (f23 f24 ?v0) ?v1) ?v_0) (or (= ?v1 (f9 f10 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f20 (f21 (f22 (f23 f24 ?v1) ?v0)) (f22 (f23 f24 ?v2) ?v0)) f1) (= (f20 (f21 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 0))) (=> (= (f20 (f21 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (< 0 (f4 f7 ?v0)) (=> (= (f20 (f21 ?v1) ?v0) f1) (< 0 (f4 f7 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (=> (< 0 (f4 f7 ?v0)) (=> (< (f4 f7 (f22 ?v_0 ?v1)) (f4 f7 (f22 ?v_0 ?v2))) (< (f4 f7 ?v1) (f4 f7 ?v2)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 1))) (=> (= (f20 (f21 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f4 f7 ?v0)) (<= ?v_0 (f4 f7 (f22 (f23 f24 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f20 (f21 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2)) f1) (=> (< 1 (f4 f7 ?v0)) (<= (f4 f7 ?v1) (f4 f7 ?v2)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f7 (f9 f10 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f9 f10 (f16 (f17 f18 ?v_0) ?v_0)) (f9 f10 (+ (f16 (f17 f18 (f4 f7 (f9 f10 (- ?v0 1)))) (f4 f7 (f9 f10 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int)) (=> (= (f26 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f36 (f16 (f17 f18 ?v0) ?v_0) 1 ?v1) f1) (= (f36 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (let ((?v_1 (f4 ?v_0 ?v1))) (= (f4 ?v_0 (f9 f10 (* 2 (f4 f7 ?v1)))) (f16 (f17 f18 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f9 f10 (* 2 (f4 f7 ?v1)))) (f22 (f23 f29 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (let ((?v_1 (f4 ?v_0 ?v1))) (= (f4 ?v_0 (f9 f10 (+ (* 2 (f4 f7 ?v1)) 1))) (f16 (f17 f18 ?v0) (f16 (f17 f18 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f9 f10 (+ (* 2 (f4 f7 ?v1)) 1))) (f22 (f23 f29 ?v0) (f22 (f23 f29 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (* 2 (f4 f7 ?v1)) 1))) (f16 (f17 f18 ?v0) (f4 (f5 f6 (f4 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f9 f10 (+ (* 2 (f4 f7 ?v1)) 1))) (f22 (f23 f29 ?v0) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f22 (f23 f29 ?v0) ?v1) (f22 (f23 f29 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f18 ?v0) ?v1) (f16 (f17 f18 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f23 f29 ?v0)) (?v_0 (f23 f29 ?v1))) (= (f22 ?v_1 (f22 ?v_0 ?v2)) (f22 ?v_0 (f22 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f17 f18 ?v0)) (?v_0 (f17 f18 ?v1))) (= (f16 ?v_1 (f16 ?v_0 ?v2)) (f16 ?v_0 (f16 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f29 ?v0))) (= (f22 ?v_0 (f22 (f23 f29 ?v1) ?v2)) (f22 (f23 f29 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f16 (f17 f18 ?v1) ?v2)) (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f29 ?v0))) (= (f22 (f23 f29 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f23 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f17 f18 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f29 ?v0))) (= (f22 (f23 f29 (f22 ?v_0 ?v1)) ?v2) (f22 (f23 f29 (f22 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 (f17 f18 (f16 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f23 f29 ?v0)) (?v_1 (f22 (f23 f29 ?v2) ?v3))) (= (f22 (f23 f29 (f22 ?v_0 ?v1)) ?v_1) (f22 ?v_0 (f22 (f23 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f16 (f17 f18 ?v2) ?v3))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v_1) (f16 ?v_0 (f16 (f17 f18 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f23 f29 (f22 (f23 f29 ?v0) ?v1))) (?v_0 (f23 f29 ?v2))) (= (f22 ?v_1 (f22 ?v_0 ?v3)) (f22 ?v_0 (f22 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f17 f18 (f16 (f17 f18 ?v0) ?v1))) (?v_0 (f17 f18 ?v2))) (= (f16 ?v_1 (f16 ?v_0 ?v3)) (f16 ?v_0 (f16 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f23 f29 ?v0))) (= (f22 (f23 f29 (f22 ?v_0 ?v1)) (f22 (f23 f29 ?v2) ?v3)) (f22 (f23 f29 (f22 ?v_0 ?v2)) (f22 (f23 f29 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) (f16 (f17 f18 ?v2) ?v3)) (f16 (f17 f18 (f16 ?v_0 ?v2)) (f16 (f17 f18 ?v1) ?v3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (= (f4 (f5 f6 (f16 f30 ?v0)) ?v_0) (f4 (f5 f6 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f4 (f5 f6 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f22 (f23 f24 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) (f9 f10 2)))) (= (f16 f30 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 f10 0)) (?v_2 (f4 f7 ?v0)) (?v_1 (f4 f7 ?v1))) (= (f9 f10 (f16 (f17 f18 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f9 f10 (+ ?v_1 (f16 (f17 f18 (f4 f7 (f9 f10 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f7 ?v0))) (= (f9 f10 (* ?v_0 2)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f7 ?v0))) (= (f9 f10 (* 2 ?v_0)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f16 (f17 f18 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2)) (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) (f4 f7 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f29 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2)) (f22 ?v_0 (f9 f10 (+ (f4 f7 ?v1) (f4 f7 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f4 (f5 f6 (f16 (f17 f18 ?v0) ?v1)) ?v2) (f16 (f17 f18 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f22 (f23 f24 (f22 (f23 f29 ?v0) ?v1)) ?v2) (f22 (f23 f29 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f16 (f17 f18 (f4 ?v_0 ?v1)) ?v0) (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f29 (f22 ?v_0 ?v1)) ?v0) (f22 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f16 (f17 f18 ?v0) (f4 ?v_0 ?v1)) (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f29 ?v0) (f22 ?v_0 ?v1)) (f22 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (f4 (f5 f6 ?v0) (f9 f10 3)) (f16 (f17 f18 (f16 (f17 f18 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3)) (= (f22 (f23 f24 ?v0) (f9 f10 3)) (f22 (f23 f29 (f22 (f23 f29 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f4 (f5 f6 ?v0) (f9 f10 2)) (f16 (f17 f18 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f22 (f23 f24 ?v0) (f9 f10 2)) (f22 (f23 f29 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1))) (f16 (f17 f18 ?v0) (f4 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1))) (f22 (f23 f29 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f16 (f17 f18 ?v0) ?v0) (f4 (f5 f6 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S3)) (= (f22 (f23 f29 ?v0) ?v0) (f22 (f23 f24 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f9 f10 (f16 (f17 f18 (f4 f7 ?v1)) (f4 f7 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f9 f10 (f16 (f17 f18 (f4 f7 ?v1)) (f4 f7 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (* 2 (f4 f7 ?v1)))) (f4 (f5 f6 (f4 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f9 f10 (* 2 (f4 f7 ?v1)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f9 f10 0)) (f9 f10 1) (f9 f10 (f16 (f17 f18 (f4 f7 ?v0)) (f4 f7 (f22 ?v_0 (f9 f10 (- (f4 f7 ?v1) 1)))))))))))
(assert (forall ((?v0 S3)) (= (f20 (f21 (f9 f10 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f20 (f21 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (= (f20 (f21 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 1))) (= (= (f20 (f21 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f20 (f21 ?v0) ?v1) f1) (= (f20 (f21 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f20 (f21 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f20 (f21 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f20 (f21 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f21 ?v0))) (= (= (f20 ?v_0 (f9 f10 (+ (f4 f7 ?v1) (f4 f7 ?v0)))) f1) (= (f20 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f20 (f21 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f20 (f21 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (and (= (f20 (f21 ?v0) ?v1) f1) (not (= (f20 (f21 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f20 (f21 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f20 (f21 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f7 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f4 f7 ?v1)) (not (= (f20 (f21 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f20 (f21 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f20 (f21 ?v0) ?v1) f1) (= (= (f20 (f21 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f20 (f21 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f20 (f21 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f20 (f21 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f20 (f21 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f7 ?v1))) (=> (= (f20 (f21 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f4 f7 ?v0) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f20 (f21 ?v1) ?v2) f1) (= (f20 (f21 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f21 ?v0))) (=> (= (f20 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f20 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f20 (f21 ?v0) ?v1) f1) (=> (= (f20 (f21 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f20 (f21 ?v0) ?v1) f1) (=> (= (f20 (f21 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f21 ?v0))) (=> (= (f20 ?v_0 ?v1) f1) (=> (= (f20 (f21 ?v1) ?v2) f1) (= (f20 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f21 ?v0))) (=> (= (f20 ?v_0 ?v1) f1) (=> (= (f20 ?v_0 ?v2) f1) (= (f20 ?v_0 (f9 f10 (- (f4 f7 ?v1) (f4 f7 ?v2)))) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f21 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f20 (f21 ?v1) ?v2) f1) (not (= (f20 ?v_0 ?v1) f1))) (and (= (f20 (f21 ?v0) ?v2) f1) (not (= (f20 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f21 ?v0)) (?v_1 (f21 ?v2))) (=> (= (f20 ?v_0 ?v1) f1) (=> (and (= (f20 (f21 ?v1) ?v2) f1) (not (= (f20 ?v_1 ?v1) f1))) (and (= (f20 ?v_0 ?v2) f1) (not (= (f20 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f21 ?v0)) (?v_1 (f4 f7 ?v2)) (?v_2 (f4 f7 ?v1))) (=> (= (f20 ?v_0 (f9 f10 (- ?v_2 ?v_1))) f1) (=> (= (f20 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f20 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f21 ?v0)) (?v_1 (f4 f7 ?v2)) (?v_2 (f4 f7 ?v1))) (=> (= (f20 ?v_0 (f9 f10 (- ?v_2 ?v_1))) f1) (=> (= (f20 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f20 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f20 (f21 ?v0) ?v1) f1) (not (= (f20 (f21 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3)) (= (f9 f10 (f4 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f7 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f7 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
