(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S3 Int) Int)
(declare-fun f6 (S4 Int) S3)
(declare-fun f7 () S4)
(declare-fun f8 () Int)
(declare-fun f9 (S5 S6) Int)
(declare-fun f10 () S5)
(declare-fun f11 () S6)
(declare-fun f12 () Int)
(declare-fun f13 () S2)
(declare-fun f14 () S4)
(declare-fun f15 () Int)
(declare-fun f16 (S7 Int) S2)
(declare-fun f17 () S7)
(declare-fun f18 () S6)
(declare-fun f19 (S8 Int) S6)
(declare-fun f20 () S8)
(declare-fun f21 () S7)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 (S9 Int) S5)
(declare-fun f25 () S9)
(declare-fun f26 () Int)
(declare-fun f27 (S10 S6) S1)
(declare-fun f28 (S11 S6) S10)
(declare-fun f29 () S11)
(declare-fun f30 (S12 S6) S6)
(declare-fun f31 (S13 S6) S12)
(declare-fun f32 () S13)
(declare-fun f33 () S3)
(declare-fun f34 () Int)
(declare-fun f35 () Int)
(declare-fun f36 () Int)
(declare-fun f37 () Int)
(declare-fun f38 (S14 Int) S7)
(declare-fun f39 () S14)
(declare-fun f40 () Int)
(declare-fun f41 () S13)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 (f6 f7 (+ (* 4 f8) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f8) 1)) (?v_1 (+ 1 (f9 f10 f11)))) (and (< ?v_1 ?v_0) (= (f3 f4 (f5 (f6 f7 ?v_0) ?v_1)) f1))))
(assert (let ((?v_0 (+ 1 (f9 f10 f11)))) (or (= ?v_0 1) (= ?v_0 (+ (* 4 f8) 1)))))
(assert (< 1 f12))
(assert (not (= (+ 1 (f9 f10 f11)) 0)))
(assert (< 0 (+ 1 (f9 f10 f11))))
(assert (let ((?v_0 (+ 1 (f9 f10 f11)))) (or (= ?v_0 1) (= ?v_0 (+ (* 4 f8) 1)))))
(assert (let ((?v_0 (+ (* 4 f8) 1)) (?v_1 (+ 1 (f9 f10 f11)))) (and (< ?v_1 ?v_0) (= (f3 f4 (f5 (f6 f7 ?v_0) ?v_1)) f1))))
(assert (< 0 (+ (* 4 f8) 1)))
(assert (not (= (f3 f4 (f5 (f6 f7 (+ (* 4 f8) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f8) 1)) (?v_1 (+ 1 (f9 f10 f11)))) (not (=> (< ?v_1 ?v_0) (not (= (f3 f4 (f5 (f6 f7 ?v_0) ?v_1)) f1))))))
(assert (= (f3 f13 (+ (* 4 f8) 1)) f1))
(assert (= (f5 (f6 f14 (- 1)) (+ (* 4 f8) 1)) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 f4 ?v1) f1) (= (f3 f4 (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (= (f3 f4 (f5 (f6 f7 (+ (* 4 f8) 1)) f15)) f1))
(assert (= (f3 (f16 f17 (+ (* 4 f8) 1)) (- 1)) f1))
(assert (= f18 (f19 f20 (- (f9 f10 (f19 f20 f12)) 1))))
(assert (= (f3 f4 (f5 (f6 f7 (+ (* 4 f8) 1)) f12)) f1))
(assert (< f12 (+ (* 4 f8) 1)))
(assert (let ((?v_0 (+ (* 4 f8) 1))) (=> (not (= (f3 (f16 f17 ?v_0) (- 1)) f1)) (not (= (f5 (f6 f14 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (+ 1 (f9 f10 f11)))) (let ((?v_1 (f6 f7 ?v_0))) (= (f3 (f16 f21 (f5 ?v_1 ?v_0)) (f5 ?v_1 (+ (* 4 f8) 1))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (+ ?v1 ?v2)) (+ (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (- ?v1 ?v2)) (- (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 (- ?v0)) ?v1) (- (f5 (f6 f7 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f5 (f6 f7 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (< 0 (f9 f10 f11)))
(assert (< 0 (f9 f10 f18)))
(assert (<= 1 f12))
(assert (< f15 (+ 1 (f9 f10 f11))))
(assert (=> (forall ((?v0 S6)) (=> (= ?v0 (f19 f20 (- (f9 f10 (f19 f20 f12)) 1))) (=> (< 0 (f9 f10 ?v0)) false))) false))
(assert (let ((?v_0 (+ 1 (f9 f10 f11)))) (and (<= 0 ?v_0) (= (f3 (f16 f21 ?v_0) (+ (* 4 f8) 1)) f1))))
(assert (= (f3 (f16 f21 (+ 1 (f9 f10 f11))) (+ (* 4 f8) 1)) f1))
(assert (forall ((?v0 Int)) (= (= (f3 (f16 f21 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f3 (f16 f21 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f3 f13 ?v_0) f1) (= (f5 (f6 f14 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f3 (f16 f21 ?v0) ?v1) f1) (=> (= (f3 (f16 f21 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 (f16 f21 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f16 f21 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f16 f21 ?v0) ?v1) f1) (=> (= (f3 (f16 f21 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f21 ?v0))) (=> (= (f3 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f16 f21 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f3 (f16 f21 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f16 f21 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (= (f3 ?v_0 (+ ?v2 ?v3)) f1) (= (f3 ?v_0 (+ (+ ?v2 (f5 (f6 f7 ?v4) ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f3 (f16 f21 (f5 (f6 f7 ?v0) ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f21 ?v0))) (= (= (f3 ?v_0 (+ ?v1 (f5 (f6 f7 ?v0) ?v2))) f1) (= (f3 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 (f6 f7 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 (f6 f7 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (let ((?v_0 (f9 f10 ?v2))) (let ((?v_1 (f6 f7 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f5 ?v_1 ?v0) (f5 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f5 ?v_0 ?v0) (f5 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f5 (f6 f7 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f5 (f6 f7 (- ?v0 ?v1)) ?v2) (- (f5 (f6 f7 ?v0) ?v2) (f5 (f6 f7 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f5 (f6 f7 (+ ?v0 ?v1)) ?v2) (+ (f5 (f6 f7 ?v0) ?v2) (f5 (f6 f7 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f21 ?v0))) (=> (= (f3 f13 ?v0) f1) (=> (= (f3 ?v_0 (f5 (f6 f7 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f21 ?v1))) (=> (<= 0 ?v0) (=> (= (f3 f13 ?v1) f1) (=> (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v2)) f1) (or (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v2) f1))))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f9 f10 f11)))) (=> (and (= ?v1 (- f22 (f5 (f6 f7 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f9 f10 f11)))) (=> (and (= ?v1 (- f23 (f5 (f6 f7 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (forall ((?v0 Int)) (= (= (f3 f13 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f3 (f16 f21 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (=> (not (= ?v0 0)) (= (= (f3 (f16 f21 ?v1) ?v2) f1) (= (f3 (f16 f21 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (=> (= (+ (f9 (f24 f25 ?v0) ?v_0) (f9 (f24 f25 ?v1) ?v_0)) (f5 (f6 f7 (+ (* 4 f8) 1)) (+ 1 (f9 f10 f11)))) false))) false))
(assert (= (+ (f9 (f24 f25 f26) (f19 f20 2)) 1) (f5 (f6 f7 (+ (* 4 f8) 1)) f12)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f3 (f16 f21 (f5 (f6 f7 ?v0) ?v1)) ?v2) f1) (= (f3 (f16 f21 ?v1) ?v2) f1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f27 (f28 f29 (f30 (f31 f32 ?v0) ?v1)) ?v2) f1) (= (f27 (f28 f29 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f3 (f16 f21 (f5 (f6 f7 ?v0) ?v1)) ?v2) f1) (= (f3 (f16 f21 ?v0) ?v2) f1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f27 (f28 f29 (f30 (f31 f32 ?v0) ?v1)) ?v2) f1) (= (f27 (f28 f29 ?v0) ?v2) f1))))
(assert (let ((?v_0 (f9 (f24 f25 f26) (f19 f20 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (f19 f20 2))) (= (+ (f9 (f24 f25 f23) ?v_0) (f9 (f24 f25 f22) ?v_0)) (f5 (f6 f7 (+ (* 4 f8) 1)) (+ 1 (f9 f10 f11))))))
(assert (= (f3 (f16 f21 (+ (* 4 f8) 1)) (+ (f9 (f24 f25 f26) (f19 f20 2)) 1)) f1))
(assert (= (f3 (f16 f21 (+ (* 4 f8) 1)) (- (f9 (f24 f25 f26) (f19 f20 2)) (- 1))) f1))
(assert (let ((?v_0 (f16 f21 (+ 1 (f9 f10 f11))))) (and (= (f3 ?v_0 f23) f1) (= (f3 ?v_0 f22) f1))))
(assert (let ((?v_0 (f19 f20 2))) (let ((?v_1 (f16 f21 (f9 (f24 f25 (+ 1 (f9 f10 f11))) ?v_0)))) (and (= (f3 ?v_1 (f9 (f24 f25 f23) ?v_0)) f1) (= (f3 ?v_1 (f9 (f24 f25 f22) ?v_0)) f1)))))
(assert (let ((?v_0 (f19 f20 2))) (= (f3 (f16 f21 (f9 (f24 f25 (+ 1 (f9 f10 f11))) ?v_0)) (+ (f9 (f24 f25 f23) ?v_0) (f9 (f24 f25 f22) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f9 (f24 f25 f26) (f19 f20 2)) 1) (f5 (f6 f7 (+ (* 4 f8) 1)) ?v0)) false)) false))
(assert (=> (= f12 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (+ (f9 (f24 f25 ?v0) ?v_0) (f9 (f24 f25 ?v1) ?v_0)) (+ (* 4 f8) 1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (<= 0 (f9 (f24 f25 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (< 0 (f9 (f24 f25 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f19 f20 0))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f9 (f24 f25 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f19 f20 (f5 (f6 f7 (f9 f10 ?v1)) (f9 f10 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f21 ?v1))) (=> (< 0 (f9 f10 ?v0)) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f9 (f24 f25 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f9 ?v_0 (f19 f20 (+ (f9 f10 ?v1) (f9 f10 ?v2)))) (f5 (f6 f7 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 (f6 f7 ?v0) ?v1))) (= (f19 f20 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f19 f20 (f5 (f6 f7 (f9 f10 (f19 f20 (ite (< ?v0 0) (- ?v0) ?v0)))) (f9 f10 (f19 f20 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f5 (f6 f7 (f9 f10 ?v0)) (f9 f10 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f5 (f6 f7 (f9 f10 ?v0)) (f9 f10 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f19 f20 (f5 (f6 f7 ?v0) ?v1)) (f19 f20 (f5 (f6 f7 (f9 f10 (f19 f20 ?v0))) (f9 f10 (f19 f20 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f19 f20 (f5 (f6 f7 ?v0) ?v1)) (f19 f20 (f5 (f6 f7 (f9 f10 (f19 f20 (- ?v0)))) (f9 f10 (f19 f20 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (= (f27 (f28 f29 (f19 f20 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f3 (f16 f21 ?v0) (f9 f10 ?v1)) f1) (= ?v1 (f19 f20 0))))))
(assert (forall ((?v0 S6) (?v1 Int)) (= (= (f3 (f16 f21 (f9 f10 ?v0)) ?v1) f1) (= (f27 (f28 f29 ?v0) (f19 f20 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (= (f3 (f16 f21 ?v0) (f9 f10 ?v1)) f1) (= (f27 (f28 f29 (f19 f20 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f27 (f28 f29 ?v0) ?v1) f1) (= (f3 (f16 f21 (f9 f10 ?v0)) (f9 f10 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (let ((?v_0 (f16 f21 ?v0))) (=> (= (f3 f13 ?v0) f1) (=> (= (f3 ?v_0 (f9 (f24 f25 ?v1) ?v2)) f1) (=> (< 0 (f9 f10 ?v2)) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 f33 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f33 ?v0)) (f5 f33 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f33 ?v0))) (= (f5 (f6 f7 ?v_0) ?v_0) (f5 (f6 f7 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 f33 ?v0) (f5 f33 ?v1)) (= (f3 (f16 f21 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f21 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f16 f21 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v0))) (=> (= (f27 ?v_0 ?v1) f1) (=> (= (f27 (f28 f29 ?v1) ?v2) f1) (= (f27 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f16 f21 (f5 f33 ?v0)) ?v1) f1) (= (f3 (f16 f21 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f21 ?v0))) (= (= (f3 ?v_0 (f5 f33 ?v1)) f1) (= (f3 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (f3 (f16 f21 ?v0) ?v0) f1)))
(assert (forall ((?v0 S6)) (= (f27 (f28 f29 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f6 f7 ?v1))) (= (+ (f5 (f6 f7 (- ?v0 (f5 ?v_0 ?v2))) ?v3) (f5 (f6 f7 (- ?v4 (f5 ?v_0 ?v5))) ?v6)) (- (+ (f5 (f6 f7 ?v0) ?v3) (f5 (f6 f7 ?v4) ?v6)) (f5 ?v_0 (+ (f5 (f6 f7 ?v2) ?v3) (f5 (f6 f7 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f5 (f6 f7 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f5 (f6 f7 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f16 f21 ?v0) ?v1) f1) (= (f3 (f16 f21 (- ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f21 ?v0))) (= (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (- ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f16 f21 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f16 f21 ?v0) (f5 (f6 f7 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f27 (f28 f29 ?v0) (f30 (f31 f32 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f16 f21 ?v0) (f5 (f6 f7 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f27 (f28 f29 ?v0) (f30 (f31 f32 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f21 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f7 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v0))) (=> (= (f27 ?v_0 ?v1) f1) (= (f27 ?v_0 (f30 (f31 f32 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f21 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f7 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v0))) (=> (= (f27 ?v_0 ?v1) f1) (= (f27 ?v_0 (f30 (f31 f32 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f16 f21 ?v0) ?v1) f1) (=> (= (f3 (f16 f21 ?v2) ?v3) f1) (= (f3 (f16 f21 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f27 (f28 f29 ?v0) ?v1) f1) (=> (= (f27 (f28 f29 ?v2) ?v3) f1) (= (f27 (f28 f29 (f30 (f31 f32 ?v0) ?v2)) (f30 (f31 f32 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f5 (f6 f7 ?v1) ?v2)) (= (f3 (f16 f21 ?v1) ?v0) f1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= ?v0 (f30 (f31 f32 ?v1) ?v2)) (= (f27 (f28 f29 ?v1) ?v0) f1))))
(assert (let ((?v_0 (+ 1 (f9 f10 f11)))) (and (= f34 (- f23 (f5 (f6 f7 f35) ?v_0))) (<= (ite (< f34 0) (* (- 2) f34) (* 2 f34)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f9 f10 f11)))) (and (= f36 (- f22 (f5 (f6 f7 f37) ?v_0))) (<= (ite (< f36 0) (* (- 2) f36) (* 2 f36)) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6) (?v3 Int)) (let ((?v_0 (f16 f21 (f9 (f24 f25 ?v0) ?v2)))) (=> (= (f3 f13 ?v0) f1) (=> (not (= (f3 (f16 f21 ?v0) ?v1) f1)) (=> (= (f3 ?v_0 (f5 (f6 f7 ?v3) ?v1)) f1) (= (f3 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6) (?v3 Int)) (let ((?v_0 (f16 f21 (f9 (f24 f25 ?v0) ?v2)))) (=> (= (f3 f13 ?v0) f1) (=> (not (= (f3 (f16 f21 ?v0) ?v1) f1)) (=> (= (f3 ?v_0 (f5 (f6 f7 ?v1) ?v3)) f1) (= (f3 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (let ((?v_0 (f16 f21 ?v0))) (=> (= (f3 f13 ?v0) f1) (=> (= (f3 ?v_0 (f9 (f24 f25 ?v1) ?v2)) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (= (f3 (f16 (f38 f39 (f9 (f24 f25 f26) (f19 f20 2))) (- 1)) (+ (* 4 f8) 1)) f1))
(assert (let ((?v_0 (f19 f20 2))) (= (+ (f9 (f24 f25 f34) ?v_0) (f9 (f24 f25 f36) ?v_0)) (f5 (f6 f7 (+ 1 (f9 f10 f11))) f15))))
(assert (let ((?v_0 (f19 f20 2))) (= (+ (f9 (f24 f25 f34) ?v_0) (f9 (f24 f25 f36) ?v_0)) 0)))
(assert (and (= f34 0) (= f36 0)))
(assert (= (f3 (f16 (f38 f39 (f9 (f24 f25 f40) (f19 f20 2))) (- 1)) (+ (* 4 f8) 1)) f1))
(assert (let ((?v_0 (f19 f20 2))) (=> (not (= f34 0)) (< 0 (+ (f9 (f24 f25 f34) ?v_0) (f9 (f24 f25 f36) ?v_0))))))
(assert (let ((?v_0 (f19 f20 2))) (=> (not (= f36 0)) (< 0 (+ (f9 (f24 f25 f34) ?v_0) (f9 (f24 f25 f36) ?v_0))))))
(assert (let ((?v_0 (+ (* 4 f8) 1))) (and (<= 0 f26) (and (< f26 ?v_0) (= (f3 (f16 (f38 f39 f40) f26) ?v_0) f1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f3 (f16 (f38 f39 (f9 (f24 f25 ?v0) (f19 f20 2))) (- 1)) (+ (* 4 f8) 1)) f1) false)) false))
(assert (let ((?v_0 (f19 f20 2))) (= (f3 (f16 f21 (+ 1 (f9 f10 f11))) (+ (f9 (f24 f25 f34) ?v_0) (f9 (f24 f25 f36) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f19 f20 2))) (=> (= (+ (f9 (f24 f25 f34) ?v_0) (f9 (f24 f25 f36) ?v_0)) (f5 (f6 f7 (+ 1 (f9 f10 f11))) ?v0)) false))) false))
(assert (let ((?v_2 (f19 f20 2)) (?v_0 (f6 f7 f35)) (?v_1 (f6 f7 f37))) (= (+ (f9 (f24 f25 (+ (+ (f5 ?v_0 f34) (f5 ?v_1 f36)) f15)) ?v_2) (f9 (f24 f25 (- (f5 ?v_0 f36) (f5 ?v_1 f34))) ?v_2)) (f5 (f6 f7 (+ (* 4 f8) 1)) f15))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f16 (f38 f39 ?v3) ?v4) ?v2) f1) (= (f3 (f16 (f38 f39 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f16 (f38 f39 ?v3) ?v4) ?v2) f1) (= (f3 (f16 (f38 f39 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f38 f39 ?v0))) (=> (= (f3 (f16 ?v_0 ?v1) ?v2) f1) (=> (= (f3 (f16 (f38 f39 ?v1) ?v3) ?v2) f1) (= (f3 (f16 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f38 f39 ?v0))) (=> (= (f3 (f16 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f3 (f16 (f38 f39 ?v3) ?v4) ?v2) f1) (= (f3 (f16 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (= (f3 (f16 (f38 f39 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f38 f39 ?v1))) (=> (< 2 ?v0) (=> (= (f3 (f16 ?v_0 (- 1)) ?v0) f1) (not (= (f3 (f16 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f16 (f38 f39 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f16 (f38 f39 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f3 (f16 (f38 f39 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f3 (f16 (f38 f39 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 (f16 (f38 f39 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f16 (f38 f39 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f16 (f38 f39 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int)) (= (f3 (f16 (f38 f39 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 (f38 f39 ?v0) ?v1))) (= (= (f3 ?v_0 (- ?v2)) f1) (= (f3 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (= (f3 (f16 (f38 f39 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f16 (f38 f39 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f16 (f38 f39 ?v3) ?v4) ?v2) f1) (= (f3 (f16 (f38 f39 (f5 (f6 f7 ?v0) ?v3)) (f5 (f6 f7 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f7 ?v3))) (=> (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (= (f3 (f16 (f38 f39 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (= (f3 (f16 (f38 f39 (f5 (f6 f7 ?v0) ?v3)) (f5 (f6 f7 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f38 f39 ?v3)) (?v_1 (f6 f7 ?v4))) (=> (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (= (= (f3 (f16 ?v_0 (f5 ?v_1 ?v0)) ?v2) f1) (= (f3 (f16 ?v_0 (f5 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f38 f39 ?v3))) (=> (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (= (= (f3 (f16 ?v_0 (f5 (f6 f7 ?v0) ?v4)) ?v2) f1) (= (f3 (f16 ?v_0 (f5 (f6 f7 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f16 (f38 f39 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f5 (f6 f7 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f16 (f38 f39 ?v0) 0) ?v1) f1) (= (f3 (f16 f21 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f16 (f38 f39 ?v0) 0) ?v1) f1) (= (f3 (f16 f21 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (= (f3 (f16 f21 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S6)) (=> (= (f3 (f16 (f38 f39 ?v0) ?v1) ?v2) f1) (= (f3 (f16 (f38 f39 (f9 (f24 f25 ?v0) ?v3)) (f9 (f24 f25 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f3 f13 ?v0) f1) (=> (not (= (f3 (f16 (f38 f39 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f16 (f38 f39 ?v2) 0) ?v0) f1)) (not (= (f3 (f16 (f38 f39 (f5 (f6 f7 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 f13 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f3 (f16 (f38 f39 (f5 (f6 f7 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f3 f13 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f3 (f16 (f38 f39 ?v1) 0) ?v0) f1)) (not (= (f3 (f16 (f38 f39 ?v2) 0) ?v0) f1))) (not (= (f3 (f16 (f38 f39 (f5 (f6 f7 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f3 f13 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f16 (f38 f39 (f5 (f6 f7 ?v1) ?v2)) 0) ?v0) f1) (or (= (f3 (f16 (f38 f39 ?v1) 0) ?v0) f1) (= (f3 (f16 (f38 f39 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f38 f39 ?v1))) (=> (= (f3 f13 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f16 (f38 f39 (f5 (f6 f7 ?v1) ?v1)) 1) ?v0) f1) (or (= (f3 (f16 ?v_0 1) ?v0) f1) (= (f3 (f16 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f5 (f6 f7 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f9 (f24 f25 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f19 f20 2))) (let ((?v_0 (f9 (f24 f25 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f9 (f24 f25 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f19 f20 3))) (let ((?v_0 (f9 (f24 f25 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f9 (f24 f25 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 3))) (= (f9 (f24 f25 (- ?v0)) ?v_0) (- (f9 (f24 f25 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 2)) (?v_1 (f24 f25 ?v0))) (= (f9 (f24 f25 (f9 ?v_1 ?v_0)) ?v_0) (f9 ?v_1 (f19 f20 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (= (f9 (f24 f25 ?v0) ?v_0) (f9 (f24 f25 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (=> (= (f9 (f24 f25 ?v0) (f19 f20 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f3 f13 2) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f5 (f6 f7 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f9 (f24 f25 ?v0) ?v_0) (f9 (f24 f25 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f19 f20 2)) (?v_0 (f19 f20 3)) (?v_3 (f24 f25 ?v1)) (?v_1 (f24 f25 ?v0))) (= (f9 (f24 f25 (- ?v0 ?v1)) ?v_0) (- (+ (- (f9 ?v_1 ?v_0) (f5 (f6 f7 (* 3 (f9 ?v_1 ?v_2))) ?v1)) (f5 (f6 f7 (* 3 ?v0)) (f9 ?v_3 ?v_2))) (f9 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f19 f20 2)) (?v_0 (f19 f20 3)) (?v_1 (f24 f25 ?v0)) (?v_3 (f24 f25 ?v1))) (= (f9 (f24 f25 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f9 ?v_1 ?v_0) (f5 (f6 f7 (* 3 (f9 ?v_1 ?v_2))) ?v1)) (f5 (f6 f7 (* 3 ?v0)) (f9 ?v_3 ?v_2))) (f9 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f9 (f24 f25 (- ?v0 ?v1)) ?v_0) (+ (- (f9 (f24 f25 ?v0) ?v_0) (f5 (f6 f7 (* 2 ?v0)) ?v1)) (f9 (f24 f25 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f9 (f24 f25 (+ ?v0 ?v1)) ?v_0) (+ (+ (f9 (f24 f25 ?v0) ?v_0) (f5 (f6 f7 (* 2 ?v0)) ?v1)) (f9 (f24 f25 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f5 (f6 f7 ?v0) (f9 ?v_0 (f19 f20 2))) (f9 ?v_0 (f19 f20 3))))))
(assert (let ((?v_0 (f19 f20 2))) (= (f3 (f16 (f38 f39 (f9 (f24 f25 f26) ?v_0)) (f9 (f24 f25 f40) ?v_0)) (+ (* 4 f8) 1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 f13 ?v0) f1) (=> (not (= (f3 (f16 f21 ?v0) ?v1) f1)) (= (f3 (f16 (f38 f39 (f9 (f24 f25 ?v1) (f19 f20 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f14 ?v0) ?v1) (ite (= (f3 (f16 (f38 f39 ?v0) 0) ?v1) f1) 0 (ite (= (f3 (f16 f17 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f16 f17 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f3 (f16 (f38 f39 (f9 (f24 f25 ?v2) (f19 f20 2))) ?v1) ?v0) f1)))))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f8) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f3 (f16 (f38 f39 f40) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f3 (f16 (f38 f39 f40) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f8) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f3 (f16 (f38 f39 f40) ?v0) ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f3 (f16 (f38 f39 ?v0) 0) ?v1) f1)) (=> (= (f3 (f16 (f38 f39 (f9 (f24 f25 ?v2) (f19 f20 2))) ?v0) ?v1) f1) (not (= (f3 (f16 f21 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int) (?v3 S6)) (let ((?v_0 (f24 f25 ?v0))) (=> (= (f3 (f16 (f38 f39 (f9 ?v_0 ?v1)) 1) ?v2) f1) (= (f3 (f16 (f38 f39 (f9 ?v_0 (f19 f20 (f5 (f6 f7 (f9 f10 ?v1)) (f9 f10 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f9 ?v_0 (f19 f20 (+ (* 2 (f9 f10 ?v1)) 1))) (f5 (f6 f7 ?v0) (f9 (f24 f25 (f9 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f31 f41 ?v0))) (= (f30 ?v_0 (f19 f20 (+ (* 2 (f9 f10 ?v1)) 1))) (f30 (f31 f32 ?v0) (f30 (f31 f41 (f30 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f9 f10 (f30 (f31 f41 ?v0) ?v1)) (f9 (f24 f25 (f9 f10 ?v0)) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f9 (f24 f25 (f9 f10 ?v0)) ?v1) (f9 f10 (f30 (f31 f41 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (<= 0 ?v0) (= (f19 f20 (f9 (f24 f25 ?v0) ?v1)) (f30 (f31 f41 (f19 f20 ?v0)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f31 f41 ?v0))) (= (f30 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) (f19 f20 1) (f19 f20 (f5 (f6 f7 (f9 f10 ?v0)) (f9 f10 (f30 ?v_0 (f19 f20 (- (f9 f10 ?v1) 1)))))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 (f24 f25 ?v0) (f19 f20 2)))) (= (f5 f33 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 2))) (= (f9 (f24 f25 (f5 f33 ?v0)) ?v_0) (f9 (f24 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 (f19 f20 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f19 f20 (f5 (f6 f7 ?v_0) ?v_0)) (f19 f20 (+ (f5 (f6 f7 (f9 f10 (f19 f20 (- ?v0 1)))) (f9 f10 (f19 f20 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f19 f20 (* 2 ?v_0)) (f19 f20 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f19 f20 (* ?v_0 2)) (f19 f20 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f19 f20 0)) (?v_2 (f9 f10 ?v0)) (?v_1 (f9 f10 ?v1))) (= (f19 f20 (f5 (f6 f7 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f19 f20 (+ ?v_1 (f5 (f6 f7 (f9 f10 (f19 f20 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 Int)) (=> (= (f3 f13 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int)) (= (f9 (f24 f25 ?v0) (f19 f20 3)) (f5 (f6 f7 (f5 (f6 f7 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S6)) (= (f30 (f31 f41 ?v0) (f19 f20 3)) (f30 (f31 f32 (f30 (f31 f32 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f9 (f24 f25 ?v0) (f19 f20 2)) (f5 (f6 f7 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (= (f30 (f31 f41 ?v0) (f19 f20 2)) (f30 (f31 f32 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f9 ?v_0 (f19 f20 (* 2 (f9 f10 ?v1)))) (f9 (f24 f25 (f9 ?v_0 ?v1)) (f19 f20 2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f31 f41 ?v0))) (= (f30 ?v_0 (f19 f20 (* 2 (f9 f10 ?v1)))) (f30 (f31 f41 (f30 ?v_0 ?v1)) (f19 f20 2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f3 (f16 (f38 f39 (f5 (f6 f7 ?v0) ?v_0)) 1) ?v1) f1) (= (f3 (f16 (f38 f39 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f24 f25 ?v1)) (?v_1 (f19 f20 ?v0))) (=> (< 0 ?v0) (= (f9 ?v_0 ?v_1) (f5 (f6 f7 ?v1) (f9 ?v_0 (f19 f20 (- (f9 f10 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f19 f20 (* 2 (f9 f10 ?v1)))) (f5 (f6 f7 ?v_1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f31 f41 ?v0))) (let ((?v_1 (f30 ?v_0 ?v1))) (= (f30 ?v_0 (f19 f20 (* 2 (f9 f10 ?v1)))) (f30 (f31 f32 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f19 f20 (+ (* 2 (f9 f10 ?v1)) 1))) (f5 (f6 f7 ?v0) (f5 (f6 f7 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f31 f41 ?v0))) (let ((?v_1 (f30 ?v_0 ?v1))) (= (f30 ?v_0 (f19 f20 (+ (* 2 (f9 f10 ?v1)) 1))) (f30 (f31 f32 ?v0) (f30 (f31 f32 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f3 f13 ?v1) f1) (= (f3 (f16 f21 ?v1) ?v0) f1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f30 (f31 f32 ?v0) ?v1) (f30 (f31 f32 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f31 f32 ?v0)) (?v_0 (f31 f32 ?v1))) (= (f30 ?v_1 (f30 ?v_0 ?v2)) (f30 ?v_0 (f30 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f6 f7 ?v0)) (?v_0 (f6 f7 ?v1))) (= (f5 ?v_1 (f5 ?v_0 ?v2)) (f5 ?v_0 (f5 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f30 (f31 f32 ?v1) ?v2)) (f30 (f31 f32 (f30 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2)) (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 (f31 f32 (f30 ?v_0 ?v1)) ?v2) (f30 ?v_0 (f30 (f31 f32 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 (f31 f32 (f30 ?v_0 ?v1)) ?v2) (f30 (f31 f32 (f30 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 (f6 f7 (f5 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f31 f32 ?v0)) (?v_1 (f30 (f31 f32 ?v2) ?v3))) (= (f30 (f31 f32 (f30 ?v_0 ?v1)) ?v_1) (f30 ?v_0 (f30 (f31 f32 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f7 ?v0)) (?v_1 (f5 (f6 f7 ?v2) ?v3))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v_1) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f31 f32 (f30 (f31 f32 ?v0) ?v1))) (?v_0 (f31 f32 ?v2))) (= (f30 ?v_1 (f30 ?v_0 ?v3)) (f30 ?v_0 (f30 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f6 f7 (f5 (f6 f7 ?v0) ?v1))) (?v_0 (f6 f7 ?v2))) (= (f5 ?v_1 (f5 ?v_0 ?v3)) (f5 ?v_0 (f5 ?v_1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 (f31 f32 (f30 ?v_0 ?v1)) (f30 (f31 f32 ?v2) ?v3)) (f30 (f31 f32 (f30 ?v_0 ?v2)) (f30 (f31 f32 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) (f5 (f6 f7 ?v2) ?v3)) (f5 (f6 f7 (f5 ?v_0 ?v2)) (f5 (f6 f7 ?v1) ?v3))))))
(assert (forall ((?v0 Int)) (= (f9 (f24 f25 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f30 (f31 f41 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f5 (f6 f7 ?v0) ?v0) (f9 (f24 f25 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 S6)) (= (f30 (f31 f32 ?v0) ?v0) (f30 (f31 f41 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f9 ?v_0 (f19 f20 (+ (f9 f10 ?v1) 1))) (f5 (f6 f7 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f31 f41 ?v0))) (= (f30 ?v_0 (f19 f20 (+ (f9 f10 ?v1) 1))) (f30 (f31 f32 ?v0) (f30 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f5 (f6 f7 ?v0) (f9 ?v_0 ?v1)) (f9 ?v_0 (f19 f20 (+ (f9 f10 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f31 f41 ?v0))) (= (f30 (f31 f32 ?v0) (f30 ?v_0 ?v1)) (f30 ?v_0 (f19 f20 (+ (f9 f10 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f5 (f6 f7 (f9 ?v_0 ?v1)) ?v0) (f9 ?v_0 (f19 f20 (+ (f9 f10 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f31 f41 ?v0))) (= (f30 (f31 f32 (f30 ?v_0 ?v1)) ?v0) (f30 ?v_0 (f19 f20 (+ (f9 f10 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f9 (f24 f25 (f5 (f6 f7 ?v0) ?v1)) ?v2) (f5 (f6 f7 (f9 (f24 f25 ?v0) ?v2)) (f9 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f30 (f31 f41 (f30 (f31 f32 ?v0) ?v1)) ?v2) (f30 (f31 f32 (f30 (f31 f41 ?v0) ?v2)) (f30 (f31 f41 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f5 (f6 f7 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) (f9 ?v_0 (f19 f20 (+ (f9 f10 ?v1) (f9 f10 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f41 ?v0))) (= (f30 (f31 f32 (f30 ?v_0 ?v1)) (f30 ?v_0 ?v2)) (f30 ?v_0 (f19 f20 (+ (f9 f10 ?v1) (f9 f10 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f9 (f24 f25 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f19 f20 (f5 (f6 f7 (f9 f10 ?v1)) (f9 f10 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f41 ?v0))) (= (f30 (f31 f41 (f30 ?v_0 ?v1)) ?v2) (f30 ?v_0 (f19 f20 (f5 (f6 f7 (f9 f10 ?v1)) (f9 f10 ?v2))))))))
(assert (forall ((?v0 S6)) (= (f27 (f28 f29 (f19 f20 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S6)) (= (f27 (f28 f29 ?v0) ?v0) f1)))
(assert (forall ((?v0 S6)) (let ((?v_0 (= (f27 (f28 f29 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f19 f20 1))) (= (= (f27 (f28 f29 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= ?v0 ?v1) (and (= (f27 (f28 f29 ?v0) ?v1) f1) (= (f27 (f28 f29 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (= (f27 (f28 f29 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f27 (f28 f29 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f19 f20 (+ 0 1)))) (= (= (f27 (f28 f29 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f28 f29 ?v0))) (= (= (f27 ?v_0 (f19 f20 (+ (f9 f10 ?v1) (f9 f10 ?v0)))) f1) (= (f27 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (= (f27 (f28 f29 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f27 (f28 f29 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (and (= (f27 (f28 f29 ?v0) ?v1) f1) (not (= (f27 (f28 f29 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (= (f27 (f28 f29 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f27 (f28 f29 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f9 f10 ?v1)) (not (= (f27 (f28 f29 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= ?v0 ?v1) (= (f27 (f28 f29 ?v0) ?v1) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f27 (f28 f29 ?v0) ?v1) f1) (= (= (f27 (f28 f29 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (= (f27 (f28 f29 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f27 (f28 f29 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (= (f27 (f28 f29 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f27 (f28 f29 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f9 f10 ?v1))) (=> (= (f27 (f28 f29 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f9 f10 ?v0) ?v_0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= ?v0 ?v1) (=> (= (f27 (f28 f29 ?v1) ?v2) f1) (= (f27 (f28 f29 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v0))) (=> (= (f27 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f27 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f27 (f28 f29 ?v0) ?v1) f1) (=> (= (f27 (f28 f29 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f27 (f28 f29 ?v0) ?v1) f1) (=> (= (f27 (f28 f29 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v0))) (=> (= (f27 ?v_0 ?v1) f1) (=> (= (f27 (f28 f29 ?v1) ?v2) f1) (= (f27 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v0))) (=> (= (f27 ?v_0 ?v1) f1) (=> (= (f27 ?v_0 ?v2) f1) (= (f27 ?v_0 (f19 f20 (- (f9 f10 ?v1) (f9 f10 ?v2)))) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f27 (f28 f29 ?v1) ?v2) f1) (not (= (f27 ?v_0 ?v1) f1))) (and (= (f27 (f28 f29 ?v0) ?v2) f1) (not (= (f27 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v0)) (?v_1 (f28 f29 ?v2))) (=> (= (f27 ?v_0 ?v1) f1) (=> (and (= (f27 (f28 f29 ?v1) ?v2) f1) (not (= (f27 ?v_1 ?v1) f1))) (and (= (f27 ?v_0 ?v2) f1) (not (= (f27 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v0)) (?v_1 (f9 f10 ?v2)) (?v_2 (f9 f10 ?v1))) (=> (= (f27 ?v_0 (f19 f20 (- ?v_2 ?v_1))) f1) (=> (= (f27 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f27 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v0)) (?v_1 (f9 f10 ?v2)) (?v_2 (f9 f10 ?v1))) (=> (= (f27 ?v_0 (f19 f20 (- ?v_2 ?v_1))) f1) (=> (= (f27 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f27 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (and (= (f27 (f28 f29 ?v0) ?v1) f1) (not (= (f27 (f28 f29 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_1 (= (f27 (f28 f29 ?v0) ?v1) f1)) (?v_0 (= (f27 (f28 f29 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (= (f27 (f28 f29 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f27 (f28 f29 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_1 (= (f27 (f28 f29 ?v0) ?v1) f1)) (?v_0 (= (f27 (f28 f29 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (and (= (f27 (f28 f29 ?v0) ?v1) f1) (not (= (f27 (f28 f29 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (and (= (f27 (f28 f29 ?v0) ?v1) f1) (not (= (f27 (f28 f29 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S1)) (let ((?v_1 (= (f27 (f28 f29 ?v0) ?v1) f1)) (?v_0 (= (f27 (f28 f29 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f28 f29 ?v0))) (=> (and (= (f27 ?v_0 ?v1) f1) (not (= (f27 (f28 f29 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f27 ?v_0 ?v2) f1) (not (= (f27 (f28 f29 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f28 f29 ?v0)) (?v_0 (f28 f29 ?v1))) (=> (and (= (f27 ?v_1 ?v1) f1) (not (= (f27 ?v_0 ?v0) f1))) (=> (= (f27 ?v_0 ?v2) f1) (and (= (f27 ?v_1 ?v2) f1) (not (= (f27 (f28 f29 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_1 (= (f27 (f28 f29 ?v0) ?v1) f1)) (?v_0 (= (f27 (f28 f29 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S6)) (= (f19 f20 (f9 f10 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f10 (f19 f20 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f9 f10 (f19 f20 ?v0)) 0))))
(check-sat)
(exit)
