(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 (S6 Int) S4)
(declare-fun f8 () S6)
(declare-fun f9 () Int)
(declare-fun f10 (S7 Int) S5)
(declare-fun f11 () S7)
(declare-fun f12 () Int)
(declare-fun f13 () S4)
(declare-fun f14 () S5)
(declare-fun f15 () Int)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (let ((?v_0 (f10 f11 2))) (let ((?v_1 (+ (f6 (f7 f8 f9) ?v_0) (f6 (f7 f8 f12) ?v_0)))) (not (=> (= ?v_1 (f3 (f4 f5 (+ 1 (f6 f13 f14))) f15)) (=> (< 0 ?v_1) (not (= f15 0))))))))
(assert (forall ((?v0 S5)) (= (f10 f11 (f6 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f13 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f13 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
