(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) Int)
(declare-fun f4 (S4 Int) S3)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S2)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (let ((?v_0 (f7 f8 2))) (=> (not (= f6 0)) (< 0 (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0))))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) 0)))
(assert (not (<= 0 (f3 (f4 f5 f6) (f7 f8 2)))))
(assert (forall ((?v0 S2)) (= (f7 f8 (f3 f10 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f10 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f10 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
